﻿/********************************************************
*                                                        *
*   © Microsoft. All rights reserved.                    *
*                                                        *
*********************************************************/
(function () {
"use strict";
try {
importScripts("//Microsoft.WinJS.1.0/js/base.js");
var taskInstance = Windows.UI.WebUI.WebUIBackgroundTaskInstance.current;
taskInstance.progress = 0;
var homePageIndices = getHomePageIndices();
var recurrence = Windows.UI.Notifications.PeriodicUpdateRecurrence.halfHour;
var market = Platform.Globalization.Marketization.getCurrentMarket();
var urisToPoll = homePageIndices.map(function (ticker) { return createTileNotificationUri(ticker.symbol, 0, 0, market); });
var marketString = market.toLowerCase();
switch (marketString) {
case "de-de":
case "en-us":
case "en-au":
case "en-ca":
case "en-gb": 
case "en-in":
case "en-my":
case "en-sg":
case "en-za":
case "es-es":
case "en-ph":
case "fr-be":
case "fr-fr":
case "fr-ca":
case "id-id":
case "it-it":
case "ja-jp":
case "es-mx":
case "nb-no":
case "nl-be":
case "nl-nl":
case "pl-pl":
case "pt-br":
case "pt-pt":
case "ru-ru":
case "sv-se":
case "th-th":
case "tr-tr":
case "zh-cn":
case "zh-hk":
case "zh-tw":
// FALLTHROUGH
{
var liveTileUrlString = "http://{market}.appex-rf.msn.com/cgtile/v1/{market}/Finance/Today.xml";
liveTileUrlString = liveTileUrlString.replace(/\{market\}/g, market);
urisToPoll.push(new Windows.Foundation.Uri(liveTileUrlString));
}
break;
case "es-ar":
case "es-co":
case "es-cl":
case "es-cr":
case "es-pe":
case "es-pr":
case "es-ve":
case "es-uy": {
var liveTileUrlString = "http://es-cl.appex-rf.msn.com/cgtile/v1/es-cl/Finance/Today.xml";
urisToPoll.push(new Windows.Foundation.Uri(liveTileUrlString));
}
}
var notifications = Windows.UI.Notifications;
var tileUpdater = notifications.TileUpdateManager.createTileUpdaterForApplication();
tileUpdater.clear();
tileUpdater.enableNotificationQueue(true);
tileUpdater.startPeriodicUpdateBatch(urisToPoll, recurrence);
taskInstance.succeeded = true;
taskInstance.progress = 100;
close();
}
catch (ex) {
FinanceAppJS.Telemetry.FlightRecorder.LogErrorEvent(ex.message, ex.stack);
taskInstance.progress = 0;
taskInstance.succeeded = false;
close();
}
function getFile (key) {
var dataFile = key + ".json";
var xhr = new XMLHttpRequest;
xhr.open("GET", dataFile, false);
xhr.send();
var data = JSON.parse(xhr.responseText);
return data;
}
function getHomePageIndices() {
var region = Platform.Globalization.Marketization.getCurrentMarketInfo().geographicRegion;
/// In case, we don't support the current language and region, the market is ROW, 
/// which does not have a region associated with it. Fall back to geographic region
if (!region) {
region = Windows.Globalization.GeographicRegion();
}
var data = getFile("GlobalizationData");
var indicesDef = getFile("IndicesInfo");
for (var indx in indicesDef) {
indicesDef[indx].displayName = "Indx_" + indx;
}
var regionClass = data.minBar;
var regionCode = region.codeThreeLetter;
var market = Platform.Globalization.Marketization.getCurrentMarket().toLowerCase();
for (var r in data.regionClassification) {
if (data.regionClassification[r].indexOf(regionCode) !== -1) {
regionClass = r;
break;
}
}
for (var r in data.regionClassification) {
if (data.regionClassification[r].indexOf(market) !== -1) {
regionClass = r;
break;
}
}
var currentMarketData = data[regionClass];
if (data.hasOwnProperty(regionCode)) {
for (var key in data[regionCode]) {
currentMarketData[key] = data[regionCode][key];
}
}
if (data.hasOwnProperty(market)) {
for (var key in data[market]) {
returnData[key] = data[market][key];
}
}
currentMarketData.homePageIndices = currentMarketData.homePageIndices.map(function (item) { return indicesDef[item]; });
return currentMarketData.homePageIndices;
}
function createTileNotificationUri(symbol, type, mode, market) {
var serverUri = "http://finance.services.appex.bing.com/Market.svc/AppTile?symbol={symbol}&type={type}&mkt={market}&mode={mode}";
serverUri = serverUri.replace("\{symbol\}", symbol);
serverUri = serverUri.replace("\{type\}", type);
serverUri = serverUri.replace("\{market\}", market);
serverUri = serverUri.replace("\{mode\}", mode);
return new Windows.Foundation.Uri(serverUri);
}
})();