﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: BasePageManager.js */
(function (global, namespace) {
"use strict";
var createElements = PlatformJS.Utilities.createElements;
var getResourceString = PlatformJS.Utilities.getResourceString;
var BasePageManager = WinJS.Class.define(function (options) { }, {}, {
currentIPage: null,
clusterDefinitions: {},
getClusterList: function getClusterList(channelId) {
var clusterDef;
if (!channelId || !(clusterDef = this.clusterDefinitions[channelId])) {
return null;
}
return Object.keys(clusterDef);
},
getClusterDefinitionAsync: function getClusterDefinitionAsync(channelId) {
return WinJS.Promise.as(this.clusterDefinitions[channelId]);
},
_FRE: null,
_freMessageDisplayedOnce: false,
_freMessageBar: null,
_freClickMessageBar: null,
_freNavigationSuppressor: function _freNavigationSuppressor(event) {
var loc = WinJS.Navigation.location;
if (loc  && BasePageManager.isFRE()) {
BasePageManager.showFREClickMessage();
event.preventDefault();
event.stopImmediatePropagation();
PlatformJS.Navigation.mainNavigator.canNavigate = true;
PlatformJS.Navigation.mainNavigator.currentIPage = BasePageManager.currentIPage;
}
},
isFRE: function isFRE() {
if (this._FRE === null) {
if (Windows.Storage.ApplicationData.current.localSettings.values.hasOwnProperty("FRE")) {
return (this._FRE = false);
}
this._FRE = !PlatformJS.Utilities.hasInternetConnection();
if (this._FRE) {
WinJS.Navigation.addEventListener("beforenavigate", this._freNavigationSuppressor);
}
}
return this._FRE;
},
resetFRE: function resetFRE() {
if (this._FRE === false) {
return;
}
this._FRE = false;
this.freToOnline();
},
showFREMessage: function showFREMessage() {
if (this._freMessageDisplayedOnce) {
return;
}
this._freMessageDisplayedOnce = true;
this._freMessageBar = new CommonJS.MessageBar(getResourceString("FREMessage"), { autoHide: false });
this._freMessageBar.addButton(getResourceString("/platform/close"), function () { this._freMessageBar.hide(); }.bind(this));
this._freMessageBar.show();
},
showFREClickMessage: function showFREClickMessage() {
var anchor = document.body;
if (!this._freClickMessageBar) {
var flyoutDiv = document.createElement("div");
var freFlyout = this._freClickMessageBar = new WinJS.UI.Flyout(flyoutDiv);
WinJS.Utilities.addClass(flyoutDiv, 'networkUnavailableFlyoutContainer');
var container = createElements(
{
tag: "div", attrs: null, children: [
{
tag: "div", attrs: { className: 'noInternetIcon' }, children: [
{ tag: "div", attrs: { className: 'platformErrorIconGlyph1' } },
{ tag: "div", attrs: { className: 'platformErrorIconGlyph2' } },
]
},
{ tag: "br", attrs: null },
{ tag: "div", attrs: { className: 'errortextLine1', textContent: getResourceString('OfflineNoNetConnectionLine1') } },
{ tag: "div", attrs: { className: 'errortextLine2', textContent: getResourceString('OfflineNoNetConnectionLine2') } }
]
}, flyoutDiv);
anchor.appendChild(flyoutDiv);
}
this._freClickMessageBar.show(anchor, "top", "center");
},
hideFREMessages: function hideFREMessages() {
if (this._freClickMessageBar) {
this._freClickMessageBar.hide();
}
if (this._freMessageBar) {
this._freMessageBar.hide();
}
},
freToOnline: function freToOnline() {
WinJS.Navigation.removeEventListener("beforenavigate", this._freNavigationSuppressor);
Windows.Storage.ApplicationData.current.localSettings.values["FRE"] = false;
this.hideFREMessages();
this.currentIPage && this.currentIPage.onFREToOnline();
},
visibilityHandler: function visibilityHandler() {
this.currentIPage && this.currentIPage.onVisibilityChange();
},
binding_networkStatusChangeHandler: null,
networkStatusChangeHandler: function networkStatusChangeHandler() {
var currentStatus = Platform.Networking.NetworkManager.instance.isNetworkAvailable;
if (currentStatus) {
this.resetFRE();
this.currentIPage && this.currentIPage.onNetworkAvailable();
} else {
this.currentIPage && this.currentIPage.onNetworkOffline();
}
}
});
BasePageManager._binding_networkStatusChangeHandler = BasePageManager.networkStatusChangeHandler.bind(BasePageManager);
WinJS.Namespace.define(namespace, {
BasePageManager: BasePageManager,
});
})(this, "CommonJS.PanoEx");
/* File: BaseDataProvider.js */
(function (global, namespace) {
"use strict";
var BasePageManager = CommonJS.PanoEx.BasePageManager;
var setDeepObject = PlatformJS.Utilities.setDeepObject;
var getDeepObject = PlatformJS.Utilities.getDeepObject;
var deepCopy = PlatformJS.Utilities.deepCopy;
var onDemandLoader = PlatformJS.onDemandLoader;
function myWriteProfilerMark(str) {
msWriteProfilerMark(WinJS.Navigation.location.channelId + ":" + str);
}
var BaseDataProvider = WinJS.Class.define(function (options) {
this._binding_complete = this._complete.bind(this);
this._binding_progress = this._progress.bind(this);
this._binding_error = this._error.bind(this);
this._binding_progress_with_data = this._progress_with_data.bind(this);
this._binding_complete_with_data = this._complete_with_data.bind(this);
if (!options.providerName) {
debugger;
throw "Required A providerName";
}
this._listeners = {};
WinJS.UI.setOptions(this, options);
this.queryService = this.queryService || new PlatformJS.DataService.QueryService(this.queryServiceId);
}, {
bypassCache: false,
enableFRE: true,
waitForLatestData: null,
queryService: null,
queryServiceId: null,
providerName: null,
cannedDataFile: "FREData\\market_{market}\\{providerName}.json",
cannedDataFileKey: null,
dataTransformer: null,
lastUpdateTime: null,
_progressStarted: false,
_refreshInterval: 0,
refreshInterval: {
get: function get() { return this._refreshInterval; },
set: function set(value) {
if (value === this._refreshInterval) {
return;
}
var oldValue = this._refreshInterval;
this._refreshInterval = value;
this._sendEvent("refreshintervalchange", [this, value, oldValue]);
}
},
dataBuilder: function dataBuilder(data) { return data; },
processResponseData: function processResponseData(data, response) { return WinJS.Promise.as(data); },
getQueryServiceParams: function getQueryServiceParams() { return null; },
getCannedDataFile: function getCannedDataFile() {
if (!this._cannedDataFile) {
this._cannedDataFile = this.cannedDataFile.replace("{market}", Platform.Globalization.Marketization.getCurrentMarket());
this._cannedDataFile = this._cannedDataFile.replace(/\{\w+\}/, function (params, value) {
value = value.substr(1, value.length - 2);
return params[value] || value;
}.bind(null, this));
}
return this._cannedDataFile;
},
getQueryServiceOptions: function getQueryServiceOptions() {
var options = new Platform.DataServices.QueryServiceOptions();
options.useCompatDataModel = true;
options.enableAutoRefresh = false;
if (this.enableFRE) {
options.localDataFile = this.getCannedDataFile();
}
return options;
},
_timeoutId: null,
_fetchPromise: null,
_processPromise: null,
_refreshEnabled: true,
_cacheDataFound: false,
_lastFetchData: null,
_cannedDataFile: null,
_listeners: null,
_lastEvent: null,
_inProgress: false,
_cancelled: null,
getCacheId: function getCacheId() {
if (this.queryService) {
return this.queryService.getCacheID();
}
},
getQueryServiceURL: function getQueryServiceURL() {
return this.queryService.getUrl(this.getQueryServiceParams());
},
resumePeriodicRefresh: function resumePeriodicRefresh() {
this._refreshEnabled = true;
},
pausePeriodicRefresh: function pausePeriodicRefresh() {
this._refreshEnabled = false;
},
completedOnce: {
get: function get() {
return this._fetchPromise && this._inProgress === false;
}
},
removeAllListeners: function removeAllListeners() {
this._listeners = {};
},
removeListeners: function removeListeners(id) {
if (this._listeners.hasOwnProperty(id)) {
delete this._listeners[id];
}
},
addListeners: function addListeners(listeners, id) {
id = id || ("listener" + Object.keys(this._listeners).length);
this._listeners[id] = listeners;
if (this._lastFetchData) {
listeners.dataavailable && msSetImmediate(listeners.dataavailable, this.providerName, this._lastFetchData, "success");
}
if (this._fetchPromise && !this._inProgress) {
listeners[this._lastEvent] && msSetImmediate(listeners[this._lastEvent], this.providerName, this._lastFetchData);
}
if (!this._fetchPromise && listeners.dataavailable && !this._lastFetchData) {
/* The last conditional !this._lastFetchData is added for perf reasons.
* We dont want anything taking up CPU time before we are done renderering.
*/
this.getData({ useLastData: true, listenerId: id });
}
return id;
},
_processUrlParams: function _processUrlParams(params) {
if (!params || params.constructor !== Object) {
return params;
}
var urlParams = PlatformJS.Collections.createStringDictionary();
return deepCopy(params, urlParams, 0);
},
_scheduleDelayedEvent: function _scheduleDelayedEvent(event, data, delay) {
if (this._timeoutId) {
this._timeoutId = clearTimeout(this._timeoutId);
}
this._timeoutId = setTimeout(this._scheduleEvent.bind(this, event, data), delay);
},
_sendEvent: function _sendEvent(event, args) {
for (var l in this._listeners) {
var listener, eventcb;
if (!(listener = this._listeners[l])) {
continue;
}
if (!(eventcb = listener[event])) {
continue;
}
eventcb.apply(global, args);
}
},
_scheduleEvent: function _scheduleEvent(event, data) {
if (event === "error" || event === "success") {
if (this._progressStarted) {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
this._progressStarted = false;
}
this._lastEvent = event;
this._inProgress = false;
this._complete_response = null;
this._progress_response = null;
myWriteProfilerMark(this.providerName + ":e");
}
if (this._timeoutId) {
this._timeoutId = clearTimeout(this._timeoutId);
}
var listener, eventcb;
for (var l in this._listeners) {
(listener = this._listeners[l]) && (eventcb = listener[event]) && msSetImmediate(eventcb, this.providerName, data);
}
},
_complete_with_data: function _complete_with_data(data) {
var response = this._complete_response;
if (!data) {
this._scheduleEvent("error", data);
return;
}
this._scheduleEvent("dataavailable", data);
if (response.isLocalResponse) {
this._scheduleEvent("fredata", data);
}
this._scheduleEvent("success", data);
},
_complete_response: null,
_complete: function _complete(timestamp, response) {
if (this._cancelled || timestamp !== this._timestamp) {
return;
}
this.lastUpdateTime = response.lastUpdateTime;
this._complete_response = response;
if (response.isCachedResponse) {
if (this._processPromise) {
this._processPromise.then(function (response) {
this._scheduleEvent(response.isStaleResponse || this._lastFetchData === null ? "error" : "success", this._lastFetchData);
}.bind(this, response));
} else {
this._scheduleEvent(response.isStaleResponse || this._lastFetchData === null ? "error" : "success", this._lastFetchData);
}
return;
}
this._processResponseData(response).then(this._binding_complete_with_data, this._binding_error);
},
_error: function _error(timestamp, errData) {
errData = errData || {};
if (this._progressStarted) {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
this._progressStarted = false;
}
if (this._cancelled || PlatformJS.Utilities.isPromiseCanceled(errData) || timestamp !== this._timestamp) {
return;
}
errData.lastFetchData = this._lastFetchData;
this._scheduleEvent("error", this._lastFetchData);
myWriteProfilerMark(this.providerName + ":e");
},
_progress_with_data: function _progress_with_data(data) {
var response = this._progress_response;
this._cacheDataFound = true;
if (PlatformJS.Utilities.hasInternetConnection() && this.waitForLatestData && (response.isStaleResponse || response.isLocalResponse)) {
this._scheduleDelayedEvent("dataavailable", data, this.waitForLatestData);
} else {
this._scheduleEvent("dataavailable", data);
}
if (response && response.isLocalResponse && BasePageManager.isFRE() && !PlatformJS.Utilities.hasInternetConnection()) {
this._scheduleEvent("fredata", data);
}
},
_progress_response: null,
_reportCacheData: null,
_progress: function _progress(timestamp, progressData) {
if (this._cancelled || timestamp !== this._timestamp) {
return;
}
switch (progressData.statusCode) {
case Platform.DataServices.QueryServiceStatusCode.cachedEntryFound:
this.lastUpdateTime = progressData.cachedResponse.lastUpdateTime;
if (!this._reportCacheData) {
return;
}
this._progress_response = progressData.cachedResponse;
/* This is progress(cached) data. For Promise Error, we dont do anything if we cant process cached data */
this._processResponseData(progressData.cachedResponse).then(this._binding_progress_with_data, function () { });
break;
case Platform.DataServices.QueryServiceStatusCode.cachedEntryNotFound:
this._scheduleEvent("nocache", null);
break;
case Platform.DataServices.QueryServiceStatusCode.attemptingNetworkFetch:
if (WinJS.Navigation.location.channelId) {
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
this._progressStarted = true;
}
break;
case Platform.DataServices.QueryServiceStatusCode.operationComplete:
if (this._progressStarted) {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
this._progressStarted = false;
}
break;
}
},
_prev_response_promise: null,
_processResponseData: function _processResponseData(response) {
try {
this._logDataQuery("service");
myWriteProfilerMark(this.providerName + ":dataBuilder" + ":s");
var dataObject = response.dataObject || (response.dataString ? JSON.parse(response.dataString) : null);
if (this.cannedDataFileKey && response.isLocalResponse) {
dataObject = getDeepObject(dataObject, this.cannedDataFileKey);
}
var data = this.dataBuilder(dataObject, response);
var that = this;
return (this._processPromise = this.processResponseData(data, response)).then(function (data) {
that._processPromise = null;
that._lastFetchData = data || that._lastFetchData;
if (!data) {
return WinJS.Promise.wrapError(null);
}
myWriteProfilerMark(that.providerName + ":dataBuilder" + ":e");
return data;
});
}
catch (ex) {
return WinJS.Promise.wrapError(null);
}
},
getData: function getData(options) {
/// <summary>Fetches data from the query Service and returns it</summary>
/*
* useLastData: If you want data only if it has changed set it to true. If set to false, it will report cached data and network data
* forceRefresh: Ignore previous fetch cache and get a fresh platform cache/network data
* listenerId: Dont bother broadcasting out an event. Just send the last fetched data to the given listener.
* bypassCache: Bypass cache for this query.
*/
var defaultOptions = { useLastData: true, forceRefresh: false, listenerId: null, bypassCache: false };
options = deepCopy(options, defaultOptions);
var useLastData = options.useLastData;
var listener, listenerId = options.listenerId;
var forceRefresh = options.forceRefresh;
var byPassCache = (options.byPassCache === true || this.bypassCache === true);
if (forceRefresh) {
this._fetchPromise = null;
}
if (!forceRefresh && !this._refreshEnabled) {
return null;
}
if (useLastData && this._fetchPromise) {
if (listenerId && (listener = (this._listeners[listenerId]))) {
if (this._lastFetchData) {
listener.dataavailable && listener.dataavailable(this.providerName, this._lastFetchData);
}
else if (!this._inProgress) {
listener.error && listener.error(this.providerName, null);
}
}
return this._fetchPromise;
}
if (this._inProgress && !forceRefresh) {
return null;
}
myWriteProfilerMark(this.providerName + ":s");
this._cancelled = false;
this._inProgress = true;
this._reportCacheData = useLastData || forceRefresh || (this._lastFetchData === null);
this._progressStarted = false;
var urlParams = this._processUrlParams(this.getQueryServiceParams());
var qsoptions = this.getQueryServiceOptions();
if (byPassCache) {
qsoptions.bypassCache = true;
}
this._logDataQuery("request");
this._timestamp = Date.now();
this._binding_complete = this._complete.bind(this, this._timestamp);
this._binding_progress = this._progress.bind(this, this._timestamp);
this._binding_error = this._error.bind(this, this._timestamp);
return this._fetchPromise = this.queryService.downloadDataAsync(urlParams, null, this.dataTransformer, qsoptions).then(this._binding_complete, this._binding_error, this._binding_progress);
/* Binding to timestamp is a hack to ensure the callbacks are coming from the latest scheduled fetchdata call 
* and not from a previously cancelled one
*/
},
_timestamp: null,
_lastQueryTime: null,
_lastRequestId: null,
_logDataQuery: function _logDataQuery(QrySendRecv) {
var eventId = "";
var evtDetail = {};
if (QrySendRecv === "request") {
this._lastQueryTime = performance.now().toFixed(3);
this._lastRequestId = this.providerName + "_" + Date.now();
eventId = "AppQueryRequest";
evtDetail = {
RequestId: this._lastRequestId,
CurrTimeInms: this._lastQueryTime,
ResponseTime: 0,
DataProvider: this.providerName,
UserTag: "QRYREQ"
};
Platform.Telemetry.FlightRecorder.logCustom(Platform.Telemetry.LogLevel.normal, eventId, JSON.stringify(evtDetail));
} else if (QrySendRecv === "service") {
var CurrTim = performance.now().toFixed(3);
eventId = "AppQueryService";
evtDetail = {
RequestId: this._lastRequestId,
CurrTimeInms: CurrTim,
ResponseTime: CurrTim - this._lastQueryTime,
DataProvider: this.providerName,
UserTag: "QRYSRV"
};
Platform.Telemetry.FlightRecorder.logCustom(Platform.Telemetry.LogLevel.normal, eventId, JSON.stringify(evtDetail));
this._lastQueryTime = null;
this._lastRequestId = null;
}
},
cancelFetch: function cancelFetch() {
this._cancelled = true;
this._inProgress = false;
this._lastQueryTime = null;
this._lastRequestId = null;
this._timestamp = null;
if (this._fetchPromise) {
this._fetchPromise.cancel();
}
if (this._processPromise) {
this._processPromise.cancel();
}
this._fetchPromise = null;
this._refreshEnabled = true;
},
clearError: function clearError() {
this.cancelFetch();
this._fetchPromise = null;
this._lastFetchData = null;
this._cancelled = false;
this._lastEvent = null;
},
clear: function clear() {
this.clearError();
},
refresh: function refresh() { },
refreshIfLastFail: function refreshIfLastFail() { },
isActive: function isActive() { },
}, {
_providers: {},
_providerInstances: {},
registerProvider: function registerProvider(name, obj, file) {
if (typeof obj === 'string') {
var evalObj = getDeepObject(global, obj);
if (typeof evalObj === 'function') {
obj = evalObj;
}
}
if (typeof obj === 'function') {
this._providers[name] = obj;
return;
}
this._providers[name] = onDemandLoader(obj, file);
},
findOrCreateProvider: function findOrCreateProvider(providerName, options) {
var providerInstance = BaseDataProvider._providerInstances[providerName];
if (providerInstance) {
var clearIt = false;
for (var opt in options) {
//A Data Provider Option could be an object instead of a simple value. Need to handle that case too
//NOTE: JSON.stringify is 5-7 times faster than a recursive Deep-Compare (10000 Iterations on a Test-Object)
if ((options[opt] instanceof Object && JSON.stringify(options[opt]) === JSON.stringify(providerInstance[opt])) || options[opt] === providerInstance[opt]) {
continue;
}
clearIt = true;
providerInstance[opt] = options[opt];
}
if (clearIt) {
providerInstance.clear();
}
return providerInstance;
}
options.providerName = providerName;
if (typeof BaseDataProvider._providers[providerName] === 'string') {
BaseDataProvider._providers[providerName] = getDeepObject(global, BaseDataProvider._providers[providerName]);
}
return (BaseDataProvider._providerInstances[providerName] = new BaseDataProvider._providers[providerName](options));
},
});
WinJS.Namespace.define(namespace, {
BaseDataProvider: BaseDataProvider,
});
})(this, "CommonJS.PanoEx");
/* File: BasePage.js */
(function (global, namespace) {
"use strict";
var BaseDataProvider = CommonJS.PanoEx.BaseDataProvider;
var BasePageManager = CommonJS.PanoEx.BasePageManager;
var createElements = PlatformJS.Utilities.createElements;
var getResourceString = PlatformJS.Utilities.getResourceString;
var deepCopy = PlatformJS.Utilities.deepCopy;
function myWriteProfilerMark(str) {
msWriteProfilerMark(WinJS.Navigation.location.channelId + ":" + str);
}
function isNonEmptyObject(obj) {
return typeof obj === 'object' && Object.keys(obj).length > 0;
}
function isNonEmptyArray(obj) {
return (obj && obj.constructor === Array && obj.length > 0);
}
var BasePage = WinJS.Class.define(function (state, options) {
document.addEventListener("msvisibilitychange", BasePageManager.visibilityHandler);
Platform.Networking.NetworkManager.addEventListener("networkstatuschanged", BasePageManager._binding_networkStatusChangeHandler);
this._binding_clusterPromiseFunc = this._clusterPromiseFunc.bind(this);
this._binding_handleReworkingDataProvider = this._handleReworkingDataProvider.bind(this);
myWriteProfilerMark("page_load:s");
myWriteProfilerMark("constructor:s");
if (this.progressType) {
CommonJS.Progress.showProgress(CommonJS.Progress[this.progressType]);
}
this.initializePromise = this.initializeAsync(state);
WinJS.UI.setOptions(this, options);
}, {
progressType: null,
showInertiaBackground: false,
semanticZoomRenderer: null,
timeStampFormatter: null,
watermarkTemplate: null,
ignoreClusters: [],
ignoreControls: ["PlatformJS.Ads.AdsWrapperControl"],
isSnapped: false,
isImmersive: false,
pageTitle: null,
initializePromise: null,
initializeAsync: function initializeAsync(state) {
BasePageManager.currentIPage = this;
this._channelId = WinJS.Navigation.history.current.location.channelId;
this._isSnapped = Windows.UI.ViewManagement.ApplicationView.value === Windows.UI.ViewManagement.ApplicationViewState.snapped;
//convert the time stamps back to date objects from strings
if (state) {
state.timestamp = state.timestamp && typeof state.timestamp === "string" && new Date(state.timestamp);
state.lastUpdatedTime = state.lastUpdatedTime && typeof state.lastUpdatedTime === "string" && new Date(state.lastUpdatedTime);
}
this._savedState = state;
this._panoramaState = state && state.panoramaState;
this.lastUpdatedTime = state && state.lastUpdatedTime;
this.clusterControlsMap = {};
this.semanticZoomRenderer = this.semanticZoomRenderer || BasePage.semanticZoomRenderer;
this.timeStampFormatter = this.timeStampFormatter || Windows.Globalization.DateTimeFormatting.DateTimeFormatter[this._isSnapped ? "longDate" : "shortDate"];
this.watermarkTemplate = getResourceString("LastUpdate");
this._panoElement = document.querySelector(".platformMainContent");
this._panoControl = this._panoElement.winControl;
this._dataProviders = {};
this._intervalBuckets = {};
this._timerIds = [];
this._clusterRenderedList = {};
return BasePageManager.getClusterDefinitionAsync(this._channelId).then(this.setClusterDefinitions.bind(this), function () { });
},
getPageState: function getPageState() {
var state = this._savedState || {};
//convert date objects to strings in order to fix memory fragmentation/leak
state.timestamp = new Date().toString();
state.lastUpdatedTime = this._lastUpdatedTime ? this._lastUpdatedTime.toString() : null;
state.panoramaState = this._panoControl.getPanoramaState();
return state;
},
getPageData: function getPageData() {
var pageData = {
title: this.pageTitle,
panoramaState: this._panoramaState,
showInertiaBackground: this.showInertiaBackground,
semanticZoomRenderer: this.semanticZoomRenderer
};
return this.initializePromise.then(this.getClustersPromise.bind(this)).then(function (rslt) {
pageData.clusterDataSource = rslt.dataSource;
return pageData;
});
},
_checkPageLoadComplete: function _checkPageLoadComplete(event) {
if (this._clusters.length < 2 || event.detail >= 2) {
if ( !this._pageLoadDone ) {
this.onPageLoadComplete();
}
}
if ( this._pageLoadDone ) {
this._panoControl._panel.removeEventListener(this._binding_checkPageLoadComplete);
this._binding_checkPageLoadComplete = null;
}
},
onBindingComplete: function onBindingComplete() {
if (this._panoControl._panel) {
this._binding_checkPageLoadComplete = this._checkPageLoadComplete.bind(this);
this._panoControl._panel.addEventListener("itemsrealizedcomplete", this._binding_checkPageLoadComplete);
} else {
this.onPageLoadComplete();
}
},
onNavigateAway: function onNavigateAway() {
},
onLayoutChange: function onLayoutChange(layoutState) {
/*** TODO: Fix Derived pages that use this for snapped state cleanup and remove it  ***/
if (this.isSnapped) {
if (layoutState !== Windows.UI.ViewManagement.ApplicationViewState.snapped) {
this.onNavigateAway();
}
} else {
if (layoutState === Windows.UI.ViewManagement.ApplicationViewState.snapped) {
this.onNavigateAway();
}
}
/*** ***/
this._panoControl.onLayoutChange(layoutState);
},
onOrientationChange: function onOrientationChange(event) {
this._panoControl.onOrientationChange(event);
},
onWindowResize: function onWindowResize(event) {
if (!this._panoControl) {
debugger;
} else {
this._panoControl.onWindowResize(event);
}
},
onDpiChange: function onDpiChange(event) {
this._panoControl.onDpiChange(event);
},
onResuming: function onResuming(event) {
this._networkChangeCallback();
},
onNetworkAvailable: function onNetworkAvailable(event) {
this._networkChangeCallback();
},
onNetworkOffline: function onNetworkOffline(event) {
this._clearRefreshTimers();
},
onFREToOnline: function onFREToOnline(event) {
//this._freStatusChanged();
},
onVisibleAreaLoad: function onVisibleAreaLoad(event) {
if (this.progressType) {
CommonJS.Progress.hideProgress(CommonJS.Progress[this.progressType]);
}
/* The following code is added because we have a stopper in dataProvider code 
* which prevents starting the data fetch for providers which already have data to render
* we can start them here because now we are done with visible load
*/
msSetImmediate(function () {
for (var p in this._dataProviders) {
var provider = this._dataProviders[p];
if (provider._lastFetchData && !provider._fetchPromise) {
provider.getData({ useLastData: false });
}
}
}.bind(this));
// This call will ensure any one time work is run such as the splash screen dismissal
// only if this control was loaded as the initial startup page.
PlatformJS.mainProcessManager.afterFirstView();
myWriteProfilerMark("page_load:e");
},
onPageLoadComplete: function onPageLoadComplete(event) {
this._pageLoadDone = true;
},
_savedState: null,
_panoElement: null,
_panoControl: null,
_panoramaState: null,
_dataProviders: null,
_clustersDef: null,
_clusterOrder: null,
_clusters: null,
_intervalIds: null,
_timerIds: null,
_intervalBuckets: null,
_lastUpdatedTime: null,
_showMarketDataAttribution: true,
_hasClonedClusters: false,
_cloneClusterData: null,
_clusterPromise_complete: null,
updatePageTimeStamp: function updatePageTimeStamp(value) {
if (!value) { return; }
value = value.constructor !== Date ? new Date(value) : value;
if (this._lastUpdatedTime && this._lastUpdatedTime > value && this._lastUpdatedTime < new Date()) { return; }
this._lastUpdatedTime = value;
this._panoControl.watermark = this._watermarkTemplate.format(this.timeStampFormatter(value));
},
hasClusterOnScreen: function hasClusterOnScreen() {
for (var c in this.clusterControlsMap) {
if (this.clusterControlsMap[c]) {
return true;
}
}
return false;
},
isClusterListEmpty: function isClusterListEmpty() {
if (this._clusters.length === 0) {
return true;
}
for (var i = 0; i < this._clusters.length ; i++) {
var clusterDef = this._clusters.getAt(i);
if (this.ignoreClusters.indexOf(clusterDef.clusterKey) === -1 && this.ignoreControls.indexOf(clusterDef.clusterContent.contentControl) === -1) {
return false;
}
}
return true;
},
addCluster: function addCluster(clusterKey, clusterDef, index) {
/// TODO: Add support for dynamic addition of Cloned Clusters .. 
/// No ask from anyone for this ... But just for the sake of uniformity and completion
this._clustersDef[clusterKey] = clusterDef;
this._clusterOrder.splice(index, 0, clusterKey);
var panoClusterDef = this._createClusterFromDef(clusterKey, clusterDef);
this._clusters.splice(index, 0, panoClusterDef);
var dataProviders = panoClusterDef.clusterContent.contentControl.dataProviders;
for (var p in dataProviders) {
this._adjustRefreshTimer(p, p.refreshInterval, p.refreshInterval);
}
},
removeCluster: function removeCluster(clusterKey, noRetry) {
if (this._clustersDef[clusterKey].statusNotifierCallback) {
this._clustersDef[clusterKey].statusNotifierCallback('Remove');
}
var cluster = this.clusterControlsMap[clusterKey];
if (cluster) {
cluster.dispose();
delete this.clusterControlsMap[clusterKey];
}
for (var j = 0; j < this._clusters.length ; j++) {
if (this._clusters.getItem(j).data.clusterKey === clusterKey) {
this._clusters.splice(j, 1);
}
}
if (noRetry) {
var clusterIndex = this._clusterOrder.indexOf(clusterKey);
if (clusterIndex !== -1) {
this._clusterOrder.splice(clusterIndex, 1);
}
}
if (this._clusterRenderedList && this._clusterRenderedList[clusterKey]) {
this._clusterRenderedList[clusterKey] = null;
}
if (!this.hasClusterOnScreen()) {
if (!this.isClusterListEmpty()) {
this._panoControl.clusterDataSource = this._clusters.dataSource;
} else {
var errType = PlatformJS.Utilities.hasInternetConnection() ? CommonJS.Error.STANDARD_ERROR : CommonJS.Error.NO_INTERNET;
this._hideRetryPopup();
if (errType === CommonJS.Error.NO_INTERNET) {
CommonJS.Error.showError(errType);
}
else {
CommonJS.Error.showError(errType, this._retryFailedClusters.bind(this));
}
}
}
},
getDataProvider: function getDataProvider(providerName, options) {
/// <summary>Get the data provider specified by the name</summary>
/// <param name="providerName" type="String">Name of the data provider to query</param>
return this._dataProviders[providerName];
},
_completeClusterPromise: function _completeClusterPromise() {
if (!this._clusterPromise_complete) { return; }
var complete = this._clusterPromise_complete;
this._clusterPromise_complete = null;
this._addAdsClusters();
complete(this._clusters);
},
_checkCompleteClusterPromise: function _checkCompleteClusterPromise() {
if (!this._clusterOrder) {
return;
}
for (var i = 0, key, clusterDef; i < this._clusterOrder.length && (key = this._clusterOrder[i]) && (clusterDef = this._clustersDef[key]) ; i++) {
if (!clusterDef.cloneFunc) {
continue;
}
if (!this._cloneClusterData || !this._cloneClusterData[key]) {
return;
}
}
this._completeClusterPromise();
},
_clusterPromiseFunc: function _clusterPromiseFunc(complete, error, progress) {
this._clusterPromise_complete = complete;
this._checkCompleteClusterPromise();
},
getClustersPromise: function getClustersPromise() {
/// <summary>Get the cluster list as a promise. This could be modified dynamically. So ensure you have modification bindings</summary>
if (!this._hasClonedClusters) {
this._addAdsClusters();
return WinJS.Promise.wrap(this._clusters);
}
return new WinJS.Promise(this._binding_clusterPromiseFunc);
},
_getDataProvider: function _getDataProvider(providerName, options) {
return (this._dataProviders[providerName] = BaseDataProvider.findOrCreateProvider(providerName, options));
},
_normalizeDataProviders: function _normalizeDataProviders(obj) {
var dataProviders = {};
if (typeof obj === 'string') {
dataProviders[obj] = {};
} else if (obj instanceof Array) {
obj.forEach(function (item) { dataProviders[item] = {}; });
} else if (Object.keys(obj).length > 0) {
dataProviders = obj;
}
return dataProviders;
},
_createClusterFromDef: function _createClusterFromDef(key, clusterDef) {
/// <summary>Create a cluster definition (acceptable in the cluster list to pano control) from the cluster def</summary>
/// <param name="key" type="String">The key name for the cluster</param>
/// <param name="clusterDef" type="Object">Cluster Definition</param>
clusterDef.clusterKey = key;
clusterDef.clusterTitle = clusterDef.clusterTitle || getResourceString("ClusterTitle_" + key);
var cluster = { clusterContent: {} };
cluster.clusterKey = key;
cluster.clusterTitle = clusterDef.clusterTitle;
cluster.hideTitle = clusterDef.hideTitle;
cluster.titleClass = clusterDef.titleClass;
cluster.supressTitleInHeader = clusterDef.supressTitleInHeader;
cluster.onHeaderSelection = clusterDef.onHeaderSelection;
cluster.clusterContent.contentControl = clusterDef.clusterControl;
cluster.clusterContent.contentOptions = deepCopy(clusterDef.clusterOptions || {}, null, 0);
cluster.clusterContent.contentOptions.clusterDef = clusterDef;
cluster.clusterContent.contentOptions.ipage = this;
cluster.clusterContent.contentOptions.primaryProviders = clusterDef.primaryProviders;
cluster.clusterContent.contentOptions.onrendercomplete = this._clusterRenderComplete.bind(this, key);
if (clusterDef.dataProviders) {
var dataProviders = clusterDef.dataProviders = this._normalizeDataProviders(clusterDef.dataProviders);
if (Object.keys(dataProviders).length > 0) {
cluster.clusterContent.contentOptions.dataProviders = {};
for (var providerName in dataProviders) {
cluster.clusterContent.contentOptions.dataProviders[providerName] = this._getDataProvider(providerName, dataProviders[providerName]);
}
}
}
if (clusterDef.clusterData) {
cluster.clusterContent.contentOptions.clusterData = clusterDef.clusterData;
}
return cluster;
},
clusterControlsMap: {},
getClusterControl: function getClusterControl(clusterKey) {
return this.clusterControlsMap[clusterKey];
},
_clearRefreshTimers: function _clearRefreshTimers() {
if (!isNonEmptyArray(this._intervalIds)) { return; }
this._intervalIds.forEach(clearInterval);
this._intervalIds = [];
},
_refreshAll: function _refreshAll() {
for (var p in this._dataProviders) {
this._dataProviders[p].getData({ useLastData: false });
}
},
_networkChangeCallback: function _networkChangeCallback() {
this._retryFailedClusters();
this._startRefreshTimers();
},
_refreshProviders: function _refreshProviders(interval) {
var providers = this._intervalBuckets[interval];
for (var i = 0; i < providers.length; i++) {
providers[i].getData({ useLastData: false });
}
},
_adjustRefreshTimer: function _adjustRefreshTimer(provider, interval, oldInterval) {
var index = this._intervalBuckets[oldInterval].indexOf(provider);
if (index !== -1) {
this._intervalBuckets[oldInterval].splice(index, 1);
}
if (this._intervalBuckets[interval]) {
this._intervalBuckets[interval].push(provider);
} else {
this._intervalBuckets[interval] = [provider];
if (interval) {
this._intervalIds.push(setInterval(this._refreshProviders.bind(this, interval), interval * 1000));
}
}
},
_startRefreshTimers: function _startRefreshTimers(doNotRefresh, intervalBucket) {
this._clearRefreshTimers();
if (!doNotRefresh) {
this._refreshAll();
}
if (!PlatformJS.Utilities.hasInternetConnection()) {
return;
}
intervalBucket = intervalBucket || this._intervalBuckets;
var intervalIds = this._intervalIds;
intervalIds[intervalIds.length] = setInterval(this._retryFailedClusters.bind(this), 60000);
for (var i in intervalBucket) {
if (i === "0") {
continue;
}
intervalIds[intervalIds.length] = setInterval(this._refreshProviders.bind(this, i), i * 1000);
}
},
_clusterRenderedList: null,
_visibleLoadDone: false,
_pageLoadDone: false,
_clusterRenderComplete: function _clusterRenderComplete(clusterKey, event) {
this._clusterRenderedList[clusterKey] = 1; // Mark it Rendered
myWriteProfilerMark(clusterKey + "_page_load" + ":e");
if (!this._visibleLoadDone) {
var keys = Object.keys(this.clusterControlsMap);
if (keys.length < 2 || (this._clusterRenderedList[keys[0]] && this._clusterRenderedList[keys[1]])) {
this._visibleLoadDone = true;
this.onVisibleAreaLoad();
}
}
if (this._visibleLoadDone && !this._pageLoadDone) {
if (this._clusters.length === Object.keys(this._clusterRenderedList).length) {
this.onPageLoadComplete(event);
}
}
var clusterDef = this._clustersDef[clusterKey];
if (clusterDef && clusterDef.clusterOptions && clusterDef.clusterOptions.onrendercomplete) {
clusterDef.clusterOptions.onrendercomplete(event);
}
},
_initDataProviders: function _initDataProviders() {
var intervalBuckets = {};
this._intervalIds = [];
for (var i in this._dataProviders) {
var interval = this._dataProviders[i].refreshInterval;
if (!intervalBuckets.hasOwnProperty(interval)) { intervalBuckets[interval] = []; }
intervalBuckets[interval].push(this._dataProviders[i]);
}
this._intervalBuckets = intervalBuckets;
this._startRefreshTimers(true);
for (var p in this._dataProviders) {
this._dataProviders[p].addListeners({ refreshintervalchange: this._adjustRefreshTimer.bind(this) });
}
},
_errorRetryMessageBar: null,
_retryPopupShouldShow: false,
_hideRetryPopup: function _hideRetryPopup() {
this._retryPopupShouldShow = false;
if (this._errorRetryMessageBar) { this._errorRetryMessageBar.hide(); }
this._errorRetryMessageBar = null;
},
_showRetryPopup: function _showRetryPopup() {
if (BasePageManager.isFRE()) { return; }
this._retryPopupShouldShow = true;
if (this._clusters.length > 0) { this.checkRetryPopup(); }
},
_errorMessageBarTimerId: null,
checkRetryPopup: function checkRetryPopup() {
/* INFO: Latest spec says .. no need for showing the popup.
* Hence we return silently
*/
return;
/* **** */
if (!this._retryPopupShouldShow || this._clusters.length === 0 || !PlatformJS.Utilities.hasInternetConnection()) { return; }
this._errorRetryMessageBar = new CommonJS.MessageBar(getResourceString("ClusterDataLoadErrMsg"), { autoHide: false });
this._errorRetryMessageBar.addButton(getResourceString("ClusterDataLoadRetryMsg"), this._retryFailedClusters.bind(this));
this._errorRetryMessageBar.show();
},
_errDataProviders: null,
_errClusterKeys: null,
_reinitialize: function _reinitialize() {
var clustersDef = this._clustersDef;
var panoControl = this._panoControl;
this._disposeThis();
this.initializePromise = this.initializeAsync(this._savedState);
this.setClusterDefinitions(clustersDef);
this.getPageData().then(function (pageData) {
WinJS.UI.setOptions(panoControl, pageData);
});
},
_retryFailedClusters: function _retryFailedClusters() {
this._hideRetryPopup();
CommonJS.Error.removeError();
var renderedClusters = {};
var dataProviders = this._errDataProviders = this._errDataProviders || {};
for (var p in dataProviders) {
this._getDataProvider(p).clearError();
dataProviders[p] = 0;
}
if (this.isClusterListEmpty()) {
this._reinitialize();
}
for (var x = 0, item ; x < this._clusters.length && (item = this._clusters.getAt(x)) ; x++) {
renderedClusters[item.clusterKey] = x;
var parentKey = item.clusterContent.contentOptions.clusterDef && item.clusterContent.contentOptions.clusterDef.parentClusterKey;
if (parentKey) {
if (!renderedClusters.hasOwnProperty(parentKey)) { renderedClusters[parentKey] = x; }
}
}
var initializedCloneClusters = {};
var k = null;
for (var i = 0, key, j = 0 ; i < this._clusterOrder.length && (key = this._clusterOrder[i]) ; i++) {
if (renderedClusters.hasOwnProperty(key)) { continue; }
var clusterDef = this._clustersDef[key];
if (!clusterDef.cloneFunc) {
this._clusters.splice(i - j, 0, this._createClusterFromDef(key, clusterDef));
/* Since creating a cluster has a getData Call ... Mark it 1 */
for (k in clusterDef.dataProviders) {
dataProviders[k] = 1;
}
} else {
if (!initializedCloneClusters.hasOwnProperty(key)) {
initializedCloneClusters[key] = 1;
this._setupCloneCluster(clusterDef);
for (k in clusterDef.dataProviders) {
dataProviders[k] = 1;
}
}
}
if (clusterDef.statusNotifierCallback) {
clusterDef.statusNotifierCallback('Add');
}
}
for (k in dataProviders) {
if (dataProviders[k]) { continue; }
this._getDataProvider(k).getData({ useLastData: false });
}
this._errDataProviders = null;
},
_handleReworkingDataProvider: function _handleReworkingDataProvider(providerName, data) {
var dataProvider = this._getDataProvider(providerName);
dataProvider.removeListeners("basepage");
this._hideRetryPopup();
CommonJS.Error.removeError();
var renderedClusters = {};
for (var k = 0, item ; k < this._clusters.length && (item = this._clusters.getAt(k)) ; k++) {
renderedClusters[item.clusterKey] = i;
var parentKey = item.clusterContent.contentOptions.clusterDef && item.clusterContent.contentOptions.clusterDef.parentClusterKey;
if (parentKey) {
if (!renderedClusters.hasOwnProperty(parentKey)) { renderedClusters[parentKey] = k; }
}
}
for (var i = 0, key, j = 0 ; i < this._clusterOrder.length && (key = this._clusterOrder[i]) ; i++) {
if (renderedClusters.hasOwnProperty(key)) { continue; }
var clusterDef = this._clustersDef[key];
if (!clusterDef.dataProviders.hasOwnProperty(providerName)) { continue; }
if (!clusterDef.cloneFunc) {
this._clusters.splice(i - j, 0, this._createClusterFromDef(key, clusterDef));
} else {
this._clone_handleDataAvailable(key, providerName, data);
}
if (clusterDef.statusNotifierCallback) {
clusterDef.statusNotifierCallback('Add');
}
}
},
_handleClusterDataError: function _handleClusterDataError(clusterKey, providerName, failInfo) {
this._errClusterKeys = this._errClusterKeys || {};
this._errDataProviders = this._errDataProviders || {};
this._errClusterKeys[clusterKey] = 1;
this._errDataProviders[providerName] = 1;
this._showRetryPopup();
var clusterDef = this._clustersDef[clusterKey];
if (failInfo && (!failInfo.hasPrimary || failInfo.isPrimary) && failInfo.allProvidersFailed && failInfo.removeOnError && !failInfo.hasRenderData) {
var provider = this._getDataProvider(providerName);
provider.addListeners({ dataavailable: this._binding_handleReworkingDataProvider }, "basepage");
this.removeCluster(clusterKey, false);
}
},
setSingleCluster: function setSingleCluster(clusterDef) {
clusterDef = { SingleCluster: clusterDef };
this.setClusterDefinitions(clusterDef, ["SingleCluster"]);
},
_addCluster: function _addCluster(clusterKey, clusterDef) {
/// <summary>Adds a cluster to the IPage. Usually due to cloning</summary>
/// <param name="clusterKey" type="String">The key name of the cluster to be added</param>
/// <param name="clusterDef" type="Object">The cluster definition as accepted by BasePage</param>
var clusters = this._clusters;
for (var i = 0; i < clusters.length; i++) {
if (clusters.getItem(i).data.clusterKey === clusterKey) {
var clusterItem = clusters.getItem(i);
var clusterControl = this.clusterControlsMap[clusterKey];
if (clusterControl) {
WinJS.UI.setOptions(clusterControl, clusterDef.clusterOptions);
if (clusterDef.clusterData) { clusterControl.clusterData = clusterDef.clusterData; }
if (clusterDef.parentClusterKey) { clusterControl.parentClusterKey = clusterDef.parentClusterKey; }
}
return;
}
}
/* No matching clusterKey found in the list. FInd the best match */
var findkey = clusterDef.parentClusterKey || clusterKey;
var pos = 0;
var index = this._clusterOrder.indexOf(findkey);
/* Find the nearest matching position */
if (index === -1) { debugger; return; }
for (var j = 0; j < clusters.length; j++, pos++) {
var key = clusters.getAt(j).clusterKey;
if (!key || this._clusterOrder.indexOf(key) >= index) {
break;
}
}
var cluster = this._createClusterFromDef(clusterKey, clusterDef);
clusters.splice(pos, 0, cluster);
if (clusterDef.statusNotifierCallback) {
clusterDef.statusNotifierCallback('Add');
}
return cluster;
},
_clone_handleDataAvailable: function _clone_handleDataAvailable(clusterKey, providerName, data) {
var clusterDef = this._clustersDef[clusterKey];
var clonedClusters = clusterDef.cloneFunc(data);
for (var key in clonedClusters) {
var clonedClusterDef = {};
deepCopy(clusterDef, clonedClusterDef, 0);
clonedClusterDef.clusterTitle = clonedClusters[key].clusterTitle;
clonedClusterDef.supressTitleInHeader = clonedClusters[key].supressTitleInHeader;
clonedClusterDef.dataProviders = null;
clonedClusterDef.clusterKey = key;
clonedClusterDef.clusterData = clonedClusters[key].clusterData;
clonedClusterDef.parentClusterKey = clusterDef.clusterKey;
this._addCluster(key, clonedClusterDef);
}
this._cloneClusterData = this._cloneClusterData || {};
this._cloneClusterData[clusterDef.clusterKey] = data;
this._checkCompleteClusterPromise();
return;
},
_clone_handleDataError: function _clone_handleDataError(clusterKey, providerName, data) {
this._errDataProviders = this._errDataProviders || {};
if (providerName) { this._errDataProviders[providerName] = 0; }
this._cloneClusterData = this._cloneClusterData || {};
this._cloneClusterData[clusterKey] = this._cloneClusterData[clusterKey] || data || {};
this._handleClusterDataError(clusterKey, providerName, { allProvidersFailed: true, removeOnError: true, hasRenderData: data ? true : false, isPrimary: true });
if (this.isClusterListEmpty()) {
var errType = PlatformJS.Utilities.hasInternetConnection() ? CommonJS.Error.STANDARD_ERROR : CommonJS.Error.NO_INTERNET;
this._hideRetryPopup();
if (errType === CommonJS.Error.NO_INTERNET) {
CommonJS.Error.showError(errType);
}
else {
CommonJS.Error.showError(errType, this._retryFailedClusters.bind(this));
}
} else {
this._showRetryPopup();
}
this._checkCompleteClusterPromise();
},
_setupCloneCluster: function _setupCloneCluster(clusterDef) {
if (!clusterDef.dataProviders) { return; }
this._hasClonedClusters = true;
clusterDef.dataProviders = this._normalizeDataProviders(clusterDef.dataProviders);
for (var i in clusterDef.dataProviders) {
var providerObj = this._getDataProvider(i, clusterDef.dataProviders[i]);
providerObj.addListeners({
dataavailable: this._clone_handleDataAvailable.bind(this, clusterDef.clusterKey),
error: this._clone_handleDataError.bind(this, clusterDef.clusterKey)
}, clusterDef.clusterKey);
}
},
_reinsertAdsHandler: null,
_addAdsClusters: function _addAdsClusters() {
var that = this;
PlatformJS.Ads.addOrderedAdsClusterConfig(that._clusters);
this._setupAdsClusterBindings();
},
_detachAdsClusterBindings: function _detachAdsClusterBindings() {
this._clusters.removeEventListener("iteminserted", this._reinsertAdsHandler);
this._clusters.removeEventListener("itemmoved", this._reinsertAdsHandler);
this._clusters.removeEventListener("itemremoved", this._reinsertAdsHandler);
},
_attachAdsClusterBindings: function _attachAdsClusterBindings() {
this._clusters.addEventListener("iteminserted", this._reinsertAdsHandler);
this._clusters.addEventListener("itemmoved", this._reinsertAdsHandler);
this._clusters.addEventListener("itemremoved", this._reinsertAdsHandler);
},
_reinsertAdsCluster: function _reinsertAdsCluster() {
this._detachAdsClusterBindings();
var that = this;
msSetImmediate(function recreateAdClusters() {
PlatformJS.Ads.addOrderedAdsClusterConfig(that._clusters);
that._attachAdsClusterBindings();
});
},
_setupAdsClusterBindings: function _setupAdsClusterBindings() {
if (!this._reinsertAdsHandler) {
this._reinsertAdsHandler = this._reinsertAdsCluster.bind(this);
this._attachAdsClusterBindings();
} 
},
setClusterDefinitions: function setClusterDefinitions(clusterDefs, clusterList) {
if (!clusterDefs) {
return null;
}
/// <summary>Sets the cluster Definition. Initializes dataproviders</summary>
this._clustersDef = clusterDefs;
clusterList = clusterList || BasePageManager.getClusterList(this._channelId) || Object.keys(clusterDefs);
var clusters = [];
var clusterOrder = [];
this._dataProviders = {};
this._cloneClusterData = null;
this._errDataProviders = null;
var cloneClusterDef = [];
/* Dont Load Ads Until the Page is done loading */
for (var i = 0; i < clusterList.length; i++) {
var clusterKey = clusterList[i];
var clusterDef = clusterDefs[clusterKey];
if (!isNonEmptyObject(clusterDef)) { continue; }
clusterDef.clusterKey = clusterKey;
if (clusterDef.validateFunc && !clusterDef.validateFunc()) {
if (clusterDef.statusNotifierCallback) {
clusterDef.statusNotifierCallback('Remove');
}
continue;
}
if (clusterDef.statusNotifierCallback) {
clusterDef.statusNotifierCallback('Add');
}
clusterOrder.push(clusterKey);
if (clusterDef.cloneFunc) {
cloneClusterDef.push(clusterDef);
continue;
}
clusters.push(this._createClusterFromDef(clusterKey, clusterDef));
}
this._clusterOrder = clusterOrder;
this._clusters = new WinJS.Binding.List(clusters);
cloneClusterDef.forEach(this._setupCloneCluster.bind(this));
this._initDataProviders();
return this._clusters;
},
dispose: function dispose() {
this._disposeThis();
if (this._panoControl && this._panoControl.dispose) {
if (this._binding_checkPageLoadComplete) {
this._panoControl._panel.removeEventListener(this._binding_checkPageLoadComplete);
}
this._panoControl.dispose();
}
},
_disposeThis: function _disposeThis() {
BasePageManager.currentIPage = null;
document.removeEventListener("msvisibilitychange", BasePageManager.visibilityHandler);
Platform.Networking.NetworkManager.removeEventListener("networkstatuschanged", BasePageManager._binding_networkStatusChangeHandler);
this._completeClusterPromise();
this._errDataProviders = null;
/* The following code cleans up the references while navigating away 
* which helps in leak investigation
* Uncomment before memory leak investigation
*
CommonJS._templateCache = new PlatformJS.Utilities.MemoryCache(20);
CommonJS._lastFragmentPath = null;
CommonJS._lastFragment = null;
setTimeout(WinJS.UI.ListView.triggerDispose, 1000);
/* */
for (var providerName in this._dataProviders) {
this._dataProviders[providerName].cancelFetch();
this._dataProviders[providerName].removeAllListeners();
}
this._clearRefreshTimers();
if (isNonEmptyArray(this._timerIds)) {
this._timerIds.forEach(clearTimeout);
this._timerIds = [];
}
this._clusterRenderedList = {};
CommonJS.Progress.resetAll();
},
}, {
semanticZoomTileBindingFunc: null,
semanticZoomRenderer: WinJS.Utilities.markSupportedForProcessing(function (itemPromise) {
var element = itemPromise.then(function (group) {
var title = group.data.semanticZoomTitle || group.data.clusterTitle;
return createElements(
{
tag: "div", attrs: { className: 'platformSemanticZoomItem' }, children: [
{
tag: "div", attrs: { className: 'semanticZoomTileContainer' }, children: [
{
tag: 'div', attrs: { className: 'semanticZoomTextContainer' }, children: [
{
tag: 'div', attrs: { className: 'semanticZoomText fontLR', textContent: title }
}
]
}
]
}
]
}
);
});
return { element: element };
})
});
WinJS.Namespace.define(namespace, {
BasePage: BasePage,
});
})(this, "CommonJS.PanoEx");
/* File: BaseCluster.js */
(function (global, namespace) {
"use strict";
var RENDER_COMPLETE = "rendercomplete";
var BaseDataProvider = CommonJS.PanoEx.BaseDataProvider;
var BasePageManager = CommonJS.PanoEx.BasePageManager;
var BasePage = CommonJS.PanoEx.BasePage;
var createElements = PlatformJS.Utilities.createElements;
var getDeepObject = PlatformJS.Utilities.getDeepObject;
function isNonEmptyArray(obj) {
return (obj && obj.constructor === Array && obj.length > 0);
}
function myWriteProfilerMark(str) {
msWriteProfilerMark(WinJS.Navigation.location.channelId + ":" + str);
}
var BaseCluster = WinJS.Class.define(function (element, options) {
/// <summary>
/// Base Cluster for each cluster that needs to be added to an IPage
/// This will automatically add listeners for dataProviders and handle some common
/// tasks like hiding/showing/cloning of clusters.
/// Usually derived classes would need to override the "update" member function
/// Which is called when data needs to be binded to the cluster.
/// </summary>
this._binding_updateWrapper = this._updateWrapper.bind(this);
this._binding_handleDataAvailable = this._handleDataAvailable.bind(this);
this._binding_handleFetchComplete = this._handleFetchComplete.bind(this);
this._binding_handleDataError = this._handleDataError.bind(this);
this._binding_handleFREData = this._handleFREData.bind(this);
this._binding_handleNoCache = this._handleNoCache.bind(this);
this._binding_firstRenderPromiseFunc = this._firstRenderPromiseFunc.bind(this);
this._binding_renderFooterTemplate = this._renderFooterTemplate.bind(this);
this._binding_updateQueuedRequest = this._updateQueuedRequest.bind(this);
this._binding_notifyRenderComplete = this._notifyRenderComplete.bind(this);
this._domElement = element;
element.winControl = this;
if (options.ipage && options.clusterDef) {
options.ipage.clusterControlsMap[options.clusterDef.clusterKey] = this;
myWriteProfilerMark("clusterload_" + options.clusterDef.clusterKey + ":s");
}
Object.defineProperties(this, WinJS.Utilities.createEventProperties(RENDER_COMPLETE));
this._providerData = {};
this._updatedProviders = {};
this._providerCompleted = {};
this._providerError = {};
}, {
_domElement: null,
_dataProviders: null,
_dataKey: null,
ipage: null,
clusterDef: null,
parentClusterKey: null,
removeOnError: true,
onrendercomplete: null,
_footerElement: null,
footerData: null,
footerText: {
set: function set(value) {
this.footerData = value;
}
},
footerTemplate: null,
footerKey: {
set: function set(value) {
if (typeof value === 'string') {
value = [value];
}
if (value && value.constructor === Array) {
this._footerKey = value;
}
},
get: function get() { return this._footerKey; }
},
dataKey: {
set: function set(value) {
if (typeof value === 'string') {
value = [value];
}
if (value && value.constructor === Array) {
this._dataKey = value;
}
},
get: function get() { return this._dataKey; }
},
domElement: {
get: function get() { return this._domElement; },
set: function set(value) { return this._domElement = value; }
},
clusterData: {
set: function set(value) { msSetImmediate(this._binding_updateWrapper, value, "Cloned"); }
},
dataProviders: {
get: function get() { return this._dataProviders; },
set: function set(dataProviders) {
this._dataProviders = dataProviders;
for (var i in dataProviders) {
var dataProvider = dataProviders[i];
dataProvider.addListeners({
dataavailable: this._binding_handleDataAvailable,
error: this._binding_handleDataError,
success: this._binding_handleFetchComplete,
fredata: this._binding_handleFREData,
nocache: this._binding_handleNoCache,
}, this.clusterDef.clusterKey);
}
}
},
/* Returns the first DataProviders QueryService Cache Id */
getFirstQueryServiceCacheId: function getFirstQueryServiceCacheId() {
for (var i in this._dataProviders) {
return this._dataProviders[i].getCacheId();
}
return null;
},
_firstRenderPromise: null,
_firstRenderPromiseComplete: null,
_firstRenderPromiseError: null,
_firstRenderPromiseFunc: function _firstRenderPromiseFunc(complete, error, progress) {
this._firstRenderPromiseComplete = complete;
this._firstRenderPromiseError = error;
},
render: function render() {
if (this._renderedOnce) {
return WinJS.Promise.as({});
}
return new WinJS.Promise(this._binding_firstRenderPromiseFunc);
},
update: function update(data, providerName) { return WinJS.Promise.as({}); },
collateProviderData: false,
dataMergeFunc: function dataMergeFunc(data) { return data; },
_primaryProviderData: null,
primaryProviders: {
get: function get() { return Object.keys(this._primaryProviderData ? (this._primaryProviderData) : this._dataProviders); },
set: function set(value) {
if (!value) {
return;
}
this._primaryProviderData = {};
if (typeof value === 'string') {
this._primaryProviderData[value] = null;
} else if (isNonEmptyArray(value)) {
for (var i = 0; i < value.length; i++) {
this._primaryProviderData[value[i]] = null;
}
}
}
},
_collatedDataUpdated: true,
_collatedDataRendered: false,
_providerData: null,
_providerCompleted: null,
_providerError: null,
_updatedProviders: null,
_checkForUpdate: function _checkForUpdate(status) {
/* Update if
* - There is new data from what was previously send
* - All the providers have responded with data 
* - Status complete or never send any data 
*/
if (this._collatedDataUpdated && this._allProvidersResponded() && (!this._collatedDataRendered || status === "complete")) {
this._updateWrapper(this.dataMergeFunc(this._providerData), "collated");
this._collatedDataRendered = true;
this._collatedDataUpdated = false;
}
},
_handleFetchComplete: function _handleFetchComplete(providerName, data) {
this._providerCompleted[providerName] = 1;
if (this.collateProviderData && this._allProvidersCompleted()) {
this._checkForUpdate("complete");
}
if (this._allProvidersCompleted()) {
this._providerCompleted = {};
}
},
_handleDataAvailable: function _handleDataAvailable(providerName, data) {
this._collatedDataUpdated = true;
this._providerData[providerName] = data;
if (this.collateProviderData) {
return this._checkForUpdate("dataavailable");
}
if (this._primaryProviderData && this._primaryProviderData.hasOwnProperty(providerName)) {
this._primaryProviderData[providerName] = data;
var allHaveData = true;
for (var p in this._primaryProviderData) {
if (!this._primaryProviderData[p]) {
allHaveData = false;
}
}
if (allHaveData) {
var promises = [];
for (var pp in this._primaryProviderData) {
promises.push(this._updateWrapper(this._primaryProviderData[pp], pp));
}
return WinJS.Promise.join(promises);
}
return;
}
this._updatedProviders[providerName] = 1;
if (this._providerError.hasOwnProperty(providerName)) {
delete this._providerError[providerName];
}
return this._updateWrapper(data, providerName);
},
_handleFREData: function _handleFREData() {
BasePageManager.showFREMessage();
},
_handleNoCache: function _handleNoCache(providerName) {
this._collatedDataUpdated = true;
this._providerData[providerName] = null;
if (this.collateProviderData) {
return this._checkForUpdate("dataavailable");
}
},
_allProvidersCompleted: function _allProvidersCompleted() {
for (var p in this._dataProviders) {
if (!this._providerCompleted.hasOwnProperty(p)) {
return false;
}
}
return true;
},
_allProvidersResponded: function _allProvidersResponded() {
for (var p in this._dataProviders) {
if (!this._providerData.hasOwnProperty(p)) {
return false;
}
}
return true;
},
_hasRenderData: function _hasRenderData() {
if (this._primaryProviderData) {
var providers = this.primaryProviders;
for (var i = 0; i < providers.length; i++) {
if (!this._providerData[providers[i]]) {
return false;
}
}
return true;
} else {
for (var p in this._dataProviders) {
if (this._providerData[p]) {
return true;
}
}
return false;
}
},
_primaryProvidersCompleted: function _primaryProvidersCompleted() {
if (this._primaryProviderData) {
var providers = this.primaryProviders;
for (var i = 0; i < providers.length; i++) {
if (!this._providerCompleted[providers[i]]) {
return false;
}
}
return true;
} else {
for (var p in this._dataProviders) {
if (this._providerCompleted[p]) {
return true;
}
}
return false;
}
},
_allProvidersFailed: function _allProvidersFailed() {
if (this._primaryProviderData === null) {
for (var p in this._dataProviders) {
if (!this._providerError[p]) {
return false;
}
}
return true;
} else {
for (var p1 in this._primaryProviderData) {
if (!this._providerError[p1]) {
return false;
}
}
return true;
}
},
_isPrimaryProvider: function _isPrimaryProvider(providerName) {
return (this._primaryProviderData && this._primaryProviderData.hasOwnProperty(providerName));
},
_handleDataError: function _handleDataError(providerName, data) {
this._providerData[providerName] = this._providerData[providerName] || data;
this._providerCompleted[providerName] = 1;
this._providerError[providerName] = 1;
var hasRenderData  = this._hasRenderData();
if (this.collateProviderData) {
this._checkForUpdate("complete");
} else {
this._notifyRenderComplete(hasRenderData ? "success" : "error");
}
this.ipage._handleClusterDataError(this.clusterDef.clusterKey, providerName, {
allProvidersFailed: this._allProvidersFailed(),
removeOnError: this.removeOnError,
hasRenderData: hasRenderData,
isPrimary: this._isPrimaryProvider(providerName),
hasPrimary: this._primaryProviderData ? true : false,
});
},
_lastFetchData: null,
_renderPromise: null,
_renderedOnce: false,
_updateQueue: null,
_currentlyRendering: null,
_renderFooterTemplate: function _renderFooterTemplate(value) {
if (!this.footerData && !this.footerTemplate && !this.footerKey) {
return value;
}
var footerData = this.footerData;
if (this.footerKey) { footerData = getDeepObject(this._currentlyRendering.data, this.footerKey); }
if (this._footerElement) {
this._footerElement.innerHTML = "";
this._domElement.removeChild(this._footerElement);
this._domElement.appendChild(this._footerElement);
} else {
this._footerElement = createElements({ tag: "div", attrs: { className: "footer" } }, this._domElement);
}
if (this.footerTemplate) {
this.footerTemplate.render(footerData, this._footerElement);
} else {
this._footerElement.textContent = footerData;
}
return value;
},
_updateImplWrapper: function _updateImplWrapper(data, providerName) {
this._currentlyRendering = { data: data, providerName: providerName };
this._lastFetchData = this._lastFetchData || {};
this._lastFetchData[providerName] = data;
if (this.clusterDef.postDataValidateFunc) {
var rslt = this.clusterDef.postDataValidateFunc(data, providerName);
rslt = typeof rslt !== 'string' ? (rslt ? 'success' : 'hide') : rslt;
if (rslt !== 'success') {
if (rslt === 'error') {
this.ipage._handleClusterDataError(this.clusterDef.clusterKey, providerName, { allProvidersFailed: true, removeOnError: true, hasRenderData: false });
}
else if (rslt === 'hide') {
this.ipage.removeCluster(this.clusterDef.clusterKey, true);
}
this._notifyRenderComplete(rslt);
return WinJS.Promise.as({});
}
};
data = getDeepObject(data, this.dataKey);
var updatePromise = this.update(data, providerName);
return updatePromise.then(this._binding_renderFooterTemplate);
},
_notifyRenderComplete: function _notifyRenderComplete(status) {
/// TODO: Status has been added just for bug:479371 to minimize code change at this late stage
/// Please fix this in the next release properly
var forceComplete = false;
var clusterKey = this.clusterDef.clusterKey;
status = status || "success";
myWriteProfilerMark(clusterKey + "_update" + ":e");
if (forceComplete || this.dataProviders === null || this._primaryProvidersCompleted() || this._hasRenderData()) {
var firstRender = !this._renderedOnce;
this._renderedOnce = true;
this._renderPromise = null;
if (this._firstRenderPromiseComplete) {
var complete = this._firstRenderPromiseComplete;
this._firstRenderPromiseComplete = null;
complete();
}
if (firstRender) {
this.dispatchEvent(RENDER_COMPLETE, status);
}
}
},
_updateQueuedRequest: function _updateQueuedRequest() {
var promises = [];
for (var providerName in this._updateQueue) {
promises.push(this._updateImplWrapper(this._updateQueue[providerName], providerName));
}
this._updateQueue = null;
this._renderPromise = WinJS.Promise.join(promises).then(this._binding_notifyRenderComplete);
},
_updateWrapper: function _updateWrapper(data, providerName) {
/// <summary>
/// The function to be binded to ondataavailable.
/// This does some post-processing before calling the update function
/// Usually checks if data is valid and if the cluster needs to be cloned
/// </summary>
/// <param name="data" type="Object">The data massaged by dataBuilder, returned from dataProvider</param>
/// <param name="providerName" type="String">The provider name of the dataProvider</param>
if (providerName === "collated" && !this._hasRenderData()) {
this._notifyRenderComplete();
return;
}
var clusterKey = this.clusterDef.clusterKey;
myWriteProfilerMark(clusterKey + "_update" + ":s");
if (this._renderPromise) {
if (this._updateQueue) {
this._updateQueue[providerName] = data;
return this._renderPromise;
}
var updateQueue = this._updateQueue = {};
this._updateQueue[providerName] = data;
return this._renderPromise = this._renderPromise.then(this._binding_updateQueuedRequest);
}
return this._renderPromise = this._updateImplWrapper(data, providerName).then(this._binding_notifyRenderComplete);
},
dispose: function dispose() {
for (var p in this._dataProviders) {
this._dataProviders[p].removeListeners(this.clusterDef.clusterKey);
}
}
});
// create mixin with cluster to support events
WinJS.Class.mix(BaseCluster, WinJS.UI.DOMEventMixin);
WinJS.Namespace.define(namespace, {
BaseCluster: BaseCluster,
});
})(this, "CommonJS.PanoEx");
/* File: EntityCluster.js */
(function (global, namespace) {
"use strict";
var BaseDataProvider = CommonJS.PanoEx.BaseDataProvider;
var BasePageManager = CommonJS.PanoEx.BasePageManager;
var BasePage = CommonJS.PanoEx.BasePage;
var BaseCluster = CommonJS.PanoEx.BaseCluster;
var createElements = PlatformJS.Utilities.createElements;
var getDeepObject = PlatformJS.Utilities.getDeepObject;
var deepCopy = PlatformJS.Utilities.deepCopy;
function mergeObjects(obj1, obj2) {
return deepCopy(obj2, deepCopy(obj1), 0);
}
function hashFunction(str) {
str = (typeof str === 'string' ? str : JSON.stringify(str));
var hash = 0, i, char;
if (str.length === 0) {
return hash;
}
for (i = 0; i < str.length; i++) {
char = str.charCodeAt(i);
hash = ((hash << 5) - hash) + char;
hash = hash & hash; // Convert to 32bit integer
}
return hash.toString();
}
var EntityCluster = WinJS.Class.derive(BaseCluster, function (domElement, options) {
this._binding_validateLayout = this._validateLayout.bind(this);
this._binding_updateWithLayout = this._updateWithLayout.bind(this);
BaseCluster.call(this, domElement, options);
this._options = options = mergeObjects(this.constructor.defaultOptions, options);
this._newsElement = createElements({ tag: "div", attrs: { className: options.className } }, domElement);
this.itemClickCallback = options.onitemclick;
options.onitemclick = this._onItemInvoked.bind(this);
options.configObject = getDeepObject(global, options.configObject);
this._newsView = new CommonJS.News.EntityCluster(this._newsElement, options);
WinJS.UI.setOptions(this, options);
}, {
dataKey: "newsItems",
layoutCacheId: "EntityClusterLayout",
collateProviderData: true,
itemClickCallback: null,
hasItems: {
get: function get() {
return this._newsItems && this._newsItems.length;
},
},
_options: null,
_newsView: null,
_newsItems: null,
_onItemInvoked: function _onItemInvoked(event) {
if (this.itemClickCallback) {
event.item.articleInfos = this._articleInfos;
this.itemClickCallback(event);
}
},
// Required for Next and Previous Article feature in Article Reader.
_articleInfos: null,
dataMergeFunc: function dataMergeFunc(data) {
var mergedArr = [], mergedData = {};
for (var p in this.dataProviders) {
if (!data[p]) {
continue;
}
mergedArr = mergedArr.concat(data[p][this.dataKey]);
}
mergedData[this.dataKey] = mergedArr;
return mergedData;
},
update: function update(data, providerName) {
data.forEach(function (obj, index) { obj.index = index; });
this._newsItems = data;
return this._findOrCreateLayout(data).then(this._binding_updateWithLayout);
},
_updateWithLayout: function _updateWithLayout(layout) {
var data = this._newsItems;
this._articleInfos = (data.filter(this._isArticle) || []).map(this._getArticleReaderId);
this._newsView.state = { data: null, renderedData: {} };
this._newsView.dataSet = { native: true, newsItems: data };
this._newsView.layout = layout;
return this._newsView.render();
},
_isArticle: function _isArticle(item) {
return (item.editorial && item.type === 'article' && item.articleid);
},
_getArticleReaderId: function _getArticleReaderId(item) {
return { articleId: (item.articleid + (item.contentid ? ("/" + item.contentid) : null)) };
},
_findOrCreateLayout: function _findOrCreateLayout(data) {
var hash = this._newsHash = hashFunction(data);
this._newsData = data.map(function (item) { return { item: item, templateClass: item.templateClass }; });
return PlatformJS.Cache.CacheService.getInstance(this.layoutCacheId).findEntry(hash).then(this._binding_validateLayout, this._binding_validateLayout);
},
_validateLayout: function _validateLayout(response) {
if (response && response.dataValue) {
return JSON.parse(response.dataValue._value);
}
var templateValues = this._newsView._createTemplateSelectorOutput(this._newsData);
var layout = this._newsView._createLayout(templateValues);
PlatformJS.Cache.CacheService.getInstance(this.layoutCacheId).addEntry(this._newsHash, layout);
return layout;
},
}, {
defaultOptions: {
className: "newsCluster",
mode: "static",
maxColumnCount: null,
theme: "appTheme",
unitWidth: null,
configKey: "EntityClusterDefaultNewsConfig",
configObject: "CommonJS.News.EntityClusterConfig.DefaultNews",
},
});
WinJS.Namespace.define(namespace + ".Clusters", {
EntityCluster: EntityCluster,
});
})(this, "CommonJS.PanoEx");
/* File: ItemsCluster.js */
(function (global, namespace) {
'use strict';
var BaseDataProvider = CommonJS.PanoEx.BaseDataProvider;
var BasePageManager = CommonJS.PanoEx.BasePageManager;
var BasePage = CommonJS.PanoEx.BasePage;
var BaseCluster = CommonJS.PanoEx.BaseCluster;
var deepCopy = PlatformJS.Utilities.deepCopy;
var ItemsCluster = WinJS.Class.derive(BaseCluster, function (domElement, options) {
BaseCluster.call(this, domElement, options);
this.className = options.className || "platformListLayout";
this._view = new CommonJS.Immersive.ItemsContainer(domElement, { className: this.className });
this.binding_renderComplete = this._renderComplete.bind(this);
WinJS.UI.setOptions(this, options);
}, {
useDataObjectForBinding: false,
className: null,
_view: null,
_moduleInfo: null,
_elements: null,
_clusterItems: null,
interactiveItemClickHandler: null,
update: function update(data) {
if (!this._elements) {
return this._renderItems(data);
}
return WinJS.Promise.as(this._updateImpl(data, this._elements));
},
_updateImpl: function _updateImpl(data, elements) {
var useDataObjectForBinding = this.useDataObjectForBinding;
if (this._clusterItems && this._clusterItems.length > 0) {
this._clusterItems.forEach(function (item, index) {
deepCopy(data[index], useDataObjectForBinding ? item : item.data, 0);
});
}
return elements;
},
_renderItems: function _renderItems(data) {
var that = this;
var view = this._view;
if (!data || data.constructor !== Array || !data.length) {
if (this._clusterItems) {
this._clusterItems.pop();
}
return WinJS.Promise.as({});
}
var useObject = this.useDataObjectForBinding;
var moduleInfo = this._moduleInfo;
this._clusterItems = new WinJS.Binding.List(deepCopy(data).map(function (item) {
var itemModuleInfo = item.moduleInfo ? deepCopy(item.moduleInfo, deepCopy(moduleInfo)) : moduleInfo;
var clusterItem = useObject ? item : { data: item };
clusterItem.moduleInfo = itemModuleInfo;
return WinJS.Binding.as(clusterItem);
}));
WinJS.UI.setOptions(this._view, {
itemDataSource: this._clusterItems.dataSource,
className: this.className
});
return this._view.render().
then(function () { return that._view._elements; }).
then(this.binding_renderComplete);
},
_renderComplete: function _renderComplete(elements) {
this._elements = elements;
for (var i = 0, item; i < this._clusterItems.length && (item = this._clusterItems.getAt(i)) ; i++) {
if (item.moduleInfo.isInteractive) {
/*Bug Fix 202186 and 196644, 206514*/
//elements[i].tabIndex = -1;
var elems = elements[i].querySelectorAll(".interactive-item");
for (var j = 0, elem; j < elems.length && (elem = elems[j]) ; j++) {
elem.tabIndex = 0;
PlatformJS.Utilities.enablePointerUpDownAnimations(elem);
PlatformJS.Utilities.registerItemClickProxy(elem,
function (element) { return WinJS.Utilities.hasClass(element, "interactive-item"); },
(function (func, item, index, element) { func && func(element, index, item); }).bind(null, this.interactiveItemClickHandler, item, j)
);
}
}
}
return elements;
},
itemTemplate: {
set: function set(value) {
if (value instanceof Element) {
this._moduleInfo = { templateId: value.id };
}
else if (value.fragmentPath || value.templateId || value.renderer) {
this._moduleInfo = value;
}
}
},
dispose: function dispose() {
BaseCluster.prototype.dispose();
if (this._view) {
this._view.dispose();
}
this._clusterItems = null;
this.binding_renderComplete = null;
}
});
WinJS.Namespace.define(namespace + ".Clusters", {
ItemsCluster: ItemsCluster,
});
})(this, "CommonJS.PanoEx");
/* File: ModuleCluster.js */
(function (global, namespace) {
'use strict';
var BaseDataProvider = CommonJS.PanoEx.BaseDataProvider;
var BasePageManager = CommonJS.PanoEx.BasePageManager;
var BasePage = CommonJS.PanoEx.BasePage;
var BaseCluster = CommonJS.PanoEx.BaseCluster;
var ModuleCluster = WinJS.Class.derive(BaseCluster, function (element, options) {
BaseCluster.call(this, element, options);
WinJS.Utilities.addClass(element, "moduleClusterContent");
WinJS.UI.setOptions(this, options || {});
}, {
_bindData: null,
moduleInfo: null,
update: function update(data) {
if (this._bindData) {
PlatformJS.Utilities.deepCopy(data, this._bindData, 0);
return WinJS.Promise.as({});
} else {
this._bindData = WinJS.Binding.as(data);
return CommonJS.loadModule(this.moduleInfo, this._bindData, this._domElement, null, null);
}
}
});
WinJS.Namespace.define(namespace + ".Clusters", {
ModuleCluster: ModuleCluster,
});
})(this, "CommonJS.PanoEx");
/* File: TableCluster.js */
(function (global, namespace) {
"use strict";
var BaseDataProvider = CommonJS.PanoEx.BaseDataProvider;
var BasePageManager = CommonJS.PanoEx.BasePageManager;
var BasePage = CommonJS.PanoEx.BasePage;
var BaseCluster = CommonJS.PanoEx.BaseCluster;
var createElements = PlatformJS.Utilities.createElements;
var deepCopy = PlatformJS.Utilities.deepCopy;
function myWriteProfilerMark(str) {
msWriteProfilerMark(WinJS.Navigation.location.channelId + ":" + str);
}
/* TODO: Try to use WinJS.Promise.timeout */
function immediatePromiseCallback(complete, error, progress) {
msSetImmediate(this, complete, error, progress);
}
function createImmediatePromise(func) {
return new WinJS.Promise(immediatePromiseCallback.bind(func));
}
function isNonEmptyArray(obj) {
return (obj && obj.constructor === Array && obj.length > 0);
}
var TableView = WinJS.Class.define(function (element, options) {
this._binding_attachTable = this._attachTable.bind(this);
this._binding_postProcessTables = this._postProcessTables.bind(this);
this._binding_createTablePromiseFunc = this._createTablePromiseFunc.bind(this);
this._domElement = element;
WinJS.UI.setOptions(this, options);
WinJS.Utilities.addClass(this._domElement, "tableview");
}, {
_domElement: null,
_tableElement: null,
_className: null,
_summary: null,
_numCols: null,
_tableTag: "table",
_theadTag: "thead",
_tbodyTag: "tbody",
_rowTag: "tr",
_columnTag: "td",
_columnHeaderTag: "th",
_columnTemplates: null,
_stickyHeader: false,
_tableClickCallback: null,
tagsToUse: null,
_defaultColumnTemplate: null,
getDefaultColumnTemplate: function getDefaultColumnTemplate() {
if (this._defaultColumnTemplate) {
return this._defaultColumnTemplate;
}
var tmplElem = createElements({
tag: "div", attrs: {}, children: [{
tag: "div", attrs: { "data-win-bind": "textContent: fieldData" }
}]
});
return (this._defaultColumnTemplate = new WinJS.Binding.Template(tmplElem));
},
_rowTemplate: null,
rowTemplate: {
get: function get() {
if (this._rowTemplate) {
return this._rowTemplate;
}
if (!this._columnTemplates) {
return null;
}
var templateElem = document.createElement("div");
var rowElem = document.createElement(this._rowTag);
WinJS.Utilities.addClass(rowElem, "tablerow");
for (var i = 0, arr = this._columnTemplates ; i < arr.length; i++) {
var template = arr[i] || this.getDefaultColumnTemplate();
var colElem = document.createElement(this._columnTag);
var colTemplateElem = template.element.cloneNode(true);
var elems = colTemplateElem.querySelectorAll("[data-win-bind]");
for (var j = 0, arr1 = elems, elem; j < arr1.length && (elem = arr1[j]) ; j++) {
var attrText = elem.getAttribute("data-win-bind");
attrText = attrText.replace(/fieldData/g, "col" + i + ".fieldData");
elem.setAttribute("data-win-bind", attrText);
}
for (var elem1 = colTemplateElem.firstElementChild; elem1; elem1 = elem1.nextElementSibling) {
colElem.appendChild(elem1);
}
WinJS.Utilities.addClass(colElem, "col_" + i);
colElem.attributes["headers"] = "thid" + i;
rowElem.appendChild(colElem);
}
templateElem.appendChild(rowElem);
this._rowTemplate = new WinJS.Binding.Template(templateElem);
return this._rowTemplate;
}
},
columnTemplates: {
set: function set(value) {
if (isNonEmptyArray(value)) {
return (this._columnTemplates = value);
}
}
},
stickyHeader: {
set: function set(value) {
this._stickyHeader = value;
}
},
className: {
get: function get() { return this._className; },
set: function set(value) {
this._className = value;
if (this._tableElement) {
WinJS.Utilities.addClass(this._tableElement, value);
}
}
},
summary: {
get: function get() { return this._summary; },
set: function set(value) {
this._summary = value;
if (this._tableElement) {
this._tableElement.summary = value;
}
}
},
tableDataArray: null,
fieldClickCallback: null,
rowClickCallback: null,
columnClickCallback: null,
hideHeader: false,
dispose: function dispose() {
if (this.tableClickHandler && this._tableElement) {
this._tableElement.removeEventListener("click", this.tableClickHandler);
}
},
render: function render() {
myWriteProfilerMark(namespace + "Controls:RenderTableView:s");
if (!(isNonEmptyArray(this.tableDataArray) && this._domElement)) { return WinJS.Promise.as(); }
this._headerCells = null;
this._firstRow = null;
this._firstColElems = null;
return this._createTablePromise()
.then(this._binding_attachTable)
.then(this._binding_postProcessTables)
.then(myWriteProfilerMark.bind(null, namespace + "Controls:RenderTableView:e"));
},
_attachTable: function _attachTable(tableElem) {
if (this._tableElement) {
this._domElement.replaceChild(tableElem, this._tableElement);
} else {
this._domElement.appendChild(tableElem);
}
this._tableElement = tableElem;
if (this._className) {
WinJS.Utilities.addClass(this._tableElement, this._className);
}
},
_createTablePromise: function _createTablePromise() {
return new WinJS.Promise(this._binding_createTablePromiseFunc);
},
_headerCells: null,
_firstRow: null,
_createRowPromise: function _createRowPromise(tbodyElem, dataArray, rowNum) {
return new WinJS.Promise(this._createRowPromiseFunc.bind(this, dataArray, rowNum));
},
_createColPromise: function _createColPromise(rowElem, rowData, colNum) {
return createImmediatePromise(this._createColPromiseFunc.bind(this, rowData, colNum));
},
_createTablePromiseFunc: function _createTablePromiseFunc(complete, error, progress) {
var tableElement = document.createElement(this._tableTag);
//attaching onclick event to table
if (this.tableClickHandler) {
PlatformJS.Utilities.enablePointerUpDownAnimations(tableElement);
tableElement.addEventListener("click", this.tableClickHandler);
}
var dataArray = this.tableDataArray;
if (this._tableTag === 'table') {
tableElement.cellSpacing = "0";
tableElement.border = "0";
tableElement.cellPadding = "0";
}
tableElement.style.overflow = "hidden";
if (this._summary) { tableElement.summary = this._summary; }
if (this._className) {
WinJS.Utilities.addClass(tableElement, this._className);
}
if (this._stickyHeader) {
WinJS.Utilities.addClass(tableElement, "stickyheadertable");
}
var theadElem = document.createElement(this._theadTag);
var tbodyElem = document.createElement(this._tbodyTag);
WinJS.Utilities.addClass(theadElem, "tableheader");
WinJS.Utilities.addClass(tbodyElem, "tablebody");
tbodyElem.addEventListener("mousewheel", CommonJS.Immersive.PanoramaPanel.verticalScrollHandler, false);
var i = 0;
if (!this.hideHeader) {
i++;
var rowElem = document.createElement(this._rowTag);
WinJS.Utilities.addClass(rowElem, "tableheaderrow");
this._headerCells = [];
for (var j = 0; j < dataArray[0].length; j++) {
var colElem = createElements({ tag: this._columnHeaderTag, attrs: { className: "col_" + j, textContent: dataArray[0][j], id: "thid" + j } }, rowElem);
this._headerCells.push(colElem);
}
theadElem.appendChild(rowElem);
}
var rowPromises = [];
for (; i < dataArray.length; i++) {
rowPromises.push(this._createRowPromise(tbodyElem, dataArray, i));
}
var completeWithTable = function (rowElems) {
rowElems.forEach(tbodyElem.appendChild.bind(tbodyElem));
for (var index = 0; index < rowElems.length; index++) {
var rowelem = rowElems[index];
this._firstRow = this._firstRow || rowelem;
WinJS.Utilities.addClass(rowelem, "tablerow");
var focusClass = "tblRowFocus";
//attach focus event to row
rowelem.addEventListener("focus", WinJS.Utilities.addClass.bind(null, rowelem, focusClass));
rowelem.addEventListener("blur", WinJS.Utilities.removeClass.bind(null, rowelem, focusClass));
//attach keyup and key down event
rowelem.addEventListener("keydown", this._processArrowKeyDown.bind(this));
if (this.rowClickCallback) {
// use index+1 for data since we need to escape row header data in Table DataArray at index 0;
PlatformJS.Utilities.enablePointerUpDownAnimations(rowelem);
PlatformJS.Utilities.registerItemClickProxy(rowelem, function () { return true; }, this._rowClickCallbackProxy.bind(this, index + 1));
}
}
if (rowElems[0]) { rowElems[0].tabIndex = 0; }
tableElement.appendChild(theadElem);
tableElement.appendChild(tbodyElem);
complete(tableElement);
};
WinJS.Promise.join(rowPromises).done(completeWithTable.bind(this), error, progress);
},
_createRowPromiseFunc: function _createRowPromiseFunc(dataArray, rowNum, complete, error, progress) {
var rowElem = document.createElement(this._rowTag);
var rowData = dataArray[rowNum];
var promise = null;
var columnPromises = [];
var rowTemplate = this.rowTemplate;
if (rowTemplate) {
var bindObj = {};
for (var j = 0; j < rowData.length; j++) {
bindObj["col" + j] = { fieldData: rowData[j] };
}
rowTemplate.render(WinJS.Binding.as(bindObj), null).done(function (elem) { complete(elem.firstElementChild); }, error, progress);
} else {
for (var k = 0; k < rowData.length; k++) {
columnPromises.push(this._createColPromise(rowElem, rowData, k));
}
promise = WinJS.Promise.join(columnPromises);
var completeWithRowElem = function (colElem) {
colElem.forEach(rowElem.appendChild.bind(rowElem));
complete(rowElem);
};
promise.done(completeWithRowElem, error, progress);
}
return rowElem;
},
_firstColElems: null,
_createColPromiseFunc: function _createColPromiseFunc(rowData, colNum, complete, error, progress) {
this._firstColElems = this._firstColElems || [];
this._firstColElems[colNum] = this._firstColElems[colNum] || colElem;
var colElem = document.createElement(this._columnTag);
this._firstColElems = this._firstColElems || [];
this._firstColElems[colNum] = this._firstColElems[colNum] || colElem;
WinJS.Utilities.addClass(colElem, "col_" + colNum);
colElem.attributes["headers"] = "thid" + colNum;
colElem.attributes["field"] = 0 + ":" + colNum;
var colData = rowData[colNum];
if (typeof (colData) === 'object') {
colData = deepCopy(colData);
}
var completeWithColElem = function (elem) {
colElem.appendChild(elem);
complete(colElem);
};
if (this._columnTemplates && this._columnTemplates[colNum]) {
this._columnTemplates[colNum].render({ fieldData: colData }, null).done(completeWithColElem, error, progress);
} else {
colElem.textContent = colData;
complete(colElem);
}
return colElem;
},
_postProcessTables: function _postProcessTables() {
msSetImmediate(this._postProcessTablesImpl.bind(this));
},
_postProcessTablesImpl: function _postProcessTablesImpl() {
if (!this._stickyHeader) { return; }
if (!this._headerCells) { return; }
if (!this._firstColElems) { return; }
for (var j = 0; j < this.tableDataArray[0].length; j++) {
var headerCell = this._headerCells[j];
var tableCell = this._firstColElems[j];
var padding = null;
if (headerCell.clientWidth < tableCell.clientWidth) {
padding = parseInt(tableCell.currentStyle.paddingLeft) + parseInt(tableCell.currentStyle.paddingRight);
headerCell.style.width = (tableCell.clientWidth - padding) + "px";
}
else if (headerCell.clientWidth > tableCell.clientWidth) {
padding = parseInt(headerCell.currentStyle.paddingLeft) + parseInt(headerCell.currentStyle.paddingRight);
tableCell.style.width = (headerCell.clientWidth - padding) + "px";
}
}
},
_rowClickCallbackProxy: function _rowClickCallbackProxy(index, event) {
this.rowClickCallback(this.tableDataArray[index]);
},
_processUpDown: function _processUpDown(srcElem, isUp) {
var elemSibling = isUp ? "previousElementSibling" : "nextElementSibling";
for (var ne = srcElem[elemSibling]; ne; ne = ne[elemSibling]) {
if (ne.nodeName === srcElem.nodeName) {
break;
}
}
if (!ne) {
return;
}
srcElem.tabIndex = -1;
ne.tabIndex = 0;
ne.focus();
},
_processArrowKeyDown: function _processArrowKeyDown(event) {
var keyCode = event.keyCode;
var ne = null;
switch (keyCode) {
case WinJS.Utilities.Key.upArrow:
this._processUpDown(event.srcElement, true);
break;
case WinJS.Utilities.Key.downArrow:
this._processUpDown(event.srcElement, false);
break;
case WinJS.Utilities.Key.leftArrow:
CommonJS.NavigableView.dispatchBoundaryEvent(event.srcElement, CommonJS.NavigableView.Direction.LEFT);
break;
case WinJS.Utilities.Key.rightArrow:
CommonJS.NavigableView.dispatchBoundaryEvent(event.srcElement, CommonJS.NavigableView.Direction.RIGHT);
break;
default:
return;
}
event.stopImmediatePropagation();
event.preventDefault();
},
});
var TableCluster = WinJS.Class.derive(BaseCluster, function (element, options) {
BaseCluster.call(this, element, options);
this._view = new TableView(element, options);
WinJS.UI.setOptions(this, options);
}, {
_view: null,
update: function update(data) {
this._view.tableDataArray = data;
return this._view.render();
},
dispose: function dispose() {
this._view.dispose();
}
});
WinJS.Namespace.define(namespace + ".Clusters", {
TableCluster: TableCluster,
TableView: TableView,
});
})(this, "CommonJS.PanoEx");
