﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: ContentSearch.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
WinJS.Namespace.define("CommonJS", {
ContentSearch: WinJS.Class.define(
// The constructor
function contentSearch_ctor(options) {
this._data = [];
this._cmsData = [];
this._articleUrlMap = {};
this._clusters = new WinJS.Binding.List();
this._needsSnapReset = false;
if (options) {
this._pano = options.pano;
this._pano.clusterDataSource = this._clusters.dataSource;
this._layoutCacheInfo = options.layoutCacheInfo;
this._snappedListView = options.snappedListView;
this._pageLoadSucceededCallback = options.pageLoadSucceededCallback;
this._pageLoadFailedCallback = options.pageLoadFailedCallback;
this._clusterTheme = options.clusterTheme;
this._bdiReporter = options.bdiReporter;
this._onAllResultsReceivedCallback = options.onAllResultsReceivedCallback;
this._onResultReceivedCallback = options.onResultReceivedCallback;
this._partnerContent = options.partnerContent;
if (options.sortResultsByDate) {
this._sortResultsByDate = options.sortResultsByDate;
}
if (options.deDupResults) {
this._deDupResults = options.deDupResults;
}
if (options.deDupPath) {
this._deDupPath = options.deDupPath;
}
if(options.deDupParamName){
this._deDupParamName = options.deDupParamName;
}
if (options.instrCallback && typeof options.instrCallback === "function") {
this._instrCallback = options.instrCallback;
}
}
},
// The set of instance members.
{
_data: [],
_cmsData: [],
_articleUrlMap: {},
_clusters: null,
_layoutCacheInfo: null,
_snappedListView: null,
_pano: null,
_lastSearch: "",
_clusterTheme: null,
_marketStringForAlgoSearch: null,
_sortResultsByDate: false,
_deDupResults: true,
_deDupPath: "/news/apiclick.aspx",
_deDupParamName: "url",
_instrCallback: null,
insertEscapedValue: function insertEscapedValue(dictionary, key, value) {
var escapedValue;
try {
escapedValue = encodeURIComponent(value);
} catch (err) {
console.log("Encountered error:" + err + " escaping value: " + value);
escapedValue = value;
}
dictionary.insert(key, escapedValue);
},
appServerDomain: function appServerDomain() {
return "apxs.cloudapp.net/asp"; //TODO： make this configurable PlatformJS.Services.appConfig.getString("AppServerDomain");
},
getMarketStringForAlgoSearch: function getMarketStringForAlgoSearch() {
if (this._marketStringForAlgoSearch === null) {
var marketParams = PlatformJS.Services.appConfig.getDictionary("MarketParams");
this._marketStringForAlgoSearch = marketParams.getString("AlgoSearch");
}
return this._marketStringForAlgoSearch;
},
getNewsSearch: function getNewsSearch(query, offset, count, sortByDate, bypassCache, /*@optional*/provider) {
msWriteProfilerMark("ContentSearch:getNewsSearch:s");
var bdiConfig = PlatformJS.Services.appConfig.getDictionary("BDIConfig");
var bdiVersions = bdiConfig.getDictionary("Versions");
var currentVersion = bdiConfig.getString("CurrentVersion");
var currentVersionConfig = bdiVersions.getDictionary(currentVersion);
var queryService = new PlatformJS.DataService.QueryService(currentVersionConfig.getString("NewsSearchDataSourceID"));
var transformer = new AppEx.Common.NewsBdiTransformer.Transforms.NewsTransformerWrapper(currentVersion, bdiConfig.getBool("EnableFavIcons"));
var urlParams = PlatformJS.Collections.createStringDictionary();
this.insertEscapedValue(urlParams, "appid", PlatformJS.Services.appConfig.getString("bingAppID"));
this.insertEscapedValue(urlParams, "query", query);
this.insertEscapedValue(urlParams, "offset", offset);
this.insertEscapedValue(urlParams, "count", count);
this.insertEscapedValue(urlParams, "sortbydate", sortByDate ? "1" : "0");
this.insertEscapedValue(urlParams, "market", this.getMarketStringForAlgoSearch());
urlParams.insert("domain", this.appServerDomain());  //note: insertEscapedValue() will encode "/" which casue CSharp layer error
this.insertEscapedValue(urlParams, "et", offset === 0 ? "1" : "0");
var options = new Platform.DataServices.QueryServiceOptions();
options.bypassCache = bypassCache;
options.honorServerExpiryTime = false;
options.useCompatDataModel = true;
if (provider) {
provider.layoutCacheInfo = { cacheKey: queryService.getUrl(urlParams), cacheID: queryService.getCacheID() };
}
return new WinJS.Promise(function (complete, error, progress) {
queryService.downloadDataAsync(urlParams, null, transformer, options).then(function (e) {
if (provider && provider.layoutCacheInfo && e) {
provider.layoutCacheInfo.uniqueResponseID = e.responseId;
}
complete({
url: queryService.getUrl(urlParams),
transformer: transformer,
data: e
});
}, function (e) {
if (PlatformJS.Utilities.isPromiseCanceled(e)) {
return;
}
error(e);
}, function (e) {
if (e.statusCode === Platform.DataServices.QueryServiceStatusCode.cachedEntryFound) {
progress({
url: queryService.getUrl(urlParams),
transformer: transformer,
data: e.cachedResponse
});
}
});
});
},
setLastUpdatedTime: function setLastUpdatedTime(lastUpdatedArray) {
if (Array.isArray(lastUpdatedArray)) {
var watermark = document.querySelector(".platformWatermark");
if (watermark) {
var mostRecentDateTime = Math.max.apply(Math, lastUpdatedArray);
if (mostRecentDateTime > 0) {
var dateTime = new Date(mostRecentDateTime);
var market = Platform.Utilities.Globalization.getCurrentMarket();
var dateFormatting = Windows.Globalization.DateTimeFormatting;
var now = new Date();
var anchor = new Date(now.getFullYear(), now.getMonth(), now.getDate());
if (anchor > dateTime) {
var dateFormat = new dateFormatting.DateTimeFormatter(dateFormatting.YearFormat.none, dateFormatting.MonthFormat.abbreviated, dateFormatting.DayFormat.default, dateFormatting.DayOfWeekFormat.default, dateFormatting.HourFormat.none, dateFormatting.MinuteFormat.none, dateFormatting.SecondFormat.none, [market]);
watermark.innerHTML = ["<span class=\"updatedTimeLabel\">", PlatformJS.Services.resourceLoader.getString("/platform/offline_lastUpdated").format(""), "</span>", "<span class=\"lastUpdatedTime\">", dateFormat.format(dateTime), "</span>"].join("");
}
else {
var timeFormat = new dateFormatting.DateTimeFormatter(dateFormatting.YearFormat.none, dateFormatting.MonthFormat.none, dateFormatting.DayFormat.none, dateFormatting.DayOfWeekFormat.none, dateFormatting.HourFormat.default, dateFormatting.MinuteFormat.default, dateFormatting.SecondFormat.none, [market]);
watermark.innerHTML = ["<span class=\"updatedTimeLabel\">", PlatformJS.Services.resourceLoader.getString("/platform/offline_lastUpdated").format(""), "</span>", "<span class=\"lastUpdatedTime\">", timeFormat.format(dateTime), "</span>"].join("");
}
watermark.tabIndex = 0;
}
else {
watermark.innerHTML = "";
watermark.tabIndex = -1;
}
}
}
},
isCancellationError: function isCancellationError(error) {
return (error && (error.name === "Error" || error.name === "Canceled") &&
error.message && error.message === "Canceled");
},
getRawArticleUrl: function getRawArticleUrl(url, path, paramName) {
var rawUrl = url;
if (url && url.length > 0) {
var uri = Windows.Foundation.Uri(url);
if (uri.path && uri.path.toLowerCase() === path && paramName && paramName.length > 0) {
var query = uri.query;
if (query && query.length > 0 && query[0] === "?") {
var queryTextValue = query.substring(1);
var vars = queryTextValue.split("&");
for (var i = 0; i < vars.length; i++) {
var pair = vars[i].split("=");
if (pair && pair.length === 2 && pair[0].toLowerCase() === paramName) {
rawUrl = pair[1];
break;
}
}
}
}
}
return decodeURIComponent(rawUrl);
},
showToast: function showToast(message) {
var messageBar = new CommonJS.MessageBar(message, { autoHide: true });
messageBar.addButton(PlatformJS.Services.resourceLoader.getString("Dismiss") ||
PlatformJS.Services.resourceLoader.getString("/partners/Dismiss"), function () { messageBar.hide(); });
messageBar.show();
},
getEditorialArticleIdPath: function getEditorialArticleIdPath(article) {
var articleIdPath = null;
if (article.editorial) {
articleIdPath = article.contentid ? article.articleid + "/" + article.contentid : article.articleid + "";
}
return articleIdPath;
},
getArticleReaderNavigationInfo: function getArticleReaderNavigationInfo(
article,
articleIdPath,
marketString,
articleInfos,
source,
instrumentation,
entryPoint,
themeOverride,
adGroups,
cssToInject,
partnerInstrumentationId,
snappedHeaderFontColor,
partnerId,
authInfo,
isPreviewModeEnabled
) {
var that = this;
var navigation = { state: {}, pageInfo: {} };
var providerType = "AppEx.Common.ArticleReader.BedrockArticleProvider";
var providerConfiguration = PlatformJS.Collections.createStringDictionary();
var queryServiceId = "";
if (PlatformJS.isDebug && isPreviewModeEnabled) {
queryServiceId = "MarketPreviewBedrockArticles";
providerConfiguration.insert("queryServiceId", "MarketPreviewBedrockArticles");
}
else {
queryServiceId = "MarketBedrockArticles2";
}
providerConfiguration.insert("queryServiceId", queryServiceId);
providerConfiguration.insert("imageCacheId", "PlatformImageCache");
providerConfiguration.insert("market", marketString);
if (articleInfos) {
providerConfiguration.insert("articleInfos", articleInfos);
}
var articleReaderTheme;
if (themeOverride !== null && themeOverride !== undefined) {
// The condition here is to make sure themeOverride can be empty string which clears all hardcoded default theme. 
articleReaderTheme = themeOverride;
}
else {
articleReaderTheme = "BingDailyArticleReaderTheme";
}
navigation.state = {
providerType: providerType,
providerConfiguration: providerConfiguration,
initialArticleId: articleIdPath,
enableSnap: true,
enableSharing: true,
adPartnerName: partnerInstrumentationId,
instrumentationId: partnerInstrumentationId,
snappedHeaderTitle: PlatformJS.Services.resourceLoader.getString("News"),
snappedHeaderFontColor: "headerFontLight",
theme: articleReaderTheme,
market: marketString,
instrumentation: instrumentation,
};
if (partnerId && authInfo) {
navigation.state.authProvider = { partnerId: partnerId, authInfo: authInfo };
}
if (adGroups) {
navigation.state.adGroups = adGroups;
}
if (cssToInject) {
navigation.state.css = cssToInject;
}
if (snappedHeaderFontColor) {
navigation.state.snappedHeaderFontColor = snappedHeaderFontColor;
}
if (articleInfos || article) {
var partnerBlocks = this._partnerContent ? this._partnerContent.partnerBlocks : null;
if (partnerBlocks) {
var keys = Object.keys(partnerBlocks);
navigation.state.validActions = {};
navigation.state.actionKeys = [];
navigation.state.actionsHandlerType = this._partnerContent.actionsHandlerType;
for (var idx = 0; idx < keys.length; idx++) {
var setupPartner = function (idxKey) {
var partnerKey = keys[idxKey];
var partnerEntry = partnerBlocks[partnerKey];
var partnerChannelID = partnerEntry.getString("ChannelID");
var partnerUri = partnerEntry.getString("PartnerUri");
var partnerName = PlatformJS.Services.resourceLoader.getString(partnerEntry.getString("NameKey"));
if (Platform.Utilities.Globalization.isFeatureEnabled(partnerEntry.getString("FeatureID")) ||
Platform.Utilities.Globalization.isFeatureEnabled(partnerEntry.getString("AlternateFeatureID"))) {
var actionKey = "linkTo" + partnerKey + "Source";
navigation.state.validActions[actionKey] = {
icon: {
type: "image",
url: partnerEntry.getString("IconUrl")
},
text: PlatformJS.Services.resourceLoader.getString("MoreFrom").format(partnerName) || PlatformJS.Services.resourceLoader.getString("/partners/MoreFrom").format(partnerName),
textSize: "small",
actionOptions: {
partnerChannelID: partnerChannelID,
partnerUri: partnerUri,
actionType: "linkToPartner",
},
};
if ((!articleInfos && article && article.source && 0 <= article.source.indexOf(partnerName)) || that._partnerContent.isPartnerApp) {
navigation.state.actionKeys.push(actionKey);
}
}
};
setupPartner(idx);
}
}
}
if (typeof source === "number") {
navigation.state.source = source;
} else {
navigation.state.source = Platform.Instrumentation.InstrumentationEditorialSourceId.protocol; 
}
navigation.state.entryPoint = entryPoint;
navigation.pageInfo.channelId = null;
navigation.pageInfo.fragment = "/common/ArticleReader/html/ArticleReaderPage.html";
navigation.pageInfo.page = "CommonJS.ArticleReaderPage";
if (!PlatformJS.Utilities.hasInternetConnection()) {
var queryService = new PlatformJS.DataService.QueryService(queryServiceId);
var urlParams = PlatformJS.Collections.createStringDictionary();
urlParams.insert("market", marketString);
urlParams.insert("articleId", articleIdPath);
navigation.dataAvailable = queryService.hasEntryAsync(urlParams, null);
} else {
navigation.dataAvailable = WinJS.Promise.wrap(true);
}
return navigation;
},
launchArticle: function launchArticle(
article,
listInfo,
themeOverride,
/*@optional*/adGroups,
/*@optional*/extraOptions,
/*@optional*/cssToInject,
/*@optional*/partnerInstrumentationId,
/*@optional*/entryPoint,
/*@optional*/snappedHeaderFontColor,
/*@optional*/partnerId,
/*@optional*/authInfo) {
var that = this;
if (article.articleId) {
var articleIdPath = article.articleId;
var articleInfos = null;
if (that._cmsData) {
articleInfos = JSON.stringify({
articleInfos: that._cmsData
});
}
var marketParams = PlatformJS.Services.appConfig.getDictionary("MarketParams");
var _marketStringForEditorial = marketParams ? marketParams.getString("Editorial") : null;
var _marketStringForEditorialLowerCase = _marketStringForEditorial ? _marketStringForEditorial.toLowerCase() : null;
var navigation = this.getArticleReaderNavigationInfo(
article,
articleIdPath,
_marketStringForEditorialLowerCase,
articleInfos,
listInfo.source,
null,//listInfo.instrumentation,
0,//entryPoint,
null,//themeOverride,
null,//adGroups,
null,//cssToInject,
null,//partnerInstrumentationId,
null,//snappedHeaderFontColor,
null,//partnerId,
null,//authInfo
null//isPreviewModeEnabled
);
if (navigation && navigation.dataAvailable) {
navigation.dataAvailable.then(function (navigationOk) {
if (navigationOk) {
WinJS.Navigation.navigate({
fragment: navigation.pageInfo.fragment,
page: navigation.pageInfo.page
}, navigation.state);
} else {
that.showToast(PlatformJS.Services.resourceLoader.getString("ArticleUnavailableOffline") || PlatformJS.Services.resourceLoader.getString("/platform/ArticleUnavailableOffline"));
}
});
}
}
else {
//the web url type
if (NewsJS) { //NEWS app only
WinJS.Navigation.navigate({ fragment: "/html/storyPage.html", page: "NewsJS.StoryPage" }, { article: article, listInfo: listInfo });
} else {
window.open(article.articleUrl);
}
}
},
doSearch: function doSearch(queryText, bypassCache) {
var that = this;
this._lastSearch = queryText;
console.log("ContentSearch: doSearch(); ");
if (this._instrCallback) {
this._instrCallback("search");
}
this._data = [];
this._cmsData = [];
var promises = [];
that._articleUrlMap = {};
promises.push(this.getNewsSearch(queryText, 0, 20, that._sortResultsByDate, bypassCache, that).then(function (e) {
return WinJS.Promise.wrap(e);
}, function (error) {
return WinJS.Promise.wrap(null);
}));
var button = PlatformJS.Utilities.getControl("refreshButton");
if (button) {
button.disabled = true;
}
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
msWriteProfilerMark("ContentSearch:Search:getAlgo:s");
this._pageDataPromise = WinJS.Promise.join(promises);
this._pageDataPromise.then(function (e) {
that._pageDataPromise = null;
var resultsReceived = 0;
var lastUpdateTimes = [];
var validSets = 0;
for (var idx = 0; idx < e.length; idx++) {
if (!e[idx]) {
continue;
}
// Use the responseId for the first available response
if (validSets === 0 && e[idx].data) {
if (that._layoutCacheInfo) {
that._layoutCacheInfo.uniqueResponseID = e[idx].data.responseId;
}
}
validSets++;
if (e[idx].data && e[idx].data.lastUpdateTime && e[idx].data.lastUpdateTime.getTime) {
lastUpdateTimes.push(e[idx].data.lastUpdateTime.getTime());
}
resultsReceived += e[idx] ? e[idx].data.dataObject.newsResults.length : 0;
that.resultsReceived(e[idx]);
var totalResults = e[idx] ? e[idx].data.dataObject.totalResults : 0;
if (totalResults <= resultsReceived) {
break;
}
}
if (validSets > 0) {
that.allResultsReceived(!bypassCache, that._pano);
if (that._pageLoadSucceededCallback) {
that._pageLoadSucceededCallback();
};
that.setLastUpdatedTime(lastUpdateTimes);
return WinJS.Promise.wrap();
} else {
return WinJS.Promise.wrapError("Error");
}
}).then(function () {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
// Do nothing
}, function (error) {
msWriteProfilerMark("ContentSearch:Search:getAlgo:e");
that._pageDataPromise = null;
if (!that.isCancellationError(error)) {
if (that._pageLoadFailedCallback) {
that._pageLoadFailedCallback(function () { that._needsSnapReset = true; that.doSearch(that._lastSearch, true); });
}
}
});
},
searchBackbuttonClick: function searchBackbuttonClick() {
console.log("ContentSearch: searchBackbuttonClick()");
this.setClusterDataSource(this._pano);
PlatformJS.Navigation.mainNavigator.canNavigate = true;
this._pano.header._headerBackButton.removeEventListener("click", this._searchBackbuttonClickBind);
},
onCMSClusterHeaderClick: function onCMSClusterHeaderClick() {
console.log("ContentSearch: onCMSClustercHeaderClick()");
this._clusters.splice(0, this._clusters.length);
var that = this;
//set complete CMS result cluster
var cmsResults = { newsItems: this._cmsData };
this._clusters.push({
clusterKey: "ingestedContent",
clusterTitle: "Ingested Article",
clusterContent: {
contentControl: "CommonJS.News.EntityCluster",
contentOptions: {
theme: that._clusterTheme ? that._clusterTheme : "newsAppTheme",
mode: CommonJS.News.ClusterMode.static,
noResultsMessage: "{0} {1}".format(
PlatformJS.Services.resourceLoader.getString("NoResultsMessage"),
PlatformJS.Services.resourceLoader.getString("NoResultsMessage2")),
configObject: CommonJS.News.EntityClusterConfig.DefaultNews,
onitemclick: function onitemclick(arg) { that.itemInvoked(arg); },
dataSet: cmsResults
}
}
});
PlatformJS.Navigation.mainNavigator.canNavigate = false;
this._searchBackbuttonClickBind = this.searchBackbuttonClick.bind(this);
this._pano.header._headerBackButton.addEventListener("click", this._searchBackbuttonClickBind, false);
},
onWebClusterHeaderClick: function onWebClusterHeaderClick() {
console.log("ContentSearch: onWebClustercHeaderClick()");
this._clusters.splice(0, this._clusters.length);
var that = this;
//set complete web result cluster
var dataResults = { newsItems: this._data };
that._clusters.push({
clusterKey: "newsCluster",
clusterTitle: PlatformJS.Services.resourceLoader.getString("NewsResults"),
clusterContent: {
contentControl: "CommonJS.News.EntityCluster",
contentOptions: {
theme: that._clusterTheme ? that._clusterTheme : "newsAppTheme",
mode: CommonJS.News.ClusterMode.static,
noResultsMessage: "{0} {1}".format(
PlatformJS.Services.resourceLoader.getString("NoResultsMessage"),
PlatformJS.Services.resourceLoader.getString("NoResultsMessage2")),
configKey: "EntityClusterDefaultNewsConfig",
configObject: CommonJS.News.EntityClusterConfig.DefaultNews,
onitemclick: function onitemclick(arg) { that.itemInvoked(arg); },
dataSet: dataResults
}
}
});
PlatformJS.Navigation.mainNavigator.canNavigate = false;
this._searchBackbuttonClickBind = this.searchBackbuttonClick.bind(this);
this._pano.header._headerBackButton.addEventListener("click", this._searchBackbuttonClickBind, false);
},
setClusterDataSource: function setClusterDataSource(panoControl) {
var that = this;
this._clusters.splice(0, this._clusters.length);
if (this._data && (this._data.length > 0 || (this._cmsData && this._cmsData.length === 0))) { //always show web result cluster if there's no CMS result
var dataResults = { newsItems: this._data };
this._clusters.push({
clusterKey: "newsCluster",
clusterTitle: PlatformJS.Services.resourceLoader.getString("NewsResults"),
onHeaderSelection: that.onWebClusterHeaderClick.bind(that),
clusterContent: {
contentControl: "CommonJS.News.EntityCluster",
contentOptions: {
theme: that._clusterTheme ? that._clusterTheme : "newsAppTheme",
mode: CommonJS.News.ClusterMode.static,
noResultsMessage: "{0} {1}".format(
PlatformJS.Services.resourceLoader.getString("NoResultsMessage"),
PlatformJS.Services.resourceLoader.getString("NoResultsMessage2")),
configKey: "EntityClusterDefaultNewsConfig",
configObject: CommonJS.News.EntityClusterConfig.DefaultNews,
onitemclick: function onitemclick(arg) { that.itemInvoked(arg); },
dataSet: dataResults,
maxColumnCount: 3
}
}
});
}
if (this._cmsData && this._cmsData.length > 0) {
var cmsResults = { newsItems: this._cmsData };
this._clusters.push({
clusterKey: "ingestedContent",
clusterTitle: "Ingested Article",
onHeaderSelection: that.onCMSClusterHeaderClick.bind(that),
clusterContent: {
contentControl: "CommonJS.News.EntityCluster",
contentOptions: {
theme: that._clusterTheme ? that._clusterTheme : "newsAppTheme",
mode: CommonJS.News.ClusterMode.static,
noResultsMessage: "{0} {1}".format(
PlatformJS.Services.resourceLoader.getString("NoResultsMessage"),
PlatformJS.Services.resourceLoader.getString("NoResultsMessage2")),
configObject: CommonJS.News.EntityClusterConfig.DefaultNews,
onitemclick: function onitemclick(arg) { that.itemInvoked(arg); },
dataSet: cmsResults,
maxColumnCount: 3
}
}
});
}
},
resultsReceived: function resultsReceived(e) {
var that = this;
if (e) {
var data = PlatformJS.Utilities.convertManageToJSON(e.data.dataObject);
if (data.newsResults.length > 0) {
for (var i = 0; i < data.newsResults.length; i++) {
var result = data.newsResults[i];
if (that._bdiReporter) {
result.bdiRequestUrl = e.url;
result.transformer = e.transformer;
}
var rawArticleUrl = that.getRawArticleUrl(result.articleUrl, that._deDupPath, that._deDupParamName);
var pageId = "0";
var contentId = "0";
if ((rawArticleUrl.indexOf("entitytype=article") > -1) && (rawArticleUrl.indexOf("contentId") > -1)) {
var words = rawArticleUrl.split("&");
for (var kk = 0; kk < words.length; kk++) {
if (words[kk].indexOf("pageId=") > -1) {
pageId = (words[kk].split("pageId="))[1];
}
if (words[kk].indexOf("contentId=") > -1) {
contentId = (words[kk].split("contentId="))[1];
}
}
}
var articleId = null;
if (contentId !== "0") {
articleId = pageId + "/" + contentId;
}
// de-dupe the full list of results since it is made using two independent queries to Bing
if (rawArticleUrl && rawArticleUrl.length > 0 && (!that._deDupResults || !that._articleUrlMap[rawArticleUrl])) {
that._articleUrlMap[rawArticleUrl] = 1;
if (articleId) {
result.articleId = articleId;
that._cmsData.push(result);
} else {
that._data.push(result);
}
if (that._onResultReceivedCallback) {
that._onResultReceivedCallback(result);
}
}
}
}
}
},
allResultsReceived: function allResultsReceived(shouldShowEdgy, panoControl) {
var that = this;
if (that._data.length >= 0) {
if (that._onAllResultsReceivedCallback) {
that._onAllResultsReceivedCallback(that._data);
}
that.setClusterDataSource(panoControl);
} else {
}
},
itemInvoked: function itemInvoked(e) {
var that = this;
var item = e.item;
if ((item && item.sentinel) || !window.navigator.onLine) {
return;
}
if (this._instrCallback) {
this._instrCallback("clickOnSearchResultArticle");
}
that.launchArticle(item, { title: that._lastSearch, subTitle: PlatformJS.Services.resourceLoader.getString("NewsResults"), articles: that._data });
}
},
// The set of static members.
{
}),
});
})();
