﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: dynamicArticleReader.js */
(function () {
WinJS.Namespace.define("DynamicPanoJS", {
DynamicArticleReaderPage: WinJS.Class.derive(CommonJS.ArticleReaderPage,
function (state) {
var that = this; 
CommonJS.ArticleReaderPage.call(that, state);
if (that._state.authProvider) {
that.authProvider = DynamicPanoJS.PaywallManager.instance.getAuthProvider(that._state.authProvider.partnerId, that._state.authProvider.authInfo, that._state.instrumentationId);
// disable sharing for any article behind paywall
that._state.enableSharing = false;
}
this._articleChanged = function (event) {
// Check if this is an ad
var isAd = that._articleManager && that._articleManager.getCurrentArticleMetadata().isAd;
that.checkPermissionForCurrentArticle(isAd);
// now enable listening for the articleviewed event
that._articleManager.addEventListener("articleviewed", that._articleViewed);
};
this._articleViewed = function (event) {
that.checkToMarkArticleAsRead();
};
if (this._articleManager.addEventListener) {
this._articleManager.addEventListener("articlechanged", this._articleChanged);
}
this.market = state.market || CommonJS.Globalization.getMarketStringForEditorial();
// Apply dynamic pano CSS
this._dynamicPanoCssLink = document.createElement("link");
this._dynamicPanoCssLink.setAttribute("href", "/common/DynamicPano/css/dynamicPano.css");
this._dynamicPanoCssLink.setAttribute("rel", "stylesheet");
var head = document.getElementsByTagName("HEAD")[0].appendChild(this._dynamicPanoCssLink);
// keep track of current location. used in goBack()
this._startingLocationFragment = WinJS.Navigation.history.current.location.fragment;
},
{
_dynamicPanoCssLink: null,
_loadAuthProviderAttempted: false,
_disposed: false, // to be set only by dispose method
authProvider: null,
dispose: function dispose() {
if (this._disposed) {
return;
}
this._disposed = true;
// Remove dynamic pano CSS
if (this._dynamicPanoCssLink && this._dynamicPanoCssLink.parentNode) {
this._dynamicPanoCssLink.parentNode.removeChild(this._dynamicPanoCssLink);
}
CommonJS.ArticleReaderPage.prototype.dispose.call(this);
},
_setupBottomEdgy: function _setupBottomEdgy() {
var that = this;
CommonJS.ArticleReaderPage.prototype._setupBottomEdgy.call(that);
if (that._state.authProvider) {
var authProvider = DynamicPanoJS.PaywallManager.instance.getAuthProvider(that._state.authProvider.partnerId, that._state.authProvider.authInfo, that._state.instrumentationId);
DynamicPanoJS.setupLoginButton(authProvider);
}
},
goBack: function goBack() {
if (Windows.UI.ViewManagement.ApplicationView.value !== Windows.UI.ViewManagement.ApplicationViewState.snapped  &&
WinJS.Navigation.history.current.location.fragment === this._startingLocationFragment) {
if (WinJS.Navigation.canGoBack) {
WinJS.Navigation.back();
} else {
PlatformJS.Navigation.mainNavigator.resetApp(new Error("DynamicArticleReaderPage cant go back"));
}
}
},
_isAdPage: function _isAdPage(articleData) {
return !!(articleData && articleData.metadata && articleData.metadata.adMetadata);
},
isCurrentArticleLocked: {
get: function get() {
if (this.authProvider) {
var articleMetadata = this._articleManager.getCurrentArticleMetadata();
return !this.authProvider.isReadingAllowed(articleMetadata.articleId, null, null, articleMetadata.free);
} else {
return false;
}
}
},
_allowMarkAsRead: false,
checkPermissionForCurrentArticle: function checkPermissionForCurrentArticle(isAd) {
var that = this;
var authInfoPromise = WinJS.Promise.wrap(null);
if (!that.authProvider) {
var articleMetadata = this._articleManager.getCurrentArticleMetadata();
if (!articleMetadata.free) {
// on first non-free article, load paywall info if not already loaded
// this functionality must be enabled in the config (Default is false)
var loadPaywallAuthInfo = Platform.Configuration.ConfigurationManager.custom.getBool("EnablePaywallReaderLoadAuth");
if (loadPaywallAuthInfo) {
authInfoPromise = that._loadAuthProvider(articleMetadata);
}
}
}
authInfoPromise.done(function performAuthentication() {
if (!that.authProvider) {
return;
}
if (!isAd && that.isCurrentArticleLocked) {
// The current article is Locked
if (that._saveButton) {
that._saveButton.disabled = true;
}
if (Windows.UI.ViewManagement.ApplicationView.value !== Windows.UI.ViewManagement.ApplicationViewState.snapped) {
that.authProvider.getEntitlementsAsync(true, false, true).then(function (isEntitled) {
var attributes = {
currentArticleId: that._articleManager.currentArticleId,
locked: that.isCurrentArticleLocked,
entitled: isEntitled,
};
DynamicPanoJS.Auth.logPaywallAppAction("appaccesspaywallarticle", attributes, that._state.instrumentationId);
if (!isEntitled) {
that.goBack();
} else {
that._allowMarkAsRead = true;
if (that._saveButton) {
that._saveButton.disabled = false;
}
}
}, function () {
that.goBack();
});
}
} else if (!isAd) {
// The current article is Not Locked
// We still retrieve entitlements to accurately instrument whether this is a subscriber who was logged in
that.authProvider.getEntitlementsAsync(false, false, false, true).then(function (isEntitled) {
var attributes = {
currentArticleId: that._articleManager.currentArticleId,
locked: that.isCurrentArticleLocked,
entitled: isEntitled,
};
DynamicPanoJS.Auth.logPaywallAppAction("appaccesspaywallarticle", attributes, that._state.instrumentationId);
});
that._allowMarkAsRead = true;
if (that._saveButton) {
that._saveButton.disabled = false;
}
} else {
that._allowMarkAsRead = false;
}
});
},
checkToMarkArticleAsRead: function checkToMarkArticleAsRead() {
var that = this;
if (!that.authProvider) {
return;
}
if (that._allowMarkAsRead) {
that.authProvider.markAsRead(that._articleManager.currentArticleId);
}
},
onBindingComplete: function onBindingComplete() {
CommonJS.ArticleReaderPage.prototype.onBindingComplete.call(this);
if (this._state.css) {
var mainContent = document.querySelector(".fragment.articleReaderPage");
if (mainContent) {
WinJS.Utilities.addClass(mainContent, "dynamicArticleReader");
var styleElement = document.createElement("style");
if (styleElement) {
styleElement.setAttribute("type", "text/css");
styleElement.setAttribute("id", "partnerStyleAnchor");
styleElement.styleSheet.cssText = toStaticHTML(this._state.css);
var firstChild = mainContent.firstChild;
if (firstChild) {
mainContent.insertBefore(styleElement, firstChild);
} else {
mainContent.appendChild(styleElement);
}
}
}
}
},
onNavigateAway: function onNavigateAway() {
CommonJS.ArticleReaderPage.prototype.onNavigateAway.call(this);
if (this._articleManager.removeEventListener) {
this._articleManager.removeEventListener("articlechanged", this._articleChanged);
this._articleManager.removeEventListener("articleviewed", this._articleViewed);
}
///clean up styles that were applied on the page
var sheets = document.styleSheets;
for (var i = 0; i < sheets.length; i++) {
var sheet = sheets[i];
if (sheet.id === "partnerStyleAnchor") {
var rules = sheet.cssRules;
while (rules.length > 0) {
sheet.deleteRule(rules[0]);
}
var partnerStyleAnchor = document.getElementById("partnerStyleAnchor");
partnerStyleAnchor.parentNode.removeChild(partnerStyleAnchor);
}
}
},
dismissSignInPrompt: function dismissSignInPrompt() {
var that = this;
if (!that.authProvider) {
return;
}
that.authProvider.dismissSignInPrompt();
},
onLayoutChange: function onLayoutChange(viewState) {
var that = this;
CommonJS.ArticleReaderPage.prototype.onLayoutChange.call(this, viewState);
if (!this.authProvider) {
return;
}
if (viewState === Windows.UI.ViewManagement.ApplicationViewState.snapped) {
// Dismiss the auth dialog if it is active.
that.dismissSignInPrompt();
}
else {
var isAd = false;
// Check if this is an ad
if (that._articleManager && that._articleManager._articleDatas && that._articleManager.currentArticleId) {
isAd = that._isAdPage(that._articleManager._articleDatas[that._articleManager.currentArticleId]);
}
this.checkPermissionForCurrentArticle(isAd);
}
},
_loadAuthProvider: function _loadAuthProvider(articleMetadata) {
var that = this;
var channelManager = PlatformJS.Navigation.mainNavigator.channelManager;
// only attempt to load auth once
if (!that._loadAuthProviderAttempted) {
if (channelManager && channelManager.featuredChannels && articleMetadata.instrumentationId) {
// find featured channel with matching instrumentationId to get partner data
// note this isn't a perfect solution since shared links may be from different markets/local markets in which case
// we will not have a match
for (var i = 0; i < channelManager.featuredChannels.length; i++) {
var channel = channelManager.featuredChannels[i];
if (channel.state.dynamicInfo && channel.state.dynamicInfo.instrumentationId === articleMetadata.instrumentationId) {
// matching channel
var options = {
dataSourceName: channel.state.dynamicInfo.dataSourceName,
feedName: channel.state.dynamicInfo.feedName,
feedMarket: channel.state.dynamicInfo.feedMarket,
dataProviderOptions: channel.state.dynamicInfo.dataProviderOptions,
cssFeedUrl: channel.state.dynamicInfo.css,
channelId: channel.state.channelId,
market: this.market
};
var dataProvider = new DynamicPanoJS.DynamicPanoProvider(options);
return dataProvider.getDynamicPanoFeed(false, options.dataSourceName, options.feedName, options.feedMarket)
.then(function (cmsData) {
if (cmsData && cmsData.data.authInfo) {
// set the paywall authprovider
that.authProvider = DynamicPanoJS.PaywallManager.instance.getAuthProvider(channel.state.dynamicInfo.id, cmsData.data.authInfo, channel.state.dynamicInfo.instrumentationId);
}
that._loadAuthProviderAttempted = true;
});
}
}
}
}
return WinJS.Promise.wrap(null);
},
})
});
})();
