﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: dynamicPano.js */
(function () {
"use strict";
var _articleAdConfig = null;
var currentScreenRatio = null;
var _getScreenRatio = function () {
if (currentScreenRatio) {
return currentScreenRatio;
}
currentScreenRatio = 0;
var bodyWidth = document.body.offsetWidth,
bodyHeight = document.body.offsetHeight;
if (bodyWidth && bodyHeight) {
if (CommonJS.Immersive.isPortrait()) {
currentScreenRatio = bodyHeight / bodyWidth;
} else {
currentScreenRatio = bodyWidth / bodyHeight;
}
}
return 0;
};
WinJS.Namespace.define("DynamicPanoJS", {
DynamicPano: WinJS.Class.define(
function categoryPano_ctor(state, onFetchCompleted) {
_articleAdConfig = null;
this.onFetchCompleted = onFetchCompleted;
//copy the state object to prevent contaminating the navigation/app bar's object
state = JSON.parse(JSON.stringify(state));
var that = this;
this._clusters = new WinJS.Binding.List();
if (!state) {
state = {};
}
else {
this._panoramaState = state.panoramaState;
}
if (!state.dynamicInfo) {
state.dynamicInfo = {};
}
this.market = state.dynamicInfo.market || CommonJS.Globalization.getMarketStringForEditorial();
state.dynamicInfo.market = this.market;
this.validateDynamicInfo(state.dynamicInfo);
this.config = this._readConfig("DynamicPano");
this._useSnappedContainer = true;
this.numCategoryClusters = 0;
this._state = state;
this.addRemovePanoramaFlush(false);
this._panoControl = PlatformJS.Utilities.getControl("news_Panorama");
this._elementPanoramaFragment = document.querySelector(".dynamicPano");
this._elementTitleLogo = document.querySelector(".platformMainContent .immersiveHeaderTitle");
this._elementSnappedTitleLogo = document.querySelector(".snappedHeaderList .immersiveHeaderTitle");
this.logoPromises = null;
var refreshButton = PlatformJS.Utilities.getControl("refreshButton");
refreshButton.label = PlatformJS.Services.resourceLoader.getString("/platform/refresh");
refreshButton.onclick = function () { that._refreshPage(); };
var helpButton = PlatformJS.Utilities.getControl("helpButton");
if (helpButton) {
helpButton.label = CommonJS.resourceLoader.getString("/platform/HelpLabel");
helpButton.onclick = function () {
Platform.Telemetry.FlightRecorder.setImpressionNavMethod(Platform.Telemetry.ImpressionNavMethod.appBar);
CommonJS.Settings.onHelpCmd();
};
}
var header = this._elementHeader = document.querySelector(".platformMainContent .immersiveHeader");
this._hgroupElement = header && header.getElementsByTagName("hgroup")[0];
var accentLineContainer = document.createElement("div");
accentLineContainer.id = "dynamicPanoAccentLineContainer";
WinJS.Utilities.addClass(accentLineContainer, "dynamicPanoAccentLineContainer");
var accent = document.createElement("div");
accent.id = "dynamicPanoAccent";
WinJS.Utilities.addClass(accent, "dynamicPanoAccent");
accentLineContainer.appendChild(accent);
var firstChild = this._elementHeader.firstChild;
if (firstChild) {
this._elementHeader.insertBefore(accentLineContainer, firstChild);
} else {
this._elementHeader.appendChild(accentLineContainer);
}
if (this._state.dynamicInfo) {
this._headerColor = this._state.dynamicInfo.backbuttontype === 1 ? "headerFontLight" : "headerFontDark";  //0: dark, 1:light
}
if (this._state.dynamicInfo && this._state.dynamicInfo.isFeaturedSource) {
// prefetch partner header logos
this.logoPromises = this.queryLogos();
var edgy = PlatformJS.Utilities.getControl("actionEdgy");
edgy.addEventListener(
"beforeshow",
function () {
CommonJS.Utilities.Pinning.setupPinFeaturedSourceButton("pinFeaturedSource", that._state.dynamicInfo);
}
);
} else {
var pinFeaturedSource = document.getElementById("pinFeaturedSource");
if (pinFeaturedSource) {
WinJS.Utilities.addClass(pinFeaturedSource, "platformHide");
}
}
this.headerSelectionEnabled = state.dynamicInfo.clusterToRender ? false : true;
this._loadPageData(false);
},
{
countWeight: 2,
_authProvider: null,
_elementPanoramaFragment: null,
_elementTitleLogo: null,
_elementSnappedTitleLogo: null,
_snappedProviders: null,
_clusterTitle: function _clusterTitle(groupData) {
if (groupData.clusterKey === this._hero) {
return PlatformJS.Services.resourceLoader.getString("SemanticZoomHeroClusterTitle");
}
return groupData.clusterTitle;
},
_pageLoadSucceeded: function _pageLoadSucceeded() {
CommonJS.Error.removeError();
//  NewsJS.Utilities.disableButton("refreshButton", false);
CommonJS.Progress.hideProgress(this.progressType);
this.setHeaderColor(this._headerColor);
},
_refreshPage: function _refreshPage(/*@optional*/showToast) {
if (!this.checkOffline(!showToast)) {
this._offlineData = null;
var panoControl = PlatformJS.Utilities.getControl("news_Panorama");
if (panoControl) {
panoControl.panoramaState = null;
}
this._loadPageData(true);
if (this._isSnapped) {
this._openedSnapped = true;
}
}
CommonJS.dismissAllEdgies();
},
snappedFragmentCreated: function snappedFragmentCreated() {
this._elementSnappedTitleLogo = document.querySelector(".snappedHeaderList .immersiveHeaderTitle");
},
showToast: function showToast(message) {
var messageBar = new CommonJS.MessageBar(message, { autoHide: true });
messageBar.addButton(PlatformJS.Services.resourceLoader.getString("/platform/Dismiss") ||
PlatformJS.Services.resourceLoader.getString("/partners/Dismiss"), function () { messageBar.hide(); });
messageBar.show();
},
checkOffline: function checkOffline(dontShowToast) {
this.isOnline = PlatformJS.Utilities.hasInternetConnection();
if (this.isOnline) {
//TODO   this.toggleOfflineArticles(true);
return false;
}
else {
if (!dontShowToast) {
var msg = PlatformJS.Services.resourceLoader.getString("/platform/ArticleUnavailableOffline");
this.showToast(msg);
}
return true;
}
},
_readConfig: function _readConfig(nodeName) {
var pano = PlatformJS.Services.appConfig.getDictionary(nodeName);
var readList = function (list) {
var obj = {};
for (var j = 0; j < list.length; j++) {
var subList = list[j];
var keys = Object.keys(subList);
for (var i in keys) {
var val = keys[i];
obj[val] = subList.getString(val);
}
};
return obj;
};
if (!pano) {
console.log(nodeName + " dictionary does not exist in appconfiguration.xml");
}
var ss = pano.getList("SlideshowConfig", Platform.Configuration.ListConfigurationItem.empty);
var ar = pano.getList("ArticleReaderConfig", Platform.Configuration.ListConfigurationItem.empty);
var cp = pano.getList("CategoryPageConfig", Platform.Configuration.ListConfigurationItem.empty);
var config = {
slideshow: readList(ss),
articlereader: readList(ar),
cacheId: pano.getString("CacheID"),
categorypage: readList(cp)
};
return config;
},
addRemovePanoramaFlush: function addRemovePanoramaFlush(shouldAdd) {
var panoEl = document.getElementById("news_Panorama");
if (panoEl) {
if (shouldAdd) {
WinJS.Utilities.addClass(panoEl, "platformPanoramaFlushLeft");
}
else {
WinJS.Utilities.removeClass(panoEl, "platformPanoramaFlushLeft");
}
}
},
applicationViewState: { fullScreenLandScape: 0, filled: 1, snapped: 2, fullScreenPortrait: 3 },
onViewStateChange: function onViewStateChange(viewState, /*@optional*/e) {
var lastViewState = this._lastViewState;
this._lastViewState = viewState;
// TODO: re-enable if/when snap is supported
//if (viewState === this.applicationViewState.snapped || lastViewState === this.applicationViewState.snapped) {
//   // this.changeSnapState(viewState);
//}
var panoControl = PlatformJS.Utilities.getControl("news_Panorama");
if (panoControl) {
if (viewState === this.applicationViewState.fullScreenPortrait || lastViewState === this.applicationViewState.fullScreenPortrait) {
panoControl.onOrientationChange(e);
}
if (viewState === Windows.UI.ViewManagement.ApplicationViewState.snapped) {
// Dismiss the auth dialog if it is active.
this.dismissSignInPrompt();
}
// TODO: re-enable if/when snap is supported
//if (!(viewState === this.applicationViewState.fullScreenLandScape && lastViewState === this.applicationViewState.fullScreenPortrait) && !(viewState === this.applicationViewState.fullScreenPortrait && lastViewState === this.applicationViewState.fullScreenLandScape)) {
//  //  panoControl.onLayoutChange(viewState);
//}
this.populatePanoBranding();
}
},
dismissSignInPrompt: function dismissSignInPrompt() {
if (this._authProvider) {
this._authProvider.dismissSignInPrompt();
}
},
onWindowResize: function onWindowResize(e) {
var panoControl = PlatformJS.Utilities.getControl("news_Panorama");
if (panoControl && panoControl.onWindowResize) {
panoControl.onWindowResize(e);
}
this.populatePanoBranding();
},
onOrientationChange: function onOrientationChange(e) {
this.onViewStateChange(Windows.UI.ViewManagement.ApplicationView.value, e);
},
setHeaderColor: function setHeaderColor(color) {
// need to set the header class on the pano element as well since it gets removed from header when scrolling
var panoElement = document.getElementById("news_Panorama");
if (panoElement) {
WinJS.Utilities.addClass(panoElement, color);
}
var headerControl = PlatformJS.Utilities.getControl("news_Panorama_header");
this._headerColor = color;
if (headerControl) {
headerControl.fontColor = color;
}
},
onLayoutChange: function onLayoutChange(viewState) {
this.onViewStateChange(viewState);
},
_loadPageData: function _loadPageData(bypassCache) {
var that = this;
var options = {
dataSourceName: that._state.dynamicInfo.dataSourceName,
feedName: that._state.dynamicInfo.feedName,
feedMarket: that._state.dynamicInfo.feedMarket,
dataProviderOptions: that._state.dynamicInfo.dataProviderOptions,
cssFeedUrl: that._state.dynamicInfo.css,
channelId: that._state.channelId,
market: that.market
};
that.dataProvider = new DynamicPanoJS.DynamicPanoProvider(options);
if (bypassCache) {
that._pageWrapperDataPromise = new WinJS.Promise.wrap(null);
} else {
that._pageWrapperDataPromise = that.dataProvider.fetchCacheData();
}
this.progressType = CommonJS.Progress.headerProgressType;
CommonJS.Progress.showProgress(this.progressType);
// Try getting cached data first
return that._pageWrapperDataPromise.then(
function pageWrapperDataFromCache_complete(complete) {
if (complete) {
if (complete.cmsData) {
that.processFetch(complete);
that._pageLoadSucceeded();
that._pageRendered = true;
}
}
}, function (error) {
that._pageWrapperDataPromise = null;
}).then(function pageWrapperDataFromNetwork() {
// Now try fetching from network
that._pageWrapperDataPromise = that.dataProvider.fetchNetworkData(bypassCache);
that._pageDataPromise = that.dataProvider.fetchPromise;
return that._pageWrapperDataPromise.then(
function pageWrapperDataFromNetwork_complete(complete) {
that._pageDataPromise = that._pageWrapperDataPromise = null;
if ((DynamicPanoJS.forceRefreshPano || complete.isNewData || !that._pageRendered) &&
complete.cmsData) {
DynamicPanoJS.forceRefreshPano = false;
var panoControl = PlatformJS.Utilities.getControl("news_Panorama");
if (panoControl) {
panoControl.panoramaState = null;
}
that.processFetch(complete);
}
if (complete.cmsData && that._clusters && that._clusters.length) {
// Only declare succeed when there's cms data and at least one cluster. 
that._pageLoadSucceeded();
}
else if (!that._pageRendered) {
that._pageLoadFailed(function () {
that._refreshPage();
});
}
},
function (error) {
that._pageDataPromise = that._pageWrapperDataPromise = null;
if (!PlatformJS.Utilities.isPromiseCanceled(error) && !that._pageRendered) {
that._pageLoadFailed(function () {
that._refreshPage();
});
}
},
function (progress) {
});
});
},
_pageLoadFailed: function _pageLoadFailed(refreshFunction) {
var that = this;
CommonJS.Error.showError(PlatformJS.Utilities.hasInternetConnection() ? CommonJS.Error.STANDARD_ERROR : CommonJS.Error.NO_INTERNET,
refreshFunction ? refreshFunction : function () { that._loadPageData(false); });
//NewsJS.Utilities.disableButton("refreshButton", false);
CommonJS.Progress.hideProgress(this.progressType);
},
_applyCustomStyling: function _applyCustomStyling() {
var css = this._cssData;
if (css) {
var partnerStyleAnchor = document.getElementById("partnerStyleAnchor");
if (partnerStyleAnchor) {
partnerStyleAnchor.styleSheet.cssText = toStaticHTML(this._cssData);
}
}
},
onNavigateAway: function onNavigateAway() {
// Get pano element
var panoElement = document.getElementById("news_Panorama");
if (panoElement && panoElement.style) {
// Hide panorama, avoids visual artifacts
// since we're removing the dynamically linked styles/templates
panoElement.style.display = "none";
}
///clean up styles that were applied on the page
var sheets = document.styleSheets;
for (var i = 0; i < sheets.length; i++) {
var sheet = sheets[i];
if (sheet.id === "partnerStyleAnchor") {
var rules = sheet.cssRules;
while (rules.length > 0) {
sheet.deleteRule(rules[0]);
}
var partnerStyleAnchor = document.getElementById("partnerStyleAnchor");
partnerStyleAnchor.parentNode.removeChild(partnerStyleAnchor);
}
}
if (this.logoPromises) {
this.logoPromises.cancel();
}
if (this._pageWrapperDataPromise) {
this._pageWrapperDataPromise.cancel();
}
if (this._pageDataPromise) {
this._pageDataPromise.cancel();
}
// If there is video playing inform the video player to close. We need this explicitly because when snapping the navigate event (which the video player is listening to) may not fire.
CommonJS.WindowEventManager.getInstance().dispatchEvent("samePageNav", event);
},
dispose: function dispose() {
if (this._panoControl &&
this._panoControl.dispose) {
this._panoControl.dispose();
}
},
addTitleLogo: function addTitleLogo() {
var that = this;
if (that.logoPromises) {
// complete the logo prefetch before applying
that.logoPromises = that.logoPromises.then(function (results) {
that.logoPromises = null;
if (results) {
that.logoUrl = results.length > 0 ? results[0] : null;
that.snapLogoUrl = results.length > 1 ? results[1] : null;
if (that.logoUrl) {
that._addTitleLogo();
}
else {
that._removeTitleLogo();
}
}
}, function (error) {
that.logoPromises = null;
});
} else if (that.logoUrl) {
that._addTitleLogo();
}
},
_removeTitleLogo: function _removeTitleLogo() {
var hgroupElement = this._hgroupElement;
if (hgroupElement) {
WinJS.Utilities.removeClass(hgroupElement, "pendingLogo");
}
var panoFragment = this._elementPanoramaFragment; //document.querySelector(".dynamicPano");
if (panoFragment) {
WinJS.Utilities.removeClass(panoFragment, "useLogo");
}
var header = this._elementTitleLogo;  //document.querySelector(".platformMainContent .immersiveHeaderTitle");
if (header) {
WinJS.Utilities.removeClass(header, "useLogo");
header.removeChild(header.firstChild);
header.innerText = this.getPanoTitle();
}
},
_addTitleLogo: function _addTitleLogo() {
var that = this;
// set the header's logo background image if requested
var panoFragment = this._elementPanoramaFragment;
var hgroupElement = this._hgroupElement;
if (this.logoUrl) {
var addTitleLogoWorker = function (foundElement, logoUrl) {
if (foundElement) {
if (!WinJS.Utilities.hasClass(foundElement, "useLogo")) {
WinJS.Utilities.addClass(foundElement, "useLogo");
if (logoUrl) {
foundElement.innerText = "";
var logoElement = document.createElement("img");
logoElement.src = logoUrl;
foundElement.appendChild(logoElement);
}
}
}
};
if (panoFragment) {
addTitleLogoWorker(panoFragment);
}
if (hgroupElement) {
WinJS.Utilities.removeClass(hgroupElement, "pendingLogo");
}
addTitleLogoWorker(this._elementTitleLogo /*document.querySelector(".platformMainContent .immersiveHeaderTitle")*/, that.logoUrl);
var snapLogoUrl = that._state.dynamicInfo.snapLogoUrl ? that.snapLogoUrl : that.logoUrl;
if (snapLogoUrl) {
addTitleLogoWorker(this._elementSnappedTitleLogo /*document.querySelector(".snappedHeaderList .immersiveHeaderTitle")*/, snapLogoUrl);
}
} else {
if (hgroupElement) {
WinJS.Utilities.removeClass(hgroupElement, "pendingLogo");
}
}
},
getLogo: function getLogo(logoUrl, forceCacheId) {
var that = this;
var networkCallRequired = function () {
;
};
var cacheId = forceCacheId ? forceCacheId : this.config.cacheId;
return new WinJS.Promise(function (complete, error) {
var staleResponse = null;
var exit = function (response,/*@optional*/err) {
if (response) {
// fallback to stale response
complete(response.dataValue);
} else {
error(err || new Error());
}
};
PlatformJS.Cache.CacheService.getInstance(cacheId).findEntry(logoUrl, { fileNameOnly: true })
.then(function (response) {
if (response && response.isStale()) {
// remember a stale response for fallback
staleResponse = response;
}
if (response && !staleResponse) {
// cached logo entry exists and is not stale
complete(response.dataValue);
return WinJS.Promise.wrap(null);
}
// there is no pre-existing and up-to-date cached logo image
if (PlatformJS.Utilities.hasInternetConnection()) {
return PlatformJS.Utilities.fetchImage(cacheId, logoUrl, networkCallRequired);
} else {
exit(staleResponse);
}
})
.done(function (finalResponse) {
if (finalResponse) {
// the cached logo image entry exists and is not stale
complete(finalResponse);
}
}, function (err) {
exit(staleResponse, err);
});
});
},
// get both the unsnapped and snapped logos at once
queryLogos: function queryLogos(fetch) {
var that = this;
var promises = [];
if (that._state.dynamicInfo) {
if (that._state.dynamicInfo.logoUrl || that._state.dynamicInfo.snapLogoUrl) {
var hgroupElement = this._hgroupElement;
if (hgroupElement) {
WinJS.Utilities.addClass(hgroupElement, "pendingLogo");
}
}
if (that._state.dynamicInfo.logoUrl) {
that.logoUrl = null;
promises.push(that.getLogo(that._state.dynamicInfo.logoUrl).then(
function (response) { return WinJS.Promise.wrap(response); },
function () { return WinJS.Promise.wrap(null); }));
}
if (that._state.dynamicInfo.snapLogoUrl) {
that.snapLogoUrl = null;
promises.push(that.getLogo(that._state.dynamicInfo.snapLogoUrl).then(
function (response) { return WinJS.Promise.wrap(response); },
function () { return WinJS.Promise.wrap(null); }));
}
//prefetch the pinning logo of partner pano
var pinLogoUrls = that._state.dynamicInfo.pinLogoUrls;
if (pinLogoUrls) {
for (var key in pinLogoUrls) {
var pinLogoUrl = pinLogoUrls[key];
if (pinLogoUrl) {
promises.push(that.getLogo(pinLogoUrl, "CustomPanoPinningLogoCache").then(
function (response) { return WinJS.Promise.wrap(response); },
function () { return WinJS.Promise.wrap(null); }));
}
}
}
}
return WinJS.Promise.join(promises);
},
getPageImpressionContext: function getPageImpressionContext() {
// used by navigator to build the impression for Platform.Telemetry
if (this._state.dynamicInfo.clusterID) {
return "/Partner Pano/Sub Pano";
}
return "/Partner Pano";
},
getPageImpressionPartnerCodeAndAttributes: function getPageImpressionPartnerCodeAndAttributes() {
var isEmptyDictionary = function (ob) {
for (var i in ob) {
return false;
}
return true;
};
var results = { partnerCode: this._state.dynamicInfo.instrumentationId };
var attributes = {};
if (this._state.dynamicInfo.clusterID) {
attributes['SubPanoChannel'] = this._state.dynamicInfo.clusterID;
};
if (!isEmptyDictionary(attributes)) {
results['attributes'] = attributes;
}
return results;
},
onBindingComplete: function onBindingComplete() {
this.addTitleLogo();
},
getSnappedHeaderListOptions: function getSnappedHeaderListOptions() {
var that = this;
return {
headerOptions: {
headerTitleText: that.getPanoTitle()
},
listViewOptions: {
itemDataSource: that.getSnappedHeaderListDataSource(),
oniteminvoked: function oniteminvoked(e) { that.snappedItemInvoked(e); }
}
};
},
onEnterExitSnap: function onEnterExitSnap() {
var that = this;
that.addTitleLogo();
},
snappedItemInvoked: function snappedItemInvoked(e) {
var that = this;
var listView = this.getSnappedListView();
if (listView) {
listView.itemDataSource.itemFromIndex(e.detail.itemIndex).then(function (f) {
if (f.data.article.categoryKey === "videos") {
// the snapped mode templates don't support the auto-playing of videos, so do it manually here.
var uri = null; throw ""; //  NewsJS.Utilities.parseCMSUriString(f.data.article.destination);
if (!uri || !uri.contentId) {
console.log("unable to extract contentID from video clip to launch: " + e);
return;
} else {
var videoOptions = f.data.article.thumbnail.videoOptions;
CommonJS.MediaApp.Controls.MediaPlayback.fullscreenPlayback(videoOptions.videoSource, videoOptions);
}
that.videoItemInvoked({ item: f.data.article });
} else {
that.itemInvoked({ item: f.data.article });
}
});
}
},
validateDynamicInfo: function validateDynamicInfo(dynamicInfo) {
// HACK: need to split multiple adUnitIds into the tower adUnitId and Video adUnitId
if (dynamicInfo && dynamicInfo.adUnitId && dynamicInfo.isFeaturedSource) {
var adUnitIds = dynamicInfo.adUnitId.split(";");
if (adUnitIds && adUnitIds.length > 1) {
dynamicInfo.videoAdUnitId = adUnitIds[1];
dynamicInfo.adUnitId = adUnitIds[0];
}
}
},
capCMSArticles: function capCMSArticles() {
return true;
},
processFetch: function processFetch(data) {
var that = this;
that._cssData = data.cmsCss;
that._applyCustomStyling();
that._cmsData = null;
that._categoryLeadStories = {};
that.handleCMS(data.cmsData);
that.fetchCompleted();
},
fetchCompleted: function fetchCompleted() {
msWriteProfilerMark("Platform:DynamicPano:fetchCompleted:s");
this._snappedProviders = [];
this.populatePanoBranding();
this.populateHeroAndCategories();
//this._newsProviderAdapter = new CommonJS.NewsProviderAdapter({
//    providers: this._snappedProviders
//});
// If we're snapped, give the snapped list view the new data
// TODO: Snapped mode is not supported in partner panos.
//if (Windows.UI.ViewManagement.ApplicationView.value === Windows.UI.ViewManagement.ApplicationViewState.snapped) {
//    var listView = this.getSnappedListView();
//    if (listView) {
//        listView.itemDataSource = new CommonJS.VirtualizedDataSource(this._newsProviderAdapter);
//    }
//}
if (this.onFetchCompleted) {
this.onFetchCompleted(this);
}
msWriteProfilerMark("Platform:DynamicPano:fetchCompleted:e");
},
populatePanoBranding: function populatePanoBranding() {
// no background images in subpanos
if (!this._state.dynamicInfo || this._state.dynamicInfo.clusterID) {
return;
}
var panoControl = PlatformJS.Utilities.getControl("news_Panorama");
if (panoControl && panoControl._element && panoControl._element.style && this._cmsData) {
if (this._cmsData.backgroundImages) {
var panoBackgroundImage = this._getPanoBackgroundImage(this._cmsData.backgroundImages);
var panoControlStyle = panoControl._element.style;
panoControlStyle.backgroundImage = panoBackgroundImage ? "url(" + panoBackgroundImage + ")" : "";
}
}
},
_getPanoBackgroundImage: function _getPanoBackgroundImage(imageArray) {
var ratio = _getScreenRatio();
var wideStandard = ratio > 1.5 ? "Wide" : "Standard";
var key = (CommonJS.Immersive.isPortrait() ? "portrait" : "landscape") + wideStandard;
// can later modify for resolutions if desired.
for (var i = 0; i < imageArray.length; i++) {
var image = imageArray[i];
if (image.name === key) {
return image.url;
}
}
return null;
},
createHero: function createHero() {
var that = this;
if (that._cmsData && that._cmsData.hero) {
this.addRemovePanoramaFlush(true);
var editorial = that._cmsData.hero;
var heroList = new WinJS.Binding.List();
that.cmsHeroCluster.call(this, editorial, heroList);
}
else {
this.addRemovePanoramaFlush(false);
}
},
getEditorialArticleIdPath: function getEditorialArticleIdPath(article) {
var articleIdPath = null;
if (article.editorial) {
articleIdPath = article.contentid ? article.articleid + "/" + article.contentid : article.articleid + "";
}
return articleIdPath;
},
getArticleInfo: function getArticleInfo(article) {
var articleInfo = null;
var articleIdPath = this.getEditorialArticleIdPath(article);
if (articleIdPath) {
articleInfo = {
articleId: articleIdPath
};
}
return articleInfo;
},
getFeaturedChannel: function getFeaturedChannel(channelID) {
var allFeaturedChannels = PlatformJS.Navigation.mainNavigator.channelManager.featuredChannels;
var featuredChannel = null,
j = 0;
for (j = 0; j < allFeaturedChannels.length; j++) {
if (allFeaturedChannels[j].id === channelID) {
featuredChannel = allFeaturedChannels[j];
break;
}
}
return featuredChannel;
},
createChannel: function createChannel(id, title, icon, subChannels, fragment, page, state) {
return {
id: id,
title: title,
icon: icon,
subChannels: subChannels,
pageInfo: {
fragment: fragment,
page: page,
channelId: id,
},
state: state,
isDisplayValue: true
};
},
populateL2IfHoisted: function populateL2IfHoisted(sortedDataSource) {
var that = this;
var changed = false;
if (sortedDataSource.length > 1) {
var channelId = WinJS.Navigation.location.channelId;
PlatformJS.Navigation.mainNavigator.loadFeaturesConfigAsync().then(function loadFeatures_Complete() {
if (channelId && channelId === that._state.dynamicInfo.id) {
var featuredChannel = that.getFeaturedChannel(channelId);
if (featuredChannel) {
if (featuredChannel.subChannels) {
changed = true;
featuredChannel.subChannels = [];
for (var idx = 0; idx < sortedDataSource.length; idx++) {
var item = sortedDataSource.getItem(idx);
if (item && item.data && item.data.clusterTitle && item.data.clusterKey && item.data.clusterKey.indexOf("AdsCluster") !== 0) {
var title = item.data.clusterTitle;
var key = item.data.clusterKey;
var id = featuredChannel.id + "_" + title;
var state = JSON.parse(JSON.stringify(featuredChannel.state));
state.dynamicInfo.clusterID = key;
state.dynamicInfo.clusterToRender = key;
state.dynamicInfo.clusterTitle = title;
var newChannel = that.createChannel(
id,
title,
"",
[],
featuredChannel.pageInfo.fragment,
featuredChannel.pageInfo.page,
state);
featuredChannel.subChannels.push(newChannel);
}
}
}
}
}
if (changed) {
PlatformJS.Navigation.mainNavigator.channelManager.channelConfigChanged = true;
}
});
}
},
setArticleInfosOnDataSource: function setArticleInfosOnDataSource(dataSource, heroArticle) {
if (dataSource && dataSource.length) {
var articleInfos = [];
// This array will contain all the references to the editorial articles in the pano. 
var articles = [];
var entityClusterStartIndex = 0;
// Handle the pano which has a hero since we can have a heroless pano
var heroCluster = dataSource.getItem(0);
if (heroCluster && heroCluster.data && heroCluster.data.clusterKey === "Hero") {
if (heroArticle && heroArticle.type === "article") {
var heroArticleInfo = this.getArticleInfo(heroArticle);
if (heroArticleInfo) {
articleInfos.push(heroArticleInfo);
articles.push(heroArticle);
}
}
entityClusterStartIndex++;
}
for (var i = entityClusterStartIndex; i < dataSource.length; i++) {
var dataItem = dataSource.getItem(i);
if (dataItem
&& dataItem.data
&& dataItem.data.clusterContent
&& dataItem.data.clusterContent.contentOptions
&& dataItem.data.clusterContent.contentOptions.dataSet
&& dataItem.data.clusterContent.contentOptions.dataSet.newsItems
&& dataItem.data.clusterContent.contentOptions.dataSet.newsItems.length) {
var newsItems = dataItem.data.clusterContent.contentOptions.dataSet.newsItems;
for (var j = 0; j < newsItems.length; j++) {
var newsItem = newsItems[j];
if (newsItem && newsItem.type === "article") {
var articleInfo = this.getArticleInfo(newsItem);
if (articleInfo) {
articleInfos.push(articleInfo);
articles.push(newsItem);
}
}
}
}
}
var clusterArticles = { articleInfos: articleInfos };
for (var k = 0; k < articles.length; k++) {
articles[k].clusterArticles = clusterArticles;
}
}
},
populateHeroAndCategories: function populateHeroAndCategories() {
var that = this;
var isAdEnabled = PlatformJS.Ads.getAdsConfig() ? true : false;
var adUnitId = "";
var subclusterAdFrequency = 4;
if (isAdEnabled) {
if (that._state.dynamicInfo.isFeaturedSource && (!that._state.dynamicInfo.adUnitId || that._state.dynamicInfo.adUnitId.length === 0)) {
isAdEnabled = false;
} else {
adUnitId = that._state.dynamicInfo.adUnitId;
subclusterAdFrequency = PlatformJS.Services.appConfig.getInt32("EntityClusterAdFrequency");
}
}
var panoControl = PlatformJS.Utilities.getControl("news_Panorama");
var heroVisible = false;
var categoryDataArray = [];
this._clusters = new WinJS.Binding.List();
this._subChannels = new WinJS.Binding.List();
// TODO: configify the default of 3 per app
var defaultMaxClusterColumns = this._state.dynamicInfo.clusterColumnMax || (that._state.dynamicInfo.clusterToRender ? 0 : 3);
var isEndOfPanoAdEnabled = isAdEnabled && defaultMaxClusterColumns !== 0;
if (!that._state.dynamicInfo.clusterToRender) {
that.createHero.call(this);
if (that._cmsData && that._cmsData.hero) {
// Push stuff for snap mode
this._snappedProviders.push({
title: PlatformJS.Services.resourceLoader.getString("TopStory"),
articles: [that._cmsData.hero]
});
heroVisible = true;
}
}
var categoryOrder = that._cmsData.categoryOrder;
if (categoryOrder && categoryOrder.length <= 1 && defaultMaxClusterColumns && !that._state.dynamicInfo.clusterColumnMax) {
// Don't limit the number of maximum columns when there is only one column (and hence no L2/drilldown)
defaultMaxClusterColumns = 0;
isEndOfPanoAdEnabled = false;
}
var numCategoryClusters = 0;
var categoryToRender = that._state.dynamicInfo.clusterToRender;
if (categoryOrder && categoryOrder.length > 0) {
if (categoryOrder.length === 1) {
that.headerSelectionEnabled = false;
}
for (var z = 0; z < categoryOrder.length; z++) {
var categoryKey = categoryOrder[z];
var categoryName = that._cmsData.categories[categoryKey].categoryName;
var newsItems = [];
// Semantic zoom data
var clusterInfo = {
title: categoryName,
thumbnail: {
url: ""
},
moduleInfo: {
height: "140px",
width: "290px",
templateId: "dynamicPanoSemanticTileNoImage"
}
};
var maxColumnCount = defaultMaxClusterColumns; // use default setting unless overridden for the cluster
if (that._cmsData && that._cmsData.categories) {
var cmsCategoryData = that._cmsData.categories[categoryKey];
if (cmsCategoryData) {
// defaultMaxClusterColumns === 0 means that we are in a subpano. 
// In this case we do not was to override to restrict but show all articles
if (defaultMaxClusterColumns > 0 && cmsCategoryData.maxColumnCount && cmsCategoryData.maxColumnCount > 0) {
maxColumnCount = cmsCategoryData.maxColumnCount;
}
if (cmsCategoryData.entities) {
for (var k = cmsCategoryData.entities.length - 1; k >= 0; k--) {
var heroResult = cmsCategoryData.entities[k];
heroResult.categoryKey = categoryKey;
if (heroResult) {
// First editorial article uses lead story template for template class system.
if (k === 0) {
heroResult.isLead = true;
}
// Add the editorial article the the combined list of editorial and algo
newsItems.unshift(heroResult);
if (heroResult.semanticZoomThumbnail && heroResult.semanticZoomThumbnail.url) {
clusterInfo.thumbnail = {
url: heroResult.semanticZoomThumbnail.url
};
clusterInfo.moduleInfo.templateId = "dynamicPanoSemanticTile";
}
}
}
}
}
}
if (this.capCMSArticles()) {
var maxCMSArticles = newsItems.length;//TODO //PlatformJS.Services.appConfig.getInt32("MaxCMSArticles");
newsItems = newsItems.slice(0, maxCMSArticles);
}
var authProvider = null;
var entitlementPromise = WinJS.Promise.wrap(true);
if (that._cmsData) {
that._authInfo = that._cmsData.authInfo;
if (that._authInfo) {
try {
that._authProvider = authProvider = DynamicPanoJS.PaywallManager.instance.getAuthProvider(that._state.dynamicInfo.id, that._authInfo, that._state.dynamicInfo.instrumentationId);
}
catch (error) {
newsItems.length = 0;
that._pageRendered = false;
return;
}
entitlementPromise = authProvider.getEntitlementsAsync(false, false, false, true);
DynamicPanoJS.setupLoginButton(authProvider, function () { that._refreshPage(); });
DynamicPanoJS.setupSubscribeButton(authProvider);
}
}
// Generate lock icon for each item if necessary
if (authProvider) {
for (var l = 0; l < newsItems.length; l++) {
var editorialArticle = newsItems[l];
// bug 362062: filter out non-articles
if (editorialArticle && editorialArticle.type === "article") {
var articleIdPath = this.getEditorialArticleIdPath(editorialArticle);
if (articleIdPath) {
entitlementPromise.then(function (isEntitled) {
if (!isEntitled && !authProvider.isReadingAllowed(articleIdPath, null, null, editorialArticle.paywall)) {
editorialArticle.isLocked = true;
} else {
editorialArticle.isLocked = false;
}
});
}
}
}
}
if (newsItems && newsItems.length > 0) {
categoryDataArray.push({ editorialArticles: newsItems, newsItems: newsItems });
this._snappedProviders.push({
title: categoryName,
articles: newsItems
});
//TODO: Right now the dynamicInfo doesn't have theme so it'll be defaulted to the not boxed theme.
var theme = that._state.dynamicInfo.theme ? that._state.dynamicInfo.theme : "dynamicPanoUnboxedTheme";
var isClustersOrSubChannels = null;
(function (clusterIndex) {
var dataResults = { newsItems: categoryDataArray[clusterIndex].newsItems };
if (that.dataProvider.layoutCacheInfo) {
dataResults.clusterID = that._state.dynamicInfo.clusterID || categoryKey + "_limited";
dataResults.cacheID = that.dataProvider.layoutCacheInfo.cacheID;
dataResults.dataCacheID = that.dataProvider.layoutCacheInfo.cacheKey;
dataResults.uniqueResponseID = that._cmsData.uniqueResponseId;
}
var enableVideoAds;
if (that._state.dynamicInfo.isFeaturedSource) {
// for Partner Panos, disable video ads if partner data doesn't have a video ad unit id
enableVideoAds = !!that._state.dynamicInfo.videoAdUnitId;
}
var contentOptions = {
theme: cmsCategoryData.isVideoCluster ? "dynamicPanoBoxedTheme" : theme,
mode: CommonJS.News.ClusterMode.static,
marginDistance: that._state.dynamicInfo.marginDistance,
marginWidth: that._state.dynamicInfo.marginWidth,
unitWidth: cmsCategoryData.isVideoCluster ? 23 : null,
videoAdUnitId: that._state.dynamicInfo.videoAdUnitId,
enableVideoAds: enableVideoAds,
onitemclick: categoryKey === "videos" ? function (e) {
that.videoItemInvoked(e);
} : function (e) {
that.itemInvoked(e);
},
maxColumnCount: categoryKey === "featuredArticles" ? null : maxColumnCount,
dataSet: dataResults,
configKey: that._state.dynamicInfo.templateConfig ? that._state.dynamicInfo.templateConfig : "EntityClusterDefaultNewsConfig",
configObject: CommonJS.News.EntityClusterConfig.DefaultNews,
newsQuery: { categoryKey: categoryKey },
instrumentationEntryPoint: that._state.dynamicInfo.isFeaturedSource ? Platform.Instrumentation.InstrumentationArticleEntryPoint.partnerPano : null
};
if (isAdEnabled) {
contentOptions.subclusterAdFrequency = 1;
contentOptions.adUnitId = adUnitId;
contentOptions.marginDistance = subclusterAdFrequency;
contentOptions.marginWidth = 5;
}
var info = {
clusterEntity: clusterInfo,
clusterPosition: clusterIndex + 1,
clusterKey: categoryKey,
clusterTitle: categoryName,
onHeaderSelection: that.onHeaderSelection && that.headerSelectionEnabled ? that.onHeaderSelection.bind(that) : null,
clusterContent: {
contentControl: "CommonJS.News.EntityCluster",
contentOptions: contentOptions
}
};
that._subChannels.push(info);
isClustersOrSubChannels = (categoryToRender && categoryToRender.length > 0 && categoryKey !== categoryToRender) ? "subChannels" : "clusters";
if (isClustersOrSubChannels === "clusters") {
that._clusters.push(info);
}
})(numCategoryClusters);
numCategoryClusters++;
}
}
that.numCategoryClusters = numCategoryClusters;
if (that._clusters && that._clusters.length > 0) {
var adClusterConfig = {
clusterPosition: that._clusters.length,
clusterEntity: {
title: CommonJS.resourceLoader.getString("/platform/advertisement"),
thumbnail: {
url: ""
},
moduleInfo: {
height: "140px",
width: "290px",
templateId: "dynamicPanoSemanticTile"
}
}
};
// If ad config information exist from CMS, disregard end of pano logic
if (PlatformJS.Ads.getCMSConfig()) {
PlatformJS.Ads.addOrderedAdsClusterConfig(that._clusters, adClusterConfig);
}
else if (isEndOfPanoAdEnabled) { // TODO: REMOVE when all editorial move ad config to CMS
if (that._state.dynamicInfo.adUnitId) {
adClusterConfig.otherAdOptions = {
adUnitId: that._state.dynamicInfo.adUnitId
};
PlatformJS.Ads.addAdsClusterConfig(that._clusters, adClusterConfig);
}
}
}
if (panoControl) {
if (numCategoryClusters === 0 || numCategoryClusters === 1 && !heroVisible) {
panoControl.zoomOptions = { locked: true };
}
var sortedDataSource = that.getSortedClusterDataSource(this._clusters);
this.setArticleInfosOnDataSource(sortedDataSource, this._cmsData.hero);
if (that._state.dynamicInfo.isFeaturedSource && !that._state.dynamicInfo.clusterID) {
that.populateL2IfHoisted(sortedDataSource);
}
if (that._state.dynamicInfo.isFeaturedSource) {
var sortedSubChannelDataSource = that.getSortedClusterDataSource(this._subChannels);
that.populateL2IfHoisted(sortedSubChannelDataSource);
}
panoControl.panoramaState = that._panoramaState;
panoControl.clusterDataSource = sortedDataSource.dataSource;
if (this._cmsData.lastFetchedTime) {
var fetchDate = new Date(this._cmsData.lastFetchedTime);
var watermark = document.querySelector(".platformWatermark");
if (watermark) {
watermark.innerHTML = ["<div id=\"platformLastUpdatedTime\"><span class=\"platformLastUpdatedLabel\">",
PlatformJS.Services.resourceLoader.getString("/platform/offline_lastUpdated").format(""),
"</span>", "<span class=\"platformLastUpdated\">",
fetchDate.toLocaleDateString() + " " + fetchDate.toLocaleTimeString(),
"</span></div>"
].join("");
watermark.tabIndex = 0;
}
}
}
if (numCategoryClusters === 0 && !heroVisible) {
PlatformJS.Navigation.mainNavigator.returnHomeAndClearHistoryIfNecessary(true);
}
}
},
onHeaderSelection: function onHeaderSelection(clusterHeaderName) {
var that = this;
if (that.numCategoryClusters >= 2 && clusterHeaderName && clusterHeaderName.length > 0) {
var dynamicInfo = JSON.parse(JSON.stringify(this._state.dynamicInfo));
dynamicInfo.clusterID = clusterHeaderName;
dynamicInfo.clusterToRender = clusterHeaderName;
dynamicInfo.clusterTitle = that._cmsData.categories[clusterHeaderName].categoryName;
var channelID = PlatformJS.Navigation.mainNavigator.channelIDInView;
var featuredChannel = that.getFeaturedChannel(channelID);
var channelIdToNavigate = featuredChannel ? featuredChannel.id + "_" + dynamicInfo.clusterTitle : "";
WinJS.Navigation.navigate({ channelId: channelIdToNavigate, fragment: this.config.categorypage.htmlPath, page: this.config.categorypage.controlName }, { dynamicInfo: dynamicInfo });
}
},
getSortedClusterDataSource: function getSortedClusterDataSource(clusters) {
var sortedDataSource = null;
if (clusters) {
sortedDataSource = clusters.createSorted(function (l, r) {
if (l.clusterPosition < r.clusterPosition) {
return -1;
} else if (l.clusterPosition === r.clusterPosition) {
return 0;
} else {
return 1;
}
});
}
return sortedDataSource;
},
fixupBidiTextNodesWorker: function fixupBidiTextNodesWorker(node) {
function fixupBidiPunctuation(text) {
var directionText = PlatformJS.Utilities.getTextDirection(text);
var result = text + ((directionText === "ltr") ? "\u200E" : "\u200F");
return result;
}
var that = this;
var nodeText = "";
if (node) {
if (node.nodeType === 3) {
node.data = fixupBidiPunctuation(node.data);
} else if ((node.nodeType === 1 || node.nodeType === 9) && node.childNodes) {
var nodeTagName = node.tagName.toUpperCase();
if (!(nodeTagName === "SCRIPT") && !(nodeTagName === "STYLE")) {
for (var i = 0; i < node.childNodes.length; i++) {
this.fixupBidiTextNodesWorker(node.childNodes[i]);
}
}
}
}
},
fixupBidiTextNodes: function fixupBidiTextNodes(htmlText, parser) {
var result = htmlText;
if (parser) {
var descDom = parser.parseFromString(htmlText, "text/html");
if (descDom.body) {
this.fixupBidiTextNodesWorker(descDom.body);
result = descDom.body.innerHTML;
}
}
return result;
},
// TODO: Move to config
getAnchorMapping: function getAnchorMapping(mappingText) {
var fallBackAnchor = "anchorLeft";
if (mappingText === "Top") {
return "anchorTop";
}
else if (mappingText === "Left") {
return "anchorLeft";
}
else if (mappingText === "Bottom") {
return "anchorBottom";
}
else if (mappingText === "Right") {
return "anchorRight";
}
else if (mappingText === "Middle") {
return "anchorMiddle";
}
else {
return fallBackAnchor;
}
},
onPreviewToggle: function onPreviewToggle() {
var that = this;
that._refreshPage();
},
cmsHeroCluster: function cmsHeroCluster(editorial, heroList) {
var that = this;
editorial.isHero = true;
var date = PlatformJS.Services.resourceLoader.getString("TopStory");
var semanticZoomImageAvailable = editorial.semanticZoomThumbnail && editorial.semanticZoomThumbnail.url;
var clusterInfo = {
title: date,
thumbnail: {
url: semanticZoomImageAvailable ? editorial.semanticZoomThumbnail.url : ""
},
moduleInfo: {
height: "140px",
width: "290px",
templateId: semanticZoomImageAvailable ? "dynamicPanoSemanticTile" : "dynamicPanoSemanticTileNoImage"
}
};
var parser = window.DOMParser ? new window.DOMParser() : null;
heroList.push(
{
moduleInfo: {
isInteractive: false,
templateId: "panoHero"
},
title: this.fixupBidiTextNodes(editorial.headline, parser),
favicon: editorial.sourceImageUrl,
faviconErrorHandler: WinJS.Utilities.markSupportedForProcessing(function (img) {
if (img && img.parentElement && img.parentElement.style) {
img.parentElement.style.display = "none";
}
}),
publishTime: editorial.publishTime,
snippet: this.fixupBidiTextNodes(editorial.abstract, parser),
source: editorial.source,
}
);
var backgroundImageData = "";
if (editorial.thumbnail && editorial.thumbnail.url) {
if (editorial.thumbnailLowRes && editorial.thumbnailLowRes.url) {
backgroundImageData = {
lowResolutionUrl: editorial.thumbnailLowRes.url,
highResolutionUrl: editorial.thumbnail.url
};
}
else {
backgroundImageData = editorial.thumbnail.url;
}
}
that._clusters.push({
clusterEntity: clusterInfo,
clusterPosition: 0,
clusterKey: that._heroKey,
clusterTitle: date,
hideTitle: true,
isSticky: true,
titleClass: this._headerColor,
clusterContent: {
contentControl: "CommonJS.Immersive.ParallaxItemsContainer",
contentOptions: {
disableParallax: true,
itemDataSource: heroList.dataSource,
className: "leadStoryLayoutImage",
backgroundImage: backgroundImageData,
onitemclick: function onitemclick() {
that.itemInvoked({ item: editorial });
},
imageSize: {
width: editorial.thumbnail && editorial.thumbnail.width ? editorial.thumbnail.width : 0,
height: editorial.thumbnail && editorial.thumbnail.height ? editorial.thumbnail.height : 0
},
attributionData: {
attributionText: editorial.imageAttribution,
caption: editorial.caption
},
showGradient: true,
anchorPoint: this.getAnchorMapping(editorial.anchorpoint)
}
},
});
},
_heroKey: "Hero",
handleCMS: function handleCMS(completedValue) {
if (completedValue) {
this._cmsData = completedValue;
}
},
getArticleReaderNavigationInfo: function getArticleReaderNavigationInfo(article, articleIdPath, marketString, articleInfos, source, instrumentation, entryPoint, themeOverride, adGroups, cssToInject, partnerInstrumentationId) {
var navigation = { state: {}, pageInfo: {} };
var providerType = "AppEx.Common.ArticleReader.BedrockArticleProvider";
var providerConfiguration = PlatformJS.Collections.createStringDictionary();
var queryServiceId = this.config.articlereader.queryServiceID;
providerConfiguration.insert("queryServiceId", queryServiceId);
providerConfiguration.insert("imageCacheId", "PlatformImageCache");
providerConfiguration.insert("market", marketString);
if (articleInfos) {
providerConfiguration.insert("articleInfos", articleInfos);
}
var articleReaderTheme;
if (themeOverride !== null && themeOverride !== undefined) {
// The condition here is to make sure themeOverride can be empty string which clears all hardcoded default theme. 
articleReaderTheme = themeOverride;
}
else {
articleReaderTheme = this.config.articlereader.theme;
}
navigation.state = {
providerType: providerType,
providerConfiguration: providerConfiguration,
initialArticleId: articleIdPath,
enableSnap: true,
enableSharing: true,
adPartnerName: this._state.dynamicInfo.instrumentationId,
snappedHeaderTitle: PlatformJS.Services.resourceLoader.getString("News"),
snappedHeaderFontColor: "headerFontLight",
theme: articleReaderTheme,
market: marketString,
instrumentation: instrumentation,
instrumentationId: partnerInstrumentationId,
};
if (this._state.dynamicInfo.id && this._authInfo) {
navigation.state.authProvider = { partnerId: this._state.dynamicInfo.id, authInfo: this._authInfo };
}
if (cssToInject) {
navigation.state.css = cssToInject;
}
if (adGroups) {
navigation.state.adGroups = adGroups;
}
if (articleInfos || article) {
var partnerBlocks = PlatformJS.Services.appConfig.getDictionary("PartnerArticleBlockMapping");
if (partnerBlocks) {
var keys = Object.keys(partnerBlocks);
navigation.state.validActions = {};
navigation.state.actionKeys = [];
for (var idx = 0; idx < keys.length; idx++) {
var setupPartner = function (idxKey) {
var partnerKey = keys[idxKey];
var partnerEntry = partnerBlocks[partnerKey];
var partnerChannelID = partnerEntry.getString("ChannelID");
var partnerName = PlatformJS.Services.resourceLoader.getString(partnerEntry.getString("NameKey"));
if (Platform.Utilities.Globalization.isFeatureEnabled(partnerEntry.getString("FeatureID"))) {
var actionKey = "linkTo" + partnerKey + "Source";
navigation.state.validActions[actionKey] = {
icon: {
type: "image",
url: partnerEntry.getString("IconUrl")
},
text: PlatformJS.Services.resourceLoader.getString("MoreFrom").format(partnerName),
textSize: "small",
oninvoke: function oninvoke(event) {
var channelInfo = PlatformJS.Navigation.mainNavigator.channelManager.resolveChannel(partnerChannelID, "featured");
if (channelInfo && channelInfo.pageInfo) {
WinJS.Navigation.navigate(channelInfo.pageInfo, channelInfo.state);
}
//  NewsJS.Instrumentation.instrumentActionKey(partnerChannelID);
}
};
if (!articleInfos && article && article.source && 0 <= article.source.indexOf(partnerName)) {
navigation.state.actionKeys.push(actionKey);
}
}
};
setupPartner(idx);
}
}
}
if (typeof source === "number") {
navigation.state.source = source;
} else {
navigation.state.source = 2; // instrument article as coming from URI
}
navigation.state.entryPoint = entryPoint;
navigation.pageInfo.channelId = null;
navigation.pageInfo.fragment = this.config.articlereader.htmlPath;
navigation.pageInfo.page = this.config.articlereader.controlName;
if (!PlatformJS.Utilities.hasInternetConnection()) {
var queryService = new PlatformJS.DataService.QueryService(queryServiceId);
var urlParams = PlatformJS.Collections.createStringDictionary();
urlParams.insert("market", marketString);
urlParams.insert("articleId", articleIdPath);
navigation.dataAvailable = queryService.hasEntryAsync(urlParams, null);
} else {
navigation.dataAvailable = WinJS.Promise.wrap(true);
}
return navigation;
},
populateArticleInfoAds: function populateArticleInfoAds(articleInfos) {
if (!_articleAdConfig) {
var articleAdConfigString = PlatformJS.Services.configuration.getDictionary("Ads2").getString("ArticleReaderAdConfig");
if (articleAdConfigString) {
try {
_articleAdConfig = JSON.parse(articleAdConfigString);
} catch (e) {
_articleAdConfig = null;
}
}
}
var applicationId = PlatformJS.Ads.Config.instance.applicationId;
if (articleInfos && articleInfos.articleInfos) {
PlatformJS.Utilities.annotateArticleInfosWithAdInfo(articleInfos.articleInfos, _articleAdConfig, applicationId);
}
},
launchArticle: function launchArticle(article, listInfo, themeOverride, /*@optional*/adGroups,  /*@optional*/extraOptions, /*@optional*/cssToInject) {
var sourceMarket = this.market || CommonJS.Globalization.getMarketStringForEditorial();
if (article.editorial) {
if (article.type === "slideshow") {
if (!sourceMarket) {
return;
}
if (article.contentid && sourceMarket) {
var targetState = { slideshowId: article.contentid, market: sourceMarket };
if (extraOptions) {
targetState.extraOptions = extraOptions;
}
targetState.instrumentationEntryPoint = listInfo.entryPoint;
WinJS.Navigation.navigate({ fragment: this.config.slideshow.htmlPath, page: this.config.slideshow.controlName }, targetState);
}
}
else if (article.type === "article") {
var articleIdPath = this.getEditorialArticleIdPath(article);
var articleInfos;
this.populateArticleInfoAds(article.clusterArticles);
if (article.clusterArticles) {
articleInfos = JSON.stringify(article.clusterArticles);
}
var navigation = this.getArticleReaderNavigationInfo(article, articleIdPath, sourceMarket, articleInfos, listInfo.source, listInfo.instrumentation, listInfo.entryPoint, themeOverride, adGroups, cssToInject, this._state.dynamicInfo.instrumentationId);
var that = this;
if (navigation && navigation.dataAvailable) {
navigation.dataAvailable.then(function (navigationOk) {
if (navigationOk) {
Platform.Telemetry.FlightRecorder.setImpressionNavMethod(Platform.Telemetry.ImpressionNavMethod.cluster);
WinJS.Navigation.navigate({
fragment: navigation.pageInfo.fragment,
page: navigation.pageInfo.page
}, navigation.state);
} else {
that.showToast(PlatformJS.Services.resourceLoader.getString("/platform/ArticleUnavailableOffline"));
}
});
}
}
}
},
itemInvoked: function itemInvoked(e) {
var that = this;
var item = e.item;
var source = null;
if (item) {
if (item.editorial) {
if (item.isHero) {
source = Platform.Instrumentation.InstrumentationEditorialSourceId.heroImage;
}
else {
source = Platform.Instrumentation.InstrumentationEditorialSourceId.cluster;
}
}
var articleReaderTheme = this._state && this._state.dynamicInfo ? this._state.dynamicInfo.articleTheme : null;
var extraOptions = that.extraOptions(item);
this.launchArticle(item,
{
source: source,
instrumentation: this._state.dynamicInfo.instrumentation,
entryPoint: Platform.Instrumentation.InstrumentationArticleEntryPoint.partnerPano
},
articleReaderTheme, null, extraOptions, this._cssData);
}
},
extraOptions: function extraOptions(item) {
return {};
},
createAdGroups: function createAdGroups() {
var that = this;
var applicationId = PlatformJS.Ads.Config.instance.applicationId;
return [{
type: "end",
adMetadatas: [
JSON.stringify({
controlType: "PlatformJS.Ads.AdsWrapperControl",
controlOptions: {
otherAdOptions: {
applicationId: applicationId,
adUnitId: that._state.dynamicInfo.adUnitId,
keywords: "Ad1",
},
className: "adTypeThin",
adUnitId: that._state.dynamicInfo.adUnitId,
},
}),
],
}];
},
videoItemInvoked: function videoItemInvoked(e) {
// do nothing; the video control instantiates and plays automatically inside the cluster. Any additional special handling can go here.
// TODO fire instrumentation
},
getPageState: function getPageState() {
var panoControl = PlatformJS.Utilities.getControl("news_Panorama");
if (panoControl) {
this._state.panoramaState = panoControl.getPanoramaState();
}
return this._state;
},
getPanoTitle: function getPanoTitle() {
var that = this;
var title = that._state.dynamicInfo.panoTitle;
if (that._state.dynamicInfo.panoTitleResource) {
title = PlatformJS.Services.resourceLoader.getString(that._state.dynamicInfo.panoTitleResource);
}
return title;
},
getPageData: function getPageData() {
var that = this;
var title = that.getPanoTitle();
return WinJS.Promise.wrap({
title: title,
semanticZoomRenderer: WinJS.Utilities.markSupportedForProcessing(that.dynamicPanoSemanticZoomRenderer),
headerOptions: that.commonHeaderOptions
});
},
dynamicPanoSemanticZoomRenderer: function dynamicPanoSemanticZoomRenderer(itemPromise) {
return {
element: itemPromise.then(
function (group) {
var div = document.createElement("div");
if (group.data.clusterEntity) {
WinJS.Utilities.addClass(div, "platformSemanticZoomItem");
var binding = group.data.clusterEntity;
CommonJS.setModuleSizeAndClass(binding.moduleInfo, div);
CommonJS.loadModule(binding.moduleInfo, binding, div).then();
}
return div;
})
};
},
}),
setupSubscribeButton: function setupSubscribeButton(authProvider) {
var that = this;
if (!authProvider || document.getElementById("subscribeButton")) {
return;
}
// create the subscribe button
var subscribeButton = document.createElement("button");
subscribeButton.id = "subscribeButton";
WinJS.Utilities.addClass(subscribeButton, "subscribeButtonHidden");
subscribeButton.innerHTML = authProvider.authInfo.subscriptionpanodescription ?
authProvider.authInfo.subscriptionpanodescription : PlatformJS.Services.resourceLoader.getString("/platform/subscribePanoButton");
// set the text color to match the partner accent color
var dynamicPanoAccent = document.querySelector(".dynamicPanoAccent");
if (dynamicPanoAccent) {
subscribeButton.style.color = window.getComputedStyle(dynamicPanoAccent).backgroundColor;
}
// click: open subscription url
if (authProvider.authInfo.subscriptionurl) {
subscribeButton.onclick = function (event) {
window.open(authProvider.authInfo.subscriptionurl);
};
};
function _updateSubscribeButtonAsync() {
return authProvider.getEntitlementsAsync(false, false, false).then(function (isEntitled) {
try {
if (isEntitled) {
WinJS.Utilities.addClass(subscribeButton, "subscribeButtonHidden");
} else {
WinJS.Utilities.removeClass(subscribeButton, "subscribeButtonHidden");
}
} catch (error) {
}
});
};
function _unsubscribeEventListeners() {
authProvider.removeEventListener("authchanged", _updateSubscribeButtonAsync);
WinJS.Navigation.removeEventListener("navigated", _unsubscribeEventListeners);
}
authProvider.addEventListener("authchanged", _updateSubscribeButtonAsync);
WinJS.Navigation.addEventListener("navigated", _unsubscribeEventListeners);
var page = document.querySelector(".platformPage");
page.appendChild(subscribeButton);
return _updateSubscribeButtonAsync();
},
setupLoginButton: function setupLoginButton(authProvider, refreshPageFunction) {
var that = this;
if (!authProvider) {
return;
}
// if we already have a signin button, then don't set this up again
if (document.getElementById("loginButton")) {
return;
}
function _updateLoginButtonAsync() {
if (!authProvider) {
return WinJS.Promise.wrap(null);
}
return authProvider.getEntitlementsAsync(false, false, false).then(function (isEntitled) {
try {
loginCmd.hidden = isEntitled;
logoutCmd.hidden = !isEntitled;
} catch (error) {
}
});
};
function _unsubscribeEventListeners() {
authProvider.removeEventListener("authchanged", _updateLoginButtonAsync);
WinJS.Navigation.removeEventListener("navigated", _unsubscribeEventListeners);
}
if (authProvider) {
authProvider.addEventListener("authchanged", _updateLoginButtonAsync);
WinJS.Navigation.addEventListener("navigated", _unsubscribeEventListeners);
}
var separator = new WinJS.UI.AppBarCommand(document.createElement("hr"), {
type: "separator"
});
var edgy = WinJS.Utilities.query(".newsActionEdgyRight"); // news app
if (!edgy || edgy.length === 0) {
edgy = WinJS.Utilities.query(".platformNewsActionEdgyRight"); // other apps 
}
if (edgy && edgy.length > 0) {
edgy = edgy[0];
} else {
edgy = document.getElementById("bottomEdgy");
}
if (!edgy) {
// no edgy, return
return;
}
edgy.appendChild(separator.element);
separator.element.id = "loginButtonSeparator";
var loginCmd = new WinJS.UI.AppBarCommand(document.createElement("button"), {
label: PlatformJS.Services.resourceLoader.getString("/Platform/Login"),
icon: "\uE181",
onclick: function onclick(event) {
CommonJS.dismissAllEdgies();
// signin and update full page if necessary
return authProvider.signIn(null).then(function () {
return authProvider.getEntitlementsAsync(false, false, false);
}).then(function (newIsEntitled) {
if (newIsEntitled && refreshPageFunction) {
DynamicPanoJS.forceRefreshPano = true;
refreshPageFunction();
}
return _updateLoginButtonAsync();
});
//TODO: Add instrumentation, similar to WSJJS.Instrumentation.instance.instrumentSignIn();
},
extraClass: "signInButton",
hidden: true,
});
loginCmd.element.id = "loginButton";
edgy.appendChild(loginCmd.element);
var logoutCmd = new WinJS.UI.AppBarCommand(document.createElement("button"), {
label: PlatformJS.Services.resourceLoader.getString("/Platform/Logout"),
icon: "\uE181",
onclick: function onclick(event) {
CommonJS.dismissAllEdgies();
// signout and update full page if necessary
return authProvider.signOut("Button").then(function () {
return authProvider.getEntitlementsAsync(false, false, false);
}).then(function (newIsEntitled) {
if (!newIsEntitled && refreshPageFunction) {
DynamicPanoJS.forceRefreshPano = true;
refreshPageFunction();
}
return _updateLoginButtonAsync();
});
//TODO: Add instrumentation, similar to WSJJS.Instrumentation.instance.instrumentSignOut();
},
extraClass: "signOutButton",
hidden: true,
});
logoutCmd.element.id = "logoutButton";
edgy.appendChild(logoutCmd.element);
return _updateLoginButtonAsync();
},
forceRefreshPano: false
});
})();
(function () {
"use strict";
WinJS.Namespace.define("CommonJS",
{
NewsProviderAdapter: WinJS.Class.define(function (options) {
this._totalCount = options.providers.length === 0 ? 0 : Number.MAX_VALUE;
this._providerDisplayLimit = options.providerDisplayLimit ? options.providerDisplayLimit : -1;
this._providerDatas = [];
this._articleFilter = options.articleFilter && typeof options.articleFilter === "function" ? options.articleFilter : null;
this._noResultsTile = options.noResultsTile;
this._errorTile = options.errorTile;
this._offlineTile = options.offlineTile;
this._runningCount = 0;
this._pendingCountCheck = null;
var providers = options.providers;
if (providers) {
// providers should be either an array or an associative array (map)
if (!Array.isArray(providers)) {
for (var key in providers) {
this._providerDatas.push({ bindings: null, provider: providers[key] });
}
} else {
for (var i = 0; i < providers.length; i++) {
this._providerDatas.push({ bindings: null, provider: providers[i] });
}
}
}
if (options.offline) {
var that = this;
// This check essentially determines whether there is cached data available for snapped mode 
// which is needed information so that it can be determined whether to show the offline error or not.  
this._pendingCountCheck = this.providerIndexContainingIndex(0).then(function (e) {
that._pendingCountCheck = null;
if (e.providerIndex < 0) {
// Setting the total count to 0 signifies to snapped mode's listview that it need not
// query for data up front.  This removes the progress ring when offline and no cached data exists.
that._totalCount = 0;
}
return that._totalCount;
});
}
}, {
removeProvider: function removeProvider(provider) {
var found = false;
for (var i = 0; i < this._providerDatas.length; i++) {
if (!found && this._providerDatas[i].provider === provider) {
this._providerDatas.splice(i, 1);
found = true;
break;
}
}
if (found) {
this._runningCount = 0;
for (var k = 0; k < i; k++) {
if (this._providerDatas[k].bindings) {
// need to find the last valid binding set to update the running count
this._runningCount = this._providerDatas[k].endIndex + 1;
}
}
for (var j = i; j < this._providerDatas.length; j++) {
if (this._providerDatas[j].bindings) {
// we need to reset the start and end index for all providers after the one removed
this._providerDatas[j].bindings = null;
this._providerDatas[j].startIndex = this._providerDatas[j].endIndex = -1;
}
}
}
this._totalCount = this._providerDatas.length > 0 ? Number.MAX_VALUE : 0;
if (this._providerDatas.length === 0) {
if (this.handler) {
this.handler.reload();
}
}
},
insertProvider: function insertProvider(provider) {
this._providerDatas.splice(0, 0, { bindings: null, provider: provider });
// we need to reset the start and end index all providers
for (var i = 0; i < this._providerDatas.length; i++) {
if (this._providerDatas[i].bindings) {
this._providerDatas[i].bindings = null;
this._providerDatas[i].startIndex = this._providerDatas[i].endIndex = -1;
}
}
this._totalCount = Number.MAX_VALUE;
this._runningCount = 0;
},
wentOnline: function wentOnline() {
var foundOffline = false;
for (var i = 0; i < this._providerDatas.length; i++) {
if (foundOffline || this._providerDatas[i].isOffline) {
if (i > 0 && !foundOffline) {
this._runningCount = this._providerDatas[i - 1].endIndex + 1;
}
foundOffline = true;
this._providerDatas[i].bindings = null;
this._providerDatas[i].startIndex = this._providerDatas[i].endIndex = -1;
this._providerDatas[i].isOffline = false;
}
}
if (foundOffline) {
this._totalCount = Number.MAX_VALUE;
if (this.handler) {
this.handler.reload();
}
}
},
// IListDataAdapter
getCount: function getCount() {
console.log("getCount: " + this._totalCount);
// return a huge number for now
return this._pendingCountCheck ? this._pendingCountCheck : WinJS.Promise.wrap(this._totalCount);
},
snappedTitleTile: function snappedTitleTile(title) {
var binding = {
title: title,
moduleInfo: {
templateId: "snappedTitleTile"
}
};
return binding;
},
snappedSourceTile: function snappedSourceTile(source) {
var binding = {
data: source,
moduleInfo: {
templateId: "snappedSourceItemTemplate"
}
};
return binding;
},
providerIndexContainingIndex: function providerIndexContainingIndex(index) {
var that = this;
var providerIndex = 0;
var startIndex = 0;
var endIndex = -1;
// Find which provider has the requested item
// Since we don't know how much data each provider will return ahead of time, we need to iterate sequentially
// until we find where we need to be
var limit = this._providerDisplayLimit >= 0 ? Math.min(this._providerDatas.length, this._providerDisplayLimit) : this._providerDatas.length;
for (providerIndex = 0; providerIndex < limit && endIndex < index; providerIndex++) {
var providerData = this._providerDatas[providerIndex];
// Does the provider have data we need to convert to bindings?
if (!providerData.bindings && (providerData.hasError || providerData.isOffline || providerData.provider.articles)) {
var articles = providerData.provider.articles || [];
providerData.bindings = [];
var extraBindingEntries = 0;
var binding = null;
if (providerData.provider.getSnappedTitleTile) {
binding = providerData.provider.getSnappedTitleTile();
} else if (providerData.provider.title) {
binding = this.snappedTitleTile(providerData.provider.title);
}
if (binding) {
providerData.bindings.push({ key: providerIndex + "_title", groupKey: providerIndex + "_", data: binding });
extraBindingEntries++;
}
var origBindingsLength = providerData.bindings.length;
for (var i = 0; i < articles.length; i++) {
if (that._articleFilter) {
if (that._articleFilter.call(that, articles[i])) {
continue;
}
}
binding = this.snappedStoryTile(articles[i]);
providerData.bindings.push({ key: providerIndex + "_" + i, groupKey: providerIndex + "_", data: binding });
}
var messageTile = providerData.isOffline ? this._offlineTile : (providerData.hasError ? this._errorTile : this._noResultsTile);
if (providerData.bindings.length === origBindingsLength && messageTile) {
var tile = null;
if (typeof messageTile === "object") {
tile = messageTile;
} else if (typeof messageTile === "function") {
tile = messageTile();
}
if (tile) {
providerData.bindings.push({ key: providerIndex + "_0", groupKey: providerIndex + "_", data: tile });
}
}
providerData.startIndex = startIndex;
providerData.endIndex = startIndex + providerData.bindings.length - extraBindingEntries;
providerData.extraBindingEntries = extraBindingEntries;
that._runningCount = providerData.endIndex + extraBindingEntries;
}
// Do we already have snapped bindings?
if (providerData.bindings) {
startIndex = providerData.endIndex + 1;
endIndex = providerData.endIndex;
} else {
// Otherwise, query for the data and call this again when data is back
return providerData.provider.queryAsync().then(function () {
if (that._totalCount === 0) {
// We now know there is a nonzero dataset.  If the count was previously 0, 
// update it and notify listeners to reload
that._totalCount = Number.MAX_VALUE;
if (that.handler) {
that.handler.reload();
}
}
return that.providerIndexContainingIndex(index);
}, function (err) {
// Couldn't retrieve data for this provider.  This must stop the chain across providers
// since the data access model is necessarilly sequential (unless we know the error is not retryable,
// in which case we can continue with the chain in order to render the remaining providers' data
if (NewsJS.Utilities.isBadHttpStatusCode(err)) {
providerData.hasError = true;
return that.providerIndexContainingIndex(index);
} else if (!PlatformJS.Utilities.hasInternetConnection()) {
providerData.isOffline = true;
return that.providerIndexContainingIndex(index);
}
return WinJS.Promise.as({ providerIndex: -1 });
});
}
}
// Index was auto-incremented at end of for-loop.  Need to decrement.
return WinJS.Promise.as({ providerIndex: providerIndex - 1 });
},
clusterItemsContainingIndex: function clusterItemsContainingIndex(index) {
var that = this;
return this.providerIndexContainingIndex(index).then(function (e) {
var providerIndex = e.providerIndex;
var providerData = that._providerDatas[providerIndex];
return { title: providerData.provider.title, articles: providerData.provider.articles };
});
},
setNotificationHandler: function setNotificationHandler(handler) {
this.handler = handler;
},
// called when a connection becomes available
reloadContentIfNecessary: function reloadContentIfNecessary() {
var that = this;
if (that._totalCount === 0) {
that._totalCount = Number.MAX_VALUE;
if (that.handler) {
that.handler.reload();
}
} else {
that.wentOnline();
}
},
itemsFromIndex: function itemsFromIndex(index, countBefore, countAfter) {
console.log("itemsFromIndex: " + index + ", " + countBefore + ", " + countAfter);
var that = this;
return this.providerIndexContainingIndex(index).then(function (e) {
var providerIndex = e.providerIndex;
if (providerIndex < 0) {
var count = that._runningCount;
that._totalCount = (that._totalCount < Number.MAX_VALUE) ? that._totalCount : count;
console.log("itemsFromIndex returning: " +
"providerIndex: " + providerIndex +
", absoluteIndex: " + index +
", data.length: 0" +
", offset: " + index +
", atStart: true" +
", atEnd: true" +
", totalCount: " + that._totalCount);
return {
absoluteIndex: index,
items: new WinJS.Binding.List(),
offset: index,
atStart: true,
atEnd: true,
totalCount: that._totalCount
};
}
var providerData = that._providerDatas[providerIndex];
var startIndex = providerData.startIndex;
var endIndex = providerData.endIndex;
var start = Math.max(startIndex, index - countBefore);
var end = Math.min(index + countAfter, endIndex);
var realCount = end - start + 1;
var offset = index - start;
var atStart = start === 0;
var limit = that._providerDisplayLimit >= 0 ? Math.min(that._providerDatas.length, that._providerDisplayLimit) : that._providerDatas.length;
var atEnd = providerIndex >= limit - 1 && index + countAfter >= endIndex;
that._totalCount = (that._totalCount < Number.MAX_VALUE) ? that._totalCount : (atEnd ? endIndex + providerData.extraBindingEntries : Number.MAX_VALUE);
var data = providerData.bindings.slice(start - startIndex, end - startIndex + 1);
console.log("itemsFromIndex returning: " +
"providerIndex: " + providerIndex +
", absoluteIndex: " + index +
", data.length: " + data.length +
", offset: " + offset +
", atStart: " + atStart +
", atEnd: " + atEnd +
", totalCount: " + that._totalCount);
return {
absoluteIndex: index,
items: data,
offset: offset,
atStart: atStart,
atEnd: atEnd,
totalCount: that._totalCount
};
});
},
}),
});
})();
(function () {
"use strict";
WinJS.Namespace.define("CommonJS.State",
{
isPreviewModeEnabled: false,
});
})();
/* File: pinning.js */
(function () {
"use strict";
// setup a category pin button
// buttonElementId: the html id of the button on the page
// category: context data
function setupPinCategoryButton(buttonElementId, category, categoryName) {
if (typeof (buttonElementId) === "undefined" ||
typeof (category) === "undefined" ||
typeof (categoryName) === "undefined") {
return;
}
if (typeof (category.categoryKey) === "undefined") {
//this is the headline category so there was no catkey
category.categoryKey = "";
}
return CommonJS.Utilities.Pinning._setupPinButton(
buttonElementId,
PlatformJS.Services.resourceLoader.getString("/platform/pinToStart"),
PlatformJS.Services.resourceLoader.getString("/platform/unpinFromStart"),
PlatformJS.Services.resourceLoader.getString("NowPinningCategory"),
PlatformJS.Services.resourceLoader.getString("NowUnpinningCategory"),
"",  // no tileNotAddedToastMessage message
"",  // no tileNotRemovedToastMessage message
categoryName + "CommonJS.CategoryPage", // make the a ID guaranteed unique tile (someone could pin "U.S." as category and topic)
categoryName,
categoryName,
"CommonJS.CategoryPage",
{ category: categoryName, categoryKey: category.categoryKey },
null,
"ms-appx:///images/logoCategory.png");
}
// setup a search (topic) pin button
// buttonElementId: the html id of the button on the page
// category: context data
function setupPinTopicButton(buttonElementId, topic) {
if (typeof (buttonElementId) === "undefined" ||
typeof (topic) === "undefined" ||
typeof (topic.queryText) === "undefined" ||
!topic.queryText) {
return;
}
return CommonJS.Utilities.Pinning._setupPinButton(
buttonElementId,
PlatformJS.Services.resourceLoader.getString("/platform/pinToStart"),
PlatformJS.Services.resourceLoader.getString("/platform/unpinFromStart"),
PlatformJS.Services.resourceLoader.getString("NowPinningTopic"),
PlatformJS.Services.resourceLoader.getString("NowUnpinningTopic"),
"",  // no tileNotAddedToastMessage message
"",  // no tileNotRemovedToastMessage message
topic.queryText + "CommonJS.Search", // make the a ID guaranteed unique tile (someone could pin "U.S." as category and topic)
topic.queryText,
topic.queryText,
"CommonJS.Search",
topic,
null,
"ms-appx:///images/logoTopic.png");
}
// setup a regular source and RSSsource pin button
// buttonElementId: the html id of the button on the page
// category: context data
// target: optional; the target page the app should launch into when the pin button on start menu is clicked
function setupPinSourceButton(buttonElementId, sourceEntity, target) {
if (typeof (buttonElementId) === "undefined" ||
typeof (sourceEntity) === "undefined" ||
typeof (sourceEntity.id) === "undefined" ||
typeof (sourceEntity.displayname) === "undefined") {
return;
}
return CommonJS.Utilities.Pinning._setupPinButton(
buttonElementId,
PlatformJS.Services.resourceLoader.getString("/platform/pinToStart"),
PlatformJS.Services.resourceLoader.getString("/platform/unpinFromStart"),
PlatformJS.Services.resourceLoader.getString("NowPinningSource"),
PlatformJS.Services.resourceLoader.getString("NowUnpinningSource"),
"",  //no tileNotAddedToastMessage message
"",  //no tileNotRemovedToastMessage message
sourceEntity.id + (target ? target : "CommonJS.SourcePage"),  // differentiate RSS source tiles from source tiles in case they have the same name
sourceEntity.displayname,
sourceEntity.displayname,
target ? target : "CommonJS.SourcePage",
sourceEntity,
null,
"ms-appx:///images/logoSource.png");
}
// setup a Featured Source pin button
// buttonElementId: the html id of the button on the page
function setupPinFeaturedSourceButton(buttonElementId, dynamicInfo) {
if (typeof (buttonElementId) === "undefined") {
return;
}
var logo = PlatformJS.Services.appConfig.getString("PinLogo");
if (typeof (logo) === "undefined" || !logo || logo === "") {
logo = "images/logoSource.png";
}
var tileDisplayName = dynamicInfo.clusterToRender ? dynamicInfo.panoTitle + " - " + dynamicInfo.clusterTitle : dynamicInfo.panoTitle;
var tileId = CommonJS.Tile.newsSecondaryTile.makeDynamicPanoTileId(dynamicInfo.clusterToRender ? dynamicInfo.clusterID : dynamicInfo.id);
var tilePinLogos = dynamicInfo.pinLogoUrls;
var liveTileUrls = dynamicInfo.liveTileUrls;
var liveTileRecurrence = dynamicInfo.liveTileRecurrence;
return CommonJS.Utilities.Pinning._setupPinButton(
buttonElementId,
PlatformJS.Services.resourceLoader.getString("/platform/pinToStart"),
PlatformJS.Services.resourceLoader.getString("/platform/unpinFromStart"),
PlatformJS.Services.resourceLoader.getString("NowPinningSource"),
PlatformJS.Services.resourceLoader.getString("NowUnpinningSource"),
"",  //no tileNotAddedToastMessage message
"",  //no tileNotRemovedToastMessage message
tileId,
tileDisplayName,
tileDisplayName,
"DynamicPano.DynamicCategoryPano",
dynamicInfo,
null,
"ms-appx:///" + logo,
tilePinLogos,
liveTileUrls,
liveTileRecurrence
);
}
// generic functionality for setting up a pinButton
function _setupPinButton(
buttonElementId,
buttonTextForAddTile,
buttonTextForRemoveTile,
tileAddSuccessToastMessage,
tileRemoveSuccessToastMessage,
tileNotAddedToastMessage,
tileNotRemovedToastMessage,
tileId,
tileShortName,
tileDisplayName,
tileLaunchTargetPage,
tileLaunchArgument,
existingArticles,
tileLogo,
tilePinLogos,
liveTileUrls,
liveTileRecurrence,
onPinSection) {
var pinIcon = "\uE015";
var unpinIcon = "\uE016";
var pinElement = document.getElementById(buttonElementId);
var pinButton = pinElement.winControl;
var tileExceedsMaxMessage = PlatformJS.Services.resourceLoader.getString("PinExceeded");
var config = PlatformJS.Services.appConfig.getDictionary("Pinning");
var maxSecondaryTileCount = /*config ? config.getInt32("maxSecondaryTileCount") : */100;
var cleanedTileId = CommonJS.Tile.newsSecondaryTile.cleanIdName(tileId); //clean the ID name
if (pinButton && pinButton.element) {
pinButton.extraClass = "appexSymbol";
// find out if this tile already exists
CommonJS.Utilities.Pinning.findSecondaryTilesAsync(cleanedTileId).then(
function (setupResult) {
if (setupResult.found) {
pinButton.label = buttonTextForRemoveTile;
pinButton.icon = unpinIcon;
}
else {
pinButton.label = buttonTextForAddTile;
pinButton.icon = pinIcon;
}
pinButton.tooltip = pinButton.label;
pinButton.onclick = function () {
stickEdgy(true);
var boundingClientRect = pinElement.getBoundingClientRect();
var tile = new CommonJS.Tile.newsSecondaryTile(
cleanedTileId,
tileShortName,
tileDisplayName,
tileLaunchTargetPage,
tileLaunchArgument,
tileLogo);
CommonJS.Utilities.Pinning.findSecondaryTilesAsync(cleanedTileId).then(
function (result) {
if (!result.found && result.totalTileCount >= maxSecondaryTileCount) {
// the 2ndary tile count has exceed the configured value
// don't pin the tile
if (tileExceedsMaxMessage) {
CommonJS.Utilities.showToast(tileExceedsMaxMessage);
}
stickEdgy(false);
}
else {
if (result.found) {
tile.requestDeleteAsync(boundingClientRect.left, boundingClientRect.top + CommonJS.Utilities.Pinning.yAxisSpacer).then(function (isDeleted) {
if (isDeleted) {
// successfully removed the pin
pinButton.label = buttonTextForAddTile;
pinButton.tooltip = pinButton.label;
pinButton.icon = pinIcon;
if (tileRemoveSuccessToastMessage) {
CommonJS.Utilities.showToast(tileRemoveSuccessToastMessage);
}
}
else {
if (tileNotRemovedToastMessage) {
CommonJS.Utilities.showToast(tileNotRemovedToastMessage);
}
}
stickEdgy(false);
},
function (error) {
stickEdgy(false);
});
}
else {
tile.requestCreateAsync(boundingClientRect.left, boundingClientRect.top + CommonJS.Utilities.Pinning.yAxisSpacer, tilePinLogos, liveTileUrls, liveTileRecurrence).then(function (isAdded) {
if (isAdded) {
// successfully added the pin
pinButton.label = buttonTextForRemoveTile;
pinButton.tooltip = pinButton.label;
pinButton.icon = unpinIcon;
if (tileAddSuccessToastMessage) {
CommonJS.Utilities.showToast(tileAddSuccessToastMessage);
}
if (onPinSection) {
onPinSection();
}
}
else {
if (tileNotAddedToastMessage) {
CommonJS.Utilities.showToast(tileNotAddedToastMessage);
}
}
stickEdgy(false);
},
function (error) {
stickEdgy(false);
});
}
}
},
function (error) {
// find tile failed during onClick
stickEdgy(false);
});
};
},
function (error) {
// find tile failed during button setup - no action
});
}
}
function stickEdgy(sticky) {
var actionEdgyCtl = PlatformJS.Utilities.getControl("actionEdgy");
if (actionEdgyCtl) {
actionEdgyCtl.sticky = sticky; // Allow/prevent edgy from disappearing automatically
if (!sticky) {
actionEdgyCtl.hide();
}
}
}
// search through the app's secondary tiles and see if this tileId exists, return the 2ndary count tile as well
function findSecondaryTilesAsync(myTileId) {
return new WinJS.Promise(function (complete, error, progress) {
Windows.UI.StartScreen.SecondaryTile.findAllAsync().then(
function (tiles) {
var found = false;
tiles.forEach(function (tile) {
if (myTileId === tile.tileId) {
found = true;
}
});
complete({ found: found, totalTileCount: tiles.length });
},
function (e) {
error(e);
});
});
}
WinJS.Namespace.define("CommonJS.Utilities.Pinning", {
setupPinCategoryButton: setupPinCategoryButton,
setupPinTopicButton: setupPinTopicButton,
setupPinSourceButton: setupPinSourceButton,
setupPinFeaturedSourceButton: setupPinFeaturedSourceButton,
_setupPinButton: _setupPinButton,
findSecondaryTilesAsync: findSecondaryTilesAsync,
yAxisSpacer: -5, // Add padding for the position of the add/remove pin box
});
})();
(function () {
"use strict";
WinJS.Namespace.define("CommonJS.Tile",
{
newsSecondaryTile: WinJS.Class.define(
function (
tileId,
tileShortName,
tileDisplayName,
tileLaunchTargetPage,
tileLaunchArgument,
tileLogo) {
// Constructor
this._tileId = tileId;
this._tileShortName = tileShortName;
this._tileDisplayName = tileDisplayName;
this._tileLaunchTargetPage = tileLaunchTargetPage;
this._tileLaunchArgument = tileLaunchArgument;
this._tileLogo = tileLogo;
},
{
// Instance Members
requestDeleteAsync: function requestDeleteAsync(xLoc, yLoc) {
var that = this;
return (new Windows.UI.StartScreen.SecondaryTile(that._tileId)).requestDeleteAsync({ x: xLoc, y: yLoc });
},
requestCreateAsync: function requestCreateAsync(xLoc, yLoc, tilePinLogos, liveTileUrls, liveTileRecurrence) {
var that = this;
var shortName = that._tileShortName;
var displayName = that._tileDisplayName;
var json = JSON.stringify({ target: that._tileLaunchTargetPage, data: that._tileLaunchArgument });
var secondaryTile = new Windows.UI.StartScreen.SecondaryTile(
that._tileId,
shortName,
displayName,
json,
Windows.UI.StartScreen.TileOptions.showNameOnLogo | Windows.UI.StartScreen.TileOptions.copyOnDeployment,
new Windows.Foundation.Uri(that._tileLogo));
return new WinJS.Promise(function (complete) {
secondaryTile.requestCreateAsync({ x: xLoc, y: yLoc }).then(
function (isAdded) {
if (isAdded) {
that._getModifiedName(shortName).then(
function (modifiedName) {
that._setTemplates(modifiedName, tilePinLogos, liveTileUrls, liveTileRecurrence);
},
function (error) {
that._setTemplates(shortName, tilePinLogos, liveTileUrls, liveTileRecurrence);
});
}
return complete(isAdded);
});
});
},
// Setup live static tile
_setTemplates: function _setTemplates(text, tilePinLogos, liveTileUrls, liveTileRecurrence) {
if (!text) {
return;
}
var tileUpdater = Windows.UI.Notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(this._tileId);
var squareTile = null,
tilePinLogoDpiSpecific = null,
logoUrl = null,
tileNotification;
// Clear out any existing live tiles
tileUpdater.clear();
if (tilePinLogos) {
//pick the right pinning logo url based on current resolution scale
tilePinLogoDpiSpecific = tilePinLogos[Windows.Graphics.Display.DisplayProperties.resolutionScale];
}
if (tilePinLogoDpiSpecific) {
//first try to load the image from local cache
PlatformJS.Cache.CacheService.getInstance("CustomPanoPinningLogoCache").findEntry(tilePinLogoDpiSpecific, { fileNameOnly: true })
.then(function logoCacheFetch_completion(response) {
var isCached;
if (response && !response.isStale() && response.dataValue) {
logoUrl = response.dataValue;
isCached = true;
} else {
logoUrl = tilePinLogoDpiSpecific;
isCached = false;
}
if (!isCached && PlatformJS.Utilities.hasInternetConnection()) {
return PlatformJS.Utilities.fetchImage("CustomPanoPinningLogoCache", logoUrl, null); // don't wait this async function.
} else {
return WinJS.Promise.wrap(null);
}
})
.done(function logoFetch_completion(finalResponse) {
}, function logoFetch_error(err) {
});
}
if (!liveTileUrls || !liveTileUrls.length) {
if (logoUrl) {
squareTile = PlatformJS.Utilities.getSquarePeekImageAndText04(logoUrl, text);
} else {
squareTile = this._getTileSquareText04(text);
}
tileNotification = new Windows.UI.Notifications.TileNotification(squareTile);
tileNotification.expirationTime = null; // No expiry
tileUpdater.update(tileNotification);
} else {
var pollUrls = [];
for (var i = 0; i < liveTileUrls.length; i++) {
try {
var url = new Windows.Foundation.Uri(liveTileUrls[i]);
pollUrls.push(url);
} catch (e) { }
}
if (pollUrls.length) {
tileUpdater.enableNotificationQueue(true);
if (logoUrl) {
squareTile = PlatformJS.Utilities.getSquareImage(logoUrl);
tileNotification = new Windows.UI.Notifications.TileNotification(squareTile);
tileNotification.expirationTime = null; // No expiry
tileNotification.tag = 1;
tileUpdater.update(tileNotification);
setTimeout(function startPeriodicUpdate() {
tileUpdater.startPeriodicUpdateBatch(pollUrls, liveTileRecurrence);
}, 15000);
} else {
tileUpdater.startPeriodicUpdateBatch(pollUrls, liveTileRecurrence);
}
}
}
},
_getTileSquareText04: function _getTileSquareText04(text) {
var squareTileXml = Windows.UI.Notifications.TileUpdateManager.getTemplateContent(Windows.UI.Notifications.TileTemplateType.tileSquareText04);
var attributes = squareTileXml.getElementsByTagName("text");
if (attributes.length > 0) {
attributes[0].appendChild(squareTileXml.createTextNode(text));
}
return squareTileXml;
},
// The name may have been changed by the user; let's get that name
_getModifiedName: function _getModifiedName(defaultName) {
var that = this;
var modifiedName = defaultName;
return new WinJS.Promise(function (complete, error) {
Windows.UI.StartScreen.SecondaryTile.findAllAsync().then(
function (tiles) {
tiles.forEach(function (tile) {
if (that._tileId === tile.tileId && tile.shortName) {
modifiedName = tile.shortName; // If the user enters emtpy string, the empty string is not returned here.  All non-empty strings are returned properly back to the app
}
});
complete(modifiedName);
},
function (e) {
error(e);
});
});
},
},
{
// Static
// Remove items that are invalid for tile Ids names  example: Technology & Science : spaces cause invalid ID
cleanIdName: function cleanIdName(str) {
var id = str.replace(/[^a-zA-Z0-9._]/g, "");
return id;
},
// Create a valid Dynamic Pano tile ID from the given string
// It is limited to 64 characters and must begin with a number or letter and be composed of the characters a-z, A-Z, 0-9, period (.), or underscore (_).
makeDynamicPanoTileId: function makeDynamicPanoTileId(str) {
var cleanedId = CommonJS.Tile.newsSecondaryTile.cleanIdName(str);
return cleanedId.substr(0, 32) + "DynamicPano.DynamicCategoryPano";
},
updateAllSecondaryTiles: function updateAllSecondaryTiles() {
Windows.UI.StartScreen.SecondaryTile.findAllAsync().then(function (tiles) {
if (tiles) {
tiles.forEach(function (tile) {
// Parse out the args
try {
var args = JSON.parse(tile.arguments);
// Create a newsSecondaryTile from the Tile
var newsTile = new CommonJS.Tile.newsSecondaryTile(tile.tileId, tile.shortName, tile.displayName, args.target, args.data, tile.logo.rawUri);
// Update the tile
var argsData = args && args.data;
var pinLogoUrls = argsData && argsData.pinLogoUrls;
var liveTileUrls = argsData && argsData.liveTileUrls;
var liveTileRecurrence = argsData && argsData.liveTileRecurrence;
newsTile._setTemplates(tile.displayName, pinLogoUrls, liveTileUrls, liveTileRecurrence);
} catch (e) { } // TODO: Something went wrong parsing out args. Can't update tile. Should we leave it be or remove it?
});
}
});
},
}
)
});
})();
