﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: feedbackFragment.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
WinJS.Namespace.define("CommonJS.Feedback", {
/// <field>
/// function to handle keydown event in Feedback Flyout
/// </field>
onKeyDown: function feedbackFragment_onKeyDown(ev) {
switch (ev.keyCode) {
case WinJS.Utilities.Key.upArrow:
if (document.activeElement.id === "buttonDislike") {
var eleLike = document.getElementById("buttonLike");
if (eleLike) {
eleLike.focus();
}
}
break;
case WinJS.Utilities.Key.downArrow:
if (document.activeElement.id === "buttonLike") {
var eleDislike = document.getElementById("buttonDislike");
if (eleDislike) {
eleDislike.focus();
}
}
break;
default: break;
}
},
/// <field>
/// function to switch like/dislike status of Feedback Flyout
/// </field>
switchStatus: function switchStatus(str) {
var eleLike = document.getElementById("buttonLike");
var eleDislike = document.getElementById("buttonDislike");
var questionTitle = document.getElementById("questionTitle");
var likeStatus = document.getElementById("likeStatus");
var userSuggest = document.getElementById("userSuggest");
if (str === "dislike") {
likeStatus.innerText = "dislike";
questionTitle.innerText = CommonJS.resourceLoader.getString("/platform/feedbackDislikeCommentQuestion");
eleDislike.className = "feedbackDivTableLeftTdDiv feedbackDivTableLeftTdDivSelected feedbackColor";
eleLike.className = "feedbackDivTableLeftTdDiv feedbackDivTableLeftTdDivUnselected feedbackColor";
} else if (str === "like") {
likeStatus.innerText = "like";
questionTitle.innerText = CommonJS.resourceLoader.getString("/platform/feedbackLikeCommentQuestion");
eleLike.className = "feedbackDivTableLeftTdDiv feedbackDivTableLeftTdDivSelected feedbackColor";
eleDislike.className = "feedbackDivTableLeftTdDiv feedbackDivTableLeftTdDivUnselected feedbackColor";
}
userSuggest.title = questionTitle.innerText;
},
/// <field>
/// function to handle input change event and autosave current input in Feedback Flyout
/// </field>
onFeedbackInputChange: function onFeedbackInputChange() {
var userSuggest = document.getElementById("userSuggest");
var currentTime = new Date();
CommonJS.feedbackAutosaveTime = currentTime.getTime();
CommonJS.feedbackAutosave = userSuggest.innerText;
},
/// <field>
/// Encoding the characters against ASP net rule
/// </field>
// RFC says:
// If data for a URI component would conflict with a reserved
// character's purpose as a delimiter, then the conflicting data must be
// percent-encoded before the URI is formed.
// reserved    = gen-delims / sub-delims
// gen-delims  = ":" / "/" / "?" / "#" / "[" / "]" / "@"
// sub-delims  = "!" / "$" / "&" / "'" / "(" / ")"
//        / "*" / "+" / "," / ";" / "="
encodingReservedCharacters: function encodingReservedCharacters(string) {
return escape(encodeURIComponent(string)).replace("*", "");
},
/// <field>
/// send feedback content to server
/// </field>
sendFeedback: function sendFeedback() {
var messageBar = null;
if (!window.navigator.onLine) {
messageBar = new CommonJS.MessageBar(CommonJS.resourceLoader.getString("/platform/noInternetDescription"), { autoHide: true });
messageBar.show();
return;
}
//get feedback infomation from the page
var select1 = document.getElementById("question1");
var select2 = document.getElementById("question2");
var userSuggest = document.getElementById("userSuggest");
var questionTitle = document.getElementById("questionTitle");
var userLike = "like";
var answer1 = "NA";
var answer2 = "NA";
var userComment = "NA";
if (select1.selectedIndex !== -1) {
answer1 = select1.options[select1.selectedIndex].innerText;
}
console.log("answer of question1: " + answer1);
if (select2.selectedIndex !== -1) {
answer2 = select2.options[select2.selectedIndex].innerText;
}
console.log("answer of question2: " + answer2);
var regS = /\"/g;
//replace double quote with single quote to work around on display bug on report site, silently restirct user comment to 1000 chars
userComment = userSuggest.innerText.replace(regS, "'").slice(0,1000);
console.log("user comments: " + userComment);
userLike = likeStatus.innerText;
console.log("user like status: " + userLike);
var http = new XMLHttpRequest();
//feedback submit webpages for each app:
//https://feedback.discoverbing.com/default.aspx?productkey=bingnewswin8&mkt=en-us
//https://feedback.discoverbing.com/default.aspx?productkey=bingsportswin8&mkt=en-us
//https://feedback.discoverbing.com/default.aspx?productkey=bingtravelwin8&mkt=en-us
//https://feedback.discoverbing.com/default.aspx?productkey=bingmapswin8&mkt=en-us
//https://feedback.discoverbing.com/default.aspx?productkey=bingfinancewin8&mkt=en-us
//https://feedback.discoverbing.com/default.aspx?productkey=bingweatherwin8&mkt=en-us
//original post string for each app, captured through feedback form submition, with default/empty answers in each fields.
//       returnQuery=%3Fproductkey%3Dbingnewswin8%26mkt%3Den-us&eformpost=true&feedbackParam1=&feedbackParam2=&feedbackParam3=&feedbackParam4=&feedbackParam5=&feedbackParam6=&feedbackParam7=&feedbackParam8=&feedbackParam9=&feedbackParam10=&feedbackParam11=&feedbackParam12=&feedbackParam13=&feedbackParam14=&feedbackParam15=&feedbackParam16=&feedbackParam17=&feedbackParam18=&FD8C313A-FF5B-4D5C-B=Like&BDED91FC-2D64-4D36-A=&79DD6AA6-5937-459A-9=Please+select+an+option&8D66D9FC-4D23-45A6-9=Please+select+an+option&F3A98558-1BD9-47CD-9=&EEDB9897-C13A-4762-B=&0FD2B25D-FCDB-4F77-9=&B1AD7E05-6A79-4ADA-A=&9A97D97E-42B7-439D-9=&2D4DD1B4-2907-4D35-B=
//     returnQuery=%3Fproductkey%3Dbingsportswin8%26mkt%3Den-us&eformpost=true&feedbackParam1=&feedbackParam2=&feedbackParam3=&feedbackParam4=&feedbackParam5=&feedbackParam6=&feedbackParam7=&feedbackParam8=&feedbackParam9=&feedbackParam10=&feedbackParam11=&feedbackParam12=&feedbackParam13=&feedbackParam14=&feedbackParam15=&feedbackParam16=&feedbackParam17=&feedbackParam18=&FD8C313A-FF5B-4D5C-B=Like&BDED91FC-2D64-4D36-A=&79DD6AA6-5937-459A-9=Please+select+an+option&8D66D9FC-4D23-45A6-9=Please+select+an+option&F3A98558-1BD9-47CD-9=&EEDB9897-C13A-4762-B=&0FD2B25D-FCDB-4F77-9=&B1AD7E05-6A79-4ADA-A=&9A97D97E-42B7-439D-9=&2D4DD1B4-2907-4D35-B=
//     returnQuery=%3Fproductkey%3Dbingtravelwin8%26mkt%3Den-us&eformpost=true&feedbackParam1=&feedbackParam2=&feedbackParam3=&feedbackParam4=&feedbackParam5=&feedbackParam6=&feedbackParam7=&feedbackParam8=&feedbackParam9=&feedbackParam10=&feedbackParam11=&feedbackParam12=&feedbackParam13=&feedbackParam14=&feedbackParam15=&feedbackParam16=&feedbackParam17=&feedbackParam18=&FD8C313A-FF5B-4D5C-B=Like&BDED91FC-2D64-4D36-A=&79DD6AA6-5937-459A-9=Please+select+an+option&8D66D9FC-4D23-45A6-9=Please+select+an+option&F3A98558-1BD9-47CD-9=&EEDB9897-C13A-4762-B=&0FD2B25D-FCDB-4F77-9=&B1AD7E05-6A79-4ADA-A=&9A97D97E-42B7-439D-9=&2D4DD1B4-2907-4D35-B=
//       returnQuery=%3Fproductkey%3Dbingmapswin8%26mkt%3Den-us&eformpost=true&feedbackParam1=&feedbackParam2=&feedbackParam3=&feedbackParam4=&feedbackParam5=&feedbackParam6=&feedbackParam7=&feedbackParam8=&feedbackParam9=&feedbackParam10=&feedbackParam11=&feedbackParam12=&feedbackParam13=&feedbackParam14=&feedbackParam15=&feedbackParam16=&feedbackParam17=&feedbackParam18=&FD8C313A-FF5B-4D5C-B=Like&BDED91FC-2D64-4D36-A=&79DD6AA6-5937-459A-9=Please+select+an+option&8D66D9FC-4D23-45A6-9=Please+select+an+option&F3A98558-1BD9-47CD-9=&EEDB9897-C13A-4762-B=&0FD2B25D-FCDB-4F77-9=&B1AD7E05-6A79-4ADA-A=&9A97D97E-42B7-439D-9=&2D4DD1B4-2907-4D35-B=
//    returnQuery=%3Fproductkey%3Dbingfinancewin8%26mkt%3Den-us&eformpost=true&feedbackParam1=&feedbackParam2=&feedbackParam3=&feedbackParam4=&feedbackParam5=&feedbackParam6=&feedbackParam7=&feedbackParam8=&feedbackParam9=&feedbackParam10=&feedbackParam11=&feedbackParam12=&feedbackParam13=&feedbackParam14=&feedbackParam15=&feedbackParam16=&feedbackParam17=&feedbackParam18=&FD8C313A-FF5B-4D5C-B=Like&BDED91FC-2D64-4D36-A=&79DD6AA6-5937-459A-9=Please+select+an+option&8D66D9FC-4D23-45A6-9=Please+select+an+option&F3A98558-1BD9-47CD-9=&EEDB9897-C13A-4762-B=&0FD2B25D-FCDB-4F77-9=&B1AD7E05-6A79-4ADA-A=&9A97D97E-42B7-439D-9=&2D4DD1B4-2907-4D35-B=
//    returnQuery=%3Fproductkey%3Dbingweatherwin8%26mkt%3Den-us&eformpost=true&feedbackParam1=&feedbackParam2=&feedbackParam3=&feedbackParam4=&feedbackParam5=&feedbackParam6=&feedbackParam7=&feedbackParam8=&feedbackParam9=&feedbackParam10=&feedbackParam11=&feedbackParam12=&feedbackParam13=&feedbackParam14=&feedbackParam15=&feedbackParam16=&feedbackParam17=&feedbackParam18=&FD8C313A-FF5B-4D5C-B=Like&BDED91FC-2D64-4D36-A=&79DD6AA6-5937-459A-9=Please+select+an+option&8D66D9FC-4D23-45A6-9=Please+select+an+option&F3A98558-1BD9-47CD-9=&EEDB9897-C13A-4762-B=&0FD2B25D-FCDB-4F77-9=&B1AD7E05-6A79-4ADA-A=&9A97D97E-42B7-439D-9=&2D4DD1B4-2907-4D35-B=
//Bing Feedback service supported markets:
var supportedMarkets = "ar-ae;ar-dz;ar-eg;ar-me;ar-sa;ar-xa;bg-bg;ca-es;cs-cz;da-dk;de-at;de-ch;de-de;de-lu;el-cy;el-gr;en-ae;en-al;en-am;en-au;en-az;en-ba;en-bd;en-bg;en-bh;en-bn;en-by;en-ca;en-dk;enee;en-eg;en-fi;en-gb;en-ge;en-hk;en-hr;en-id;en-ie;en-il;en-in;en-iq;en-is;en-jo;en-kw;en-lb;en-lk;en-lt;en-lv;en-ly;en-md;en-me;en-mk;en-mt;en-my;en-ni;en-ni;en-no;en-nz;en-om;en-ph;en-pk;en-pr;en-qa;en-ro;en-sa;en-sf;en-sg;en-sl;en-sr;en-th;en-tr;en-tt;en-us;en-vn;en-wi;en-ww;en-xa;en-xc;en-xe;en-xo;en-xp;en-xs;en-ye;en-za;es-ar;es-bo;es-cl;es-co;es-r;es-do;es-ec;es-es;es-gt;es-hn;es-la;es-mx;es-ni;es-pa;es-pe;es-pr;es-py;es-sv;es-us;es-uy;es-ve;es-ww;et-ee;eu-es;fi-fi;fr-be;fr-ca;fr-ch;fr-dz;fr-fr;fr-lu;fr-ma;fr-tn;fr-xa;fr-xc;fr-xi;gu-in;he-il;hi-in;hr-hr;hu-hu;id-id;it-it;ja-jp;kk-kz;kn-in;ko-kr;lt-lt;lv-lv;mk-mk;ml-in;mr-in;ms-my;nl-be;nl-nl;no-no;pl-pl;pt-br;pt-pt;ro-ro;ru-kz;ru-ru;ru-ua;sk-sk;sl-l;sr-cyrl-cs;sr-sp;sv-se;ta-in;te-in;th-th;tr-tr;uk-ua;vi-vn;zh-cn;zh-hk;zh-tw;";
var currentMarket = Platform.Globalization.Marketization.getCurrentMarket().toLowerCase();
var marketSupported = true;
if(supportedMarkets.indexOf(currentMarket) < 0){
marketSupported = false;
console.warn("Current market " + currentMarket + " is not a supported market on Feedback service");
}
var productKey = PlatformJS.Services.appConfig.getString("FeedbackProductKey");
if (!productKey || productKey === "") {
productKey = "";
console.warn("Something goes wrong, could not find the feedback product key, feedback data will not be sent.");
}
var urlMarket = marketSupported ? currentMarket : "en-us";
var url = "https://feedback.discoverbing.com/eformpost.aspx?locale=" + CommonJS.Feedback.encodingReservedCharacters(urlMarket) + "&productKey=" + CommonJS.Feedback.encodingReservedCharacters(productKey) + "&ct=feedback&subtype=free";
var version = Windows.ApplicationModel.Package.current.id.version;
var versionString = CommonJS.Feedback.encodingReservedCharacters("v" + version.major + "." + version.minor + "." + version.build + "." + version.revision);
var arch = Windows.ApplicationModel.Package.current.id.architecture;
//enum from http://msdn.microsoft.com/en-us/library/windows/desktop/windows.system.processorarchitecture.aspx
var archString = "undefinedEnum";
if (arch === 0) {
archString = "X86";
} else if (arch === 5) {
archString = "Arm";
} else if (arch === 9) {
archString = "X64";
} else if (arch === 11) {
archString = "Neutral";
} else if (arch === 65535) {
archString = "Unknown";
}
//string parts extracted from post string(same for all apps so far):
var FBSettingID = "returnQuery=%3Fproductkey%3D";       //sameple setting: "bingfinancewin8"
var FBSettingIDAnswer = productKey;
var SettingMarket = "%26mkt%3D";                        //example setting: "en-us"
var SettingMarketAnswer = CommonJS.Feedback.encodingReservedCharacters(currentMarket);
var MiscStr = "&eformpost=true&feedbackParam1=&feedbackParam2=&feedbackParam3=&feedbackParam4=&feedbackParam5=&feedbackParam6=&feedbackParam7=&feedbackParam8=&feedbackParam9=&feedbackParam10=&feedbackParam11=&feedbackParam12=&feedbackParam13=&feedbackParam14=&feedbackParam15=&feedbackParam16=&feedbackParam17=&feedbackParam18="; //no answer required
var FBParamLike = "&FD8C313A-FF5B-4D5C-B=";             //example answer: "Like"
var FBParamLikeAnswer = CommonJS.Feedback.encodingReservedCharacters(userLike);
var FBParamComment = "&BDED91FC-2D64-4D36-A=";          //example answer: "test+only"
var FBParamCommentAnswer = CommonJS.Feedback.encodingReservedCharacters(userComment);
var FBParamFrequency = "&79DD6AA6-5937-459A-9=";        //example answer: "More+than+once+a+day"
var FBParamFrequencyAnswer = CommonJS.Feedback.encodingReservedCharacters(answer1);
var FBParamRate = "&8D66D9FC-4D23-45A6-9=";             //example answer: "Good"
var FBParamRateAnswer = CommonJS.Feedback.encodingReservedCharacters(answer2);
var FBParamRes = "&F3A98558-1BD9-47CD-9=";              //example answer: "1024x768"
var FBParamResAnswer = CommonJS.Feedback.encodingReservedCharacters(window.screen.width + "x" + window.screen.height);
var FBParamArch = "&28DFC297-F3F5-43E8-8=";             //example answer: "Non-Arm"
var FBParamArchAnswer = CommonJS.Feedback.encodingReservedCharacters(archString);
var FBParamBuildNO = "&EEDB9897-C13A-4762-B=";          //example answer: "1.0.1"
var FBParamBuildNOAnswer = CommonJS.Feedback.encodingReservedCharacters(versionString);
var FBParamLatLong = "&0FD2B25D-FCDB-4F77-9=";          //example answer: "11.1 22.2"
var FBParamLatLongAnswer = "";
var FBParamGEO = "&B1AD7E05-6A79-4ADA-A=";              //example answer: "yes"
var FBParamGEOAnswer = "";
var FBParamNetworkStatus = "&9A97D97E-42B7-439D-9=";    //example answer: "good"
var FBParamNetworkStatusAnswer = "";
var FBParamMarketInfo = "&2D4DD1B4-2907-4D35-B=";       //example answer: "en-us"
var FBParamMarketInfoAnswer = marketSupported ? CommonJS.Feedback.encodingReservedCharacters(currentMarket) : CommonJS.Feedback.encodingReservedCharacters(currentMarket + "(unsupported)");
MiscStr = MiscStr + FBParamMarketInfoAnswer; //store market info in feedbackParam18, since current Feedback Feedback site report only supports showing 9 custom fields.
var params = FBSettingID +
FBSettingIDAnswer +
SettingMarket +
SettingMarketAnswer +
MiscStr +
FBParamLike +
FBParamLikeAnswer +
FBParamComment +
FBParamCommentAnswer +
FBParamFrequency +
FBParamFrequencyAnswer +
FBParamRate +
FBParamRateAnswer +
FBParamRes +
FBParamResAnswer +
FBParamArch +
FBParamArchAnswer +
FBParamBuildNO +
FBParamBuildNOAnswer +
FBParamLatLong +
FBParamLatLongAnswer +
FBParamGEO +
FBParamGEOAnswer +
FBParamNetworkStatus +
FBParamNetworkStatusAnswer +
FBParamMarketInfo +
FBParamMarketInfoAnswer;
console.log("post URL: " + url);
console.log("submit string: " + params);
http.open("POST", url, true);
//Send the proper header information along with the request
http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
http.setRequestHeader("Content-length", params.length);
http.setRequestHeader("Accept-Encoding", "gzip, deflate");
http.setRequestHeader("Host", "feedback.discoverbing.com");
http.setRequestHeader("User-Agent", window.navigator.userAgent);
http.setRequestHeader("Connection", "close");
http.onreadystatechange = function () {
if (http.readyState === 4) { //state is Complete
if (http.status === 200) { //status is OK
console.log("feedback submitted.");
} else {
console.log("feedback submit failed.");
}
}
};
http.ontimeout = function () {
console.log("feedback submit timeout.");
};
if (productKey !== "") {
http.send(params);
} else {
console.warn("http post is cancelled due to invalid product key");
}
messageBar = new CommonJS.MessageBar(CommonJS.resourceLoader.getString("/platform/feedbackThankYou"), { autoHide: true });
messageBar.show();
userSuggest.innerText = ""; 
CommonJS.feedbackAutosave = ""; //clear user input when submit
//no need to clear feedbackAutosaveTime: if timeout expires, it will be ignored anyway; if it is in 30 minutes, we just restore empty string
PlatformJS.Utilities.getControl("SharedFeedbackPage").hide();
}
});
})();
