﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: services.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
/// <reference path="services.js" />
/// <dictionary target='comment'>accessor</dictionary>
/// <dictionary target='variable'>Accessor</dictionary>
// Recommendation from Windows to override the error handler to get useful stacks for exceptions thrown inside promises.
// This needs to be done in our apps and cannot be done at the WinJS level.
// Talked to Harris Syed (harsyed) 6/11/2012
(function appexPlatformObjectExtensionsInit() {
'use strict';
var e = WinJS.Promise.wrapError();
var d = Object.getPrototypeOf(e).done;
Object.getPrototypeOf(e).done = function (c, e, p) {
e = e || function (v) {
if (!(v instanceof Error)) {
var description;
try {
description = JSON.stringify(v);
} catch (e) {
description = "[unknown]";
}
v = {
number: 0,
stack: "",
description: description
};
}
WinJS.Application.queueEvent({ type: "error", detail: v });
};
d.call(this, c, e, p);
};
})();
(function appexPlatformProcessManagerInit() {
"use strict";
WinJS.Namespace.define("PlatformJS",
{
DataService: {},
mainProcessManager: null,
isDebug: false,
_launchedLanguage: null,
ProcessManager: WinJS.Class.define(function processManager_ctor() {
var orientationSensor = null,
that = this;
PlatformJS.Services = Platform.ServicesAccessor;
// Initialize application wide crash reporting
this._crashReporter = new PlatformJS.CrashReporterProxy();
this._activated = false;
this.processListeners = [];
// Add the activated event listener
WinJS.Application.addEventListener("activated", function processManager_onActivated(event) {
that._onActivated(event);
});
// Add the checkpoint event listener
WinJS.Application.addEventListener("checkpoint", function processManager_onCheckpoint(event) {
that._onCheckpoint(event);
});
// Add the suspend event listener
Windows.UI.WebUI.WebUIApplication.addEventListener("suspending", function processManager_onSuspending(event) {
that._onSuspending(event);
});
// Add the resuming event listener
Windows.UI.WebUI.WebUIApplication.addEventListener("resuming", function processManager_onResuming(event) {
that._onResuming(event);
});
// Add the layout change listener
this._windowSizeManager = new PlatformJS.WindowSizeManager();
// Add the dpi change listener ("Make everything on your screen bigger" setting)
this._dpiChangeManager = new PlatformJS.DpiChangeManager();
//// Add the layout change listener
////TODO: we should cache the current viewState in memory
////      and avoid firing the events if the viewState is still
////      the same after resize (full => 3/4)
////[BEGIN]
//window.addEventListener("resize", function (event) {
//    var viewState = Windows.UI.ViewManagement.ApplicationView.value;
//    var viewStateChangedArgs = {
//        detail: [{ viewState: viewState }],
//        type: "viewstatechanged",
//        viewState: viewState,
//    };
//    that._onLayoutChange(viewStateChangedArgs);
//}, false);
////[END]
// Add the before navigation event listener
WinJS.Navigation.addEventListener("beforenavigate", function processManager_onBeforeNavigated(event) {
Platform.Process.instance.onBeforeNavigate();
that._errorShownByPlatform = false;
});
// Add the after navigation event listener
WinJS.Navigation.addEventListener("navigated", function processManager_onNavigated(event) {
Platform.Process.instance.onAfterNavigate();
});
// check to see if there are any marketization overrides
// the namespace to look for is "AppexJS.PreInitialize"
msWriteProfilerMark("Platform:MarketOverrides:s");
if (typeof AppexJS === "object") {
if (AppexJS.PreInitialize) {
if (AppexJS.PreInitialize.doMarketOverrides) {
var overrides = AppexJS.PreInitialize.doMarketOverrides();
if (overrides) {
var marketization = Platform.Globalization.Marketization;
// any language to marketlist mapping?
var mapping = overrides.languageMarketsMapping;
if (mapping) {
for (var language in mapping) {
marketization.overrideLanguageMarket(language, mapping[language]);
}
}
// any market string override?
if (overrides.marketStringOverride) {
marketization.setCurrentMarket(overrides.marketStringOverride);
}
if (overrides.disablePrimaryLanguageOverride) {
marketization.disablePrimaryLanguageOverride = overrides.disablePrimaryLanguageOverride;
}
}
}
if (AppexJS.PreInitialize.enableLocationLookup) {
Platform.Configuration.ConfigurationManager.enableLocationLookup = AppexJS.PreInitialize.enableLocationLookup;
}
}
}
msWriteProfilerMark("Platform:MarketOverrides:e");
// preserve the language we launched with
that._launchedLanguage = Platform.Globalization.Marketization.getQualifiedLanguageString();
this._initializePromise = PlatformJS.Services.process.onInitialize();
},
{
_activated: false,
_initializeCompletionCalled: false,
_checkPointTimer: null,
_processListeners: [],
_crashReporter: null,
_activateStopWatch: null,
_resumeStopWatch: null,
_currentViewState: null,
_initializePromise: null,
// helper proxies
_windowSizeManager: null,
_dpiChangeManager: null,
_postActiveComplete: null,
showSettings: function showSettings() {
for (var i = 0; i < this._processListeners.length; i++) {
// The first process listener with a show settings method, call it and stop
if (this._processListeners[i].showSettings) {
this._processListeners[i].showSettings();
break;
}
}
},
afterFirstView: function afterFirstView(event) {
// Fix for bug 527426 (change list # 155565):
// set the flag to true to allow splash screen to be dismissed
CommonJS.Progress.canDestroySplash(true);
CommonJS.Progress.destroySplash(true);
for (var i = 0, ilen = this._processListeners.length; i < ilen; i++) {
if (this._processListeners[i].afterFirstView) {
this._processListeners[i].afterFirstView(event);
}
}
this.afterFirstView = function (event) { }; // reset to no-op
},
_onCheckpoint: function _onCheckpoint(event) {
/// <summary>
/// Handles Checkpoint event
/// </summary>
/// <param name="event">
/// Checkpoint event
/// </param>
/// <returns>
/// Nothing
/// </returns>
PlatformJS.Services.platformEventSource.processCheckpointStart();
// Go backwards
for (var i = this._processListeners.length - 1; i >= 0; i--) {
if (this._processListeners[i].onCheckpoint) {
this._processListeners[i].onCheckpoint(event);
}
}
PlatformJS.Services.process.onCheckpointAsync().done();
PlatformJS.Services.platformEventSource.processCheckpointStop();
},
_onLayoutChange: function _onLayoutChange(event) {
/// <summary>
/// Handles layout change event
/// </summary>
/// <param name="event">
/// Layout change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
for (var i = 0; i < this._processListeners.length; i++) {
if (this._processListeners[i].onLayoutChange) {
this._processListeners[i].onLayoutChange(event);
}
}
// Instrumentation - Capture View State - Windows.UI.ViewManagement.ApplicationViewState
PlatformJS.Services.instrumentation.incrementInt32Array(
Platform.Instrumentation.InstrumentationDataSetId.platform,
Platform.Instrumentation.InstrumentationDataPointId.layoutChangeCount,
event.viewState, 4, 1);
},
_onWindowResize: function _onWindowResize(event) {
/// <summary>
/// Handles window resize event. Occurs when:
///  - changing resolution in control panel
///  - WINDOWS+ARROW when using multiple monitors
/// </summary>
/// <param name="event">
/// resize event
/// </param>
/// <returns>
/// Nothing
/// </returns>
for (var i = 0; i < this._processListeners.length; i++) {
if (this._processListeners[i].onWindowResize) {
this._processListeners[i].onWindowResize(event);
}
}
},
_onSuspending: function _onSuspending(event) {
/// <summary>
/// Handles Suspend event
/// </summary>
/// <param name="event">
/// Suspend event
/// </param>
/// <returns>
/// Nothing
/// </returns>
PlatformJS.Services.platformEventSource.processSuspendStart();
// Go backwards
for (var i = this._processListeners.length - 1; i >= 0; i--) {
if (this._processListeners[i].onSuspending) {
this._processListeners[i].onSuspending(event);
}
}
// Find the cumulative page navigation (cost) and see if it has reached the threshold for restarting the app. 
// It's configurable per architecture.
var thresholdKey = "Unknown";
var thresholdReached = false;
switch (Windows.ApplicationModel.Package.current.id.architecture) {
case Windows.System.ProcessorArchitecture.arm:
thresholdKey = "ARM";
break;
case Windows.System.ProcessorArchitecture.neutral:
thresholdKey = "Neutral";
break;
case Windows.System.ProcessorArchitecture.unknown:
thresholdKey = "Unknown";
break;
case Windows.System.ProcessorArchitecture.x64:
thresholdKey = "X64";
break;
case Windows.System.ProcessorArchitecture.x86:
thresholdKey = "X86";
break;
default:
thresholdKey = "Unknown";
break;
}
if (PlatformJS.Services.isConfigurationInitialized && PlatformJS.Navigation.mainNavigator && PlatformJS.Navigation.mainNavigator.weightedNavigationCounter) {
// check for terminate threshold if configuration is initialized
var threshold = Platform.Configuration.ConfigurationManager.custom.getDictionary("TerminateThreshold").getInt32(thresholdKey);
var currentScore = PlatformJS.Navigation.mainNavigator.weightedNavigationCounter.getCount();
if ((threshold !== 0) && (currentScore >= threshold)) {
thresholdReached = true;
PlatformJS.Services.instrumentation.incrementInt32(
Platform.Instrumentation.InstrumentationDataSetId.platform,
Platform.Instrumentation.InstrumentationDataPointId.terminateOnSuspendCount);
Platform.Telemetry.FlightRecorder.logSessionExit(Platform.Telemetry.LogLevel.normal, "Threshold = " + threshold + ", Score = " + currentScore);
}
}
// clear any pending image requests
PlatformJS.Images.dispose();
PlatformJS.Services.process.onSuspend();
PlatformJS.Services.platformEventSource.processSuspendStop();
// If the current market has been determined to be embargoed, we close the app on suspend.
if (Platform.Configuration.ConfigurationManager.instance.isEmbargoed) {
PlatformJS.Services.platformEventSource.traceInfo("Embargoed country/region detected. Closing app.");
Platform.Diagnostics.EventTraceSession.stopTraceSession();
Platform.Process.exitApplication();
}
// If the threshold for page navigations have been reached, we close the app on suspend.
if (thresholdReached) {
PlatformJS.Services.platformEventSource.traceInfo("Threshold = " + threshold + ", Score = " + currentScore + ". Closing app.");
Platform.Diagnostics.EventTraceSession.stopTraceSession();
setTimeout(function () {
Platform.Process.exitApplication();
}, 3000); // gives time to upload FR data
}
Platform.Diagnostics.EventTraceSession.stopTraceSession();
},
_onMarketConfigurationChange: function _onMarketConfigurationChange(eventName, obj) {
// Reload javascript cached resource strings since market has changed.  
// The cs side one will have been changed already by the configurationManager
CommonJS.reloadResourceLoader();
var settingsPage = PlatformJS.Utilities.getControl("settingsPage");
if (settingsPage) {
settingsPage.hide();
}
this._resetCss();
this._applyAnyPendingConfigChanges(true);
this._resetSettingPageChrome();
Platform.Globalization.Marketization.hasPendingUpdate = false;
},
_onUpdatedMarket: function _onUpdatedMarket() {
for (var i = 0; i < this._processListeners.length; i++) {
if (this._processListeners[i].onUpdatedMarket) {
this._processListeners[i].onUpdatedMarket();
}
}
},
_resetSettingPageChrome: function _resetSettingPageChrome() {
// fix chrome on settingsPage
var container = document.getElementById("settingsPage");
if (container) {
var title = PlatformJS.Services.resourceLoader.getString("/platform/optionsTitle");
var clearHistory = PlatformJS.Services.resourceLoader.getString("ClearHistory");
var clearHistoryInstruction = PlatformJS.Services.resourceLoader.getString("ClearHistoryInstruction");
var dataContext = {
pageTitle: title,
clearHistory: clearHistory,
clearHistoryInstruction: clearHistoryInstruction
};
WinJS.Binding.processAll(container, dataContext);
}
},
_resetCss: function _resetCss() {
var newQualifiedLanguageString = Platform.Globalization.Marketization.getQualifiedLanguageString();
// set direction on HTML node for i18n
var htmlTag = document.getElementsByTagName("html")[0];
htmlTag.lang = newQualifiedLanguageString;
htmlTag.removeAttribute("dir");
htmlTag.dir = window.getComputedStyle(htmlTag).direction;
// reset css if language had changed 
if (this._launchedLanguage !== newQualifiedLanguageString) {
var linkTags = document.getElementsByTagName("link");
for (var index = 0; index < linkTags.length; index++) {
// reload the css
var link = linkTags[index];
var hrefValue = link.getAttribute("href");
link.setAttribute("href", "");
link.setAttribute("href", hrefValue);
}
// note: reload server string resource files is required here if dynamic market selection is re-enabled
// update the launched language since we have effectively changed the language for the app
this._launchedLanguage = newQualifiedLanguageString;
}
},
_applyAnyPendingConfigChanges: function _applyAnyPendingConfigChanges(forceToHome) {
if (Platform.Configuration.ConfigurationManager.hasPendingUpdate) {
Platform.Configuration.ConfigurationManager.instance.applyPendingUpdate();
PlatformJS.Services.process.applyPendingConfigurationUpdate(); // this cause the c# cache to reload its manifest.
PlatformJS.Cache.CacheService.reset(); // now clear js side cached caches.   new calls will make new connections to the new caches on c# side
// Navigate away to allow apps to clean up resources (do this before reloadchannels cleans up the currentIPage).
PlatformJS.Navigation.mainNavigator.navigateAway();
// reload the channels here so the apps have chance to change on their onUpdatedConfig
PlatformJS.Navigation.mainNavigator.channelManager.reloadChannels();
//clear the Ads config here so that the next time an ad is requested, it will use the updated configuration
PlatformJS.Ads.Config.clearAdsConfig();
for (var i = this._processListeners.length - 1; i >= 0; i--) {
if (this._processListeners[i].onUpdatedConfig) {
this._processListeners[i].onUpdatedConfig(event);
}
}
// safest option is to navigate to home is config is changed.
PlatformJS.Navigation.mainNavigator.returnHomeAndClearHistoryIfNecessary(true); // refresh the app to home screen                       
}
},
_onResuming: function _onResuming(event) {
/// <summary>
/// Handles Resume event
/// </summary>
/// <param name="event">
/// resume event
/// </param>
/// <returns>
/// Nothing
/// </returns>
var that = this;
if (Windows.Storage.ApplicationData.current.localSettings.values["etw_logging"]) {
var newFile = Windows.Storage.ApplicationData.current.localSettings.values["etw_logging_newFile"];
Platform.Diagnostics.EventTraceSession.startTraceSession(newFile);
}
CommonJS.NetworkIndicator.checkNetworkState();
// Instrumentation - App Resume Average Time - Start
this._resumeStopWatch = PlatformJS.Services.instrumentation.createStopwatch(
Platform.Instrumentation.InstrumentationDataSetId.platform,
Platform.Instrumentation.InstrumentationDataPointId.appResumeAverageTime, true);
PlatformJS.Services.platformEventSource.processResumeStart();
this._initializePromise.then(function processManager_onResumeInitializeCompletion() {
// some resume code implicitly relies on initialization to be complete
// but the app may be suspended and resumed before this is true
that._applyAnyPendingConfigChanges(false);
PlatformJS.Images.init();
PlatformJS.Services.process.onResume();  // async
for (var i = 0; i < that._processListeners.length; i++) {
try {
if (that._processListeners[i].onResuming) {
that._processListeners[i].onResuming(event);
}
}
catch (e) { }
}
PlatformJS.Services.platformEventSource.processResumeStop();
// Instrumentation - App Resume Average Time - Stop
that._resumeStopWatch.stop();
});
},
_onActivated: function _onActivated(event) {
msWriteProfilerMark("Platform:Activated:s");
var that = this;
var splashScreen = event.detail.splashScreen;
if (event.detail.kind === Windows.ApplicationModel.Activation.ActivationKind.protocol) {
// note: we do not pass in the actual URI since it may fail to marshal if the URI
// starts with a number (it does not strictly comply with URI schema).
if (Platform.Configuration.ConfigurationManager.parseActivationProtocolUri(event.detail.uri.host, event.detail.uri.query)) {
// if we've processed platform arguments then close app
PlatformJS.Services.platformEventSource.traceInfo("Platform arguments processed. Settings updated. Closing app.");
Platform.Process.exitApplication();
}
var uri = event.detail.uri;
if (uri.path === "/enableetw") {
var newFile = false;
if (uri.queryParsed.length >= 1) {
var firstQuery = uri.queryParsed[0];
newFile = (firstQuery.name === "newfile" && firstQuery.value === "true");
}
if (Platform.Diagnostics.EventTraceSession.startTraceSession(newFile)) {
Windows.Storage.ApplicationData.current.localSettings.values["etw_logging"] = true;
Windows.Storage.ApplicationData.current.localSettings.values["etw_logging_newFile"] = newFile;
}
}
else if (uri.path === "/disableetw") {
Windows.Storage.ApplicationData.current.localSettings.values["etw_logging"] = false;
Platform.Diagnostics.EventTraceSession.stopTraceSession();
}
}
splashScreen.addEventListener("dismissed", function processManager_onDismissed(evt) {
that._onSystemSplashScreenDismissed(event);
}, false);
PlatformJS.Services.instrumentation.setInt32(
Platform.Instrumentation.InstrumentationDataSetId.ceipPing,
Platform.Instrumentation.InstrumentationDataPointId.activationKind,
event.detail.kind);
// Instrumentation - Capture View State - Windows.UI.ViewManagement.ApplicationViewState
PlatformJS.Services.instrumentation.incrementInt32Array(
Platform.Instrumentation.InstrumentationDataSetId.platform,
Platform.Instrumentation.InstrumentationDataPointId.layoutChangeCount,
Windows.UI.ViewManagement.ApplicationView.value, 4, 1);
// Initialize the extended splash screen
//TODO: handle different activations (termination and such)
//[BEGIN]
//if (event.detail.kind === Windows.ApplicationModel.Activation.ActivationKind.launch) {
// Don't show splash screen if app is already activated and activation is via protocol
if (!that._activated) {
CommonJS.Progress.setSystemSplash(event.detail.activatedOperation.getDeferral(), function processManager_initialExtendedSplash() {
that._postSplashComplete();
});
//Delay showing the extended splash screen. By doing this we actually improve startup perf
//by avoiding expensive rendering/painting from IE and DWM for our DOM. If for some 
//reason we take too long then we will allow the extended splash screen to show along with 
//progress spinner.
//Magic number explanation: Using 2.5secs here as on ARM we have typically spent ~1.5secs to get to this point.
//That gives us a roughly 4 sec delay before showing the extended splash. On non ARM we typically have shown the app by 4secs.
setTimeout(function processManager_postSplashTimeout() {
if (CommonJS.Progress.isShowingSystemSplash()) {
// The timeout expired and the system splash screen has not been dismissed so it's time to show 
// the extended splash screen.
CommonJS.Progress.initializeExtendedSplash(splashScreen, false);
CommonJS.Progress.destroySystemSplash(false /* removeExtendedSplash */);
}
}, 2500);
} else {
that._postSplashComplete();
}
//}
//[END]
that._initializePromise.then(function processManager_initializeCompletion() {
// If this is the first activation
var historySetup = null;
var historySetup2 = WinJS.Promise.wrap(null);
var earlyFetchPromise = null;
if (!that._activated && !that._initializeCompletionCalled) {
// it can take a long time until "that._activated" actually gets set to true
// so double-activation is possible.  using "_initializeCompletionCalled" ensures that we don't call this block of code twice
that._initializeCompletionCalled = true;
// Check if we're in recover mode
var isRecoverMode = Platform.Process.isRecoverMode;
// Map QueryService onto the DataService namespace
PlatformJS.DataService.QueryService = Platform.QueryService;
// Create a collections object and expose it on the Collections namespace
PlatformJS.Collections = Platform.ServicesAccessor.collections;
// Initialize additional process listeners (we're initializing earlier so
// that other process listeners get a chance to do any early fetching work)
var processListenersList = PlatformJS.Services.manifest.processListeners;
var processListener = null;
for (var i = 0; i < processListenersList.size; i++) {
processListener = PlatformJS.Utilities.createObject(processListenersList[i].name);
if (processListener) {
that._processListeners.push(processListener);
}
}
// Check we need to start from a clear state
var isVersionUpdate = PlatformJS.Services.process.isVersionUpdate();
var resetHistory = Windows.Storage.ApplicationData.current.localSettings.values["platform_resetHistory"];
var isLanguageOrLocationChanged = !Platform.Globalization.Marketization.isSavedLanguageAndLocationSame();
var clearState = (event.detail.previousExecutionState === Windows.ApplicationModel.Activation.ApplicationExecutionState.notRunning)
|| (event.detail.previousExecutionState === Windows.ApplicationModel.Activation.ApplicationExecutionState.terminated)
|| (event.detail.previousExecutionState === Windows.ApplicationModel.Activation.ApplicationExecutionState.closedByUser)
|| resetHistory
|| isLanguageOrLocationChanged;
if (isVersionUpdate || clearState) {
// This is the most optimized case from an 
// early prefetch perspective because we know
// navigation will go to home channel
// Invoke on before activate handlers passing in home channel
// Apps may choose to early-fetch their data at this point
var promises = [];
var listeners = that._processListeners;
for (var j = 0; j < that._processListeners.length; j++) {
if (listeners[j].onBeforeActivate) {
msWriteProfilerMark("Platform:ProcessListenerBeforeActivate" + j + ":s");
promises.push(listeners[j].onBeforeActivate(event, isRecoverMode, "Home"));
msWriteProfilerMark("Platform:ProcessListenerBeforeActivate" + j + ":e");
}
}
if (promises.length) {
/* Join does a little too much and normally it'll be just one promise 
* Hence a simple optimization 
*/
earlyFetchPromise = promises.length > 1 ? WinJS.Promise.join(promises) : promises[0];
}
}
// Initialize the navigator
PlatformJS.Navigation.mainNavigator = new PlatformJS.Navigation.Navigator();
that._processListeners.push(PlatformJS.Navigation.mainNavigator);
// Persist the current language and location of the system
Platform.Globalization.Marketization.updateSavedLanguageAndLocation();
// Setup navigation history
historySetup = PlatformJS.Navigation.mainNavigator.initialize(clearState, isVersionUpdate);
// If we have an early fetch going on
if (earlyFetchPromise !== null) {
// Join early fetch promise with history setup
historySetup2 = WinJS.Promise.join([earlyFetchPromise, historySetup]).then(
function processManager_getHistorySetup() {
return historySetup;
});
} else {
historySetup2 = historySetup;
}
}
else {
// Nothing to do
historySetup2 = WinJS.Promise.wrap(null);
}
// Call platform activation after history is set up
historySetup2.then(function processManager_historySetupComplete(target) {
// If we have a target and we
// didn't do any early-prefetching yet
if (target && (earlyFetchPromise === null)) {
// Invoke on before activate handlers passing in current target
// Apps may choose to early-fetch their data at this point
var listeners = that._processListeners;
for (var i = 0; i < that._processListeners.length; i++) {
if (listeners[i].onBeforeActivate) {
msWriteProfilerMark("Platform:ProcessListenerBeforeActivate" + i + ":s");
listeners[i].onBeforeActivate(event, isRecoverMode, target.pageInfo.channelId);
msWriteProfilerMark("Platform:ProcessListenerBeforeActivate" + i + ":e");
}
}
}
// Invoke platform activation handler
that._platformActivation(target, isRecoverMode, event);
});
});
},
_onSystemSplashScreenDismissed: function _onSystemSplashScreenDismissed(event) {
msWriteProfilerMark("Platform:SystemSplashScreenDismissed:s");
msWriteProfilerMark("Platform:SystemSplashScreenDismissed:e");
},
_platformActivation: function _platformActivation(target, isRecoverMode, event) {
/// <summary>
/// Handles activation event
/// </summary>
/// <param name="event">
/// activation event
/// </param>
/// <returns>
/// Nothing
/// </returns>
msWriteProfilerMark("Platform:PlatformActivation:s");
var applicationAccessor = null,
historySetup = null,
that = this;
// Trace every activation that happens, not just the first.
PlatformJS.Services.platformEventSource.processActivateStart();
// Instrumentation - App Activate Average Time - Start
this._activateStopWatch = PlatformJS.Services.instrumentation.createStopwatch(
Platform.Instrumentation.InstrumentationDataSetId.platform,
Platform.Instrumentation.InstrumentationDataPointId.appActivateAverageTime, true);
// Instrumentation - Protocol URI
if (event.detail.kind === Windows.ApplicationModel.Activation.ActivationKind.protocol) {
var truncatedURI = event.detail.uri.rawUri.substring(0, 499); // Uri limited to 500 characters
PlatformJS.Services.instrumentation.setString(
Platform.Instrumentation.InstrumentationDataSetId.ceipPing,
Platform.Instrumentation.InstrumentationDataPointId.protocolUri,
truncatedURI);
}
// Some platform code must be run for each activation, not just the first.
Platform.Process.setUIDispatcher();
Platform.Process.registerPlatformUIEventHandler("configuration_changed", that._showConfigurationChangedDialog);
Platform.Process.registerPlatformUIEventHandler("http_status_403_error", that._handle403Error);
Platform.Process.registerPlatformUIEventHandler("first_network_request_suspended", that._handleFirstNetworkCallSuspended.bind(this));
Platform.Process.registerPlatformUIEventHandler("network_request_suspended", that._handleNetworkSuspendMessaging.bind(this));
Platform.Process.registerPlatformUIEventHandler("network_request_resumed", that._handleNetworkResumeMessaging.bind(this));
Platform.Process.registerPlatformUIEventHandler("show_version_update_UI", that._showVersionUI.bind(this));
Platform.Process.registerPlatformUIEventHandler("http_response_badid", that._onBadId);
Platform.Process.registerPlatformUIEventHandler("show_credential_picker_UI", that._showCredentialUI);
Platform.Process.registerPlatformUIEventHandler("market_configuration_changed", that._onMarketConfigurationChange.bind(this));
Platform.Process.registerPlatformUIEventHandler("updated_market", that._onUpdatedMarket.bind(this));
Platform.Process.registerPlatformUIEventHandler("string_resource_changed", that._overrideWinJSGetString);
// Run only when first activated.
if (!that._activated) {
switch (event.detail.kind) {
case Windows.ApplicationModel.Activation.ActivationKind.launch:
PlatformJS.Services.process.onActivateLaunch(event.detail.arguments);
break;
case Windows.ApplicationModel.Activation.ActivationKind.protocol:
PlatformJS.Services.process.onActivateProtocol(event.detail.uri.absoluteUri, event.detail.arguments);
break;
case Windows.ApplicationModel.Activation.ActivationKind.search:
PlatformJS.Services.process.onActivateSearch(event.detail.queryText, event.detail.arguments);
break;
case Windows.ApplicationModel.Activation.ActivationKind.share:
PlatformJS.Services.process.onActivateShare("", event.detail.arguments); // pass in an empty URI for now - we'll revisit in Blue
break;
default:
msWriteProfilerMark("Unsupported FR launch type: " + event.detail.kind);
PlatformJS.Services.process.onActivateLaunch(event.detail.arguments);
break;
}
PlatformJS.Images.init();
msWriteProfilerMark("Platform:onActivateDone:s");
that._resetCss();
// Add the visibility change listener
document.addEventListener("msvisibilitychange", function processManager_onMSVisiblityChange(event) {
that._onVisibilityChange(event);
});
// Do not reset history on subsequent boots
Windows.Storage.ApplicationData.current.localSettings.values["platform_resetHistory"] = false;
// Post platform activation
historySetup = WinJS.Promise.wrap(target);
that._postPlatformActivation(historySetup, event);
// Activation done
that._activated = true;
msWriteProfilerMark("Platform:onActivateDone:e");
} else {
//This is not the first activation
//this needs to wait until at least one activation is complete
historySetup = WinJS.Promise.wrap(null);
that._postPlatformActivation(historySetup, event);
// We still need to send reports even though we didn't have splash screen post activation work
if (event.detail.previousExecutionState === Windows.ApplicationModel.Activation.ApplicationExecutionState.suspended) {
// Activation from suspension - OnSuspend will take care of sending the ping data set
Platform.Process.instance.sendReports(false);
} else {
// Activation without suspension - Need to send ping data set
Platform.Process.instance.sendReports(true);
}
}
msWriteProfilerMark("Platform:PlatformActivation:e");
},
_postPlatformActivation: function _postPlatformActivation(historySetup, event) {
/// <summary>Handle post platform activation tasks such as activating the other process listerns</summary>
/// <param name="historySetup">Navigation history promise</param>
/// <param name="event">Activation event</param>
msWriteProfilerMark("Platform:PostPlatformActivation:s");
var that = this;
// Fire the checkpoint event every minute
if (this._checkPointTimer) {
clearInterval(this._checkPointTimer);
} else {
var checkpointInterval = PlatformJS.Services.configuration.getDictionary("PLM").getInt32("CheckpointIntervalInMilliseconds", 60 * 1000);
this._checkPointTimer = setInterval(function processManager_checkPointTimer() {
WinJS.Application.checkpoint();
},
checkpointInterval);
}
var target = null;
var diskState = null;
historySetup
.then(function processManager_historySetupComplete(t) {
target = t;
if (target && target.state && !target.state.__lookupStateFile) {
return WinJS.Promise.wrap(target.state);
} else if (target) {
return PlatformJS.Navigation.mainNavigator.readEntryStateFromDiskAsync(target);
} else {
return WinJS.Promise.wrap(null);
}
})
.then(function processManager_readEntryStateFromDiskAsyncComplete(state) {
if (state) {
diskState = state.state;
}
return WinJS.Promise.wrap(target);
})
.then(function processManager_getTargetComplete(target) {
var promises = [];
var listeners = that._processListeners;
var desired = null;
var isRecoverMode = Platform.Process.isRecoverMode;
for (var i = 0; i < that._processListeners.length; i++) {
if (listeners[i].onActivated) {
msWriteProfilerMark("Platform:ProcessListenerActivated" + i + ":s");
var temp = that._processListeners[i].onActivated(event, isRecoverMode);
if (temp && desired) {
throw "Multiple ProcessListenerActivated tried to override the target landing page";
}
if (temp) {
desired = temp;
}
msWriteProfilerMark("Platform:ProcessListenerActivated" + i + ":e");
}
}
return WinJS.Promise.wrap(desired)
.then(function processManager_getDesiredComplete(desired) {
var actualTarget = null;
var useTarget = true;
var comparison = null;
if (target) {
comparison = {
pageInfo: target.pageInfo,
state: diskState
};
} else {
useTarget = false;
comparison = {
pageInfo: {
page: WinJS.Navigation.history.current.location.page,
fragment: WinJS.Navigation.history.current.location.fragment,
},
state: WinJS.Navigation.history.current.state,
};
}
if (that._processNavigationForDuplicate(desired, comparison)) {
actualTarget = desired || target;
} else if (useTarget) {
actualTarget = target;
}
return WinJS.Promise.wrap(actualTarget);
});
})
.then(function processManager_getActualTargetComplete(target) {
if (target) {
// once activation is completed, navigate to landing
if (target.mode === "print") {
PlatformJS.Navigation.mainNavigator.loadPage({
location: target.pageInfo,
state: target.state
});
} else if (event.detail.kind === 1 &&
Windows.UI.ViewManagement.ApplicationView.value === 2 &&
event.detail.previousExecutionState !== Windows.ApplicationModel.Activation.ApplicationExecutionState.notRunning) {
PlatformJS.Navigation.mainNavigator.pendingNavigation = target;
} else {
WinJS.Navigation.navigate(
target.pageInfo,
target.state);
}
}
PlatformJS.Services.platformEventSource.processActivateStop();
msWriteProfilerMark("Platform:Activated:e");
msWriteProfilerMark("Platform:PostPlatformActivation:e");
});
// Instrumentation - App Activate Average Time - Stop
this._activateStopWatch.stop();
},
_processNavigationForDuplicate: function _processNavigationForDuplicate(target, current) {
if (!target && current) {
return true;
}
function getType(literal) {
var node = window;
var segments = literal.split(".");
for (var i = 0, ilen = segments.length; i < ilen; i++) {
node = node[segments[i]];
if (!node) {
return null;
}
}
return node;
}
if (current && current.pageInfo) {
var location = current.pageInfo;
var targetPageInfo = target.pageInfo;
if (location.fragment === targetPageInfo.fragment &&
location.page === targetPageInfo.page) {
var pageType = getType(targetPageInfo.page);
if (pageType && pageType.areStateEqual) {
return !pageType.areStateEqual(current.state, target.state);
}
}
}
return true;
},
_postSplashComplete: function _postSplashComplete() {
var that = this;
// Defer the work that can happen after the splash has disappeared and the UI thread
// has had a chance to do some other work.
setTimeout(function processManager_postSplashTimeout() {
msWriteProfilerMark("Platform:PostSplashComplete:s");
Windows.Storage.ApplicationData.current.localSettings.values.insert("currentAppVersion", PlatformJS.Services.process.getAppVersionString());
// Check network status
CommonJS.NetworkIndicator.statusChange();
if (!that._postActiveComplete) {
// Perform platform post activate work only if not already performed.
PlatformJS.Services.process.startPostActivateWork();
that._postActiveComplete = true;                         
}
// Perform any app specific post activate work
for (var i = 0; i < that._processListeners.length; i++) {
if (that._processListeners[i].startPostActivateWork) {
that._processListeners[i].startPostActivateWork();
}
}
CommonJS.Settings.showMarketNotification();
CommonJS.NetworkIndicator.checkNetworkState();
msWriteProfilerMark("Platform:PostSplashComplete:e");
}, 1000);
},
_showConfigurationChangedDialog: function _showConfigurationChangedDialog(eventName, obj) {
// TODO
},
_showCredentialUI: function _showCredentialUI(eventName, obj) {
// Set up the options
var credUI = Windows.Security.Credentials.UI;
var options = new credUI.CredentialPickerOptions();
options.message = CommonJS.resourceLoader.getString("/platform/credentialMessage").format(obj.message);
options.caption = CommonJS.getAppName(); // This is either resource "AppTitle" or "/platform/AppTitle" if the first doesn't exist
options.targetName = obj.message;
options.authenticationProtocol = obj.code;
// Get credentials from user
credUI.CredentialPicker.pickAsync(options).then(
function processManager_pickAsyncComplete(credential) {
Platform.QueryService.onCredentialUIComplete(credential, obj.message, obj.code);
},
function processManager_pickAsyncError(error) {
// Something went wrong. Unblock the network requests so they can try again
Platform.QueryService.onCredentialUIComplete(null, obj.message, obj.code);
});
},
_overrideWinJSGetString: function _overrideWinJSGetString() {
// Replace the WinJS getString function with a custom implementation
// that uses the platform string resource loader
WinJS.Resources.getString = function (resourceId) {
var resourceValue = Platform.ServicesAccessor.resourceLoader.getValue(resourceId);
return { value: resourceValue.value, lang: resourceValue.language };
};
},
_onBadId: function _onBadId(eventName, obj) {
// Need to download a new configuration
Platform.Process.instance.onBadIdAsync();
},
_handleFirstNetworkCallSuspended: function _handleFirstNetworkCallSuspended(eventName, obj) {
CommonJS.Progress.destroySplash(true);
},
_errorShownByPlatform: false,
_handleNetworkSuspendMessaging: function _handleNetworkSuspendMessaging(eventName, obj) {
if (this._errorShownByPlatform) {
return;
}
this._errorShownByPlatform = true;
switch (obj.code) {
case Platform.DataServices.QueryServiceMessaging.large:
CommonJS.Error.showError(CommonJS.Error.NO_INTERNET, null, null, true);
break;
case Platform.DataServices.QueryServiceMessaging.small:
if (!CommonJS.messageBar && !CommonJS.Error._errorControl) {
var messageBar = new CommonJS.MessageBar(PlatformJS.Services.resourceLoader.getString("/platform/noInternetTitle") + " " + PlatformJS.Services.resourceLoader.getString("/platform/noInternetDescription"), { autoHide: true });
messageBar.show();
}
break;
}
},
_handleNetworkResumeMessaging: function _handleNetworkResumeMessaging(eventName, obj) {
if (!this._errorShownByPlatform) {
return;
}
this._errorShownByPlatform = false;
switch (obj.code) {
case Platform.DataServices.QueryServiceMessaging.large:
CommonJS.Error.removeError(true);
break;
case Platform.DataServices.QueryServiceMessaging.small:
break;
}
},
_showVersionUI: function _showVersionUI(eventName, obj) {
if (obj.code === Platform.Utilities.VersionUpdateUIType.forcedUpdate) {
// show forceupdate UI
CommonJS.Update.showForceUpdate(obj.message);
}
},
_handle403Error: function _handle403Error(eventName, obj) {
var allowList = PlatformJS.Services.configuration.getList("DomainAllowList403");
if (allowList) {
var uri = null;
try {
uri = new Windows.Foundation.Uri(obj.message);
}
catch (e) {
}
if (uri) {
var matchFound = false;
for (var i = 0; i < allowList.size; i++) {
var urlString = allowList[i];
// try converting the allowlist value to a Uri
try {
var listUri = new Windows.Foundation.Uri(urlString.value);
// match the host and the path
if (listUri.host.toLowerCase() === uri.host.toLowerCase()
&& listUri.path.toLowerCase() === uri.path.toLowerCase()) {
matchFound = true;
break;
}
}
catch (e) { }
}
if (matchFound && !Platform.Configuration.ConfigurationManager.instance.isEmbargoed) {
// set a variable so the app will know that we are now blocked
Platform.Configuration.ConfigurationManager.instance.isEmbargoed = true;
CommonJS.Error.showMarketError();
}
}
}
},
_onOrientationChange: function _onOrientationChange(event) {
/// <summary>
/// Handles orientation change event
/// </summary>
/// <param name="event">
/// Orientation change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
for (var i = 0; i < this._processListeners.length; i++) {
if (this._processListeners[i].onOrientationChange) {
this._processListeners[i].onOrientationChange(event);
}
}
// Instrumentation - Capture View State - Windows.UI.ViewManagement.ApplicationViewState
PlatformJS.Services.instrumentation.incrementInt32Array(
Platform.Instrumentation.InstrumentationDataSetId.platform,
Platform.Instrumentation.InstrumentationDataPointId.layoutChangeCount,
Windows.UI.ViewManagement.ApplicationView.value, 4, 1);
},
_onDpiChange: function _onDpiChange(event) {
/// <summary>
/// Handles dpi change event ("Make everything on your screen bigger" setting)
/// </summary>
/// <param name="event">
/// Dpi change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
for (var i = 0; i < this._processListeners.length; i++) {
if (this._processListeners[i].onDpiChange) {
this._processListeners[i].onDpiChange(event);
}
}
},
_onVisibilityChange: function _onVisibilityChange(event) {
/// <summary>
/// Handles visibility change event
/// </summary>
/// <param name="event">
/// Visibility change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
PlatformJS.Services.process.onVisibilityChange(document.msHidden);
for (var i = 0; i < this._processListeners.length; i++) {
if (this._processListeners[i].onVisibilityChange) {
this._processListeners[i].onVisibilityChange(event);
}
}
// If a market update was detected, we close the app instead of sending the app to the background
if (Platform.Globalization.Marketization.hasPendingUpdate && document.msVisibilityState === "hidden") {
// Save all state by simulating a suspend event. Note that on a real suspend event the parameter is not null.
this._onSuspending(null);
PlatformJS.Services.platformEventSource.traceInfo("A market update was detected. Closing app.");
Platform.Process.exitApplication();
}
// If the current market has been determined to be embargoed, we close the app instead of sending the app to the background
if (Platform.Configuration.ConfigurationManager.instance.isEmbargoed && document.msVisibilityState === "hidden") {
// Save all state by simulating a suspend event. Note that on a real suspend event the parameter is not null.
this._onSuspending(null);
PlatformJS.Services.platformEventSource.traceInfo("Embargoed country/region detected. Closing app.");
Platform.Process.exitApplication();
}
}
}),
initialize: function initialize() {
/// <summary>
/// Do initialization of app
/// </summary>
/// <returns>
/// Nothing
/// </returns>
WinJS.Binding.optimizeBindingReferences = true;
PlatformJS.isDebug = Platform.Process.isDebug();
if (Windows.Storage.ApplicationData.current.localSettings.values["etw_logging"]) {
var newFile = Windows.Storage.ApplicationData.current.localSettings.values["etw_logging_newFile"];
Platform.Diagnostics.EventTraceSession.startTraceSession(newFile);
}
msWriteProfilerMark("Platform:Initialize:s");
if (!PlatformJS.mainProcessManager) {
PlatformJS.mainProcessManager = new PlatformJS.ProcessManager();
}
msWriteProfilerMark("Platform:Initialize:e");
//this code is kept but commented out so that consumers can see how to attach to an event listener in C# for notifications
/* Platform.Notifications.instance.addEventListener("notificationreceived", function (type, content) {
content = null;
});*/
},
launchApp: function launchApp(launchParams) {
if (launchParams.appName) {
var appName = launchParams.appName.toLowerCase();
var appGuid = PlatformJS.Services.configuration.getDictionary("AppLauncher").getString(appName, "");
if (appGuid && appGuid.length > 0) {
var launchUrl = appGuid + ":";
if (launchParams.appPath) {
launchUrl += appPath;
}
if (launchParams.appParams) {
launchUrl += "?";
var firstParam = true;
for (var param in launchParams.appParams) {
if (!firstParam) {
launchUrl += "&";
}
launchUrl += param + "=" + encodeURIComponent(launchParams.appParams[param]);
firstParam = false;
}
}
try {
var uri = new Windows.Foundation.Uri(launchUrl);
Windows.System.Launcher.launchUriAsync(uri);
}
catch (e) {
}
}
}
},
getLaunchParams: function getLaunchParams(event) {
var args = {};
if (event.detail.kind === Windows.ApplicationModel.Activation.ActivationKind.protocol) {
if (event.detail.uri) {
var uriQuery = event.detail.uri.query;
if (uriQuery && uriQuery.length > 0) {
var queryStr = uriQuery.substring(1);  // remove the "?"
var params = queryStr.split("&");
for (var i = 0; i < params.length; i++) {
var kv = params[i];
var pair = kv.split("=");
if (pair.length === 2) {
pair[1] = pair[1].replace(/\+/g, " ");
args[pair[0]] = decodeURIComponent(pair[1]);
}
}
}
}
}
return args;
}
});
})();
(function appexPlatformWindowSizeManagerInit(WinJS) {
'use strict';
Platform.Process.perfTrackWriteStartEvent(Platform.PerfTrackScenarioId.launch, "App Launch", null);
var NS = WinJS.Namespace.define("PlatformJS", {
WindowSizeManager: WinJS.Class.define(function windowSizeManager_ctor() {
// initialize default viewState
this._lastViewState = Windows.UI.ViewManagement.ApplicationView.value;
// register event handler
window.addEventListener("resize", this._onWindowResize.bind(this), false);
}, {
_lastViewState: null,
_onWindowResize: function _onWindowResize(event) {
var lastViewState = this._lastViewState;
var viewState = Windows.UI.ViewManagement.ApplicationView.value;
if (viewState !== lastViewState) {
if ((viewState === 3 && lastViewState !== 2) || (lastViewState === 3 && viewState !== 2)) {
this._lastViewState = viewState;
PlatformJS.mainProcessManager._onOrientationChange(event);
} else {
this._lastViewState = viewState;
var viewStateChangedArgs = {
detail: [{ viewState: viewState }],
type: "viewstatechanged",
viewState: viewState,
};
PlatformJS.mainProcessManager._onLayoutChange(viewStateChangedArgs);
}
}
else {
PlatformJS.mainProcessManager._onWindowResize(event);
}
}
}),
DpiChangeManager: WinJS.Class.define(function dpiChangeManager_ctor() {
Windows.Graphics.Display.DisplayProperties.addEventListener("logicaldpichanged", this._onLogicalDpiChanged.bind(this));
}, {
_onLogicalDpiChanged: function _onLogicalDpiChanged(event) {
PlatformJS.mainProcessManager._onDpiChange(event);
}
}),
CrashReporterProxy: WinJS.Class.define(function crashReporterProxy_ctor() {
var crashReporter = this._reporter = (Platform.CrashReporting && Platform.CrashReporting.CrashReport) ? Platform.CrashReporting.CrashReport.instance : null;
if (crashReporter) {
WinJS.Application.onerror = this._onApplicationError.bind(this);
WinJS.Navigation.addEventListener("navigating", this._onNavigating.bind(this));
document.addEventListener("click", this._onUserAction.bind(this));
}
}, {
// private variables
_reporter: null,
_onUserAction: function _onUserAction(evt) {
this._reporter.addUserActionHistory("nodeName:\"" + evt.target.nodeName + "\", className:\"" + evt.target.className + "\", X:" + evt.x + " Y:" + evt.y + "\ninnerText: " + evt.target.innerText + "\n");
},
_onNavigating: function _onNavigating(eventInfo) {
var curr = WinJS.Navigation.history.current;
this._reporter.addNavHistory("location:" + JSON.stringify(curr.location) + "\nstate:" + JSON.stringify(curr.state));
},
//Previous version of onPromiseError and onWindowError are now integrated into one. Use detail exception to tell
_onApplicationError: function _onApplicationError(eventInfo) {
var detail = eventInfo.detail;
if (detail) {
var msg = "", stack = "", extraInfo = CommonJS.Version ? "CommonJS Version: " + CommonJS.Version + "\n" : "";
if (detail.exception) {
msg = detail.exception.message ? detail.exception.message : detail.exception;
stack = detail.exception.stack;
} else if (detail.error) {
//This error might not crash the app but we still want to send out a report.
if (detail.error[0]) {
msg = detail.error[0].message;
stack = detail.error[0].name;
} else {
msg = detail.error.message;
stack = detail.error.stack ? detail.error.stack : detail.error.filename + " : " + detail.error.lineno;
}
} else if (detail.stack) {
msg = detail.description;
stack = detail.stack;
} else if (detail.errorMessage) {
msg = detail.errorMessage;
stack = detail.errorUrl + ": " + detail.errorLine;
}
try {
extraInfo += JSON.stringify(detail);
} catch (e) { }
this._reporter.sendCrashInfo(msg, stack, extraInfo);
}
return false;
},
}),
FramesPerSecondIndicator: WinJS.Class.define(function framesPerSecondIndicator_ctor(element) {
this._delegate = this._measureFramesPerSecond.bind(this);
this._element = element;
}, {
_element: null,
_running: false,
_lastMeasure: 0,
_frameCounter: 0,
_delegate: null,
start: function start() {
this._running = true;
this._measureFramesPerSecond();
},
stop: function stop() {
this._running = false;
},
_measureFramesPerSecond: function _measureFramesPerSecond() {
var now = new Date().getTime() % 1000;
if (now < this._lastMeasure) {
this._element.innerText = this._frameCounter + "fps";
this._frameCounter = 0;
}
this._frameCounter += 1;
this._lastMeasure = now;
if (this._running) {
msRequestAnimationFrame(this._delegate);
}
},
}),
UIDelayIndicator: WinJS.Class.define(function uiDelayIndicator_ctor(element) {
this._delegate = this._measureUIDelays.bind(this);
this._element = element;
}, {
_element: null,
_running: false,
_lastMarker: 0,
_maximumDelay: null,
_delegate: null,
start: function start() {
this._running = true;
this._measureUIDelays();
},
stop: function stop() {
this._running = false;
},
_measureUIDelays: function _measureUIDelays() {
var now = new Date().getTime();
if (this._lastMarker !== 0) {
var delay = (now - this._lastMarker);
if (delay > this._maximumDelay) {
this._maximumDelay = delay;
this._element.innerText = delay + "ms";
}
}
this._lastMarker = now;
msRequestAnimationFrame(this._delegate);
},
}),
});
// Add the activated event listener
WinJS.Application.addEventListener("activated", function uiDelayIndicator_onActivated(event) {
if (PlatformJS.isDebug) {
var perfIndicatorElement = document.createElement("div");
var fpsIndicatorElement = document.createElement("span");
var delayIndicatorElement = document.createElement("span");
WinJS.Utilities.addClass(perfIndicatorElement, "platformPerformanceIndicator");
perfIndicatorElement.appendChild(fpsIndicatorElement);
perfIndicatorElement.appendChild(delayIndicatorElement);
var framesPerSecondIndicator = new NS.FramesPerSecondIndicator(fpsIndicatorElement);
framesPerSecondIndicator.start();
var delayIndicator = new NS.UIDelayIndicator(delayIndicatorElement);
delayIndicator.start();
document.body.appendChild(perfIndicatorElement);
}
});
})(WinJS);
(function appexPlatformServicesOnDemandLoaderInit(global) {
'use strict';
function importScripts(files) {
if (!files) {
return;
}
files = files.constructor === Array ? files : [files];
files.forEach(function (file) {
var script = document.createElement("script");
script.src = file;
script.defer = false;
document.head.appendChild(script);
});
}
function importCSS(files) {
if (!files) {
return;
}
files = files.constructor === Array ? files : [files];
files.forEach(function (file) {
var link = document.createElement("link");
link.rel = "stylesheet";
link.href = file;
document.head.appendChild(link);
});
}
function importDepObjs(deps) {
if (!deps) {
return;
}
deps = deps.constructor === Array ? deps : [deps];
deps.forEach(function (obj) {
getDeepObject(global, obj);
});
}
function getDeepObject(obj, key) {
if (!key) {
return obj;
}
if (typeof key === 'string') {
key = key.split(".");
}
key.forEach(function (k) { obj = obj && obj[k]; });
return obj;
}
function onDemandLoader(objPath, jsFiles, cssFiles, deps) {
var splitted = objPath.split(".");
var className = splitted.pop();
var namespace = splitted.join(".");
var classDef = {};
var loadingInProgress = false;
var loadInfo = {
js: jsFiles,
css: cssFiles,
deps: deps,
};
var namespaceObj = getDeepObject(global, splitted);
if (!namespaceObj) {
namespaceObj = WinJS.Namespace.define(namespace, {});
}
if (namespaceObj[className]) {
return namespaceObj[className];
}
classDef[className] = {
get: (function (namespaceObj, className, loadInfo) {
importDepObjs(loadInfo.deps);
if (loadingInProgress) {
return null;
}
loadingInProgress = true;
/* namespaceObj[className] shoots off another "Getter" before its deleted
* Hence we need to stop the infinite recursion with a flag (loadingInProgress)
*/
delete namespaceObj[className];
loadingInProgress = false;
importScripts(loadInfo.js);
importCSS(loadInfo.css);
return namespaceObj[className];
}).bind(null, namespaceObj, className, loadInfo),
configurable: true,
set: (function (namespaceObj, className, value) {
loadingInProgress = true;
delete namespaceObj[className];
loadingInProgress = false;
namespaceObj[className] = value;
}).bind(null, namespaceObj, className),
};
WinJS.Namespace.define(namespace, classDef);
}
PlatformJS.onDemandLoader = onDemandLoader;
})(this);
