﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: SlideshowCluster.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function appexCommonControlsSlideshowClusterInit (WinJS) {
"use strict";
var RENDER_COMPLETE = "rendercomplete";
var Slideshow = WinJS.Namespace.define("CommonJS.Slideshow",
{
ClusterMode: {
static: "static",
dynamic: "dynamic"
},
SlideshowCluster: WinJS.Class.define(function slideshowCluster_ctor (domElement, options) {
// ctor
var that = this;
domElement.winControl = this;
this._domElement = domElement;
// register itemclick event
domElement.addEventListener("click", CommonJS.Utils.itemClickProxy(this));
Object.defineProperties(this, WinJS.Utilities.createEventProperties("itemclick"));
// register rendercomplete event
Object.defineProperties(this, WinJS.Utilities.createEventProperties(RENDER_COMPLETE));
// null check template (options)
if (!options.template) {
// TODO: fill out default template information
// [BEGIN]
options.template = {
fragmentPath: "/Common/Slideshow/html/ImageModuleTemplates.html",
id: "square"
};
// [END]
}
// null check view (options)
var viewInfo = options.viewInfo;
if (!viewInfo) {
viewInfo = {
type: "CommonJS.GridClusterView",
options: {
mode: CommonJS.GridClusterView.Mode.Uniform,
template: options.template
}
};
}
// create the view
this.view = PlatformJS.Utilities.createObject(viewInfo.type, viewInfo.options);
// null check provider view (options)
if (options.mode === Slideshow.ClusterMode.dynamic && !options.provider) {
options.provider = new CommonJS.SlideShowProvider();
}
// set options
WinJS.UI.setOptions(this, options);
this.invalidate();
},
{
// declare null aliases for auto-complete to work
_domElement: null,
onitemclick: null,
onrendercomplete: null,
view: null,
mode: null,
provider: null,
/// <summary>
/// Invalidates the Slideshow cluster by querying the provider and binding the resulting data to the view.
/// </summary>
invalidate: function invalidate() {
var that = this;
var view = this.view;
var domElement = this._domElement;
var mode = this.mode;
var dataSet = this.dataSet || [];
var getSlideshowImages = (mode === Slideshow.ClusterMode.dynamic) ?
this._queryProviderAsync() : WinJS.Promise.wrap(dataSet);
getSlideshowImages
.then(function slideshowCluster_getSlideshowImagesComplete (response) {
// release provider instance (managed CLR object)
// JSCop Note: not sure if delete has the same semantics as
// setting to null, so leaving it as delete for now.
/// <disable>JS2078.DoNotDeleteObjectProperties</disable>
delete that.provider;
/// <enable>JS2078.DoNotDeleteObjectProperties</enable>
// bind resulting set
return view.render(domElement, { items: response });
})
.then(function slideshowCluster_viewRenderComplete () {
return that.dispatchEvent(RENDER_COMPLETE);
});
},
_queryProviderAsync: function _queryProviderAsync() {
var that = this;
var provider = this.provider;
var config = PlatformJS.Collections.createStringDictionary();
var imageType;
// get config from options
config.insert("slideshowId", that.slideshowId);
config.insert("market", Platform.Utilities.Globalization.getCurrentMarket());
// image type to prefetch for cluster
return provider.initializeAsync(config)
.then(function slideshowCluster_providerInitializeAsyncComplete (result) {
return provider.queryAsync(0, 100);
})
.then(function slideshowCluster_providerQueryAsyncComplete (response) {
var output = [];
for (var i = 0, max = response.slides.length; i < max; i++) {
var slide = response.slides[i];
var height;
var width;
var image = slide.thumbnail; // image
height = image.height;
width = image.width;
output.push({
index: i,
url: image.url,
width: width < height ? "100%" : "auto",
height: height < width ? "100%" : "auto",
});
}
return WinJS.Promise.wrap(output);
});
}
})
});
WinJS.Class.mix(Slideshow.SlideshowCluster, WinJS.UI.DOMEventMixin);
})(WinJS);
/* File: SlideshowControl.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function appexCommonControlsSlideshowControlInit() {
"use strict";
var STRINGS = {
PLAY: CommonJS.resourceLoader.getString("/Common/Play") || "Play",
PAUSE: CommonJS.resourceLoader.getString("/Common/Pause") || "Pause",
SLIDESHOW: CommonJS.resourceLoader.getString("/Common/Slideshow") || "Slideshow",
SLIDE: CommonJS.resourceLoader.getString("/Common/Slide") || "Image"
};
var slideshow = WinJS.Namespace.define("CommonJS.Slideshow", {
ImageCard: WinJS.Class.define(function imageCard_ctor(element, options) {
element = element || document.createElement("div");
element.winControl = this;
this._zoomInEnabled = true;
WinJS.UI.setOptions(this, options);
this._init(element);
this._fetchImage(this._showPlaceholder.bind(this));
},
{
cropImage: {
get: function get() {
return this._crop;
},
set: function set(value) {
this._crop = value;
}
},
showErrorInfo: {
get: function get() {
return this._showErrorInfo;
},
set: function set(v) {
this._showErrorInfo = v;
}
},
fill: {
get: function get() {
return this._fill;
},
set: function set(v) {
this._fill = v;
}
},
zoomInEnabled: {
get: function get() {
return this._zoomInEnabled;
},
set: function set(v) {
this._zoomInEnabled = v;
}
},
pageIndex: {
get: function get() {
return this._pageIndex;
},
set: function set(v) {
this._pageIndex = v;
}
},
alternateText: {
get: function get() {
return this._alternateText;
},
set: function set(value) {
this._alternateText = value;
}
},
imageSource: {
set: function set(value) {
if (typeof value === "string") {
this._imageCardUrl = value;
} else {
this._imageCardUrl = value.url;
this._cacheId = value.cacheId;
this._width = value.width;
this._height = value.height;
}
}
},
_init: function _init(element) {
this._domElement = element;
if (this.alternateText) {
this._domElement.setAttribute("aria-label", this.alternateText);
}
// Create the image element
this._imgElementDiv = document.createElement("div");
this._imgElement = document.createElement("img");
WinJS.Utilities.addClass(this._imgElementDiv, "platformImageCardImage platformHide");
WinJS.Utilities.addClass(this._imgElement, "ssImage");
this._imgElementDiv.appendChild(this._imgElement);
if (this.zoomInEnabled) {
this.initializeOpticalZoom();
}
// placeholder image
var placeholderElement = this._placeholderElement = document.createElement("div");
WinJS.Utilities.addClass(placeholderElement, "platformImageCardPlaceholder");
this._domElement.appendChild(placeholderElement);
// icon element
var iconElement = document.createElement("div");
WinJS.Utilities.addClass(iconElement, "platformImageCardPlaceholderIcon platformCameraIcon");
placeholderElement.appendChild(iconElement);
this._iconElement = iconElement;
// progress element
var progressElement = document.createElement("progress");
WinJS.Utilities.addClass(progressElement, "platformImageCardPlaceholderProgress win-ring");
placeholderElement.appendChild(progressElement);
this._progressElement = progressElement;
placeholderElement.appendChild(progressElement);
// show progress in placeholder initially
this._showPlaceholder();
this._domElement.appendChild(this._imgElementDiv);
WinJS.Utilities.addClass(this._domElement, "platformPlaceHolderMedium");
},
// Setting up optical zoom support
initializeOpticalZoom: function initializeOpticalZoom() {
this._imgElementDiv.addEventListener("wheel", this._handleWheel.bind(this));
var zoomedInElement = document.querySelector(".ssZoomIn");
if (zoomedInElement){
this._ssZoomedInView = zoomedInElement.winControl;
}
},
handleKeyDown: function handleKeyDown(eventObject) {
if (!eventObject.ctrlKey) {
return;
}
// image not in view. no need to perform zooming operations.
if (WinJS.Utilities.hasClass(this._imgElementDiv, "platformHide")) {
return;
}
// No need to perform optical zoom, if the current state is zoomed out.
var semanticZoomControl = document.querySelector(".ssSemanticZoomDom");
if (semanticZoomControl && semanticZoomControl.winControl && semanticZoomControl.winControl.zoomedOut) {
return;
}
if (this._ssZoomedInView && this.pageIndex !== this._ssZoomedInView.currentPage) {
return;
}
var distance;
var Key = WinJS.Utilities.Key;
switch (eventObject.keyCode) {
case Key.add:
case Key.equal:
distance = 1;
break;
case Key.subtract:
case Key.dash:
distance = -1;
break;
default:
return;
}
distance = distance * this.zoomState.DistancePerKeystroke;
var x = 0.5 * window.innerWidth;
var y = 0.5 * window.innerHeight;
var processed = this._performZoom(distance, x, y);
if (processed) {
eventObject.stopPropagation();
eventObject.preventDefault();
}
},
_handleWheel: function _handleWheel(eventObject) {
if (!eventObject.ctrlKey || eventObject.deltaY === 0) {
return;
}
var distance = eventObject.deltaY * this.zoomState.DistancePerWheelDelta;
var x = eventObject.offsetX;
var y = eventObject.offsetY;
// if there are margins around the image, those need to be taken care of.
var tempElement = eventObject.srcElement;
while (tempElement && tempElement !== this._imgElementDiv) {
x += tempElement.offsetLeft;
y += tempElement.offsetTop;
tempElement = tempElement.parentNode;
}
this._performZoom(distance, x, y);
},
_currentZoomLevel: 1,
_performZoom: function _performZoom(distance, x, y) {
var container = this._imgElementDiv;
var currentZoomLevel = this._currentZoomLevel;
var minZoomLevel = this.zoomState.min;
var maxZoomLevel = this.zoomState.max;
if (!this.zoomInEnabled) {
return false;
}
if ((currentZoomLevel <= minZoomLevel && distance < 0) ||
(currentZoomLevel >= maxZoomLevel && distance > 0)) {
return false;
}
this._currentZoomLevel = currentZoomLevel = currentZoomLevel + distance;
if (currentZoomLevel < minZoomLevel) {
currentZoomLevel = minZoomLevel;
}
else if (currentZoomLevel > maxZoomLevel) {
currentZoomLevel = maxZoomLevel;
}
var zoString = x.toFixed() + "px " + y.toFixed() + "px";
container.style["transition-property"] = "-ms-transform";
container.style["transition-timing-function"] = "linear";
container.style["transform-origin"] = zoString;
container.style["transform"] = "scale(" + currentZoomLevel + ")";
return true;
},
resetZoom: function resetZoom() {
if (!this.zoomInEnabled) {
return;
}
var that = this;
setImmediate(function () {
var container = that._imgElementDiv;
// if the image was zoomed using mouse/keyboard
container.style["transition-property"] = "-ms-transform";
container.style["transform"] = "scale(1)";
that._currentZoomLevel = 1;
// if the image was zoomed-in using touch gesture
var zoomElement = container.parentNode;
if (zoomElement) {
zoomElement.msContentZoomFactor = 1;
}
});
},
/// <summary>
/// If the image is at the original size, it cannot (optical) zoom-out further.
/// </summary>
canZoomOut: function canZoomOut() {
return !(this._currentZoomLevel <= this.zoomState.min);
},
zoomState: {
min: 1,     // 100% of the image size
max: 5,     // 500% of the image size
DistancePerKeystroke: .25,
DistancePerWheelDelta: -.4 / (document.documentElement.clientHeight * .15),
},
_setImage: function _setImage(url) {
var that = this;
var img = that._imgElement;
img.src = url;
var container = this.container || this._domElement;
img.addEventListener("load", this._handleOnLoad.bind(this), false);
img.addEventListener("error", this._handleImageError.bind(this), false);
},
_showPlaceholder: function _showPlaceholder() {
this._toggleProgress(true);
this._toggleIcon(false);
// show the placeholder
this._togglePlaceholder(true);
},
_fetchImage: function _fetchImage(networkCallRequired) {
var that = this;
// Check to see if this is a local image
if (this._imageCardUrl.indexOf("/") !== 0) {
PlatformJS.Utilities.fetchImage(this._cacheId, this._imageCardUrl, networkCallRequired).then(function imageCard_fetchImageComplete(url) {
that._setImage(url);
}, function imageCard_fetchImageError(url) {
that._handleImageError(url);
});
} else if (this._imageCardUrl === "") {
that._handleImageError(null);
} else {
this._setImage(this._imageCardUrl);
}
},
_refresh: function _refresh() {
slideshow.Utilities.setInnerHtml(this._domElement, "");
this._init(this._domElement);
this._fetchImage(this._showPlaceholder.bind(this));
},
_handleImageError: function _handleImageError(err) {
var that = this;
// turn off progress ring
this._toggleProgress(false);
// turn on the camera icon
this._toggleIcon(true);
// turn on the placeholder
this._togglePlaceholder(true);
},
// methods
_toggleElement: function _toggleElement(element, show) {
/// <summary>
/// Shows or hides the given element.
/// </summary>
if (element) {
if (show) {
WinJS.Utilities.removeClass(element, "platformHide");
} else {
WinJS.Utilities.addClass(element, "platformHide");
}
}
},
_toggleProgress: function _toggleProgress(show) {
/// <summary>
/// Shows or hides the progress ring.
/// </summary>
this._toggleElement(this._progressElement, show);
},
_togglePlaceholder: function _togglePlaceholder(show) {
/// <summary>
/// Shows or hides the entire placeholder.
/// </summary>
this._toggleElement(this._placeholderElement, show);
},
_toggleIcon: function _toggleIcon(show) {
var placeholderImageElement = this._placeholderElement;
var that = this;
/// <summary>
/// Shows or hides the camera icon.
/// </summary>
if (show && that.showErrorInfo) {
var className = "ssError";
var domElement = placeholderImageElement.querySelector("." + className);
if (!domElement) {
domElement = document.createElement("div");
WinJS.Utilities.addClass(domElement, className);
placeholderImageElement.appendChild(domElement);
WinJS.Utilities.addClass(placeholderImageElement, className);
var retryFunction = WinJS.Utilities.markSupportedForProcessing(function imageCard_retryFunction(evt) {
that._refresh();
});
var data;
if (!PlatformJS.Utilities.hasInternetConnection()) {
data = CommonJS.Error.getErrorModuleItem(retryFunction, "450px", "100%", "/platform/offline_noContent", "platformOfflineErrorModule");
} else {
data = CommonJS.Error.getErrorModuleItem(retryFunction, "450px", "100%");
}
var moduleInfo = data.moduleInfo;
// create error container
var container = document.createElement("div");
container.style.width = moduleInfo.width;
container.style.height = moduleInfo.height;
slideshow.Utilities.setInnerHtml(domElement, "");
domElement.appendChild(container);
// render error module
CommonJS.loadModule(moduleInfo, data, container);
}
this._toggleElement(this._iconElement, false);
} else {
this._toggleElement(this._iconElement, show);
}
},
_removePlaceholderImage: function _removePlaceholderImage() {
this._domElement.removeChild(this._placeholderElement);
this._placeholderElement = null;
},
_handleOnLoad: function _handleOnLoad(e) {
var that = this;
WinJS.Utilities.addClass(that._imgElement, CommonJS.Slideshow.Constants.ssImageLoaded);
var alt = this.alternateText ? this.alternateText : STRINGS.SLIDE;
that._imgElement.setAttribute("alt", alt);
that._showImageOnload(e.srcElement);
},
autoAdjustImageSize: function autoAdjustImageSize(img, fill) {
var w = this._width ? this._width : img.naturalWidth,
h = this._height ? this._height : img.naturalHeight,
imgParentNode = img.parentNode,
container = (imgParentNode && imgParentNode.parentNode) ? imgParentNode.parentNode : null;
// image bigger than container
if (container && (fill || (w >= container.clientWidth || h >= container.clientHeight))) {
var newSize = this._calculateImageDisplaySize(w, h, container);
img.setAttribute("width", newSize.width);
img.setAttribute("height", newSize.height);
}
else {
img.setAttribute("width", w);
img.setAttribute("height", h);
}
},
_showImageOnload: function _showImageOnload(img) {
var that = this;
this.autoAdjustImageSize(img, that.fill);
u.removeClass(img.parentNode, "platformHide");
if (this._placeholderElement !== null) {
if (!WinJS.Utilities.hasClass(this._placeholderElement, "platformHide")) {
WinJS.UI.Animation.crossFade(img, this._placeholderElement).then(function imageCard_crossFadeComplete() {
that._removePlaceholderImage();
});
} else {
that._removePlaceholderImage();
}
}
},
circularManager: {
get: function get() {
return this._circularManager;
},
set: function set(v) {
this._circularManager = v;
}
},
pageId: {
get: function get() {
return this._pageId;
},
set: function set(v) {
this._pageId = v;
}
},
_cropImageOnload: function _cropImageOnload(img) {
u.removeClass(img.parentNode, "platformHide");
var loadPos = calcPos(img);
setImagePos(img, loadPos);
if (this._placeholderElement !== null) {
this._removePlaceholderImage();
}
function calcPos(imgElement) {
var container = imgElement.parentNode;
var cw = container.clientWidth, ch = container.clientHeight;
var imageW = imgElement.naturalWidth, imageH = imgElement.naturalHeight;
var ratio = cw / ch;
if (imageW / imageH < ratio) {
// keep width
var dispWidth = cw;
var dispHeight = imageH * (dispWidth / imageW);
return { left: 0, top: 0 - (dispHeight - ch) / 2, width: dispWidth, height: dispHeight };
} else {
var dispHeight1 = ch;
var dispWidth1 = imageW * (dispHeight1 / imageH);
return { left: 0 - (dispWidth1 - cw) / 2, top: 0, width: dispWidth1, height: dispHeight1 };
}
}
function setImagePos(imageElement, pos) {
imageElement.style.position = "relative";
imageElement.setAttribute("width", pos.width);
imageElement.setAttribute("height", pos.height);
imageElement.style.top = pos.top + "px";
imageElement.style.left = pos.left + "px";
}
},
_calculateImageDisplaySize: function _calculateImageDisplaySize(imageWidth, imageHeight, mainContainer) {
if (imageWidth && imageHeight && mainContainer) {
var width = 0;
var height = 0;
var containerWidth = mainContainer.clientWidth;
var containerHeight = mainContainer.clientHeight;
containerWidth = containerWidth > 0 ? containerWidth : 160;
containerHeight = containerHeight > 0 ? containerHeight : 160;
var imageRatio = imageWidth / imageHeight;
var containerRatio = containerWidth / containerHeight;
if (imageRatio > containerRatio) {
width = containerWidth;
height = width / imageRatio;
} else {
height = containerHeight;
width = height * imageRatio;
}
if (width === 190) {
debugger;
}
return { width: width + "px", height: height + "px" };
}
return { width: "auto", height: "auto" };
}
},
{
// Static methods
relayoutSlides: function relayoutSlides() {
var that = this;
var images = document.querySelectorAll(".ssImage");
for (var i = 0; i < images.length; i++) {
var img = images[i];
if (img.parentNode && img.parentNode.parentNode) {
var container = img.parentNode.parentNode;
var imageCard = container.winControl;
if (imageCard) {
imageCard.autoAdjustImageSize(img, imageCard.fill);
}
}
}
},
}),
Constants: {
ssImageLoaded: "ssImageLoaded",
},
Utilities: {
// Naeim to give me a function to return number of columns
// that I should devide the screen based on resolution.
getColumns: function getColumns() {
var state = Windows.UI.ViewManagement.ApplicationView.value;
if (state === Windows.UI.ViewManagement.ApplicationViewState.snapped) {
return 1;
} else if (state === Windows.UI.ViewManagement.ApplicationViewState.fullScreenPortrait) {
return 2;
} else {
return 4;
}
},
setInnerHtml: function setInnerHtml(elem, html) {
if (html) {
WinJS.Utilities.setInnerHTML(elem, toStaticHTML(html));
} else {
elem.innerText = "";
}
},
clickInfoArea: function clickInfoArea(evt) {
// Do not toggle info block if retry button is clicked
if (evt.srcElement && WinJS.Utilities.hasClass(evt.srcElement, "platformRetryButton")) {
return true;
}
var hitTargets = document.msElementsFromPoint(evt.clientX, evt.clientY);
if (hitTargets) {
// get elements from point
for (var i = 0, len = hitTargets.length; i < len; i++) {
var item = hitTargets[i];
if (WinJS.Utilities.hasClass(item, "win-navbutton") ||
WinJS.Utilities.hasClass(item, "ssMediaOverlay") ||
WinJS.Utilities.hasClass(item, "win-semanticzoom-button") ||
WinJS.Utilities.hasClass(item, "ssAttribution")) {
return true;
}
}
}
return false;
},
clickBlock: function clickBlock(evt, className) {
var hitTargets = document.msElementsFromPoint(evt.clientX, evt.clientY);
if (hitTargets) {
// get elements from point
for (var i = 0, len = hitTargets.length; i < len; i++) {
if (WinJS.Utilities.hasClass(hitTargets[i], className)) {
return true;
}
}
}
return false;
},
clickFlyoutArea: function clickFlyoutArea(evt) {
var hitTargets = document.msElementsFromPoint(evt.clientX, evt.clientY);
if (hitTargets) {
// get elements from point
for (var i = 0, len = hitTargets.length; i < len; i++) {
if (hitTargets[i].className.indexOf("platformFlyoutOuterContainer") !== -1) {
return true;
}
}
}
return false;
}
}
});
var u = WinJS.Utilities;
var s = WinJS.Namespace.define("CommonJS", {
SlideshowControl: WinJS.Class.define(function slideshowControl_ctor(element, options) {
this.element = element || document.createElement("div");
this.element.winControl = this;
this.options = options;
// Create the DOM elements
u.addClass(this.element, "slideView");
// should pass in as option, otherwise, no cache used
// Attaching JS control to DOM element
this._canvas = document.createElement("div");
this._canvas.setAttribute("aria-label", STRINGS.SLIDESHOW);
this.element.appendChild(this._canvas);
this._canvas.className = "viewPort";
this.semanticZoomDom = document.createElement("div");
WinJS.Utilities.addClass(this.semanticZoomDom, "ssSemanticZoomDom");
this.zoomInDom = document.createElement("div");
WinJS.Utilities.addClass(this.zoomInDom, "ssZoomIn");
WinJS.Utilities.addClass(this.zoomInDom, "platformParallaxImageViewport");
this.zoomOutDom = document.createElement("div");
WinJS.Utilities.addClass(this.zoomOutDom, "ssZoomOut");
// Add the semantic zoom dom
this._canvas.appendChild(this.semanticZoomDom);
// Add the two list view doms
this.semanticZoomDom.appendChild(this.zoomInDom);
this.semanticZoomDom.appendChild(this.zoomOutDom);
this._createHeader(this.element);
WinJS.UI.setOptions(this, options);
},
{
_instrDataSetID: 8,
// corresponds to 'ab' in slideshow dataset.
_instSlideshowViewDataPointID: 25185,
cacheId: {
get: function get() {
return this._cacheId;
},
set: function set(v) {
this._cacheId = v;
}
},
startIndex: {
get: function get() {
return this.options.startIndex;
},
set: function set(value) {
this.options.startIndex = value;
}
},
currentPage: {
get: function get() {
if (this._zoomedInItem) {
return this._zoomedInItem.currentPage;
} else {
return this.options.startIndex;
}
}
},
dataOptions: {
set: function set(v) {
this._config = v.config;
this._provider = v.provider;
this._initData();
}
},
_createHeader: function _createHeader(container) {
var h = document.createElement("div");
container.appendChild(h);
this.header = new CommonJS.Immersive.Header(h);
},
_instrumentationSlideshow: function _instrumentationSlideshow(slideshowId, instrumentationId) {
//note: previous insturmentation string: str = slideshowId + "*" + instrumentationId + "*";
//note this.instrumentationEntryPoint used to identify if it is from partnerPano
var title = this._zoomedInItem ? this._zoomedInItem.title : "";
var authorPublisherInfo = "";
var attrList = document.getElementsByClassName("ssAttr");
if (attrList && attrList[0]) {
authorPublisherInfo = attrList[0].innerText;
}
var instrIndex = PlatformJS.Navigation.mainNavigator.getCurrentImpression().addContent(
authorPublisherInfo,              // sourceName
instrumentationId,                // partnerCode
slideshowId,                      // contentId
"slideshow",                      // type
new Date(0),                      // date
null,                             // uri
title,                            // slug
false,                            // isSummary
null,                             // worth
false,                            // isAd
null                              // adCampaign
);
//NOTE: per ask, we need to log two events: addContent() and ContentviewProgress()
PlatformJS.Navigation.mainNavigator.getCurrentImpression().logContentView(
Platform.Telemetry.LogLevel.normal,                 //level,
instrIndex,                                         //k,
Platform.Telemetry.ContentViewMechanism.unknown,    //viewMechanism,
true,                                               //logOnlyIfNotViewed,
null                                                //progress
);
},
_initData: function _initData() {
var that = this;
function handleError(err) {
// TODO: handle errors
that.destroySplash();
var code = PlatformJS.Utilities.getPlatformErrorCode(err);
// range 100-199 is query service / connectivity exceptions
// 102 only per service exception code
var errorCode = PlatformJS.Utilities.checkOfflineErrorCode(code);
CommonJS.Error.showError(errorCode, function slideshowControl_initDataShowError(evt) {
CommonJS.forceRefresh();
});
}
var provider = this.provider;
var config = this.config;
if (!provider) {
debugger; // programmer error. should not happen.
} else {
// get json data array
that.initializeSplash();
provider.initializeAsync(config).then(
function slideshowControl_providerInitializeAsyncComplete(success) {
provider.queryAsync(0, -1).then(function slideshowControl_providerQueryAsyncComplete(result) {
that.destroySplash();
that.data = (result);
// Slideshow instrumentation logging
if (result) {
var slideshowId = "";
var instrumentationId = "";
if (provider.slideshowId) {
slideshowId = provider.slideshowId;
}
if (result.instrumentationId) {
instrumentationId = result.instrumentationId;
}
that._instrumentationSlideshow.bind(that)(slideshowId, instrumentationId);
}
}, handleError);
}, handleError);
}
},
provider: {
get: function get() {
return this._provider;
}
},
config: {
get: function get() {
return this._config;
}
},
data: {
get: function get() {
return this._data;
},
set: function set(r) {
if (r && r.slides) {
this._data = r.slides;
this.options.title = r.title;
this.options.desc = r.desc;
this.options.byline = r.byline;
this.options.version = r.version;
if (r.additionalButtons && r.additionalButtons.length > 0) {
this.options.additionalButtons = r.additionalButtons;
}
}
this.refresh();
}
},
smDataSource: {
get: function get() {
if (!this._smDS) {
var slides = [];
var rawData = this.data;
for (var i = 0, len = rawData.length; i < len; i++) {
var dataItem = rawData[i];
slides.push({ key: "r" + i, data: dataItem, itemOffset: i, uniqueID: i });
}
var itemsList = new WinJS.Binding.List(slides);
var charPostfix = "A";
// Create the groups for the ListView from the item data and the grouping functions
var groupedItemsList = itemsList.createGrouped(function slideshowControl_createdGroup(item) {
if (item) {
return item.itemOffset + charPostfix;
}
return charPostfix;
},
function slideshowControl_groupItem(item) {
return item;
},
function slideshowControl_groupCompare(l, r) {
return 0;
});
this._smDS = groupedItemsList;
}
return this._smDS;
}
},
refresh: function refresh() {
var that = this;
if (!this.data) {
return;
}
// Create the zoomed in list view
this._zoomedInItem = new CommonJS.SlideshowControlBase(this.zoomInDom, this.options, this.data.length);
// Create the zoomed out listview
var zoomOutOptions = { selectionMode: "none", crossSlide: "none" };
zoomOutOptions.itemDataSource = this.smDataSource.groups.dataSource;
this._zoomedOutItem = new WinJS.UI.ListView(this.zoomOutDom, zoomOutOptions);
this._zoomedOutItem.itemTemplate = this.semanticZoomRenderer.bind(this);
// Create the semantic zoom control
this._semanticZoom = new WinJS.UI.SemanticZoom(this.semanticZoomDom);
// This function sets focus on the flipview container after exiting zoomed-out view,
// so that keyboard navigation works on the flipview
function setFocusOnFlipContainer(event) {
if (!that._semanticZoom.zoomedOut) {
var flipContainer = that.zoomInDom.querySelector(".flipContainer");
if (flipContainer) {
flipContainer.focus();
}
}
};
this._semanticZoom.addEventListener("zoomchanged", setFocusOnFlipContainer);
this._zoomedInItem.smDataSource = this.smDataSource;
setFocusOnFlipContainer();
},
semanticZoom: {
get: function get() {
return this._semanticZoom;
}
},
semanticZoomRenderer: function semanticZoomRenderer(itemPromise) {
var that = this;
return {
element: itemPromise.then(function slideshowControl_semanticZoomRendererItemPromiseComplete(item) {
var d = document.createElement("div");
d.setAttribute("aria-label", STRINGS.SLIDE + " " + item.index);
WinJS.Utilities.addClass(d, "ssZoomedOutTemplate");
//prevent crash when the feed has invalid data
if (item.data && item.data.data && item.data.data.thumbnail) {
var imageCard = new CommonJS.Slideshow.ImageCard(d, {
imageSource: {
url: item.data.data.thumbnail.url,
cacheId: that.cacheId,
width: item.data.data.thumbnail.width,
height: item.data.data.thumbnail.height
},
alternateText: item.data.data.altText,
fill: true,
zoomInEnabled: false
});
}
return d;
})
};
},
initializeSplash: function initializeSplash() {
CommonJS.Progress.showProgress(CommonJS.Progress.centerProgressType);
},
destroySplash: function destroySplash() {
CommonJS.Progress.hideProgress(CommonJS.Progress.centerProgressType);
// This call will ensure any one time work is run such as the splash screen dismissal
// only if this control was loaded as the initial startup page.
PlatformJS.mainProcessManager.afterFirstView();
},
/// <field>Show the current entity</field>
showEntityForIndex: function showEntityForIndex(index) {
this._zoomedInItem.showEntityForIndex(index);
},
},
{
MediaBlockPosition: {
topLeft: 0,
topRight: 1,
bottomLeft: 2,
bottomRight: 3
},
MediaBlockColumnSpan: {
one: 0,
two: 1
}
}),
SlideshowControlBase: WinJS.Class.define(function slideshowControlBase_ctor(element, options, count) {
options = options || {};
this._options = options;
this._domElement = element;
this._domElement.winControl = this;
this._slideCount = count;
this._slideInterval = 5000;
this._crop = true,
this._infoShown = true;
this._changeHandled = false;
this._playbackMode = false;
this._additionalButtons = null;
WinJS.UI.setOptions(this, options);
this._domElement.onresize = this._onLayoutUpdated.bind(this);
},
{
// private variables
_isZoomedOut: null,
_additionalButtons:null,
_triggerZoom: null,
_selectedIndex: null,
_headerShownFlag: false,
zoomableView: {
get: function get() {
return this;
}
},
// IZoomable begins
beginZoom: function beginZoom() {
this._selectedIndex = this._ssControl.currentPage;
},
configureForZoom: function configureForZoom(isZoomedOut, isCurrentView, triggerZoom, prefectchedPages) {
this._isZoomedOut = isZoomedOut;
this._triggerZoom = triggerZoom;
},
endZoom: function endZoom(isCurrentView, setFocus) {
var selectedIndex = this._selectedIndex;
if (selectedIndex) {
this._ssControl.currentPage = (selectedIndex);
this._infoShown = this._infoShownFlag;
}
},
getCurrentItem: function getCurrentItem() {
// zoom out start
// force header always shown
this._headerShownFlag = true;
var header = document.querySelector(".immersiveHeader");
if (header) {
header.style.visibility = "visible";
}
var dataSource = this.smDataSource.dataSource;
var binding = dataSource.createListBinding();
return binding.fromIndex(this._ssControl.currentPage)
.then(function slideshowControlBase_getCurrentItemFromIndexComplete(listItem) {
return WinJS.Promise.wrap({
item: listItem,
position: {
left: 0,
top: 0,
width: 100,
height: 100
}
});
});
},
getPanAxis: function getPanAxis() { return "horizontal"; },
handlePointer: function handlePointer(pointerId) {
// HACK: We cannot ste the pointer capture on the viewport without
//      accessing a private variable of panel's.  how should this
//      be handled?
// [BEGIN]
// var e = document.querySelector(".ssZoomIn");
this._ssControl._panningDivContainer.msSetPointerCapture(pointerId);
// [END]
},
positionItem: function positionItem(listItem, position) {
// zoom in start
// force a force refresh
this._headerShownFlag = false;
this._infoShown = !this._infoShown;
this._toggleInfoBlock();
var index = listItem.firstItemIndexHint;
this._ssControl.currentPage = index;
this._selectedIndex = index;
return WinJS.Promise.wrap({
x: 0,
y: 0
});
},
setCurrentItem: function setCurrentItem(x, y) {
},
_determineMediaContainerColumnDefinition: function _determineMediaContainerColumnDefinition() {
if (this._mediaContainer) {
var columDefinition = "(1fr)[" + this._mediaColumns + "]";
if ((!this._additionalButtons) || (this._additionalButtons && this._additionalButtons.length <= 0)) {
this._mediaContainer.style.msGridColumns = columDefinition;
return;
}
if (this._mediaPos === CommonJS.SlideshowControl.MediaBlockPosition.bottomLeft) {
columDefinition = "1fr auto" + " (1fr)[" + (this._mediaColumns - 1) + "]";
}
else if ((this._mediaPos === CommonJS.SlideshowControl.MediaBlockPosition.topRight)
|| (this._mediaPos === CommonJS.SlideshowControl.MediaBlockPosition.bottomRight)
|| (this._mediaPos === CommonJS.SlideshowControl.MediaBlockPosition.topLeft)) {
columDefinition = "(1fr)[" + (this._mediaColumns - 1) + "]" + " auto 1fr";
}
this._mediaContainer.style.msGridColumns = columDefinition;
}
},
// IZoomable ends
// TODO: update layout when state changed.
_onLayoutUpdated: function _onLayoutUpdated() {
if (this._mediaContainer) {
CommonJS.Slideshow.ImageCard.relayoutSlides();
this._mediaColumns = slideshow.Utilities.getColumns();
this._mediaContainer.style.msGridColumns = "(1fr)[" + this._mediaColumns + "]";
this._updateMediaOverlay();
}
},
_updateAdditionalButtonsColumnPosition: function _updateAdditionalButtonsColumnPosition() {
var buttonsWrapper = document.querySelector(".ssAdditionalButtons");
if (!buttonsWrapper) {
return;
}
if (this._mediaPos === CommonJS.SlideshowControl.MediaBlockPosition.bottomLeft) {
buttonsWrapper.style.msGridColumn = 2;
}
else if ((this._mediaPos === CommonJS.SlideshowControl.MediaBlockPosition.topRight)
|| (this._mediaPos === CommonJS.SlideshowControl.MediaBlockPosition.bottomRight)
|| (this._mediaPos === CommonJS.SlideshowControl.MediaBlockPosition.topLeft)) {
buttonsWrapper.style.msGridColumn = this._mediaColumns;
}
},
currentPage: {
get: function get() {
var currentPage = 0;
if (this._ssControl) {
currentPage = this._ssControl.currentPage;
}
return currentPage;
}
},
// Control option: auto playback
playbackMode: {
get: function get() {
// always return false to turn off playback feature.
return false;
},
set: function set(v) {
this._playbackMode = v;
}
},
showPlaybackButton: {
get: function get() {
// always return false to turn off playback feature.
return false;
}
},
cacheId: {
get: function get() {
return this._cacheId;
},
set: function set(v) {
this._cacheId = v;
}
},
showMoreInfo: {
get: function get() { return this._showMoreInfo; },
set: function set(v) { this._showMoreInfo = v; }
},
slideInterval: {
get: function get() { return this._slideInterval; },
},
// Control Option: slideshow start index
startIndex: {
get: function get() {
if (typeof this._startIndex === "undefined") {
this._startIndex = 0;
}
return this._startIndex;
},
set: function set(newData) {
this._startIndex = newData;
}
},
additionalButtons: {
set: function set(v) {
this._additionalButtons = v;
}
},
title: {
get: function get() {
return this._title;
},
set: function set(v) {
this._title = v;
}
},
desc: {
get: function get() {
return this._desc;
},
set: function set(v) {
this._desc = v;
}
},
// Control Option or config in data
pageTitlePosition: {
get: function get() {
if (!this._titlePos) {
this._titlePos = CommonJS.SlideshowControl.MediaBlockPosition.topLeft;
}
return this._titlePos;
},
set: function set(newData) {
this._titlePos = newData;
}
},
// Control Option or config in data
mediaBlockPosition: {
get: function get() {
var mediaBlockPosition = CommonJS.SlideshowControl.MediaBlockPosition;
if (!this._mediaPos) {
this._mediaPos = mediaBlockPosition.bottomRight;
}
var titlePos = this.pageTitlePosition;
if (this._mediaPos === titlePos) {
switch (titlePos) {
case mediaBlockPosition.topLeft:
this._mediaPos = mediaBlockPosition.bottomRight;
break;
case mediaBlockPosition.topRight:
this._mediaPos = mediaBlockPosition.bottomLeft;
break;
case mediaBlockPosition.bottomLeft:
this._mediaPos = mediaBlockPosition.topRight;
break;
case mediaBlockPosition.bottomRight:
this._mediaPos = mediaBlockPosition.topLeft;
break;
}
}
return this._mediaPos;
},
set: function set(newData) {
this._mediaPos = newData;
}
},
mediaBlockColumnSpan: {
get: function get() {
if (!this._mediaColumnSpan) {
this._mediaColumnSpan = CommonJS.SlideshowControl.MediaBlockColumnSpan.one;
}
return this._mediaColumnSpan;
},
set: function set(v) {
this._mediaColumnSpan = v;
}
},
onClickHandler: {
get: function get() {
return this._onClickHandler;
},
set: function set(v) {
this._onClickHandler = v;
}
},
_reset: function _reset() {
slideshow.Utilities.setInnerHtml(this._domElement, "");
},
_render: function _render() {
var that = this;
slideshow.Utilities.setInnerHtml(this._domElement, "");
this._canvas = document.createElement("div");
this._canvas.setAttribute("aria-label", STRINGS.SLIDESHOW);
this._domElement.appendChild(this._canvas);
this._canvas.className = "flipContainer";
this._createFlipControl(this._canvas);
this._createMediaContainer(this._domElement);
// final step
this._hookupEvents();
},
_hookupEvents: function _hookupEvents() {
var that = this;
this._ssControl.addEventListener("pagevisibilitychanged", updateMediaBlock, false);
this._ssControl.addEventListener("pagevisibilitychanged", updateTitleBlock, false);
if (this._additionalButtons) {
for (var i = 0, len = this._additionalButtons.length; i < len; i++) {
var currentButton = this._additionalButtons[i];
if (currentButton.eventListeners) {
for (var currentProperty in currentButton.eventListeners) {
if (currentButton.eventListeners.hasOwnProperty(currentProperty)) {
var listener = currentButton.eventListeners[currentProperty];
this._ssControl.addEventListener(currentProperty, function () {
listener(that._ssControl.currentPage);
}, false);
}
}
}
}
}
function scheduleFlip(eventInfo) {
if (that.playbackMode) {
var image = eventInfo.srcElement.querySelector(".ssImage");
var onload = function onload(e) {
var img = e.srcElement;
that.startTimer();
};
if (!u.hasClass(CommonJS.Slideshow.Constants.ssImageLoaded)) {
image.addEventListener("load", onload, false);
}
var readyImage = eventInfo.srcElement.querySelector("." + CommonJS.Slideshow.Constants.ssImageLoaded);
if (readyImage) {
that.startTimer();
}
}
}
// Part 1: click to show filmstrip and mediablock
// This event is triggered when the user interaction results in a tap gesture.
this._ssControl.addEventListener("click", touchListener, false);
this._ssControl.addEventListener("keyup", keyupListener, false);
this._mediaContainer.addEventListener("click", touchListener, false);
this._mediaContainer.addEventListener("keyup", keyupListener, false);
//// not working now
//// This event is triggered when the user interaction results in a tap gesture.
////document.addEventListener("MSPointerDown", onMSPointerDown, false);
////document.addEventListener("MSPointerUp", onMSPointerUp, false);
// background
// A little background might be in order here…
// the flipView is built on top of intrinsic panning in Trident.
// In order to receive the full stream of events (namely MSPointerMove
// or MSGestureChange events) you need to prevent Trident from doing the panning.
// This is done by calling evt.preventManipulation (in DP2/DP3 builds,
// but will be changing to the declarative CSS markup ‘-ms-touch-action:none’).
// However, applying this to the flipView as a whole will prevent the touch
// interactions of the flipView from working.
// to simulate a swipe use MSPointer:
// swipe: "down" followed by a "pagevisiblitychange"
// click/simple touch:  "down" + "up" or just one "click"
function onMSPointerDown(evt) {
if (slideshow.Utilities.clickInfoArea(evt)) {
return;
}
if (!that.swipeStart) {
that.swipeStart = true;
}
}
function onMSPointerUp(evt) {
if (slideshow.Utilities.clickInfoArea(evt)) {
return;
}
// if a down follow with a up, then it's not a swipe
if (that.swipeStart) {
that.swipeStart = false;
}
}
function stopPlayback(evt) {
// if a down follow with a up, then it's not a swipe
if (that.swipeStart) {
that.swipeStart = false;
if (that.playbackMode) {
that.stopTimer();
}
}
}
function touchListener(evt) {
// reset swipe if it's a simple touch/click
if (that.swipeStart) {
that.swipeStart = false;
}
if (slideshow.Utilities.clickBlock(evt, "ssMediaOverlay")) {
if (that.onClickHandler) {
return that.onClickHandler(that._mediaBox.getAttribute("uid"));
}
} else if (slideshow.Utilities.clickInfoArea(evt)) {
return;
}
that._toggleInfoBlock();
}
function keyupListener(event) {
switch (event.keyCode) {
case 32: onSpacebarUp(event); break;
case 13: onEnterKeyUp(event); break;
default: break;
}
}
function onSpacebarUp(event) {
// causing crash in DP6. thumbnails always visible for now.
that._toggleInfoBlock();
}
function onEnterKeyUp(event) {
var target = event.target;
if (target && WinJS.Utilities.hasClass(target, "ssMediaOverlay")) {
if (that.onClickHandler) {
return that.onClickHandler(that._mediaBox.getAttribute("uid"));
}
}
}
// Initialize the currentImageCard variable with the first imagecard.
var currentImageCard = null;
var firstImageCardElement = document.querySelector(".ssZoomIn .flipItem");
if (firstImageCardElement && firstImageCardElement.winControl){
currentImageCard = firstImageCardElement.winControl;
}
// imgCard_keydownHandler had to be added to the parent of semantic zoom control. 
// because, semantic zoom control eats up ctrl+ and ctrl- events after processing those. 
// so, these events never reach to the image card level. Inside currentImageCard.handleKeyDown,
// if we process  ctrl+ or ctrl- to zoom-in or out the image, then we stop its propagation, so that
// semantic zoom control doesnt zoom out, when the user is trying to perform optical zoom-out.
var semanticZoomDom = document.querySelector(".ssSemanticZoomDom");
if (semanticZoomDom && semanticZoomDom.parentNode) {
semanticZoomDom.parentNode.addEventListener("keydown", imgCard_keydownHandler, true);
}
function imgCard_keydownHandler(ev) {
if (currentImageCard) {
currentImageCard.handleKeyDown(ev);
}
};
function updateMediaBlock(e) {
if (that._mediaBox && that._ssControl && !e.detail.visible) {
slideshow.Utilities.setInnerHtml(that._mediaBox, "");
var index = that._ssControl.currentPage;
var binding = that.smDataSource.dataSource.createListBinding();
binding.fromIndex(index).then(function slideshowControlBase_updateMediaBlockFromIndexComplete(item) {
that._setMediaContent(item);
});
}
// reset zoom level
if (e.target && e.target.winControl && e.detail.visible) {
var imgCardElement = e.target;
currentImageCard = imgCardElement.winControl;
currentImageCard.resetZoom();
}
}
function updateTitleBlock(e) {
if (that._titleBox && that._ssControl && !e.detail.visible) {
if (that._ssControl.currentPage === 0 && that._infoShown) {
that._titleBox.style.display = "block";
} else {
that._titleBox.style.display = "none";
}
}
}
},
_updateAdditionalButtonsDisplay: function _updateAdditionalButtonsDisplay(display) {
var buttonsElement = document.querySelector(".ssAdditionalButtons");
if (buttonsElement) {
buttonsElement.style.display = display;
}
},
_toggleInfoBlock: function _toggleInfoBlock() {
var that = this;
var header = document.querySelector(".immersiveHeader");
if (!that._infoShown) {
that._infoShown = true;
that._mediaBox.style.display = "block";
if (that._ssControl.currentPage === 0) {
that._titleBox.style.display = "block";
}
if (!this._headerShownFlag && header) {
header.style.visibility = "visible";
}
this._updateAdditionalButtonsDisplay("-ms-flexbox");
} else {
that._mediaBox.style.display = "none";
that._titleBox.style.display = "none";
if (!this._headerShownFlag && header) {
header.style.visibility = "hidden";
}
that._infoShown = false;
this._updateAdditionalButtonsDisplay("none");
}
that._attributionButton.currentState = that._infoShown ? "on" : "off";
},
_createMediaContainer: function _createMediaContainer(container) {
this._mediaContainer = document.createElement("div");
WinJS.Utilities.addClass(this._mediaContainer, "ssMediaContainer");
this._mediaColumns = slideshow.Utilities.getColumns();
this._mediaContainer.style.msGridColumns = "(1fr)[" + this._mediaColumns + "]";
container.appendChild(this._mediaContainer);
this._renderPageTitle(this._mediaContainer);
this._createMediaBox(this._mediaContainer);
this._createAttribution();
},
_createButtonContent: function _createButtonContent(textContent, className) {
var buttonElement = document.createElement("div");
buttonElement.innerText = textContent || "";
WinJS.Utilities.addClass(buttonElement, className);
return buttonElement;
},
_createAdditionalButtons: function _createAdditionalButtons(mediaContainerElement) {
if (!this._additionalButtons) {
return;
}
var buttonsWrapper = document.createElement("div");
WinJS.Utilities.addClass(buttonsWrapper, "ssAdditionalButtons");
var row = mediaContainerElement.style.msGridRow;
var column = mediaContainerElement.msGridColumn;
var buttonElement = null;
var that = this;
for (var i = 0; i < this._additionalButtons.length; i++) {
var currentButton = this._additionalButtons[i];
buttonElement = document.createElement("div");
if (buttonElement) {
WinJS.Utilities.addClass(buttonElement, currentButton.className);
buttonElement.setAttribute("tabIndex", 0);
buttonsWrapper.appendChild(buttonElement);
var onclick = (function slideshowControlBase_additionalButtonOnClick(button) {
return function (event) {
button.clickHandler(that._ssControl.currentPage);
event.stopPropagation(); // prevent infoBlock from toggling out
};
})(currentButton);
var onkeydown = (function slideshowControlBase_additionalButtonOnKeyDown(button) {
return function (event) {
if (event.keyCode === WinJS.Utilities.Key.enter) {
button.clickHandler(that._ssControl.currentPage);
event.stopPropagation(); // same as above
}
};
})(currentButton);
buttonElement.addEventListener("click", onclick, false);
buttonElement.addEventListener("keydown", onkeydown, false);
var primaryTextDiv = this._createButtonContent(currentButton.primaryText, "primaryText");
var valueDiv = this._createButtonContent(currentButton.value, "value");
var secondaryTextDiv = this._createButtonContent(currentButton.secondaryText, "secondaryText");
buttonElement.appendChild(primaryTextDiv);
buttonElement.appendChild(secondaryTextDiv);
buttonElement.appendChild(valueDiv);
}
}
buttonsWrapper.style.msGridColumn = column;
if ((this.mediaBlockPosition === CommonJS.SlideshowControl.MediaBlockPosition.topLeft) ||
(this.mediaBlockPosition === CommonJS.SlideshowControl.MediaBlockPosition.topRight)) {
buttonsWrapper.style.msGridRow = row;
}
else {
buttonsWrapper.style.msGridRow = row;
buttonsWrapper.style.msGridRowAlign = "end";
}
mediaContainerElement.appendChild(buttonsWrapper);
},
_createMediaOverlay: function _createMediaOverlay(pos, span, isTitle) {
var box = document.createElement("div");
WinJS.Utilities.addClass(box, "ssMediaOverlay" + (isTitle ? "Title" : ""));
WinJS.Utilities.addClass(box, "ssMediaPos" + pos);
box.setAttribute("tabIndex", 0);
this._setMediaOverlayPosition(box, pos, span);
return box;
},
_setMediaOverlayPosition: function _setMediaOverlayPosition(box, pos, span) {
var mediaBlockPosition = CommonJS.SlideshowControl.MediaBlockPosition;
switch (pos) {
case mediaBlockPosition.topLeft:
box.style.msGridRow = 1;
box.style.msGridColumn = 1;
break;
case mediaBlockPosition.bottomLeft:
box.style.msGridRow = 2;
box.style.msGridColumn = 1;
break;
case mediaBlockPosition.topRight:
box.style.msGridRow = 1;
box.style.msGridColumn = this._mediaColumns - this.mediaBlockColumnSpan;
break;
case mediaBlockPosition.bottomRight:
box.style.msGridRow = 2;
box.style.msGridColumn = this._mediaColumns - this.mediaBlockColumnSpan;
break;
}
box.style.msGridColumnSpan = this.mediaBlockColumnSpan + 1;
},
_updateMediaOverlay: function _updateMediaOverlay() {
var box = document.querySelector(".ssMediaOverlayTitle");
if (box) {
this._setMediaOverlayPosition(box, this.pageTitlePosition, this.mediaBlockColumnSpan);
}
box = document.querySelector(".ssMediaOverlay");
if (box) {
this._setMediaOverlayPosition(box, this.mediaBlockPosition, this.mediaBlockColumnSpan);
}
},
_renderPageTitle: function _renderPageTitle(container) {
var pos = this.pageTitlePosition;
var span = this.mediaBlockColumnSpan;
this._titleBox = this._createMediaOverlay(pos, span, true);
container.appendChild(this._titleBox);
var hasData = false;
var text = this.title;
if (text) {
var title = document.createElement("div");
title.className = "ssTitle";
slideshow.Utilities.setInnerHtml(title, text);
this._titleBox.appendChild(title);
hasData = true;
}
text = this.desc;
if (text) {
var desc = document.createElement("div");
desc.className = "ssDesc";
slideshow.Utilities.setInnerHtml(desc, text);
this._titleBox.appendChild(desc);
hasData = true;
}
text = this.byline;
if (text) {
var byline = document.createElement("div");
byline.className = "ssByline";
slideshow.Utilities.setInnerHtml(byline, text);
this._titleBox.appendChild(byline);
hasData = true;
}
this._titleBox.style.visibility = hasData && this.showTitleBox ? "visible" : "hidden";
},
_mediaBoxOnWheel: function _mediaBoxOnWheel(event) {
var newEvent = document.createEvent("WheelEvent");
newEvent.initWheelEvent("wheel", true, true, null, 0, 0, 0, 0, 0, 0, null, null, 0, event.deltaY, 0, 0);
this._ssControl._panningDiv.dispatchEvent(newEvent);
},
_createMediaBox: function _createMediaBox(container) {
var that = this;
var pos = this.mediaBlockPosition;
var span = this.mediaBlockColumnSpan;
this._mediaBox = this._createMediaOverlay(pos, span, false);
container.appendChild(this._mediaBox);
var binding = this.smDataSource.dataSource.createListBinding();
binding.fromIndex(this.startIndex).then(function slideshowControlBase_createMediaBoxFromIndexComplete(item) {
that._setMediaContent(item);
});
this._mediaBox.addEventListener("wheel", this._mediaBoxOnWheel.bind(this), false);
},
_createAttribution: function _createAttribution() {
var that = this;
this.attrBox = document.createElement("div");
WinJS.Utilities.addClass(this.attrBox, "ssAttribution");
this._domElement.appendChild(this.attrBox);
// attribution button
var title = PlatformJS.Services.resourceLoader.getString("/platform/imageAttribution") || "Image attribution";
var attributionButton = this._attributionButton = new CommonJS.Button(null, {
icon: "platformInfoButton",
title: "title",
states: [
{
id: "on",
title: "title",
iconRemove: "platformInfoButtonOff",
iconAdd: "platformInfoButtonOn",
},
{
id: "off",
title: "title",
iconRemove: "platformInfoButtonOn",
iconAdd: "platformInfoButtonOff",
}
]
});
attributionButton.onclick = this._toggleInfoBlock.bind(this);
attributionButton.currentState = that._infoShown ? "on" : "off";
WinJS.Utilities.addClass(attributionButton.element, "platformAttributionButton");
this.attrBox.appendChild(attributionButton.element);
},
_setAttrContent: function _setAttrContent(item) {
var itemObject = item.data;
var text = itemObject.data.attribution;
if (text) {
slideshow.Utilities.setInnerHtml(this._attributionLabel, text);
}
},
// ListDataSource and ArrayDataSource wrap data different
// ListDataSource firstlevel: {item}
// ArrayDataSource firstLevel: {key:"i", data: item}
_setMediaContent: function _setMediaContent(item) {
var itemObject = item.data;
var hasData = false;
// remember uid
this._mediaBox.setAttribute("uid", itemObject.data.uniqueIdentifier ? itemObject.data.uniqueIdentifier : "NA");
// Create the title div
var text = (item.index === 0 || this.showTitleOnEveryFrame) ? this.title : null;
if (text) {
var title = document.createElement("div");
title.className = "ssTitle";
slideshow.Utilities.setInnerHtml(title, text);
this._mediaBox.appendChild(title);
hasData = true;
}
var titleText = this.dontShowSlideTitle ? "" : itemObject.data.title;
if (!this.dontShowImageCount) {
text = PlatformJS.Services.resourceLoader.getString("/Common/ImageCount").format(item.index + 1, this._slideCount);
if (titleText && titleText.length > 0) {
text += ": " + titleText;
}
}
if (text) {
var desc = document.createElement("div");
desc.className = "ssSlideTitle";
slideshow.Utilities.setInnerHtml(desc, text);
this._mediaBox.appendChild(desc);
hasData = true;
}
text = itemObject.data.desc;
if (text) {
var desc1 = document.createElement("div");
desc1.className = "ssDesc";
slideshow.Utilities.setInnerHtml(desc1, text);
this._mediaBox.appendChild(desc1);
hasData = true;
}
var attrContainer = document.createElement("div");
if (attrContainer) {
attrContainer.className = "ssAttrContainer";
text = itemObject.data.attribution;
if (text) {
var attr = document.createElement("div");
attr.className = "ssAttr";
slideshow.Utilities.setInnerHtml(attr, text);
if (itemObject.data.onClickAttribution) {
attr.addEventListener("click", itemObject.data.onClickAttribution, false);
}
attrContainer.appendChild(attr);
hasData = true;
}
var favicon = itemObject.data.favicon;
if (favicon) {
var sourceImageUrl = favicon.url;
var sourceImage = document.createElement("div");
if (favicon.width) {
sourceImage.style.width = favicon.width + "px";
}
if (favicon.height) {
sourceImage.style.height = favicon.height + "px";
}
sourceImage.className = "ssLogo sourceImage fitBoth";
var sourceImageImage = new CommonJS.ImageCard(sourceImage, {
classification: "tiny",
imageSource: {
url: sourceImageUrl,
cacheId: this.cacheId
}
});
attrContainer.appendChild(sourceImage);
hasData = true;
}
if (this.showArticleLinkLabel) {
text = itemObject.data.uniqueIdentifier;
if (text) {
var readArticleLabel = document.createElement("div");
readArticleLabel.className = "ssArticleLinkLabel";
slideshow.Utilities.setInnerHtml(readArticleLabel, CommonJS.resourceLoader.getString("/Common/ArticleLinkLabelText"));
attrContainer.appendChild(readArticleLabel);
hasData = true;
}
}
this._mediaBox.appendChild(attrContainer);
}
this._mediaBox.style.visibility = hasData ? "visible" : "hidden";
this._createAdditionalButtons(this._mediaBox);
},
indexOfFirstVisible: {
set: function set(v) {
// when selection happen, stop playback first.
if (this._ssControl.currentPage !== v && this.playbackMode) {
this.stopTimer();
}
return this._ssControl.currentPage = v;
},
get: function get() {
return this._ssControl.currentPage;
},
},
/// <field>Show the current entity</field>
showEntityForIndex: function showEntityForIndex(index) {
if (!this._changeHandled) {
// when selection happen, stop playback first.
if (this._ssControl.currentPage !== index && this.playbackMode) {
this.stopTimer();
}
this._ssControl.currentPage = index;
}
this._changeHandled = false;
},
_addPlayButton: function _addPlayButton(container) {
this._playButton = document.createElement("button");
u.addClass(this._playButton, "win-commandicon win-commandring win-commandimage");
if (this.playbackMode) {
slideshow.Utilities.setInnerHtml(this._playButton, "&#xE103;");
this._playButton.setAttribute("aria-label", STRINGS.PAUSE);
this._playButton.setAttribute("state", "pause");
} else {
slideshow.Utilities.setInnerHtml(this._playButton, "&#xE102;");
this._playButton.setAttribute("aria-label", STRINGS.PLAY);
this._playButton.setAttribute("state", "play");
}
var that = this;
this._playButton.addEventListener("click", function slideshowControlBase_onClickPlayButton(e) {
if (that._playButton.getAttribute("state") === "pause") {
that.stopTimer();
} else {
that.startTimer();
}
}, false);
container.appendChild(this._playButton);
},
smDataSource: {
get: function get() {
return this._smDS;
},
set: function set(v) {
this._smDS = v;
this._render();
}
},
_lastZoomFactor: 1,
_createFlipControl: function _createFlipControl(container) {
var that = this;
function renderer(itemPromise, element) {
var d = element;
if (!d) {
d = document.createElement("div");
u.addClass(d, "flipItem");
u.addClass(d, "zoomElement");
d.addEventListener("MSContentZoom", that._onMSContentZoom.bind(that));
d.addEventListener("wheel", that._onMouseWheel.bind(that), true);
}
return {
element: d,
renderComplete:
itemPromise.then(function slideshowControlBase_itemPromiseComplete(item) {
var itemData = item.data.data;
var imageObj = itemData.image;
d.setAttribute("aria-label", STRINGS.SLIDE + " " + item.index);
if (imageObj && imageObj.url) {
var imageCard = new CommonJS.Slideshow.ImageCard(d, {
imageSource: {
url: imageObj.url,
cacheId: that.cacheId,
width: imageObj.width,
height: imageObj.height
},
showErrorInfo: true,
alternateText: itemData.altText,
zoomInEnabled: true,
pageIndex: item.index
});
}
})
};
};
var options = {};
options.itemDataSource = this.smDataSource.dataSource;
options.currentPage = this.startIndex;
options.itemTemplate = renderer;
options.itemSpacing = 40;
// Create the zoomed in list view
this._ssControl = new WinJS.UI.FlipView(container, options);
// Replace the default prev/next page buttons with our customizable page buttons.
this._ssControl._nextButton.style.display = "none";
this._ssControl._prevButton.style.display = "none";
var paginatedViewManager = this._paginatedViewManager = new CommonJS.Slideshow.SlideshowPaginatedViewManager({
controller: this._ssControl,
});
paginatedViewManager.attachEventListeners(this._ssControl._contentDiv);
// sample animation for slide
function _nextAnimation(curr, next) {
var incomingPageMove = {};
next.style.left = "0px";
next.style.top = "0px";
incomingPageMove.left = "100px";
incomingPageMove.top = "100px";
var p = WinJS.UI.Animation.fadeOut(curr);///.then(function (){ curr.style.display = "none"; });
// Ideally, the animation.fadeOut + animation.transitionContent promises should be joined.
// Unfortunately a recent regression in IE has made animation.fadeOut's promise never return, so a joined promise would be bad.
// For now, we'll return the promise for transitionContent alone (which is okay, since it's the longer animation).
// When bug 373009 is fixed, we can probably join the two.
var p2 = WinJS.UI.Animation.enterContent(next, [incomingPageMove]);
return WinJS.Promise.join([p, p2]);
}
if (this.customAnimations) {
this._ssControl.setCustomAnimations(this.customAnimations);
} else {
var animation = {
next: null,
previous: null,
jump: null
};
this._ssControl.setCustomAnimations(animation);
}
},
// user trying to pinch. image cannot scale down below 100%. initiate zoom-out.
_onMSContentZoom: function _onMSContentZoom(event) {
if (event && event.target) {
if (this._lastZoomFactor === 1 && event.target.msContentZoomFactor === 1) {
this._performZoomOut(0.5 * window.innerWidth, 0.5 * window.innerHeight, event);
}
this._lastZoomFactor = event.target.msContentZoomFactor;
}
},
_onMouseWheel: function _onMouseWheel(ev) {
// if the contained image cannot zoom-out further, then we should perform semantic zoom-out.
if (ev.ctrlKey && ev.deltaY > 0 && !ev.currentTarget.winControl.canZoomOut()) {
this._performZoomOut(null, null, ev);
ev.stopPropagation();
ev.preventDefault();
}
},
_performZoomOut: function _performZoomOut(x, y, eventObject) {
var semanticZoomDom = document.querySelector(".ssSemanticZoomDom");
var location = { x: x, y: y };
// pass control to semantic zoom 
if (semanticZoomDom && semanticZoomDom.winControl) {
var semanticZoomCtrl = semanticZoomDom.winControl;
if (!x || !y) {
location = semanticZoomCtrl._getPointerLocation(eventObject);
}
semanticZoomCtrl._zoom(true, location);
}
},
clearTimer: function clearTimer() {
if (this.inPromise && this.playPromise) {
this.playPromise.cancel();
this.playPromise = null;
this.inPromise = false;
}
},
startTimer: function startTimer() {
this.playbackMode = true;
var that = this;
function atEnd() {
if (that._ssControl.currentPage === that._itemCount - 1) {
return true;
}
return false;
}
function promiseShowNext() {
that.inPromise = true;
that.playPromise = WinJS.Promise.timeout(5000).then(
function slideshowControlBase_playPromiseTimeoutComplete() {
if (that._ssControl.next()) {
that.inPromise = false;
}
});
}
this.clearTimer();
if (atEnd()) {
this.stopTimer();
return;
}
promiseShowNext();
if (this._playButton) {
this._playButton.setAttribute("state", "pause");
slideshow.Utilities.setInnerHtml(this._playButton, "&#xE103;");
this._playButton.setAttribute("aria-label", STRINGS.PAUSE);
}
},
stopTimer: function stopTimer() {
this.playbackMode = false;
this.clearTimer();
if (this._playButton) {
this._playButton.setAttribute("state", "play");
slideshow.Utilities.setInnerHtml(this._playButton, "&#xE102;");
this._playButton.setAttribute("aria-label", STRINGS.PLAY);
}
},
})
});
})();
/* File: SlideshowPage.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function appexCommonControlsSlideshowPageInit() {
"use strict";
WinJS.Namespace.define("CommonJS", {
SlideShowProvider: WinJS.Class.define(function slideShowProvider_ctor (options) {
WinJS.UI.setOptions(this, options);
}, {
slideshowId: null,
market: null,
queryServiceId: "CustomPanoSlideshows",
updateResponse: null,
initializeAsync: function initializeAsync(configuration) {
WinJS.UI.setOptions(this, configuration);
return WinJS.Promise.wrap(true);
},
queryAsync: function queryAsync(startPos, count) {
var that = this;
var queryService = new Platform.QueryService(this.queryServiceId);
var queryParams = PlatformJS.Collections.createStringDictionary();
queryParams.insert("slideshowId", this.slideshowId);
queryParams.insert("market", this.market);
var isPreviewModeEnabled = Platform.Configuration.ConfigurationManager.instance.previewFeaturedDataSource;
if (PlatformJS.isDebug && isPreviewModeEnabled) {
queryParams["previewparams"] = "/" + PlatformJS.Services.appConfig.getString("CMSPreviewParam");
}
else {
queryParams["previewparams"] = "";
}
return queryService.fetchDataAsync(queryParams, null, null)
.then(function (response) {
var jsonResponse = null;
try {
jsonResponse = JSON.parse(response.dataString);
if (that.updateResponse) {
jsonResponse = that.updateResponse(jsonResponse);
}
} catch (exception) {
queryService.deleteCacheEntryAsync(queryParams, null);
throw new SyntaxError("Syntax Error");
}
return jsonResponse;
});
}
},
{
_version: 1
}),
SlideshowPage: WinJS.Class.define(function slideshowPage_ctor(state) {
if (state) {
this.slideshowId = state.slideshowId;
this.startPageIndex = state.startPageIndex ? state.startPageIndex : 0;
this.instrumentationEntryPoint = state.instrumentationEntryPoint;
this.market = state.market ? state.market : CommonJS.Globalization.getMarketStringForEditorial();
this._state = state;
}
},
{
slideshowId: null,
startPageIndex: 0,
instrumentationEntryPoint: null,
market: null,
queryServiceId: "CustomPanoSlideshows",
//#region Overriddes
// Media overlay click handler, if required
clickHandler: null,
// Override provided for the case where the client needs to modify the server response data 
updateResponse: null,
//#endregion Overrides
getPageImpressionContext: function getPageImpressionContext() {
if (this.instrumentationEntryPoint === 1) {
return "/Partner Pano/Slideshow";
} else {
return "/Slideshow";
}
},
getPageState: function getPageState() {
this._state = this._state || {};
var element = document.getElementById('ssView');
if (element) {
var control = element.winControl;
if (control && control.currentPage >= 0) {
this._state.startPageIndex = control.currentPage;
}
}
return this._state;
},
getPageData: function getPageData() {
var that = this;
var options = { slideshowId: this.slideshowId, market: this.market, updateResponse: this.updateResponse, queryServiceId: this.queryServiceId };
var provider = new CommonJS.SlideShowProvider(options);
var config = PlatformJS.Collections.createStringDictionary();
var p = new WinJS.Promise(function (complete) {
complete({
dataOptions: {
provider: provider,
config: config
}, 
instrumentationEntryPoint: that.instrumentationEntryPoint,
startIndex: that.startPageIndex,
clickHandler: that.clickHandler
});
});
return p;
},
onBindingComplete: function onBindingComplete() {
},
onLayoutChange: function onLayoutChange(layoutMode) {
},
})
});
})();
/* File: SlideshowPaginatedViewManager.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// SlideshowPaginatedViewManager is derived from PaginatedViewManager.
// It owns the scroll event in slideshow and implements the interface exposed from baseclass for slideshow.
// All other events are inherited from WinJS.UI.FlipView.
WinJS.Namespace.define("CommonJS.Slideshow", {
SlideshowPaginatedViewManager: WinJS.Class.derive(CommonJS.PaginatedViewManager, function (options) {
this._controller = options.controller;
CommonJS.PaginatedViewManager.call(this, options);
// events
var panningDiv = this._controller._panningDivContainer;
if (panningDiv) {
this._attach(panningDiv, "scroll", this._onScroll);
this._attach(panningDiv, "wheel", this._onWheel);
}
},
{
_controller: null,
attachEventListeners: function attachEventListeners(elt) {
this._attach(elt, "MSPointerHover", this._pointerHoverListener);
this._attach(elt, "MSPointerMove", this._pointerMoveListener);
this._attach(elt, "MSPointerDown", this._pointerDownListener);
this._attach(elt, "MSManipulationStateChanged", this._manipulationListener);
},
exclude: function exclude(elt) {
var stopPropagation = this._stopPropagation.bind(this);
this._attach(elt, "MSPointerHover", stopPropagation);
this._attach(elt, "MSPointerMove", stopPropagation);
this._attach(elt, "MSPointerDown", stopPropagation);
this._attach(elt, "MSManipulationStateChanged", stopPropagation);
},
_getContainerElement: function _getContainerElement() {
return this._controller._contentDiv;
},
_hasNext: function _hasNext() {
return this._controller._hasNextContent;
},
_hasPrevious: function _hasPrevious() {
return this._controller._hasPrevContent;
},
_onNextPageClick: function _onNextPageClick(event) {
this._controller.next();
},
_onPreviousPageClick: function _onPreviousPageClick(event) {
this._controller.previous();
},
_onScroll: function _onScroll(event) {
this._maybeUpdateButtons();
},
_onWheel: function _onWheel(event) {
if (!event.ctrlKey) {
if (event.deltaY > 0) {
this.scrollOneSlide(1);
}
else if (event.deltaY < 0) {
this.scrollOneSlide(2);
}
}
},
scrollOneSlide: function scrollOneSlide(direction) {
/// <summary>
/// Scrolls the viewport by one slide. direction = 1 means scroll next, direction = 2 means scroll previous.
/// </summary>
var panel = this._controller._panningDiv;
var viewport = this._controller._panningDivContainer;
var modifier = 0;
if (direction === 1) {
modifier = 1;
}
else if (direction === 2) {
modifier = -1;
}
var marketDirection = window.getComputedStyle(viewport).direction;
var directionModifier = marketDirection === "ltr" ? -1 : 1;
if ((direction === 1 && this._hasNext()) || (direction === 2 && this._hasPrevious())) {
var currentPage = this._controller._pageManager._currentPage;
var scrollLeft = currentPage.location;
var newScrollLeft = direction === 1 ? currentPage.next.location : currentPage.prev.location;
var offset = Math.abs(newScrollLeft - scrollLeft);
panel.style.msTransitionProperty = "transform";
panel.style.msTransitionDuration = "0.25s";
panel.style.msTransform = "translate(" + ((modifier * offset) * directionModifier) + "px, 0px)";
clearTimeout(this._scrollAnimationTimeout);
this._scrollAnimationTimeout = setTimeout(function () {
panel.style.msTransitionProperty = "";
panel.style.msTransitionDuration = "";
panel.style.msTransform = "";
viewport.scrollLeft = newScrollLeft;
}, 260);
}
}
})
});
})();
/* File: GenericSlideshowPage.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function appexCommonControlsGenericSlideshowPageInit() {
"use strict";
/// 
/// GenericSlideShows takes in static slide show data and instantiates a slideshow control.
///
WinJS.Namespace.define("CommonJS", {
GenericSlideshowPage: WinJS.Class.define(function genericSlideshowPage_ctor(state) {
/// <summary>
/// Constructor.
/// </summary>
/// <param name="state">
/// - data: Static slideshow data
/// - startIndex: Starting index into the list of slides on launch
/// - instrumentationEntryPoint: Instrumentation value for the entry point
/// - cacheId: ID of the cache used for storing/fetching images
/// </param>
this._state = state;
this._impressionContext = state.impressionContext || "Slideshow";
},
{
_state: null,
_control: null,
_impressionContext: null,
getPageState: function getPageState() {
var state = this._state;
// update the start page index
var control = this._control;
if (control && control.currentPage >= 0) {
state.startPageIndex = control.currentPage;
}
return state;
},
getPageImpressionContext: function getPageImpressionContext() {
return this._impressionContext;
},
getPageData: function getPageData() {
return WinJS.Promise.wrap({});
},
onBindingComplete: function onBindingComplete() {
this._initialize();
},
_initialize: function _initialize() {
var state = this._state;
// control elt
var elt = document.getElementById("ssView");
// control options
var options = {
data: state.data,
startIndex: state.startIndex,
instrumentationEntryPoint: state.instrumentationEntryPoint,
cacheId: state.cacheId,
};
// instantiate the control
this._control = new CommonJS.SlideshowControl(elt, options);
},
})
});
})();
