﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: columnDefinition.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
WinJS.Namespace.define("CommonJS.Table", {
ColumnDefinition: WinJS.Class.define(function (options) {
this.headerTemplate = document.querySelector(".columnHeaderTemplate");
this.boundField = "title";   // TODO: should not use magic cookie  should be empty string
this.fieldTemplate = document.querySelector(".textFieldTemplate");
this.headerText = "not set";  // TODO: should not use magic cookie  should be empty string
this.priority = 0;
this.ID = Math.round(Math.random() * 1e9);
}, {
headerTemplate: null,
fieldTemplate: null,
boundField: null,
priority: null,
ID: null,
headerText: null,
isAutoSizeColumn: false
})
});
})();
/* File: table.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
// TODO: what's the purpose of this... thing?
CommonJS.groupPositionEnum = {
inline: "inline",
top: "top"
};
(function () {
"use strict";
var STRINGS = {
ROW: CommonJS.resourceLoader.getString("/Platform/Row") || "Row"
};
WinJS.Namespace.define("CommonJS.Table", {
EntityToken: {},
Table: WinJS.Class.define(function (element, options) {
this._onRowKeyDownHandlerBind = this._onRowKeyDown.bind(this);
this._onRowClickedBind = this._onRowClicked.bind(this);
this.tableDefinition = options;
this.host = element;
element.winControl = this;
this._element = element; 
if (options && options.existingState && options.existingState.sortDirection) {
this._selectedColumnSelectionCount = options.existingState.sortDirection;
}
// bool used to determine whether the table is a cluster table or a ecv 
this._isTableCluster = element.className === "platformClusterContent";
}, {
host: null,
_onRowKeyDownHandlerBind: null,
_onRowClickedBind: null,
_cssPrefix: "table-",
_expandoQuerySelector: ".table-expando",
_renderChunkSize: 10,
_itemsRendered: 0,
_rowHeight: 0,
_desc: "sortdir-desc",
_asc: "sortdir-asc",
_selected: "sort-selected",
_sortable: "column-sortable",
_headerCSS: "top-header",
_elemOffsetHeight: null,
_lastScrollFire: null,
_scrollTimeout: null,
_approximateRenderedHeight: null,
_element: null,
_selectedColumnSelectionCount: 0,
_containerHeight: null,
_renderUIDelay: null,
_scroller: null,
_suppressCapture: null,
_dataSource: null,
_selectedColumnHeader: null,
_minRenderHeight: null,
_groupsRendered: 0,
_hasFirstItemSetRendered: false,
_isRenderComplete: false,
_header: null,
_manager: null,
_containers: null,
containerHeight: {
get: function get() {
// this will be re-evaluated again if the host height is zero
// this is by design.
if (!this._containerHeight) {
this._containerHeight = this.host.offsetHeight;
}
return this._containerHeight;
}
},
tableDefinition: {
get: function get() {
return this._tableDefinition;
},
set: function set(v) {
if (v) {
this._tableDefinition = v;
this._buildAggregateTemplate(); 
if (this._manager) {
this._manager.tableDefinition = v;
}
this._addTableHeader();
this._buildAggregateTemplate();
this._alignHeaderGrid();
}
// TODO  what if set to null?
}
},
attachListeners: function attachListeners() {
if (this._manager) {
this._manager.attachListeners();
}
},
destroy: function destroy() {
if (this._manager) {
this._manager.destroy();
}
if (this._scrollTimeout) {
clearTimeout(this._scrollTimeout);
this._scrollTimeout = null;
}
if (this._renderUIDelay) {
msClearImmediate(this._renderUIDelay);
}
},
dataSource: {
get: function get() {
return this._dataSource;
},
set: function set(v) {
this._clean(); // clean before removing datasource, as the datasource needs to be the same for the clean operation
this._dataSource = v;
this._onNewDataSource(v);
}
},
setSelectedSort: function setSelectedSort(sort) {
var selectedColumn = null;
this._loop(this._tableDefinition.columns, function selectSortColumn(column, index) {
if (column.sortIdentifier === sort) {
selectedColumn = column;
return false; // break loop
} else {
return true;
}
});
this._selectedColumnHeader = selectedColumn;
},
setScrollPosition: function setScrollPosition(position) {
this._minRenderHeight = this.containerHeight + position;
this._table.style.minHeight = (this.containerHeight + position) + "px";
this._renderNextChunk();
this._scroller.scrollTop = position;
},
cancelLayout: function cancelLayout() {
},
addEventListener: function addEventListener(eventName, callback) {
// TODO
},
initialize: function initialize() {
var pre = this._cssPrefix;
var ctr = document.createElement("div");
ctr.className = pre + "container";
ctr.setAttribute("role", "grid");
ctr.setAttribute("aria-labelledby", "filterBar_title");
this.host.appendChild(ctr);
if (!this._isInlineGroup) {
var header = this._createClassElement("div", pre + "header " + this._headerCSS);
ctr.appendChild(header);
this._header = header;
header.style.display = "none";
}
var scroller = this._createClassElement("div", pre + "scroller");
var scrollingContainerAriaLabel = WinJS.Resources._getWinJSString("ui/listViewViewportAriaLabel").value || "Scrolling Container";
scroller.setAttribute("aria-label", scrollingContainerAriaLabel);
this._attachPreserveContext(scroller, "scroll");
this._scroller = scroller;
ctr.appendChild(scroller);
var table = this._createClassElement("div", pre + "table");
scroller.appendChild(table);
this._table = table;
this._manager = new CommonJS.Table.TableManager(this.host, this.tableDefinition, this);
},
// Begin IZoomableView 
getPanAxis: function getPanAxis() {
return "vertical";
},
getCurrentItem: function getCurrentItem() {
var current = this._getItem(this.dataSource, 0);
var data = { item: current };
data.position = {
left: 0,
top: this._scroller.scrollTop,
width: 100,
height: 100
};
return WinJS.Promise.wrap(data);
},
configureForZoom: function configureForZoom() {
},
zoomableView: {
get: function get() {
return this;
},
},
setCurrentItem: function setCurrentItem(x, y) {
},
beginZoom: function beginZoom() {
},
endZoom: function endZoom(isZoomedOut) {
},
positionItem: function positionItem(item, position) {
var host = this.host;
var child = null;
if (this._itemsRendered < item.data.index) {
var progressType = CommonJS.Progress.centerProgressType;
CommonJS.Progress.showProgress(progressType);
this._bindData(this.dataSource, this._itemsRendered, item.data.index + 50); //render to first item in dataset
CommonJS.Progress.hideProgress(progressType);
}
if (!(child = host.querySelector("[row='" + item.data.group + "']"))) {
// not inline group, query for entity row.
child = host.querySelector("[entity='" + item.data.index + "']");
}
if (!child) {
return WinJS.Promise.wrap({ x: 0, y: 0 });
}
var elem = child.parentNode;
var minimum = elem.parentNode.offsetTop;
/*
the top of the 0th item is equal to the height of the header.
so we need to subtract the offset of the header from the item.
*/
var newHeight = elem.offsetTop - minimum;
this._scroller.scrollTop = newHeight;
return WinJS.Promise.wrap({
x: 0,
y: newHeight
});
},
handlePointer: function handlePointer(pointer) {
// todo
if (!this._suppressCapture) {
this._scroller.focus();
this._scroller.msSetPointerCapture(pointer);
}
},
// End of IZoomableView 
_getItem: function _getItem(collection, index) {
if (collection.length && !collection.getItem) {
// assume array;
return collection[index];
}
if (collection.list && collection.list.getItem) {
// assume projection
return collection.list.getItem(index);
}
return null;
},
_loop: function _loop(collection, fn, start, end) {
/// <param name="start" optional="true"/>
/// <param name="end" optional="true"/> 
// used to be able to call with async but noone every called it async so removing asyncness
if (!collection) {
return;
}
var len = collection.length;
start = start ? Math.max(0, start) : 0;
end = end ? Math.min(len, end) : len;
var j;
// if is SimpleArray
if (collection.getItem) {
for (j = start; j < end; j++) {
/// <disable>JS2034.DoNotCompareToTrueOrFalse</disable>
if (fn(collection.getItem(j), j) === false) {
/// <enable>JS2034.DoNotCompareToTrueOrFalse</enable>
break;
}
}
}
else {
for (j = start; j < end; j++) {
/// <disable>JS2034.DoNotCompareToTrueOrFalse</disable>
if (fn(collection[j], j) === false) {
/// <enable>JS2034.DoNotCompareToTrueOrFalse</enable>
break;
}
}
}
},
_buildSelector: function _buildSelector(elem, attribute) {
var value = elem.getAttribute(attribute);
if (value) {
return "[" + attribute + "=\"" + value + "\"]";
}
return "";
},
_buildSelectorForElement: function _buildSelectorForElement(elem) {
var id, className = null;
var attributes = ["role", "aria-label", "column", "priority"];
if (elem) {
if (elem.id) {
id = elem.id.trim();
}
if (elem.className) {
className = elem.className.split(" ")[0]; // only first className, to ignore class names which are appended based on state.
}
var selector = (id ? "#" + id : "") + (className ? "." + className : "").replace(/ /gi, ".");
for (var i = 0, l = attributes.length; i < l; i++) {
selector += this._buildSelector(elem, attributes[i]);
}
return selector;
} else {
return null;
}
},
_saveFocusedElement: function _saveFocusedElement() {
var elem = document.activeElement;
var selector = [];
while (elem !== this.host) {
if (elem === document.body) {
// we walked all the way up and didn't cross our parent, we don't own whatever was focused. abort!
return;
}
try {
selector.push(this._buildSelectorForElement(elem));
elem = elem.parentNode;
}
catch (e) { return; } // elem can be removed from dom while we're walking up, catch this exception
}
this._lastFocusedItem = selector.reverse().join(" ");
},
_focusLastFocusedElement: function _focusLastFocusedElement() {
var result = false;
if (this._lastFocusedItem) {
var elem = document.querySelector(this._lastFocusedItem);
if (elem && elem !== document.activeElement) {
try {
elem.focus();
result = true;
}
catch (e) { } // sometimes focus() fails, if display none or its an appbar, etc
}
this._lastFocusedItem = null;
}
return result;
},
_onRowClicked: function _onRowClicked(event) {
var elem = event;
var index = elem.getAttribute("entity");
var entity = null;
if (index !== null) {
entity = this._getItem(this.dataSource, index).data;
}
this._saveFocusedElement();
var def = this._tableDefinition;
var expando = null;
if (entity) {
entity.detail = { itemIndex: entity.index };
if (def.hasExpando) {
if (this._getExpando(elem)) {
this._hideExpandoForContainer(elem);
elem.setAttribute("aria-expanded", false);
this._alignHeaderGrid();
} else {
expando = this._createExpandoForContainer(elem);
elem.setAttribute("aria-expanded", true);
}
}
if (this._tableDefinition.onRowClicked) {
var result = this._tableDefinition.onRowClicked(entity, expando);
if (result && result.expandoData) {
// bind expando row
this._renderEntityToRow(result.expandoData, elem);
var columns = this._tableDefinition.columns;
var numCols = columns.length,
that = this;
this._loop(columns, function highlightColInExpandRow(column, index) {
var colHeader = that._header.querySelector("[column='" + column.ID + "']");
var colExpandRow = elem.querySelector("[aria-label='" + column.ID + "']");
if (colHeader && colExpandRow && colHeader.getAttribute("selected") === "selected") {
colExpandRow.setAttribute("sorted", "sorted");
}
});
}
}
} else {
var group = elem.getAttribute("group");
// header
}
this._focusLastFocusedElement(); // focused item may get destroyed, reset focus to keep user happy :)
},
_onNewDataSource: function _onNewDataSource(ds) {
this._scroller.scrollTop = 0;
this.host.style.minHeight = "auto";
this._buildContainers(ds.list.length, ds.list.groups.length);
this._itemsRendered = 0;
this._lastScrollFire = 0;
this._groupsRendered = 0;
this._hasFirstItemSetRendered = false;
this._isRenderComplete = false;
this._addTableHeader();   // add the table header (even if grouped so that manager can find defined widths)
this._manager.update(true, ds);  //hand in the datasource ds  so manager can figure out width of data
this._buildAggregateTemplate();
this._bindData(ds, this._itemsRendered, this._renderChunkSize); 
this._alignHeaderGrid();
},
_alignHeaderGrid: function _alignHeaderGrid() { 
var columns = this._tableDefinition.columns;
var backgroundColor = null;
var selectedId = null; 
var colHeader, colGrid, i;
var alignHeaderColumn = function(colHeaderCell, colDataCell) {
if (colDataCell) {
var expanderGridCell = colDataCell.parentNode;
if (expanderGridCell) {
colHeaderCell.style.width = window.getComputedStyle(colDataCell).width;
colHeaderCell.parentNode.style.width = window.getComputedStyle(expanderGridCell).width;
}
if (colHeaderCell.currentStyle.display === "none") {
if (colHeaderCell.parentNode) {
colHeaderCell.parentNode.style.backgroundColor = colHeaderCell.currentStyle.backgroundColor;
}
}
}
};
for (var index = 0; index < columns.length; index++) {
var column = columns[index]; 
//  align top header
if (!this._isInlineGroup) {
colHeader = this._header.querySelector("[column='" + column.ID + "']"); // header cell
colGrid = this._scroller.querySelector("[column='" + column.ID + "']"); // data cell
backgroundColor = colHeader.currentStyle.backgroundColor;
alignHeaderColumn(colHeader, colGrid);
if (colHeader.getAttribute("selected") === "selected") {
selectedId = column.ID;
}
} else {
//  align inline header  so columnheader and data intermixed
var colHeaders = this._scroller.querySelectorAll("[column='" + column.ID + "']");
if (colHeaders) {
for (i = colHeaders.length - 2; i >= 0; i--) {
if (colHeaders[i].getAttribute("role") === "columnheader") {
backgroundColor = colHeaders[i].currentStyle.backgroundColor;
colHeader = colHeaders[i];    // header cell
colGrid = colHeaders[i + 1];  //data cell
alignHeaderColumn(colHeader, colGrid);
if (colHeader.getAttribute("selected") === "selected") {
selectedId = column.ID;
}
}
}
}
}
};
// set trailing space to background color
if (!this._isInlineGroup) {
var spacer = this._header.querySelector(".table-header-space");
if (spacer) {
spacer.style.backgroundColor = backgroundColor;
}
} else {
var spacers = this._scroller.querySelectorAll(".table-header-space");
for (i = spacers.length - 1; i >= 0; i--) {
spacers[i].style.backgroundColor = backgroundColor;
}
}
// mark data cells in sorted column
if (selectedId) {
var selectedCells = this._scroller.querySelectorAll("[column='" + selectedId + "']");
var visibleColInfo = this._manager.getVisibleColumnInfo(selectedId);
var gridCell;
if (visibleColInfo) {
for (i = selectedCells.length - 1; i >= 0; i--) {
gridCell = selectedCells[i];
if (gridCell.parentNode) {
gridCell.parentNode.setAttribute("sorted", "sorted");
}
}
} else {
// remove sort/select indicators on header and cells.
var children = this._header.parentNode.querySelectorAll(".table-column-header");
for (i = children.length - 1; i >= 0; i--) {
var item = children[i];
WinJS.Utilities.removeClass(item, this._selected);
WinJS.Utilities.removeClass(item, this._asc);
WinJS.Utilities.removeClass(item, this._desc);
item.removeAttribute("aria-sort");
item.parentNode.style.backgroundColor = backgroundColor;
};
for (i = selectedCells.length - 1; i >= 0; i--) {
gridCell = selectedCells[i];
if (gridCell.parentNode) {
gridCell.parentNode.removeAttribute("sorted");
}
}
}
}
}, 
_clean: function _clean() {
var that = this;
var expando = this._getExpando(this.host);
if (!expando) {
return;
}
if (!expando.length) {
expando = [expando];
}
this._loop(expando, function cleanExpando(item) {
var ctr = item.parentNode.children[0];
that._hideExpandoForContainer(ctr, true);
});
},
_bindData: function _bindData(ds, start, end) {
var that = this;
var renderedGroups = this._groupsRendered;
var shouldRenderInlineGroups = this._isInlineGroup;
var lastGroup = null; 
var numRendered = 0;
if (start && start > 0 && shouldRenderInlineGroups) {
var lastGroupItem = this._getItem(ds, start - 1);
if (lastGroupItem && lastGroupItem.data) {
lastGroup = lastGroupItem.data.group;
} else {
return;
}
}
if (end - start > 0) {
this._addTableHeader();
}
var _bindingFn = function (listItem, index) {
var item = listItem.data;
if (shouldRenderInlineGroups && item.group !== lastGroup) {
var groupContainer = that._getContainer(index + renderedGroups);
that._renderGroupHeader(item.group, groupContainer);
renderedGroups++;
}
var container = that._getContainer(index + renderedGroups);
lastGroup = item.group;
that._renderEntityToRow.apply(that, [item, container, index]);
if (index === 0) {
that._rowHeight = container.offsetHeight;
}
numRendered++;
return true;
};
try {
this._loop(ds.list, _bindingFn, start, end);
}
catch (err) {
console.log("Binding error: " + err);
}
// Binding Complete
this._manager.disableUpdates = false;
this._itemsRendered += numRendered;
this._groupsRendered = renderedGroups;
if (this._itemsRendered === 0) {
this._hideTableHeader();
} else {
this._showTableHeader();
} 
if (numRendered > 0) {
this._onPartialRenderComplete(numRendered);
} else {
this._cleanUnusedContainers(that._itemsRendered + renderedGroups);
this._onRenderComplete();
}
},
_onFirstItemSetRendered: function _onFirstItemSetRendered() {
if (this.onRenderComplete && !this._hasFirstItemSetRendered) {
this._hasFirstItemSetRendered = true;
this.onRenderComplete();
}
this._alignHeaderGrid();
},
_onRenderComplete: function _onRenderComplete() {
this._isRenderComplete = true;
this._table.style.minHeight = "auto";
this._onFirstItemSetRendered(); 
},
_addTableHeader: function _addTableHeader() {
if (this._header ) { 
this._header.innerHTML = "";
var headers = this._buildColumnHeaders(this._headerCSS);
this._header.appendChild(headers); 
this._header.style.display = (this._isInlineGroup ? "none" : "block");
}
},
_hideTableHeader: function _hideTableHeader() {
if (this._header) {
this._header.style.display = "none";
}
},
_showTableHeader: function _showTableHeader() {
if (this._header && !this._isInlineGroup) {
this._header.style.display = "block";
}
},
delayedLayoutUpdated: function delayedLayoutUpdated() {
if (!this._tableDefinition || !this._tableDefinition.columns) {
return;
}
// need to redraw header to deal with not drawing divs between invisible columns
this._addTableHeader(); 
this._alignHeaderGrid();
//renderAdditionalRowsIfNeeded
if (this.dataSource) {
this._containerHeight = null; // invalidate container cache when resize fires
var avgItemHeight = this._rowHeight;
this._approximateRenderedHeight = avgItemHeight * this._itemsRendered;
var scrollPos = this._scroller.scrollTop;
// can we adjust renderchunk here to max size needed????
var minRenderHeight = Math.max(this.containerHeight, this._minRenderHeight ? this._minRenderHeight : 0) + scrollPos;
if (this._approximateRenderedHeight <= minRenderHeight) {
this._renderNextChunk();
}
}
},
_onPartialRenderComplete: function _onPartialRenderComplete(numRendered) {
if (this.isNextColClick) {
this.isNextColClick = false;
this._focusLastFocusedElement();
}
var avgItemHeight = this._rowHeight;
this._approximateRenderedHeight = avgItemHeight * this._itemsRendered;
var approximateTotalHeight = avgItemHeight * this.dataSource.list.length;
var scrollPos = this._scroller.scrollTop;
var minRenderHeight = Math.max(this.containerHeight, this._minRenderHeight ? this._minRenderHeight : 0) + scrollPos;
if (this._approximateRenderedHeight <= minRenderHeight) {
/*this means we rendered less than one screen height
of data. this _should_ happen on big screens,
otherwise we would be wasting CPU on small netbooks/laptops
once we realize we didn't render enough, we triple the size
of the chunk size.
if that is still not big enough (maybe you have a 1px tall item)
then this method would execute again, and would triple the chunk size
until the resulting item is between 1 and 3x the size of the table.
*/
this._renderChunkSize += 3;
console.log("Increased this._renderChunkSize to " + this._renderChunkSize);
this._renderNextChunk();
return;
} else {
this._onFirstItemSetRendered();
}
this._table.style.minHeight = approximateTotalHeight + "px";
},
_renderNextChunk: function _renderNextChunk() {
return this._bindData(this.dataSource, this._itemsRendered, this._itemsRendered + this._renderChunkSize);
},
_cleanUnusedContainers: function _cleanUnusedContainers(lastUsed) {
this._loop(this._containers, function (item, index) {
item.innerHTML = "";
item.setAttribute("rowType", "none");
}, lastUsed);
},
_renderGroupHeader: function _renderGroupHeader(groupName, elem) {
var headers = this._buildColumnHeaders(groupName);
elem.setAttribute("rowType", "header");
elem.setAttribute("row", groupName || "none");
elem.appendChild(headers);
// todo: add group name...no one is using it so for now i'm leaving it out.
},
_renderEntityToRow: function _renderEntityToRow(entity, elem, index) {
/// <param name="index" optional="true"/>
var that = this;
var config = this._tableDefinition;
elem.innerHTML = "";
var promises = [];
var len = config.columns.length;
if (typeof index !== "undefined") { //may not exist
elem.setAttribute("entity", index);
var rowType = (entity.index % 2 === 0) ? "odd" : "even";
elem.setAttribute("rowType", rowType);
}
elem.setAttribute("row", entity.group);
var backingObject = {};
var backingIndex = 0;
var info = this._rowBackingInfo;
this._loop(config.columns, function (column, i) {
var fields = column.boundField;
if (!fields.push) {
// treat single fields as array of fields
fields = [fields];
}
var backingMap = info[i];
var indexOffset = backingIndex;
that._loop(backingMap, function (item, fieldIndex) {
if (typeof item === "undefined" /*note: it would be better to test it's the expected type as opposed to verifying it's not undefined*/) {
return;
}
// support passing in a function or EntityToken instead of a string key
var key = fields[fieldIndex];
var value;
if (typeof key === "function") {
value = key;
} else if (key === CommonJS.Table.EntityToken) {
value = entity;
} else {
value = entity[key];
}
var boundFieldIndex = item + indexOffset;
backingObject["bf" + boundFieldIndex] = value;
backingIndex++;
});
});
if (config.bindRow) {
// Allow the consumer to directly bind the row elements for better perf.
WinJS.Utilities.setInnerHTMLUnsafe(elem, this._rowTemplate._element.innerHTML);
config.bindRow(elem, backingObject);
this._addColIndexes(elem);
} else {
return this._rowTemplate.render(backingObject, elem).then(function () {
that._addColIndexes(elem);
});
}
},
// ColIndexes help us to determine cursor key navigation up and down between columns
_addColIndexes: function _addColIndexes(row) {
var rowChildNodes = row.childNodes;
for (var i = 0, colContainer, rowChildNodesLength = rowChildNodes.length; i < rowChildNodesLength; i++) {
colContainer = rowChildNodes[i];
if (colContainer && colContainer.childNodes.length > 0) {
colContainer.firstChild.setAttribute("index", i);
}
}
},
_buildColumnHeaders: function _buildColumnHeaders(groupType) {
var def = this._tableDefinition;
var cols = def.columns;
var colDivs = [];
var visibleColumnInfo;
var outerContainer = document.createElement("div");
outerContainer.className = "table-group-header";
var headerContainer = document.createElement("div");
var inline = groupType !== this._headerCSS;
headerContainer.className = "table-column-headers " + def.groupPosition.toLowerCase();
if (inline && def.showGroupHeaders) {
var groupText = document.createElement("div");
groupText.setAttribute("class", "group-text");
groupText.textContent = groupType;
outerContainer.appendChild(groupText);
}
outerContainer.appendChild(headerContainer);
var lastHeaderText = null;
for (var i = 0, l = cols.length; i < l; i++) {
var c = cols[i];
var displayString = c.hideHeader ? "" : cols[i].headerText;
var pri = c.priority;
var id = c.ID;
visibleColumnInfo = this._manager.getVisibleColumnInfo(id); 
var isSelected = this._selectedColumnHeader && (c.sortIdentifier === this._selectedColumnHeader.sortIdentifier);
var sc = isSelected ? this._selectedColumnSelectionCount : 0;
var selected = c.selected || isSelected;
var colOptions = {
pri: pri,
id: id,
displayString: displayString,
selected: selected,
sortable: c.sortIdentifier,
initialSortDirDesc: c.initialSortDirDesc,
sortCount: sc,
classSpecifier: c.classSpecifier,
headerTemplate: c.headerTemplate
};
if (visibleColumnInfo && visibleColumnInfo.forceWidth) {
colOptions.width = visibleColumnInfo.width;
} 
if (i > 0 && visibleColumnInfo && (displayString || lastHeaderText)) {
var border = document.createElement("div");
border.className = "table-header-border";
headerContainer.appendChild(border);
}
var col = this._buildColumnHeader(colOptions);
headerContainer.appendChild(col);
lastHeaderText = displayString;
}
var headerSpace = document.createElement("div");
WinJS.Utilities.addClass(headerSpace, "table-header-space");
outerContainer.appendChild(headerSpace);
return outerContainer;
},
_getSortDir: function _getSortDir(defaultDescending, iteration) {
var isSame = ((iteration || 0) + (defaultDescending ? 1 : 0)) % 2;
var classes = [this._asc, this._desc];
return classes[isSame];
},
_getSortDirIdentifier: function _getSortDirIdentifier(defaultDescending, iteration) {
var isSame = ((iteration || 0) + (defaultDescending ? 1 : 0)) % 2;
var classes = ["Ascending", "Descending"];
return classes[isSame];
},
_setSelectedColumnHeader: function _setSelectedColumnHeader(elem, col) {
var children = elem.parentNode.querySelectorAll(".table-column-header");
var that = this;
this._loop(children, function (item) {
WinJS.Utilities.removeClass(item, that._selected);
WinJS.Utilities.removeClass(item, that._asc);
WinJS.Utilities.removeClass(item, that._desc);
item.removeAttribute("aria-sort");
});
var isDesc = col.initialSortDirDesc;
var elemRow = elem;
while (elemRow && !WinJS.Utilities.hasClass(elemRow, "table-row")) {
elemRow = elemRow.parentNode;
}
var groupLabel = elemRow && elemRow.getAttribute("row");
var previous = this._selectedColumnHeader;
if (previous) {
var rows = that._scroller.querySelectorAll("[column='" + previous.ID + "']");
for (var i = 0, l = rows.length; i < l; i++) {
var row = rows[i];
if (row.parentNode && row.parentNode.getAttribute("sorted")) {
var rowElem = row;
while (rowElem && !WinJS.Utilities.hasClass(rowElem, "table-row")) {
rowElem = rowElem.parentNode;
}
var rowLabel = rowElem && rowElem.getAttribute("row");
if (!groupLabel || !rowLabel || rowLabel === groupLabel) {
row.parentNode.removeAttribute("sorted");
}
}
}
}
var iteration = 0;
if (previous && previous.sortIdentifier === col.sortIdentifier) {
iteration = this._selectedColumnSelectionCount + 1;
}
var direction = this._getSortDir(isDesc, iteration);
WinJS.Utilities.addClass(elem, this._selected + " " + direction);
var ariaDirection = direction === this._desc ? "descending" : "ascending";
elem.setAttribute("aria-sort", ariaDirection);
this._selectedColumnHeader = col;
this._selectedColumnSelectionCount = iteration;
},
_buildColumnHeader: function _buildColumnHeader(colOptions) {
var that = this;
var pri = colOptions.pri;
var id = colOptions.id;
var displayString = colOptions.displayString;
var sortable = colOptions.sortable;
var isSelected = colOptions.selected;
var expander = document.createElement("div");
WinJS.Utilities.addClass(expander, "table-header-expander");
var columnHeader = document.createElement("div");
expander.appendChild(columnHeader);
var additionalClassName = " " + (sortable ? this._sortable : "") + " " + (isSelected ? this._selected : "");
if (sortable) {
additionalClassName += " " + this._getSortDir(colOptions.initialSortDirDesc, colOptions.sortCount);
PlatformJS.Utilities.enablePointerUpDownAnimations(columnHeader);
}
if (colOptions.classSpecifier) {
additionalClassName += " " + colOptions.classSpecifier;
}
columnHeader.setAttribute("priority", "P" + pri);
columnHeader.setAttribute("column", id);
columnHeader.setAttribute("class", "table-column-header " + additionalClassName);
columnHeader.setAttribute("role", "columnheader");
columnHeader.setAttribute("tabindex", 0);
var previous = this._selectedColumnHeader;
if (colOptions.selected) {
var dir = this._getSortDir(colOptions.initialSortDirDesc, colOptions.sortCount);
var ariaDirection = dir === this._desc ? "descending" : "ascending";
columnHeader.setAttribute("aria-sort", ariaDirection);
columnHeader.setAttribute("selected", "selected");
}
var itemToRender = { backingField0: displayString };
var template = new WinJS.Binding.Template(colOptions.headerTemplate);
template.render(itemToRender, columnHeader);
var onColClick = function (e) {
var item = e.currentTarget;
var colId = item.getAttribute("column");
if (!colId && item.children.length > 0) {
colId = item.children[0].getAttribute("column"); // parent was clicked. 
}
if (!colId) {
return;
}
var def = that._tableDefinition.columns;
var col = null;
for (var i = 0, l = def.length; i < l; i++) {
col = def[i];
if (col.ID === colId) {
break;
}
}
if (that._manager && that._manager.getVisibleColumnInfo(colId)) {
if (col.sortIdentifier) {
that._setSelectedColumnHeader(item, col);
}
item.setAttribute("selected", "selected");
that._saveFocusedElement();
that.isNextColClick = true;
that._tableDefinition.onColumnHeaderClick(item, col, col.initialSortDirDesc);
}
};
var onColKeyUp = function (e) {
switch (e.keyCode) {
case 13: onColClick(e); break;
default: break;
}
};
expander.addEventListener("click", onColClick);
columnHeader.addEventListener("keydown", this._onColHeaderKeyDown.bind(this));
columnHeader.addEventListener("keyup", onColKeyUp);
return expander;
},
_buildAggregateTemplate: function _buildAggregateTemplate() {
var that = this;
var columns = this._tableDefinition.columns;
var aggregateTemplate = [];
var numBF = 0;
var backingFieldMap = [];
var visibleColumnInfo;
var lastHeaderText = null;
var gridBorder = document.createElement("div");
gridBorder.setAttribute("class", "table-grid-border");
var gridBorderHTML = gridBorder.outerHTML;
for (var index = 0, l = columns.length; index < l; index++) {
var column = columns[index];
if (!column || !column.fieldTemplate) {
continue;
}
visibleColumnInfo = that._manager.getVisibleColumnInfo(column.ID);
var colTemplate = column.fieldTemplate.innerHTML;
var bfRegex = /backingField(\d+)/gi;
var result = bfRegex.exec(colTemplate);
backingFieldMap[index] = [];
var fIndex = 0;
while (result) {
var str = result[0];
var bfIndex = parseInt(result[1]);
backingFieldMap[index][bfIndex] = fIndex++;
// (?!\\d) is a lookahead operator which makes sure there's not a digit following the regex
// this is necessary so 'backingField1' and 'backingField11' don't both get caught.
colTemplate = colTemplate.replace(new RegExp(str + "(?!\\d)", "g"), "bf" + numBF);
result = bfRegex.exec(colTemplate);
numBF++;
}
var elem = document.createElement("div");
elem.setAttribute("class", "table-column " + (column.classSpecifier ? column.classSpecifier : ""));
elem.setAttribute("priority", "P" + column.priority);
elem.setAttribute("column", column.ID);
elem.setAttribute("role", "gridcell");
if (colTemplate.toLowerCase().indexOf("tabindex") === -1) {
// apps are inconsistently setting tab index, and we can't have dupes
// so we need to check first
elem.setAttribute("tabindex", "0");
}
elem.setAttribute("aria-label", column.headerText);
// there is no column=  css rule for the column so the width was dynamically figured out so force it here.
if (visibleColumnInfo && visibleColumnInfo.forceWidth) {
elem.style.width = visibleColumnInfo.width;
}
MSApp.execUnsafeLocalFunction(function () {
elem.innerHTML = colTemplate;
});
var container = document.createElement("div");
var headerText = column.headerText;
container.setAttribute("class", "table-grid-expander");
container.appendChild(elem);
container.setAttribute("aria-label", headerText);
if (index > 0 && (headerText || lastHeaderText)) {
aggregateTemplate.push(gridBorderHTML);
}
aggregateTemplate.push(container.outerHTML);
lastHeaderText = headerText;
};
var templateHtml = document.createElement("div");
templateHtml.setAttribute("data-win-control", "WinJS.Binding.Template");
MSApp.execUnsafeLocalFunction(function () {
templateHtml.innerHTML = aggregateTemplate.join("");
});
WinJS.UI.processAll(templateHtml); 
this._rowTemplate = new WinJS.Binding.Template(templateHtml);
this._rowBackingInfo = backingFieldMap;
},
_isInlineGroup: {
get: function get() {
return this._tableDefinition ? this._tableDefinition.GroupPosition === CommonJS.groupPositionEnum.inline : false;
}
},
_itemClickProxyHandler: function _itemClickProxyHandler(element) {
return WinJS.Utilities.hasClass(element, "table-row");
}, 
_setRowAttributesAndHooks: function _setRowAttributesAndHooks(row, index) {
row.setAttribute("index", index);
if (this._tableDefinition.hasExpando) {
row.setAttribute("aria-expanded", false);
};
row.setAttribute("aria-label", STRINGS.ROW + " " + (index + 1)); // TODO: Use rowheaders
// adding the automationid if it isn't cluster table
if (!this._isTableCluster) {
row.setAttribute("id", "row" + "_" + (index + 1));
}
row.setAttribute("tabindex", 0);
if (!row.rowHooked) {
// avoid hoooking a row multiple times.  Otherwise we can get case of
// the rowhandlers being called multiple times after sorting.
PlatformJS.Utilities.registerItemClickProxy(row, this._itemClickProxyHandler, this._onRowClickedBind);
row.addEventListener("keydown", this._onRowKeyDownHandlerBind);
PlatformJS.Utilities.enablePointerUpDownAnimations(row);
row.rowHooked = true;
}
row.innerHTML = "";
}, 
_getContainer: function _getContainer(index) { 
var row = this._containers[index];
this._setRowAttributesAndHooks(row, index);
row.parentNode.style.display = "block"; 
return row;
},
_buildContainers: function _buildContainers(items, groups) { 
if (!this._containers) {
this._containers = [];
}
var numGroups = 0;
if (this._isInlineGroup) {
numGroups = groups;
}
var existingLen = this._containers.length;
var newLength = items;
var index,
row,
container;
var newRows = newLength + numGroups;
// add extra containers to the DOM, we will need them.
if (existingLen === 0) {
var placeHolderTable = this._createClassElement("div", this._cssPrefix + "table");
for (index = 0; index < newRows; index++) {
row = this._createClassElement("div", "table-row");
container = this._createClassElement("div", "table-container");
row.setAttribute("role", "row");
container.appendChild(row);
placeHolderTable.appendChild(container);
this._containers.push(row);
}
this._scroller.removeChild(this._table);
this._scroller.appendChild(placeHolderTable);
this._table = placeHolderTable;
} else {
if (existingLen < newRows) {
for (index = this._containers.length; index < newRows; index++) {
row = this._createClassElement("div", "table-row");
container = this._createClassElement("div", "table-container");
row.setAttribute("role", "row");
container.appendChild(row);
this._table.appendChild(container);
this._containers.push(row);
}
} else if (existingLen > newRows) { // we already have more than we need, remove the extras
for (index = newRows; index < existingLen; index++) {
row = this._containers[index]; 
try {
row.removeEventListener("keydown", this._onRowKeyDownHandlerBind);
PlatformJS.Utilities.disablePointerUpDownAnimations(row);
// dont need to clean up registerItemClickProxy  since local function binds no cycles
} catch (err) { 
}
var ctr = row.parentNode;
ctr.parentNode.removeChild(ctr);
};
this._containers.length = newRows; 
}
}
// erase previous containers 
var l = Math.min(existingLen, this._containers.length);
for (index = 0; index < l; index++) { 
this._containers[index].innerHTML = "";
}
},
_getExpando: function _getExpando(container) {
var results = container.parentNode.querySelectorAll(this._expandoQuerySelector);
if (results.length && results.length === 1) {
return results[0];
}
if (results.length === 0) {
return null;
}
return results;
},
_hideExpandoForContainer: function _hideExpandoForContainer(container, isCleanOperation) {
/// <param name="isCleanOperation" optional="true"/>
var expando = this._getExpando(container);
var row = expando.parentNode.querySelector(".table-row");
var entityIndex = parseInt(row.getAttribute("entity"));
if (isNaN(entityIndex)) {
throw "error, entityIndex is out of bounds";
}
WinJS.Utilities.removeClass(container, "row-expando");
expando.parentNode.removeChild(expando);
// if its a clean operation, we only want to hide the expando
// the data doesn't need to be rebound, because the next render
// pass will have new data anyway
if (isCleanOperation) {
return;
}
var item = this._getItem(this.dataSource, entityIndex).data;
this._renderEntityToRow(item, row);
},
_createExpandoForContainer: function _createExpandoForContainer(container) {
var expando = document.createElement("div");
expando.setAttribute("class", this._cssPrefix + "expando expando-collapsed");
var that = this;
var capturedPtr = null;
var onSwipe = function (evt) {
if (!evt.isVertical) {
that._suppressCapture = true;
expando.focus();
that.disablePointerCapture = true;
try {
expando.msSetPointerCapture(evt.pointer.pointerId);
}
catch (e) {
// someone else got capture before us. if this element is in semantic zoom, that's most likely what happened.
// see ui.js in winjs sdk for similar patterns of try/catching msSetPointerCapture
};
}
};
var leave = function () {
that._suppressCapture = false;
};
PlatformJS.Utilities.registerSwipeProxy(expando, onSwipe, null, leave);
WinJS.Utilities.addClass(container, "row-expando");
container.parentNode.appendChild(expando);
// First of all, we shouldn't really need this scrolling logic,
// a scrolling container should scroll by default if it has focus
// so something screwy is going on. Until we figure that out lets
// explicitly handle keyboard scrolling. Secondly, this scrolling logic
// should maybe belong in app code, pending further investigation.
expando.addEventListener("keydown", function (event) {
switch (event.keyCode) {
case WinJS.Utilities.Key.rightArrow:
this.scrollLeft += 50;
break;
case WinJS.Utilities.Key.leftArrow:
this.scrollLeft -= 50;
break;
case WinJS.Utilities.Key.pageDown:
this.scrollLeft += this.clientWidth;
// prevent whole table from scrolling
event.preventDefault();
break;
case WinJS.Utilities.Key.pageUp:
this.scrollLeft -= this.clientWidth;
// prevent whole table from scrolling
event.preventDefault();
break;
case WinJS.Utilities.Key.home:
this.scrollLeft = 0;
// prevent whole table from scrolling
event.preventDefault();
break;
case WinJS.Utilities.Key.end:
this.scrollLeft = this.scrollWidth;
// prevent whole table from scrolling
event.preventDefault();
break;
default: break;
}
});
return expando;
}, 
_createClassElement: function _createClassElement(type, className, id) {
/// <param name="id" optional="true"/>
var obj = document.createElement(type);
if (className) {
obj.setAttribute("class", className);
}
if (id) {
obj.setAttribute("id", id);
}
return obj;
},
_attachPreserveContext: function _attachPreserveContext(dom, event, fn) {
/// <param name="fn" optional="true"/>
var that = this;
if (!fn) {
fn = "_on" + event[0].toUpperCase() + event.slice(1);
}
dom.addEventListener(event, function () {
that[fn].apply(that, arguments);
});
},
_onScroll: function _onScroll(event) {
var that = this;
var now = new Date();
if (this._isRenderComplete) {
return;
}
if (now - this._lastScrollTime < 400) {
if (!this._scrollTimeout) {
this._scrollTimeout = setTimeout(function () {
that._scrollTimeout = null;
that._onScroll.call(that, event);
}, 200);
}
return;
}
this._lastScrollTime = now;
var elem = this._scroller;
var scrollTop = elem.scrollTop;
if (!this._lastScrollFire) {
this._lastScrollFire = scrollTop;
return;
}
if (that._lastScrollFire > scrollTop) {
// scrolling upwards
return;
}
var elemHeight = this._elemOffsetHeight;
if (!elemHeight) {
this._elemOffsetHeight = elem.offsetHeight;
elemHeight = this._elemOffsetHeight;
}
var thresh = elemHeight / 4;
if (scrollTop - this._lastScrollFire < thresh) {
return;
}
if (this._scrollTimeout) {
clearTimeout(this._scrollTimeout);
this._scrollTimeout = null;
}
this._lastScrollFire = scrollTop;
if (this._approximateRenderedHeight - scrollTop < 4 * elemHeight) {
// if we have less than 4 screens worth of data left, get more
this._renderUIDelay = msSetImmediate(that._renderNextChunk.bind(that));
}
},
_render: function _render(entities) {
},
_buildHeader: function _buildHeader(div) {
},
_onColHeaderKeyDown: function _onColHeaderKeyDown(event) {
// If TAB key is pressed, try setting focus on next/previous cluster
if (event.keyCode === WinJS.Utilities.Key.tab) {
if (event.shiftKey) {
this._setFocusOnPreviousCluster();
} else {
this._setFocusOnNextCluster();
}
} else if (PlatformJS.Utilities.isCursorKey(event.keyCode)) { // Else listen for arrow key events
event.preventDefault();
event.stopPropagation();
switch (event.keyCode) {
case WinJS.Utilities.Key.rightArrow:
this._setFocusOnNextColHeader(event.target);
break;
case WinJS.Utilities.Key.downArrow:
this._setFocusOnFirstRow();
break;
case WinJS.Utilities.Key.leftArrow:
this._setFocusOnPreviousColHeader(event.target);
break;
default:
break;
}
}
},
_onRowKeyDown: function _onRowKeyDown(event) {
var role = event.target.getAttribute("role");
if (role === "gridcell") {
this._onGridCellKeyDown(event);
} else {
var keyCode = event.keyCode;
if (PlatformJS.Utilities.isCursorKey(event.keyCode) || WinJS.Utilities.Key.space === keyCode) {
// Prevent cursor keys and spacebar from scrolling
event.preventDefault();
event.stopPropagation();
switch (keyCode) {
case WinJS.Utilities.Key.upArrow:
this._setFocusOnPreviousRow(event.target);
break;
case WinJS.Utilities.Key.rightArrow:
this._setFocusOnNextCluster();
break;
case WinJS.Utilities.Key.downArrow:
this._setFocusOnNextRow(event.target);
break;
case WinJS.Utilities.Key.leftArrow:
this._setFocusOnPreviousCluster();
break;
default:
break;
}
}
}
},
_onGridCellKeyDown: function _onGridCellKeyDown(event) {
var keyCode = event.keyCode;
if (keyCode === WinJS.Utilities.Key.tab) {
if (event.shiftKey) {
this._setFocusOnPreviousCluster();
} else {
// Attempt to drill-down and set focus on gridcell inner content
// If none exists, move to next cluster
this._setFocusOnGridcellContent(event.target) || this._setFocusOnNextCluster();
}
} else if (PlatformJS.Utilities.isCursorKey(keyCode) || WinJS.Utilities.Key.space === keyCode) {
// Prevent cursor keys and spacebar from scrolling
event.preventDefault();
event.stopPropagation();
switch (keyCode) {
case WinJS.Utilities.Key.upArrow:
this._setFocusOnColAbove(event.target);
break;
case WinJS.Utilities.Key.rightArrow:
this._setFocusOnNextCol(event.target);
break;
case WinJS.Utilities.Key.downArrow:
this._setFocusOnColBelow(event.target);
break;
case WinJS.Utilities.Key.leftArrow:
this._setFocusOnPreviousCol(event.target);
break;
default:
break;
}
}
},
_setFocusOnFirstColHeader: function _setFocusOnFirstColHeader() {
var firstColHeader = this._header.querySelector("[tabIndex='0']");
if (firstColHeader) {
firstColHeader.focus();
}
},
_setFocusOnColHeader: function _setFocusOnColHeader(colHeaderIndex) {
var colHeaders = this._header.querySelectorAll("[role='columnheader']");
if (colHeaders.length > 0) {
colHeaders[colHeaderIndex].focus();
}
},
_setFocusOnFirstRow: function _setFocusOnFirstRow() {
var firstRow = this._scroller.querySelector("[tabIndex='0']");
if (firstRow) {
firstRow.focus();
}
},
_setFocusOnNextCluster: function _setFocusOnNextCluster() {
CommonJS.NavigableView.dispatchBoundaryEvent(this._element, CommonJS.NavigableView.Direction.RIGHT);
},
_setFocusOnPreviousCluster: function _setFocusOnPreviousCluster() {
CommonJS.NavigableView.dispatchBoundaryEvent(this._element, CommonJS.NavigableView.Direction.LEFT);
},
_setFocusOnColAbove: function _setFocusOnColAbove(currentCol) {
var colIndex = currentCol.getAttribute("index") || 0,
currentRow = this._getCurrentRow(currentCol),
rowAbove = this._getPreviousRow(currentRow);
if (rowAbove) {
var column = this._getCol(rowAbove, colIndex);
if (column) {
column.focus();
}
} else {
// If there's no row above, we must be at the top of scroller
this._setFocusOnColHeader(colIndex);
}
},
_setFocusOnColBelow: function _setFocusOnColBelow(currentCol) {
var currentRow = this._getCurrentRow(currentCol),
rowBelow = this._getNextRow(currentRow);
if (rowBelow) {
var colIndex = currentCol.getAttribute("index") || 0,
column = this._getCol(rowBelow, colIndex);
if (column) {
column.focus();
}
}
else {
// If there's no rowBelow we must be at bottom. Do nothing.
}
},
_setFocusOnCurrentRow: function _setFocusOnCurrentRow(currentCol) {
var success = false,
currentRow = this._getCurrentRow(currentCol);
if (currentRow) {
currentRow.focus();
success = true;
}
return success;
},
_setFocusOnNextRow: function _setFocusOnNextRow(currentRow) {
var nextRow = this._getNextRow(currentRow);
if (nextRow) {
nextRow.focus();
} else {
// If there's no next row we must be at bottom. Do nothing.
}
},
_setFocusOnPreviousRow: function _setFocusOnPreviousRow(currentRow) {
var previousRow = this._getPreviousRow(currentRow);
if (previousRow) {
previousRow.focus();
} else {
// If there's no row above, we must be at the top of scroller
this._setFocusOnFirstColHeader();
}
},
_setFocusOnNextColHeader: function _setFocusOnNextColHeader(currentCol) {
var nextCol = this._getNextCol(currentCol);
if (nextCol) {
nextCol.focus();
} else {
// If there's no next col, we must be at far edge
this._setFocusOnNextCluster();
}
},
_setFocusOnPreviousColHeader: function _setFocusOnPreviousColHeader(currentCol) {
var previousCol = this._getPreviousCol(currentCol);
if (previousCol) {
previousCol.focus();
} else {
// If there's no previous col, we must be at near edge
this._setFocusOnPreviousCluster();
}
},
_setFocusOnNextCol: function _setFocusOnNextCol(currentCol) {
var nextCol = this._getNextCol(currentCol);
if (nextCol && nextCol.tabIndex >= 0) {
nextCol.focus();
} else {
// If there's no next col, we must be at far edge. We drill back up to row focus
this._setFocusOnCurrentRow(currentCol);
}
},
_setFocusOnPreviousCol: function _setFocusOnPreviousCol(currentCol) {
var previousCol = this._getPreviousCol(currentCol);
if (previousCol && previousCol.tabIndex >= 0) {
previousCol.focus();
} else {
// If there's no previous col, we must be at near edge. We drill back up to row focus.
this._setFocusOnCurrentRow(currentCol);
}
},
// Attempts to drill-down and set focus on first content with tabindex
_setFocusOnGridcellContent: function _setFocusOnGridcellContent(col) {
var success = false;
if (col) {
var content = col.querySelector("[tabIndex='0']");
if (content) {
content.focus();
success = true;
}
}
return success;
},
_getCol: function _getCol(row, colIndex) {
var column = null,
columnContainer = null,
columns = row.childNodes;
if ((columns.length > 0) && (colIndex < columns.length)) {
columnContainer = columns[colIndex];
column = columnContainer.firstChild;
}
return column;
},
_getCurrentRow: function _getCurrentRow(currentCol) {
var element = currentCol;
while (element && element.getAttribute("role") !== "row") {
element = element.parentElement;
}
return element;
},
_getPreviousRow: function _getPreviousRow(currentRow) {
var previousRow = null,
previousRowContainer = currentRow.parentElement.previousElementSibling;
if (previousRowContainer && previousRowContainer.childNodes.length > 0) {
previousRow = previousRowContainer.firstChild;
}
return previousRow;
},
_getNextRow: function _getNextRow(currentRow) {
var nextRow = null,
nextRowContainer = currentRow.parentElement.nextElementSibling;
if (nextRowContainer && nextRowContainer.childNodes.length > 0) {
nextRow = nextRowContainer.firstChild;
}
return nextRow;
},
_getNextCol: function _getNextCol(currentCol) {
var nextCol = null,
nextColContainer = currentCol.parentElement.nextElementSibling;
if (nextColContainer && nextColContainer.childNodes.length > 0) {
nextCol = nextColContainer.firstChild;
}
return nextCol;
},
_getPreviousCol: function _getPreviousCol(currentCol) {
var previousCol = null,
previousColContainer = currentCol.parentElement.previousElementSibling;
if (previousColContainer && previousColContainer.childNodes.length > 0) {
previousCol = previousColContainer.firstChild;
}
return previousCol;
}
})
});
})();
CommonJS.Table.GroupPosition = {
top: "top",
inline: "inline"
};
/* File: tableDefinition.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
WinJS.Namespace.define("CommonJS.Table", {
TableDefinition: WinJS.Class.define(function (options) {
this.itemSpacing = {
min: 25,
max: 150
};
this.groupPosition = CommonJS.Table.GroupPosition.inline;
this.showColumnHeaders = false;
this.showGroupHeaders = true;
this.columns = [];
this.groupTemplate = document.querySelector(".listHeaderTemplate");
}, {
itemSpacing: null,
columns: null,
groupPosition: null,
groupTemplate: null,
rowSpacing: null,
showGroupHeaders: null,
showColumnHeaders: null,
isAutoSizeTable: false, 
cssWhiteList: [],   // if the css href contains the string then is accepted.  
})
});
})();
CommonJS.Table.GroupPosition = {
top: "top",
inline: "inline"
};
/* File: tableManager.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
WinJS.Namespace.define("CommonJS.Table", {
//
// CommonJS.Table.TableManager calculates the columns to set visible and the ones to hide based on actual container width and column width from the css file.
//
TableManager: WinJS.Class.define(function (container, tableDefinition, tableController) {
this.container = container; 
this.tableDefinition = tableDefinition;
this._initalizeMarketAvgCharWidth();
this.attachListeners();
this.tableController = tableController;
}, {
disableUpdates: true,
tableDefinition: null,
container: null,
_columnWidths: {}, 
_layoutUpdatedDelay: null,
_layoutUpdatedPtr: null,
_elemOffsetHeight: null,
_lastMeasuredWidth: null, 
_visibleColumns: {},
_rules: {},
_activeStyleSheet: null,  // stylesheet to put priorities on. determined as stylesheet of first columnID
_sortIconWidth: 20,
_avgMarketCharWidth: 8, // default is 8.  is overriden in resource string via _initalizeMarketAvgCharWidth
_autoSizingPaddingLeft: 10,
attachListeners: function attachListeners() {
if (!this._layoutUpdatedPtr) {
this._layoutUpdatedPtr = this.onLayoutUpdated.bind(this);
this.container.attachEvent("onresize", this._layoutUpdatedPtr);
this.update();
}
},
destroy: function destroy() {
if (this._layoutUpdatedPtr) {
this.container.detachEvent("onresize", this._layoutUpdatedPtr);
this._layoutUpdatedPtr = null;
}
if (this._layoutUpdatedDelay) {
msClearImmediate(this._layoutUpdatedDelay);
}
},
onLayoutUpdated: function onLayoutUpdated() {
var that = this;
this._layoutUpdatedDelay = msSetImmediate(function () {
that.update();
that._elemOffsetHeight = null;
that.tableController.delayedLayoutUpdated.call(that.tableController);
});
}, 
update: function update(forceRecalcOfColumns, ds) {
if (!this.tableDefinition) {
return;
}
var containerWidth = this._getContainerWidth();
if (!forceRecalcOfColumns) {
if (this._lastMeasuredWidth === containerWidth || this.disableUpdates) {
return;
}
} 
this._lastMeasuredWidth = containerWidth;
this._visibleColumns = {};
this._makePriorityRules();
var columnRules = this._getColumnsByPriority().reverse();
var totalWidth = containerWidth - 1;
var measuredWidth = 0;
var visibleColumnsCnt = 0;
var minRowWidth = 0;
var td = this.tableDefinition;
var minColSpacing = td.itemSpacing.min;
var maxColSpacing = td.itemSpacing.max; 
for (var i = 0, l = columnRules.length; i < l; i++) { 
var col = columnRules[i];
var pri = this._priorities[col.priority];
//var pri = this._getCSSColumnRule("[priority=P" + col.priority + "]");
var colCalc = this.getColumnWidth(col, td, ds);
// every column but the last will have a variable padding to the right
var thisColWidth = colCalc.width + (i === l - 1 ? 0 : minColSpacing);
if ((minRowWidth + thisColWidth) < totalWidth || i === 0 /* always show 1 column */) {
console.log("Show " + col.ID);
pri.style.cssText = "display: -ms-grid; -ms-grid-columns: 1fr auto;";
visibleColumnsCnt++;
this._setVisibleColumnInfo(col.ID, colCalc.width + "px", colCalc.forceWidth);
minRowWidth += thisColWidth;     // measure the row so far
measuredWidth += colCalc.width;  // measure just the width of the columns
} else {
console.log("Hide " + col.ID);
pri.style.display = "none";
}
}
// subtract 1 column from colSpacing math because last column doesn't get padding to the right
var minWidth = measuredWidth + (visibleColumnsCnt - 1) * minColSpacing + "px";
var maxWidth = measuredWidth + (visibleColumnsCnt - 1) * maxColSpacing + "px";
var styleObj = "min-width: " + minWidth + "; max-width: " + maxWidth;
var sheet = this._getSheet();
if (sheet) {
//sheet.addRule(".table-column-headers", styleObj);
sheet.addRule(".table-row", styleObj);
}
},
getColumnWidth: function getColumnWidth(col, td, ds) {                
if (!td.isAutoSizeTable && !col.isAutoSizeColumn) {
var column = this._getCSSColumnRule("[column=" + col.ID.toLowerCase() + "]", "width");
if (column) {
return {
width: this._getRuleWidth(column),
forceWidth: false
};
}
}
var colCalcInfo = this._calcMinWidthChar(col, ds); 
return {
// add 20% buffer to deal with it being highlighted
// add 10px since we have 10px paddingLeft by default for auto-sizing table
width: (Math.max(colCalcInfo.dataItemWidth, colCalcInfo.titleWidth + this._sortIconWidth) + this._autoSizingPaddingLeft) * 1.20,
forceWidth: true
};
},
getVisibleColumnInfo: function getVisibleColumnInfo(id) {
return this._visibleColumns[id];
},
_setVisibleColumnInfo: function _setVisibleColumnInfo(id, width, forceWidth) {
this._visibleColumns[id] = { width: width, forceWidth: forceWidth };
},
_getAndScaleCssColWidth: function _getAndScaleCssColWidth(id) {
var column = this._getCSSColumnRule("[column=" + id.toLowerCase() + "]", "width");
if (!column) {
return 0;
}
var width = this._getRuleWidth(column);
return width;
},
_getCSSColumnRule: function _getCSSColumnRule(ruleText, requiredStyle) {
/// <param name="requiredStyle" optional="true"/>
var column = ruleText.toLowerCase();
var that = this;
if (this._rules[column]) {
return this._rules[column];
}
var possibleRules = [];
var cssSheets = document.styleSheets;
/* for each css doc loaded */
/* heuristic:  for specifc rules are in the later loaded sheets.
so lets start looking from last sheet and work backwards
we will stop when we find rules that match.
*/
var isStringInPartialList = function (partialMatchList, testString) {
testString = testString.toLowerCase();
for (var i = 0; i < partialMatchList.length; i++) {
if (testString.indexOf(partialMatchList[i].toLowerCase()) > -1) {
return true;
}
}
return false;
};
var blackList = ["winjs", "immersive", "articlereader.css", "autosuggest.css", "dateselector.css", "interactivemap.css", "mediaplayback.css", "slideshow.css"];
for (var sheetIndex = cssSheets.length - 1; sheetIndex >= 0; sheetIndex--) {
var sheet = cssSheets[sheetIndex];
if (sheet.href) {
var href = sheet.href.toLowerCase();
if (isStringInPartialList(blackList, href)) {
continue;
}
var whiteList = this.tableDefinition.cssWhiteList;
if (whiteList && whiteList.length > 0) {
if (!isStringInPartialList(whiteList, href)) {
continue;
}
}
}
var rules = sheet.cssRules;
for (var ruleIndex = 0, ruleLength = rules.length; ruleIndex < ruleLength; ruleIndex++) {
var rule = rules[ruleIndex];
/*check to see if its our rule*/
var selector = rule.selectorText;
if (!selector) {
continue;
}
selector = selector.toLowerCase();
if (selector && selector.indexOf(column) >= 0) {
var selectorText = rule.selectorText;
var element = that.container.querySelector(selectorText);
if (element) {
if (requiredStyle && rule.style[requiredStyle].length === 0) {
continue;
}
possibleRules.push(rule);
}
}
}
if (possibleRules.length > 0) {
// found rules that match, dont check other css files.
break;
}
}
if (possibleRules.length === 0) {
return null;  // TODO add fix  so dont keep searching on null entries...
}
if (possibleRules.length === 1) {
this._rules[column] = possibleRules[0];
return this._rules[column];
}
var bestCssSpecificity = 0;
var bestRule = null;
for (var i = 0; i < possibleRules.length; i++) {
var specificity = this._calcCssSpecificity(possibleRules[i]);
if (specificity > bestCssSpecificity) {
bestCssSpecificity = specificity;
bestRule = possibleRules[i];
}
}
this._rules[column] = bestRule;
return bestRule;
},
_calcCssSpecificity: function _calcCssSpecificity(cssRule) {
// poor heuristic but works because usually the additional specifity is longer , 
// but partially solves problem about multiple matches due to language /league etc
// Replace with better specificty calculator if needed
return cssRule.selectorText.length;
}, 
_getColumnWidth: function _getColumnWidth(ID) {
/* assumptions: all fields are the same width for a given column */
var rule = this._getCSSColumnRule("[column=" + ID.toLowerCase() + "]", "width");
/* column widths are ALWAYS expressed in px */
return this._getRuleWidth(rule);
},
_priorities : {},
_makePriorityRules: function _makePriorityRules() {
var priorities = this._getColumnPrioritylist();
for (var i = 0; i < priorities.length; i++) {
var prop = "[priority=P" + priorities[i] + "]";
this._priorities[priorities[i]] = this._makeCssProperty(prop, "display:block;");
}
}, 
_getRuleWidth: function _getRuleWidth(rule) {
if (rule) {
var width = parseInt(rule.style.width.replace("px", ""));
return width;
} else {
return 0;
}
},
_getSheet: function _getSheet() {
if (this._activeStyleSheet) {
return this._activeStyleSheet;
}
var ids = this._getColumnIDs();
for (var index = 0; index < ids.length; index++) {
var column = ids[index];
if (!column) {
continue;
}
var id = column.toLowerCase();
var rule = this._getCSSColumnRule("[column=" + id + "]", "width");
if (rule) {
this._activeStyleSheet = rule.parentStyleSheet;
break;
}
}
return this._activeStyleSheet;
},
_getContainerWidth: function _getContainerWidth() {
var ctr = this.container;
var minWidth = 100;
var width = minWidth;
/*in semantic zoom, the zoomed in container is initialized to a width
of 50px until the semantic zoom control has finished rendering, and then
the width of the zoomed in control is equal the width of the semantic
zoom control. so if we encounter a width which is smaller than the minwidth
we will walk the tree until we find a container which exceeds the minwidth
we specified. */
var itemWidth = ctr.offsetWidth;
var isTooSmall = true;
while (isTooSmall) {
if (!ctr.parentNode) {
break;
}
ctr = ctr.parentNode;
var ctrWidth = ctr.offsetWidth;
if (ctrWidth > minWidth) {
isTooSmall = false;
}
width = ctrWidth;
}
return width;
},
_makeCssProperty: function _makeCssProperty(selectorText, cssValue) {
var exists = this._getCSSColumnRule(selectorText);
if (exists) {
return exists;
}
var sheet = this._getSheet();
if (!sheet) {
// getSheet looks for the sheet with column=0[]
sheet = document.styleSheets[document.styleSheets.length - 1];
}
if (sheet) {
sheet.addRule(selectorText, cssValue);
var rule = sheet.rules[sheet.rules.length - 1];
if (rule.selectorText === selectorText) {
this._rules[selectorText.toLowerCase()] = rule;
} else {
rule = this._getCSSColumnRule(selectorText);
}
return rule;
}
return null;
},   
_getColumnIDs: function _getColumnIDs() {
var cols = this.tableDefinition.columns;
var len = cols.length;
var ids = [];
for (var i = 0; i < len; i++) {
ids.push(cols[i].ID);
}
return ids;
},
_getColumnsByPriority: function _getColumnsByPriority() {
var cols = this.tableDefinition.columns;
var len = cols.length;
var ids = [];
for (var i = 0; i < len; i++) {
ids.push(cols[i]);
}
ids.sort(function (a, b) {
var dir = b.priority - a.priority;
return dir;
});
return ids;
},
_getColumnPrioritylist: function _getColumnPrioritylist() {
var cols = this.tableDefinition.columns;
var len = cols.length;
var priorities = [];
for (var i = 0; i < len; i++) {
priorities.push(parseInt(cols[i].priority));
}
priorities.sort(function (a, b) {
var dir = b - a;
return dir;
});
return priorities;
},
_calcMinWidthChar: function _calcMinWidthChar(col, dataSource) {
//TODO need to handle images special  
var id = col.ID;
var maxWidth = 0;
var maxItem = "";
if (dataSource) {
for (var j = 0; j < dataSource._list.length; j++) {
var item = dataSource._list.getItem(j);
if (item && item.data && item.data[id]) {
var dataItemWidth = item.data[id].length;
if (dataItemWidth > maxWidth) {
maxWidth = dataItemWidth;
maxItem = item.data[id];
}
}
}
}
var avgCharWidth = this._getAvgCharWidth(id);
var results = {
id: id,
title: col.headerText,
titleWidth: col.headerText.length * avgCharWidth,
dataItem: maxItem,
dataItemWidth: maxWidth * avgCharWidth
};
return results;
}, 
_getAvgCharWidth: function _getAvgCharWidth(columnID) {
// should calculate based on any settings regarding font_size / font-weight for this column.
return this._avgMarketCharWidth;
},
_initalizeMarketAvgCharWidth: function _initalizeMarketAvgCharWidth() {
var width = PlatformJS.Services.resourceLoader.getString("/Common/AverageMarketCharacterSizePx");
if (width) {
width = parseInt(width);
if (!isNaN(width) && width > 2 && width < 20) {
this._avgMarketCharWidth = width;
} 
}
} 
}),
});
})();
