﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: uiconfig.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function appexCommonControlsECUIConfigInit () {
"use strict";
WinJS.Namespace.define("CommonJS.EntityCollection", {
UIConfig: WinJS.Class.define(function uiConfig_ctor (options) {
//ctor
WinJS.UI.setOptions(this, options);
}, {
GetEntityTemplate: function GetEntityTemplate(view) {
return document.querySelector(".itemTemplate");
},
GetDataAttributionText: function GetDataAttributionText() {
return "<h3>this is an attribution</h3>";
},
GetHeaderTemplate: function GetHeaderTemplate(view) {
switch (view) {
case CommonJS.EntityCollection.Views.Grid:
return document.querySelector(".headerTemplate");
//break;
default:
return document.querySelector(".listHeaderTemplate");
// break;
}
},
HideAppBar: function HideAppBar() {
return false;
},
GetSemanticZoomEntityTemplate: function GetSemanticZoomEntityTemplate(view) {
return document.querySelector("#semanticZoomTemplate");
},
GetListRendererTemplate: function GetListRendererTemplate(view) {
return document.querySelector(".listTemplate");
},
GetViewOptions: function GetViewOptions(view) {
var options = {};
/* this sample shows how to enable multiselect for the grid view of ECV */
switch (view) {
case CommonJS.EntityCollection.Views.Grid:
//  options.selectionMode = "multi";
// options.disableClearFilters = true;
// options.disableTap = true;
break;
}
return options;
},
GetAppBarItems: function GetAppBarItems(controller) {
/*must return an array of CommonJS.Button options objects controller is passed in so consumer can grab handles to entities, sort, fitler, etc in their callbacks*/
var buttons = [];
var onSampleItemClicked = function (item) {
var items = controller.currentView.getSelectedItems();
controller.currentView.clearSelection();
console.log("test button clicked");
};
var multiSelect = {
icon: "iconHome",
title: "test button",
onclick: onSampleItemClicked
};
// for testing only
//  buttons.push(multiSelect);
return buttons;
},
getLocalizedStringPrefix: function getLocalizedStringPrefix() {
return "";
},
onNavigateAway: function onNavigateAway() {
},
setSelectionAppBar: function setSelectionAppBar(domElement, sort, filters, controller) {
// you have access to the selection app bar.
// you populate it with whatever you want, clear filters is already there
},
onSelectionChanged: function onSelectionChanged(changedItems) {
console.log(changedItems.length + " items are selected");
},
onSelectionChanging: function onSelectionChanging(changingItems) {
console.log(changingItems.length + " items are changing");
},
getSleepDuration: function getSleepDuration() {
/*any value zero or lower means don't sleep ever*/
/*value is in milliseconds*/
return 0;
},
OnItemClicked: function OnItemClicked() {
console.log("item clicked");
return false;
},
GetSupportedViews: function GetSupportedViews() {
return {
list: [CommonJS.EntityCollection.Views.Grid],
defaultView: CommonJS.EntityCollection.Views.Grid
};
},
GetTableDefinition: function GetTableDefinition(entities) {
var td = new CommonJS.Table.TableDefinition();
var testFields = ["title", "id", "group"];
for (var i = 0, len = testFields.length; i < len; i++) {
var colDefinition = new CommonJS.Table.ColumnDefinition();
colDefinition.headerText = testFields[i];
colDefinition.priority = i;
colDefinition.boundField = testFields[i];
colDefinition.ID = testFields[i];
td.columns.push(colDefinition);
}
var imgDefinition = new CommonJS.Table.ColumnDefinition();
imgDefinition.fieldTemplate = document.querySelector(".imageFieldTemplate");
imgDefinition.priority = 100;
imgDefinition.boundField = "image";
imgDefinition.ID = "image";
td.columns.push(imgDefinition);
td.groupPosition = "top";
//   td.GroupPosition = "inline"; //can also be "top"
return td;
},
SetFilterType: function SetFilterType(filter) {
/*this is where you would have code that specifies for a given filter id (e.g. stock), to set the type to "horizontal".
if you do nothing, it will default to multi Option
filter.type = "DropDown" or "Toggle";
filter.selectionMode = "Multiple" or "SingleToggle";
*/
filter.type = "DropDown";
if (filter.attribute !== "Sort") {
filter.selectionMode = "Multiple";
} else {
filter.selectionMode = "SingleToggle";
}
}
})
});
CommonJS.EntityCollection.Views =
{
Grid: 1,
List: 2,
Map: 4
};
})();
