﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: Cluster.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function appexCommonControlsWebPicksClusterInit(WinJS) {
"use strict";
var RENDER_COMPLETE = "rendercomplete";
var WebPicks = WinJS.Namespace.define("CommonJS.WebPicks",
{
ClusterMode: {
static: "static",
dynamic: "dynamic"
},
WebPicksParser: {
transformWebPick: function transformWebPick(index, jsonNode) {
var item = jsonNode;
var image = item.Image;
return {
index: index,
title: item.Title,
description: item.Desc,
url: item.Url,
attribution: item.Attribution,
image: {
url: image.Url,
height: image.Height,
width: image.Width,
alt: image.AltText,
}
};
}
},
WebPicksCluster: WinJS.Class.define(function webPicksCluster_ctor(domElement, options) {
// ctor
var that = this;
domElement.winControl = this;
this._domElement = domElement;
WinJS.Utilities.addClass(domElement, "webCollectionCluster");
// register itemclick event
domElement.addEventListener("click", CommonJS.Utils.itemClickProxy(this));
Object.defineProperties(this, WinJS.Utilities.createEventProperties("itemclick"));
// register rendercomplete event
Object.defineProperties(this, WinJS.Utilities.createEventProperties(RENDER_COMPLETE));
// set options
WinJS.UI.setOptions(this, options);
},
{
// declare null aliases for auto-complete to work
_domElement: null,
identifier: null,
onitemclick: null,
onrendercomplete: null,
type: null,
/// <summary>
/// Invalidates the Slideshow cluster by querying the provider and binding the resulting data to the view.
/// </summary>
render: function render() {
var that = this;
var domElement = this._domElement;
var mode = this.mode;
var dataSet = this.dataSet || [];
var getWebPicks = (mode === WebPicks.ClusterMode.dynamic) ?
this._queryProviderAsync() : WinJS.Promise.wrap(dataSet);
function createItem(raw) {
var item = raw.data;
var wrapper = document.createElement("div");
wrapper.className = item.className;
var card = document.createElement("div");
card.className = "card";
wrapper.appendChild(card);
var grid = document.createElement("div");
grid.className = "grid";
card.appendChild(grid);
var thumbnail = document.createElement("div");
thumbnail.className = "thumbnail fitBoth";
grid.appendChild(thumbnail);
var imageControl = new CommonJS.ImageCard(thumbnail, {
noIdentifier: 1,
classification: "small"
});
imageControl.imageSource = item.image.url;
imageControl.alternateText = item.image.alt;
var title = document.createElement("div");
title.className = "title";
grid.appendChild(title);
var titleSpan = document.createElement("span");
titleSpan.innerText = item.title;
title.appendChild(titleSpan);
var description = document.createElement("div");
description.className = "description";
description.innerText = item.description;
grid.appendChild(description);
return wrapper;
}
return getWebPicks
.then(function webPicksCluster_getWebPicksComplete(response) {
if (response) {
/// <disable> JS3056 </disable>
var itemDataSource = new WinJS.Binding.List();
/// <enable> JS3056 </enable>
var addItemToList = function addItemToList(listItem, list, className) {
listItem.moduleInfo = {
renderer: createItem,
};
listItem.className = className;
list.push(listItem);
};
for (var i = 0, ilen = response.length; i < ilen; i++) {
var item = response[i];
addItemToList(item, itemDataSource, i === 0 ? "large" : "small");
if (that.attributionCreator && (typeof item.attribution !== "undefined") && (item.attribution !== "")) {
that.attributionCreator.addAttribution(item.title, item.attribution);
}
}
var options = {
className: "platformListLayout",
itemDataSource: itemDataSource.dataSource,
onitemclick: WebPicks.WebPicksCluster.itemClickHandler
};
var itemContainer = new CommonJS.Immersive.ItemsContainer(domElement, options);
return itemContainer.render();
} else {
return WinJS.Promise.wrap({});
}
})
.then(function webPicksCluster_itemContainerRenderComplete() {
return that.dispatchEvent(RENDER_COMPLETE);
}, function webPicksCluster_itemContainerRenderError(err) {
debugger;
});
},
_queryProviderAsync: function _queryProviderAsync() {
// dynamic mode, fetch picks from provider first
var provider = new WebPicks.WebPicksProvider();
var identifier = this.identifier;
return provider.getAsync(identifier);
},
onOrientationChange: function onOrientationChange(event) {
var item = (this._domElement) ? this._domElement.winControl : null;
if (item && item.onOrientationChange) {
item.onOrientationChange(event);
}
},
onWindowResize: function onWindowResize(event) {
var item = (this._domElement) ? this._domElement.winControl : null;
if (item && item.onWindowResize) {
item.onWindowResize(event);
}
}
})
});
WinJS.Class.mix(WebPicks.WebPicksCluster, WinJS.UI.DOMEventMixin);
WebPicks.WebPicksCluster.itemClickHandler = function (evt) {
if (evt && evt.item) {
// launch url in browser
var item = evt.item;
var element = "WebPicks Tile";
Platform.Telemetry.FlightRecorder.logUserAction(Platform.Telemetry.LogLevel.normal,
"WebPicks",
element,
Platform.Telemetry.UserActionOperation.click,
Platform.Telemetry.UserActionMethod.unknown,
0);
var uri = new Windows.Foundation.Uri(item.url);
Windows.System.Launcher.launchUriAsync(uri).then();
}
};
})(WinJS);
/* File: GroupPage.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function appexCommonControlsWebPicksGroupPageInit(WinJS) {
"use strict";
var WebPicks = WinJS.Namespace.define("CommonJS.WebPicks", {
GroupPage: WinJS.Class.define(function groupPage_ctor(state) {
var that = this;
this.identifier = state.identifier;
this.titleResource = state.titleResource;
this.title = PlatformJS.Services.resourceLoader.getString(state.titleResource);
this._impressionContext = state.Context;
var panoramaElement = document.getElementById("mainPanorama");
this._panoramaControl = (panoramaElement) ? panoramaElement.winControl : null;
if (state.semanticModuleInfo) {
this.semanticModuleInfo = state.semanticModuleInfo;
this.semanticZoomRenderer = WinJS.Utilities.markSupportedForProcessing(function groupPage_semanticZoomRenderer(itemPromise) {
return {
element: itemPromise.then(function groupPage_semanticZoomItemPromiseComplete(group) {
var div = document.createElement("div");
WinJS.Utilities.addClass(div, "platformSemanticZoomItem");
var binding = that.semanticZoomTile(group.data.clusterTitle);
CommonJS.setModuleSizeAndClass(binding.moduleInfo, div);
CommonJS.loadModule(binding.moduleInfo, binding, div).then();
return div;
})
};
});
}
}, {
_impressionContext: null,
getPageImpressionContext: function getPageImpressionContext() {
return this._impressionContext;
},
/// Identifier of the editor"s pick group used by the page
identifier: {
get: function get() { return this._identifier; },
set: function set(value) {
this._identifier = value;
}
},
titleResource: {
get: function get() { return this._titleResource; },
set: function set(value) {
this._titleResource = value;
}
},
title: {
get: function get() { return this._title; },
set: function set(value) {
this._title = value;
}
},
_panoramaControl: null,
semanticZoomRenderer: null,
semanticModuleInfo: {
get: function get() { return this._semanticModuleInfo; },
set: function set(value) {
this._semanticModuleInfo = value;
}
},
semanticZoomTile: function semanticZoomTile(clusterTitle) {
var that = this;
var binding = {
clusterTitle: clusterTitle,
moduleInfo: that.semanticModuleInfo
};
return binding;
},
fetchDataPromise: function fetchDataPromise(provider) {
var that = this;
var identifier = this.identifier;
var title = this.title;
var semanticZoomRenderer = this.semanticZoomRenderer;
// show progress report
CommonJS.Progress.showProgress(CommonJS.Progress.centerProgressType);
return this._dataPromise = provider.getGroupAsync(identifier)
.then(function groupPage_getGroupAsyncComplete(response) {
var max = response.collections.length;
var singleCluster = (max === 1);
var clusters = new WinJS.Binding.List();
title = title || response.title;
var attributionCreator = new CommonJS.WebPicks.GroupPageAttributionCreator();
for (var i = 0; i < max; i++) {
var collection = response.collections[i];
var id = "webPicks" + collection.title.split(" ").join("");
clusters.push({
clusterKey: id,
clusterTitle: singleCluster ? "" : collection.title,
clusterContent: {
contentControl: "CommonJS.WebPicks.WebPicksCluster",
contentOptions: {
type: WebPicks.ClusterMode.static,
dataSet: collection.items,
useDefaultClickHandler: true,
mode: WebPicks.ClusterMode.static,
attributionCreator: attributionCreator
}
}
});
}
CommonJS.Progress.hideProgress(CommonJS.Progress.centerProgressType);
return {
title: title,
clusters: clusters.dataSource,
semanticZoomRenderer: semanticZoomRenderer,
zoomOptions: {
locked: singleCluster
}
};
}, function groupPage_getGroupAsyncError(err) {
CommonJS.Progress.hideProgress(CommonJS.Progress.centerProgressType);
if (PlatformJS.Utilities.isPromiseCanceled(err)) {
return;
}
var code = PlatformJS.Utilities.getPlatformErrorCode(err);
// 102: service exception code
var errorCode = PlatformJS.Utilities.checkOfflineErrorCode(code);
CommonJS.Error.showError(errorCode, function groupPage_showErrorGetGroupAsync(evt) {
CommonJS.forceRefresh();
});
return {
title: title,
clusters: { list: new WinJS.Binding.List() },
semanticZoomRenderer: semanticZoomRenderer
};
});
},
// IPAGE interface
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away and when the app is suspending.
/// Return any data that you need to resurrect your UX when the page is recreated
/// Keep this state object as small as possible
/// </summary>
/// <returns>
/// This function must return a JSON object that can be serializable. Do not pass a Managed object
/// </returns>
getPageState: function getPageState() {
return {
identifier: this.identifier,
titleResource: this.titleResource,
semanticModuleInfo: this.semanticModuleInfo
};
},
/// <summary>
/// This function is invoked by the UX Framework when the page is being created and when
/// it is necessary to bind data to the UX.
/// </summary>
/// <returns>
/// Returns a promise that contains data to bind the UX to
/// </returns>
getPageData: function getPageData() {
var provider = new WebPicks.WebPicksProvider();
return this.fetchDataPromise(provider);
},
/// <summary>
/// This function is invoked by the UX Framework when the data binding is complete
/// </summary>
/// <returns>
/// Nothing
/// </returns>
onBindingComplete: function onBindingComplete() {
},
/// <summary>
/// Set this property to true if you want the back button to appear in the navbar
/// This is used for immersive pages
/// </summary>
isImmersive: false,
/// <summary>
/// This function is invoked by the UX Framework when the layout has changed
/// </summary>
/// <param name="layoutState">
/// The current layout state
/// </param>
/// <returns>
/// Nothing
/// </returns>
onLayoutChange: function onLayoutChange(layoutState) { },
/// <summary>
/// This function is invoked by the device has been rotated
/// </summary>
/// <param name="event">
/// orientation change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
onOrientationChange: function onOrientationChange(event) {
if (this._panoramaControl && this._panoramaControl.onOrientationChange) {
this._panoramaControl.onOrientationChange(event);
}
},
/// <summary>
/// Handles window resize event. Occurs when:
///  - changing resolution in control panel
///  - WINDOWS+ARROW when using multiple monitors
/// </summary>
/// <param name="event">
/// resize event
/// </param>
/// <returns>
/// Nothing
/// </returns>
onWindowResize: function onWindowResize(event) {
if (this._panoramaControl && this._panoramaControl.onWindowResize) {
this._panoramaControl.onWindowResize(event);
}
},
dispose: function dispose() {
var promise = this._dataPromise;
if (promise) {
promise.cancel();
}
var panoramaControl = this._panoramaControl;
if (panoramaControl) {
panoramaControl.dispose();
}
}
})
});
})(WinJS);
/* File: AttributionCreator.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function appexCommonControlsWebPicksGroupPageInit (WinJS) {
"use strict";
var WebPicks = WinJS.Namespace.define("CommonJS.WebPicks", {
GroupPageAttributionCreator: WinJS.Class.define(function groupPageAttributionCreater_ctor () {
this._hasBar = false;
},
{
_attributionFlyout: null,
_hasBar: null,
addAttribution: function addAttribution(title, attribution) {
if (!this._hasBar) {
this.createBottomBar();
}
if (this._hasBar) {
var attributionLine = document.createElement("div");
WinJS.Utilities.addClass(attributionLine, "attributionTextLine");
var attributionTitle = document.createElement("span");
WinJS.Utilities.addClass(attributionTitle, "attributionTextName");
attributionTitle.innerText = title + " ";
attributionLine.appendChild(attributionTitle);
var attributionCredit = document.createElement("span");
WinJS.Utilities.addClass(attributionCredit, "attributionTextCredit");
attributionCredit.innerText = attribution;
attributionLine.appendChild(attributionCredit);
this._attributionFlyout.appendChild(attributionLine);
}
},
createBottomBar: function createBottomBar() {
var container = document.querySelector("#webCollectionContainer");
if (container) {
var flyoutDiv = CommonJS.FlyoutManager.getFlyoutElement();
flyoutDiv.id = "webCollectionAttributionFlyout";
var attributionContainerDiv = document.createElement("div");
WinJS.Utilities.addClass(attributionContainerDiv, "webCollectionAttributionContainer");
var attributionListDiv = document.createElement("div");
attributionListDiv.id = "webCollectionAttributionList";
attributionContainerDiv.appendChild(attributionListDiv);
flyoutDiv.appendChild(attributionContainerDiv);
var flyout = new WinJS.UI.Flyout(flyoutDiv);
this._attributionFlyout = attributionListDiv;
var buttonDiv = document.createElement("button");
buttonDiv.id = "webCollectionAtrribution";
var button = new WinJS.UI.AppBarCommand(buttonDiv, { icon: "\uE014", extraClass: "appexSymbol", type: "flyout", flyout: "webCollectionAttributionFlyout", label: PlatformJS.Services.resourceLoader.getString("/platform/aboutLabel") });
var barDiv = document.createElement("div");
WinJS.Utilities.addClass(barDiv, "webCollectionAppBar");
var bar = new WinJS.UI.AppBar(barDiv, { placement: "bottom", commands: [button,CommonJS.Settings.getHelpButton().winControl] });
container.appendChild(barDiv);
this._hasBar = true;
}
}
})
});
})(WinJS);
/* File: Provider.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function appexCommonControlsWebPicksClusterInit (WinJS) {
"use strict";
var RENDER_COMPLETE = "rendercomplete";
var WebPicks = WinJS.Namespace.define("CommonJS.WebPicks",
{
WebPicksProvider: WinJS.Class.define(function webPicksProvider_ctor (domElement, options) {
}, {
_getConfiguration: function _getConfiguration(identifier) {
return WinJS.Promise.wrap(identifier)
.then(function webPicksProvider_getIdentifierComplete (id) {
var queryService = new Platform.QueryService("BestOfTheWebConfiguration");
var configuration = PlatformJS.Collections.createStringDictionary();
configuration.insert("identifier", id);
var options = new Platform.DataServices.QueryServiceOptions();
options.useCompatDataModel = true;
return queryService.downloadDataAsync(configuration, null, null, options);
})
.then(function webPicksProvider_downloadDataAsyncComplete (response) {
var config = JSON.parse(response.dataString);
var url = config.urls[0].Path;
var queryService = new Platform.QueryService("BestOfTheWeb");
var configuration = PlatformJS.Collections.createStringDictionary();
configuration.insert("url", url);
var options = new Platform.DataServices.QueryServiceOptions();
options.useCompatDataModel = true;
return new WinJS.Promise(function webPicksProvider_downloadBestOfTheWebPromiseInit (complete, error, progress) {
queryService.downloadDataAsync(configuration, null, null, options).then(
function webPicksProvider_downloadBestOfTheWebComplete (downloadResponse) {
complete(downloadResponse);
},
function webPicksProvider_downloadBestOfTheWebError (e) {
if (PlatformJS.Utilities.isPromiseCanceled(e)) {
return;
}
error(e);
},
function webPicksProvider_downloadBestOfTheWebProgress (e) {
if (e.statusCode === Platform.DataServices.QueryServiceStatusCode.cachedEntryFound
&& e.cachedResponse) {
complete(e.cachedResponse);
}
});
});
});
},
getGroupAsync: function getGroupAsync(identifier) {
return this._getConfiguration(identifier)
.then(function webPicksProvider_getGroupIdentifierComplete (response) {
var jsonResponse = JSON.parse(response.dataString);
var output = {
title: jsonResponse.Title,
collections: []
};
for (var i = 0, ilen = jsonResponse.Collections.length; i < ilen; i++) {
var jsonCollection = jsonResponse.Collections[i];
var collection = {
title: jsonCollection.Title,
items: []
};
for (var j = 0, jlen = jsonCollection.Items.length; j < jlen; j++) {
var jsonNode = jsonCollection.Items[j];
collection.items.push(WebPicks.WebPicksParser.transformWebPick(j, jsonNode));
}
output.collections.push(collection);
}
return WinJS.Promise.wrap(output);
});
},
getAsync: function getAsync(identifier) {
return this._getConfiguration(identifier)
.then(function webPicksProvider_getIdentifierComplete (response) {
var output = [];
var jsonResponse = JSON.parse(response.dataString);
for (var i = 0, ilen = jsonResponse.Items.length; i < ilen; i++) {
var item = jsonResponse.Items[i];
output.push(WebPicks.WebPicksParser.transformWebPick(i, item));
}
return output;
});
}
}),
});
})(WinJS);
