﻿(function () {
"use strict";
function updateArticleTimes(newsArticle) {
if (newsArticle.published) {
var utcTime1 = newsArticle.published.utctime;
// TODO: Let platform know that this may be off an hour, need to investigate
var time1 = CommonJS.Utils.convertBDITimeToFriendlyTime(utcTime1);
newsArticle.publishTime = time1 && time1.indexOf("NaN") < 0 ? time1 : "";
}
else {
newsArticle.publishTime = "";
}
if (newsArticle.updated) {
var utcTime2 = newsArticle.updated.utctime;
// TODO: Let platform know that this may be off an hour, need to investigate
var time2 = CommonJS.Utils.convertBDITimeToFriendlyTime(utcTime2);
newsArticle.updatedTime = time2 && time2.indexOf("NaN") < 0 ? time2 : "";
}
else {
newsArticle.updatedTime = "";
}
}
function convertCMSArticle(result, options) {
var newsArticle = {};
newsArticle.editorial = true;
newsArticle.lastModified = result.lastModified;
if (result.isFREOffline) {
// Localize messages
var abstract = result.content.abstract;
var headline = result.content.headline;
var FREOfflineTitleResourceKey = result.FREOfflineTitleResourceKey;
var FREOfflineSubtitleResourceKey = result.FREOfflineSubtitleResourceKey;
result.content.headline = headline.replace(FREOfflineTitleResourceKey, PlatformJS.Services.resourceLoader.getString(FREOfflineTitleResourceKey));
result.content.abstract = abstract.replace(FREOfflineSubtitleResourceKey, PlatformJS.Services.resourceLoader.getString(FREOfflineSubtitleResourceKey));
newsArticle.isFREOffline = true;
}
if (result.heroImage) {
newsArticle.anchorpoint = result.heroImage.anchorPoint;
}
var cmsImage = null;
if (result.heroImage && result.heroImage.image) {
cmsImage = result.heroImage.image;
}
else {
cmsImage = result.image;
}
if (cmsImage) {
newsArticle.imageAttribution = cmsImage.attribution ? cmsImage.attribution : "";
newsArticle.altText = cmsImage.altText ? cmsImage.altText : "";
newsArticle.caption = cmsImage.caption ? toStaticHTML(cmsImage.caption) : "";
var originalImage = null;
if (cmsImage.images) {
for (var i = 0; i < cmsImage.images.length; i++) {
var img = cmsImage.images[i];
if (img.url) {
var imgName = img.name && img.name.toLowerCase ? img.name.toLowerCase() : "";
if (imgName === "original") {
newsArticle.thumbnail = {};
newsArticle.thumbnail.url = img.url;
newsArticle.thumbnail.width = img.width;
newsArticle.thumbnail.height = img.height;
newsArticle.thumbnail.name = "original";
}
else if (imgName === "semanticzoom") {
newsArticle.semanticZoomThumbnail = {};
newsArticle.semanticZoomThumbnail.url = img.url;
newsArticle.semanticZoomThumbnail.width = img.width;
newsArticle.semanticZoomThumbnail.height = img.height;
newsArticle.semanticZoomThumbnail.name = "semanticZoom";
}
else if (imgName === "lowres") {
newsArticle.thumbnailLowRes = {};
newsArticle.thumbnailLowRes.url = img.url;
newsArticle.thumbnailLowRes.width = img.width;
newsArticle.thumbnailLowRes.height = img.height;
newsArticle.thumbnailLowRes.name = "lowRes";
}
}
}
}
}
else {
newsArticle.imageAttribution = "";
newsArticle.altText = "";
newsArticle.caption = "";
}
newsArticle.sourceImageUrl = result.content.source && result.content.source.favicon ? result.content.source.favicon : "";
// CMS headline support HTML Fragments
newsArticle.headline = result.content.headline ? toStaticHTML(result.content.headline) : "";
newsArticle.title = newsArticle.headline;
newsArticle.source = result.content.source && result.content.source.name ? result.content.source.name : "";
newsArticle.destination = result.destination ? result.destination : "";
// The following are the different destination URLs we support (newsArticle.destination)
// OLD FORMAT (To be eventually removed)
//      article://33259198
// NEW FORMAT (various urls below, see data contract spec for full details)
//      //application/view?entitytype=article&pageId=33259198
//      bingnews://application/view?entitytype=article&pageId=33259198
//      ///view?entitytype=article&pageId=2123125
//      bingnews:///view?entitytype=article&pageId=2123125
var newsUri = NewsJS.Utilities.parseCMSUriString(newsArticle.destination);
if (newsUri) {
if (newsUri.entitytype === "article") {
newsArticle.type = newsUri.entitytype;
newsArticle.articleid = newsUri.pageId && newsUri.pageId.length > 0 ? newsUri.pageId : null;
newsArticle.contentid = newsUri.contentId && newsUri.contentId.length > 0 ? newsUri.contentId : null;
} else if (newsUri.entitytype === "slideshow") {
newsArticle.type = newsUri.entitytype;
newsArticle.contentid = newsUri.pageId;
} else if (newsUri.entitytype === "video") {
newsArticle.type = newsUri.entitytype;
var videoOptions = {};
var videoSource = null;
if (newsUri.contentId && newsUri.contentId.length > 0) {
videoSource = newsUri.contentId;
}
// CMS renders headlines with <p> tags, which the video control doesn't handle. Strip them out
var strippedTitle = NewsJS.Utilities.stripHTML(newsArticle.headline);
// defend against bad video feed data
// NOTE: as of v2.2.7, CUX video renderer throws out video objects that don't have thumbnails for fullscreen templates.
// snap mode templates will still display. We may want to just toss them here instead.
if (!newsArticle.thumbnail) {
newsArticle.thumbnail = {
width: 0,
height: 0,
url: "",
name: ""
};
}
videoOptions.thumbnail = newsArticle.thumbnail.url;
videoOptions.videoSource = videoSource;
videoOptions.source = newsArticle.source;
videoOptions.sourceImageUrl = newsArticle.sourceImageUrl;
videoOptions.title = strippedTitle;
newsArticle.thumbnail.videoOptions = videoOptions;
} else if (newsUri.entitytype === "partnerPano" || newsUri.entitytype === "pano") {
newsArticle.type = newsUri.entitytype;
}
}
// CMS abstract support HTML Fragments
newsArticle.abstract = result.content.abstract ? toStaticHTML(result.content.abstract) : "";
newsArticle.snippet = newsArticle.abstract;
newsArticle.byline = result.content.byline ? result.content.byline : "";
if (result.content.publicationDate && result.content.publicationDate.published && result.content.publicationDate.published.utctime) {
newsArticle.published = result.content.publicationDate.published;
var utcTime1 = result.content.publicationDate.published.utctime;
// TODO: Let platform know that this may be off an hour, need to investigate
var time1 = CommonJS.Utils.convertBDITimeToFriendlyTime(utcTime1);
newsArticle.publishTime = time1 && time1.indexOf("NaN") < 0 ? time1 : "";
}
else {
newsArticle.publishTime = "";
}
if (result.content.publicationDate && result.content.publicationDate.updated && result.content.publicationDate.updated.utctime) {
newsArticle.updated = result.content.publicationDate.updated;
var utcTime2 = result.content.publicationDate.updated.utctime;
// TODO: Let platform know that this may be off an hour, need to investigate
var time2 = CommonJS.Utils.convertBDITimeToFriendlyTime(utcTime2);
newsArticle.updatedTime = time2 && time2.indexOf("NaN") < 0 ? time2 : "";
}
else {
newsArticle.updatedTime = "";
}
newsArticle.template = result.template;
newsArticle.templateClass = result.templateClass;
if (options) {
if (options.useByline) {
newsArticle.source = newsArticle.byline;
}
}
return newsArticle;
}
function rssFeedTile(tileName, onclick) {
var binding =
{
title: tileName,
onclick: onclick,
moduleInfo: {
height: "90px",
width: "260px",
fragmentPath: "/html/templates.html",
templateId: "rssFeedTile"
}
};
return binding;
}
function semanticZoomTile(clusterTitle) {
var binding = {
clusterTitle: clusterTitle,
moduleInfo: {
fragmentPath: "/html/templates.html",
templateId: "semanticZoomTile",
width: "250px",
height: "80px"
}
};
return binding;
}
function commonStoryTile(article) {
var binding =
{
article: article,
title: NewsJS.Utilities.fixupBidiPunctuation(article.title),
snippet: article.snippet,
imageUrl: article.thumbnail ? article.thumbnail.url : "",
backgroundImageUrl: article.thumbnail ? "url('" + article.thumbnail.url + "')" : "",
favIconUrl: article.sourceImageUrl,
subtitle: article.publishTime ? article.source + " · " + article.publishTime : article.source
};
return binding;
}
function snappedTitleTile(title) {
var binding = {
title: title,
moduleInfo: {
fragmentPath: "/html/templates.html",
templateId: "snappedTitleTile"
}
};
return binding;
}
function snappedStoryTile(article) {
var binding = commonStoryTile(article);
binding.source = article.source;
// piggy back on the NewsCluster image cache
binding.image = { url: binding.imageUrl, cacheId: "PlatformImageCache" };
var landscape = true;
if (article.thumbnail && article.thumbnail.width && article.thumbnail.height) {
if (article.thumbnail.height > article.thumbnail.width) {
landscape = false;
}
}
binding.publishTime = article.publishTime ? article.publishTime : "";
var articleWithoutContent = article.editorial && !article.destination;
var hasImage = (article.thumbnail && article.thumbnail.url) ? true : false;
binding.moduleInfo = {
fragmentPath: "/html/templates.html",
className: (landscape ? "snappedStoryTileLandscapeImage" : "snappedStoryTilePortraitImage") + (articleWithoutContent ? " win-interactive" : ""),
templateId: hasImage ? "snappedStoryTile" : "snappedStoryTileNoImage"
};
return binding;
}
function developingNewsTile(article) {
var binding = convertCMSArticle(article, null);
binding.moduleInfo = {
fragmentPath: "/html/templates.html",
className: "developingNewsTileLandscapeImage",
templateId: "developingNewsTile"
};
return binding;
}
function snappedSourceTile(source) {
var binding = {
data: source,
moduleInfo: {
fragmentPath: "/html/templates.html",
templateId: "snappedSourceItemTemplate"
}
};
return binding;
}
function sourceImageDisplayConverter(sourceImageUrl) {
return (sourceImageUrl && sourceImageUrl.length > 0) ? "block" : "none";
}
function sourceImageCard(url) {
return {
url: url,
cacheId: "Sources"
};
}
function todayHeroEditorialTile(article) {
var imageUrl = article.images ? article.images[0].url : "";
var binding =
{
article: article,
title: article.title,
imageUrl: imageUrl,
backgroundImageUrl: "url('" + imageUrl + "')",
subtitle: article.source + " · " + article.publishTime,
moduleInfo: {
height: "470px",
width: "470px",
fragmentPath: "/html/templates.html",
templateId: "todayHeroTile"
}
};
return binding;
}
function addTopicCardTile() {
var binding =
{
title: PlatformJS.Services.resourceLoader.getString("AddTopic"),
type: "favorite",
imageGlyphText: "\uE109",
moduleInfo: {
height: "270px",
width: "280px",
fragmentPath: "/html/templates.html",
templateId: "addTopicCardTile",
isInteractive: false
}
};
return binding;
}
function clusterColorMapper(bindingElement, dstElement) {
var className;
var bindingElementType = bindingElement ? bindingElement.type : "";
if (bindingElementType === "favorite") {
className = "favoriteTopic";
} else if (bindingElementType === "search") {
className = "searchTopic";
} else if (bindingElementType === "addTopic") {
className = "addTopic";
} else {
className = "defaultTopic";
}
WinJS.Utilities.addClass(dstElement, className);
}
function clusterHeadingTopicTile(topic, type, onopen, ondelete) {
var binding =
{
template: "clusterHeadingTopicTile",
query: topic,
title: topic,
item: binding,
type: type,
open: onopen,
del: ondelete,
glyph: WinJS.UI.AppBarIcon["cancel"],
invokeBehavior: "Search",
moduleInfo: {
height: "90px",
width: "260px",
fragmentPath: "/html/templates.html",
templateId: "clusterHeadingTopicTile",
isInteractive: false
}
};
return binding;
}
function semanticZoomSourceTile(sourceDisplayName) {
var binding = {
template: "homeSemanticTileNoImage",
title: sourceDisplayName,
moduleInfo: {
height: "140px",
width: "290px",
fragmentPath: "/html/templates.html",
templateId: "homeSemanticTileNoImage",
isInteractive: false
}
};
return binding;
}
function semanticZoomTopicTile(topic, type) {
var binding =
{
template: "topicSemanticZoomTile",
query: topic,
title: topic,
type: type,
imageGlyphText: type === "addTopic" ? "\uE109" : "",
invokeBehavior: "Search",
moduleInfo: {
height: "140px",
width: "290px",
fragmentPath: "/html/templates.html",
templateId: "topicSemanticZoomTile",
isInteractive: false
}
};
return binding;
}
function noResultsTile(message1, message2, glyph) {
var binding = {
sentinel: true,
message1: message1,
message2: message2,
imageGlyphText: glyph,
moduleInfo: {
fragmentPath: "/html/templates.html",
templateId: "noResultsAlert"
}
};
return binding;
}
WinJS.Namespace.define("NewsJS.Bindings", {
noResultsTile: noResultsTile,
rssFeedTile: rssFeedTile,
snappedTitleTile: snappedTitleTile,
snappedStoryTile: snappedStoryTile,
developingNewsTile: developingNewsTile,
snappedSourceTile: snappedSourceTile,
sourceImageDisplayConverter: WinJS.Binding.converter(sourceImageDisplayConverter),
sourceImageCard: WinJS.Binding.converter(sourceImageCard),
semanticZoomTile: semanticZoomTile,
addTopicCardTile: addTopicCardTile,
todayHeroEditorialTile: todayHeroEditorialTile,
convertCMSArticle: convertCMSArticle,
clusterHeadingTopicTile: clusterHeadingTopicTile,
clusterColorMapper: clusterColorMapper,
semanticZoomTopicTile: semanticZoomTopicTile,
semanticZoomSourceTile: semanticZoomSourceTile,
updateArticleTimes: updateArticleTimes
});
})();
