﻿/* articleReader\newsArticleReaderPage.js */
(function () {
"use strict";
WinJS.Namespace.define("NewsJS", {
NewsArticleReaderPage: WinJS.Class.derive(DynamicPanoJS.DynamicArticleReaderPage,
function (state) {
DynamicPanoJS.DynamicArticleReaderPage.call(this, state);
NewsJS.Partners.Theme.onNavigated(state);
var stylesheetNode = document.createElement("link");
stylesheetNode.setAttribute("href", "/css/articleReader.css");
stylesheetNode.setAttribute("rel", "stylesheet");
document.getElementsByTagName("HEAD")[0].appendChild(stylesheetNode);
},
{
dispose: function dispose() {
DynamicPanoJS.DynamicArticleReaderPage.prototype.dispose.call(this);
NewsJS.Partners.Theme.onNavigateAway();
if (this._articleManager.removeEventListener) {
this._articleManager.removeEventListener("articlechanged", this._articleChanged);
this._articleManager.removeEventListener("articleviewed", this._articleViewed);
}
},
_handleShareRequestImpl: function _handleShareRequestImpl(request, shareData) {
var that = this;
if (shareData && shareData.pageState && shareData.pageState.initialArticleId && shareData.pageState.market) {
var articleIdPath = shareData.articleId;
var parts = articleIdPath.split("/");
if (parts.length > 0 && parts.length <= 2) {
var pageId = parts[0];
var contentId = parts.length === 2 ? parts[1] : null;
var uriText = that.formatShareUri(shareData, pageId, contentId);
if (uriText) {
request.data.setText(that.formatShareText(shareData, request.data.properties.description, uriText));
request.data.setUri(new Windows.Foundation.Uri(uriText));
request.data.properties.title = that.formatShareTitle(shareData);
request.data.properties.description = that.formatShareDescription(shareData);
var htmlText = that.formatShareHTML(shareData, uriText);
var htmlFormat = Windows.ApplicationModel.DataTransfer.HtmlFormatHelper.createHtmlFormat(htmlText);
request.data.setHtmlFormat(htmlFormat);
NewsJS.Telemetry.Utilities.recordShare(
uriText,
shareData.pageState.telemetry ? shareData.pageState.telemetry.k : 0,
"Article Reader");
}
}
}
},
formatShareUri: function formatShareUri(shareData, pageId, contentId) {
try {
//Use sharing url if it is provided otherwise fallback to deeplinking with article id
var sharingUrl = shareData.articleHeader.sharingUrl;
if (sharingUrl && typeof sharingUrl === "string" && sharingUrl.length > 0) {
sharingUrl += "?a=1&m=" + Windows.Foundation.Uri.escapeComponent(shareData.pageState.market);
return sharingUrl;
}
else { 
var uriString = NewsJS.Utilities.getAppProtocol() + "://application/view?entitytype=article&pageId=" + Windows.Foundation.Uri.escapeComponent(pageId);
if (contentId) {
uriString += "&contentId=" + Windows.Foundation.Uri.escapeComponent(contentId);
}
uriString += "&market=" + Windows.Foundation.Uri.escapeComponent(shareData.pageState.market);
uriString += "&referrer=share";
return uriString;
}
} catch (err) {
return null;
}
},
formatBingAppName: function formatBingAppName() {
return PlatformJS.Services.resourceLoader.getString("/platform/bing") + " " + CommonJS.getAppName();
},
formatShareTitle: function formatShareTitle(shareData) {
return shareData.articleHeader.headline + " - " + this.formatBingAppName();
},
formatShareDescription: function formatShareDescription(shareData) {
var publisherName = shareData.articleHeader.publisherName;
var result = shareData.articleHeader.author + " | ";
if (publisherName && publisherName.length > 0) {
result += publisherName + " | ";
}
result += shareData.articleHeader.date;
return result;
},
formatShareText: function formatShareText(shareData, description, uri) {
return shareData.articleHeader.headline + "\n" + description + "\n" + shareData.articleHeader.snippet + "\n" + uri;
},
formatShareHTML: function formatShareHTML(shareData, uriText) {
var that = this;
var win8ShareText = PlatformJS.Services.resourceLoader.getString("/platform/win8Share");
var win8ShareLinkText = PlatformJS.Services.resourceLoader.getString("/platform/win8ShareLink");
var link = "<a href=\"" + uriText + "\">" + win8ShareLinkText.format(CommonJS.getAppName()) + "</a>";
var message = win8ShareText.format(PlatformJS.Services.resourceLoader.getString("/platform/win8Brand"), link);
console.log("Share message = " + message);
return "<h2><b>" + shareData.articleHeader.headline +
"</b></h2><p>" + shareData.articleHeader.author +
"</p><p>" + shareData.articleHeader.publisherName + " - " + shareData.articleHeader.date +
"</p><blockquote style=\"background-color:#f2efed\">" + shareData.articleHeader.snippet +
"</blockquote><p>" + message + "</p>";
},
_isAdPage: function _isAdPage(articleData) {
return !!(articleData && articleData.metadata && articleData.metadata.adMetadata);
},
onLayoutChange: function onLayoutChange(viewState) {
var that = this;
DynamicPanoJS.DynamicArticleReaderPage.prototype.onLayoutChange.call(this, viewState);
},
_articleViewed: function _articleViewed(event) {
var that = this;
that.checkToMarkArticleAsRead();
},
}),
});
})();
/* Controls\domUtil.js */
(function () {
"use strict";
WinJS.Namespace.define("NewsJS.Controls",
{
DomUtil: WinJS.Class.mix(WinJS.Class.define(function (domElement, options) {
},
{
},
{
domCollapser: WinJS.Binding.converter(function (data) {
return data && data.length > 0 ? "" : "none";
})
}),
WinJS.UI.DOMEventMixin),
});
})();
/* Controls\moreColumnControl.js */
(function () {
"use strict";
WinJS.Namespace.define("NewsJS.Controls",
{
MoreColumnControl: WinJS.Class.mix(WinJS.Class.define(function (element, options) {
// ctor
var that = this;
element.winControl = this;
this._domElement = element;
WinJS.Utilities.addClass(this._domElement, "newsMoreEntriesColumn");
var addTileContainer = document.createElement("div");
WinJS.Utilities.addClass(addTileContainer, "newsMoreEntriesTileContainer");
this._domElement.appendChild(addTileContainer);
if (options.addTileOptions.itemclick) {
this._itemClick = options.addTileOptions.itemclick;
PlatformJS.Utilities.enablePointerUpDownAnimations(this._domElement);
// register itemclick event
PlatformJS.Utilities.registerItemClickProxy(this._domElement,
function (domElement) {
return WinJS.Utilities.hasClass(domElement, "newsMoreEntriesColumn");
}, function (domElement) {
that._itemClick(domElement);
});
Object.defineProperties(this, WinJS.Utilities.createEventProperties("itemclick"));
}
this._itemsContainer = PlatformJS.Utilities.createObject("CommonJS.Immersive.ItemsContainer", addTileContainer, options.addTileOptions);
// the platformCluster element housing this control needs a css class
var clusterElement = element.parentElement;
if (WinJS.Utilities.hasClass(clusterElement, "platformCluster")) {
WinJS.Utilities.addClass(clusterElement, "newsMoreEntriesCluster");
}
// set options
WinJS.UI.setOptions(this, options.options);
},
{
// declare null aliases for auto-complete to work
_domElement: null,
_itemsContainer: null,
_itemClick: null,
refresh: function refresh() {
},
render: function render() {
var that = this;
return new WinJS.Promise(function (complete, error) {
if (that._itemsContainer) {
that._itemsContainer.render().done(function () {
var clusterItem = that._itemsContainer.element.querySelector(".platformClusterItem");
if (clusterItem) {
clusterItem.setAttribute("aria-label", PlatformJS.Services.resourceLoader.getString("AddTopic"));
clusterItem.setAttribute("role", "button");
}
complete();
});
} else {
complete();
}
});
},
}, {
// end static type definition
}), WinJS.UI.DOMEventMixin),
});
})();
/* Controls\snappedHeaderList.js */
(function () {
"use strict";
WinJS.Namespace.define("NewsJS.Controls",
{
SnappedHeaderList: WinJS.Class.define(
function (element, options) {
this._domElement = element || document.createElement("div");
WinJS.Utilities.addClass(this._domElement, "snappedHeaderList");
var header = document.createElement("div");
this._header = PlatformJS.Utilities.createObject("CommonJS.Immersive.Header", header, options.headerOptions);
if (options && options.headerOptions && !options.headerOptions.fontColor) {
this._header.fontColor = "headerFontLight";
}
this._domElement.appendChild(header);
if (!WinJS.Navigation.canGoBack) {
WinJS.Utilities.addClass(header, "snappedHeaderNoBack");
}
var listview = document.createElement("div");
WinJS.Utilities.addClass(listview, "listview");
this._listview = new WinJS.UI.ListView(listview, { layout: { type: WinJS.UI.ListLayout } });
this._listview.selectionMode = "none";
this.itemDataSource = options.listViewOptions.itemDataSource;
this._listview.itemTemplate = options.listViewOptions.itemTemplate || this._itemRenderer;
if (options.listViewOptions.oniteminvoked) {
this._listview.addEventListener("iteminvoked", options.listViewOptions.oniteminvoked);
}
this._domElement.appendChild(listview);
WinJS.UI.setOptions(this, options);
},
{
_domElement: null,
_header: null,
_listview: null,
_itemDataSource: null,
itemDataSource: {
get: function get() {
return this._itemDataSource;
},
set: function set(dataSource) {
this._itemDataSource = this._listview.itemDataSource = dataSource;
}
},
listview: {
get: function get() {
return this._listview;
}
},
_itemRenderer: function _itemRenderer(itemPromise) {
return itemPromise.then(function (item) {
if (item.data.article && item.data.article.offlineUnavailable) {
return CommonJS.loadModule(item.data.article.moduleInfo, item.data.article);
}
else {
return CommonJS.loadModule(item.data.moduleInfo, item.data);
}
});
}
})
});
})();
/* Controls\slideShowEntryBlock.js */
(function () {
"use strict";
var T = Platform.Telemetry;
WinJS.Namespace.define("NewsJS", {
SlideShowEntryBlock: WinJS.Class.define(function (element, options) {
this.element = element || document.createElement("div");
WinJS.Utilities.addClass(this.element, "newsSlideShowEntry");
this.element.winControl = this;
this._clickBinding = this.onclick.bind(this);
this._keyUpBinding = this._onKeyUp.bind(this);
this.element.addEventListener("click", this._clickBinding);
this.element.addEventListener("keyup", this._keyUpBinding);
var articleData = options.controlOptions;
var thumbnail = articleData.thumbnail;
var imageElt = document.createElement("div");
WinJS.Utilities.addClass(imageElt, "newsSlideShowEntryImage fitWidth sized");
var background = document.createElement("div");
WinJS.Utilities.addClass(background, "newsSlideShowEntryBackground");
this.element.appendChild(background);
var imageCard = new CommonJS.ImageCard(imageElt, {
alternateText: thumbnail.altText,
imageSource: {
url: thumbnail.url,
cacheId: "PlatformImageCache",
}
});
this.element.setAttribute("tabIndex", "0");
this.element.setAttribute("role", "link");
this.element.setAttribute("aria-label", thumbnail.altText || "");
this.element.appendChild(imageElt);
var attribution = document.createElement("div");
WinJS.Utilities.addClass(attribution, "attribution");
attribution.innerText = thumbnail.attribution;
this.element.appendChild(attribution);
var icon = document.createElement("div");
WinJS.Utilities.addClass(icon, "icon");
this.element.appendChild(icon);
var iconRing = document.createElement("div");
WinJS.Utilities.addClass(iconRing, "iconRing win-commandring win-commandicon");
icon.appendChild(iconRing);
var iconImage = document.createElement("div");
WinJS.Utilities.addClass(iconImage, "iconImage");
iconRing.appendChild(iconImage);
PlatformJS.Utilities.enablePointerUpDownAnimations(this.element);
WinJS.UI.setOptions(this, options.controlOptions);
},
{
// PRIVATE
_clickBinding: null,
_keyUpBinding: null,
_onKeyUp: function _onKeyUp(event) {
var keyCode = event.keyCode;
if (keyCode === WinJS.Utilities.Key.enter || keyCode === WinJS.Utilities.Key.space) {
this._openSlideShowPage();
}
},
_logUserAction: function _logUserAction(actionContext, element) {
T.FlightRecorder.logUserAction(
T.LogLevel.normal,
actionContext,
element,
T.UserActionOperation.click,
T.UserActionMethod.unknown,
0);
},
_openSlideShowPage: function _openSlideShowPage() {
this._logUserAction("Article Reader", "Slideshow");
WinJS.Navigation.navigate({
fragment: "/html/newsSlideshow.html",
page: this.slideShowPage || "NewsJS.SlideShowPage"
},
{
providerType: this.providerType,
providerConfiguration: this.articleData,
theme: this.theme,
parentArticle: this.parentArticle
});
},
// PUBLIC
articleData: null,
parentArticle: null,
providerType: null,
element: null,
theme: null,
slideShowPage: null,
onclick: function onclick(event) {
this._openSlideShowPage();
},
dispose: function dispose() {
this.element.removeEventListener("click", this._clickBinding);
this.element.removeEventListener("keyup", this._keyUpBinding);
}
})
});
})();
/* Controls\verticalScrollContainer.js */
(function () {
"use strict";
WinJS.Namespace.define("NewsJS.Controls", {
VerticalScrollContainer: WinJS.Class.derive(CommonJS.Immersive.ItemsContainer, function (element, options) {
CommonJS.Immersive.ItemsContainer.call(this, element, options);
this._wheelEvent = function (event) {
event.stopPropagation();
};
this.element.addEventListener("wheel", this._wheelEvent);
},
{
_wheelEvent: null,
dispose: function dispose() {
CommonJS.Immersive.ItemsContainer.prototype.dispose.call(this);
}
}),
});
})();
