﻿(function () {
"use strict";
WinJS.Namespace.define("NewsJS", {
SlideShowPage: WinJS.Class.derive(NewsJS.NewsBasePage,
function (state) {
NewsJS.NewsBasePage.call(this, state);
this._useSnappedContainer = false;
var that = this;
this.dontShowSlideTitle = false;
if (state && state.slideshowId) {
this.slideshowId = state.slideshowId;
if (state.slideshowId.indexOf("Reuters_") >= 0) {
this.dontShowSlideTitle = true;
}
}
if (state && state.extraOptions && state.extraOptions.dontShowSlideTitle) {
this.dontShowSlideTitle = state.extraOptions.dontShowSlideTitle;
}
if (state) {
if (state.market) {
this.market = state.market;
} else if (NewsJS.Globalization) {
this.market = NewsJS.Globalization.getMarketStringForEditorial();
}
}
if (state && state.imageIndex) {
this.imageIndex = state.imageIndex;
} else {
this.imageIndex = 0;
}
if (state && (state.instrumentationEntryPoint || state.instrumentationEntryPoint === 0)) {
this.instrumentationEntryPoint = state.instrumentationEntryPoint;
}
if (!state) {
state = {};
}
this._state = JSON.parse(JSON.stringify(state));
},
{
_state: null,
slideshowId: null,
market: null,
image: null,
isImmersive: true,
getPageImpressionContext: function getPageImpressionContext() {
var prefix = "";
if (this.instrumentationEntryPoint === Platform.Instrumentation.InstrumentationArticleEntryPoint.partnerPano) {
prefix = NewsJS.Telemetry.String.ImpressionContext.partnerPano;
}
return prefix + NewsJS.Telemetry.String.ImpressionContext.slideShow;
},
getPageState: function getPageState() {
var slideShowControl = PlatformJS.Utilities.getControl("ssView");
if (slideShowControl) {
this._state.imageIndex = slideShowControl.currentPage;
}
return this._state;
},
getPageData: function getPageData() {
var that = this;
var provider = null;
if (this._state.providerType) {
provider = PlatformJS.Utilities.createObject(this._state.providerType, this._state.providerConfiguration);
} else {
var options = { slideshowId: that.slideshowId, market: that.market, queryServiceId: "MarketBedrockSlideshows" };
provider = new CommonJS.SlideShowProvider(options);
}
var config = PlatformJS.Collections.createStringDictionary();
var p = new WinJS.Promise(function (complete) {
var result = {
clickHandler: WinJS.Utilities.markSupportedForProcessing(function (value) {
that.articleLinkHandler(value);
}),
dontShowSlideTitle: that.dontShowSlideTitle,
startIndex: that.imageIndex,
dataOptions: {
provider: provider,
config: config
},
instrumentationEntryPoint: that.instrumentationEntryPoint
};
complete(result);
});
return p;
},
onBindingComplete: function onBindingComplete() {
},
onLayoutChange: function onLayoutChange(layoutMode) {
var slideView = PlatformJS.Utilities.getControl("ssView");
var applicationViewState = Windows.UI.ViewManagement.ApplicationViewState;
if (slideView && slideView.semanticZoom) {
if (layoutMode === applicationViewState.snapped) {
slideView.semanticZoom.zoomedOut = false;
slideView.semanticZoom.locked = true;
} else {
slideView.semanticZoom.locked = false;
}
}
},
articleLinkHandler: function articleLinkHandler(value) {
var that = this;
var uriString = value;
var result = NewsJS.Utilities.parseCMSUriString(uriString, that.market);
if (result && result.entitytype === "article") {
var navigationPromise = NewsJS.Utilities.mapUriToNavigation(result);
if (navigationPromise) {
navigationPromise.then(function (navigation) {
if (navigation && navigation.dataAvailable) {
navigation.dataAvailable.then(function (navigationOk) {
if (navigationOk) {
Platform.Telemetry.FlightRecorder.setImpressionNavMethod(NewsJS.Telemetry.String.ImpressionNavMethod.slideShow);
NewsJS.Telemetry.SlideShow.recordSlideShowToArticle(that.slideshowId, that.market, result.pageId, result.contentId);
navigation.state.instrumentation = that._state.instrumentation;
WinJS.Navigation.navigate({
fragment: navigation.pageInfo.fragment,
page: navigation.pageInfo.page
}, navigation.state);
} else {
NewsJS.Utilities.showToast(PlatformJS.Services.resourceLoader.getString("ArticleUnavailableOffline"));
}
});
}
});
}
}
},
})
});
})();