﻿/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS", {
ArticleReaderPage: WinJS.Class.derive(DynamicPanoJS.DynamicArticleReaderPage,
function (state) {
DynamicPanoJS.DynamicArticleReaderPage.call(this, state);
},
{
_handleShareRequestImpl: function _handleShareRequestImpl(request, shareData) {
var that = this;
if (!shareData.pageState || !shareData.articleHeader) {
return null;
}
request.data.properties.title = that.formatShareTitle(shareData);
request.data.properties.description = that.formatShareDescription(shareData);
var htmlText = that.formatShareHTML(shareData);
if (htmlText) {
var htmlFormat = Windows.ApplicationModel.DataTransfer.HtmlFormatHelper.createHtmlFormat(htmlText);
request.data.setHtmlFormat(htmlFormat);
}
var uriText = that.formatShareUri(shareData);
if (uriText) {
request.data.setText(that.formatShareText(shareData, request.data.properties.description, uriText));
request.data.setUri(new Windows.Foundation.Uri(uriText));
}
},
formatShareUri: function formatShareUri(shareData) {
//Use sharing url if it is provided otherwise fallback to deeplinking with article id
if (shareData.articleHeader) {
var sharingUrl = shareData.articleHeader.sharingUrl;
if (sharingUrl && typeof sharingUrl === "string" && sharingUrl.length > 0) {
// a parameter: 0 -> finance, 1 -> news, 2 -> sports, 3 -> travel, 4 -> weather
sharingUrl += "?a=0&m=" + Windows.Foundation.Uri.escapeComponent(shareData.pageState.market);
return sharingUrl;
}
}
if (shareData.articleId) {
var uriBuilder = new Platform.Utilities.AppExUriBuilder();
uriBuilder.controllerId = "application";
uriBuilder.commandId = "view";
uriBuilder.queryParameters.insert("entitytype", "article");
var urlParts = shareData.articleId.split("/");
uriBuilder.queryParameters.insert("pageid", urlParts[0]);
if (urlParts.length === 2) {
uriBuilder.queryParameters.insert("contentid", urlParts[1]);
}
else {
uriBuilder.queryParameters.insert("contentid", "");
}
uriBuilder.queryParameters.insert("market", shareData.pageState.market);
var uriString = uriBuilder.toString();
return uriString;
}
else {
return null;
}
},
formatShareTitle: function formatShareTitle(shareData) {
if (shareData.articleHeader.headline) {
return utils.getShareContractSubject(shareData.articleHeader.headline);
}
else {
return "";
}
},
formatShareDescription: function formatShareDescription(shareData) {
var publisherName = shareData.articleHeader.publisherName || "";
var result = shareData.articleHeader.author ? (shareData.articleHeader.author + " | ") : "";
if (publisherName && result) {
result += publisherName + " | ";
}
if (result) {
result += shareData.articleHeader.date;
}
return result;
},
formatShareText: function formatShareText(shareData, description, uri) {
return shareData.articleHeader.headline + "\n" + description + "\n" + shareData.articleHeader.snippet + "\n" + uri;
},
formatShareHTML: function formatShareHTML(shareData) {
var shareUri = this.formatShareUri(shareData);
if (shareUri) {
var win8ShareText = PlatformJS.Services.resourceLoader.getString("/platform/win8Share");
var win8ShareLinkText = PlatformJS.Services.resourceLoader.getString("/platform/win8ShareLink");
var link = '<a href=\"' + shareUri + '\">' + win8ShareLinkText.format(CommonJS.getAppName()) + '</a>';
var message = win8ShareText.format(PlatformJS.Services.resourceLoader.getString("/platform/win8Brand"), link);
return "<h2><b>" + shareData.articleHeader.headline +
"</b></h2><p>" + shareData.articleHeader.author +
"</p><p>" + shareData.articleHeader.publisherName + " - " + shareData.articleHeader.date +
"</p><blockquote style=\"background-color:#f2efed\">" + shareData.articleHeader.snippet +
"</blockquote><p>" + message + "</p>";
}
else {
return "";
}
},
dispose: function dispose() {
// Make sure the header disposes of its event handlers.
utils.disposeHeaderControl();
DynamicPanoJS.DynamicArticleReaderPage.prototype.dispose.call(this);
}
}),
});
})();