﻿(function () {
"use strict";
//Remove base page if there are no functionalities reqd for onNavigateAway, OnOrientationChanged etc
WinJS.Namespace.define("FinanceAppJS.Calculator", {
BasePage: WinJS.Class.define(function (state) {
FinanceAppJS.Utils.ResumeHandler.suspendCallback = this.saveToRoaming;
// Attach action to Help button
utils.tryAttachHelpButtonAction();
}, {
chartData: null,
scaledChartData: null,
setDataObject: function setDataObject(dataObject) {
this.data = dataObject.data;
this.data.pageTitle = dataObject.pageTitle;
},
convertMonthsToYearInChart: function convertMonthsToYearInChart(labels) {
var chartData = this.scaledChartData;
if (labels[0].value % 12 === 0) {
chartData.xaxis.labels = labels.map(function (item) {
var itemValue = item.value;
item.value = (item.value / 12);
item.label = (item.label / 12);
if (itemValue % 12 !== 0) {
item.label = FinanceAppJS.Utils.Formatters.numberFormatter(item.label, 1);
}
return item;
});
chartData.xaxis.name = utils.getResourceString("yearsLabel");
}
else {
chartData.xaxis.labels = labels;
}
},
scaleChart: function scaleChart(chartData, compoundingNMonths, totalPeriods, index) {
if (typeof index === 'undefined' || index === null) {
index = 0;
}
this.scaledChartData = {};
utils.deepCopy(chartData, this.scaledChartData);
var totalPeriods = totalPeriods;
this["chartData" + index] = chartData;
this.compoundingNMonths = compoundingNMonths;
this.totalPeriods = totalPeriods;
chartData = this.scaledChartData;
var maxBars = (screen.width < FinanceAppJS.Constants.Tools.MinScreenWidthForMaxBars) ? FinanceAppJS.Constants.Tools.SecondMaxBars : FinanceAppJS.Constants.Tools.MaxBars;
if (totalPeriods <= maxBars) {
this.convertMonthsToYearInChart(chartData.xaxis.labels);
return chartData;
}
var compoundingValuesinMonths = FinanceAppJS.Constants.Tools.CompoundingMonthsList;
var index = compoundingValuesinMonths.indexOf(compoundingNMonths);
var divisorsList = [];
for (var i = index; i < compoundingValuesinMonths.length; i++) {
divisorsList.push(compoundingValuesinMonths[i] / compoundingNMonths);
}
var lastDivisorValue = divisorsList[divisorsList.length - 1];
var noOfBars = totalPeriods;
var count = 0, yearCount = 1, divisor, initialNoOfBars = noOfBars;
while (noOfBars > maxBars) {
if (count < divisorsList.length) {
divisor = Math.floor(divisorsList[count]);
count++;
}
else {
divisor = lastDivisorValue * yearCount;
yearCount++;
}
noOfBars = initialNoOfBars / divisor;
}
var remainingBars = initialNoOfBars % divisor;
var labels = [];
for (var k = 0 ; k < chartData.data.length; k++) {
var temp = [];
for (var j = divisor - 1; j < chartData.data[k].points.length; j += divisor) {
temp.push(chartData.data[k].points[j]);
if (k === 0) {
labels.push(chartData.xaxis.labels[j]);
}
}
if (remainingBars) {
temp.push(chartData.data[k].points[chartData.data[k].points.length - 1]);
if (k === 0) {
labels.push(chartData.xaxis.labels[chartData.xaxis.labels.length - 1]);
}
}
chartData.data[k].points = temp;
}
this.convertMonthsToYearInChart(labels);
return chartData;
},
getPageData: function getPageData() {
var pageData = {
data: this.data,
};
return WinJS.Promise.wrap(pageData);
},
onWindowResize: function onWindowResize(e) {
this.redrawChart();
},
onOrientationChange: function onOrientationChange(e) {
this.redrawChart();
},
onLayoutChange: function onLayoutChange(e) {
this.redrawChart();
},
redrawChart: function redrawChart() {
var that = this;
msSetImmediate(function () {
that.baseControl = that.baseControl || document.querySelector(".calculatorPage").winControl;
if (that.baseControl) {
var calcObject = that.baseControl.calculatorObject;
calcObject.reComputeAndRedrawChart(that);
}
});
},
saveToRoaming: function saveToRoaming() {
this.baseControl = this.baseControl || document.querySelector(".calculatorPage").winControl;
if (this.baseControl) {
this.baseControl.writeInputDataToRoaming();
this.baseControl.writeSelectedModeToRoaming();
this.baseControl.writeSelectedSubModeToRoaming();
this.baseControl.clearErroneousDataFromRoaming();
}
},
getPageState: function getPageState() {
},
/// <summary>
/// This function is invoked by the UX Framework (navigator) when the page is getting disposed
/// </summary>
/// <param>
/// None
/// </param>
/// <returns>
/// Nothing
/// </returns>
dispose: function dispose() {
// Make sure the header disposes of its event handlers.
utils.disposeHeaderControl();
},
onNavigateAway: function onNavigateAway(reason) {
this.saveToRoaming();
this.baseControl = this.baseControl || document.querySelector(".calculatorPage").winControl;
if (this.baseControl) {
this.baseControl.dispose();
}
FinanceAppJS.Utils.ResumeHandler.suspendCallback = null;
}
}, {            
colorBar0: utils.getColorWithOpacity(utils.JsLessVariables(true).colorBgSub, 70),
colorBar1: utils.getColorWithOpacity(utils.JsLessVariables(true).colorBgMain, 50),
colorBar2: utils.getColorWithOpacity(utils.JsLessVariables(true).colorBgSub, 100)
})
});
})();
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS.Calculator", {
PageControl: WinJS.Class.define(function (element, options) {
element.winControl = this;
this._domElement = element;
this._calculatorElement = document.createElement("div");
WinJS.Utilities.addClass(this._domElement, "calculatorPage");
}, {
_domElement: null,
_options: null,
_calculatorElement: null,
_header: null,
_data: null,
_currentModeIndex: null,
_currentModeElement: null,
_isErrorAtModeIndex: null,
_node: null,
data: {
get: function get() { return this._data; },
set: function set(value) {
this._data = value;
//By default, setting isError as false for all modes. On error, this will be changed to true
this._isErrorAtModeIndex = [];
for (var i = 0; i < this._data.modes.length; i++) {
if (this._data.modes[i].subModes) {
var temp = [];
for (var j = 0; j < this._data.modes[i].subModes.length; j++) {
temp.push(false);
}
this._isErrorAtModeIndex.push(temp);
}
else {
this._isErrorAtModeIndex.push(false);
}
}
this.setSelectedModeFromRoaming();
if (this._data.modes[this._currentModeIndex].subModes) {
this.setSelectedSubModeFromRoaming(this._currentModeIndex);
}
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.TOOLS,
this._data.modes[this._currentModeIndex].title,
FinanceAppJS.Telemetry.Constants.Location.MODESELECTOR,
"");
this.setInputDataFromRoaming(this._currentModeIndex);
this.createHeader();
}
},
getDefaultValuesAndRange: function getDefaultValuesAndRange(modeIndex) {
var node;
var config = FinanceAppJS.Globalization.getCalculatorValues();
if (this._data.modes.length > 1) {
var currentMode = this._data.modes[modeIndex];
if (currentMode.subModes) {
var currentSubMode = currentMode.subModes[currentMode.subModeIndex];
node = currentSubMode.subtitle;
}
else {
node = currentMode.title;
}
}
else {
node = this._data.pageTitle;
}
this._node = node;
var calcObject = {};
calcObject.defaultValues = {};
calcObject.min = {};
calcObject.max = {};
var currentConfig = config[node];
for (var key in currentConfig) {
calcObject.defaultValues[key] = currentConfig[key].default;
calcObject.max[key] = currentConfig[key].max;
calcObject.min[key] = currentConfig[key].min;
}
this.currentCalcConfig = calcObject;
return this.currentCalcConfig;
},
dispose: function dispose() {
var modes = this._modesContainer.childNodes;
for (var i = 0; i < modes.length; i++) {
modes[i].onclick = null;
modes[i].onkeyup = null;
}
if (this.subModeList) {
this.subModeList.onchange = null;
}
this.calculatorObject.dispose();
},
createSubModeElements: function createSubModeElements(i) {
var subModeElement = document.createElement('div');
subModeElement.id = this._node + "_SubModeElement";
subModeElement.setAttribute("aria-describedby", this._node + "_SubModeElement");
var label = document.createElement('label');
label.id = this._node + "_Label";
label.setAttribute("aria-describedby",this._node + "_Label");
WinJS.Utilities.addClass(label, "inputLabel");
WinJS.Utilities.addClass(label, "subModeLabel");
label.textContent = this._data.modes[i].subModeListLabel;
var subModeList = document.createElement('select');
subModeList.id = this._node + "_SubModeList";
subModeList.setAttribute("aria-describedby", this._node + "_SubModeList");
WinJS.Utilities.addClass(subModeList, "listOptions");
for (var k = 0; k < this._data.modes[i].subModes.length; k++) {
var option = document.createElement('option');   
option.value = k;
option.textContent = utils.getResourceString(this._data.modes[i].subModes[k].subtitle);
option.id = this._data.modes[i].subModes[k].subtitle;
option.setAttribute("aria-describedby",this._data.modes[i].subModes[k].subtitle);
subModeList.appendChild(option);
}
subModeList.value = this._data.modes[i].subModeIndex;
subModeList.onchange = this.subModeChanged.bind(this, i);
this.subModeList = subModeList;
subModeElement.appendChild(label);
subModeElement.appendChild(subModeList);
return subModeElement;
},
subModeChanged: function subModeChanged(i, event) {
var subModeIndex = event.target.value;
var data = this._data.modes[i].subModes[subModeIndex];
this._calculatorElement.innerHTML = "";
this.writeInputDataToRoaming();
this._data.modes[i].subModeIndex = parseInt(subModeIndex);
this.setInputDataFromRoaming(i);
//disposing previous calc object and creating a new one
this.calculatorObject.dispose();
this.calculatorObject = new FinanceAppJS.Calculator.CalculatorControl(this._calculatorElement, { data: data, automationId: this._node });
},
createBodyElement: function createBodyElement(defaultMode, bodyElement, modeIndex) {
if (defaultMode.subModes) {
var list = this.createSubModeElements(modeIndex);
WinJS.Utilities.addClass(list, "subModeContainer");
bodyElement.appendChild(list);
}
this._calculatorElement.innerHTML = "";
bodyElement.appendChild(this._calculatorElement);
var currentMode;
if (defaultMode.subModes) {
currentMode = defaultMode.subModes[defaultMode.subModeIndex];
}
else {
currentMode = defaultMode;
}
this.calculatorObject = new FinanceAppJS.Calculator.CalculatorControl(this._calculatorElement, { data: currentMode, automationId: this._node});
},
createModeElements: function createModeElements(i) {
var modeTab = document.createElement("div");
WinJS.Utilities.addClass(modeTab, "modeTab");
if (i === this._currentModeIndex) {
WinJS.Utilities.addClass(modeTab, "active");
this._currentModeElement = modeTab;
// Set Accessibility
modeTab.setAttribute("tabindex", 0);
};
var modeTabText = this._data.modes[i].title;
modeTab.textContent = utils.getResourceString(modeTabText);
modeTab.id = modeTabText;
modeTab.setAttribute("aria-describedby", modeTabText);
modeTab.onclick = this.modeChanged.bind(this, i);
// Set Accessibility. Attach keyup / pressed Events.
modeTab.onkeyup = this.keyUPEvents.bind(this, i);
this._modesContainer.appendChild(modeTab);
},
modeChanged: function modeChanged(i, currentSelectedMode) {
if (i !== this._currentModeIndex) {
WinJS.Utilities.addClass(currentSelectedMode.target, "active");
WinJS.Utilities.removeClass(this._currentModeElement, "active");
// Set Tabindex on click
currentSelectedMode.target.setAttribute("tabindex", 0);
this._currentModeElement.setAttribute("tabindex", -1);
this._calculatorElement.innerHTML = "";
if (this._data.modes[i].subModes) {
this.setSelectedSubModeFromRoaming(i);
}
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.TOOLS,
this._data.modes[i].title,
FinanceAppJS.Telemetry.Constants.Location.MODESELECTOR,
"");
this.writeInputDataToRoaming();
this.setInputDataFromRoaming(i);
if (this._data.modes[this._currentModeIndex].subModes) {
this.writeSelectedSubModeToRoaming();
}
if (this._data.modes[this._currentModeIndex].navInstrumentId) {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, this._data.modes[this._currentModeIndex].navInstrumentId, 1);
}
//disposing previous calc object and creating a new one
this.calculatorObject.dispose();
if (this.subModeList) {
this.subModeList.onchange = null;
}
var dataObject;
var defaultMode = this._data.modes[i];
var bodyElement = this._bodyElement;
bodyElement.innerHTML = "";
this.createBodyElement(defaultMode, bodyElement, i);
this._currentModeIndex = i;
this._currentModeElement = currentSelectedMode.target;
}
},
createHeader: function createHeader() {
var header = document.createElement("div");
header.id = this._data.pageTitle + "_header";
var immersiveHeader = new CommonJS.Immersive.Header(header, { headerTitleText: utils.getResourceString(this._data.pageTitle) });
this._domElement.appendChild(header);
this._modesContainer = document.createElement("div");
WinJS.Utilities.addClass(this._modesContainer, "modesContainer");
if (this._data.modes.length > 1) {
for (var i = 0; i < this._data.modes.length; i++) {
this.createModeElements(i);
}
this._domElement.appendChild(this._modesContainer);
}
var defaultMode = this._data.modes[this._currentModeIndex];
var bodyElement = this._bodyElement = document.createElement('div');
WinJS.Utilities.addClass(bodyElement, "bodyElement");
this._domElement.appendChild(bodyElement);
this.createBodyElement(defaultMode, bodyElement, this._currentModeIndex);
},
writeInputDataToRoaming: function writeInputDataToRoaming() {
var roaming = FinanceAppJS.Calculator.RoamingInterface.getInstance();
var key = this._data.pageTitle + "_" + this._currentModeIndex;
if (this._data.modes[this._currentModeIndex].subModes) {
key += "_" + this._data.modes[this._currentModeIndex].subModeIndex;
}
var data = this.calculatorObject.inputFieldsValue;                   
for (var sym in data) {                    
data[sym] = CollectionProvider.Formatters.parseNumberWithSeparator(data[sym]);
}
if (this.calculatorObject.currentResultObject.type === 'error') {
if (this._data.modes[this._currentModeIndex].subModes) {
this._isErrorAtModeIndex[this._currentModeIndex][this._data.modes[this._currentModeIndex].subModeIndex] = true;
}
else {
this._isErrorAtModeIndex[this._currentModeIndex] = true;
}
}
roaming.writeToRoaming(data, key, "inputFields");
},
setInputDataFromRoaming: function setInputDataFromRoaming(modeIndex) {
var currentCalc;
var config = this.getDefaultValuesAndRange(modeIndex);
var data;
var roaming = FinanceAppJS.Calculator.RoamingInterface.getInstance();
var key = this._data.pageTitle + "_" + modeIndex;
if (this._data.modes[modeIndex].subModes) {
key += "_" + this._data.modes[modeIndex].subModeIndex;
}
var roamingData = roaming.readFromRoaming(key, "inputFields");
if (roamingData) {
data = roamingData;
}
else {
data = config.defaultValues;
}
if (data) {
var currentMode = this._data.modes[modeIndex];
if (currentMode.subModes) {
currentCalc = currentMode.subModes[currentMode.subModeIndex];
}
else {
currentCalc = currentMode;
}
currentCalc.inputData = data;
currentCalc.minValues = config.min;
currentCalc.maxValues = config.max;
}
},
writeSelectedModeToRoaming: function writeSelectedModeToRoaming() {
if (this._data.modes.length > 1) {
var roaming = FinanceAppJS.Calculator.RoamingInterface.getInstance();
var key = this._data.pageTitle;
var data = this._currentModeIndex;
roaming.writeToRoaming(data, key, "modeIndex");
}
},
writeSelectedSubModeToRoaming: function writeSelectedSubModeToRoaming() {
if (this._data.modes.length > 1) {
if (this._data.modes[this._currentModeIndex].subModes) {
var roaming = FinanceAppJS.Calculator.RoamingInterface.getInstance();
var key = this._data.pageTitle + "_" + this._currentModeIndex;
var data = this._data.modes[this._currentModeIndex].subModeIndex;
roaming.writeToRoaming(data, key, "subModeIndex");
}
}
},
setSelectedModeFromRoaming: function setSelectedModeFromRoaming(modeIndex) {
this._currentModeIndex = 0;
if (this._data.modes.length > 1) {
var roaming = FinanceAppJS.Calculator.RoamingInterface.getInstance();
var key = this._data.pageTitle;
var data = roaming.readFromRoaming(key, "modeIndex");
if (data) {
this._currentModeIndex = data;
}
}
},
setSelectedSubModeFromRoaming: function setSelectedSubModeFromRoaming(modeIndex) {
var roaming = FinanceAppJS.Calculator.RoamingInterface.getInstance();
var key = this._data.pageTitle + "_" + modeIndex;
var data = roaming.readFromRoaming(key, "subModeIndex");
if (data) {
this._data.modes[modeIndex].subModeIndex = data;
}
else {
this._data.modes[modeIndex].subModeIndex = 0;
}
},
clearErroneousDataFromRoaming: function clearErroneousDataFromRoaming() {
var roaming = FinanceAppJS.Calculator.RoamingInterface.getInstance();
for (var i = 0; i < this._isErrorAtModeIndex.length; i++) {
if (this._isErrorAtModeIndex[i] instanceof Array) {
for (var j = 0; j < this._isErrorAtModeIndex[i].length; j++) {
if (this._isErrorAtModeIndex[i][j]) {
var key = this._data.pageTitle + "_" + i + "_" + j;
roaming.writeToRoaming(null, key, "inputFields");
}
}
}
else {
if (this._isErrorAtModeIndex[i]) {
var key = this._data.pageTitle + "_" + i;
roaming.writeToRoaming(null, key, "inputFields");
}
}
}
},
keyUPEvents: function keyUPEvents(i, event) {
if (!event) {
return;
}
var keyCode = event.keyCode;
switch (keyCode) {
case WinJS.Utilities.Key.leftArrow:
case WinJS.Utilities.Key.rightArrow:
FinanceAppJS.Utils.Navigator.leftRightArrowKeyDown(event, false, true);
break;
case WinJS.Utilities.Key.space:
case WinJS.Utilities.Key.enter:
this.modeChanged(i, event);
break;
case WinJS.Utilities.Key.tab:
case WinJS.Utilities.Key.shift:
return true;
}
}
}, {
})
});
})();
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS.Calculator", {
CalculatorControl: WinJS.Class.define(function (element, options) {
this._data = options.data;
this._automationId = options.automationId;
WinJS.Utilities.addClass(element, "calculatorElement");
var inputPanel = this._inputPanel = document.createElement("div");
inputPanel.id = this._automationId + "_InputPanel";
inputPanel.setAttribute("aria-describedby", this._automationId + "_InputPanel");
var midPanel = this._midPanel = document.createElement("div");
midPanel.id = this._automationId + "_MidPanel";
midPanel.setAttribute("aria-describedby", this._automationId + "_MidPanel");
var resultPanel = this._resultPanel = document.createElement("div");
resultPanel.id = this._automationId + "_ResultPanel";
resultPanel.setAttribute("aria-describedby", this._automationId + "_ResultPanel");
var adElement = this._adElement = document.createElement("div");
adElement.id += this._automationId + "_adElement";
adElement.setAttribute("aria-describedby", this._automationId + "_adElement");
this.calcElement = element;
this.renderInputPanel(inputPanel).then(this.onInputPanelRendered.bind(this));
}, {
_data: null,
_inputPanel: null,
_midPanel: null,
_resultPanel: null,
_resultPanelRendered: false,
chartTableArea: null,
chartContainer: null,
calculateButton: null,
_automationId:null,
reComputeAndRedrawChart: function reComputeAndRedrawChart(ipageObject) {
if (this.currentSelectedTab >= 0) {
var keys = ["firstTab", "secondTab"];
for (var i = 0; i < keys.length; i++) {
if (this.currentResultObject[keys[i]].type === 'chart') {
var chartData = ipageObject.scaleChart(ipageObject["chartData" + i], ipageObject.compoundingNMonths, ipageObject.totalPeriods, i);
this.currentResultObject[keys[i]].data = chartData;
}
}
var currentIndex = this.currentSelectedTab;
if (this.currentResultObject[keys[currentIndex]].type === 'chart') {
this.renderChart(this.chartTableArea, this.currentResultObject[keys[currentIndex]].data);
}
}
},
reCalculateOnEnterKeyPressed: function reCalculateOnEnterKeyPressed(event) {
//If Enter key is hit on the input elements, it should have the same effect as that of hitting the calculate button
if (event.keyCode === WinJS.Utilities.Key.enter) {
this.onCalculateButtonInvoked();
event.preventDefault();
}
},
onInputPanelRendered: function onInputPanelRendered() {
this.calculateButton.onclick = this.onCalculateButtonInvoked.bind(this);
this.calculateButton.addEventListener("MSLostPointerCapture", PlatformJS.Utilities.pointerEventListenersMap["MSLostPointerCapture"], false);
this.calculateButton.addEventListener("MSPointerCancel", PlatformJS.Utilities.pointerEventListenersMap["MSPointerCancel"], false);
this.calculateButton.addEventListener("MSPointerUp", PlatformJS.Utilities.pointerEventListenersMap["MSPointerUp"], false);
this.calculateButton.addEventListener("MSPointerDown", PlatformJS.Utilities.pointerEventListenersMap["MSPointerDown"], false);
this.calculateButton.addEventListener("MSPointerOut", PlatformJS.Utilities.pointerEventListenersMap["MSPointerOut"], false);
for (var i = 0; i < this._inputElements.length; i++) {
this._inputElements[i].onkeypress = this.reCalculateOnEnterKeyPressed.bind(this);
}
var outputObject = this.calculate();
if (this._data.pageViewId) {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.PlatformInstrumentationDataSetId, this._data.pageViewId, 1);
}
if (outputObject) {
if (outputObject.type === 'error') {
this.showError(this._midPanel, outputObject.errorMsg);
}
else {
this.renderMidPanel(this._midPanel, outputObject.firstTab, outputObject.secondTab);
this.renderResultPanel(this._resultPanel, outputObject.opfields);
//this.renderAds(this._adElement);
}
}
},
onCalculateButtonInvoked: function onCalculateButtonInvoked() {
var outputObject = this._outputObject = this.calculate();
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.TOOLS,
this._data.title,
FinanceAppJS.Telemetry.Constants.Location.CALCBUTTON,
this._data.subtitle);
// Add instrumentation for Calculate Button.
if (this._data.instrumentationId) {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, this._data.instrumentationId, 1);
}
if (outputObject.type === 'error') {
this.showError(this._midPanel, outputObject.errorMsg);
}
else {
if (outputObject.unchanged === false) {
var dataObj, key;
if (this.currentSelectedTab === 0 || this.currentSelectedTab === 1) {
if (this.currentSelectedTab === 0) {
dataObj = outputObject.firstTab;
key = "firstTab";
}
else {
dataObj = outputObject.secondTab;
key = "secondTab";
}
if (dataObj.type === "chart") {
this.renderChart(this.chartTableArea, dataObj.data, key);
}
else {
this.renderTable(this.chartTableArea, dataObj.data, key);
}
}
else {
this.renderMidPanel(this._midPanel, outputObject.firstTab, outputObject.secondTab);
}
this.renderResultPanel(this._resultPanel, outputObject.opfields);
}
}
},
showError: function showError(element, errorMsg) {
element.innerHTML = "";
//If midPanel was rendered before with correct values, remove that class
WinJS.Utilities.removeClass(element, "midPanel");
WinJS.Utilities.addClass(element, "errorPanel");
this.currentSelectedTab = -1;
if (!errorMsg) {                    
var genericErrorMsg = utils.getResourceString("CalculatorExceptionError");
errorMsg = genericErrorMsg;
}
var errorDiv = document.createElement('div');
errorDiv.id = this._automationId + "_ErrorDiv";
errorDiv.setAttribute("aria-describedby", this._automationId + "_ErrorDiv");
errorDiv.innerHTML = errorMsg;
WinJS.Utilities.addClass(errorDiv, "errordiv");
element.appendChild(errorDiv);
//Clearing out all charts and tables. TODO: check if this reqd for tables as well
this.firstTabChartControl = null;
this.firstTabTableControl = null;
this.secondTabChartControl = null;
this.secondTabTableControl = null;
if (this._resultPanelRendered) {
this.calcElement.removeChild(this._resultPanel);
this._resultPanelRendered = false;
}
else {
this.calcElement.appendChild(element);
}
},
calculate: function calculate() {
//TODO: Add logic to use default value if user does not type in anything and presses calculate
var equal = true;
var inputObject = {};
var minValues = {};
for (var j = 0; j < this._data.inputFields.length; j++) {
var field = this._data.inputFields[j];
var element = this._inputPanel.querySelector("#" + field);
inputObject[field] = element.value;
minValues[field] = element.min;
}
if (this.inputFieldsValue) {
for (var prop in inputObject) {
if (this.inputFieldsValue[prop] !== inputObject[prop]) {
equal = false;
break;
}
}
}
else {
this.inputFieldsValue = {};
equal = false;
}
if (equal) {
var obj = this.currentResultObject ? this.currentResultObject : {};
obj.unchanged = true;
return obj;
}
utils.deepCopy(inputObject, this.inputFieldsValue);
var outputObject = this.currentResultObject = this._data.calculateFunction(inputObject, minValues);
outputObject.unchanged = false;
return outputObject;
},
renderInputPanel: function renderInputPanel(element) {
WinJS.Utilities.addClass(element, "toolsInputPanel");
var inputTemplate = document.getElementById(this._data.inputTemplate).winControl;
var bindingInfo = this._data.extraInputBindingInfo || null;
return inputTemplate.render(bindingInfo).then(this.onInputTemplateRendered.bind(this, element));
},
onInputTemplateRendered: function onInputTemplateRendered(parentElement, elem) {
parentElement.appendChild(elem);
var inputElements = [];
for (var i = 0; i < this._data.inputFields.length; i++) {
var bindingField = this._data.inputFields[i];
var inputElem = elem.querySelector("#" + bindingField);
inputElem.max = this._data.maxValues[bindingField];
inputElem.min = this._data.minValues[bindingField];
inputElem.precision = ( this._data.precision && this._data.precision[bindingField] >= 0 ) ? this._data.precision[bindingField] : 0;
//If it is a list box where the min and max values for the options need to be populated, it is done here after reading from the config
if (inputElem.winControl && inputElem.winControl.populateMinMax) {
inputElem.winControl.minMax = { min: inputElem.min, max: inputElem.max };
}
var inputInitValue = this._data.inputData[bindingField];
var inputInitValueDecimalPlaces = 0;
if (inputElem.precision > 0) {
var valueAsString = String(inputInitValue);
var decimalCharPos = valueAsString.indexOf(".");
inputInitValueDecimalPlaces = ((decimalCharPos == -1) ? 0 : (valueAsString.length - (decimalCharPos + 1)));
}
inputElem.value = CollectionProvider.Formatters.formatNumber(this._data.inputData[bindingField], inputInitValueDecimalPlaces);
inputElements.push(inputElem);
}
this._inputElements = inputElements;
this.initValidation(inputElements);
var calculateButton = document.createElement("button");
calculateButton.id = this._automationId + "_CalculateButton";
calculateButton.setAttribute("aria-describedby", this._automationId + "_CalculateButton");
WinJS.Utilities.addClass(calculateButton, "calculateButton");
calculateButton.textContent = utils.getResourceString("Calculate");
this.calculateButton = calculateButton;
parentElement.appendChild(calculateButton);
this.calcElement.appendChild(parentElement);
},
initValidation: function initValidation(inputElements) {
var inputElementsValidationData = [];
for (var i = 0 ; i < inputElements.length ; i++) {
var inputElement = inputElements[i];
inputElement.maxLength = 20;
var inputValidationData = {};
var noOfDecimalPlacesInMax = String(inputElement.max).indexOf(".");
if (noOfDecimalPlacesInMax < 0) {
noOfDecimalPlacesInMax = 0;
} else {
noOfDecimalPlacesInMax = (inputElement.max.length - (noOfDecimalPlacesInMax+1));
}
inputValidationData = {
inputElement: inputElement,
createErrMsgElemInParent: true,
minValidation: { enabled: false },
maxValidation: { enabled: true, msg: utils.getResourceString("ValueExceedsMaxMessage").format(CollectionProvider.Formatters.formatNumber(inputElement.max, noOfDecimalPlacesInMax)) },
decimalValidation: { noOfDecimalPlaces: inputElement.precision, enabled: true },
errMsgEleClass: "inputerrorMsg"
};
inputElementsValidationData.push(inputValidationData);
}
this.inputValidator = new FinanceAppJS.Calculator.NumberInputValidator(inputElementsValidationData);
this.inputValidator.validate();
},
renderChart: function renderChart(element, data, key) {
var chartContainerKey = key + "ChartContainer";
var chartControlKey = key + "ChartControl";
element.innerHTML = "";
if (!this[chartContainerKey]) {
this[chartContainerKey] = document.createElement("div");
this[chartContainerKey].id = this._automationId + "_ToolChartContainer";
this[chartContainerKey].setAttribute("aria-describedby", this._automationId + "_ToolChartContainer");
}
element.appendChild(this[chartContainerKey]);
if (data.type === 'error') {
WinJS.Utilities.addClass(element, "chartErrorHost");
WinJS.Utilities.removeClass(this[chartContainerKey], "toolchartContainer");
WinJS.Utilities.addClass(this[chartContainerKey], "chartErrorMsg");
this[chartContainerKey].textContent = data.errorMsg;
}
else {
WinJS.Utilities.removeClass(element, "chartErrorHost");
WinJS.Utilities.removeClass(this[chartContainerKey], "chartErrorMsg");
WinJS.Utilities.addClass(this[chartContainerKey], "toolchartContainer");
if (!this[chartControlKey]) {
var chartOptions = this._data.chartOptions || {};
chartOptions.legendParent = this.chartTableArea;
this[chartControlKey] = new CommonJS.BarChartControl(this[chartContainerKey], chartOptions);
}
this[chartControlKey].data = data;
}
},
renderTable: function renderTable(element, data, key) {
element.innerHTML = "";
//TODO: should this be replaced with commonJS table?
var tableControlKey = key + "TableControl";
this[tableControlKey] = new CommonJS.PanoEx.Clusters.TableView(element);
this[tableControlKey].stickyHeader = true;
this[tableControlKey].tableDataArray = data;
var tableRenderPromise = this[tableControlKey + "Promise"] = this[tableControlKey].render();                
var busyControl = this.busyControl;
if (busyControl) {
WinJS.Utilities.addClass(busyControl, "visible");
}
tableRenderPromise.then(function () {
if (busyControl) {
WinJS.Utilities.removeClass(busyControl, "visible");
}
});
},
onChartTableButtonsClicked: function onChartTableButtonsClicked(selection) {
var promise;
if (this.busyControl) {
WinJS.Utilities.removeClass(this.busyControl, "visible");
}
if (this.currentSelectedTab !== selection) {
var currentElement, otherElement, dataKey, renderFunc;
if (selection === 0) {
promise = this.secondTabTableControlPromise;
currentElement = this._firstTabButton;
otherElement = this._secondTabButton;
dataKey = "firstTab";
}
else if (selection === 1) {
promise = this.firstTabTableControlPromise;
currentElement = this._secondTabButton;
otherElement = this._firstTabButton;
dataKey = "secondTab";
}
if (promise) {
promise.cancel();
}
WinJS.Utilities.removeClass(this.chartTableArea, "tableview");
this.currentSelectedTab = selection;
this.chartTableArea.innerHTML = "";
WinJS.Utilities.addClass(currentElement, "active");
WinJS.Utilities.removeClass(otherElement, "active");
var dataObject = this.currentResultObject[dataKey];
if (dataObject.type === 'chart') {
renderFunc = this.renderChart;
}
else {
renderFunc = this.renderTable;
}
var data = {
displayType: dataObject.type,
name: currentElement.id
};
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.TOOLS,
this._data.title,
FinanceAppJS.Telemetry.Constants.Location.CHARTTABLESELECTOR,
data);
// Add instrumentation for Chart and Schedule Button.
if (this.currentResultObject[dataKey].instrumentationId) {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, this.currentResultObject[dataKey].instrumentationId, 1);
}
renderFunc = renderFunc.bind(this);
renderFunc(this.chartTableArea, dataObject.data, dataKey);
}
},
renderMidPanel: function renderMidPanel(domElement, firstTab, secondTab) {
domElement.innerHTML = "";
//If errorPanel was rendered before, remove it
WinJS.Utilities.removeClass(domElement, "errorPanel");
WinJS.Utilities.addClass(domElement, "midPanel");
var chartTableArea = this.chartTableArea = document.createElement("div");
chartTableArea.id = this._automationId + "_ChartTableArea";
chartTableArea.setAttribute("aria-describedby", this._automationId + "_ChartTableArea");
WinJS.Utilities.addClass(chartTableArea, "chartTableArea");
var tabSelectorContainer = document.createElement("div");
tabSelectorContainer.id = this._automationId + "_TabSelector";
tabSelectorContainer.setAttribute("aria-describedby", this._automationId + "_TabSelector");
WinJS.Utilities.addClass(tabSelectorContainer, "tabSelector");
this.busyControl = document.createElement("div");
WinJS.Utilities.addClass(this.busyControl, "chartSpinnerContainer");
var chartSpinner = document.createElement("progress");
WinJS.Utilities.addClass(chartSpinner, 'chartSpinner');
WinJS.Utilities.addClass(chartSpinner, 'win-ring');
this.busyControl.appendChild(chartSpinner);
domElement.appendChild(this.busyControl);
domElement.appendChild(chartTableArea);                          
var firstTabButton = this._firstTabButton = document.createElement("button");
WinJS.Utilities.addClass(firstTabButton, "midPanelButton");
firstTabButton.textContent = utils.getResourceString(this._data.firstTabDisplayString);
firstTabButton.id = this._automationId +"_"+ this._data.firstTabDisplayString;
firstTabButton.setAttribute("aria-describedby", this._automationId + "_" + this._data.firstTabDisplayString);
firstTabButton.onclick = this.onChartTableButtonsClicked.bind(this, 0);
var secondTabButton = this._secondTabButton = document.createElement("button");
WinJS.Utilities.addClass(secondTabButton, "midPanelButton");
secondTabButton.textContent = utils.getResourceString(this._data.secondTabDisplayString);
secondTabButton.id = this._automationId +"_"+ this._data.secondTabDisplayString;
secondTabButton.setAttribute("aria-describedby", this._automationId + "_" + this._data.secondTabDisplayString);
secondTabButton.onclick = this.onChartTableButtonsClicked.bind(this, 1);
tabSelectorContainer.appendChild(firstTabButton);
tabSelectorContainer.appendChild(secondTabButton);
domElement.appendChild(tabSelectorContainer);
this.calcElement.appendChild(domElement);
this.currentSelectedTab = 0;
WinJS.Utilities.addClass(firstTabButton, "active");
if (firstTab.type === 'chart') {
this.renderChart(chartTableArea, firstTab.data, 'firstTab');
}
else {
this.renderTable(chartTableArea, firstTab.data, 'firstTab');
}
},
renderResultPanel: function renderResultPanel(element, data) {
if (this._resultPanelRendered) {
WinJS.Binding.processAll(element, data);
}
else {
WinJS.Utilities.addClass(element, "resultPanel");
element.innerHTML = "";
element.setAttribute("tabindex", 0);
document.getElementById(this._data.outputTemplate).winControl.render(data, null).then(this.onOutputTemplateRendered.bind(this, element));
}
},
onOutputTemplateRendered: function onOutputTemplateRendered(parentElement, domElement) {
parentElement.appendChild(domElement);
this._resultPanelRendered = true;
this.calcElement.appendChild(parentElement);
},
dispose: function dispose() {
this.calculateButton.onclick = null;
this.calculateButton.removeEventListener("MSLostPointerCapture", PlatformJS.Utilities.pointerEventListenersMap["MSLostPointerCapture"], false);
this.calculateButton.removeEventListener("MSPointerCancel", PlatformJS.Utilities.pointerEventListenersMap["MSPointerCancel"], false);
this.calculateButton.removeEventListener("MSPointerUp", PlatformJS.Utilities.pointerEventListenersMap["MSPointerUp"], false);
this.calculateButton.removeEventListener("MSPointerDown", PlatformJS.Utilities.pointerEventListenersMap["MSPointerDown"], false);
this.calculateButton.removeEventListener("MSPointerOut", PlatformJS.Utilities.pointerEventListenersMap["MSPointerOut"], false);
if (this._firstTabButton) {
this._firstTabButton.onclick = null;
}
if (this._secondTabButton) {
this._secondTabButton.onclick = null;
}
this.inputValidator.dispose();
for (var i = 0; i < this._inputElements.length; i++) {
this._inputElements[i].onkeypress = null;
}
},
renderAds: function renderAds(element) {
var ad = new PlatformJS.Ads.AdsWrapperControl(element, {
className: "adTypeThin",
adUnitId: "92863",
title: PlatformJS.Services.resourceLoader.getString("/platform/advertisement")
});
ad.render();
this.calcElement.appendChild(element);
}
}, {
})
});
})();
