﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.Calculator", {
RoamingInterface: WinJS.Class.define(
function () {
this.applicationData = Windows.Storage.ApplicationData.current;
this.roamingSettings = this.applicationData.roamingSettings;
this.roamingFolder = this.applicationData.roamingFolder;
this.composite = null;
},
{
data: '',
writeToRoaming: function writeToRoaming(data, key, type) {
this.composite = new Windows.Storage.ApplicationDataCompositeValue();
if (typeof data === "object") {
data = JSON.stringify(data);
}
this.composite[type] = data;
this.roamingSettings.values[key] = this.composite;
this.applicationData.signalDataChanged();
},
readFromRoaming: function readFromRoaming(key, type) {
var data = this.roamingSettings.values[key];
if (data === null || typeof (data) === 'undefined') {
return null;
}
else if (typeof data === "object" && data[type]) {
return JSON.parse(data[type]);
}
}
}, {
_instance: null,
getInstance: function getInstance() {
var roaming = FinanceAppJS.Calculator.RoamingInterface;
if (roaming._instance === null) {
roaming._instance = new FinanceAppJS.Calculator.RoamingInterface();
}
return roaming._instance;
}
})
});
})();
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.Calculator", {
NumberInputValidator: WinJS.Class.define(
function (inputFieldsDataArray) {
if (!inputFieldsDataArray) {
return;
}
this._inputFieldsDataMap = {};
var nivNS = FinanceAppJS.Calculator.NumberInputValidator;
for (var i = 0; i < inputFieldsDataArray.length; i++) {
var textInputData = inputFieldsDataArray[i];
if (!textInputData || !textInputData.inputElement) {
continue;
}
if (textInputData.inputElement.nodeName === 'INPUT') {
if (textInputData.createErrMsgElemInParent) {
textInputData.errMsgEle = document.createElement("div");
WinJS.Utilities.addClass(textInputData.errMsgEle, textInputData.errMsgEleClass);
textInputData.errMsgEle.id = textInputData.inputElement.id + "_errorMsg";
textInputData.errMsgEle.style.visibility = 'hidden';
textInputData.inputElement.parentElement.appendChild(textInputData.errMsgEle);
}
}
var noOfDecimalPlaces = 0;
if (textInputData.decimalValidation && textInputData.decimalValidation.noOfDecimalPlaces) {
noOfDecimalPlaces = textInputData.decimalValidation.noOfDecimalPlaces;
}
var allowDecimalPoint = noOfDecimalPlaces > 0 ? true : false;
var regExString = nivNS.numberRegEx.format(nivNS.decimalChar, noOfDecimalPlaces, allowDecimalPoint ? 1 : 0);
textInputData.regEx = new RegExp(regExString);
this._inputFieldsDataMap[textInputData.inputElement.id] = textInputData;
}
this.onFocus_bind = this.onFocus.bind(this);
this.onBlur_bind = this.onBlur.bind(this);
this.onPasteOrDrop_bind = this.onPasteOrDrop.bind(this);
this.onKeyUp_bind = this.onKeyUp.bind(this);
}
,
{
_inputFieldsDataMap: null,
onFocus_bind: null,
onBlur_bind: null,
onPasteOrDrop_bind: null,
onKeyUp_bind: null,
dispose: function dispose() {
for (var inputElemId in this._inputFieldsDataMap) {
var inputElement = this._inputFieldsDataMap[inputElemId].inputElement;
inputElement.onkeydown = null;
inputElement.onpaste = null;
inputElement.ondrop = null;
inputElement.removeEventListener("focus", this.onFocus_bind);
inputElement.removeEventListener("blur", this.onBlur_bind);
inputElement.removeEventListener("keyup", this.onKeyUp_bind);
}
},
validateKeyPressed: function validateKeyPressed(e) {
var errorMsgEle = this._inputFieldsDataMap[e.target.id].errMsgEle;
var result = this.isValidKey(e);
if (!result.valid) {
e.preventDefault();
e.target.noOfDigitsAndDecimalCharCountBeforeCursor = -1;
if (result.errorMsg) {
FinanceAppJS.Calculator.NumberInputValidator.showErrorMsg(errorMsgEle, result.errorMsg);
}
}
else {
e.target.noOfValidKeyPresses = 1;
e.target.noOfDigitsAndDecimalCharCountBeforeCursor = this.getNoOfDigitsAndDecimalCharCountBeforeCursor(e);
FinanceAppJS.Calculator.NumberInputValidator.hideErrorMsg(errorMsgEle);
}
},
validate: function validate() {
for (var inputElemId in this._inputFieldsDataMap) {
var inputElement = this._inputFieldsDataMap[inputElemId].inputElement;
if (inputElement.nodeName === 'INPUT') {
inputElement.onkeydown = this.validateKeyPressed.bind(this);
inputElement.onpaste = this.onPasteOrDrop_bind;
inputElement.ondrop = this.onPasteOrDrop_bind;
inputElement.addEventListener("keyup", this.onKeyUp_bind);
}
inputElement.addEventListener("focus", this.onFocus_bind);
inputElement.addEventListener("blur", this.onBlur_bind);
}
},
onFocus: function onFocus(e) {
PlatformJS.Navigation.mainNavigator.disableSearchOnType();
},
onBlur: function onBlur(e) {
if (e.target.nodeName === 'INPUT') {
var errorMsg = this._inputFieldsDataMap[e.target.id].errMsgEle;
FinanceAppJS.Calculator.NumberInputValidator.hideErrorMsg(errorMsg);
}
PlatformJS.Navigation.mainNavigator.enableSearchOnType();
},
onPasteOrDrop: function onPasteOrDrop(event) {
var newValue = this.getNewValue(event);
event.target.noOfDigitsAndDecimalCharCountBeforeCursor = -1;
if (this._inputFieldsDataMap[event.target.id].regEx.test(newValue) && this.isValueInLimits(event).valid) {
event.returnValue = false;
event.preventDefault();
event.target.noOfDigitsAndDecimalCharCountBeforeCursor = this.getNoOfDigitsAndDecimalCharCountBeforeCursor(event);
this.formatTargetValue(event, newValue);
} else {
event.preventDefault();
event.returnValue = true;
}
},
onKeyUp: function onKeyUp(event) {
var isDigit = ((event.keyCode >= WinJS.Utilities.Key.num0 && event.keyCode <= WinJS.Utilities.Key.num9) || (event.keyCode >= WinJS.Utilities.Key.numPad0 && event.keyCode <= WinJS.Utilities.Key.numPad9));
var isValueChangeControlChar = (event.keyCode == WinJS.Utilities.Key.backspace || event.keyCode == WinJS.Utilities.Key.deleteKey);
if (event.target.noOfValidKeyPresses && (isDigit || isValueChangeControlChar || event.char === FinanceAppJS.Calculator.NumberInputValidator.decimalChar)) {
event.target.noOfValidKeyPresses = 0;
if (FinanceAppJS.Calculator.NumberInputValidator.decimalChar == event.char && event.target.value === "") {
event.target.value = "0" + event.char;
}
this.formatTargetValue(event);
}
},
formatTargetValue: function formatTargetValue(event, newValue) {
newValue = newValue || String(event.target.value);
var decimalCharPos = newValue.indexOf(FinanceAppJS.Calculator.NumberInputValidator.decimalChar);
var decimalPlaces = decimalCharPos == -1 ? 0 : newValue.length - (decimalCharPos + 1);
var newValueAsNumber = CollectionProvider.Formatters.parseNumberWithSeparator(newValue);
if (!newValueAsNumber ||( newValueAsNumber < 100 && event.target.value.length == String(newValueAsNumber).length)){
return;
}
var formattedValue = CollectionProvider.Formatters.formatNumber(newValueAsNumber, decimalPlaces);
if (decimalCharPos === (newValue.length - 1)) {
formattedValue += FinanceAppJS.Calculator.NumberInputValidator.decimalChar;
}
event.target.value = formattedValue;
if (event.target.noOfDigitsAndDecimalCharCountBeforeCursor >= 0) {
if (event.target.noOfDigitsAndDecimalCharCountBeforeCursor == 0) {
event.target.setSelectionRange(0, 0);
} else {
var cursorPosAfterFormat = 0;
var noOfDigitsAndDecChar = 0;
for (var i = 0; i < formattedValue.length; i++) {
if (noOfDigitsAndDecChar < event.target.noOfDigitsAndDecimalCharCountBeforeCursor) {
var charCode = formattedValue.charCodeAt(i);
if ((charCode >= 48 && charCode <= 57) || String.fromCharCode(charCode) == FinanceAppJS.Calculator.NumberInputValidator.decimalChar) {
noOfDigitsAndDecChar++;
}
}
if (noOfDigitsAndDecChar === event.target.noOfDigitsAndDecimalCharCountBeforeCursor) {
cursorPosAfterFormat = i;
break;
}
}
cursorPosAfterFormat++;
event.target.setSelectionRange(cursorPosAfterFormat, cursorPosAfterFormat);
}
}
},
isValidKey: function isValidKey(evt) {
if (!this.isAllowedCtrlChar(evt).valid) {
if (!evt.char || evt.char === FinanceAppJS.Calculator.NumberInputValidator.numGrpSeparatorChar) {
// other ctr char
return { valid: false, errorMsg: "" };
}
var newValue = this.getNewValue(evt);
var textBoxData = this._inputFieldsDataMap[evt.target.id];
if (!evt.target.value) {
if (textBoxData.decimalValidation && textBoxData.decimalValidation.noOfDecimalPlaces && evt.char === FinanceAppJS.Calculator.NumberInputValidator.decimalChar) {
/* this is to fix following problem
Assume the decimal charater is .
Issue : User can type ..........
When user tries to type ... We receive value as "" not .. in keyDown Event
to prevent that we check the current value if it is "" then we replace it with . 
*/
evt.target.value = FinanceAppJS.Calculator.NumberInputValidator.decimalChar;
return { valid: true, errorMsg: "" };
} else {
if (evt.target.selectionStart) {
/* this is to fix following problem
Assume the decimal charater is .
already . exists in the input
When user tries to type .9 We receive value as "" not . in keyDown Event
to prevent that we check the current value if it is "" the we append new value with . 
*/
newValue = FinanceAppJS.Calculator.NumberInputValidator.decimalChar + newValue;
}
}
}
if (!textBoxData.regEx.test(newValue)) {
return { valid: false, errorMsg: "" };
}
return this.isValueInLimits(evt, newValue);
} else if (evt.keyCode === WinJS.Utilities.Key.deleteKey || evt.keyCode === WinJS.Utilities.Key.backspace) {
var newValue = this.getNewValue(evt);
if (!newValue.length) {
return { valid: true, errorMsg: "" };
}
var textBoxData = this._inputFieldsDataMap[evt.target.id];
if (!textBoxData.regEx.test(newValue)) {
return { valid: false, errorMsg: "" };
}
return this.isValueInLimits(evt, newValue);
} else {
return { valid: true, errorMsg: "" };
}
},
getNewValue: function getNewValue(evt) {
var currentValue = evt.target.value;
var first = currentValue.substring(0, evt.target.selectionStart);
var second = currentValue.substring(evt.target.selectionEnd, currentValue.length);
var newValue = "";
if (evt.type === "paste" || evt.type === "drop") {
var transferData = "";
if (evt.type === "paste") {
transferData = window.clipboardData.getData("Text");
} else {
transferData = evt.dataTransfer.getData("Text");
}
newValue = first + transferData + second;
} else if (evt.keyCode === WinJS.Utilities.Key.backspace) {
if (evt.target.selectionStart !== evt.target.selectionEnd) {
newValue = first + second;
} else if (first && first.length) {
newValue = first.slice(0, first.length - 1) + second;
} else {
newValue = second;
}
} else if (evt.keyCode === WinJS.Utilities.Key.deleteKey) {
if (evt.target.selectionStart !== evt.target.selectionEnd) {
newValue = first + second;
} else if (second && second.length) {
newValue = first + second.slice(1, second.length);
} else {
newValue = first;
}
} else {
newValue = first + evt.char + second;
}
if (newValue) {
newValue = newValue.replace(FinanceAppJS.Calculator.NumberInputValidator.numGrpSeparatorCharSearchRegEx, "");
}
return newValue;
},
getNoOfDigitsAndDecimalCharCountBeforeCursor: function getNoOfDigitsAndDecimalCharCountBeforeCursor(evt) {
var leftToSelection = evt.target.value.substring(0, evt.target.selectionStart);
if (!leftToSelection) {
leftToSelection = "";
}
if (evt.type == "keydown") {
if ((evt.keyCode >= WinJS.Utilities.Key.num0 && evt.keyCode <= WinJS.Utilities.Key.num9) || (evt.keyCode >= WinJS.Utilities.Key.numPad0 && evt.keyCode <= WinJS.Utilities.Key.numPad9) || evt.char === FinanceAppJS.Calculator.NumberInputValidator.decimalChar) {
leftToSelection += evt.char;
} else if (evt.keyCode === WinJS.Utilities.Key.backspace) {
if (evt.target.selectionStart === evt.target.selectionEnd && leftToSelection.length) {
leftToSelection = leftToSelection.slice(0, -1);
}
}
} else if (evt.type == "paste") {
leftToSelection += window.clipboardData.getData("Text") || "";
} else if (evt.type == "drag") {
leftToSelection += transferData = evt.dataTransfer.getData("Text") || "";
} else {
return -1;
}
return (leftToSelection.match(FinanceAppJS.Calculator.NumberInputValidator.regExToFindDigitsAndDecimalChar) || []).length;
},
isAllowedCtrlChar: function isAllowedCtrlChar(evt) {
var ctrlKeyChar = FinanceAppJS.Calculator.NumberInputValidator.ctrlKeyChar;
var isControlKey = evt.ctrlKey || evt.metaKey || evt.altKey;
if (isControlKey || ctrlKeyChar.indexOf(evt.char) >= 0) {
return { valid: true, errorMsg: "" };
}
return { valid: false, errorMsg: "" };
},
isValueInLimits: function isValueInLimits(evt, newValue) {
if (!newValue) {
newValue = this.getNewValue(evt);
}
newValue = FinanceAppJS.Utils.Formatters.parseDouble(newValue);
var textBoxData = this._inputFieldsDataMap[evt.target.id];
if (!textBoxData.minValidation && !textBoxData.maxValidation) {
return { valid: true, erorMsg: "" };
}
if (textBoxData.minValidation && textBoxData.minValidation.enabled && evt.target.min) {
var minimum = evt.target.min;
if (minimum > newValue) {
return { valid: false, errorMsg: textBoxData.minValidation.msg };
}
}
if (textBoxData.maxValidation && textBoxData.maxValidation.enabled && evt.target.max) {
var maximum = evt.target.max;
if (maximum < newValue) {
return { valid: false, errorMsg: textBoxData.maxValidation.msg };
}
}
return { valid: true, errorMsg: "" };
}
}, {
decimalChar: CollectionProvider.Formatters.getDecimalCharacter(),
ctrlKeyChar: FinanceAppJS.Constants.Tools.AllowableCtrlKeyChars,
numberRegEx: "^(\\d*(\\{0}(\\d{0,{1}})){0,{2}})$",
numGrpSeparatorChar: CollectionProvider.Formatters.getNumberGroupSeparatorChar(),
numGrpSeparatorCharSearchRegEx: new RegExp("\\" + CollectionProvider.Formatters.getNumberGroupSeparatorChar(), "gi"),
_regExToFindDigitsAndDecimalChar: null,
regExToFindDigitsAndDecimalChar: {
get: function get() {
if (!FinanceAppJS.Calculator.NumberInputValidator._regExToFindDigitsAndDecimalChar) {
FinanceAppJS.Calculator.NumberInputValidator._regExToFindDigitsAndDecimalChar = new RegExp("\\d|\\" + FinanceAppJS.Calculator.NumberInputValidator.decimalChar, "gi");
}
return FinanceAppJS.Calculator.NumberInputValidator._regExToFindDigitsAndDecimalChar;
}
},
showErrorMsg: function showErrorMsg(errorMsgElement, msg) {
if (!msg || !errorMsgElement) {
return;
}
if (errorMsgElement.style.visibility === 'hidden') {
errorMsgElement.style.visibility = 'visible';
}
errorMsgElement.textContent = msg;
},
hideErrorMsg: function hideErrorMsg(errorMsgElement) {
if (!errorMsgElement) {
return;
}
if (errorMsgElement && errorMsgElement.style.visibility !== 'hidden') {
errorMsgElement.style.visibility = 'hidden';
}
},
})
});
})();
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS.Calculator", {
SelectBox: WinJS.Class.define(function (element, options) {
element.winControl = this;
this._domElement = element;
WinJS.UI.setOptions(this, options);
}, {
compounding: {
set: function set(value) {
if (value) {
var listNames = FinanceAppJS.Constants.Tools.CompoundingMonthsNames;
var listValues = FinanceAppJS.Constants.Tools.CompoundingMonthsList;
listNames = listNames.map(function (item) { return utils.getResourceString(item); });
for (var i = 0; i < listNames.length; i++) {
var option = document.createElement("option");
option.value = "" + listValues[i];
option.textContent = listNames[i];
this._domElement.appendChild(option);
}
if (this._defaultValue) {
this._domElement.value = this._defaultValue;
}
}
}
},
defaultValue: {
get: function get() { return this._defaultValue; },
set: function set(value) {
this._defaultValue = value;
this._domElement.value = value;
}
},
minMaxReqd: {
get: function get() { return this.populateMinMax; },
set: function set(value) {
this.populateMinMax = value;
}
},
minMax: {
set: function set(value) {
for (var i = value.min; i <= value.max; i++) {
var option = document.createElement("option");
option.value = i;
option.textContent = FinanceAppJS.Utils.Formatters.numberFormatter(i, 0, false, null, true);
this._domElement.appendChild(option);
}
if (this._defaultValue) {
this._domElement.value = this._defaultValue;
}
}
},
}, {
})
});
})();
(function () {
'use strict';
function disableSearchOnType(event) {
PlatformJS.Navigation.mainNavigator.disableSearchOnType();
}
function enableSearchOnType(event) {
PlatformJS.Navigation.mainNavigator.enableSearchOnType();
}
function manageInputSearchOnType(inputElement) {
if (inputElement) {
inputElement.addEventListener("focus", disableSearchOnType);
inputElement.addEventListener("blur", enableSearchOnType);
}
}
WinJS.Namespace.define("SearchOnTypeManager", {
manageInputSearchOnType: manageInputSearchOnType
});
})();