﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
CommoditiesDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.DataProviderBase, function (options) {
FinanceAppJS.DataProvider.DataProviderBase.call(this, options);
}, {
queryServiceId: "commodities",
refreshInterval: FinanceAppJS.Constants.RefreshIntervals.HomePageEquityData,
getQueryServiceParams: function getQueryServiceParams() {
var urlParams = PlatformJS.Collections.createStringDictionary();
urlParams.insert("localizeFor", FinanceAppJS.Globalization.getMarket());
return urlParams; 
},
dataBuilder: function dataBuilder(response) {
return response.filter(utils.isNonEmptyObject).map(function (category) {
return {
category: category.Cat,
items: category.Cdta.map(function (item) {
return {
Dn: item.Dn,
Lp: item.Lp,
Fd: utils.contractFormat(item.Cm, item.Cy),
C: item.C,
Cp: item.Cp,
};
})
};
});
}
}, {
})
});
})();
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS", {
Commodities: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
/// <summary>
/// Commodities Page Controller
/// </summary>
FinanceAppJS.FinanceBasePage.call(this, state);
var clusterDefinition = {
commodities: {
dataProviders: "CommoditiesDataProvider",
clusterControl: "FinanceAppJS.Controls.ItemsCluster",
clusterOptions: {
itemTemplate: { templateId: "commodities", isInteractive: true },
useDataObjectForBinding: true,
},
cloneFunc: function cloneFunc(data) {
var clusterDef = {};
for (var i = 0, item ; i < data.length && (item = data[i]) ; i++) {
clusterDef[item.category] = { clusterTitle: item.category }; 
clusterDef[item.category].clusterData = item.items;
}
return clusterDef;
}
}
};
this.setClusterDefinitions(clusterDefinition);
this.pageTitle = utils.getResourceString("Commodities");
}, {
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Commodities";
}
})
});
})();