﻿(function () {
WinJS.Namespace.define("FinanceAppJS.Controls", {
AutoSuggestLocal: WinJS.Class.derive(CommonJS.AutoSuggest, function (element, options) {
CommonJS.AutoSuggest.call(this, element, options);
this.staticVars = { dropdownItemHeight: 40, maxDropdownListHeight: 400, autosuggestBarHeight: 68 };
var that = this;
if (options && options.classForAutoSugList) {
FinanceAppJS.Controls.AutoSuggestLocal.allAppliedListClasses[options.classForAutoSugList]="";
}
SearchOnTypeManager.manageInputSearchOnType(element);
WinJS.UI.setOptions(this, options);
}, {
_createListItem: null,
classForAutoSugList:null,
renderListItem: {
get: function get() {
return this._createListItem;
},
set: function set(value) {
this._createListItem = value;
}
},
selectedIndex:{
get: function get() {
return this._selectedIndex;
},
set: function set(value) {
this._selectedIndex = value;
}
},
itemDataSource:{
get: function get() {
return this._itemDataSource;
},
set: function set(value) {
if (!this._isInvalidEntry) {
this._itemDataSource = value;
this._updateList(value);
}
}
},
isShowing: {
get: function get() {
return this._isShowing;
}
},
_createItem: function _createItem(itemData, i) {
if (this.renderListItem) {
return this.renderListItem(itemData, i);
}
return CommonJS.AutoSuggest.prototype._createItem(itemData, i);
},
_updateList: function _updateList(data) {
var i;
this._platformAutoSuggestListDom.innerHTML = "";
this._selectedIndex = -1;
this._platformAutoSuggestListDom.setAttribute("onfocus", "CommonJS.autoSuggest._SetFocusBack();"); 
if (data && data.length > 0) {
if (this._selectionMode === CommonJS.AutoSuggest.forceSelection) {
this._selectedIndex = 0;
}
var dropdownListHeight = this.staticVars.dropdownItemHeight * data.length < this.staticVars.maxDropdownListHeight ? this.staticVars.dropdownItemHeight * data.length : this.staticVars.maxDropdownListHeight;
this._platformAutoSuggestListDom.style.height = dropdownListHeight + "px";
for (i = 0; i < data.length; i++) {
var item = this._createItem(data[i], i);
if (item) {
item.id = "CommonJS.AutoSuggest_" + i;
item.setAttribute("data-index", i);
this._platformAutoSuggestListDom.appendChild(item);
}
}
if (this._selectionMode === CommonJS.AutoSuggest.forceSelection) {
this._platformAutoSuggestListDom.children[0].setAttribute("aria-selected", true);
}
if (!this._isShowing) {
this._showList();
}
} else if (data) { 
this._isShowing = false;
this._hideList();
}
msWriteProfilerMark("Platform:Autosuggest:suggestlistUpdated");
},
_showList: function _showList() {
if (CommonJS.autoSuggest === null || CommonJS.autoSuggest.element === null) {
return;
}
var previousList = document.getElementById("platformAutoSuggestList");
if (previousList) {
var allAppliedListClasses = FinanceAppJS.Controls.AutoSuggestLocal.allAppliedListClasses;
for (var className in allAppliedListClasses) {
if (className)
WinJS.Utilities.removeClass(previousList, className);
}
}
if (this.classForAutoSugList) {
var previousList = document.getElementsByClassName(this.classForAutoSugList);
if (previousList && previousList.length !== 0) {
WinJS.Utilities.removeClass(previousList[0], this.classForAutoSugList);
}
}
CommonJS.AutoSuggest.prototype._showList.call(this);
if (this.classForAutoSugList) {
WinJS.Utilities.addClass(CommonJS.autoSuggest._platformAutoSuggestListDom, this.classForAutoSugList);
}
}
}, {
allAppliedListClasses: {},
})
});
})();
