﻿(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
CurrencyConverterDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.DataProviderBase, function (options) {
FinanceAppJS.DataProvider.DataProviderBase.call(this, options);
}, {
queryServiceId: "GlobalCurrency",
refreshInterval: FinanceAppJS.Constants.RefreshIntervals.SixtySeconds,
getQueryServiceParams: function getQueryServiceParams() {
var param = PlatformJS.Collections.createStringDictionary();
param.insert("localCurrency", FinanceAppJS.Globalization.getDefaultCurrency());
return param;
},
dataBuilder: function dataBuilder(data) {
var currencyMap = {};
var thisNS = FinanceAppJS.DataProvider.CurrencyConverterDataProvider;
var currencyInfoList = FinanceAppJS.CurrencyInfo.getCurrencyInfo();
thisNS.firstCurrencyInTheResponse = null;
for (var i = 0; i < data.length; i++) {
currencyMap[data[i].An] = i;
if (!thisNS.firstCurrencyInTheResponse && currencyInfoList[data[i].An]) {
thisNS.firstCurrencyInTheResponse = data[i].An;
}
}
thisNS.updateNoConvRateCcys(currencyMap);
return { rawData: data, indexMap: currencyMap };
}
}, {
noConversionRatePresentCcys: {},
firstCurrencyInTheResponse:null,
updateNoConvRateCcys: function updateNoConvRateCcys(data) {
var noConversionCcys = {};
var currencyInfoList = FinanceAppJS.CurrencyInfo.getCurrencyInfo();
for (var currency in currencyInfoList) {
if (!data || !data.hasOwnProperty(currency)) {
noConversionCcys[currency] = true;
}
}
FinanceAppJS.DataProvider.CurrencyConverterDataProvider.noConversionRatePresentCcys = noConversionCcys;
},
getStaticDataForSearchDialogue: function getStaticDataForSearchDialogue() {
var currencyInfoList = FinanceAppJS.CurrencyInfo.getCurrencyInfo();
var dataProvider = new Array();
for (var currency in currencyInfoList) {
var currencyInfoOriginal = currencyInfoList[currency];
var currencyInfoLocalized = {};
currencyInfoLocalized.symbol = currencyInfoOriginal.symbol;
currencyInfoLocalized.currencyText = utils.getResourceString(currencyInfoOriginal.country) + " " + utils.getResourceString(currencyInfoOriginal.currency);
currencyInfoLocalized.countryCode = currencyInfoOriginal.countryCode;
currencyInfoLocalized.currencyCode = currency; // not localizing currency codes since it is a unicode for currency
dataProvider.push(currencyInfoLocalized);
}
return dataProvider;
}
})
});
})();
