﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS", {
CurrencyConverterPage: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
FinanceAppJS.FinanceBasePage.call(this, state);
var that = this;
this._init();
var clusterDefinition = {
fromCurrencyCluster: {
clusterTitle: utils.getResourceString("CCTitleFrom"),
clusterControl: "FinanceAppJS.Controls.FromCurrencyClusterControl",
clusterOptions: {
onChange: this.onFromSectionChanged.bind(this),
textBoxOnClick: function textBoxOnClick(event) {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
"",
FinanceAppJS.Telemetry.Constants.Location.TEXTBOX,
"");
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.From_Currency_Amount_Click, 1);
}
},
dataProviders: "CurrencyConverterDataProvider"
},
toCurrenciesCluster: {
clusterTitle: utils.getResourceString("CCTitleTo"),
clusterControl: "FinanceAppJS.CurrencyConverter.ToCurrencyCluster",
clusterOptions: {
className: "toCurrencyCluster",
quickSearch: this._quickSuggestLocal,
onrendercomplete: function onrendercomplete(event) {
that._addEventListenersForListView();
},
},
dataProviders: "CurrencyConverterDataProvider"
}
};
this.setClusterDefinitions(clusterDefinition);
this.pageTitle = utils.getResourceString("CurrencyConverter");
FinanceAppJS.Utils.ResumeHandler.suspendCallback = this.saveToRoaming;
},
{
_quickSuggestLocal: null,
_roamingData: {},
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Tools/Currency Converter";
},
_init: function _init() {
this._quickSuggestLocal = FinanceAppJS.CurrencyConverter.ToCurrencyCluster.QuickSuggest.getQuickSearchDialogue();
var previousData = FinanceAppJS.Controls.CurrencyConverterInitDataProvider.getInstance().getInitData();
this._roamingData.ccy = previousData.selectedCurrency;
this._roamingData.amount = previousData.amount;
},
onFromSectionChanged: function onFromSectionChanged(changeData) {
this._roamingData = changeData;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
"",
FinanceAppJS.Telemetry.Constants.Location.TEXTBOX,
"Text Changed");
this.getClusterControl("toCurrenciesCluster").onFromSectionUpdate(changeData);
},
onBindingComplete: function onBindingComplete() {
FinanceAppJS.FinanceBasePage.prototype.onBindingComplete.call(this);
},
moveUpStub: function moveUpStub() {
var promise = WatchListManage.handleMove(this._listElmWin, "up");
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.BE_MoveUp_Button_Click, 1);
promise.then(ToCurrencyConverterListManager.writetoCurrenciesToRoaming.bind(this, this._listElmWin));
},
moveDownStub: function moveDownStub() {
var promise = WatchListManage.handleMove(this._listElmWin, "down");
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.BE_MoveDown_Button_Click, 1);
promise.then(ToCurrencyConverterListManager.writetoCurrenciesToRoaming.bind(this, this._listElmWin));
},
_addEventListenersForListView: function _addEventListenersForListView() {
var that = this;
if (this._initializedOnce) {
return;
}
var listElm = that.getClusterControl("toCurrenciesCluster");
var bottomEdgy = document.querySelector("#bottomAppbar");
if (listElm && listElm.clusterItems && bottomEdgy) {                    
var btnClearSelection = document.getElementById("btnClearSelection");
var btnMoveUp = document.getElementById("btnMoveUp");
var btnMoveDown = document.getElementById("btnMoveDown");
var reorderButtons = document.querySelector("#reorderButtons");
// Set Button Labels Text        
utils.setWinLabelText(btnClearSelection, "MyStocksClearSelection");
utils.setWinLabelText(btnMoveUp, "MoveUP");
utils.setWinLabelText(btnMoveDown, "MoveDown");
var listElmWin = listElm.view;
this._listElmWin = listElmWin;
this.bottomEdgy = bottomEdgy;
var optionItem = {};
optionItem.PageId = FinanceAppJS.Constants.IDs.CurrencyConverter;
ToCurrencyConverterListManager.attachBasicListEvents(this, listElm, btnClearSelection, reorderButtons, optionItem, that._quickSuggestLocal);
that._quickSuggestLocal.onItemSelect = function (event) {
var elmWin = event.src;
var query = utils.trim(event.queryText);
if (!query) {
return;
}
that._query = query;
if (FinanceAppJS.Globals.internetAvailable === false) {
that._quickSuggestLocal.showMessage("ASOfflineMessage");
return;
}
// Suggestion is chosen from the Auto-Suggest tray
if (typeof event.index !== 'undefined' && event.index >= 0 && elmWin.searchSuggestions && listElm) {
// add selection of new currency to be added to To Clusters
var suggItem = elmWin.searchSuggestions[event.index];
FinanceAppJS.CurrencyConverter.ToCurrencyCluster.Operations.addCurrencyToToList(suggItem, listElmWin, that);
} else {
var invalidText = utils.getResourceString("ASInvalidCcy").format(event.queryText);
that._quickSuggestLocal.showMessage(invalidText, false);
}
};
this.moveUpHandler = this.moveUpStub.bind(this);
this.moveDownHandler = this.moveDownStub.bind(this);
// Attach event to move UP
btnMoveUp.addEventListener("click", this.moveUpHandler, false);
// Attach event to move Down
btnMoveDown.addEventListener("click", this.moveDownHandler, false);
this._btnMoveUp = btnMoveUp;
this._btnMoveDown = btnMoveDown;
this._initializedOnce = true;
/* Add Tile. Checking if Add tile */
var addTile = listElm._domElement.querySelector(".addTileContainer")
if (addTile) {
addTile.setAttribute("aria-label", utils.getResourceString("CurrencyListAddButton_Al"));
addTile.setAttribute("role", "link");
}
}
},
onNavigateAway: function onNavigateAway(reason) {
FinanceAppJS.FinanceBasePage.prototype.onNavigateAway.call(this);
if (this._btnMoveUp) {
this._btnMoveUp.removeEventListener("click", this.moveUpHandler, false);
}
if (this._btnMoveDown) {
this._btnMoveDown.removeEventListener("click", this.moveDownHandler, false);
}
this.saveToRoaming();
},
saveToRoaming: function saveToRoaming() {
if (this._roamingData) {
FinanceAppJS.Roaming.CurrencyConverter.getInstance().setField(FinanceAppJS.Roaming.CurrencyConverter.amount, this._roamingData.amount);
}
}
})
});
})();
