﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.Roaming", {
CurrencyConverter: WinJS.Class.define(
function (data) {
this.data = data;
this.applicationData = Windows.Storage.ApplicationData.current;
this.roamingSettings = this.applicationData.roamingSettings;
this.composite = new Windows.Storage.ApplicationDataCompositeValue();
},
{
data: '',
writeToRoaming: function writeToRoaming(dt) {
if (!dt) {
return;
}
var rmNS = FinanceAppJS.Roaming.CurrencyConverter;
this.composite[rmNS.toCurrencies] = JSON.stringify(dt.toCurrencies);
this.composite[rmNS.amount] = JSON.stringify(dt.amount);
this.roamingSettings.values[rmNS.pageName] = this.composite;
this.applicationData.signalDataChanged();
},
readFromRoaming: function readFromRoaming() {
var rmNS = FinanceAppJS.Roaming.CurrencyConverter;
var dt = this.roamingSettings.values[rmNS.pageName];
if (!dt) {
return null;
}
var data = {};
if (dt[rmNS.toCurrencies]) {
data.toCurrencies = JSON.parse(dt[rmNS.toCurrencies]);
} else {
data.toCurrencies = [];
}
if (dt[rmNS.amount]) {
data.amount = JSON.parse(dt[rmNS.amount]);
} else {
data.amount = "";
}
return data;
},
clearCcyData: function clearCcyData() {
var rmNS = FinanceAppJS.Roaming.CurrencyConverter;
this.composite[rmNS.toCurrencies] = "";
this.composite[rmNS.amount] = "";
this.roamingSettings.values[rmNS.pageName] = this.composite;
this.applicationData.signalDataChanged();
},
setField: function setField(fieldName, value) {
var rmNS = FinanceAppJS.Roaming.CurrencyConverter;
if (!value) value = "";
var dt = this.roamingSettings.values[rmNS.pageName];
this.composite[rmNS.amount] = dt[rmNS.amount];
this.composite[rmNS.toCurrencies] = dt[rmNS.toCurrencies];
switch (fieldName) {
case rmNS.amount: {
this.composite[rmNS.amount] = JSON.stringify(value);
break;
}
case rmNS.toCurrencies: {
this.composite[rmNS.toCurrencies] = JSON.stringify(value);
// log a content view here
var content = { Page: FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId) };
var Symbol = "";
value.forEach(function (item) {
Symbol += item + "|";
});
content.Symbol = Symbol;
FinanceAppJS.Telemetry.FlightRecorder.LogContentView(content);
break;
}
default: return;
}
this.roamingSettings.values[rmNS.pageName] = this.composite;
this.applicationData.signalDataChanged();
},
setSelectedCcyAndAmount: function setSelectedCcyAndAmount(ccy, amount) {
var rmNS = FinanceAppJS.Roaming.CurrencyConverter;
var dt = this.roamingSettings.values[rmNS.pageName];
this.composite[rmNS.amount] = JSON.stringify(amount);
this.composite[rmNS.toCurrencies] = dt[rmNS.toCurrencies];
this.roamingSettings.values[rmNS.pageName] = this.composite;
this.applicationData.signalDataChanged();
},
}, {
pageName: "CurrencyConverter",
amount: "a",
toCurrencies: "To",
instance: null,
getInstance: function getInstance() {
if (!FinanceAppJS.Roaming.CurrencyConverter.instance) {
FinanceAppJS.Roaming.CurrencyConverter.instance = new FinanceAppJS.Roaming.CurrencyConverter();
}
return FinanceAppJS.Roaming.CurrencyConverter.instance;
}
})
});
})();
