﻿(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS.Controls", {
FromCurrencyClusterControl: WinJS.Class.derive(FinanceAppJS.Controls.BaseCluster, function (element, options) {
FinanceAppJS.Controls.BaseCluster.call(this, element, options);
element = element || document.createElement("div");
this._domelement = element;
element.winControl = this;
WinJS.Utilities.addClass(element, "moduleClusterContent");
WinJS.Utilities.addClass(element, "fromCurrencyCluster");
options = options || {};
if (options.ipage && options.clusterDef && options.clusterDef.clusterOptions) {
this.onChange = options.clusterDef.clusterOptions.onChange;
this.textBoxOnClick = options.clusterDef.clusterOptions.textBoxOnClick;
}
WinJS.UI.setOptions(this, options);
}, {
_isInitialized: false,
_domelement: null,
onChange: null,
textBoxOnClick: null,
_fromCurrencyValueTextInput: null,
_comboButton: null,
_comboControl: null,
_currencySymbolDiv: null,
getAmount: function getAmount() {
return CollectionProvider.Formatters.parseNumberWithSeparator(this._fromCurrencyValueTextInput.value) || 0;
},
getCurrency: function getCurrency() {
return this._comboControl.getSelectedCurrency();
},
update: function update(data, providerName) {
if (!this._isInitialized) {
this._isInitialized = true;
this._render();
}
return WinJS.Promise.as({});
},
_initAmountSection: function _initAmountSection(initData, currencyInfoList) {
var that = this;
var amountParent = document.createElement("div");
WinJS.Utilities.addClass(amountParent, "amountParent");
this._currencySymbolDiv = document.createElement("div");
this._currencySymbolDiv.textContent = currencyInfoList[FinanceAppJS.Controls.FromCurrencyComboBox.getPreviouslySelectedCurrency()].symbol;
this._currencySymbolDiv.id = "ccy_convert_amount_currency_symbol";
WinJS.Utilities.addClass(this._currencySymbolDiv, "fromCurrencySymbol row1 col1");
amountParent.appendChild(this._currencySymbolDiv);
this._fromCurrencyValueTextInput = document.createElement("input");
this._fromCurrencyValueTextInput.id = "ccy_convert_amount_input"; // for ui automation
WinJS.Utilities.addClass(this._fromCurrencyValueTextInput, "fromCurrencyAmount row1 col2");
this._fromCurrencyValueTextInput.type = "number";
this._fromCurrencyValueTextInput.value = CollectionProvider.Formatters.formatNumber(initData.amount,2);
this._fromCurrencyValueTextInput.min = FinanceAppJS.Constants.Tools.Currency_converter_Min_Amount;
this._fromCurrencyValueTextInput.max = FinanceAppJS.Constants.Tools.Currency_converter_Max_Amount;
this._fromCurrencyValueTextInput.oninput = function (event) {
if (that.onChange) {
var changedData = {};
changedData.ccy = that._comboControl.getSelectedCurrency();
changedData.amount = that.getAmount();
that.onChange(changedData);
}
};
this._fromCurrencyValueTextInput.onclick = function (event) {
if (that.textBoxOnClick) {
that.textBoxOnClick(event);
}
};
this._fromCurrencyValueTextInput.addEventListener("keydown", function (event) {
if (event.keyCode === WinJS.Utilities.Key.enter) {
event.preventDefault();
return false;
}
});
amountParent.appendChild(this._fromCurrencyValueTextInput);
var clearSymbolButton = document.createElement("button");
clearSymbolButton.id = "ccy_convert_amount_clear_button" // for UI automation
clearSymbolButton.tabIndex = -1;
WinJS.Utilities.addClass(clearSymbolButton, "clearSym row1 col3");
amountParent.appendChild(clearSymbolButton);
clearSymbolButton.onclick = function (event) {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
"",
FinanceAppJS.Telemetry.Constants.Location.CLEARBTN,
"");
that._fromCurrencyValueTextInput.value = "";
var changedData = {};
changedData.ccy = that._comboControl.getSelectedCurrency();
changedData.amount = 0;
that.onChange(changedData);
};
this._domelement.appendChild(amountParent);
},
_initComboBox: function _initComboBox(initData) {
var that = this;
var comboDiv = document.createElement("div");
WinJS.Utilities.addClass(comboDiv, "comboboxParent");
this._comboControl = new FinanceAppJS.Controls.FromCurrencyComboBox(comboDiv, {
onSelectionChange: function onSelectionChange(ccyData) {
that._currencySymbolDiv.textContent = ccyData.symbol;
if (that.onChange) {
var changedData = {};
changedData.ccy = ccyData.currencyCode;
changedData.amount = that.getAmount();
that.onChange(changedData);
}
}
});
this._domelement.appendChild(comboDiv);
},
_render: function _render() {
this._domelement.innerHTML = "";
var initData = FinanceAppJS.Controls.CurrencyConverterInitDataProvider.getInstance().getInitData();
initData.selectedCurrency = FinanceAppJS.Controls.FromCurrencyComboBox.getPreviouslySelectedCurrency();
var currencyInfoList = FinanceAppJS.CurrencyInfo.getCurrencyInfo();
this._initAmountSection(initData, currencyInfoList);
this._initiateInputValidator();
this._initComboBox(initData);
// todo sugu logcontentview
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.PlatformInstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation["CurrencyConverter"], 1);
},
_initiateInputValidator: function _initiateInputValidator() {
this._fromCurrencyValueTextInput.maxLength = 20;
var errorMessageHolder = document.createElement("div");
WinJS.Utilities.addClass(errorMessageHolder, "amountErrorMessageDiv");
this._domelement.appendChild(errorMessageHolder);
var validator = new FinanceAppJS.Calculator.NumberInputValidator([{
inputElement: this._fromCurrencyValueTextInput,
errMsgEle: errorMessageHolder,
maxValidation: { enabled: true, msg: utils.getResourceString("ValueExceedsMaxMessage").format(CollectionProvider.Formatters.formatNumber(this._fromCurrencyValueTextInput.max,0))},
decimalValidation: { noOfDecimalPlaces: 2, enabled: true, msg: "" },
}]);
validator.validate();
}
}, {
})
});
})();
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS.Controls", {
FromCurrencyComboBox: WinJS.Class.define(function (element, options) {
element = element || document.createElement("div");
element.winControl = this;
element.id = "ccy_convert_from_combo_box_parent";
//Setting aria-describedby which is required for automation. Value is the current selected currency
element.setAttribute("aria-describedby", FinanceAppJS.Controls.FromCurrencyComboBox.getPreviouslySelectedCurrency());
options = options || {};
this._domelement = element;
/* autosuggestinput -start */
/* autosuggestinput - for narrator and other accessibility issues */
this._autoSuggestInput = document.createElement("input");
this._autoSuggestInput.id ="ccy_convert_from_combo_box_accessibility";
WinJS.Utilities.addClass(this._autoSuggestInput, "autoSuggestInput");
this._autoSuggest = new FinanceAppJS.Controls.AutoSuggestLocal(this._autoSuggestInput, { classForAutoSugList: "autosuggestList" });
this._autoSuggestInput.tabIndex = -1;
element.appendChild(this._autoSuggestInput);
/* autosuggestinput -end */
/* comboButton - todisplay the selected currency - start*/
var comboButton = document.createElement("button");
comboButton.id = "ccy_convert_from_combo_box_display";
WinJS.Utilities.addClass(comboButton, "comboBox win-interactive");
comboButton.setAttribute("role", "");
this._contentDiv = document.createElement("div");
WinJS.Utilities.addClass(this._contentDiv, "contentParent");
this._flagDiv = document.createElement("div");
this._currencyTextDiv = document.createElement("div");
WinJS.Utilities.addClass(this._contentDiv, "");
WinJS.Utilities.addClass(this._currencyTextDiv, "fontMMBS selectedCurrencyText row1 col2");
this._contentDiv.appendChild(this._flagDiv);
this._contentDiv.appendChild(this._currencyTextDiv);
comboButton.appendChild(this._contentDiv);
comboButton.contentEditable = false;
var downArrowDiv = document.createElement("div");
WinJS.Utilities.addClass(downArrowDiv, "downArraowDiv row1 col3");
comboButton.appendChild(downArrowDiv);
comboButton.tabIndex = 0;
this._domelement.appendChild(comboButton);
/* comboButton - todisplay the selected currency - end*/
/* Events bindind - start*/
var that = this;
var onclickHandler = function (event) {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
"",
FinanceAppJS.Telemetry.Constants.Location.CCYDROPDWN,
"");
if (event.pointerType && (event.pointerType === event.MSPOINTER_TYPE_PEN || event.pointerType === event.MSPOINTER_TYPE_TOUCH)) {
that._autoSuggestInput.readOnly = true; // to fix issue - currency list is not showing when virtual keyboard is up
}
if (that._autoSuggest.isShowing) {
that._autoSuggest.hide();
that.resetAutoSuggestInput.call(that);
that._autoSuggestInput.setAttribute("role", "combobox");
} else {
var noConversionRatePresentCcys = FinanceAppJS.DataProvider.CurrencyConverterDataProvider.noConversionRatePresentCcys;
that._currentDividerIndex = that._dividerIndex;
that._autoSuggest.itemDataSource = that._dataProvider.filter(function (item, index) {
if (index == that._dividerIndex) {
return true;
}
if (!item || !item.currencyCode || noConversionRatePresentCcys[item.currencyCode]) {
if (index < that._dividerIndex) {
that._currentDividerIndex--;
}
return false;
}
return true;
});
}
};
var clickEvent = window.navigator.msPointerEnabled ? "MSPointerUp" : "click";
element.addEventListener(clickEvent, function (event) {
that._autoSuggestInput.focus();
that._autoSuggestInput.value = " "; // auto suggest will not be shown if the value is blank or null so setting the value with space
if (CommonJS.autoSuggest !== that._autoSuggest) {
CommonJS.autoSuggest = that._autoSuggest;
}
onclickHandler(event);
});
comboButton.addEventListener("keyup", function (event) {
if (event.keyCode === WinJS.Utilities.Key.space) {
that._autoSuggestInput.focus();
that._autoSuggestInput.value = " "; // auto suggest will not be shown if the value is blank or null so setting the value with space
if (CommonJS.autoSuggest !== that._autoSuggest) {
CommonJS.autoSuggest = that._autoSuggest;
}
onclickHandler(event);
}
});
this._autoSuggest.onItemSelection = function (index, event) {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
"",
FinanceAppJS.Telemetry.Constants.Location.LISTBOX,
that._autoSuggest._itemDataSource[index].currencyCode + " - From Currency Selected");
if (index !== that._currentDividerIndex) {
that.selectedItem = that._autoSuggest.itemDataSource[index] || {};
that.resetAutoSuggestInput.call(that);
if (that._onSelectionChange != null)
that._onSelectionChange(that._autoSuggest.itemDataSource[index]);
}
};
this._autoSuggest.renderListItem = function (itemData, i) {
if (that._currentDividerIndex == i) {
return that.createDividerItem();
} else if (that._currentDividerIndex > i) {
return that.createSuggestionItem(itemData, i, true);
} else {
return that.createSuggestionItem(itemData, i, false);
}
};
this._autoSuggestInput.onkeydown = function (event) {
if (event.keyCode === WinJS.Utilities.Key.space) {
onclickHandler(event);
return;
}
if (that._autoSuggest.isShowing) {
if (event.keyCode === WinJS.Utilities.Key.escape) {
that._autoSuggest.hide();
that._autoSuggest.itemDataSource = [];
that.resetAutoSuggestInput.call(that);
event.stopPropagation();
} else if (event.keyCode === WinJS.Utilities.Key.downArrow || event.keyCode === WinJS.Utilities.Key.upArrow || event.keyCode === WinJS.Utilities.Key.leftArrow || event.keyCode === WinJS.Utilities.Key.rightArrow) {
event.stopPropagation();
event.preventDefault();
} else {
var isControlKey = event.ctrlKey || event.shiftKey || event.metaKey || event.altKey;
if (event.char && !isControlKey) {
that.navigateToCorrespondingItem(event.char);
}
}
}
};
this._autoSuggestInput.onfocusin = function (event) {
that.resetAutoSuggestInput.call(that);
}
/* Events binding - End*/
this._init();
this.resetAutoSuggestInput();
WinJS.UI.setOptions(this, options);
}, {
_domelement: null,
_autoSuggest: null,
_autoSuggestInput: null,
_dataProvider: null,
_onSelectionChange: null,
_selectedItem: {},
_flagDiv: null,
_currencyTextDiv: null,
_dividerIndex: 0,
_currentDividerIndex: 0,
keyDown_bind: null,
typedKeysDetails: {
lastKeyPressedTime: null,
text: "",
setCurrentKey: function setCurrentKey(char) {
if (!this.lastKeyPressedTime) {
this.text = char;
} else {
var currentTime = new Date();
var diff = currentTime - this.lastKeyPressedTime;
if (diff > FinanceAppJS.Controls.FromCurrencyComboBox.MAX_WAITING_PERIOD_FOR_KEY_PRESS_TO_APPEXND_TEXT) {
this.text = char;
} else {
this.text = this.text + char;
}
}
this.lastKeyPressedTime = new Date();
}
},
_init: function _init() {
this._initializeDataProvider();
var initData = FinanceAppJS.Controls.CurrencyConverterInitDataProvider.getInstance().getInitData();
initData.selectedCurrency = FinanceAppJS.Controls.FromCurrencyComboBox.getPreviouslySelectedCurrency();
for (var i = 0; i < this._dataProvider.length ; i++) {
var item = this._dataProvider[i];
if (item.currencyCode === initData.selectedCurrency) {
this.selectedItem = item;
}
}
},
_initializeDataProvider: function _initializeDataProvider() {
var staticCcyData = FinanceAppJS.CurrencyInfo.getCurrencyInfo();
var localCurrency = FinanceAppJS.Globalization.getDefaultCurrency();
var topCurrencies = FinanceAppJS.Globalization.getTopConvertedCcysForccy(localCurrency).topCurrencies;
var insertedCurrencies = {};
this._dataProvider = [];
for (var i = 0; i < topCurrencies.length; i++) {
var topCcy = topCurrencies[i];
var ccyData = staticCcyData[topCcy];
this._dataProvider.push(this.localizeCcyData(ccyData, topCcy));
insertedCurrencies[topCcy] = "";
}
if (staticCcyData[localCurrency]) {
this._dataProvider.push(this.localizeCcyData(staticCcyData[localCurrency], localCurrency));
}
this._dividerIndex = this._dataProvider.length;
this._dataProvider.push({});
for (var ccy in staticCcyData) {
if (!insertedCurrencies.hasOwnProperty(ccy)) {
var ccyData = staticCcyData[ccy];
this._dataProvider.push(this.localizeCcyData(ccyData, ccy));
}
}
},
localizeCcyData: function localizeCcyData(currencyInfoOriginal, currencyCode) {
var currencyInfoLocalized = {};
currencyInfoLocalized.symbol = currencyInfoOriginal.symbol;
currencyInfoLocalized.currencyText = utils.getResourceString(currencyInfoOriginal.country) + " " + utils.getResourceString(currencyInfoOriginal.currency);
currencyInfoLocalized.countryCode = currencyInfoOriginal.countryCode;
currencyInfoLocalized.currencyCode = currencyCode;
return currencyInfoLocalized;
},
selectedItem: {
get: function get() {
return this._selectedItem;
},
set: function set(value) {
this._selectedItem = value;
FinanceAppJS.Controls.FromCurrencyComboBox.previouslySelectedCurrency = value.currencyCode;
this.updateButton();
}
},
onSelectionChange: {
set: function set(value) {
this._onSelectionChange = value;
}
},
getSelectedCurrency: function getSelectedCurrency() {
return this._selectedItem.currencyCode;
},
createDividerItem: function createDividerItem() {
var dividerItem = document.createElement("div");
WinJS.Utilities.addClass(dividerItem, "dividerItem");
dividerItem.tabIndex = -1;
dividerItem.setAttribute("data-displayedText", " ");
dividerItem.setAttribute("data-value", " ");
return dividerItem;
},
createSuggestionItem: function createSuggestionItem(itemData, i, isTopccy) {
var currencyText = itemData.currencyText;
var buttonItem = document.createElement("button");
WinJS.Utilities.addClass(buttonItem, "suggestedItem");
buttonItem.setAttribute("onfocus", "CommonJS.autoSuggest._SetFocusBack();");
buttonItem.setAttribute("data-displayedText", currencyText);
buttonItem.setAttribute("data-value", currencyText);
buttonItem.setAttribute("onmspointerup", "CommonJS.autoSuggest._selectedIndex = " + i + "; CommonJS.autoSuggest._onClick(event)");
buttonItem.setAttribute("role", "option");
var currencyTextDiv = document.createElement("div");
currencyTextDiv.id = "ccy_convert_from_suggest_item_" + itemData.currencyCode; // unique for automation
if (isTopccy) {
WinJS.Utilities.addClass(currencyTextDiv, "topccyText");
} else {
WinJS.Utilities.addClass(currencyTextDiv, "ccyText");
}
currencyTextDiv.textContent = itemData.currencyText;
buttonItem.setAttribute("aria-label", itemData.currencyText);
buttonItem.appendChild(currencyTextDiv);
return buttonItem;
},
updateButton: function updateButton() {
var flagClass = FinanceAppJS.Utils.getCountryFlagClass(this._selectedItem.countryCode);
if (!flagClass || flagClass.indexOf("countryFlagSprite_NONE") != -1) {
this._flagDiv.className = "";
this._flagDiv.innerHTML = "";
} else {
this._flagDiv.className = flagClass + " row1 col1 flagcross selectedccyFlag";
}
this._currencyTextDiv.textContent = this._selectedItem.currencyText;
},
resetAutoSuggestInput: function resetAutoSuggestInput() {
var staticCcyData = FinanceAppJS.CurrencyInfo.getCurrencyInfo();
this._autoSuggestInput.value = this.localizeCcyData(staticCcyData[FinanceAppJS.Controls.FromCurrencyComboBox.getPreviouslySelectedCurrency()], "").currencyText;
},
navigateToCorrespondingItem: function navigateToCorrespondingItem(char) {
this.typedKeysDetails.setCurrentKey(char);
var itemsIntheList = this._autoSuggest._platformAutoSuggestListDom.children;
var currentSelectedIndex = this._autoSuggest.selectedIndex;
if (currentSelectedIndex < 0) {
currentSelectedIndex = -1;
}
for (var i = 1; i <= itemsIntheList.length ; i++) {
var index = (i + currentSelectedIndex) % itemsIntheList.length;
var item = itemsIntheList[index];
if (item && item.innerText && item.innerText.toLowerCase().indexOf(this.typedKeysDetails.text.toLowerCase()) == 0) {
this._autoSuggest._updateSelectedItem(index);
this._autoSuggest.selectedIndex = index;
item.scrollIntoView();
break;
}
}
}
}, {
MAX_WAITING_PERIOD_FOR_KEY_PRESS_TO_APPEXND_TEXT: 500, // 500 milliseconds
// this is static variable to use to find what was the previous selected currency 
previouslySelectedCurrency: FinanceAppJS.Globalization.getDefaultCurrency(),
currencyInfoList: FinanceAppJS.CurrencyInfo.getCurrencyInfo(),
//returns the previously selected currency if the currency has the conversion rate other wise returns default currency
getPreviouslySelectedCurrency: function getPreviouslySelectedCurrency() {
var thisNS = FinanceAppJS.Controls.FromCurrencyComboBox;
var localCurrency = FinanceAppJS.Globalization.getDefaultCurrency();
var dataProviderNS = FinanceAppJS.DataProvider.CurrencyConverterDataProvider;
if (!thisNS.previouslySelectedCurrency || dataProviderNS.noConversionRatePresentCcys[thisNS.previouslySelectedCurrency]) {
if (dataProviderNS.noConversionRatePresentCcys[localCurrency]) {
thisNS.previouslySelectedCurrency = FinanceAppJS.Constants.Tools.Currency_converter_Default_From_Selected_Currency;
} else {
thisNS.previouslySelectedCurrency = localCurrency;
}
}
if (!thisNS.currencyInfoList[thisNS.previouslySelectedCurrency]) {
thisNS.previouslySelectedCurrency = FinanceAppJS.Constants.Tools.Currency_converter_Default_From_Selected_Currency;
}
if (dataProviderNS.noConversionRatePresentCcys[thisNS.previouslySelectedCurrency]) {
thisNS.previouslySelectedCurrency = dataProviderNS.firstCurrencyInTheResponse;
}
return thisNS.previouslySelectedCurrency;
}
})
});
})();
