﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.Utilities", {
SearchDialogLocal: WinJS.Class.define(
function quickSearchDialogLocalCtor() {
},
{
_searchDialog: null,
_dataProvider: null,
_searchFilterFunction: null,
_addButtonClick: null,
_listItemRenderFunction: null,
_previousSearchText: null,
_promptText: utils.getResourceString("Search"),
_autosuggestPlaceholder: utils.getResourceString("Search"),
_onItemSelect: null,
dataProvider: {
get: function get() {
return this._dataProvider;
},
set: function set(value) {
this._dataProvider = value;
}
},
promptText: {
get: function get() {
return this._promptText;
},
set: function set(value) {
this._promptText = value;
}
},
autoSuggestionPlaceHolder: {
get: function get() {
return this._autosuggestPlaceholder;
},
set: function set(value) {
this._autosuggestPlaceholder = value;
}
},
filterFunction: {
get: function get() {
return this._searchFilterFunction;
},
set: function set(value) {
this._searchFilterFunction = value;
}
},
filter: function filter(event) {
var filteredDataProvider = new Array();
var thisObject = { queryText: event.queryText };
if (this._dataProvider) {
filteredDataProvider = this._dataProvider.filter(this._searchFilterFunction, thisObject);
}
return filteredDataProvider;
},
listItemRenderFunction: {
get: function get() {
this._listItemRenderFunction;
},
set: function set(value) {
this._listItemRenderFunction = value;
}
},
onItemSelect: {
get: function get() {
this._onItemSelect;
},
set: function set(value) {
this._onItemSelect = value;
}
},
getSearchBoxOptions: function getSearchBoxOptions() {
},
_onSearchSuggestionsRequested: function _onSearchSuggestionsRequested(event) {
this._previousSearchText = event.queryText;
var suggestions =  this.filter(event) ;
this._searchDialog.searchSuggestions = { suggestions: suggestions };
if (!suggestions || suggestions.length == 0) {
this._searchDialog._addButton.disabled = true
}
},
_onHide: function _onHide() {
this._searchDialog = null;
this._previousSearchText = null;
},
showProgress: function showProgress() {
if (this._searchDialog) {
this._searchDialog.showSearchProgress();
}
CommonJS.dismissAllEdgies();
},
hideProgress: function hideProgress() {
if (this._searchDialog) {
this._searchDialog.hideSearchProgress();
}
CommonJS.dismissAllEdgies();
},
showMessage: function showMessage(msg, isResourceKey) {
if (this._searchDialog) {
this._searchDialog.message = (isResourceKey === false) ? msg : utils.getResourceString(msg);
}
CommonJS.dismissAllEdgies();
},
hideMessage: function hideMessage() {
if (this._searchDialog) {
this._searchDialog.message = "";
}
CommonJS.dismissAllEdgies();
},
hideQuickSearch: function hideQuickSearch() {
if (this._searchDialog) {
// Hide Progressbar
this.hideProgress();
//  this.setQuickSearchText("");
this.hideMessage();
this._searchDialog.searchVisible = false;
}
CommonJS.dismissAllEdgies();
},
showQuickSearch: function showQuickSearch() {
var that = this;
if (!this._searchDialog) {
FinanceAppJS.Telemetry.FlightRecorder.LogAppEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
FinanceAppJS.Telemetry.Constants.AppUtility.FLYOUT,
"Currency Search");
this._searchDialog = CommonJS.SearchDialog.show({});
this._searchDialog.autoSuggest = new FinanceAppJS.Controls.AutoSuggestLocal(this._searchDialog._searchBox);
this._searchDialog._searchBox.maxLength = FinanceAppJS.Constants.Tools.Currency_converter_Autosuggest_Max_Length;
this._searchDialog.onSearchSuggestionsRequested = that._onSearchSuggestionsRequested.bind(that);
this._searchDialog.searchPlaceholderText = utils.getResourceString(that.autoSuggestionPlaceHolder) || "";
this._searchDialog.promptText = utils.getResourceString(that.promptText) || "";
this._searchDialog.onSearchTextEntered = function (event) {
if (that._onItemSelect)
that._onItemSelect(event);
},
this._searchDialog.onHide = this._onHide.bind(this);
this._searchDialog.autoSuggestOptions = {
renderListItem: that._listItemRenderFunction,
selectionMode: CommonJS.AutoSuggest.forceSelection,
};
this._searchDialog._setFocusToTextBox();
}
return null;
},
},
{
})
});
})();