﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.CurrencyConverter", {
ToCurrencyCluster: WinJS.Class.derive(FinanceAppJS.HomePage.MyStocksCluster, function (domElement, options) {   
this.dragElementBinding = this.dragElement;
FinanceAppJS.HomePage.MyStocksCluster.call(this, domElement, options);
WinJS.Utilities.removeClass(domElement, "watchlistCluster");
WinJS.Utilities.addClass(domElement, "toCurrencyCluster");            
},
{
_currenciesInfo: null,
_dataFromProvider: null,
_templatePromise: null,
_fromCurrency: null,
_amount: 1000,
_isinitialized: false,
quickSearch: {
get: function get() {
return this._quickSearch;
},
set: function set(value) {
this._quickSearch = value;
}
},
_computeMinWidth: function _computeMinWidth() {
// do nothing here - overiding the base class function
},
_setWidthAuto: function _setWidthAuto() {
// do nothing here - overiding the base class function
},
dragElement: function dragElement(sourceElement, sourceData) {
var elementPrototype = sourceElement.parentElement;
var element = document.createElement("div");
WinJS.Utilities.addClass(element, "ListView2SimpleDraggedElement");
element.style.width = elementPrototype.style.width;
element.style.height = elementPrototype.style.height;
var titleElement = document.createElement("div");
WinJS.Utilities.addClass(titleElement, "currencyDraggedTitle");
WinJS.Utilities.addClass(titleElement, "titleDiv");
titleElement.textContent = sourceData.tileData.currencyText;
element.appendChild(titleElement);
return element;
},
saveOrderToRoaming: function saveOrderToRoaming() {                
var list = this.clusterItems;
var currentOrder = [], currencyCode;
for (var i = 0; i < list.length - 1; i++) {
currencyCode = list.getAt(i).tileData.currencyCode;
currentOrder.push(currencyCode);
}
FinanceAppJS.Roaming.CurrencyConverter.getInstance().setField(FinanceAppJS.Roaming.CurrencyConverter.toCurrencies, currentOrder);
},
addInvoked: function addInvoked() {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
"",
FinanceAppJS.Telemetry.Constants.Location.ADD,
"Add Currency");
this.quickSearch.showQuickSearch();                
},
removeItem: function removeItem(item) {
var roamingData = FinanceAppJS.Roaming.CurrencyConverter.getInstance().readFromRoaming().toCurrencies
var deletedCurrency = item.detail.tileData.currencyCode;
var index = roamingData.indexOf(deletedCurrency);
if (index >= 0) {
roamingData.splice(index, 1);
}
FinanceAppJS.Roaming.CurrencyConverter.getInstance().setField(FinanceAppJS.Roaming.CurrencyConverter.toCurrencies, roamingData);
},
_init: function _init() {
var existingData = FinanceAppJS.Controls.CurrencyConverterInitDataProvider.getInstance().getInitData();
this._fromCurrency = FinanceAppJS.Controls.FromCurrencyComboBox.getPreviouslySelectedCurrency();
this._amount = existingData.amount;
},
update: function update(data, providerName) {
if (!this._isinitialized) {
this._isinitialized = true;
this._init();
this._dataFromProvider = data;
return this.refresh();
} else if (this.hasAllSelectedCurrenciesDataPresent(data)) {
this._dataFromProvider = data;
return this.refresh();
} else {
return WinJS.Promise.as({});
}
},
hasAllSelectedCurrenciesDataPresent: function hasAllSelectedCurrenciesDataPresent(data) {
//From section check
if (!data.indexMap[FinanceAppJS.Controls.FromCurrencyComboBox.previouslySelectedCurrency] && data.indexMap[FinanceAppJS.Controls.FromCurrencyComboBox.previouslySelectedCurrency] != 0) {
return false;
}
//to section check
var existingCurrencies = FinanceAppJS.Roaming.CurrencyConverter.getInstance().readFromRoaming().toCurrencies;
if (existingCurrencies) {
for (var i = 0; i < existingCurrencies.length ; i++) {
var ccy = existingCurrencies[i];
if (!data.indexMap[ccy] && data.indexMap[ccy] !== 0) {
return false;
}
}
}
return true;
},
getCurrencyTileInfoList: function getCurrencyTileInfoList() {
var toCurrencies = FinanceAppJS.Controls.CurrencyConverterInitDataProvider.getInstance().getInitData().toCurrencies;
var toCurrencyInfoList = new Array();
for (var i = 0 ; i < toCurrencies.length ; i++) {
if (!toCurrencies[i] || FinanceAppJS.DataProvider.CurrencyConverterDataProvider.noConversionRatePresentCcys[toCurrencies[i]]) continue;
var conversionRate = this.getConversionRate(this._fromCurrency, toCurrencies[i]);
var reverseConversionRate = this.getConversionRate(toCurrencies[i], this._fromCurrency);;
var toCurrencyTileInfo = FinanceAppJS.CurrencyConverter.ToCurrencyCluster.TileInfo.getItemTileInfo(this._fromCurrency, toCurrencies[i], this._amount, conversionRate, reverseConversionRate);
toCurrencyInfoList.push({ tileData: toCurrencyTileInfo });
}
return toCurrencyInfoList;
},
_rebind: function _rebind(toCurrencyInfoList) {
var stkTilesLength = this.clusterItems.length - 1;
var newDataLength = toCurrencyInfoList.length - 1;
for (var i = 0, item; i < stkTilesLength && i < toCurrencyInfoList.length && (item = this.clusterItems.getAt(i)) ; i++) {
if (toCurrencyInfoList[i] && toCurrencyInfoList[i].tileData) {
utils.deepCopy(toCurrencyInfoList[i], item);
}
}
if (stkTilesLength < newDataLength) {
var listBinding = this.clusterItems;
var dataToInsert = toCurrencyInfoList.splice(stkTilesLength, (newDataLength - stkTilesLength));
var insertAtPos = stkTilesLength;
while (dataToInsert.length > 0) {
listBinding.splice(insertAtPos, 0, dataToInsert.shift());
insertAtPos++;
}
}
},
refresh: function refresh() {
var toCurrencyInfoList = this.getCurrencyTileInfoList();
for (var i = 0; i < toCurrencyInfoList.length; i++) {
toCurrencyInfoList[i].itemKey = "ccy_convert_to_list_tile_" + toCurrencyInfoList[i].tileData.currencyCode;
}
if (this.clusterItems && this.clusterItems.length > 0 && toCurrencyInfoList.length === this.clusterItems.length -1 ) { //using this.clusterItems.length -1 as we dont push the add tile to currencyList.
this._rebind(toCurrencyInfoList);
return WinJS.Promise.as({});
}
else {
return this.invalidate(toCurrencyInfoList);
}
},
templatePromise: {
get: function get() {
return (this._templatePromise = this._templatePromise || FinanceAppJS.CurrencyConverter.ToCurrencyCluster.TileInfo.currencyListTemplates(false));
},
},
_itemTemplateSelector_S: function _itemTemplateSelector_S(item) {
if (this._itemRenderPromises && this._itemRenderPromises.length) {
return this._itemRenderPromises.shift();
}
return FinanceAppJS.CurrencyConverter.ToCurrencyCluster.TileInfo.currencyListTemplateSelector(item.data, this._templates);
},
onFromSectionUpdate: function onFromSectionUpdate(changedData) {
this._amount = changedData.amount;
this._fromCurrency = changedData.ccy;
this.refresh();
},
getConversionRate: function getConversionRate(fromCurrency, toCurrency) {
try {
fromCurrency = fromCurrency.toUpperCase();
toCurrency = toCurrency.toUpperCase();
return this._dataFromProvider.rawData[this._dataFromProvider.indexMap[toCurrency]].Rt / this._dataFromProvider.rawData[this._dataFromProvider.indexMap[fromCurrency]].Rt;
} catch (e) {
FinanceAppJS.Telemetry.FlightRecorder.LogErrorEvent(e.message, e.stack);
return 0;
}
},
resetProvider: function resetProvider() {
// Overriding the resetProvider function, else it executes the resetProvider in Mystocks.js which causes null reference
},
})
});
})();
(function () {
'use strict';
function getItemTileInfo(fromCurrency, toCurrency, fromValue, conversionRate, reverseConversionRate) {
var toCurrencyInfo = FinanceAppJS.CurrencyInfo.getCurrencyInfo()[toCurrency.toUpperCase()];
var toCurrencyTileInfo = {};
toCurrencyTileInfo.currencyCode = toCurrency;
toCurrencyTileInfo.currencySymbol = toCurrencyInfo.symbol;
toCurrencyTileInfo.currencyName = utils.getResourceString(toCurrencyInfo.currency);
toCurrencyTileInfo.countryCode = toCurrencyInfo.countryCode;
toCurrencyTileInfo.countryName = utils.getResourceString(toCurrencyInfo.country);
toCurrencyTileInfo.convertedValue = convert(fromValue, conversionRate);
toCurrencyTileInfo.currencyText = utils.getResourceString(toCurrencyInfo.country) + " " + utils.getResourceString(toCurrencyInfo.currency);
toCurrencyTileInfo.conversionRateText = conversionText(fromCurrency, toCurrency, conversionRate, reverseConversionRate);
toCurrencyTileInfo.type = "CCY";
return toCurrencyTileInfo;
}
function convert(fromAmount, conversionRate) {
return CollectionProvider.Formatters.formatNumber((conversionRate * fromAmount), 2);
}
function conversionText(fromCurrency, toCurrency, conversionRate, reverseConversionRate) {
return utils.addLtrMark(FinanceAppJS.Utils.Formatters.numberFormatter(1, 0) + " " + fromCurrency + " = " + FinanceAppJS.Utils.Formatters.numberFormatter(conversionRate, 4) + " " + toCurrency) + " | " + utils.addLtrMark(FinanceAppJS.Utils.Formatters.numberFormatter(1, 0) + " " + toCurrency + " = " + FinanceAppJS.Utils.Formatters.numberFormatter(reverseConversionRate, 4) + " " + fromCurrency);
}
function getAddTileTemplateData() {
var item = {};
item.type = FinanceAppJS.Constants.IDs.AddTile;
item.addTileClickHandler = FinanceAppJS.Utilities.QuickSearch.getInstance().showQuickSearch;
item.naratorText = utils.getResourceString("CurrencyListAddButton_Al");
return item;
}
function getCurrencyListTemplates(shouldIncludeAddTileTemplate) {
return WinJS.UI.Fragments.render("/pages/CurrencyConverter/html/CurrencyConverterListItemTemplate.html").then(templateFragmentSelector_S.bind(null, shouldIncludeAddTileTemplate));
}
function templateFragmentSelector_S(shouldIncludeAddTileTemplate, templateFragment) {
return WinJS.UI.processAll(templateFragment).then(templateSelector_S.bind(null, shouldIncludeAddTileTemplate, templateFragment));
}
function templateSelector_S(shouldIncludeAddTileTemplate, templateFragment) {
var templates = {};
templates['toCurrencyItemTemplate'] = templateFragment.querySelector('#toCurrencyItemTemplate');
if (shouldIncludeAddTileTemplate !== false) {
templates['addTileTemplate'] = templateFragment.querySelector('#addTileTemplate');
}
return templates;
}
function currencyListTemplateSelector(itemData, templates) {
var itemTemplate = null;
var idConstants = FinanceAppJS.Constants.IDs;
var data = itemData.tileData;
if (data.type === "CCY") {
itemTemplate = templates.toCurrencyItemTemplate;
var container = document.createElement("div");
container.id = itemData.itemKey;
itemTemplate.winControl.render(itemData, container);
return container;
}
else {
itemTemplate = templates.addTileTemplate;
return itemTemplate;
}
}
WinJS.Namespace.define("FinanceAppJS.CurrencyConverter.ToCurrencyCluster.TileInfo", {
getItemTileInfo: getItemTileInfo,
getAddTileTemplateData: getAddTileTemplateData,
currencyListTemplates: getCurrencyListTemplates,
currencyListTemplateSelector: currencyListTemplateSelector,
});
})();
(function () {
'use strict';
function searchDialogueFilterFunction(item) {
if (!item) return false;
if (!this.queryText) return false;
if (this.queryText == item.symbol) {
return true;
}
if (FinanceAppJS.DataProvider.CurrencyConverterDataProvider.noConversionRatePresentCcys[item.currencyCode]) {
return false;
}
this.queryText = this.queryText.toLowerCase();
if (item.currencyCode.toLowerCase().indexOf(this.queryText) != -1) {
return true;
}
if (item.currencyText.toLowerCase().indexOf(this.queryText) != -1) {
return true;
}
return false;
}
function getQuickSearchDialogue() {
var quickSearchDialogue = new FinanceAppJS.Utilities.SearchDialogLocal();
quickSearchDialogue.promptText = utils.getResourceString("ASAddToList");
quickSearchDialogue.autoSuggestionPlaceHolder = utils.getResourceString("Currency") + "/ " + utils.getResourceString("Country");
quickSearchDialogue.dataProvider = FinanceAppJS.DataProvider.CurrencyConverterDataProvider.getStaticDataForSearchDialogue();
quickSearchDialogue.filterFunction = searchDialogueFilterFunction;
quickSearchDialogue.listItemRenderFunction = listItemrenderFunction;
return quickSearchDialogue;
}
function listItemrenderFunction(itemData, i) {
var currencyCode = (itemData.currencyCode) ? itemData.currencyCode : "";
var currencyText = (itemData.currencyText) ? itemData.currencyText : "";
var symbol = (itemData.symbol) ? itemData.symbol : "";
if (currencyCode == null && currencyText == null && symbol == null) {
return null;
}
var buttonItem = document.createElement("button"),
listItem = document.createElement("div"),
listItemLabel = document.createElement("div"),
listItemTitle = document.createElement("div"),
listItemSymbol = document.createElement("div");
WinJS.Utilities.addClass(buttonItem, "win-interactive");
WinJS.Utilities.addClass(listItem, "platformAutoSuggestListItem");
WinJS.Utilities.addClass(listItemLabel, "platformAutoSuggestListItemLabel");
WinJS.Utilities.addClass(listItemTitle, "platformAutoSuggestListItemTitle");
WinJS.Utilities.addClass(listItemSymbol, "platformAutoSuggestListItemComment");
listItemLabel.innerText = currencyCode;
listItemTitle.innerText = currencyText;
listItemSymbol.innerText = symbol;
buttonItem.setAttribute("onfocus", "CommonJS.autoSuggest._SetFocusBack();");
var displayText = currencyCode + "-" + currencyText;
buttonItem.setAttribute("data-displayedText", displayText);
buttonItem.setAttribute("data-value", displayText);
buttonItem.setAttribute("onmspointerup", "CommonJS.autoSuggest._selectedIndex = " + i + "; CommonJS.autoSuggest._onClick(event)");
buttonItem.setAttribute("role", "option");
listItem.appendChild(listItemLabel);
listItem.appendChild(listItemTitle);
listItem.appendChild(listItemSymbol);
buttonItem.appendChild(listItem);
return buttonItem;
}
WinJS.Namespace.define("FinanceAppJS.CurrencyConverter.ToCurrencyCluster.QuickSuggest", {
getQuickSearchDialogue: getQuickSearchDialogue,
});
})();
(function () {
'use strict';
function addCurrencyToToList(selectedItem, listElmWin, ipage) {
var isInvalid = !(selectedItem && listElmWin && ipage);
if (isInvalid) {
return;
}
var quickSearch = ipage._quickSuggestLocal;
var existingCurrencies = FinanceAppJS.Roaming.CurrencyConverter.getInstance().readFromRoaming();
if (existingCurrencies && existingCurrencies.toCurrencies) {
for (var i = 0; i < existingCurrencies.toCurrencies.length; i++) {
if (existingCurrencies.toCurrencies[i] === selectedItem.currencyCode) {
var duplicateMessage = utils.getResourceString("AsDuplicateEntry").format(selectedItem.currencyCode);
quickSearch.showMessage(duplicateMessage, false);
return;
}
}
if (existingCurrencies.toCurrencies.length >= FinanceAppJS.Constants.Tools.Currency_converter_Max_Tiles_Count) {
var maxCountExceedsMessage = utils.getResourceString("CCMaxCountExceedsMessage").format(FinanceAppJS.Constants.Tools.Currency_converter_Max_Tiles_Count);
quickSearch.showMessage(maxCountExceedsMessage, false);
return;
}
}
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
"",
FinanceAppJS.Telemetry.Constants.AppUtility.FLYOUT,
selectedItem.currencyCode + " Currency Added");
quickSearch.showProgress();
var newTmplData = {};
var toCluster = ipage.getClusterControl("toCurrenciesCluster");
var fromCluster = document.getElementsByClassName("moduleClusterContent")[0];
var fromCurrency = fromCluster.winControl.getCurrency();
var amount = fromCluster.winControl.getAmount();
newTmplData.tileData = FinanceAppJS.CurrencyConverter.ToCurrencyCluster.TileInfo.getItemTileInfo(fromCurrency, selectedItem.currencyCode, amount, toCluster.getConversionRate(fromCurrency, selectedItem.currencyCode), toCluster.getConversionRate(selectedItem.currencyCode, fromCurrency));;
newTmplData.itemKey = "ccy_convert_to_list_tile_" + newTmplData.tileData.currencyCode;
listElmWin.itemDataSource.insertAtStart(null, newTmplData).then(function (item) {
listElmWin.ensureVisible(0);
ToCurrencyConverterListManager.addCcyToRoaming(item.data.tileData.currencyCode);
quickSearch.hideQuickSearch();
}, function (error) {
quickSearch.hideQuickSearch();
});
}
WinJS.Namespace.define("FinanceAppJS.CurrencyConverter.ToCurrencyCluster.Operations", {
addCurrencyToToList: addCurrencyToToList,
});
})();
