﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.NewsControls",
{
/// <summary>
/// Cluster with market movers data
/// </summary>
EntityControl: WinJS.Class.derive(FinanceAppJS.Controls.BaseCluster, function (domElement, options) {
FinanceAppJS.Controls.BaseCluster.call(this, domElement, options);
domElement = utils.createElement(domElement, "div", { className: "financeNewsClusterHeight" });
this._articleInfos = [];
this._newsItems = null;
this.view = new CommonJS.News.EntityCluster(
domElement, {
mode: options.mode,
subclusterAdFrequency: options.subclusterAdFrequency ? options.subclusterAdFrequency : null,
subclusterAdMax: options.subclusterAdMax ? options.subclusterAdMax : null,
adUnitId: options.adUnitId ? options.adUnitId : null,
marginWidth: options.marginWidth ? options.marginWidth : null,
marginDistance: 5,
maxColumnCount: options.maxColumnCount ? options.maxColumnCount : null,
theme: options.theme ? options.theme : "financeAppTheme",
onitemclick: this._onItemInvoked.bind(this),
unitWidth: options.unitWidth ? options.unitWidth : null,
configKey: options.configKey || "EntityClusterDefaultFinanceSportsConfig" ,
configObject: options.configObject || CommonJS.News.EntityClusterConfig.DefaultFinanceSports,
instrumentationEntryPoint: options.instrumentationEntryPoint ? options.instrumentationEntryPoint : null,
telemetry: {
getCurrentImpression: function getCurrentImpression() {
return PlatformJS.Navigation.mainNavigator.getCurrentImpression();
}
},
});
this.itemClickCallback = options.onitemclick;
// set options
WinJS.UI.setOptions(this, options);
},
{
collateProviderData: false,
dataField: "newsItems",
_newsItems: null,
_onItemInvoked: function _onItemInvoked(event) {
if (this.itemClickCallback) {
event.item.articleInfos = this._articleInfos;
this.itemClickCallback(event);
}
},
// Required for Next and Previous Article feature in Article Reader.
_articleInfos: null,
update: function update(data, providerName) {
this._newsItems = data[this.dataField];
if (data.articleInfos) {
this._articleInfos = data.articleInfos;
}
this._mergeNews();
this.view.state = {
data: null,
renderedData: {}
};
// Set the dataCacheID to the cluster key for Layout Persistence.
// Set the cacheId for Layout Persistence.
if (data.cacheID && data.dataCacheID) {
this.view.cacheID = data.cacheID;
this.dataSet.clusterID = this.clusterDef.clusterKey + (this.maxColumnCount ? "_3columns" : "_AllItems");
this.dataSet.dataCacheID = data.dataCacheID; /* Passed in from CloneFunc */
this.dataSet.isLocalResponse = data.isLocalResponse ? data.isLocalResponse : false;
this.dataSet.uniqueResponseID = data.uniqueResponseID ? data.uniqueResponseID : null;
}
WinJS.UI.setOptions(this.view, {
dataSet: this.dataSet
});
return this.view.render();
},
_mergeNews: function _mergeNews() {
var newsItems = [];
var index = 0, len;
if (this._newsItems) {
var eNewsItems = this._newsItems;
len = eNewsItems.length;
if (len > 0) {
for (var i = 0; i < len; i++) {
var item = eNewsItems[i];
item.index = index++;
newsItems.push(item);
}
}
}
this.dataSet = {
native: true,
newsItems: newsItems
};
}
})
});
})();
(function () {
'use strict';
var RENDER_COMPLETE = "rendercomplete";
WinJS.Namespace.define("FinanceAppJS.NewsControls",
{
/// <summary>
/// Cluster with market movers data
/// </summary>
NewsMergedCluster: WinJS.Class.derive(FinanceAppJS.Controls.BaseCluster, function (domElement, options) {
FinanceAppJS.Controls.BaseCluster.call(this, domElement, options);
domElement = utils.createElement(domElement, "div", { className: "financeNewsClusterHeight" });
this._newsItems = null;
this.view = new CommonJS.News.EntityCluster(
domElement, {
mode: options.mode,
cacheID: this.cacheID,
maxColumnCount: options.maxColumnCount ? options.maxColumnCount : null,
theme: options.theme ? options.theme : "financeAppTheme",
onitemclick: this._onItemInvoked.bind(this),
unitWidth: options.unitWidth ?  options.unitWidth : null,
configKey: "EntityClusterDefaultFinanceSportsConfig",
configObject: CommonJS.News.EntityClusterConfig.DefaultFinanceSports,
instrumentationEntryPoint: options.instrumentationEntryPoint ? options.instrumentationEntryPoint : null,
telemetry: {
getCurrentImpression: function getCurrentImpression() {
return PlatformJS.Navigation.mainNavigator.getCurrentImpression();
}
},
});
this.itemClickCallback = options.onitemclick;
// set options
WinJS.UI.setOptions(this, options);
},
{
collateProviderData: true,
_dataField: "newsItems",
_editorialNewsData: null,
_bingNewsData: null,
dataSet: null,
cacheID: null,
_onItemInvoked: function _onItemInvoked(event) {
if (this.itemClickCallback) {
event.item.articleInfos = this._articleInfos;
this.itemClickCallback(event);
}
},
// Required for Next and Previous Article feature in Article Reader.
_articleInfos: null,
update: function update(data, providerName) {
var editorial = {};
var bingnews = {};
/* Populate articleInfos if existing in EditorialNewsDataProvider */
if (data && data.EditorialNewsDataProvider) {
if (utils.isNonEmptyArray(data.EditorialNewsDataProvider.articleInfos)) {
this._articleInfos = data.EditorialNewsDataProvider.articleInfos;
} else {
this._articleInfos = null;
}
editorial.cacheID = data.EditorialNewsDataProvider.cacheID;
editorial.dataCacheID = data.EditorialNewsDataProvider.dataCacheID;
editorial.isLocalResponse = data.EditorialNewsDataProvider.isLocalResponse;
editorial.uniqueResponseID = data.EditorialNewsDataProvider.uniqueResponseID;
}
if (data && data.BingNewsDataProvider) {
bingnews.cacheID = data.BingNewsDataProvider.cacheID;
bingnews.dataCacheID = data.BingNewsDataProvider.dataCacheID;
bingnews.isLocalResponse = data.BingNewsDataProvider.isLocalResponse;
bingnews.uniqueResponseID = data.BingNewsDataProvider.uniqueResponseID;
}
this._editorialNewsData = data.EditorialNewsDataProvider && data.EditorialNewsDataProvider[this._dataField];
this._bingNewsData = data.BingNewsDataProvider && data.BingNewsDataProvider[this._dataField];
/* Need to send in isLocalResponse flag to EntityCluster as part of the dataSet */
/* When it is set, layout entries are not created. So create layout only when both are network responses. */
var isLocalResponse = true;
if (!bingnews.isLocalResponse && !editorial.isLocalResponse) {
isLocalResponse = false;
}
this._mergeNews();
if (!isLocalResponse && editorial.cacheID && bingnews.cacheID) {
/* If this is not a localResponse, create cache Entries for the merged DataSet in both 
editorial cache and bing news cache.
*/
var promise1 = PlatformJS.Cache.CacheService.getInstance(editorial.cacheID).findEntry(editorial.dataCacheID + "mergedparent");
return promise1.then(
this._onEntryPromiseComplete.bind(this, editorial, bingnews), /* on complete */
this._onEntryPromiseComplete.bind(this, editorial, bingnews) /* on error */);
}
// No Layout Caching.
return this._callRender(null, null, isLocalResponse, null);
},
_onEntryPromiseComplete: function _onEntryPromiseComplete(editorial, bingnews, values) {
var guidToWrite = editorial.uniqueResponseID + "_" + bingnews.uniqueResponseID;
if (values && values.dataValue.uniqueResponseID === guidToWrite) {
// Set the data from cache.
this.dataSet.newsItems = values.dataValue.newsItems;
return this._callRender(editorial.cacheID, editorial.dataCacheID + "mergedparent", editorial.isLocalResponse, values.dataValue.uniqueResponseID);
}
else {
/* Delete invalid Entries */
PlatformJS.Cache.CacheService.getInstance(editorial.cacheID).removeEntry(editorial.dataCacheID + "mergedparent");
var dataToWrite = {
uniqueResponseID: guidToWrite,
newsItems: this.dataSet.newsItems
};
/* Create new parent child relationships in Editorial and bingnews cache */
var promise1 = PlatformJS.Cache.CacheService.getInstance(editorial.cacheID).addEntry(editorial.dataCacheID + "mergedparent", dataToWrite);
return promise1.then(this._callRender.bind(this, editorial.cacheID, editorial.dataCacheID + "mergedparent", editorial.isLocalResponse, guidToWrite));
}
},
_callRender: function _callRender(cacheID, dataCacheID, isLocalResponse, uniqueResponseID) {
this.view.state = {
data: null,
renderedData: {}
};
// Set the dataCacheID to the cluster key for Layout Persistence.
// Set the cacheId for Layout Persistence.
// TODO: Temporarily disabling layout persistence till bug 323789 is resolved.
if (cacheID && dataCacheID) {
this.view.cacheID = cacheID;
this.dataSet.clusterID = this.clusterDef.clusterKey + (this.maxColumnCount ? "_3columns" : "_AllItems");
this.dataSet.dataCacheID = dataCacheID;
this.dataSet.isLocalResponse = isLocalResponse;
this.dataSet.uniqueResponseID = uniqueResponseID;
}
WinJS.UI.setOptions(this.view, {
dataSet: this.dataSet
});
return this.view.render();
},
_mergeNews: function _mergeNews() {
var newsItems = [];
var index = 0, len;
if (this._editorialNewsData) {
var eNewsItems = this._editorialNewsData;
len = eNewsItems.length;
if (len > 0) {
for (var i = 0; i < len; i++) {
var item = eNewsItems[i];
item.index = index++;
newsItems.push(item);
}
}
}
if (this._bingNewsData) {
var bNewsItems = this._bingNewsData;
len = bNewsItems.length;
if (len > 0) {
for (i = 0; i < len; i++) {
bNewsItems[i].index = index++;
newsItems.push(bNewsItems[i]);
}
}
}
this.dataSet = {
native: true,
newsItems: newsItems
};
}
})
});
})();
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.EntityPano",
{
/// <summary>
/// Cluster with market movers data
/// </summary>
MoreSourcesCluster: WinJS.Class.derive(FinanceAppJS.Controls.BaseCluster, function (domElement, options) {
FinanceAppJS.Controls.BaseCluster.call(this, domElement, options);
this._view = new FinanceAppJS.Controls.FinanceFeaturedCluster(
domElement, options);
WinJS.UI.setOptions(this, options);
},
{
_view: null,
_lastData: null,
update: function update(data) {
if (data && data.length > 0 && JSON.stringify(data) !== JSON.stringify(this._lastData)) {
this._lastData = data;
WinJS.UI.setOptions(this._view, {
dataSet: data
});
return this._view.render();
}
else {
return WinJS.Promise.wrap({});
}
},
dispose: function dispose() {
if (this._view) {
this._view.dispose();
}
}
})
});
})();
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS.EntityClusterConfig.MoneyCluster",
{
TemplateClassMap:
{
M: {
classID: "M",
snippetMin: 0,
aspectRatioMin: 0,
aspectRatioMax: 0,
isDefault: false,
type: "MoneyEntity",
templateList: [
"Money_BigThumbnail_1col_4row",
"Money_SmallThumbnail_1col_3row",
"Money_BigThumbnail_1col_3row",
"Money_NoThumbnail_1col_1row",
"Money_SmallThumbnail_1col_4row",
"Money_NoThumbnail_1col_2row"
]
},
MV: {
classID: "MV",
snippetMin: 0,
aspectRatioMin: 0,
aspectRatioMax: 0,
isDefault: false,
type: "Video",
templateList: [
"Money_Video_1col_2row",
"Money_Video_1col_1row"
]
},
MS: {
classID: "MS",
snippetMin: 0,
aspectRatioMin: 0,
aspectRatioMax: 0,
isDefault: false,
type: "Slideshow",
templateList: [
"Money_Slideshow_1col_2row",
"Money_Slideshow_1col_1row"
]
},
},
TemplateDefinitions:
{
Money_BigThumbnail_1col_4row: {
classID: "Money_BigThumbnail_1col_4row",
thumbnailHeight: 400,
thumbnailWidth: 300,
height: 59,
width: 30,
lastResort: false
},
Money_SmallThumbnail_1col_3row: {
classID: "Money_SmallThumbnail_1col_3row",
thumbnailHeight: 220,
thumbnailWidth: 300,
height: 44,
width: 30,
lastResort: false
},
Money_BigThumbnail_1col_3row: {
classID: "Money_BigThumbnail_1col_3row",
thumbnailHeight: 300,
thumbnailWidth: 250,
height: 44,
width: 30,
lastResort: false
},
Money_NoThumbnail_1col_1row: {
classID: "Money_NoThumbnail_1col_1row",
thumbnailHeight: 0,
thumbnailWidth: 0,
height: 14,
width: 30,
lastResort: true
},
Money_SmallThumbnail_1col_4row: {
classID: "Money_SmallThumbnail_1col_4row",
thumbnailHeight: 220,
thumbnailWidth: 300,
height: 59,
width: 30,
lastResort: false
},
Money_NoThumbnail_1col_2row: {
classID: "Money_NoThumbnail_1col_2row",
thumbnailHeight: 0,
thumbnailWidth: 0,
height: 29,
width: 30,
lastResort: false
},
Money_Video_1col_2row: {
classID: "Money_Video_1col_2row",
thumbnailHeight: 162,
thumbnailWidth: 300,
height: 29,
width: 30,
lastResort: false
},
Money_Video_1col_1row: {
classID: "Money_Video_1col_1row",
thumbnailHeight: 0,
thumbnailWidth: 0,
height: 14,
width: 30,
lastResort: false
},
Money_Slideshow_1col_2row: {
classID: "Money_Slideshow_1col_2row",
thumbnailHeight: 162,
thumbnailWidth: 300,
height: 29,
width: 30,
lastResort: false
},
Money_Slideshow_1col_1row: {
classID: "Money_Slideshow_1col_1row",
thumbnailHeight: 0,
thumbnailWidth: 0,
height: 14,
width: 30,
lastResort: false
},
},
});
})();
