﻿(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
EntityNewsPano: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
/// <summary>
/// Constructor for a simple IPage class that controls the multisizelistview
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
FinanceAppJS.FinanceBasePage.call(this, state);
this._newsPageDetails = {
pano: state.panoId,
collection: state.collectionId
};
var ItemClickCallbacks = {
EntityCluster: function EntityCluster(event) {
var instrumId = this._currentlyRendering.data.clusterItemClickInstrumentationId;
var clst = this.ipage.getClusterContext(this.ipage._newsPageDetails.pano, this.clusterDef.clusterKey);
var page = FinanceAppJS.Telemetry.FlightRecorder.GetPageId(this.ipage._newsPageDetails.pano);
if (this.ipage._newsPageDetails.collection) {
if (this.ipage._newsPageDetails.pano.indexOf("EntityNews") > -1) {
page = clst + FinanceAppJS.Telemetry.Constants.Page.SINGLECLUSTERNEWSPAGE;
} else if (this.ipage._newsPageDetails.pano.indexOf("EntityMoney") > -1) {
page = clst + FinanceAppJS.Telemetry.Constants.Page.SINGLECLUSTERMONEYPAGE;
}
}
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(page,
clst,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
event.item.type + " " + event.item.contentid);
var item = event.item;
utils.launchNewsUri(item, Platform.Instrumentation.InstrumentationEditorialSourceId.cluster);
}
};
var multipleClusters = false;
var maxColumnCount = null;
if (!state || (state && !state.singleCluster)) {
multipleClusters = true;
maxColumnCount = FinanceAppJS.Constants.NewsCluster.NewsClusterMaxColumnCount;
}
var clusterDefinitions = {};
var dataProvider = {};
if (state && state.provider) {
this._provider = state.provider;
dataProvider[state.provider] = { collectionId: this._savedState && this._savedState.collectionId || null, isPreview: FinanceAppJS.Settings.cmsPreviewEnabled };
}
var map = PlatformJS.Services.appConfig.getDictionary("MoreSourcesMap");
var sourcesPageName = map.getString(this.moreSourcesType);
var sources = {};
sources.SourcesDataProvider = { featuredCategory: sourcesPageName };
var moreSourcesTitle = utils.getResourceString(this.moreSourcesResourceKey);
var theme = "financeAppTheme";
if (multipleClusters) {
clusterDefinitions.EntityCluster = {
clusterTitle: "",
clusterControl: "FinanceAppJS.NewsControls.EntityControl",
dataProviders: dataProvider,
onHeaderSelection: this.disableBasePanoClusterHeader ? null : this.headerClickCallback.bind(this),
supressTitleInHeader: this.disableBasePanoClusterHeader ? true : false,
cloneFunc: this.getMultipleClonedDefs.bind(this),
clusterOptions: {
mode: CommonJS.News.ClusterMode.static,
onitemclick: ItemClickCallbacks.EntityCluster,
configKey: this.configKey,
configObject: this.configObject,
theme: theme,
instrumentationEntryPoint: FinanceAppJS.Instrumentation.EntryPoint[this.instrumentationEntryPoint],
maxColumnCount: this.basePanoMaxColumnCount,
subclusterAdFrequency: this.basePanoSubclusterAdFrequency || null,
subclusterAdMax:  this.basePanoSubclusterAdMax || null,
adUnitId: this.basePanoAdUnitId || null,
marginWidth : this.basePanoMarginWidth  || null,
marginDistance: this.basePanoMarginDistance || null
}
};
if (this.enableMoreSources) {
clusterDefinitions.MoreSourcesCluster = {
clusterTitle: moreSourcesTitle,
clusterControl: "FinanceAppJS.EntityPano.MoreSourcesCluster",
validateFunc: function validateFunc() {
return utils.isNonEmptyString(Platform.Configuration.ConfigurationManager.getMarketStringForEditorial());
},
dataProviders: sources,
clusterOptions: {
className: "platformListLayout",
clickInstrumentationID: FinanceAppJS.Constants.Instrumentation[this.moreSourcesInstrId],
}
};
}
}
else {
clusterDefinitions.EntityCluster = {
clusterTitle: "",
clusterControl: "FinanceAppJS.NewsControls.EntityControl",
dataProviders: dataProvider,
cloneFunc: this.getSingleClonedDefs.bind(this),
clusterOptions: {
maxColumnCount: maxColumnCount,
subclusterAdFrequency: PlatformJS.Services.configuration.getBool("EnableAddsInSingleEntityClusterPage") ? 1 : 0,
subclusterAdMax: 1,
adUnitId: PlatformJS.Services.configuration.getDictionary("Ads2").getString(this.subclusterAdId),
marginWidth: 3,
marginDistance: PlatformJS.Services.appConfig.getInt32("EntityClusterAdFrequency"),
mode: CommonJS.News.ClusterMode.static,
onitemclick: ItemClickCallbacks.EntityCluster,
configKey: this.configKey,
configObject: this.configObject,
theme: theme,
instrumentationEntryPoint: FinanceAppJS.Instrumentation.EntryPoint[this.instrumentationEntryPoint],
}
};
this._panoControl.zoomOptions = { locked: true };
}
this.setClusterDefinitions(clusterDefinitions);
this.pageTitle = utils.getResourceString(state.pageTitle);
this._showMarketDataAttribution = false; // We will not show Market Data attribution on News pano
this._hideQuotesDelayText = true; // to hide quotes delay text in News pano
}, {
moreSourcesType: "News",
subclusterAdId: "NewsSubClusterAdUnitID",
moreSourcesResourceKey: "MORE_NEWS_FROM",
instrumentationEntryPoint: "entityNewsPano",
moreSourcesInstrId: "News_MoreSource_Click",
categoryList: "EntityNewsCategoryList",
singleCategoryPagePrefix: "NewsPage_",
multipleCategoryPagePrefix: "News_",
configKey: "EntityClusterDefaultFinanceSportsConfig",
configObject: CommonJS.News.EntityClusterConfig.DefaultFinanceSports,
navigateFunctionOnHeaderClick: navigationHelper.navigateToEntityCategoryNewsPano,
enableMoreSources: true,
disableBasePanoClusterHeader: false,
basePanoMaxColumnCount: FinanceAppJS.Constants.NewsCluster.NewsClusterMaxColumnCount,
_newsPageDetails: {},
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
var pageid = this._newsPageDetails.pano;
var cluster = this._newsPageDetails.collection;
var isMoney = (pageid.indexOf("EntityMoney") > -1);
var isNews = (pageid.indexOf("EntityNews") > -1);
if (!cluster) {
if (pageid === "EntityNewsPano") {
return "/News By Category";
} else if (pageid === "EntityMoneyPano") {
return "/Money";
}
}
var base = "/News By Category";
var idsplit = cluster.split("_");
if (!idsplit || !idsplit.length) {
return base;
}
if (isMoney) {
base = "/Money";
} else if (isNews) {
base = "/News By Category";
}
return base + "/" + this.getClusterContext(pageid, cluster);
},
getClusterContext: function getClusterContext(pano, clusterkey) {
var idsplit = clusterkey.split("_");
if (pano === "EntityMoneyPano") {
if (idsplit[1] === "SavingInvesting") {
return "Saving and Investing";
} else if (idsplit[1] === "CareerEducation") {
return "Career and Education";
} else if (idsplit[1] === "RealEstate") {
return "Real Estate";
} else if (idsplit[1] === "SpendingBorrowing") {
return "Spending and Borrowing";
} else if (idsplit[1] === "Taxes") {
return "Taxes";
} else if (idsplit[1] === "Retirement") {
return "Retirement";
}
} else if (pano === "EntityNewsPano") {
if (idsplit[1] === "Business") {
if (idsplit[0] === "rt") {
return "Top Stories";
} else if (idsplit[0] === "fn") {
return "Business";
}
} else if (idsplit[1] === "Market") {
return "Market";
} else if (idsplit[1] === "Technology") {
return "Technology";
}
}
return idsplit[1];
},
getSingleClonedDefs: function getSingleClonedDefs(data) {
var clusterDef = {};
var collectionId = this._savedState.collectionId;
var dataCacheID = this._getProviderURL();
var cacheID = this._getProviderCacheID();
if (data[collectionId] && data[collectionId].newsItems.length > 0) {
var currList = data[collectionId];
var instrumentId = this._getEntityNewsCategoryInstrumentationKey(collectionId);
clusterDef[collectionId] = {
clusterTitle: currList.displayName,
clusterData: {
newsItems: currList.newsItems,
dataCacheID: dataCacheID,
cacheID: cacheID,
uniqueResponseID: currList.uniqueResponseID,
articleInfos: currList.articleInfos,
clusterItemClickInstrumentationId: this.multipleCategoryPagePrefix + instrumentId + "Cluster_Click",
}
};
}
return clusterDef;
},
getMultipleClonedDefs: function getMultipleClonedDefs(data) {
var clusterDef = {};
var collectionId = null;
var dataCacheID = this._getProviderURL();
var cacheID = this._getProviderCacheID();
var EntityNewsCategoryList = PlatformJS.Services.configuration.getList(this.categoryList);
for (var i = 0; i < EntityNewsCategoryList.size; i++) {
var category = JSON.parse(EntityNewsCategoryList[i].value);
if (utils.isNonEmptyObject(data[category.collectionId])) {
var currList = data[category.collectionId];
var instrumentId = this._getEntityNewsCategoryInstrumentationKey(category.collectionId);
clusterDef[category.collectionId] = {
clusterTitle: currList.displayName,
supressTitleInHeader: this.disableBasePanoClusterHeader ? true : false,
clusterData: {
newsItems: currList.newsItems,
dataCacheID: dataCacheID,
cacheID: cacheID,
uniqueResponseID: currList.uniqueResponseID,
articleInfos: currList.articleInfos,
clusterItemClickInstrumentationId: this.singleCategoryPagePrefix + instrumentId + "Cluster_Click",
}
};
}
}
if (EntityNewsCategoryList.length < 2) {
this._panoControl.zoomOptions = { locked: true };
}
return clusterDef;
},
getPageId: function getPageId(idstr) {
return idstr;
},
getClusterId: function getClusterId(idstr) {
var idsplit = idstr.split("_");
if (!idsplit || !idsplit.length) {
return idstr;
}
if (idsplit[1] === "SavingInvesting") {
return idstr;
}
return idstr;
},
headerClickCallback: function headerClickCallback(clusterKey) {
var stateToPass = {};
var instrumentationKey;
stateToPass.provider = this._savedState.provider;
stateToPass.pageTitle = this._savedState.pageTitle;
stateToPass.panoId = this._savedState.panoId;
stateToPass.singleCluster = true;
stateToPass.collectionId = clusterKey;
var instrumentId = this._getEntityNewsCategoryInstrumentationKey(clusterKey);
if (instrumentId) {
instrumentationKey = this.multipleCategoryPagePrefix + instrumentId + "ClusterHeader_Click";
}
var cluster = this.getClusterContext(this._newsPageDetails.pano, clusterKey);
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.FlightRecorder.GetPageId(this._newsPageDetails.pano),
cluster,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERHEADER,
"");
this.navigateFunctionOnHeaderClick(stateToPass, instrumentationKey);
},
_getEntityNewsCategoryInstrumentationKey: function _getEntityNewsCategoryInstrumentationKey(clusterKey) {
var EntityNewsCategoryList = PlatformJS.Services.configuration.getList(this.categoryList);
for (var i = 0; i < EntityNewsCategoryList.size; i++) {
var category = JSON.parse(EntityNewsCategoryList[i].value);
if (category.collectionId === clusterKey) {
if (category.InstrumentionId) {
return category.InstrumentionId;
}
}
}
},
_getProviderURL: function _getProviderURL() {
var provider = this.getDataProvider(this._provider);
return provider.getQueryServiceURL();
},
_getProviderCacheID: function _getProviderCacheID() {
var provider = this.getDataProvider(this._provider);
return provider.getCacheId();
}
})
});
WinJS.Namespace.define("FinanceAppJS", {
EntityMoneyPano: WinJS.Class.derive(FinanceAppJS.EntityNewsPano, function (options) {
this.enableMoreSources = PlatformJS.Services.configuration.getBool("EnableMoneyMoreSources");
var enableMoneyL2 = PlatformJS.Services.configuration.getBool("EnableMoneyL2");
var ad = PlatformJS.Services.configuration.getDictionary("Ads2").getString(this.subclusterAdId);
if (enableMoneyL2 === false) {
this.basePanoMaxColumnCount = null;
if (ad) {
this.basePanoSubclusterAdFrequency = 1;
this.basePanoSubclusterAdMax = 1;
this.basePanoAdUnitId = ad;
this.basePanoMarginWidth = 3;
this.basePanoMarginDistance = PlatformJS.Services.appConfig.getInt32("EntityClusterAdFrequency");
}
this.disableBasePanoClusterHeader = true;
}
FinanceAppJS.EntityNewsPano.call(this, options);
}, {
moreSourcesType: "Money",
subclusterAdId: "MoneySubClusterAdUnitID",
moreSourcesResourceKey: "MORE_ARTICLES_FROM",
instrumentationEntryPoint: "entityMoneyPano",
moreSourcesInstrId: "Money_MoreSource_Click",
categoryList: "EntityMoneyCategoryList",
singleCategoryPagePrefix: "MoneyPage_",
multipleCategoryPagePrefix: "Money_",
configKey: "EntityClusterDefaultMoneyConfig",
configObject: FinanceAppJS.EntityClusterConfig.MoneyCluster,
navigateFunctionOnHeaderClick: navigationHelper.navigateToEntityCategoryMoneyPano,
enableMoreSources: true,
basePanoMaxColumnCount: FinanceAppJS.Constants.NewsCluster.NewsClusterMaxColumnCount,
disableBasePanoClusterHeader: false
})
});
WinJS.Namespace.define("FinanceAppJS", {
EntityCategoryNewsPano: WinJS.Class.derive(FinanceAppJS.EntityNewsPano, function (options) {
FinanceAppJS.EntityNewsPano.call(this, options);
//TODO: Move all single cluster related code here 
}, {
})
});
WinJS.Namespace.define("FinanceAppJS", {
EntityCategoryMoneyPano: WinJS.Class.derive(FinanceAppJS.EntityMoneyPano, function (options) {
FinanceAppJS.EntityMoneyPano.call(this, options);
}, {
//TODO: Move all single cluster related code here
})
});
})();
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
EntityVideosPano: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
/// <summary>
/// Constructor for a simple IPage class that controls the multisizelistview
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
FinanceAppJS.FinanceBasePage.call(this, state);
var ItemClickCallbacks = {
EntityCluster: function EntityCluster(event) {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.MarketToday_VideoClusterHeader, 1);
var item = event.item;
var cluster = instrumId.split("_");
if (cluster) {
cluster = cluster[1];
}
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.FlightRecorder.GetPageId(this.ipage._channelId),
cluster,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
event.item.contentid);
utils.launchNewsUri(item, Platform.Instrumentation.InstrumentationEditorialSourceId.cluster);
}
};
var clusterDefinitions = {};
var dataProvider = {};
if (state && state.provider) {
dataProvider[state.provider] = { isPreview: FinanceAppJS.Settings.cmsPreviewEnabled };
this._provider = state.provider;
}
var map = PlatformJS.Services.appConfig.getDictionary("MoreSourcesMap");
var sourcesPageName = map.getString("Videos");
var sources = {};
sources.SourcesDataProvider = { featuredCategory: sourcesPageName };
var moreSourcesTitle = utils.getResourceString("MORE_VIDEOS_FROM");
var theme = "financeAppTheme";
clusterDefinitions.EntityCluster = {
clusterTitle: "",
clusterControl: "FinanceAppJS.NewsControls.EntityControl",
dataProviders: dataProvider,
cloneFunc: this.getMultipleClonedDefs.bind(this),
clusterOptions: {
maxColumnCount: null, /* No onHeaderClick and show all items flat in a cluster */
mode: CommonJS.News.ClusterMode.static,
onitemclick: ItemClickCallbacks.EntityCluster,
theme: theme,
instrumentationEntryPoint: FinanceAppJS.Instrumentation.EntryPoint.entityVideosPano,
}
};
clusterDefinitions.MoreSourcesCluster = {
clusterTitle: moreSourcesTitle,
clusterControl: "FinanceAppJS.EntityPano.MoreSourcesCluster",
dataProviders: sources,
validateFunc: function validateFunc() {
return utils.isNonEmptyString(Platform.Configuration.ConfigurationManager.getMarketStringForEditorial());
},
clusterOptions: {
isVideoCluster: true,
className: "platformListLayout",
clickInstrumentationID: FinanceAppJS.Constants.Instrumentation.Videos_MoreSource_Click,
}
};
this.setClusterDefinitions(clusterDefinitions);
this.pageTitle = utils.getResourceString(state.pageTitle);
this._showMarketDataAttribution = false; // We will not show Market Data attribution on News pano
this._hideQuotesDelayText = true; // to hide quotes delay text in News pano
}, {
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Videos";
},
_provider: null,
getMultipleClonedDefs: function getMultipleClonedDefs(data) {
var clusterDef = {};
var collectionId = null;
var dataCacheID = this._getProviderURL();
var cacheID = this._getProviderCacheID();
var EntityVideosCategoryList = PlatformJS.Services.configuration.getList("EntityVideosCategoryList");
for (var i = 0; i < EntityVideosCategoryList.size; i++) {
var category = JSON.parse(EntityVideosCategoryList[i].value);
if (utils.isNonEmptyObject(data[category.collectionId])) {
var currList = data[category.collectionId];
clusterDef[category.collectionId] = {
clusterTitle: currList.displayName,
clusterData: {
newsItems: currList.newsItems,
dataCacheID: dataCacheID,
cacheID: cacheID,
uniqueResponseID: currList.uniqueResponseID
}
};
}
}
return clusterDef;
},
_getProviderURL: function _getProviderURL() {
var provider = this.getDataProvider(this._provider);
return provider.getQueryServiceURL();
},
_getProviderCacheID: function _getProviderCacheID() {
var provider = this.getDataProvider(this._provider);
return provider.getCacheId();
}
})
});
})();
