﻿(function () {
"use strict";
var FinanceAppJS2 = WinJS.Namespace.define("FinanceAppJS.DataProvider", {
EntityPanoProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.DataProviderBase, function (options) {
if (options && options.collectionId) {
this.collectionId = options.collectionId;
}
FinanceAppJS.DataProvider.DataProviderBase.call(this, options);
this._isPreview = FinanceAppJS.Settings.cmsPreviewEnabled;
}, {
type: "news",
queryServiceId: "NewsEntityPanoSource",
_articleIndexCounter: -1,
bypassCache: false,
_isPreview: false,
isPreview: {
get: function get(value) {
return this._isPreview;
},
set: function set(value) {
this._isPreview = value;
if (this._isPreview) {
this.bypassCache = true;
}
else {
this.bypassCache = false;
}
}
},
entities: null,
usePrefixForKey: false,
refreshInterval: FinanceAppJS.Constants.RefreshIntervals.EntityPanoProvider,
getQueryServiceParams: function getQueryServiceParams() {
var urlParams = PlatformJS.Collections.createStringDictionary();
urlParams["previewString"] = this._isPreview ? encodeURIComponent("/preview") : "";
urlParams.insert("market", encodeURIComponent(FinanceAppJS.Globalization.getMarket()));
return urlParams;
},
dataBuilder: function dataBuilder(jsonResponse, response) {
this._articleIndexCounter = -1;
var articleInfos = [];
var parsedData = {};
if (jsonResponse && jsonResponse.clusters && jsonResponse.clusters.length > 0) {
var clusters = jsonResponse.clusters;
if (this.collectionId) {
var collectionId = this.collectionId;
clusters = clusters.filter(function (cluster) {
if (cluster.entityList && cluster.entityList.collectionId && cluster.entityList.collectionId === collectionId) {
return true;
}
});
}
var length = clusters.length;
for (var i = 0; i < length; i++) {
var currCluster = clusters[i];
if (currCluster.entityList && currCluster.entityList.collectionId
&& currCluster.entityList.entities && currCluster.entityList.entities.length > 0) {
var entities = currCluster.entityList.entities;
var items = [];
for (var j = 0; j < entities.length; j++) {
var newsItem = utils.convertCMSArticle(entities[j], this.type);
if (!newsItem) {
continue;
}
if (newsItem.type === "article") {
this._articleIndexCounter++;
newsItem.articleIndex = this._articleIndexCounter;
}
items.push(newsItem);
if (newsItem.editorial && newsItem.type === "article" && newsItem.articleid) {
articleInfos.push({ articleId: utils.getArticleReaderId(newsItem) });
}
}
var keyToUse = currCluster.entityList.collectionId;
keyToUse = this.usePrefixForKey ? i + "_" + keyToUse : keyToUse;
parsedData[keyToUse] = {
displayName: currCluster.entityList.categoryName,
newsItems: items,
uniqueResponseID: response.responseId,
articleInfos: articleInfos
};
}
}
}
return (Object.keys(parsedData).length > 0) ? parsedData : null;
}
}, {
})
});
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
VideoEntityPanoProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.EntityPanoProvider, function (options) {
FinanceAppJS.DataProvider.EntityPanoProvider.call(this, options);
}, {
queryServiceId: "VideosEntityPanoSource"
})
});
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
MoneyEntityPanoProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.EntityPanoProvider, function (options) {
FinanceAppJS.DataProvider.EntityPanoProvider.call(this, options);
}, {
type: "money",
queryServiceId: "MoneyEntityPanoSource"
})
});
})();
(function () {
"use strict";
var FinanceAppJS2 = WinJS.Namespace.define("FinanceAppJS.DataProvider", {
SourcesDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.DataProviderBase, function (options) {
if (options && options.featuredCategory) {
this.featuredCategory = options.featuredCategory;
}
FinanceAppJS.DataProvider.DataProviderBase.call(this, options);
this.isPreview = FinanceAppJS.Settings.cmsPreviewEnabled;
}, {
_isPreview: false,
isPreview: {
get: function get() { return this._isPreview; },
set: function set(value) {
this._isPreview = value;
if (this.isPreview) {
this.queryServiceId = "FinanceFeaturesConfigurationDataSource_preview";
this._queryService = new PlatformJS.DataService.QueryService(this.queryServiceId);
this.bypassCache = true;
}
else {
this.bypassCache = false;
}
}
},
featuredCategory: "MoreSources_News",
queryServiceId: Platform.Configuration.ConfigurationManager.partnerDataFeedUrl.length ?
"FeaturesConfigurationFullUrlDataSource" :
"FinanceFeaturesConfigurationDataSource",
refreshInterval: FinanceAppJS.Constants.RefreshIntervals.EntityPanoProvider,
getQueryServiceParams: function getQueryServiceParams() {
var urlParams = PlatformJS.Collections.createStringDictionary();
var market = Platform.Configuration.ConfigurationManager.getMarketStringForEditorial();
urlParams.insert("Market", encodeURIComponent(market));
urlParams.insert("url", Platform.Configuration.ConfigurationManager.partnerDataFeedUrl);
return urlParams;
},
dataBuilder: function dataBuilder(jsonResponse, response) {
var that = this;
var channelsToRender = [];
if (jsonResponse && jsonResponse.sources) {
var mn = PlatformJS.Navigation.mainNavigator.channelManager;
jsonResponse.sources.forEach(function (sourceItem) {
if (sourceItem
&& sourceItem.clusterlogo
&& sourceItem.displayname
&& sourceItem.featuredcategory === that.featuredCategory) {
var channelInfo = mn.parseChannel({ destination: "//sources/" + sourceItem.id }, [sourceItem]);
if (channelInfo) {
utils.setSourceItemAttributes(channelInfo, sourceItem);
channelsToRender.push(channelInfo);
}
}
});
if (channelsToRender.length > 0) {
channelsToRender.sort(function (a, b) {
if (a.alphaorder < b.alphaorder) {
return -1;
} else if (a.alphaorder > b.alphaorder) {
return 1;
} else {
return 0;
}
});
}
}
return channelsToRender.length > 0 ? channelsToRender : null;
}
}, {
})
});
})();
(function () {
"use strict";
var QueryServiceWrapper = WinJS.Class.define(function (promiseFunc) {
this._promiseFunc = promiseFunc;
}, {
_promiseFunc: null,
_convertToResponseData: function _convertToResponseData(data, isCached) {
return {
lastUpdateTime: new Date(),
isLocalResponse: false,
isCachedResponse: isCached ? true : false,
responseId: null,
isStaleResponse: isCached ? true : false,
dataString: typeof data === 'string' ? data : JSON.stringify(data)
};
},
_complete: function _complete(data, isCached) {
return this._convertToResponseData(data, false);
},
_progress: function _progress(data, isCached) {
return {
statusCode: Platform.DataServices.QueryServiceStatusCode[(data ? "cachedEntryFound" : "cachedEntryNotFound")],
cachedResponse: this._convertToResponseData(data, true)
};
},
_error: function _error() {
},
downloadDataAsync: function downloadDataAsync(urlParams, payloadParams, transformer, options) {
var promFunc = this._promiseFunc();
var that = this;
return new WinJS.Promise(function (complete, error, progress) {
promFunc.then(
function (c) { complete(that._complete(c)); },
function (e) { error(that._error(e)); },
function (p) { progress(that._progress(p)); }
);
});
},
getCacheId: function getCacheId() {
},
getURL: function getURL() {
}
});
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
TodaySourcesDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.DataProviderBase, function (options) {
this.queryService = new QueryServiceWrapper(this.getQueryServicePromise.bind(this));
FinanceAppJS.DataProvider.DataProviderBase.call(this, options);
this._currentMarket = Platform.Configuration.ConfigurationManager.instance.currentConfigurationFolderName;
}, {
refreshInterval: FinanceAppJS.Constants.RefreshIntervals.EntityPanoProvider,
getQueryServicePromise: function getQueryServicePromise(urlParams, payloadParams, transformer, options) {
var that = this;
var task = function (complete, error, progress) {
var cacheInstance = PlatformJS.Cache.CacheService.getInstance("ConfigurationCache");
var searchEntry = that._currentMarket + "-Features";
/* timeout is required to make this an asynchronous task. otherwise progress event is lost */
WinJS.Promise.timeout().then(function () {
cacheInstance.findEntry(searchEntry, { supportsInMemory: true })
.then(function getFeaturesConfig_Complete(response) {
var returnValue = null;
if (response && response.dataValue) {
returnValue = response.dataValue;
}
progress(returnValue);
})
.then(function () {
PlatformJS.Navigation.mainNavigator.channelManager.downloadFeaturesConfigAsync().then(function downloadComplete() {
cacheInstance.findEntry(searchEntry, { supportsInMemory: true })
.then(function getFeaturesConfig_Complete(response) {
var returnValue = null;
if (response && response.dataValue) {
returnValue = response.dataValue;
}
complete(returnValue);
}, function () {
complete(null);
});
}, function downloadError() {
complete(null);
});
});
});
};
return new WinJS.Promise(task);
},
getClusterLogoandDisplayName: function getClusterLogoandDisplayName(id, sources) {
id = id.toLowerCase();
var params = null;
if (sources) {
for (var i = 0; i < sources.length; i++) {
if (sources[i].id.toLowerCase() === id) {
params = {
clusterLogo: sources[i].clusterlogo,
displayName: sources[i].displayname
};
break;
}
}
}
return params;
},
dataBuilder: function dataBuilder(jsonResponse, response) {
var channelsToRender = [];
var that = this;
var mn = PlatformJS.Navigation.mainNavigator.channelManager;
if (jsonResponse && jsonResponse.navbaritems && jsonResponse.sources) {
var featuredSources = {};
var sources = jsonResponse.sources;
for (var idx = 0, len = sources.length; idx < len; idx++) {
if (sources[idx] && sources[idx].id) {
var sourceId = sources[idx].id.toLowerCase();
featuredSources[sourceId] = sources[idx];
}
}
this.featuredSources = featuredSources;
jsonResponse.navbaritems.forEach(function (navBarItem) {
if (navBarItem.destination.startsWith("//sources/")) {
var channelInfo = mn.parseChannel(navBarItem, jsonResponse.sources);
if (channelInfo) {
/* Id is the string after "//sources/"  hence substring(10). get the panotitle and 
displayname of the id from sources array. */
var sourceId = navBarItem.destination.substring(10).toLowerCase();
var sourceItem = that.featuredSources[sourceId];
if (sourceItem
&& sourceItem.clusterlogo
&& sourceItem.displayname) {
utils.setSourceItemAttributes(channelInfo, sourceItem);
channelsToRender.push(channelInfo);
}
}
}
});
var todayItems = [];
jsonResponse.sources.forEach(function (sourceItem) {
if (sourceItem
&& sourceItem.clusterlogo
&& sourceItem.displayname
&& sourceItem.featuredcategory === "MoreSources_Today") {
var nItem = { destination: "//sources/" + sourceItem.id };
var channelInfo = mn.parseChannel(nItem, [sourceItem]);
if (channelInfo) {
utils.setSourceItemAttributes(channelInfo, sourceItem);
todayItems.push(channelInfo);
}
}
});
if (todayItems.length > 0) {
todayItems.sort(function (a, b) {
if (a.alphaorder < b.alphaorder) {
return -1;
} else if (a.alphaorder > b.alphaorder) {
return 1;
} else {
return 0;
}
});
}
channelsToRender = channelsToRender.concat(todayItems);
}
return channelsToRender.length > 0 ? channelsToRender : null;
}
}, {
})
});
})();
