﻿(function () {
'use strict';
WinJS.Namespace.define('FinanceAppJS.FundBrowse', {
Collection: WinJS.Class.derive(CommonJS.EntityCollection.Collection, function (options) {
CommonJS.EntityCollection.Collection.call(this, options);
this.options = options || {};
this._data = [];
this.impressionContext = "/Fund Browse/" + options.category;
}, {
/*CommonJS.EntityCollection.Collection Members*/
Initialize: function Initialize(config) {
FinanceAppJS.Utils.disableBottomEdgy();
config = config || {};
this.UIConfig = config.UIConfig || new FinanceAppJS.FundBrowse.UIConfig({ sid: this.options.sid, category: this.options.category });
this.DataConfig = config.DataConfig || new CommonJS.EntityCollection.DataConfig();
this.Provider = new CollectionProvider.FundBrowseProvider();
WinJS.Utilities.addClass(document.querySelector(".ImersivePage"),  this.options.category.replace(/[\W]/g, ""));
var providerConfig = PlatformJS.Collections.createStringDictionary();
providerConfig.insert('sid', this.options.sid);
providerConfig.insert('category', this.options.category);
return this.Provider.initializeAsync(providerConfig);
},
}),
UIConfig: WinJS.Class.derive(CommonJS.EntityCollection.UIConfig, function (options) {
options = options || {};
this.sid = options.sid;
this.category = options.category;
CommonJS.EntityCollection.UIConfig.call(this, options);
}, {
sid: null,
category: null,
GetSupportedViews: function GetSupportedViews() {
return {
list: [CommonJS.EntityCollection.Views.List],
defaultView: CommonJS.EntityCollection.Views.List
};
},
OnItemClicked: function OnItemClicked(item) {
var data = {
ScreenId: this.sid,
FundName: item.FundName
};
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.FUNDBROWSE,
FinanceAppJS.Telemetry.Constants.Location.ECV,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
data);
navigationHelper.navigateToFundDetailsPage({ entity: { Scid: item.ScreenerId, Fn: item.FundName, Tkr: item.Tkr } });
return true;
},
GetViewOptions: function GetViewOptions(view) {
var options = {};
switch (view) {
case CommonJS.EntityCollection.Views.Grid:
options.selectionMode = 'multi';
options.disableClearFilters = true;
break;
case CommonJS.EntityCollection.Views.List:
options.selectionMode = 'none';
options.disableClearFilters = true;
break;
}
// Bug#158094: disabling semanticZoom for all ECVs
options.disableSemanticZoom = true;
return options;
},
SetFilterType: function SetFilterType(filter) {
switch (filter.attribute){
case "Sort":
filter.type = "Toggle";
break;
}
filter.selectionMode = 'SingleToggleFilter';
},
GetEntityTemplate: function GetEntityTemplate(view) {
var entityTemplate = null;
switch (view) {
case CommonJS.EntityCollection.Views.Grid:
entityTemplate = document.querySelector('.fundBrowseItemTemplate');
break;
}
return entityTemplate;
},
HideAppBar: function HideAppBar() { return false; },
GetAppBarItems: function GetAppBarItems(controller) {
/*must return an array of WinJS.UI.AppBarCommand options objects controller is passed in so consumer can grab handles to entities, sort, fitler, etc in their callbacks*/
var buttons = [
{
id: "helpButton",
icon: "\uFF60",
extraClass: 'appexSymbol right',
label: utils.getResourceString("/Platform/HelpLabel"),
instrumentId: FinanceAppJS.Constants.Instrumentation.Help_FundScreenerEcv_Click,
onclick: navigationHelper.navigateToHelpPage
}
];
return buttons;
},
GetTableDefinition: function GetTableDefinition(entities) {
var td = new CommonJS.Table.TableDefinition();
td.cssWhiteList.push("FundBrowse.css");
var fields = {
"Pre-Screened": {
FundName: utils.getResourceString('FundBrowse_Col_FundName'),
Category: utils.getResourceString('FundBrowse_Col_Category'),
Rating: utils.getResourceString('FundBrowse_Col_Rating'),
Return: utils.getResourceString('FundBrowse_Col_Return'),
ExpenseRatio: utils.getResourceString('FundBrowse_Col_ExpenseRatio'),
TotalAssets: utils.getResourceString('FundBrowse_Col_TotalAssets')
},
"Performance": {
FundName: utils.getResourceString('FundBrowse_Col_FundName'),
Category: utils.getResourceString('FundBrowse_Col_Category'),
Rating: utils.getResourceString('FundBrowse_Col_Rating'),
Return: utils.getResourceString('FundBrowse_Col_Return'),
},
"Highest Rated": {
FundName: utils.getResourceString('FundBrowse_Col_FundName'),
Category: utils.getResourceString('FundBrowse_Col_Category'),
Rating: utils.getResourceString('FundBrowse_Col_Rating'),
Return: utils.getResourceString('FundBrowse_Col_Return'),
ExpenseRatio: utils.getResourceString('FundBrowse_Col_ExpenseRatio'),
}
};
fields = fields[this.category];
var i = 0;
for (var f in fields) {
var colDefinition = new CommonJS.Table.ColumnDefinition();
if ( this.category === "Performance" && f === "Return") {
colDefinition.headerText = utils.getResourceString("FundBrowse_Col_" + f + "_" + this.sid);
} else {
colDefinition.headerText = utils.getResourceString("FundBrowse_Col_" + f);
}
colDefinition.priority = i++;
colDefinition.boundField = f;
colDefinition.ID =  f;
colDefinition.headerTemplate = document.querySelector("#columnHeaderTemplate");
colDefinition.fieldTemplate = document.querySelector("#textFieldTemplate" + "_" + f) || document.querySelector("#textFieldTemplate");
td.columns.push(colDefinition);
}
td.itemSpacing = { min: 0, max: 0 };
td.GroupPosition = 'top'; //can also be 'top'
td.showColumnHeaders = true;
return td;
},
})
});
})();
