﻿(function () {
WinJS.Namespace.define("FinanceAppJS", {
FundDetails: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
FinanceAppJS.FinanceBasePage.call(this, state);
this.pageState = { Title: state.entity.Fn, Tkr: state.entity.Tkr, Scid: state.entity.Scid, UniqueId: state.entity.Tkr || state.entity.Scid };
var defaultNoDataDisplayValue = FinanceAppJS.Constants.Funds.DefaultNoDataDisplayValue;
var clusterDefinitions = {
chart: {
clusterTitle: utils.getResourceString("FD OverView"),
clusterControl: "FinanceAppJS.FundDetailsPage.FundOverviewCluster",
dataProviders: {
FundDetailsDataProvider: { entities: this.pageState.Scid },
FundChartDataProvider: { instrumentType: "fund", stockSymbol: this.pageState.Scid, duration: "1m", refreshInterval: 0 },
},
primaryProviders: "FundDetailsDataProvider",
clusterOptions: {
instrumentType: "fund",
moduleInfo: {
height: "100%",
width: "auto",
fragmentPath: "/pages/FundDetails/html/FundDetailsTemplates.html",
templateId: "overview",
}
}
},
keyStats: {
clusterTitle: utils.getResourceString("KeyStats"),
clusterControl: "FinanceAppJS.Controls.ModuleClusterControl",
dataProviders: { FundDetailsDataProvider: { entities: this.pageState.Scid } },
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.peers &&
(["Fyr", "Rfyc", "Erj", "Erc", "Rj", "Rc", "Nc", "Nj", "Ej", "Ec", "Dj", "Dc", "Cj", "Cc", "Terr", "Cter"].some(function (k) { return data.peers[k] && data.peers[k] !== defaultNoDataDisplayValue; }));
},
clusterOptions: {
dataKey: ["peers"],
moduleInfo: {
fragmentPath: "/pages/FundDetails/html/FundDetailsTemplates.html",
templateId: "peercluster",
}
}
},
fundDetails: {
clusterTitle: utils.getResourceString("ETFFUNDProfile"),
clusterControl: "FinanceAppJS.Controls.ModuleClusterControl",
dataProviders: { FundDetailsDataProvider: { entities: this.pageState.Scid } },
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.profile &&
(["Sn", "Ff", "Is", "Fm", "In", "Incd"].some(function (k) { return data.profile[k] && data.profile[k] !== defaultNoDataDisplayValue; }));
},
clusterOptions: {
dataKey: ["profile"],
moduleInfo: {
fragmentPath: "/pages/FundDetails/html/FundDetailsTemplates.html",
templateId: "profilecluster",
}
}
},
mstarrating: {
clusterTitle: utils.getResourceString("ProviderRating"),
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.rating &&
(["Og", "Tyg", "Fyg", "Nyg"].some(function (k) { return data.rating[k];}) ||
["Rtyr", "Rfyr", "Rnyr", "Or", "Tyk", "Fyk"].some(function (k) { return data.rating[k] !== defaultNoDataDisplayValue; }));
},
clusterControl: "FinanceAppJS.Controls.ModuleClusterControl",
dataProviders: { FundDetailsDataProvider: { entities: this.pageState.Scid } },
clusterOptions: {
dataKey: ["rating"],
moduleInfo: {
fragmentPath: "/pages/FundDetails/html/FundDetailsTemplates.html",
templateId: "ratingcluster",
}
}
},
fundcomp: {
clusterTitle: utils.getResourceString("FD Fund Components"),
postDataValidateFunc: function postDataValidateFunc(data) {
var assetData = data.asset;
return (assetData.Ahld || assetData.Bhld || assetData.Ehld);
},
clusterControl: "FinanceAppJS.Controls.ModuleClusterControl",
dataProviders: { FundDetailsDataProvider: { entities: this.pageState.Scid } },                   
clusterOptions: {
dataKey: ["asset"],
moduleInfo: {
height: "100%",
width: "auto",
fragmentPath: "/pages/FundDetails/html/FundDetailsTemplates.html",
templateId: "assetcluster",
}
}
},
topholdings: {
clusterTitle: utils.getResourceString("ETFTop10"),
postDataValidateFunc: function postDataValidateFunc(data) { return data.holdings && data.holdings.length > 0; },
clusterControl: "FinanceAppJS.Controls.TableCluster",
dataProviders: { FundDetailsDataProvider: { entities: this.pageState.Scid } },                    
clusterOptions: {
dataKey: "holdings",
footerKey: "portfolioDate",
className: "holdingsTable",
onrendercomplete: function onrendercomplete() {
// Attach cluster with Arrow key navigation - scroll event.
FinanceAppJS.Utils.Navigator.enableArrowKeyAccessibilty();
}
}
}
};
this.setClusterDefinitions(clusterDefinitions);
this.pageTitle = this.pageState.Title;
this.roaming = new FinanceAppJS.Roaming;
}, {
pinUnpinManager: null,
onBindingComplete: function onBindingComplete() {
/// <summary>
/// This function is invoked by the UX Framework when the data binding is complete
/// </summary>
/// <returns>
/// Nothing
/// </returns>
FinanceAppJS.FinanceBasePage.prototype.onBindingComplete.call(this);
// Setup actions for bottom edgy
var btmEdgy = document.querySelector("#platformActionEdgy");
this.btnManage = btmEdgy.querySelector("#btnMF");
var fundUniqueStatus = utils.getFundUniqueStatus(this.pageState);
var isRoamingEntryExists = this.roaming.isWatchListEntryExists(fundUniqueStatus.symbol, fundUniqueStatus.type);
WatchListManage.toggleEdgyLabels(isRoamingEntryExists, this.btnManage);
var options = {
symbol: fundUniqueStatus.symbol,
type: fundUniqueStatus.type,
isEntryExists: isRoamingEntryExists,
elm: this.btnManage,
actionBar: btmEdgy,
name: this.pageState.Title,
roamingObj: this.roaming
};
this.edgyBtnClickHandler = WatchListManage.addOrRemoveFromEdgy.bind(null, options);
this.btnManage.addEventListener("click", this.edgyBtnClickHandler);
this.pinUnpinManager = new FinanceAppJS.PinUnpinManager(btmEdgy, this.getPageState(), FinanceAppJS.Constants.IDs.Fund, this.pageState.UniqueId, this.pageState.Title, this.pageState.UniqueId, null, null, FinanceAppJS.Constants.Instrumentation.PinStart_Fund_Click);
},
onVisibilityChanged: function onVisibilityChanged() {
if (document.msVisibilityState === "visible" && this.pinUnpinManager) {
this.pinUnpinManager.updateBottomSwipyPinButtons(this.pageState.UniqueId, FinanceAppJS.Constants.IDs.Fund);
}
},
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Fund details page";
},
getCurrentContent: function getCurrentContent() {
var content = {
Symbol: this.pageState.Tkr,
Page: FinanceAppJS.Telemetry.Constants.Page.FUNDDETAILS,
};
return content;
},
onPageLoadComplete: function onPageLoadComplete() {
FinanceAppJS.Telemetry.FlightRecorder.LogSearchEventFromResultPage();
FinanceAppJS.FinanceBasePage.prototype.onPageLoadComplete.call(this);
var content = this.getCurrentContent();
FinanceAppJS.Telemetry.FlightRecorder.LogContentView(content);
},
onNavigateAway: function onNavigateAway(reason) {
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away
/// </summary>
/// <param name="reason">
/// The reason why the page is being navigated away: "backNavigation" or "newNavigation"
/// </param>
/// <returns>
/// Nothing
/// </returns>
FinanceAppJS.FinanceBasePage.prototype.onNavigateAway.call(this);
var chartControlDiv = document.querySelector(".fundChart");
if (chartControlDiv) {
var chartControl = chartControlDiv.winControl;
if (chartControl) {
chartControl.dispose();
}
}
if (this.pinUnpinManager) {
this.pinUnpinManager.clean();
}
if (this.btnManage && this.edgyBtnClickHandler) {
this.btnManage.removeEventListener("click", this.edgyBtnClickHandler);
this.btnManage = null;
}
},
getSharedContractData: function getSharedContractData() {
var that = this;
var dataProvider = this.getDataProvider("FundDetailsDataProvider");
var data = dataProvider._lastFetchData;
var frmtLastUpdatedTime = utils.formatLastUpdatedTime(this._lastUpdatedTime);
var sharedContractDataPromise;
if (data) {
var fundEntityData = {
timeAttribution: utils.getResourceString('ShareContractTimeAttribution').format(frmtLastUpdatedTime),
dataAttribution: utils.getResourceString('ShareContractDataAttribution'),
source: FinanceAppJS.Constants.IDs.NonIndices,
entities: [{
type: FinanceAppJS.Constants.IDs.Fund,
header: this.pageState.Title,
cmp: this.pageState.Title,
sym: data.overview.tkr ? data.overview.tkr : "",
lp: data.overview.Nav,
changeStatus: data.overview.changeStatus,
ch: data.overview.Ch,
chp: data.overview.Chp
}]
};
var uriBuilder = new Platform.Utilities.AppExUriBuilder();
uriBuilder.controllerId = "application";
uriBuilder.commandId = "view";
uriBuilder.queryParameters.insert("entitytype", "fund");
uriBuilder.queryParameters.insert("sym", this.pageState.Tkr);
uriBuilder.queryParameters.insert("cmp", this.pageState.Title);
uriBuilder.queryParameters.insert("secid", this.pageState.Scid);
var uri = uriBuilder.toString();
fundEntityData.deepLink = uri;
sharedContractDataPromise = new WinJS.Promise(function (complete, error) {
utils.getShareContractHtmlFormat(fundEntityData).then(function (htmlOutput) {
complete({
title: utils.getShareContractSubject(that.pageState.Title),
htmlContent: htmlOutput,
textContent: utils.getShareContractTextFormat(fundEntityData),
uri: uri
});
});
});
}
else {
sharedContractDataPromise = new WinJS.Promise.wrapError({});
}
return sharedContractDataPromise;
},
},
{
areStateEqual: function areStateEqual(firstState, secondState) {
var firstItem = firstState.entity;
var secondItem = secondState.entity;
if (firstItem && secondItem) {
return ((firstItem.Fn === secondItem.Fn)
&& (firstItem.Scid === secondItem.Scid)
);
}
return false;
}
})
});
})();
(function () {
'use strict';
var FundDetailsPage = WinJS.Namespace.define("FinanceAppJS.FundDetailsPage",
{
/// <summary>
/// Cluster with Chart as view for stock quotes
/// </summary>
FundOverviewCluster: WinJS.Class.derive(FinanceAppJS.Controls.BaseOverviewCluster, function (domElement, options) {
this._rangeSelectors = ['1m', '3m', '1y', '3y', '5y', 'max'];
FinanceAppJS.Controls.BaseOverviewCluster.call(this, domElement, options);
// set options
WinJS.UI.setOptions(this, options);
},
{
update: function update(data, providerName) {
switch (providerName) {
case 'FundDetailsDataProvider':
var that = this;
if (data) {
this.equityUpdateTime = data.lastUpdateTime;
}
if (data && data.overview && data.overview.stk && data.overview.stk.displayName) {
this.displayName = data.overview.stk.displayName;
}
else {
this.displayName = "-";
}
this.realtimeQuotesLastUpdatedTimeString = utils.getResourceString("ChartRTLastUpdated").format(data.overview.Dt);
return FinanceAppJS.Controls.ModuleClusterControl.prototype.update.call(this, data).then(function () {
var quoteSearchButton = document.querySelectorAll(".quoteSearchglyphParent");
if (quoteSearchButton.length > 0) {
for (var index = 0; index < quoteSearchButton.length; index++) {
quoteSearchButton[index].addEventListener("MSLostPointerCapture", PlatformJS.Utilities.pointerEventListenersMap["MSLostPointerCapture"], false);
quoteSearchButton[index].addEventListener("MSPointerCancel", PlatformJS.Utilities.pointerEventListenersMap["MSPointerCancel"], false);
quoteSearchButton[index].addEventListener("MSPointerUp", PlatformJS.Utilities.pointerEventListenersMap["MSPointerUp"], false);
quoteSearchButton[index].addEventListener("MSPointerDown", PlatformJS.Utilities.pointerEventListenersMap["MSPointerDown"], false);
quoteSearchButton[index].addEventListener("MSPointerOut", PlatformJS.Utilities.pointerEventListenersMap["MSPointerOut"], false);
}
}
return that.performPendingUpdate();
});
case 'FundChartDataProvider':
return this.updateChart(data);
}
},
})
});
})();
