﻿(function () {
'use strict';
function getOverviewData(data) {
var chartStartDuration = "1m";
var item = {};
item.Nav = FinanceAppJS.Utils.Formatters.numberFormatter(data.Nav, 2);
item.Ch = FinanceAppJS.Utils.Formatters.numberFormatter(data.Ch, 2, true);
item.Chp = FinanceAppJS.Utils.Formatters.percentFormatter(data.Chp, 2, true);
item.col1 = "row2 col3 fontMB pttc";
item.col2 = "row3 col3 fontMB pttc";
item.img = "row3 col1 ptp";
if (data.Ch > 0) {
item.changeStatus = 1;
item.img += " largeGlyph financeGlyphUp";
item.col1 += " upcolor";
item.col2 += " upcolor";
}
else if (data.Ch < 0) {
item.changeStatus = -1;
item.img += " largeGlyph financeGlyphDn";
item.col1 += " downcolor";
item.col2 += " downcolor";
}
else if (data.Ch === 0) {
item.changeStatus = 0;
item.img += " mediumGlyph financeGlyphEq";
item.col1 += " equalcolor";
item.col2 += " equalcolor";
}
//TODO : do this
item.Nast = data.Nast ? utils.formatVolume(data.Nast, 2) : "-";
item.Minv = FinanceAppJS.Utils.Formatters.numberFormatter(data.Minv, 0);
item.Rr = data.Ok ? data.Ok : "-"; 
item.Yld = FinanceAppJS.Utils.Formatters.percentFormatter(data.Yld, 2);
item.Ld = FinanceAppJS.Utils.Formatters.numberFormatter(data.Ld, 0, false, utils.getResourceString("None"));
item.Cat = data.Cat;
item.Dt = FinanceAppJS.Utils.Formatters.shortDateFormat(data.Dt);
item.Ex = FinanceAppJS.Utils.Formatters.percentFormatter(data.Erj, 2);
item.St = data.St ? data.St : "-"; 
item.stk = { seriesId: data.Scid + chartStartDuration, displayName: data.Fn };
item.Og = data.Og;
item.tkr = data.Tkr;
item.caption = utils.getResourceString("FundChartCaption");
var fundDetails = getFundDetailsTemplateData(data);
for (var prop in fundDetails) {
item[prop] = fundDetails[prop];
}
var adConfig = PlatformJS.Ads.getAdsConfig("sponsoredBy");
if (adConfig) {
item["adUnitId"] = adConfig.adUnitId;
}
// Add narator text
item.naratorText = data.Fn + ". " + utils.getResourceString("EntityDetailsOverview");
return item;
}
function getFundDetailsTemplateData(data) {
var fundItem = {};
if (!data.Fs) {
fundItem.index = 0;
}
else {
fundItem.index = data.Fs;
}
if (!data.Bh) {
fundItem.bindex = 0;
}
else {
fundItem.bindex = data.Bh;
}
var returns = [];
returns.push(data.Ytr ? data.Ytr : 0, data.Omr ? data.Omr : 0, data.Tyr ? data.Tyr : 0, data.Fyr ? data.Fyr : 0, data.Nyr ? data.Nyr : 0);
fundItem.returns = returns;
fundItem.Ytr = FinanceAppJS.Utils.Formatters.numberFormatter(data.Ytr, 2);
fundItem.Omr = FinanceAppJS.Utils.Formatters.numberFormatter(data.Omr, 2);
fundItem.Tyr = FinanceAppJS.Utils.Formatters.numberFormatter(data.Tyr, 2);
fundItem.Fyr = FinanceAppJS.Utils.Formatters.numberFormatter(data.Fyr, 2);
fundItem.Nyr = FinanceAppJS.Utils.Formatters.numberFormatter(data.Nyr, 2);
fundItem.Ytc = data.Ytc ? FinanceAppJS.Utils.Formatters.numberFormatter(data.Ytc.R, 0) : "-";
fundItem.Omc = data.Omc ? FinanceAppJS.Utils.Formatters.numberFormatter(data.Omc.R, 0) : "-";
fundItem.Tyc = data.Tyc ? FinanceAppJS.Utils.Formatters.numberFormatter(data.Tyc.R, 0) : "-";
fundItem.Fyc = data.Fyc ? FinanceAppJS.Utils.Formatters.numberFormatter(data.Fyc.R, 0) : "-";
fundItem.Nyc = data.Nyc ? FinanceAppJS.Utils.Formatters.numberFormatter(data.Nyc.R, 0) : "-";
return fundItem;
}
function getPeersData(data) {
var peerItem = {};
peerItem.name = data.Tkr ? data.Tkr : utils.getResourceString("Fund");
peerItem.Fyr = FinanceAppJS.Utils.Formatters.percentFormatter(data.Fyr, 2);
peerItem.Rfyc = FinanceAppJS.Utils.Formatters.percentFormatter(data.Rfyc, 2);
peerItem.Erj = FinanceAppJS.Utils.Formatters.percentFormatter(data.Erj, 2);
peerItem.Erc = FinanceAppJS.Utils.Formatters.percentFormatter(data.Erc, 2);
peerItem.Rj = FinanceAppJS.Utils.Formatters.numberFormatter(data.Rj, 2);
peerItem.Rc = FinanceAppJS.Utils.Formatters.numberFormatter(data.Rc, 2);
//TODO: do these (M, B formatting)
peerItem.Nc = data.Nc ? utils.formatVolume(data.Nc, 2) : "-";
peerItem.Nj = data.Nast ? utils.formatVolume(data.Nast, 2) : "-";
peerItem.Ej = data.Ahld ? FinanceAppJS.Utils.Formatters.percentFormatter(data.Ahld.Ust, 2) : "-";
peerItem.Ec = FinanceAppJS.Utils.Formatters.percentFormatter(data.Ec, 2);
peerItem.Dj = FinanceAppJS.Utils.Formatters.percentFormatter(data.Dj, 2);
peerItem.Dc = FinanceAppJS.Utils.Formatters.percentFormatter(data.Dc, 2);
peerItem.Cj = data.Ahld ? FinanceAppJS.Utils.Formatters.percentFormatter(data.Ahld.Csh, 2) : "-";
//TODO: do these (M, B formatting)
peerItem.Cc = utils.formatValue("", utils.formatVolume(parseFloat(data.Cc, 2)), "%");
peerItem.Cat = data.Cat ? data.Cat : "-";
peerItem.naratorText = utils.getResourceString("KeyStats") + ". " + peerItem.name;
return peerItem;
}
function getProfileData(dataItem) {
var profileItem = {};
var map = FinanceAppJS.Constants.Funds.FundStyleMap();
profileItem.Ff = dataItem.Ff ? utils.addLtrMark(dataItem.Ff) : "-";
profileItem.Is = !dataItem.Fs ? "-" : utils.addLtrMark(map[dataItem.Fs - 1]);
//Removing tenure for now. Will bring it back with more clarity
//profileItem.Fm = (dataItem.Fm ? dataItem.Fm : "-") + " / " + (dataItem.T ? utils.getResourceString("yrs").format(dataItem.T) : "-");
profileItem.Fm = (dataItem.Fm ? dataItem.Fm : "-");
profileItem.Fm = utils.addLtrMark(profileItem.Fm);
profileItem.Mp = FinanceAppJS.Utils.Formatters.numberFormatter(dataItem.Mp, 0);
profileItem.Mpr = FinanceAppJS.Utils.Formatters.numberFormatter(dataItem.Mpr, 0);
profileItem.Mpp = FinanceAppJS.Utils.Formatters.numberFormatter(dataItem.Mpp, 0);
profileItem.Sn = dataItem.Sn ? utils.addLtrMark(dataItem.Sn) : "-";
var fundWebsite = dataItem.Fw;
if (!fundWebsite || fundWebsite === "") {
profileItem.wd = 'none';
}
else {
if (fundWebsite.indexOf("http") !== 0) {
profileItem.website = "http://" + fundWebsite;
}
else {
profileItem.website = fundWebsite;
}
}
return profileItem;
}
function getRatingData(dataItem) {
var ratingItem = {};
ratingItem.Org = FinanceAppJS.Utils.Formatters.numberFormatter(dataItem.Og, 0);
ratingItem.Og = dataItem.Og;
ratingItem.Rtyr = dataItem.Rtyr ? dataItem.Rtyr : "-";
ratingItem.Rfyr = dataItem.Rfyr ? dataItem.Rfyr : "-";
ratingItem.Rnyr = dataItem.Rnyr ? dataItem.Rnyr : "-";
ratingItem.Or = dataItem.Or ? dataItem.Or : "-";
ratingItem.Tyk = dataItem.Tyk ? dataItem.Tyk : "-";
ratingItem.Fyk = dataItem.Fyk ? dataItem.Fyk : "-";
ratingItem.Nyk = dataItem.Nyk ? dataItem.Nyk : "-";
ratingItem.Ok = dataItem.Ok ? dataItem.Ok : "-";
ratingItem.Tyg = dataItem.Tyg;
ratingItem.Fyg = dataItem.Fyg;
ratingItem.Nyg = dataItem.Nyg;
ratingItem.ticker = dataItem.Fw;
ratingItem.naratorText = utils.getResourceString("MorningStarRatingFor_Al") + ". " + ratingItem.ticker;
return ratingItem;
}
function getAssetData(dataItem) {
var assetItem = {};
assetItem.chart1 = "";
assetItem.chart2 = "";
assetItem.Tkr = dataItem.Tkr;
var sum = 0;
if (dataItem.Ahld) {
var ahld = {};
sum += (ahld.Ust = dataItem.Ahld.Ust ? dataItem.Ahld.Ust : 0);
sum += (ahld.Bnd = dataItem.Ahld.Bnd ? dataItem.Ahld.Bnd : 0);
sum += (ahld.Csh = dataItem.Ahld.Csh ? dataItem.Ahld.Csh : 0);
sum += (ahld.Nust = dataItem.Ahld.Nust ? dataItem.Ahld.Nust : 0);
if (sum < 100) {
ahld.Others = (100 - sum);
}
assetItem.Ahld = ahld;
}
var hld = dataItem.Bhld;
var eHldarray = dataItem.Ehld;
if (dataItem.Bhld) {
var bhld = {};
sum = 0;
for (var i = 0; i < hld.length; i++) {
bhld[hld[i].Hldr] = hld[i].Perc;
sum += hld[i].Perc;
hld[i].Hldr = hld[i].Hldr;
}
if (sum < 100) {
bhld.Others = (100 - sum);
}
assetItem.Bhld = bhld;
}
if (dataItem.Ehld) {
var ehld = {};
sum = 0;
for (var j = 0; j < eHldarray.length; j++) {
ehld[eHldarray[j].Hldr] = eHldarray[j].Perc;
sum += eHldarray[j].Perc;
eHldarray[j].Hldr = eHldarray[j].Hldr;
}
if (sum < 100) {
ehld.Others = (100 - sum);
}
assetItem.Ehld = ehld;
}
if (dataItem.Ft === 0) {
assetItem.chart2 = 'none';
assetItem.hld = assetItem.Ehld;
}
else if (dataItem.Ft === 1) {
assetItem.chart2 = 'none';
assetItem.hld = assetItem.Bhld;
}
else if (dataItem.Ft === 2) {
assetItem.chart1 = 'none';
}
else {
if (assetItem.Bhld && assetItem.Ehld) {
assetItem.chart1 = 'none';
}
else {
assetItem.chart2 = 'none';
assetItem.hld = assetItem.Bhld || assetItem.Ehld;
}
}
if (!assetItem.hld) {
assetItem.chart1Title = 'none';
}
if (!assetItem.Bhld) {
assetItem.chart3Title = 'none';
}
if (!assetItem.Ehld) {
assetItem.chart2Title = 'none';
}
return assetItem;
}
function getHoldingsData(dataItem, x) {
var holdingsItem = [];
if (x === -1) {
holdingsItem[holdingsItem.length] = utils.getResourceString("ETFName");
holdingsItem[holdingsItem.length] = utils.getResourceString("PercentPortfolioWt");
holdingsItem[holdingsItem.length] = utils.getResourceString("FD Change in shares");
holdingsItem[holdingsItem.length] = utils.getResourceString("ETFSharesOwned");
}
else {
holdingsItem[holdingsItem.length] = utils.addLtrMark(dataItem.Hn);
holdingsItem[holdingsItem.length] = utils.addLtrMark(FinanceAppJS.Utils.Formatters.numberFormatter(dataItem.Hp, 2));
holdingsItem[holdingsItem.length] = utils.addLtrMark(FinanceAppJS.Utils.Formatters.numberFormatter(dataItem.Ch, 0));
holdingsItem[holdingsItem.length] = utils.addLtrMark(FinanceAppJS.Utils.Formatters.numberFormatter(dataItem.Tsh, 0));
}
return holdingsItem;
}
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
FundDetailsDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.DataProviderBase, function (options) {
FinanceAppJS.DataProvider.DataProviderBase.call(this, options);
this.entities = options && options.entities;
}, {
queryServiceId: "funddetails",
entities: null,
getQueryServiceParams: function getQueryServiceParams() {
var urlParams = PlatformJS.Collections.createStringDictionary();
urlParams.insert("entities", encodeURIComponent(this.entities));
urlParams.insert("lang", FinanceAppJS.Globalization.getLanguage());
urlParams.insert("localizeFor", FinanceAppJS.Globalization.getMarket());
return urlParams;
},
dataBuilder: function dataBuilder(data, response) {
var dataSet = {}, dt = data[0];
dataSet.overview = getOverviewData(dt);
dataSet.peers = getPeersData(dt);
dataSet.profile = getProfileData(dt);
dataSet.rating = getRatingData(dt);
dataSet.asset = getAssetData(dt);
dataSet.holdings = dt && dt.Hlds && [getHoldingsData(dt, -1)].concat(dt.Hlds.map(getHoldingsData));
if (dataSet && response) {
dataSet.lastUpdateTime = response.lastUpdateTime;
}
//Adding Space between keywords and timestamp
dataSet.portfolioDate = dt && dt.Pdt ? utils.getResourceString("ETFPortfolioDate") + " " + utils.dateFormat(dt.Pdt) : "-";
return dataSet;
}
}, {
})
});
})();