﻿(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
GlobalCurrencyConverter: WinJS.Class.define(function (options) {
this.rawData = options.data;
this.currencyInfo = FinanceAppJS.CurrencyInfo.getCurrencyInfo();
this.from = options.from;
this.to = options.to;
this._dataObj = {};
},
{
_c1value: null,
_c2value: null,
_dataObj: null,
_textOne: null,
_textTwo: null,
rawData: null,
from: null,
to: null,
getDataAndBindings: function getDataAndBindings() {
var map = {};
try {
for (var i = 0; i < this.rawData.length; i++) {
map[this.rawData[i].An] = i;
}
var defaultLeft;
var defaultRight;
if (typeof map[this.from] === 'undefined') {
defaultLeft = FinanceAppJS.CurrencyFlatRates.DefaultCurrency();
defaultRight = FinanceAppJS.CurrencyFlatRates.CurrencyRight();
}
else {
defaultLeft = this.from;
defaultRight = this.to;
}
var defaultAmount = FinanceAppJS.CurrencyFlatRates.DefaultAmount();
var defaultRatio = this.rawData[map[defaultRight]].Rt / this.rawData[map[defaultLeft]].Rt;
var bindingObject = {};
bindingObject.c1 = CollectionProvider.Formatters.formatNumberWithoutSeparator(defaultAmount, 2);
this._c1value = defaultAmount;
bindingObject.r1 = defaultLeft;
bindingObject.r2 = defaultRight;
bindingObject.s1 = this.currencyInfo[defaultLeft].symbol;
bindingObject.s2 = this.currencyInfo[defaultRight].symbol;
bindingObject.ticker1 = defaultLeft;
bindingObject.ticker2 = defaultRight;
bindingObject.data = this.rawData;
bindingObject.map = map;
bindingObject.c2 = CollectionProvider.Formatters.formatNumberWithoutSeparator((defaultRatio * parseFloat(this._c1value)), 2);
this._c2value = bindingObject.c2;
bindingObject.msg1 = this.showConversionRate(defaultLeft, defaultRatio, defaultRight);
bindingObject.msg2 = this.showConversionRate(defaultRight, 1 / defaultRatio, defaultLeft);
var that = this;
bindingObject.r1changed = WinJS.Utilities.markSupportedForProcessing(function (e) {
that._dataObj.r1 = e.target.value;
that.listconvert(that._dataObj.r1, that._dataObj.r2, map, 1);
});
bindingObject.r2changed = WinJS.Utilities.markSupportedForProcessing(function (e) {
that._dataObj.r2 = e.target.value;
that.listconvert(that._dataObj.r1, that._dataObj.r2, map, 2);
});
bindingObject.c1changed = WinJS.Utilities.markSupportedForProcessing(function (e) {
that._c1value = CollectionProvider.Formatters.parseNumber(e.target.value);
that.convert(that._dataObj.r1, that._dataObj.r2, that._c1value, that._dataObj.c2, map, 2);
});
bindingObject.c2changed = WinJS.Utilities.markSupportedForProcessing(function (e) {
that._c2value = CollectionProvider.Formatters.parseNumber(e.target.value);
that.convert(that._dataObj.r1, that._dataObj.r2, that._dataObj.c1, that._c2value, map, 1);
});
}
catch (e) {
FinanceAppJS.Telemetry.FlightRecorder.LogErrorEvent(e.message, e.stack);
console.log(e);
}
this._dataObj = WinJS.Binding.as(bindingObject);
return this._dataObj;
},
convert: function convert(r1, r2, c1, c2, map, num) {
// For text box alone binding does not work and we neeed to directly manipulate the DOM :
// 1. If the bindable object is immediately changed to the user typed value, the cursor will race to the end
// 2. If we cache the user typed value instead of updating bindable object, if user enters same number again, the value would not change and it would not update
// (since the notifications are raised only if the value changes - Bug no: 331376)
// The fix is to cache the user typed value in a variable and update the DOM directly instead of updating the bindable object, so that both cases 1 and 2 are solved
var from, to, amount;
if (num === 1) {
from = r2;
to = r1;
amount = c2;
this._textOne = this.textOne || document.querySelector('.txtBoxOne');
var txtBoxOne = this._textOne;
if (txtBoxOne) {
txtBoxOne.value = CollectionProvider.Formatters.formatNumberWithoutSeparator(((this.rawData[map[to]].Rt / this.rawData[map[from]].Rt) * amount), 2);
}
}
else {
from = r1;
to = r2;
amount = c1;
this._textTwo = this._textTwo || document.querySelector('.txtBoxTwo');
var txtBoxTwo = this._textTwo;
if (txtBoxTwo) {
txtBoxTwo.value = CollectionProvider.Formatters.formatNumberWithoutSeparator(((this.rawData[map[to]].Rt / this.rawData[map[from]].Rt) * amount), 2);
}
}
},
/// <summary>
/// changes the values of textbox and the rates displayed when the selection in dropdown is changed
/// </summary>
listconvert: function listconvert(r1, r2, map, num) {
var ratio = this.rawData[map[r2]].Rt / this.rawData[map[r1]].Rt;
var reverseRatio = 1 / ratio;
if (num === 1) {
this._dataObj.s1 = this.currencyInfo[r1].symbol;
}
else {
this._dataObj.s2 = this.currencyInfo[r2].symbol;
}
this._dataObj.msg1 = this.showConversionRate(r1, ratio, r2);
this._dataObj.msg2 = this.showConversionRate(r2, reverseRatio, r1);
this._textOne = this.textOne || document.querySelector('.txtBoxOne');
this._textTwo = this._textTwo || document.querySelector('.txtBoxTwo');
if (this._textOne && this._textTwo) {
this.convert(r1, r2, CollectionProvider.Formatters.parseNumber(this._textOne.value), CollectionProvider.Formatters.parseNumber(this._textTwo.value), map, num);
}
},
showConversionRate: function showConversionRate(leftCurrency, rate, rightCurrency) {
//ISO codes are the same for all languages. Should not be localized
return utils.addLtrMark(FinanceAppJS.Utils.Formatters.numberFormatter(1, 0) + " " + leftCurrency + " = " + FinanceAppJS.Utils.Formatters.numberFormatter(rate, 4) + " " + rightCurrency);
}
})
});
})();
