﻿(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
IndexDetails: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
FinanceAppJS.FinanceBasePage.call(this, state);
var pageState = state;
var entityObj = {};
if (pageState && pageState.entity) {
entityObj = pageState.entity;
}
// no symbol then just kick off
if (!entityObj || !entityObj.indexSymbol) {
// TODO - log an error message that Index symbol was not found - this return will crash the application
return;
}
// sym from the world market is not complete - get the complete symbol for any index to enable chart data
this.idxSymbol = FinanceAppJS.Globalization.getCompleteIndexSymbol(entityObj.indexSymbol);
var idxInfo = FinanceAppJS.Globalization.getIndexInfo(this.idxSymbol);
if (!idxInfo) {
// TODO: if all indices are present in IndicesInfo.json - you should remove this code.
this.commonName = utils.getResourceString(entityObj.displayName);
this.countryname = "";
this.idxCode = "";
this.pageTitle = this.commonName;
} else {
this.countryName = utils.getResourceString(idxInfo.countryname);
this.idxCode = idxInfo.code;
this.commonName = utils.getResourceString(idxInfo.displayName);
this.pageTitle = this.idxCode + " (" + this.countryName + "), " + this.commonName;
}
this.pageTitle = this.commonName;
this.entityObj = entityObj;
this.entityTitle = entityObj.displayName;
// get short name, complete name, country code
// commented for the time being - till more robust logic for finding EOD index exits
//this.isEOD = utils.isEODInstrument(entityObj.E1, false);  // Change the logic or whatever it is
this.isEOD = false;
this.exchangeCode = entityObj.E2;
this.isEOD = utils.isEODInstrument(entityObj.indexSymbol);
this.isUSExchange = FinanceAppJS.Globalization.isUSExchange(this.exchangeCode);
var that = this;
this.roaming = new FinanceAppJS.Roaming;
var clusterDefinitions = {
overviewCluster: {
// hide title display .... 
clusterTitle: utils.getResourceString("Chart"),
clusterControl: "FinanceAppJS.IndexDetailsPage.IndexOverviewCluster",
supressTitleInHeader: true,
dataProviders: {
IndexEntityOverviewDataProvider: { symbolsCsv: this.idxSymbol, isUSExchange: this.isUSExchange, cmpName: this.entityTitle, refreshInterval: this.isEOD ? 0 : FinanceAppJS.Constants.RefreshIntervals.HomePageEquityData },
StockChartDataProvider: { instrumentType: "stock", stockSymbol: this.idxSymbol, isEOD: this.isEOD, duration: this.isEOD ? "1m" : "1d", refreshInterval: this.isEOD ? 0 : FinanceAppJS.Constants.RefreshIntervals.HomePageEquityData },
},
primaryProviders: "IndexEntityOverviewDataProvider",
clusterOptions: {
instrumentType: "stock",
isEOD: this.isEOD,
isUSExchange: this.isUSExchange,
moduleInfo: {
fragmentPath: "/pages/IndexDetails/html/IndexDetailsTemplates.html",
templateId: "tmplEntityMain",
}
}
},
marketMoversCluster: {
clusterTitle: utils.getResourceString("IndexMovers"),
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.Mov && (data.Mov.active || data.Mov.gainers || data.Mov.losers);
},
clusterControl: "FinanceAppJS.HomePage.MarketMoversCluster",
dataProviders: {
IndexConstituentsDataProvider: { marketSymbol: this.idxSymbol }
},
clusterOptions: {
stockModuleInfo: {
fragmentPath: "/pages/IndexDetails/html/IndexDetailsTemplates.html",
templateId: "marketMoversItemTemplate", height: 1, width: 1, isInteractive: false,
},
onrendercomplete: function onrendercomplete() {
msSetImmediate(function () {
//Bind aria-labels to respective win-item in watchlist.
var markWatchListObj = document.querySelector(".MarketMoversCluster");
if (markWatchListObj) {
var watchListItems = markWatchListObj.querySelectorAll(".win-template");
if (watchListItems && watchListItems.length > 0) {
utils.addCustomAriaLabelToTiles(watchListItems, "naratorText");
}
if (true) {
var marketMoverHeaders = markWatchListObj.querySelectorAll(".moversHeaderTemplate");
/*Bug Fix - 206045, we don't need headers to have tabIndex and and list should have aria-label*/
if (marketMoverHeaders) {
var setMoverListItem = true;
for (var index = 0; index < marketMoverHeaders.length; index++) {
if (marketMoverHeaders[index].parentElement) {
marketMoverHeaders[index].parentElement.tabIndex = -1;
var moverListElements = marketMoverHeaders[index].parentElement.querySelector(".financeMoversInnerList");
if (moverListElements.childElementCount > 0) {
moverListElements.children[0].tabIndex = 0;
}
}
}
}
that._isMMClusterRenderedOnce = true;
}
}
});
},
}
},
constituentCluster: {
clusterTitle: utils.getResourceString("IndexConstituents"),
clusterControl: "FinanceAppJS.Controls.TableCluster",
dataProviders: {
IndexConstituentsDataProvider: { marketSymbol: this.idxSymbol }
},
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.Cts && data.Cts.length > 1;
},
clusterOptions: {
columnTemplates: ["tmpl_ticker", "tmpl_tickername", "tmpl_price", "tmpl_changep"].map(PlatformJS.Utilities.getControl),
dataKey: ["Cts"],
stickyHeader: true,
summary: utils.getResourceString("IndexConstituents"),
className: "IndexConstituents",
rowClickCallback: function rowClickCallback(data) {
var instrumentID = FinanceAppJS.Constants.Instrumentation.Index_IndexConstituents_Click;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.INDEXDETAILS,
FinanceAppJS.Telemetry.Constants.Cluster.CONSTITUENT,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
data[4].Cmp);
var state = {};
state.entity = data[4];
navigationHelper.navigateToEntityPage(state, instrumentID);
},
onrendercomplete: function onrendercomplete() {
FinanceAppJS.Utils.Navigator.enableArrowKeyAccessibilty();
}
}
}
};
this.setClusterDefinitions(clusterDefinitions);
}, {
pinUnpinManager: null,
/// <summary>
/// This function is invoked by the UX Framework when the data binding is complete
/// </summary>
/// <returns>
/// Nothing
/// </returns>
onBindingComplete: function onBindingComplete() {
FinanceAppJS.FinanceBasePage.prototype.onBindingComplete.call(this);
// Setup actions for bottom edgy
var btmEdgy = document.querySelector("#indexDetailsActionEdgy");
// set up ad to watch list button on the bottom edgy swipe
this.btnManage = btmEdgy.querySelector("#btnStkManage");
var isRoamingEntryExists = this.roaming.isWatchListEntryExists(this.idxSymbol, FinanceAppJS.Constants.IDs.Index);
WatchListManage.toggleEdgyLabels(isRoamingEntryExists, this.btnManage);
var options = {
symbol: this.idxSymbol,
type: FinanceAppJS.Constants.IDs.Index,
isEntryExists: isRoamingEntryExists,
elm: this.btnManage,
actionBar: btmEdgy,
name: this.pageTitle,
roamingObj: this.roaming
};
this.edgyBtnClickHandler = WatchListManage.addOrRemoveFromEdgy.bind(null, options);
this.btnManage.addEventListener("click", this.edgyBtnClickHandler);
this.pinUnpinManager = new FinanceAppJS.PinUnpinManager(btmEdgy, this.getPageState(), FinanceAppJS.Constants.IDs.Index, this.idxSymbol, this.pageTitle, this.entityObj.displayName, null, null, FinanceAppJS.Constants.Instrumentation.PinStart_Quote_Click);
},
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away
/// </summary>
/// <param name="reason">
/// The reason why the page is being navigated away: "backNavigation" or "newNavigation"
/// </param>
/// <returns>
/// Nothing
/// </returns>
onNavigateAway: function onNavigateAway(reason) {
FinanceAppJS.FinanceBasePage.prototype.onNavigateAway.call(this);
var chartControlDiv = document.querySelector(".entityChart");
if (chartControlDiv) {
var chartControl = chartControlDiv.winControl;
if (chartControl) {
chartControl.dispose();
}
}
if (this.pinUnpinManager) {
this.pinUnpinManager.clean();
}
if (this.btnManage && this.edgyBtnClickHandler) {
this.btnManage.removeEventListener("click", this.edgyBtnClickHandler);
this.btnManage = null;
}
},
onVisibilityChanged: function onVisibilityChanged(e) {
// TODO: if required, put the code here, 
},
getSharedContractData: function getSharedContractData() {
var dataProvider = this.getDataProvider("IndexEntityOverviewDataProvider");
return utils.getSharedContractDataForStocks(dataProvider, this.entityObj, this.exchangeName, this._lastUpdatedTime, "index");
},
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Index details page";
},
getCurrentContent: function getCurrentContent() {
var content = {
Symbol: this.idxSymbol,
Page: FinanceAppJS.Telemetry.Constants.Page.INDEXDETAILS,
};
return content;
},
onPageLoadComplete: function onPageLoadComplete() {
FinanceAppJS.Telemetry.FlightRecorder.LogSearchEventFromResultPage();
FinanceAppJS.FinanceBasePage.prototype.onPageLoadComplete.call(this);
var content = this.getCurrentContent();
FinanceAppJS.Telemetry.FlightRecorder.LogContentView(content);
},
},
{})
});
})();
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.IndexDetailsPage",
{
/// <summary>
/// Cluster with Chart as view for stock quotes
/// </summary>
IndexOverviewCluster: WinJS.Class.derive(FinanceAppJS.Controls.BaseOverviewCluster, function (domElement, options) {
this._rangeSelectors = options.isEOD ? ['1m', '1y', '5y'] : options.isUSExchange ? ['1d', '5d', '1m', '1y', '5y', 'max'] : ['1d', '5d', '1m', '1y', '5y'];
FinanceAppJS.Controls.BaseOverviewCluster.call(this, domElement, options);
// set options
WinJS.UI.setOptions(this, options);
},
{
update: function update(data, providerName) {
switch (providerName) {
case 'IndexEntityOverviewDataProvider':
var that = this;
if (data && data.Eqsm) {
this.displayName = data.Eqsm;
}
else {
this.displayName = "-";
}
if (data) {
this.equityUpdateTime = data.lastUpdateTime;
}
this.realtimeQuotesLastUpdatedTimeString = data.dateTime;
return FinanceAppJS.Controls.ModuleClusterControl.prototype.update.call(this, data).then(function () {
var quoteSearchButton = document.querySelectorAll(".quoteSearchglyphParent");
if (quoteSearchButton.length > 0) {
for (var index = 0; index < quoteSearchButton.length; index++) {
quoteSearchButton[index].addEventListener("MSLostPointerCapture", PlatformJS.Utilities.pointerEventListenersMap["MSLostPointerCapture"], false);
quoteSearchButton[index].addEventListener("MSPointerCancel", PlatformJS.Utilities.pointerEventListenersMap["MSPointerCancel"], false);
quoteSearchButton[index].addEventListener("MSPointerUp", PlatformJS.Utilities.pointerEventListenersMap["MSPointerUp"], false);
quoteSearchButton[index].addEventListener("MSPointerDown", PlatformJS.Utilities.pointerEventListenersMap["MSPointerDown"], false);
quoteSearchButton[index].addEventListener("MSPointerOut", PlatformJS.Utilities.pointerEventListenersMap["MSPointerOut"], false);
}
}
return that.performPendingUpdate();
});
case 'StockChartDataProvider':
return this.updateChart(data);
}
},
}, {
})
});
})();