﻿var _gSelectedItemCountPrev = 0;
var _gSelectedItemCountCurrent = 0;
var _gNowItemSelected = false;
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
MarketToday: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
/// <summary>
/// Constructor for a simple IPage class that controls the FundFilmStrip
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
FinanceAppJS.FinanceBasePage.call(this, state);
_gSelectedItemCountPrev = 0;
_gSelectedItemCountCurrent = 0;
_gNowItemSelected = false;
var showDisclaimer = false;
this.showDisclaimer = FinanceAppJS.Globalization.getBATSDisclaimerFlag();
this.roaming = new FinanceAppJS.Roaming;
this.watchListCount = this.roaming.getWatchlistCount();
this.pageType = FinanceAppJS.Constants.IDs.MarketToday;
var videoStateToPass = {
provider: "VideoEntityPanoProvider",
pageTitle: "Videos",
panoId: "EntityVideosPano",
singleCluster: false,
collectionId: null
};
var moneyStateToPass = {
provider: "MoneyEntityPanoProvider",
pageTitle: "chMoney",
panoId: "EntityMoneyPano",
singleCluster: false,
collectionId: null
};
var HeaderSelectionCallbacks = {
indexChartCluster: function indexChartCluster() {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.INDEXCHART,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERHEADER,
"");
navigationHelper.navigateToMarketPage(null, "MarketToday_MarketClusterHeader_Click");
},
myStocksCluster: function myStocksCluster() {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.WATCHLIST,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERHEADER,
"");
navigationHelper.navigateToMyStocksPage(null, "MarketToday_MyStocksHeader_Click");
},
videoItemsCluster: function videoItemsCluster() {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.VIDEO,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERHEADER,
"");
navigationHelper.navigateToEntityVideosPano(videoStateToPass, "MarketToday_VideoClusterHeader");
},
moneyItemsCluster: function moneyItemsCluster() {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.MONEY,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERHEADER,
"");
navigationHelper.navigateToEntityMoneyPano(moneyStateToPass, "MarketToday_MoneyClusterHeader_Click");
},
toolsCluster: function toolsCluster() {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.TOOLITEMS,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERHEADER,
"");
navigationHelper.navigateToToolsPage({}, "MarketToday_ToolsClusterHeader_Click");
}
};
if (Platform.Utilities.Globalization.isFeatureEnabled("EntityNews")) {
var stateToPass = {};
stateToPass.provider = "EntityPanoProvider";
stateToPass.pageTitle = "chNews";
stateToPass.panoId = "EntityNewsPano";
stateToPass.singleCluster = false;
stateToPass.collectionId = null;
HeaderSelectionCallbacks.bussNewsCluster = function () {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.NEWS,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERHEADER,
"");
navigationHelper.navigateToEntityNewsPano(stateToPass, "MarketToday_NewsClusterHeader_Click");
};
} else if (Platform.Utilities.Globalization.isFeatureEnabled("NewsPano")) {
HeaderSelectionCallbacks.bussNewsCluster = function () {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.NEWS,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERHEADER,
"");
navigationHelper.navigateToNewsPage(null, "MarketToday_NewsClusterHeader_Click");
};
}
var ItemClickCallbacks = {
bussNewsCluster: function bussNewsCluster(event) {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.MarketToday_NewsCluster_Click, 1);
var item = event.item;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.NEWS,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
item.contentid);
utils.launchNewsUri(item, Platform.Instrumentation.InstrumentationEditorialSourceId.cluster);
},
moneyItemsCluster: function moneyItemsCluster(event) {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.MarketToday_MoneyCluster_Click, 1);
var item = event.item;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.MONEY,
FinanceAppJS.Telemetry.Constants.Location.NEWSITEM,
item);
utils.launchNewsUri(item, Platform.Instrumentation.InstrumentationEditorialSourceId.cluster);
},
acrossMarketCluster: function acrossMarketCluster(event) {
var item = event.detail.item.data, func;
var type = item.classToAppend.charAt(0).toUpperCase() + item.classToAppend.slice(1);
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.ACROSSMARKET,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
type);
(func = navigationHelper["navigateTo" + type + "Page"]) && func(null, "MarketToday_AcrossMarket_" + type + "_Click");
}
};
var that = this;
var bussNewsDataProviders = {};
var videoItemsDataProviders = {};
var moneyItemsDataProviders = {};
var featuredArticlesDataProviders = {};
var EditorialNewsDataProviderOptions = { isPreview: FinanceAppJS.Settings.cmsPreviewEnabled };
if (Platform.Utilities.Globalization.isFeatureEnabled("NewsFromCMSEditorial")) {
bussNewsDataProviders.EditorialNewsDataProvider = EditorialNewsDataProviderOptions;
videoItemsDataProviders.EditorialNewsDataProvider = EditorialNewsDataProviderOptions;
featuredArticlesDataProviders.EditorialNewsDataProvider = EditorialNewsDataProviderOptions;
}
if (Platform.Utilities.Globalization.isFeatureEnabled("EntityMoney")) {
moneyItemsDataProviders.EditorialNewsDataProvider = EditorialNewsDataProviderOptions;
}
if (utils.isMarketSupportedForBingNews()) {
bussNewsDataProviders.BingNewsDataProvider = { queryType: "category" };
}
var sources = {};
sources.TodaySourcesDataProvider = { featuredCategory: "MoreSources_News" };
var indicesConfig = utils.getDefaultConfigForIndices();
var equityDataProviderOptions = FinanceAppJS.DataProvider.EquityDataProvider.getDefaultProviderOptions(this.roaming);
var clusterDefinitions = {
newsCluster: {
clusterTitle: utils.getResourceString("chToday"),
semanticZoomTitle: utils.getResourceString("SemanticZoomHeroClusterTitle"),
clusterControl: "FinanceAppJS.HomePage.HeroImageCluster",
dataProviders: {
EquityDataProvider: equityDataProviderOptions,
EditorialNewsDataProvider: EditorialNewsDataProviderOptions,
},
primaryProviders: "EditorialNewsDataProvider",
postDataValidateFunc: function postDataValidateFunc(data, providerName) {
return (providerName !== 'EditorialNewsDataProvider' || (data.heroCluster && data.heroCluster.image.url !== null)) ? 'success' : 'error';
},
validateFunc: function validateFunc() {
return Platform.Utilities.Globalization.isFeatureEnabled("NewsFromCMSEditorial");
},
hideTitle: true,
pinned: true, // re-order of cluster is prevented.
supressTitleInHeader: true,
titleClass: "headerFontLight",
statusNotifierCallback: function statusNotifierCallback(status) {
var elem = document.querySelector(".platformMainContent");
if (elem && elem.winControl) {
switch (status) {
case 'Add':
elem.winControl.showInertiaBackground = true;
that.showInertiaBackground = true;
WinJS.Utilities.addClass(elem, "platformPanoramaFlushLeft");
break;
case 'Remove':
elem.winControl.showInertiaBackground = false;
that.showInertiaBackground = false;
WinJS.Utilities.removeClass(elem, "platformPanoramaFlushLeft");
break;
}
}
}
},
indexChartCluster: {
clusterTitle: utils.getResourceString("Market_Pano"),
onHeaderSelection: HeaderSelectionCallbacks.indexChartCluster,
clusterControl: "FinanceAppJS.HomePage.IndexChartCluster",
dataProviders: {
StockChartDataProvider: { instrumentType: "stock", stockSymbol: indicesConfig.chartDefaultSymbol, duration: indicesConfig.chartDefaultDuration, isEOD: indicesConfig.isEOD, refreshInterval: indicesConfig.isEOD ? 0 : FinanceAppJS.Constants.RefreshIntervals.HomePageEquityData },
EquityDataProvider: equityDataProviderOptions
},
primaryProviders: "EquityDataProvider",
clusterOptions: {
instrumentType: "index",
isEOD: indicesConfig.isEOD,
moduleInfo: { renderer: FinanceAppJS.Renderers.TodayIndexChart },
}
},
bussNewsCluster: {
clusterTitle: utils.getResourceString("chNews"),
onHeaderSelection: HeaderSelectionCallbacks.bussNewsCluster,
clusterControl: Object.keys(bussNewsDataProviders).length === 1 ? "FinanceAppJS.NewsControls.EntityControl" : "FinanceAppJS.NewsControls.NewsMergedCluster",
dataProviders: bussNewsDataProviders,
validateFunc: function validateFunc() {
return utils.isNonEmptyObject(bussNewsDataProviders);
},
clusterOptions: {
mode: CommonJS.News.ClusterMode.static,
maxColumnCount: FinanceAppJS.Constants.NewsCluster.NewsClusterMaxColumnCount,
onitemclick: ItemClickCallbacks.bussNewsCluster,
instrumentationEntryPoint: Platform.Instrumentation.InstrumentationArticleEntryPoint.homePano,
},
},
videoItemsCluster: {
clusterTitle: utils.getResourceString("Videos"),
onHeaderSelection: HeaderSelectionCallbacks.videoItemsCluster,
clusterControl: "FinanceAppJS.NewsControls.EntityControl",
dataProviders: videoItemsDataProviders,
validateFunc: function validateFunc() {
return utils.isNonEmptyObject(videoItemsDataProviders);
},
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.videoItems && data.videoItems.length > 0;
},
clusterOptions: {
mode: CommonJS.News.ClusterMode.static,
maxColumnCount: 3,
dataField: "videoItems",
theme: "financeAppTheme",
instrumentationEntryPoint: Platform.Instrumentation.InstrumentationArticleEntryPoint.homePano
},
},
moneyItemsCluster: {
clusterTitle: utils.getResourceString("chMoney"),
onHeaderSelection: HeaderSelectionCallbacks.moneyItemsCluster,
clusterControl: "FinanceAppJS.NewsControls.EntityControl",
dataProviders: moneyItemsDataProviders,
validateFunc: function validateFunc() {
return utils.isNonEmptyObject(moneyItemsDataProviders);
},
//Known issue: After app upgrade from previous versions, users wont see money cluster for the first time, as cache wont have it 
//and post-validate will remove the cluster during progress of the call
//and it won't be added again into the pano after the real call completes
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.moneyItems && data.moneyItems.length > 0;
},
clusterOptions: {
mode: CommonJS.News.ClusterMode.static,
maxColumnCount: FinanceAppJS.Constants.NewsCluster.NewsClusterMaxColumnCount,
dataField: "moneyItems",
configKey: "EntityClusterDefaultMoneyConfig",
configObject: FinanceAppJS.EntityClusterConfig.MoneyCluster,
onitemclick: ItemClickCallbacks.moneyItemsCluster,
instrumentationEntryPoint: Platform.Instrumentation.InstrumentationArticleEntryPoint.homePano,
},
},
todaySourcesCluster: {
clusterTitle: utils.getResourceString("MORE_NEWS_FROM"),
clusterControl: "FinanceAppJS.EntityPano.MoreSourcesCluster",
dataProviders: sources,
validateFunc: function validateFunc() {
return utils.isNonEmptyString(Platform.Configuration.ConfigurationManager.getMarketStringForEditorial());
},
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.length > 0;
},
clusterOptions: {
className: "platformListLayout",
clickInstrumentationID: FinanceAppJS.Constants.Instrumentation.Today_FeaturedCluster_ItemClick,
}
},
featuredArticlesCluster: {
clusterTitle: utils.getResourceString("chMagazineArticles"),
clusterControl: "FinanceAppJS.NewsControls.EntityControl",
dataProviders: featuredArticlesDataProviders,
validateFunc: function validateFunc() {
var enableFeaturedArticles = PlatformJS.Services.appConfig.getBool("EnableFeaturedArticlesCluster");
return enableFeaturedArticles;
},
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.magazineItems && data.magazineItems.length > 0;
},
clusterOptions: {
mode: CommonJS.News.ClusterMode.static,
maxColumnCount: null,
dataField: "magazineItems",
onitemclick: ItemClickCallbacks.bussNewsCluster,
},
},
myStocksCluster: {
clusterTitle: this.watchListCount > utils.getHomePageWLDisplayCount() ? WatchListManage.getTitleWithCount(this.watchListCount) : utils.getResourceString("chMyStocks"),
onHeaderSelection: HeaderSelectionCallbacks.myStocksCluster,
clusterControl: "FinanceAppJS.HomePage.MyStocksCluster",
clusterOptions: {
roamingObject: this.roaming,
className: "watchlistCluster",
// TODO: Looks like onrendercomplete is being called for every item container. Should be fixed in base controller/provider.
onrendercomplete: function onrendercomplete(event) {
that._addEventListenersForListView();
msSetImmediate(function () {
//Bind aria-labels to respective win-item in watchlist.
var markWatchListObj = document.querySelector(".watchlistCluster");
if (markWatchListObj) {
var watchListItems = markWatchListObj.querySelectorAll(".win-item");
if (watchListItems && watchListItems.length > 0) {
if (!that._isWatchlistClusterRenderedOnce) {
//Add keydown event to listview. and override the left and right arrow key functionality.
var index = 0;
while (index < watchListItems.length) {
watchListItems[index].addEventListener("keydown", function (e) {
if (e.keyCode === WinJS.Utilities.Key.rightArrow || e.keyCode === WinJS.Utilities.Key.leftArrow) {
var oldFocus = that.listElmWin._getCurrentItem()._value.item.index;
WinJS.Promise.join([that.listElmWin._dataSource._list._currentKey, that.listElmWin.layout.getKeyboardNavigatedItem(oldFocus, null, e.keyCode)]).then(function (params) {
var maxCount = params[0],
newFocus = params[1];
if (newFocus === oldFocus || newFocus < 0 || newFocus >= maxCount) {
// Move focus here
if (e.keyCode === WinJS.Utilities.Key.rightArrow || e.keyCode === WinJS.Utilities.Key.pageDown) {
CommonJS.NavigableView.dispatchBoundaryEvent(e.srcElement, CommonJS.NavigableView.Direction.RIGHT);
}
else if (e.keyCode === WinJS.Utilities.Key.leftArrow || e.keyCode === WinJS.Utilities.Key.pageUp) {
CommonJS.NavigableView.dispatchBoundaryEvent(e.srcElement, CommonJS.NavigableView.Direction.LEFT);
}
}
});
}
}, true);
index++;
}
that._isWatchlistClusterRenderedOnce = true;
}
//add customw narator text
utils.addCustomAriaLabelToTiles(watchListItems, "naratorText");
}
}
});
},
},
dataProviders: {
EquityDataProvider: equityDataProviderOptions
},
},
toolsCluster: {
clusterTitle: utils.getResourceString("chTools"),
//isLastCluster: true,
onHeaderSelection: HeaderSelectionCallbacks.toolsCluster,
clusterControl: "FinanceAppJS.Controls.ToolsCluster",
clusterOptions: {
className: "platformListLayout",
}
},
acrossMarketCluster_CC: {
clusterTitle: utils.getResourceString("ChAcross Market"),
clusterControl: "FinanceAppJS.Controls.ItemsCluster",
dataProviders: "AcrossMarketCCDataProvider",
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.length > 1 && (data[0].data || data[1].data);
},
clusterOptions: {
itemTemplate: {
fragmentPath: "/pages/MarketToday/html/MarketTodayTemplates.html",
templateId: "AcrossMarket_CC"
},
className: "platformListLayout",
onitemclick: ItemClickCallbacks.acrossMarketCluster,
interactiveItemClickHandler: ItemClickCallbacks.acrossMarketClusterETF,
}
},
acrossMarketCluster: {
clusterTitle: utils.getResourceString("ChAcross Market"),
clusterControl: "FinanceAppJS.Controls.AcrossMarketCluster",
dataProviders: {
AcrossMarketDataProvider: {},
HomeRatesDataProvider: {},
},
postDataValidateFunc: function postDataValidateFunc(data) {
return data && (data.AcrossMarketDataProvider || data.HomeRatesDataProvider);
},
clusterOptions: {
className: "platformListLayout acrossMarketCluster",
itemTemplate: {
fragmentPath: "/pages/MarketToday/html/MarketTodayTemplates.html",
templateId: "AcrossMarketTemplate"
},
collateProviderData: true,
onitemclick: ItemClickCallbacks.acrossMarketCluster,
interactiveItemClickHandler: ItemClickCallbacks.acrossMarketClusterETF,
}
},
};
clusterDefinitions.gettingStartedCluster = utils.getTempClusterConfig();
clusterDefinitions.nextStepsCluster = utils.getNextStepsClusterConfig();
this.setClusterDefinitions(clusterDefinitions);
this.setPageTimeUpdateDataProvider("EquityDataProvider");
this.showCMSPreviewButton();
this.pageTitle = utils.getResourceString("BingAppTitle");
}, {
_isMMClusterRenderedOnce: false,
_isWatchlistClusterRenderedOnce: false,
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Today";
},
showCMSPreviewButton: function showCMSPreviewButton() {
var previewButton, editorialNewsProvider;
// Dependent on the Platform team to disable this flag (PlatformJS.isDebug=false) for app store submission
if (!PlatformJS.isDebug || !(previewButton = PlatformJS.Utilities.getControl("previewButton"))) {
return;
}
editorialNewsProvider = this.getDataProvider("EditorialNewsDataProvider");
var gettingStartedProvider = this.getDataProvider("TempClusterProvider");
var nextStepsProvider = this.getDataProvider("NextStepsClusterProvider");
if (!(editorialNewsProvider)) {
return;
}
var cmsPreviewButton = document.getElementById("cmsPreviewButton");
if (cmsPreviewButton) {
WinJS.Utilities.removeClass(cmsPreviewButton, "hide");
}
previewButton.label = utils.getResourceString(FinanceAppJS.Settings.cmsPreviewEnabled ? "PreviewOff" : "PreviewOn");
previewButton.onclick = function () {
FinanceAppJS.Settings.cmsPreviewEnabled = !FinanceAppJS.Settings.cmsPreviewEnabled;
// Set isPreview for Editorial News Cluster and Provider
if (editorialNewsProvider) {
editorialNewsProvider.isPreview = FinanceAppJS.Settings.cmsPreviewEnabled;
editorialNewsProvider.forceRefresh();
}
if (gettingStartedProvider) {
gettingStartedProvider.isPreview = FinanceAppJS.Settings.cmsPreviewEnabled;
gettingStartedProvider.forceRefresh();
}
if (nextStepsProvider) {
nextStepsProvider.isPreview = FinanceAppJS.Settings.cmsPreviewEnabled;
nextStepsProvider.forceRefresh();
}
previewButton.label = utils.getResourceString(FinanceAppJS.Settings.cmsPreviewEnabled ? "PreviewOff" : "PreviewOn");
};
},
onVisibilityChanged: function onVisibilityChanged() {
if (document.msVisibilityState === "visible") {
if (this.listElmWin) {
var selection = this.listElmWin.selection;
if (selection && selection._selected) {
var selectedItemsCount = selection.count();
var pupm = this.pinUnpinManager;
if (selectedItemsCount === 1) {
selection.getItems().then(function (items) {
if (items && items.length === 1) {
var selectedItem = items[0].data.tileData;
pupm.updateBottomSwipyPinButtons(utils.getGlobalInstrumentSymbol(selectedItem), selectedItem.type);
}
});
}
}
}
}
},
onNavigateAway: function onNavigateAway(reason) {
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away
/// </summary>
/// <param name="reason">
/// The reason why the page is being navigated away: "backNavigation" or "newNavigation"
/// </param>
/// <returns>
/// Nothing
/// </returns>
var chartControlDiv = document.querySelector(".chartContainer");
FinanceAppJS.FinanceBasePage.prototype.onNavigateAway.call(this);
if (this.pinUnpinManager) {
this.pinUnpinManager.clean();
}
// Release quick search internal variables.
FinanceAppJS.Utilities.QuickSearch.getInstance().release();
},
_initializedOnce: false,
pinUnpinManager: null,
_addEventListenersForListView: function _addEventListenersForListView() {
/// <summary>Initialize the Bottom swipy buttons and do it only once.</summary>
/// <summary>No need to do it on subsequent updates</summary>
var that = this;
var listElm = that.getClusterControl("myStocksCluster");
if (this._initializedOnce) {
if (listElm && this.listElm !== listElm) {
this.listElm = listElm;                        
var btnClearSelection = document.getElementById("btnClearSelection");
var optionItem = {};
optionItem.PageId = FinanceAppJS.Constants.IDs.MarketToday;
this.listElmWin = listElm.view;
FinanceAppJS.Utilities.QuickSearch.getInstance().init(this.listElmWin, FinanceAppJS.Constants.IDs.MarketToday);
WatchListManage.attachBasicListEvents(this, listElm, btnClearSelection,  null, false, null, optionItem, false);
}
return;
}
this.listElm = listElm;
var bottomEdgy = document.querySelector("#bottomAppbar");
if (listElm && listElm.clusterItems && bottomEdgy) {
var listElmWin = listElm.view;
this.listElmWin = listElmWin;
FinanceAppJS.Utilities.QuickSearch.getInstance().init(this.listElmWin, FinanceAppJS.Constants.IDs.MarketToday, this.getDataProvider("EquityDataProvider"));                    
var btnClearSelection = document.getElementById("btnClearSelection");
this.bottomEdgy = bottomEdgy;
//add Instrumentation ids for item click.
var optionItem = {};
optionItem.PageId = FinanceAppJS.Constants.IDs.MarketToday;
WatchListManage.attachBasicPageEvents(this, listElm, btnClearSelection, null, false, null, optionItem);
WatchListManage.attachBasicListEvents(this, listElm, btnClearSelection, false, null, optionItem, false);
this.pinUnpinManager = new FinanceAppJS.PinUnpinManager(this.bottomEdgy, null, null, null, null, null, null, null, FinanceAppJS.Constants.Instrumentation.PinStart_Today_Click);
this._initializedOnce = true;
}
},
onWindowResize: function onWindowResize(event) {
FinanceAppJS.FinanceBasePage.prototype.onWindowResize.call(this, event);
this.refreshWatchListCluster();
},
onOrientationChange: function onOrientationChange(event) {
FinanceAppJS.FinanceBasePage.prototype.onOrientationChange.call(this,event);
this.refreshWatchListCluster();
},
refreshWatchListCluster: function refreshWatchListCluster() {
var watchListCluster = this.getClusterControl("myStocksCluster");
if (watchListCluster) {
var wlProvider = this.getDataProvider("EquityDataProvider");
wlProvider.getData({ listenerId: "myStocksCluster" });
}
},
onBindingComplete: function onBindingComplete() {
FinanceAppJS.FinanceBasePage.prototype.onBindingComplete.call(this);
var btnRemoveStock = document.getElementById("btnRemoveStk");
var btnClearSelection = document.getElementById("btnClearSelection");
// Set Button Labels Text
utils.setWinLabelText(btnRemoveStock, "BTN_LABEL_REMOVE_FROM_WATCHLIST");
utils.setWinLabelText(btnClearSelection, "MyStocksClearSelection");
},
onPageLoadComplete: function onPageLoadComplete() {
FinanceAppJS.FinanceBasePage.prototype.onPageLoadComplete.call(this);
// attach a scroll listener to the Hero cluster view port at this time 
var viewport = document.getElementById("FinanceAppJS.HomePage.HeroImageCluster_newsCluster");
if (viewport) {
viewport.addEventListener("mousewheel", FinanceAppJS.Telemetry.FlightRecorder.HeroScroll.bind(FinanceAppJS.Telemetry.FlightRecorder));
}
// log a content view for the watchlist item just once and no more than once per session. 
var Symbs = "";
var count = 0;
var rSettings = this.roaming && this.roaming.readFromRoaming();
var symbol = rSettings.data;
if (symbol) {
Symbs = symbol.join("|");
count = symbol.length;
}
var content = {
Watchlist: Symbs,
Count: count
};
FinanceAppJS.Telemetry.FlightRecorder.LogWatchlistContentFromToday(content);
FinanceAppJS.Telemetry.FlightRecorder.SetHeroPageLoadtime();
// Prefetching currency panorama data in home page as the cache gets populated and if the user goes offline in b/w, the page will load
utils.prefetchCurrencies();
},
getSharedContractData: function getSharedContractData() {
var dataProvider = this.getDataProvider("EquityDataProvider");
var data = dataProvider._lastFetchData;
var frmtLastUpdatedTime = utils.formatLastUpdatedTime(this.lastUpdatedTime);
var sharedContractDataPromise;
if (data) {
data = data.Rtd;
var mtData = {
timeAttribution: utils.getResourceString('ShareContractTimeAttribution').format(frmtLastUpdatedTime),
dataAttribution: utils.getResourceString('ShareContractDataAttribution'),
entities: []
};
var uriBuilder = new Platform.Utilities.AppExUriBuilder();
var subject = null;
var selectedItems = (this.listElmWin && this.listElmWin.selection) ? this.listElmWin.selection.getIndices() : [];
if (selectedItems.length) {
// Create a list binding and use it to obtain the items.
var binding = this.listElmWin.itemDataSource.createListBinding();
// Item manipulation requires a key, so convert the indexes to keys.
// Form an array of all the item keys and promises.
var promises = [];
for (var i = 0, count = selectedItems.length; i < count; i++) {
// Get the items based on the index (async).
promises[i] = binding.fromIndex(selectedItems[i]).then(function (item) {
var entity = WatchListManage.prepareShareContractData(item);
mtData.entities.push(entity);
});
}
subject = (selectedItems.length === 1) ? mtData.entities[0].cmp : utils.getResourceString("MyStocksLabel");
mtData.source = FinanceAppJS.Constants.IDs.NonIndices;
uriBuilder.controllerId = "watchlist";
}
else {
subject = utils.getResourceString("Market_Pano");
var rtConfigSymbols = FinanceAppJS.Globalization.getHomePageIndices();
for (i = 0; i < data.length; i++) {
var entity = {
type: FinanceAppJS.Constants.IDs.Index,
header: null,
lp: utils.formatNumber(data[i].Lp, "FLOAT2", false, ""),
changeStatus: data[i].Ch > 0 ? 1 : (data[i].Ch < 0 ? -1 : 0),
ch: utils.formatNumber(data[i].Ch, "FLOAT2", true, ""),
chp: utils.formatNumber(data[i].Chp, "PERCENT", true, "")
};
rtConfigSymbols.forEach(function (item) {
var symbParts = item.symbol.split(".");
if (utils.inArray(symbParts, data[i].Sym) !== -1) {
entity.sym = utils.getResourceString(item.displayName);
return false;
}
}),
mtData.entities.push(entity);
}
mtData.source = FinanceAppJS.Constants.IDs.Indices;
uriBuilder.controllerId = "application";
}
var uri = uriBuilder.toString();
mtData.deepLink = uri;
sharedContractDataPromise = new WinJS.Promise(function (complete, error) {
var title = utils.getShareContractSubject(subject);
if (promises && promises.length) {
// The fromIndex method is async, so use a join to wait for them all to be complete.
WinJS.Promise.join(promises).then(function () {
utils.getShareContractHtmlFormat(mtData).then(function (htmlOutput) {
complete({
title: title,
htmlContent: htmlOutput,
textContent: utils.getShareContractTextFormat(mtData),
uri: uri
});
});
});
}
else {
utils.getShareContractHtmlFormat(mtData).then(function (htmlOutput) {
complete({
title: title,
htmlContent: htmlOutput,
textContent: utils.getShareContractTextFormat(mtData),
uri: uri
});
});
}
});
}
else {
sharedContractDataPromise = new WinJS.Promise.wrapError({});
}
return sharedContractDataPromise;
},
})
});
})();
