﻿/* pages\MarketToday\js\HeroImageCluster.js */
(function () {
'use strict';
/// <summary>
/// Cluster with ParallaxItemsContainer as view for Hero Image
/// </summary>
WinJS.Namespace.define("FinanceAppJS.HomePage", {
HeroImageCluster: WinJS.Class.derive(FinanceAppJS.Controls.BaseCluster, function (domElement, options) {
FinanceAppJS.Controls.BaseCluster.call(this, domElement, options);
this.clusterItems = null;
this.heroImageLoaded = false;
this.tickers = FinanceAppJS.Globalization.getHomePageIndices().slice(0, FinanceAppJS.Constants.HomePage.MaxIndices);
this._indicesData = [];
for (var i = 0; i < this.tickers.length; i++) {
this._indicesData[i] = {
moduleInfo: {
renderer: function renderer(item) {
/// TODO : See if using innerHTML and html string would result in better perf
var domStructure = PlatformJS.Utilities.createElements(
{
tag: "div", attrs: { className: "newsStockTileContainer hide" }, children: [
{ tag: "div", attrs: { className: "row2 stockName" }, children: null },
{
tag: "div", attrs: { className: "row1" }, children: [
{ tag: "span", attrs: { className: "indicator", style: "padding-top: 4px;" }, children: [{ tag: "span" }] },
{
tag: "div", attrs: { className: "newsStockChange", direction: "ltr" }, children: [
{ tag: "span", attrs: { className: "hide", textContent: utils.getResourceString("PercentText_Al") }, },
{ tag: "span" }
]
},
{
tag: "div", attrs: { className: "stockValueCon" }, children: [
{ tag: "span", attrs: { className: "hide", textContent: utils.getResourceString("CurrentValue_Al") }, },
{ tag: "span", attrs: { className: "stockPrice" } }
]
}
]
},
]
});
var row1 = domStructure.children[1];
var row2 = domStructure.children[0];
var indicator = row1.children[0].children[0];
var stockValue = row1.children[2].children[1];
var stockChange = row1.children[1].children[1];
item.data.bind("Ch", function (newValue) {
indicator.className = FinanceAppJS.ConverterFunc.stockClassConverterSmall(newValue);
stockChange.textContent = FinanceAppJS.ConverterFunc.NumberFormator(newValue);
stockChange.className = FinanceAppJS.ConverterFunc.ValueChangeColorCSSClass(newValue);
stockChange.style.visibility = FinanceAppJS.ConverterFunc.visibilityConverter(newValue);
});
item.data.bind("Lp", function (newValue) {
stockValue.textContent = FinanceAppJS.ConverterFunc.NumberFormatorWithoutSign(newValue);
});
item.data.bind("displayName", function (newValue) {
row2.textContent = newValue;
});
return domStructure;
},
isInteractive: true
},
Lp: null, Ch: null, Chp: null, displayName: null,
};
}
// set options
this.binding_newsItemClick = this._newsItemClick.bind(this);
WinJS.UI.setOptions(this, options);
var provider = null;
if ((provider = this._dataProviders["EquityDataProvider"]) && provider._lastFetchData) {
this.update(provider._lastFetchData, "EquityDataProvider");
}
if ((provider = this._dataProviders["EditorialNewsDataProvider"]) && provider._lastFetchData) {
this.update(provider._lastFetchData, "EditorialNewsDataProvider");
}
}, {
_newsView: null,
_newsItems: null,
_indicesItems: null,
_indicesData: null,
// prevent animation on parallax items container
preventAnimation: true,
update: function update(data, providerName) {
switch (providerName) {
case 'EquityDataProvider':
return this._updateIndexTiles(data);
case 'EditorialNewsDataProvider':
if (data && data.articleInfos && data.articleInfos.length > 0) {
if (data.heroCluster && data.heroCluster.content && data.heroCluster.content.articleid) {
data.heroCluster.content.articleInfos = data.articleInfos;
}
}
return this._updateNews(data.heroCluster);
}
return WinJS.Promise.as({});
},
_attachIndexActionEvent: function _attachIndexActionEvent() {
var indices = document.querySelectorAll(".newsStockTileContainer");
if (indices && indices.length > 0) {
for (var i = 0; i < indices.length; i++) {
PlatformJS.Utilities.enablePointerUpDownAnimations(indices[i]);
indices[i].onkeypress = function (event) {
var keyCode = event.keyCode;
switch (keyCode) {
case WinJS.Utilities.Key.space:
case WinJS.Utilities.Key.enter:
indices[i].onclick(event);
break;
default:
FinanceAppJS.Utils.Navigator.leftRightArrowKeyDown(event);
break;
}
event.stopImmediatePropagation();
event.preventDefault();
};
}
}
},
_updateIndexTiles: function _updateIndexTiles(equtityData) {
var realTimeQuotesData = equtityData.Rtd.slice(0, FinanceAppJS.Constants.HomePage.MaxIndices);
if (this._newsData) {
utils.copyArrayToList(realTimeQuotesData, this._newsData, 1);
} else {
utils.deepCopy(realTimeQuotesData, this._indicesData);
}
return WinJS.Promise.as({}).then(this._attachIndexActionEvent());
},
_newsItemClick: function _newsItemClick(event) {
if (!event.detail.item) {
return;
}
FinanceAppJS.Telemetry.FlightRecorder.HeroScroll(null);
if (event.detail.item.indexSymbol) {
// launch from here the Index Details page 
var instrumentID = FinanceAppJS.Constants.Instrumentation.Index_TodayIndexHero_Click;
var state = utils.getIndexDetails(event.detail.item, "ChartData");
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.HERO,
FinanceAppJS.Telemetry.Constants.Location.HEROINDEX,
event.detail.item.displayName);
navigationHelper.navigateToIndexDetailsPage(state, instrumentID);
}
else {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY,
FinanceAppJS.Telemetry.Constants.Cluster.HERO,
FinanceAppJS.Telemetry.Constants.Location.HERONEWS,
event.detail.item.articleid);
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.MarketToday_HeroImageHeadLine_Click, 1);
if (!event.item.isFRE || FinanceAppJS.Globals.FRE) {
utils.launchNewsUri(event.detail.item, Platform.Instrumentation.InstrumentationEditorialSourceId.heroImage);
}
}
},
_updateNews: function _updateNews(data) {
var bgImage = data.imageData.backgroundImage;
bgImage.cacheId = "FinanceHeroData";
if (this._imageData && this._newsData && this._imageData.backgroundImage.url === data.imageData.backgroundImage.url && this._newsData.getAt(0).headline === data.content.headline) {
return WinJS.Promise.as({});
}
var renderedOnce = (this._newsData ? true : false);
this._imageData = utils.deepCopy(data.imageData);
var arr = [data.content].concat(this._indicesData);
arr[0].moduleInfo = {
renderer: function renderer(item) {
var domStructure = PlatformJS.Utilities.createElements({
tag: "div", attrs: { className: "hide newsMainTile" }, children: [
{ tag: "div", attrs: { className: "newsHeadline row1 cluster-item", role: "link" } },
{ tag: "span", attrs: { className: "hide", textContent: utils.getResourceString("TodaySource_Al") } },
{ tag: "div", attrs: { className: "newsProvider t5 row2" } }
]
});
var headline = domStructure.children[0];
var text = domStructure.children[2];
var narratorDiv = domStructure.children[1];
item.data.bind("headline", function (newValue) {
domStructure.style.display = FinanceAppJS.ConverterFunc.styleDisplayConverter(newValue);
headline.innerHTML = toStaticHTML(newValue);
});
item.data.source.bind("name", function (newValue) {
text.textContent = newValue;
narratorDiv.style.visibility = FinanceAppJS.ConverterFunc.visibilityConverter(newValue);
text.style.visibility = FinanceAppJS.ConverterFunc.visibilityConverter(newValue);
});
return domStructure;
},
className: "newsMainTile",
isInteractive: false
};
this._newsData = new WinJS.Binding.List(arr, { binding: true });
if (renderedOnce) {
return this._newsView.refresh({
itemDataSource: this._newsData.dataSource,
attributionData: this._imageData.attributionData,
anchorPoint: this._imageData.anchorPoint,
showGradient: this._imageData.showGradient,
backgroundImage: this._imageData.backgroundImage,
});
} else {
this._newsView = new CommonJS.Immersive.ParallaxItemsContainer(this._domElement, {
className: "mtNewsMainContainer",
imageSize: { width: 1190, height: 768 },
itemDataSource: this._newsData.dataSource,
onitemclick: this.binding_newsItemClick,
imageData: this._imageData,
});
return this._newsView.render();
}
},
onOrientationChange: function onOrientationChange(event) {
if (this._newsView) {
this._newsView.onOrientationChange(event);
}
},
dispose: function dispose() {
FinanceAppJS.Controls.BaseCluster.prototype.dispose();
if (this._newsView) {
this._newsView.dispose();
}
}
})
});
})();
/* pages\MarketToday\js\IndexChartCluster.js */
(function () {
'use strict';
var HomePage = WinJS.Namespace.define("FinanceAppJS.HomePage", {
/// <summary>
/// Cluster with Chart as view for stock quotes
/// </summary>
IndexChartCluster: WinJS.Class.derive(FinanceAppJS.Controls.BaseCluster, function (domElement, options) {
FinanceAppJS.Controls.BaseCluster.call(this, domElement, options);
if (!options || !options.dataProviders || !options.dataProviders.StockChartDataProvider) {
debugger;
}
this._chartDataProvider = options.dataProviders.StockChartDataProvider;
this._chartDataProvider.addListeners({ error: this._chartDataErrorHandler.bind(this) });
this._isCurrentInstrumentEOD = options.isEOD;
this._setRangeSelectors(this._isCurrentInstrumentEOD);
if (options.className) {
WinJS.Utilities.addClass(this._domElement, options.className);
}
WinJS.UI.setOptions(this, options);
}, {
_chartData: null,
_chartDataCache: null,
_chartPendingUpdate: false,
_displayName: null,
_chartInitialized: false,
_equityUpdateTime: null,
_chartDataProvider: null,
_isCurrentInstrumentEOD: null,
_isClusterRenderedOnce: false,
_currentStockIndex: 0,
_currentRangeIndex: 0,
_rangeSelectors: null,
_indicesList: null,
_realtimeQuotesData: null,
_chartChildElements: null,
_chartElement: null,
_chartControl: null,
_setRangeSelectors: function _setRangeSelectors(isEOD) {
if (isEOD) {
this._rangeSelectors = ["1m", "1y"];
}
else {
this._rangeSelectors = ["1d", "5d", "1m", "1y"];
}
},
// TODO: Check callback
_indexChanged: function _indexChanged(event) {
var selectors = this._chartChildElements.chartSelectors;
var index = this._currentStockIndex;
selectors.forEach(function (elem, i) {
if (elem !== event.currentTarget) {
WinJS.Utilities.removeClass(elem, "active");
} else {
index = i;
WinJS.Utilities.addClass(elem, "active");
}
});
if (index === this._currentStockIndex) {
return;
}
//On Index changed, check if the new index's type (EOD or intraday) is different from the previous one.
//If yes, change the range selectors accordingly
var isNewIndexEOD = utils.isEODInstrument(this._indicesList[index].symbol);
var selectedIndex;
if (this._isCurrentInstrumentEOD !== isNewIndexEOD) {
this._setRangeSelectors(isNewIndexEOD);
//The below code preserves the state of the previously selected range option.
//If the transition is from EOD to intraday, the selected range option needs to be preserved as such.
//So in this case, the index shifts forward by two, since 'Day' and 'Week' options are newly added in the beginning.
//If the transition is from intraday to EOD, the selected range option needs to be preserved as such and,
//If 'Day' or 'Week' was the previous option selected, it should default to 'Month' as 'Day' and 'Week' options are not present in EOD
//So in this case, the index shifts backward by two, since 'Day'and 'Week' options are removed from the beginning.
if (this._isCurrentInstrumentEOD) {
selectedIndex = this._currentRangeIndex + 2;
}
else {
var idx = this._currentRangeIndex - 2;
if (idx < 0) {
selectedIndex = 0;
}
else {
selectedIndex = idx;
}
}
this._currentRangeIndex = selectedIndex;
this._updateDateSelectors();
}
this._currentStockIndex = index;
this._isCurrentInstrumentEOD = isNewIndexEOD;
var symbol = this._indicesList[this._currentStockIndex].symbol;
this._resetChart();
this.update(this._equityData, 'EquityDataProvider');
this._dataProviders["StockChartDataProvider"].updateOptions({
stockSymbol: symbol,
isEOD: this._isCurrentInstrumentEOD,
duration: this._rangeSelectors[this._currentRangeIndex],
refreshInterval: this._isCurrentInstrumentEOD ? 0 : FinanceAppJS.Constants.RefreshIntervals.HomePageEquityData
});
var currentStockDetails = this._realtimeQuotesData[this._currentStockIndex];
var pageId = this._dataProviders.StockChartDataProvider._pageId;
var Page_Id = FinanceAppJS.Telemetry.FlightRecorder.GetPageId(this.ipage._channelId);
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(Page_Id,
FinanceAppJS.Telemetry.Constants.Cluster.INDEXCHART,
FinanceAppJS.Telemetry.Constants.Location.INDEXSELECTOR,
currentStockDetails.displayName);
if (pageId === '/pages/MarketToday/html/MarketToday.html') {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.MarketToday_ChartIndices_Click, 1);
}
else if (pageId === '/pages/Market/html/Market.html') {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.Market_ChartIndices_Click, 1);
}
},
_dateRangedChanged: function _dateRangedChanged(event) {
var index = this._currentRangeIndex;
this._chartChildElements.chartRangeSelectors.forEach(function (elem, i) {
if (elem !== event.currentTarget) {
WinJS.Utilities.removeClass(elem, "active");
} else {
index = i;
WinJS.Utilities.addClass(elem, "active");
}
});
if (index === this._currentRangeIndex) {
return;
}
this._currentRangeIndex = index;
this._resetChart();
this._chartDataProvider.updateOptions({
duration: this._rangeSelectors[this._currentRangeIndex],
isEOD: this._isCurrentInstrumentEOD,
refreshInterval: (this._rangeSelectors[this._currentRangeIndex] === '1d') ? FinanceAppJS.Constants.RefreshIntervals.HomePageEquityData : 0
});
var pageId = FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId);
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(pageId,
FinanceAppJS.Telemetry.Constants.Cluster.CHART,
FinanceAppJS.Telemetry.Constants.Location.CHARTRANGESELECTOR,
this._rangeSelectors[this._currentRangeIndex]);
},
_onIndexDetailsClick: function _onIndexDetailsClick(event) {
var instrumentID = FinanceAppJS.Constants.Instrumentation.Index_TodayIndexCluster_Click;
var currentStockDetails = this._realtimeQuotesData[this._currentStockIndex];
var pageId = FinanceAppJS.Telemetry.FlightRecorder.GetPageId(this.ipage._channelId);
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(pageId,
FinanceAppJS.Telemetry.Constants.Cluster.INDEXCHART,
FinanceAppJS.Telemetry.Constants.Location.IDXMOREBTN,
currentStockDetails.displayName);
var state = {};
var state = utils.getIndexDetails(currentStockDetails, "ChartData");
navigationHelper.navigateToIndexDetailsPage(state, instrumentID);
},
update: function update(data, providerName) {
switch (providerName) {
case 'EquityDataProvider':
this._equityData = data;
var dataObject = this._getDataObject(data);
dataObject.rangeSelectors = this._rangeSelectors;
dataObject.activeRangeIndex = this._currentRangeIndex;
dataObject.activeIndex = this._currentStockIndex;
if (!this._chartChildElements) {
this._chartChildElements = {};
this._chartElement = this.moduleInfo.renderer(dataObject, this._chartElement, this._chartChildElements);
this._updateDateSelectors();
this._chartControl = this._chartChildElements.chartContainer.winControl;
this._chartChildElements.indexDetailsButton.onclick = WinJS.Utilities.markSupportedForProcessing(this._onIndexDetailsClick.bind(this));
var indexChangedBinding = this._indexChanged.bind(this);
var dateRangedChangedBinding = this._dateRangedChanged.bind(this);
this._chartChildElements.chartSelectors.forEach(function (elem) {
elem.onclick = indexChangedBinding;
elem.onkeypress = indexChangedBinding;
});
this._chartChildElements.chartRangeSelectors.forEach(function (elem) { elem.onclick = dateRangedChangedBinding; });
this._domElement.appendChild(this._chartElement);
} else {
this.moduleInfo.renderer(dataObject, this._chartElement, this._chartChildElements);
}
var dateTimeString = FinanceAppJS.Utils.Formatters.lastUpdateTimeStampFormatter(dataObject.realtimeQuotesData.Ld, dataObject.realtimeQuotesData.Lt, dataObject.realtimeQuotesData.tz);
this._chartControl.realtimeQuotesLastUpdatedTimeString = dateTimeString;
this._resetChart();
this._performPendingUpdate();
// check if recent chart data is available.
if (this._chartControl && this._chartDataCache) {
// recent chart data is available which was not used because it was not in sync with equity data.
this._chartControl.data = this._chartDataCache;
this._chartDataCache = null;
}
return WinJS.Promise.as();
case 'StockChartDataProvider':
return this._updateChart(data);
}
},
_getDataObject: function _getDataObject(data) {
this.isEquityLocalResponse = data.isLocalResponse;
this._equityUpdateTime = data.lastUpdateTime;
data = data.Rtd;
this._realtimeQuotesData = data;
if (!this._indicesList) {
var indicesList = data.map(function (item) { return { displayName: item.displayName, symbol: item.indexSymbol }; });
this._indicesList = indicesList.slice(0, FinanceAppJS.Constants.HomePage.MaxIndices);
}
this._displayName = this._indicesList[this._currentStockIndex].displayName;
return {
realtimeQuotesData: data[this._currentStockIndex],
indicesList: indicesList
};
},
_chartDataErrorHandler: function _chartDataErrorHandler() {
this._updateChart(null);
},
_resetChart: function _resetChart() {
var symbol = this._indicesList[this._currentStockIndex].symbol;
var duration = this._rangeSelectors[this._currentRangeIndex];
this._displayName = this._indicesList[this._currentStockIndex].displayName;
this._chartControl.activeSeries = { seriesId: symbol + duration, displayName: this._displayName };
},
_performPendingUpdate: function _performPendingUpdate() {
if (this._chartUpdatePending) {
return this._updateChart(this._chartData);
}
else {
return WinJS.Promise.as();
}
},
_updateChart: function _updateChart(data) {
this._chartDataCache = null;
if (!FinanceAppJS.Globals.FRE) {
// compare the update time of chart data and equity data
if (!this.isEquityLocalResponse && this._equityUpdateTime && data && data.length > 0 && data[0] && data[0].lastUpdateTime) {
if ((new Date(data[0].lastUpdateTime)).getTime() - (new Date(this._equityUpdateTime).getTime()) > FinanceAppJS.Constants.Global.ChartAndEquitydata_Allowed_TimeDifference) {
// save the chart data for later use
this._chartDataCache = data;
// chart data is more fresh. Set it to null.
data = null;
}
}
}
if (this._chartControl) {
this._chartControl.data = data;
this._chartUpdatePending = false;
this._chartData = null;
}
else {
// chart div is not rendered yet cache the data and set the pending flag
this._chartUpdatePending = true;
this._chartData = data;
}
return WinJS.Promise.as();
},
_updateDateSelectors: function _updateDateSelectors() {
var elems = this._chartChildElements;
var activeRangeIndex = this._currentRangeIndex;
if (!elems.chartRangeSelectors || this._rangeSelectors.length !== elems.chartRangeSelectors.length) {
elems.chartRangeSelectorContainer.innerHTML = "";
var chartRangeSelectorContainer = elems.chartRangeSelectorContainer;
elems.chartRangeSelectors = this._rangeSelectors.map(function (range, index) {
var chartRangeSelector = document.createElement("button");
chartRangeSelector.className = "rectangularButton";
chartRangeSelector.tabIndex = 0;
chartRangeSelector.textContent = utils.getDateRangeButtonName(range);
chartRangeSelectorContainer.appendChild(chartRangeSelector);
return chartRangeSelector;
});
WinJS.Utilities.addClass(elems.chartRangeSelectors[0], "start");
WinJS.Utilities.addClass(elems.chartRangeSelectors[this._rangeSelectors.length - 1], "end");
}
elems.chartRangeSelectors.forEach(function (elem, index) {
if (index !== activeRangeIndex) {
WinJS.Utilities.removeClass(elem, "active");
} else {
WinJS.Utilities.addClass(elem, "active");
}
});
},
dispose: function dispose() {
if (this._chartControl) {
WinJS.UI.setOptions(this._chartControl, { refreshEnabled: false });
this._chartControl.dispose();
}
},
})
});
})();
/* pages\MarketToday\js\MyStocksCluster.js */
(function () {
'use strict';
var HomePage = WinJS.Namespace.define("FinanceAppJS.HomePage", {
MyStocksCluster: WinJS.Class.derive(FinanceAppJS.Controls.BaseCluster, function (domElement, options) {            
FinanceAppJS.Controls.BaseCluster.call(this, domElement, options);
this.clusterItems = null;
WinJS.Utilities.addClass(domElement, "watchlistCluster");
this._loadTemplatePromiseFunc_binding = this._loadTemplatePromiseFunc.bind(this);
this._templateProvider_S_binding = this._templateProvider_S.bind(this);
this._itemTemplate_S_binding = this._itemTemplate_S.bind(this);
this._itemTemplateSelector_S_binding = this._itemTemplateSelector_S.bind(this);
this._loadingStateChangedCallback_binding = this._loadingStateChangedCallback.bind(this);
this._resetProvider_binding = this.resetProvider.bind(this);
this.addButtonInvokedBinding = this.addInvoked.bind(this);
this.removeItemBinding = this.removeItem.bind(this);
this.saveOrderToRoamingBinding = this.saveOrderToRoaming.bind(this);
this._showHeaderAfterRenderBinding = this._showHeaderAfterRender.bind(this, domElement);
this.addEventListener("rendercomplete", this._showHeaderAfterRenderBinding);
WinJS.UI.setOptions(this, options);
this._computeMinWidth();
var clusterMap = utils.getDeepObject(options, ["ipage", "clusterControlsMap"]);
if (!(clusterMap.hasOwnProperty("indexChartCluster") && clusterMap.hasOwnProperty("newsCluster"))) {
this.lazyRendering = false;
this.view;
this.templatePromise;
}
},
{
// declare null aliases for auto-complete to work            
onitemclick: null,
_view: null,
listViewFeatures: CommonJS.UI.ListView2.FEATURES.ADD + CommonJS.UI.ListView2.FEATURES.REMOVE + CommonJS.UI.ListView2.FEATURES.REORDER,
lazyRendering: true,
preventAnimation: true,
_roamingObject: null,
dragElementBinding : WatchListDataProvider.getWatchListDragElement,
saveOrderToRoaming: function saveOrderToRoaming() {
if (!this.roamingObject) {
return;
}
var rSettings = this.roamingObject.readFromRoaming();
var existingSymbols = rSettings.data;
var symbols = this.view.getOrder();
if (symbols) {
if (!existingSymbols) {
existingSymbols = [];
}
var length = symbols.length;    // copy current order of today page stocks to roaming settings. Retain stocks that are in watchlist but not visible in today page
for (var i = 0; i < length; i++) {
existingSymbols[i] = symbols[i];
}
this.roamingObject.setWatchlist(existingSymbols);
}
},
_computeMinWidth: function _computeMinWidth() {
var watchListClusterHeight = document.body.offsetHeight - 150; /* see markettoday.css*/
var noOfTilesPerColumn = Math.floor(watchListClusterHeight / 150); // 140 - tile + 10 -margin
var roamingCount = this.roamingObject.getWatchlistCount() + 1;
var noOfcolumns = Math.ceil(roamingCount / noOfTilesPerColumn);
var finalCols = noOfcolumns > 4 ? 4 : noOfcolumns;
var finalWidth = 360 * finalCols; /* see markettoday.css 350 + 10px for left and right margin */
this._domElement.style.minWidth = finalWidth + "px";
},
_setWidthAuto: function _setWidthAuto() {
this._domElement.style.minWidth = "";
},
view: {
get: function get() {   
if (!this._view) {
this._view = new CommonJS.UI.ListView2(this._domElement,
{
friendlyName:"myStocksList",
layout: { type: WinJS.UI.GridLayout },
selectionMode: 'multi',
onadditeminvoked: this.addButtonInvokedBinding,
onitemdeleted: this.removeItemBinding,
dragThreshold: 200,
enabledFeatures: this.listViewFeatures,
onlistreordered: this.saveOrderToRoamingBinding,
draggedElementRender: this.dragElementBinding,
itemTemplate: this._itemTemplate_S_binding,
});
}
return this._view;
}
},
roamingObject: {
set: function set(value) {
this._roamingObject = value;
},
get: function get() {
return this._roamingObject;
}
},
addInvoked: function addInvoked() {
var page = FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId);
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(page,
FinanceAppJS.Telemetry.Constants.Cluster.WATCHLIST,
FinanceAppJS.Telemetry.Constants.Location.ADD,
"");
FinanceAppJS.Utilities.QuickSearch.getInstance().showQuickSearch();
},
removeItem: function removeItem(item ) {
var toBeDeleted = [];
/* null check to not crash ListView2 is sometimes invoking this with addTile. 
remove this after CUX fixes it. */
if (!item.detail.tileData) {
return;
}
toBeDeleted.push({symbol: WatchListManage.getSymbolFromTileData(item.detail.tileData)});
this.roamingObject.removeFromWatchlist(toBeDeleted);
},
update: function update(data) {
data = data.Wl;
var tilesInHomePage = utils.getHomePageWLDisplayCount();
if (data.length > tilesInHomePage) {
data = data.slice(0, tilesInHomePage);
}
for (var i = 0; i < data.length; i++) {
data[i].itemKey = WatchListManage.getSymbolFromTileData(data[i].tileData);
if(!data[i].title){
data[i].title = data[i].tileData.instrumentDisplaySymbol;
}
}
this._itemRenderPromises = null;
if (this.clusterItems && this.clusterItems.length ) { 
var stkTilesLength = this.clusterItems.length - 1; 
var newDataLength = data.length;
for (var i = 0, item; i < stkTilesLength && i < data.length && (item = this.clusterItems.getAt(i)) ; i++) {
if (data[i] && data[i].tileData) {
utils.deepCopy(data[i], item);
}
}
if (stkTilesLength < newDataLength) {
var listBinding = this.clusterItems;
var dataToInsert = data.splice(stkTilesLength, (newDataLength - stkTilesLength));
var insertAtPos = stkTilesLength;
while (dataToInsert.length > 0) {
listBinding.splice(insertAtPos, 0, dataToInsert.shift());
insertAtPos++;
} 
}
if (stkTilesLength > newDataLength) {
var listBinding = this.clusterItems;
listBinding.splice(newDataLength, stkTilesLength - newDataLength);
}
this._updateHeaderCount();
return WinJS.Promise.as({});
}
else {
return this.invalidate(data);
}
},
_templatePromise: null,
templatePromise: {
get: function get() {
return (this._templatePromise = this._templatePromise || WatchListDataProvider.watchListTemplates(false));
},
},
_showHeaderAfterRender: function _showHeaderAfterRender(domElement, event) {
if (this._showHeaderAfterRenderBinding) {
this.removeEventListener("rendercomplete", this._showHeaderAfterRenderBinding);
this._showHeaderAfterRenderBinding = null;
}
try {
if (typeof event.detail === 'string' && event.detail !== 'success') {
return;
}
var editButton = document.getElementsByClassName("listView2EditButtonContainer");
if (editButton && editButton[0]) {
editButton[0].style.visibility = 'visible';
}
}
catch (ex) {
debugger;
}
},
/// <summary>
/// Invalidates the News cluster by querying the service and binding the resulting data to the view.
/// </summary>
invalidate: function invalidate(response) {
this.clusterItems = new WinJS.Binding.List(response, { binding: true });
return this.lazyRendering ? utils.createImmediatePromise(this._loadTemplatePromiseFunc_binding) : new WinJS.Promise(this._loadTemplatePromiseFunc_binding);
},
_templates: null,
_loadTemplatePromiseComplete: null,
_loadTemplatePromiseFunc: function _loadTemplatePromiseFunc(complete, error) {
this._loadTemplatePromiseComplete = complete;
this.templatePromise.then(this._templateProvider_S_binding);
},
_templateProvider_S: function _templateProvider_S(templates) {
this._templates = templates;  
if (this.lazyRendering) {
msSetImmediate(WinJS.UI.setOptions.bind(WinJS.UI), this.view, {
itemDataSource: (this.clusterItems && this.clusterItems.dataSource) || null,
onloadingstatechanged: this._loadingStateChangedCallback_binding
});
} else {
var itemRenderPromises = [];
for (var i = 0; i < this.clusterItems.length; i++) {
itemRenderPromises.push(this._itemTemplateSelector_S(this.clusterItems.getItem(i)));
}
this._itemRenderPromises = itemRenderPromises;
WinJS.UI.setOptions(this.view, {                                                                                                                                              
itemDataSource: (this.clusterItems && this.clusterItems.dataSource) || null,
onloadingstatechanged: this._loadingStateChangedCallback_binding
});
}
},
_loadingStateChangedCallback: function _loadingStateChangedCallback(event) {
if (this.view && this.view.loadingState === "itemsLoaded") {
this.view.removeEventListener("loadingstatechanged", this._loadingStateChangedCallback_binding, false);
this._itemRenderPromises = null;
this._loadTemplatePromiseComplete();
this.clusterItems.addEventListener("iteminserted", this._resetProvider_binding);
this.clusterItems.addEventListener("itemremoved", this._resetProvider_binding);
this.clusterItems.addEventListener("itemmoved", this._resetProvider_binding);
this._setWidthAuto();
}
},
resetProvider: function resetProvider() {
// Reset Data Provider
var wlProvider = this.ipage.getDataProvider("EquityDataProvider");
if (wlProvider) {
wlProvider.invalidateSymbols = true;
wlProvider.clear();
msSetImmediate(function () {
wlProvider.getData();
});
}
else {
debugger;
}
},
_updateHeaderCount: function _updateHeaderCount() {
var wlCountCurrent = this.roamingObject.getWatchlistCount();
if (wlCountCurrent > utils.getHomePageWLDisplayCount()) {
WatchListManage.updateWatchlistClusterTitle(WatchListManage.getTitleWithCount(wlCountCurrent));
}
else {
WatchListManage.updateWatchlistClusterTitle(utils.getResourceString("chMyStocks"));
}
},
_itemTemplate_S: function _itemTemplate_S(itemPromise) {
return itemPromise.then(this._itemTemplateSelector_S_binding);
},
_itemTemplateSelector_S: function _itemTemplateSelector_S(item) {
if (this._itemRenderPromises && this._itemRenderPromises.length) {
return this._itemRenderPromises.shift();
}
return WatchListDataProvider.watchListTemplateSelector(item.data, this._templates, null, null, true);
},
dispose: function dispose() {
if (this._showHeaderAfterRenderBinding) {
this.removeEventListener("rendercomplete", this._showHeaderAfterRenderBinding);
this._showHeaderAfterRenderBinding = null;
}
if (this.clusterItems) {
this.clusterItems.removeEventListener("iteminserted", this._resetProvider_binding);
this.clusterItems.removeEventListener("itemremoved", this._resetProvider_binding);
this.clusterItems.removeEventListener("itemmoved", this._resetProvider_binding);
}
this._templatePromise && this._templatePromise.cancel();
},
})
});
})();
/* pages\MarketToday\js\MarketMoversCluster.js */
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.HomePage", {
/// <summary>
/// Cluster with market movers data
/// </summary>
MarketMoversCluster: WinJS.Class.derive(FinanceAppJS.Controls.BaseCluster, function (domElement, options) {
FinanceAppJS.Controls.BaseCluster.call(this, domElement, options);
this._types = ["gainers", "losers", "active"];
this.binding_attachElements = this._attachElements.bind(this);
this.binding_renderMoversType = this._renderMoversType.bind(this);
WinJS.Utilities.addClass(domElement, "MarketMoversCluster");
WinJS.Utilities.addClass(domElement, "MarketMoversFlow");
if (options.stockModuleInfo) {
this._stockModuleInfo = options.stockModuleInfo;
} else {
this._stockModuleInfo = {
fragmentPath: "/shared/html/WatchListItemTemplate.html",
templateId: "stockItemTemplate", height: 1, width: 1, isInteractive: false,
};
};
WinJS.UI.setOptions(this, options);
}, {
_clusterItems: null,
_renderData: null,
_elements: null,
_views: null,
_types: null,
_stockModuleInfo: null,
update: function update(data) {
data = data.Mov;
if (this._clusterItems) {
for (var type in this._clusterItems) {
utils.copyArrayToList(data[type], this._clusterItems[type]);
}
return WinJS.Promise.as({});
}
return this.invalidate(data);
},
_attachElements: function _attachElements(value) {
for (var type in this._elements) {
this._domElement.appendChild(this._elements[type]);
}
this._renderData = null;
return value;
},
_renderMoversType: function _renderMoversType(type) {
if (!utils.isNonEmptyArray(this._renderData[type])) { return WinJS.Promise.as({}); }
FinanceAppJS.Utils.Logger.LogPerformance("MarketMoversCluster", "renderMoversType_" + type, FinanceAppJS.Utils.Logger.PerformanceMarks.Start);
var domElement = this._elements[type] = document.createElement("div");
var headerElems = utils.createElements("div", "div", {
"smallGlyph arrowPaddingBottom financeGlyphUp": "",
"smallGlyph arrowPaddingBottom financeGlyphDn": "",
"moversHeader": utils.getResourceString(type.charAt(0).toUpperCase() + type.slice(1))
}, "moversHeaderTemplate ", domElement);
domElement.className = type + "Container";
domElement = utils.createElement(domElement, "div");
var data = this._renderData[type];
for (var i = 0 ; i < data.length; i++) {
data[i].moduleInfo = this._stockModuleInfo;
}
var list = new WinJS.Binding.List(data, { binding: true });
var options = {
itemDataSource: list.dataSource,
className: "platformListLayout financeMoversInnerList",
onitemclick: function onitemclick(event) {
var itemData = event.detail.item.tileData;
var page = FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.history.current.location.channelId);
var cluster = FinanceAppJS.Telemetry.Constants.Cluster.MOVERS;
var location = FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM;
var data = itemData.instrumentFullName;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(page, cluster, location, data);
switch (itemData.type) {
case FinanceAppJS.Constants.IDs.Fund:
var entity = WatchListManage.getFundDetailsPageInfo(itemData);
navigationHelper.navigateToFundDetailsPage(entity , FinanceAppJS.Constants.Instrumentation.Market_MarketMoversCluster_Click);
break;
case FinanceAppJS.Constants.IDs.Etf:
var entity = WatchListManage.getETFDetailsPageInfo(itemData);
navigationHelper.navigateToETFDetailsPage(entity, FinanceAppJS.Constants.Instrumentation.Market_MarketMoversCluster_Click);
break;
case FinanceAppJS.Constants.IDs.Stock:
var entity = WatchListManage.getEntityPageInfo(itemData);
navigationHelper.navigateToEntityPage(entity, FinanceAppJS.Constants.Instrumentation.Market_MarketMoversCluster_Click);
break;
}
},
};
var view = this._views[type] = new CommonJS.Immersive.ItemsContainer(domElement, options);
var items = this._clusterItems[type] = list;
return view.render().then(function (value) {
FinanceAppJS.Utils.Logger.LogPerformance("MarketMoversCluster", "renderMoversType_" + type, FinanceAppJS.Utils.Logger.PerformanceMarks.End);
return value;
});
},
/// <summary>
/// Invalidates the News cluster by querying the service and binding the resulting data to the view.
/// </summary>
/// <param>
/// type can be gainers, losers, active only.
/// </param>
invalidate: function invalidate(data) {
this._views = {};
this._renderData = utils.deepCopy(data);
this._elements = {};
this._clusterItems = {};
var promises = this._types.map(this.binding_renderMoversType);
return WinJS.Promise.join(promises).then(this.binding_attachElements);
},
dispose: function dispose() {
FinanceAppJS.Controls.BaseCluster.prototype.dispose();
for (var view in this._views) {
this._views[view].dispose();
}
}
})
});
})();
/* pages\MarketToday\js\AcrossMarketCluster.js */
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.Controls", {
AcrossMarketCluster: WinJS.Class.derive(FinanceAppJS.Controls.ItemsCluster, function (domElement, options) {
FinanceAppJS.Controls.ItemsCluster.call(this, domElement, options);
}, {
getEmptyBindingObject: function getEmptyBindingObject(templateId) {
var obj = {};
obj.title = "";
obj.className = "";
obj.separator = "";
obj.moduleInfo = {
fragmentPath: "/pages/MarketToday/html/MarketTodayTemplates.html",
templateId: templateId
};
for (var k = 0; k < FinanceAppJS.Constants.HomePage.USAcrossMarketCount; k++) {
obj["data" + (k + 1)] = { change: "", label: "", pchange: "", value: "" };
}
return obj;
},
update: function update(data) { 
var collatedData = [];
var ccbProvider = data.AcrossMarketDataProvider;
if (data && ccbProvider) {
for (var i = 0; i < ccbProvider.length; i++) {
collatedData.push(ccbProvider[i]);
}
}
else {
for (var i = 0; i < FinanceAppJS.Constants.ccClusterLength ; i++) { 
collatedData.push(this.getEmptyBindingObject("AcrossMarketTemplate"));
}
}
var ratesProvider = data.HomeRatesDataProvider;
if (data && ratesProvider) {
for (var j = 0; j < ratesProvider.length; j++) {
collatedData.push(ratesProvider[j]);
}
}
else {
collatedData.push(this.getEmptyBindingObject("AcrossMarketRatesTemplate"));
}
if (!this._elements) {
return this._renderItems(collatedData);
}
return WinJS.Promise.as(this._updateImpl(collatedData, this._elements));
},
})
});
})();
