﻿(function () {
'use strict';
function updateChartTile(elems, data) {
elems.largeGlyph.className = "largeGlyph " + FinanceAppJS.ConverterFunc.StockClassConverter(data.realtimeQuotesData);
elems.mainValue.textContent = FinanceAppJS.ConverterFunc.NumberFormatorWithoutSign(data.realtimeQuotesData.Lp);
elems.changedPrice.textContent = FinanceAppJS.ConverterFunc.NumberFormator(data.realtimeQuotesData.Ch);
elems.changePercent.textContent = FinanceAppJS.ConverterFunc.NumberFormator(data.realtimeQuotesData.Chp);
elems.openPrice.textContent = FinanceAppJS.ConverterFunc.NumberFormatorWithoutSign(data.realtimeQuotesData.Op);
elems.dayRange.textContent = FinanceAppJS.ConverterFunc.dayRangeConverter(data.realtimeQuotesData);
elems.previousClose.textContent = FinanceAppJS.ConverterFunc.NumberFormatorWithoutSign(data.realtimeQuotesData.Pp);
elems.yearRange.textContent = FinanceAppJS.ConverterFunc.yearRangeConverter(data.realtimeQuotesData);
elems.oneYearReturns.textContent = FinanceAppJS.ConverterFunc.NumberFormatorWithoutSign(data.realtimeQuotesData.yrr);
elems.numConstituents.textContent = FinanceAppJS.Utils.Formatters.numberFormatter(data.realtimeQuotesData.Cts, 0, false); // if not avl use '-'
var chColor = FinanceAppJS.ConverterFunc.ColorConverter(data.realtimeQuotesData.Ch);
elems.changedPrice.style.color = chColor;
elems.changePercent.style.color = chColor;
elems.percentSign.style.color = chColor;
var chVisible = FinanceAppJS.ConverterFunc.visibilityConverter(data.realtimeQuotesData.Ch);
var chpVisible = FinanceAppJS.ConverterFunc.visibilityConverter(data.realtimeQuotesData.Chp);
elems.changedPrice.style.visibility = chVisible;
elems.changePercent.style.visibility = chpVisible;
elems.percentSign.style.visibility = chpVisible;
elems.chartSelectors.forEach(function (elem, index) {
if (index !== data.activeIndex) {
WinJS.Utilities.removeClass(elem, "active");
} else {
WinJS.Utilities.addClass(elem, "active");
}
});
};
function createChartTile(container, data, elems) {
var chartTile = document.createElement("div");
chartTile.className = "chartTile";
/// <disable>JS2009.MultilineStrings</disable>
chartTile.innerHTML = '\
<div class="tileLeft">\
<div class="indicator"><div class="largeGlyph"></div></div>\
<div class="mainvalue"></div>\
<div dir="ltr" class="changedValue">\
<div class="changedPrice"></div><span class="changedPercentVal"></span><span class="percentSign">%</span>\
</div>\
</div>\
<div class="tileRight">\
<div class="openPrice"><div class="header"></div><div class="value"></div></div>\
<div class="dayRange"><div class="header"></div><div class="value"></div></div>\
<div class="prevClose"><div class="header"></div><div class="value"></div></div>\
<div class="yearRange"><div class="header"></div><div class="value"></div></div>\
<div class="oneYearsReturns"><div class="header"></div><div class="value"></div></div>\
<div class="numberOfConstituents"><div class="header"></div><div class="value"></div></div>\
</div>\
</div>';
var tileLeft = elems.tileLeft = chartTile.children[0];
var tileRight = elems.tileRight = chartTile.children[1];
elems.largeGlyph = tileLeft.children[0].children[0];
elems.mainValue = tileLeft.children[1];
elems.changedPrice = tileLeft.children[2].children[0];
elems.changePercent = tileLeft.children[2].children[1];
elems.percentSign = tileLeft.children[2].children[2];
elems.openPrice = tileRight.children[0].children[1];
elems.dayRange = tileRight.children[1].children[1];
elems.previousClose = tileRight.children[2].children[1];
elems.yearRange = tileRight.children[3].children[1];
elems.oneYearReturns = tileRight.children[4].children[1];
elems.numConstituents = tileRight.children[5].children[1];
elems.openPriceHeader = tileRight.children[0].children[0];
elems.dayRangeHeader = tileRight.children[1].children[0];
elems.prevCloseHeader = tileRight.children[2].children[0];
elems.yearRangeHeader = tileRight.children[3].children[0];
elems.oneYearReturnsHeader = tileRight.children[4].children[0];
elems.numConstituentsHeader = tileRight.children[5].children[0];
elems.openPriceHeader.textContent = utils.getResourceString("MTOpen");
elems.dayRangeHeader.textContent = utils.getResourceString("MTDay Range");
elems.prevCloseHeader.textContent = utils.getResourceString("MT PRev Close");
elems.yearRangeHeader.textContent = utils.getResourceString("MT52 Wk Range");
elems.oneYearReturnsHeader.textContent = utils.getResourceString("IdxYrReturnPct");
elems.numConstituentsHeader.textContent = utils.getResourceString("IdxNumConstituents");
container.appendChild(chartTile);
};
function keyEventHandler(event) {
var keyCode = event.keyCode;
if (!FinanceAppJS.Utils.Navigator.checkKeyPressed(keyCode)) {
FinanceAppJS.Utils.Navigator.leftRightArrowKeyDown(event, false, true);
/*we dont want to scroll the screen on first and last instance of rows.*/
event.stopImmediatePropagation();
event.preventDefault();
}
};
function createChartSelector(container, data, elems) {
var chartSelectorContainer = document.createElement("div");
chartSelectorContainer.className = "chartSelectorContainer";
elems.chartSelectors = [];
data.indicesList.forEach(function (item, index) {
var chartSelector = document.createElement("div");
elems.chartSelectors.push(chartSelector);
chartSelector.className = "chartSelector";
chartSelector.role = "button";
chartSelector.textContent = item.displayName;
chartSelector.onkeydown = keyEventHandler;
if (index === 0) {
chartSelector.tabIndex = 0;
}
chartSelectorContainer.appendChild(chartSelector);
});
container.appendChild(chartSelectorContainer);
};
function createChartRangeSelector(container, data, elems) {
var chartRangeSelectorContainer = elems.chartRangeSelectorContainer = document.createElement("div");
chartRangeSelectorContainer.className = "chartRangeSelectorContainer";
container.appendChild(chartRangeSelectorContainer);
};
function createBottomDetails(container, data, elems) {
var bottomDetails = document.createElement("div");
bottomDetails.className = "chartBottomDetailsContainer";
createChartRangeSelector(bottomDetails, data, elems);
var bottomRight = document.createElement("div");
bottomRight.className = "chartBottomRightButtonsContainer";
/// <disable>JS2009.MultilineStrings</disable>
bottomRight.innerHTML = '\
<button class="quoteSearchglyphParent indexDetailsButtonContainer" role="link" tabindex="0">\
<span class="win-commandring win-commandicon roundUIBtnDark financeGlyphReadMore"></span>\
<span class="quoteSearchglyphTextContent"></span>\
</button>\
<button class="quoteSearchglyphParent" tabindex="0">\
<span class="quoteSearchglyph win-commandring win-commandicon roundUIBtnDark"></span>\
<span class="quoteSearchglyphTextContent"></span>\
</button>';
var quoteSearchButton = elems.quoteSearchButton = bottomRight.children[1];
var indexDetailsButton = elems.indexDetailsButton = bottomRight.children[0];
quoteSearchButton.onclick = function () { utils.showSearchPane(); };
quoteSearchButton.children[1].textContent = utils.getResourceString("SearchQuotes");
indexDetailsButton.children[1].textContent = utils.getResourceString("IndexDetails");
quoteSearchButton.addEventListener("MSLostPointerCapture", PlatformJS.Utilities.pointerEventListenersMap["MSLostPointerCapture"], false);
quoteSearchButton.addEventListener("MSPointerCancel", PlatformJS.Utilities.pointerEventListenersMap["MSPointerCancel"], false);
quoteSearchButton.addEventListener("MSPointerUp", PlatformJS.Utilities.pointerEventListenersMap["MSPointerUp"], false);
quoteSearchButton.addEventListener("MSPointerDown", PlatformJS.Utilities.pointerEventListenersMap["MSPointerDown"], false);
quoteSearchButton.addEventListener("MSPointerOut", PlatformJS.Utilities.pointerEventListenersMap["MSPointerOut"], false);
indexDetailsButton.addEventListener("MSLostPointerCapture", PlatformJS.Utilities.pointerEventListenersMap["MSLostPointerCapture"], false);
indexDetailsButton.addEventListener("MSPointerCancel", PlatformJS.Utilities.pointerEventListenersMap["MSPointerCancel"], false);
indexDetailsButton.addEventListener("MSPointerUp", PlatformJS.Utilities.pointerEventListenersMap["MSPointerUp"], false);
indexDetailsButton.addEventListener("MSPointerDown", PlatformJS.Utilities.pointerEventListenersMap["MSPointerDown"], false);
indexDetailsButton.addEventListener("MSPointerOut", PlatformJS.Utilities.pointerEventListenersMap["MSPointerOut"], false);
bottomDetails.appendChild(bottomRight);
container.appendChild(bottomDetails);
};
function createChartControl(container, data, elems) {
var chartHolder = document.createElement("div");
chartHolder.className = "chartHolder";
chartHolder.style.width = chartHolder.style.height = "auto";
var chartContainer = document.createElement("div");
chartContainer.className = "chartContainer";
var curIndex = data.indicesList[data.activeIndex];
var duration = data.rangeSelectors[data.activeRangeIndex];
var activeSeries = { seriesId: curIndex.symbol + duration, displayName: curIndex.displayName };
chartContainer.winControl = new FinanceAppJS.UI.appexStockChart(chartContainer, { enableHover: 'mouseAndTouch', disableHoverOnBlur: 'true', activeSeries: activeSeries });
chartHolder.appendChild(chartContainer);
elems.chartContainer = chartContainer;
container.appendChild(chartContainer);
};
function renderer(data, chartSection, elems) {
elems = elems || {};
if (!chartSection) {
chartSection = document.createElement("div");
createChartSelector(chartSection, data, elems);
createChartTile(chartSection, data, elems);
createChartControl(chartSection, data, elems);
createBottomDetails(chartSection, data, elems);
chartSection.className = "chartSection";
}
updateChartTile(elems, data);
return chartSection;
}
WinJS.Namespace.define("FinanceAppJS.Renderers", {
TodayIndexChart: renderer
});
})();