﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.WatchListPano", {
MyStocksClusterDual: WinJS.Class.derive(FinanceAppJS.Controls.BaseCluster, function (domElement, options) {
FinanceAppJS.Controls.BaseCluster.call(this, domElement, options);
this.clusterItems = null;
this._loadTemplatePromiseFunc_binding = this._loadTemplatePromiseFunc.bind(this);
this._templateProvider_S_binding = this._templateProvider_S.bind(this);
this._itemTemplate_S_binding = this._itemTemplate_S.bind(this);
this._itemTemplateSelector_S_binding = this._itemTemplateSelector_S.bind(this);
this._loadingStateChangedCallback_binding = this._loadingStateChangedCallback.bind(this);
this._headerRenderer_binding = this._headerRenderer.bind(this);
this._resetProvider_binding = this.resetProvider.bind(this);
this._createSkeleton();
this.roaming = new FinanceAppJS.Roaming();
this._currentMode = this.roaming.readWatchlistModeFromRoaming();
this._addBtnBinding = this.onAddItemInvoked.bind(this);
this._delBtnBinding = this.onItemDeleted.bind(this);
this._reorderBinding = this.onItemReorder.bind(this);            
WinJS.Utilities.addClass(this._domElement, "watchListCluster");
WinJS.UI.setOptions(this, options);
},
{
_dragElementBinding: WatchListDataProvider.getWatchListDragElement,
currentMode: {
get: function get() {
return this._currentMode;
},
set: function set(value) {
this._currentMode = value;
this.roaming.writeWatchlistModeToRoaming(value);
this._changeRenderMode();
},
},
onItemReorder: function onItemReorder() {
var symbols = this.view.getOrder();
this.roaming.setWatchlist(symbols);
},
onAddItemInvoked: function onAddItemInvoked() {
var page = FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId);
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(page,
"",
FinanceAppJS.Telemetry.Constants.Location.ADD,
"");
FinanceAppJS.Utilities.QuickSearch.getInstance().showQuickSearch();
},
onItemDeleted: function onItemDeleted(item) {
var toBeDeleted = [];
/* null check to not crash ListView2 is sometimes invoking this with addTile. 
remove it after CUX fixes it. */
if (!item.detail.tileData) {
return;
}
toBeDeleted.push({ symbol: WatchListManage.getSymbolFromTileData(item.detail.tileData) });
this.roaming.removeFromWatchlist(toBeDeleted);
},
_createSkeleton: function _createSkeleton() {
this._listModeRoot = utils.createElement(this._domElement, "div");
this._initializeListMode();
},
_initializeListMode: function _initializeListMode() {
WinJS.Utilities.addClass(this._listModeRoot, "listModeRoot");
this._header = utils.createElement(this._listModeRoot, "div");
this._listView = utils.createElement(this._listModeRoot, "div");
this._listView.addEventListener("mousewheel", CommonJS.Immersive.PanoramaPanel.verticalScrollHandler, false);
},
// declare null aliases for auto-complete to work
_header: null,
_renderedMode: null, /* takes values list/tile */
_currentMode: null,
onitemclick: null,
_view: null,
_sort: null,
_sortDir: null,
listViewFeatures: CommonJS.UI.ListView2.FEATURES.ADD + CommonJS.UI.ListView2.FEATURES.REMOVE,
view: {
get: function get() {
if (!this._view) {
this._view = new CommonJS.UI.ListView2(this._listView, {
friendlyName: "watchlist",
layout: { type: WinJS.UI.ListLayout },
draggedElementRender: this._dragElementBinding,
enabledFeatures: this.listViewFeatures,
selectionMode: 'multi',
dragThreshold: 200,
onadditeminvoked: this._addBtnBinding,
onitemdeleted: this._delBtnBinding,
onlistreordered: this._reorderBinding,
itemTemplate: this._itemTemplate_S_binding,
});
}
return this._view;
}
},
currentSort: {
set: function set(sort) {
if (!this._sortDir || this._sort !== sort) {
this._sortDir = 1; //Ascending Order.
} else {
this._sortDir = this._sortDir * -1; //Descending Order.
}
this._sort = sort;
this._doSortOnNextRefresh = true;
this._triggerRefresh();
},
get: function get() {
return this._sort;
}
},
_triggerRefresh: function _triggerRefresh() {
var wlProvider = this.ipage.getDataProvider("EquityDataProvider");
wlProvider.getData({ listenerId: "myStocksCluster" });
},
_sortData: function _sortData(data) { // expecting watchlist data to be sorted.
var toSort = [];
var invEntries = [];
var sortField = this._sort;
for (var i = 0; i < data.length; i++) {
var item = data[i];
if (item.tileData[sortField] === null ||
typeof item.tileData[sortField] === 'undefined' ||
item.tileData[sortField] === "-") {
invEntries.push(item);
} else {
toSort.push(item);
}
}
var sort_func = function (field, reverse) {
return function (a, b) {
var A = a.tileData[field], B = b.tileData[field];
return ((A < B) ? -1 :
(A > B ? +1 : 0)) * reverse;
};
};
if (this._sortDir === 1) {
toSort.sort(sort_func(sortField, 1));
} else {
toSort.sort(sort_func(sortField, -1));
}
return toSort.concat(invEntries);
},
_changeRenderMode: function _changeRenderMode() {
if (this._currentMode === this._renderedMode) {
return;
}
if (this._currentMode === "list") {
WinJS.Utilities.removeClass(this._listView, "tileClusterData");
WinJS.Utilities.addClass(this._listView, "listClusterData");
WinJS.Utilities.addClass(this._domElement, "watchListClusterListView");
} else if (this._currentMode === "tile") {
WinJS.Utilities.removeClass(this._listView, "listClusterData");
this._listView.style.width = "auto";
WinJS.Utilities.addClass(this._listView, "tileClusterData");
WinJS.Utilities.removeClass(this._domElement, "watchListClusterListView");
}
var that = this;
this.templatePromise.then(function (templates) {
that._headerRenderer(templates);
WinJS.UI.setOptions(that.view, {
layout: that._currentMode === "list" ? new WinJS.UI.ListLayout() : new WinJS.UI.GridLayout(),
enabledFeatures: that.currentMode === "list" ? (CommonJS.UI.ListView2.FEATURES.ADD + CommonJS.UI.ListView2.FEATURES.REMOVE) : (CommonJS.UI.ListView2.FEATURES.ADD + CommonJS.UI.ListView2.FEATURES.REMOVE + CommonJS.UI.ListView2.FEATURES.REORDER)
});
that._renderedMode = that._currentMode;
});
},
update: function update(data) {
if (this._currentMode === "list") {
return this.updateList(data);
} else if(this._currentMode === "tile") {
return this.updateTile(data);
}
},
updateTile: function updateTile(data) {
if (this._renderedMode !== this._currentMode) {
this.clusterItems = null;
WinJS.Utilities.removeClass(this._listView, "listClusterData");
WinJS.Utilities.addClass(this._listView, "tileClusterData");
}
return this.listUpdateHandler(data.Wl);
},
updateList: function updateList(data) {
if (this._renderedMode !== this._currentMode) {
this.clusterItems = null;
WinJS.Utilities.removeClass(this._listView, "tileClusterData");
WinJS.Utilities.addClass(this._listView, "listClusterData");
WinJS.Utilities.addClass(this._domElement, "watchListClusterListView");
}
return this.listUpdateHandler(data.Wl);
},
createHeaderItem: function createHeaderItem() {
var item = {};
item.tileData = {
nameHeader: utils.getResourceString("NameField"),
lpHeader: utils.getResourceString("LastPrice"),
changeHeader: utils.getResourceString("IndexCh"),
yRangeHeader: utils.getResourceString("YEAR_HIGH_LOW"),
dRangeHeader: utils.getResourceString("DAY_HIGH_LOW"),
volumeHeader: utils.getResourceString("SE Volume"),
yieldHeader: utils.getResourceString("DIVIDEND_YIELD"),
peHeader: utils.getResourceString("PRICE_EARNING_RATIO"),
fpeHeader: utils.getResourceString("FORWARD_PRICE_EARNING_RATIO"),
marketcapHeader: utils.getResourceString("SEMarket Cap"),
epsHeader: utils.getResourceString("EARNINGS_PER_SHARE"),
pricebookHeader: utils.getResourceString("PRICE_BOOK"),
rpMonthHeader: utils.getResourceString("RETURN_PERCENTAGE_MONTHLY"),
rpYearHeader: utils.getResourceString("RETURN_PERCENTAGE_YEARLY"),
betaHeader: utils.getResourceString("SEBeta"),
nameHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "instrumentFullName")),
lpHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "instrumentSortLp")),
changeHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "instrumentSortChp")),
volumeHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "V")),
peHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "Pe")),
fpeHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "FpEPS")),
yieldHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "Dy")),
marketcapHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "Mc")),
epsHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "Eps")),
pricebookHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "PtB")),
rpMonthHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "Rm")),
rpYearHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "Ry")),
betaHeaderClick: WinJS.Utilities.markSupportedForProcessing(this.onListHeaderClick.bind(this, "Beta")),
};
return item;
},
prevHeader: null,
clearSortIcon: function clearSortIcon() {
if (this.prevHeader) {
WinJS.Utilities.removeClass(this.prevHeader, "upGlyph");
WinJS.Utilities.removeClass(this.prevHeader, "downGlyph");
WinJS.Utilities.removeClass(this.prevHeader.parentElement, "header-selected");
}
},
onListHeaderClick: function onListHeaderClick(sortField, event) {
// adding keypress handler.
if (event.type !== "click" && event.keyCode !== WinJS.Utilities.Key.enter && event.keyCode !== WinJS.Utilities.Key.space) {
return false;
}
this.currentSort = sortField;                
var target = event.target;
this.clearSortIcon();                
if (this._sortDir === 1) {
WinJS.Utilities.removeClass(target, "upGlyph");
WinJS.Utilities.addClass(target, "downGlyph");
} else if (this._sortDir === -1) {
WinJS.Utilities.removeClass(target, "downGlyph");
WinJS.Utilities.addClass(target, "upGlyph");
}
WinJS.Utilities.addClass(target.parentElement, "header-selected");
WatchListManage.addStocksToWatchlist(this._view, this.roaming);
this.prevHeader = target;
},
_saveNewSortOrder: function _saveNewSortOrder(data) {
var symbols = [];
for (var i = 0; i < data.length; i++) {
symbols.push(data[i].itemKey);
}
if (symbols.length) {
this.roaming.setWatchlist(symbols);
}
else {
this.roaming.clearWatchList();
}
var wlProvider = this.ipage.getDataProvider("EquityDataProvider");
if (wlProvider) {
wlProvider.invalidateSymbols = true;
wlProvider.clear();
}
},
listUpdateHandler: function listUpdateHandler(data) {
this._itemRenderPromises = null;
// Do not change the data in the provider.
data = utils.deepCopy(data);
for (var i = 0 ; i < data.length; i++) {
data[i].itemKey = WatchListManage.getSymbolFromTileData(data[i].tileData);
}
if (this._doSortOnNextRefresh && this._sort) {
data = this._sortData(data);
this._saveNewSortOrder(data);
this._doSortOnNextRefresh = false;
}
if (this.clusterItems && this.clusterItems.length ) {
var stkTilesLength = this.clusterItems.length - 1;
var newDataLength = data.length;
for (var i = 0, item; i < stkTilesLength && i < data.length && (item = this.clusterItems.getAt(i)) ; i++) {
if (data[i] && data[i].tileData) {
utils.deepCopy(data[i], item);
// Should set these values explicitly so that the listener is activated 
// and control gets the new data
item.tileData.instrumentDayValues = data[i].tileData.instrumentDayValues; 
item.tileData.instrumentYearValues = data[i].tileData.instrumentYearValues;
}
}
if (stkTilesLength < newDataLength) {
var listBinding = this.clusterItems;
var dataToInsert = data.splice(stkTilesLength, (newDataLength - stkTilesLength));
var insertAtPos = stkTilesLength;
while (dataToInsert.length > 0) {
listBinding.splice(insertAtPos, 0, dataToInsert.shift());
insertAtPos++;
}
}
return WinJS.Promise.as({});
}
else {
return this.invalidate(data);
}
},
_templatePromise: null,
_headerRendered: false,
templatePromise: {
get: function get() {
return (this._templatePromise = this._templatePromise || WatchListDataProvider.watchListTemplates(false));
},
},
/// <summary>
/// Invalidates the News cluster by querying the service and binding the resulting data to the view.
/// </summary>
invalidate: function invalidate(response) {
this.clusterItems = new WinJS.Binding.List(response, { binding: true });
this._renderedMode = this._currentMode;
return new WinJS.Promise(this._loadTemplatePromiseFunc_binding);
},
_templates: null,
_loadTemplatePromiseComplete: null,
_loadTemplatePromiseFunc: function _loadTemplatePromiseFunc(complete, error) {
this._loadTemplatePromiseComplete = complete ;
this.templatePromise
.then(this._headerRenderer_binding)
.then(this._templateProvider_S_binding);
},
_measureHeaderWidths: function _measureHeaderWidths() {
/* cleanup this in dispose() */
var cols = this._actualColumnWidths = utils.deepCopy(FinanceAppJS.WatchListPano.MyStocksClusterDual.listModeFields);
var headerRoot = this._header;
cols.forEach(function (item) {
item.elem = headerRoot.querySelector("." + item.id);
var itemMinWidth = parseInt(item.elem.currentStyle.minWidth);
var child = item.elem.childNodes[1]; // get the element to measure.
item.actualInnerWidth = itemMinWidth > child.clientWidth ? itemMinWidth : child.clientWidth;
item.actualMinWidth = itemMinWidth;
item.actualWidth = item.elem.clientWidth;
});
},
_actualColumnWidths: null,
_showAndHideColumns: function _showAndHideColumns() {
var avlblWidth = document.body.offsetWidth - 162; /* 120 + 42 */
var headerRoot = this._header;
var cols = this._actualColumnWidths;
var listWidth = 0, item = null;
var i = 0, showCount = 0;
for (i = 0; i < cols.length > 0 && avlblWidth >= cols[i].actualWidth; i++) {
var col = cols[i];
avlblWidth -= col.actualWidth;
listWidth += col.actualWidth;
col.elem.style.display = "-ms-grid";
col.showorhide = "show";
showCount++;
}
for (; i < cols.length; i++) {
cols[i].elem.style.display = "none";
cols[i].showorhide = "hide";
}
var widthToSplit = avlblWidth / showCount;
for (var j = 0; j < showCount; j++) {
cols[j].innerWidth = cols[j].actualInnerWidth + widthToSplit;
cols[j].elem.style.minWidth = cols[j].innerWidth + "px";
}
listWidth = listWidth + avlblWidth;
this._listView.style.width = listWidth + 24 + "px"; /* 24 for vertical scroll */
},
_headerRenderer: function _headerRenderer(templates) {
var that = this;
var promise = WinJS.Promise.as({});
if (!this._headerRendered) {
var itemTemplate = templates['listModeHeaderTemplate'];
this._header.style.position = "absolute";
this._header.style.visibility = "hidden";
var headerItem = this.createHeaderItem();
promise = promise
.then(function () {
return itemTemplate.winControl.render(headerItem, that._header);
})
.then(function () {
that._measureHeaderWidths();
that._header.style.position = "static";
that._header.style.visibility = "visible";
that._header.style.height = "30px";
that._header.style.display = "none";
that._headerRendered = true;
});
}
promise.then(function () {
if (that._currentMode === "list") {
/* set the visibility of header to visible */
that._showAndHideColumns();
that._header.style.display = "block";
} else {
that._header.style.display = "none";
}
});
return promise.then(function () { return templates; });
},
_templateProvider_S: function _templateProvider_S(templates) {
this._templates = templates;
var itemRenderPromises = [];
this._itemRenderPromises = itemRenderPromises;
WinJS.UI.setOptions(this.view, {
layout: this.currentMode === "list" ? new WinJS.UI.ListLayout() : new WinJS.UI.GridLayout(),
enabledFeatures: this.currentMode === "list" ? (CommonJS.UI.ListView2.FEATURES.ADD + CommonJS.UI.ListView2.FEATURES.REMOVE) : (CommonJS.UI.ListView2.FEATURES.ADD + CommonJS.UI.ListView2.FEATURES.REMOVE + CommonJS.UI.ListView2.FEATURES.REORDER)
});
WinJS.UI.setOptions(this.view, {
itemDataSource: (this.clusterItems && this.clusterItems.dataSource) || null,
onloadingstatechanged: this._loadingStateChangedCallback_binding
});
},
_loadingStateChangedCallback: function _loadingStateChangedCallback(event) {
if (this.view && this.view.loadingState === "itemsLoaded") {
this.view.removeEventListener("loadingstatechanged", this._loadingStateChangedCallback_binding, false);
this._itemRenderPromises = null;
this.templates = null;
this._loadTemplatePromiseComplete();
this.clusterItems.addEventListener("iteminserted", this._resetProvider_binding);
this.clusterItems.addEventListener("itemremoved", this._resetProvider_binding);
this.clusterItems.addEventListener("itemmoved", this._resetProvider_binding);
}
},
resetProvider: function resetProvider() {
// Reset Data Provider
// ToDo: investigate further cleanup on addStock.
this.clearSortIcon();
var wlProvider = this.ipage.getDataProvider("EquityDataProvider");
if (wlProvider) {
wlProvider.invalidateSymbols = true;
wlProvider.clear();
}
else {
debugger;
}
},
_itemTemplate_S: function _itemTemplate_S(itemPromise) {
return itemPromise.then(this._itemTemplateSelector_S_binding);
},
_itemTemplateSelector_S: function _itemTemplateSelector_S(item) {
if (this._itemRenderPromises && this._itemRenderPromises.length) {
return this._itemRenderPromises.shift();
}
return WatchListDataProvider.watchListTemplateSelector(item.data, this._templates, this._currentMode, this._actualColumnWidths);
},
dispose: function dispose() {
if (this.clusterItems) {
this.clusterItems.removeEventListener("iteminserted", this._resetProvider_binding);
this.clusterItems.removeEventListener("itemremoved", this._resetProvider_binding);
this.clusterItems.removeEventListener("itemmoved", this._resetProvider_binding);
}
this._actualColumnWidths = null;
this._templatePromise && this._templatePromise.cancel();
},
onOrientationChange: function onOrientationChange(event) {
this._refreshControl();
},
onDpiChange: function onDpiChange(event) {
this._refreshControl();
},
onWindowResize: function onWindowResize(event) {
this._refreshControl();
},
_refreshControl: function _refreshControl() {
var that = this;
this.templatePromise.then(function (templates) {
that._headerRenderer(templates);
that.view.forceLayout();
});
}
}, {
listModeFields: [
{ id: "nameField" },
{ id: "lastpriceField" },
{ id: "changeField" },
{ id: "volumeField" },
{ id: "dayRangeField" },
{ id: "yearRangeField" },
{ id: "marketcapField" },
{ id: "peField" },
{ id: "fpeField" },
{ id: "yieldField" },
{ id: "epsField" },
{ id: "pricebookField" },
{ id: "rpMonthField" },
{ id: "rpYearField" },
{ id: "betaField" },
]        
})
});
})();
