﻿var _gSelectedItemCountPrev = 0;
var _gSelectedItemCountCurrent = 0;
var _gNowItemSelected = false;
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
WatchlistPage: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
/// <summary>
/// Constructor for a simple IPage class that controls the FundFilmStrip
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
FinanceAppJS.FinanceBasePage.call(this, state);
//TODO: Make these member variables in both home page and here
_gSelectedItemCountPrev = 0;
_gSelectedItemCountCurrent = 0;
_gNowItemSelected = false;
this.roaming = new FinanceAppJS.Roaming();
var that = this;
var equityDataProviderOptions = { isSnapped: false, refreshInterval: FinanceAppJS.Constants.RefreshIntervals.HomePageEquityData, wlSymbols: this.roaming.getWatchListSymbols() };
var clusterDefinitions = {
myStocksCluster: {
clusterTitle: "WatchList",
clusterControl: "FinanceAppJS.WatchListPano.MyStocksClusterDual",
clusterOptions: {
className: "MyStocksPage",
onrendercomplete: function onrendercomplete(event) {
var sortDetails = document.querySelector(".edgySortButton .win-command");
if (sortDetails) {
sortDetails.id = "sortBtn";
sortDetails.setAttribute("aria-describedby", "sortBtn");
}
var viewDetails = document.querySelector(".edgyModeButton .win-command");
if (viewDetails) {
viewDetails.id = "viewBtn";
viewDetails.setAttribute("aria-describedby", "viewBtn");
}
that._addEventListenersForListView();
that._setWaterMarkPosition(that.roaming.readWatchlistModeFromRoaming());
msSetImmediate(function watchListNarratorText () {
//Bind aria-labels to respective win-item in watchlist.
var markWatchListObj = document.querySelector(".listModeRoot");
if (markWatchListObj) {
var watchListItems = markWatchListObj.querySelectorAll(".win-item");
if (watchListItems && watchListItems.length > 0) {
//add customw narator text
utils.addCustomAriaLabelToTiles(watchListItems, "naratorText");
}
// If there are no items, hide pin/unpin button panel
if (watchListItems && watchListItems.length === 1) {
WatchListManage.handlePinButtonsVisibility(false);
WatchListManage.handleSortButtonsVisibility(false);
}
}
});
},
},
dataProviders: {
EquityDataProvider: equityDataProviderOptions
}
}
};
this.setClusterDefinitions(clusterDefinitions);
this.pageTitle = utils.getResourceString("chMyStocks");
}, {
pinUnpinManager: null,
/// <summary>
/// This function is invoked by the UX Framework when the orientation has changed
/// </summary>
/// <returns>
/// Nothing
/// </returns>
onOrientationChange: function onOrientationChange(event) {
// call base class handler
FinanceAppJS.FinanceBasePage.prototype.onOrientationChange.call(this);
},
/// <summary>
/// This function is invoked when dpi changes ("Make everything on your screen bigger" setting)
/// </summary>
/// <param name="event">
/// Dpi change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
onDpiChange: function onDpiChange(event) {
FinanceAppJS.FinanceBasePage.prototype.onDpiChange.call(this);
},
onVisibilityChanged: function onVisibilityChanged()
{
if (document.msVisibilityState === "visible") {
if (this.listElmWin && this.listElmWin.selection) {
var selection = this.listElmWin.selection;
var selectedItemsCount = selection.count();
if (selectedItemsCount === 0) {
this.pinUnpinManager.updateBottomSwipyPinButtons(FinanceAppJS.Constants.IDs.WATCHLIST_SYMBOL, FinanceAppJS.Constants.IDs.WatchList);
}
else if (selectedItemsCount === 1) {
var pupm = this.pinUnpinManager;
selection.getItems().then(function (items) {
if (items && items.length === 1) {
var selectedItem = items[0].data.tileData;
pupm.updateBottomSwipyPinButtons(utils.getGlobalInstrumentSymbol(selectedItem), selectedItem.type);
}
});
}
}
}
},
onNavigateAway: function onNavigateAway(reason) {
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away
/// </summary>
/// <param name="reason">
/// The reason why the page is being navigated away: "backNavigation" or "newNavigation"
/// </param>
/// <returns>
/// Nothing
/// </returns>
FinanceAppJS.FinanceBasePage.prototype.onNavigateAway.call(this);
if (this.pinUnpinManager) {
this.pinUnpinManager.clean();
}
if (this._btnMoveUp) {
this._btnMoveUp.removeEventListener("click", this.moveUpHandler, false);
}
if (this._btnMoveDown) {
this._btnMoveDown.removeEventListener("click", this.moveDownHandler, false);
}
FinanceAppJS.Utilities.QuickSearch.getInstance().release();
},
_initializedOnce: false,
_addEventListenersForListView: function _addEventListenersForListView() {
/// <summary>Initialize the Bottom swipy buttons and do it only once.</summary>
/// <summary>No need to do it on subsequent updates</summary>
var that = this;
if (this._initializedOnce) {
return;
}
var listElm = that.getClusterControl("myStocksCluster");
var bottomEdgy = document.querySelector("#bottomAppbar");
if (listElm && listElm.clusterItems && bottomEdgy) {                    
var btnClearSelection = document.getElementById("btnClearSelection");
var btnMoveUp = document.getElementById("btnMoveUp");
var btnMoveDown = document.getElementById("btnMoveDown");
var reorderButtons = document.querySelector("#reorderButtons");
// Set Button Labels Text
utils.setWinLabelText(btnAddStock, "BTN_LABEL_ADD_TO_WATCHLIST");                    
utils.setWinLabelText(btnClearSelection, "MyStocksClearSelection");
utils.setWinLabelText(btnMoveUp, "MoveUP");
utils.setWinLabelText(btnMoveDown, "MoveDown");
var listElmWin = listElm.view;
this.listElmWin = listElmWin;
FinanceAppJS.Utilities.QuickSearch.getInstance().init(this.listElmWin, FinanceAppJS.Constants.IDs.WatchList, this.getDataProvider("EquityDataProvider"));
this.bottomEdgy = bottomEdgy;
//add Instrumentation ids for item click.
var optionItem = {};
optionItem.PageId = FinanceAppJS.Constants.IDs.WatchList;
WatchListManage.attachBasicListEvents(this, listElm, btnClearSelection, true, reorderButtons, optionItem, true);
WatchListManage.attachBasicPageEvents(this, listElm, btnClearSelection, true, reorderButtons, optionItem);
this.moveUpHandler = this.moveUpStub.bind(this);
this.moveDownHandler = this.moveDownStub.bind(this);
// Attach event to move UP
btnMoveUp.addEventListener("click", this.moveUpHandler, false);
// Attach event to move Down
btnMoveDown.addEventListener("click", this.moveDownHandler, false);
this._btnMoveUp = btnMoveUp;
this._btnMoveDown = btnMoveDown;
this._initializedOnce = true;
}
},
moveUpStub: function moveUpStub() {
var promise = WatchListManage.handleMove(this.listElmWin, "up");
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.Moveup_mystock_Click, 1);
promise.then(WatchListManage.addStocksToWatchlist.bind(this, this.listElmWin, this.roaming));
},
moveDownStub: function moveDownStub() {
var promise = WatchListManage.handleMove(this.listElmWin, "down");
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.Movedown_mystock_Click, 1);
promise.then(WatchListManage.addStocksToWatchlist.bind(this, this.listElmWin, this.roaming));
},
onBindingComplete: function onBindingComplete() {
FinanceAppJS.FinanceBasePage.prototype.onBindingComplete.call(this);
this._createModeEdgyButton();
this._createSortEdgyButton();
// set initial hide/unhide.
var mode = this.roaming.readWatchlistModeFromRoaming();
var watchlistcnt = this.roaming.getWatchlistCount();
this._handleAdsClusterVisibility(mode);
if (mode === "list") {
WatchListManage.handleSortButtonsVisibility(false);
} else if (mode === "tile") {
if (watchlistcnt !== 0) {
WatchListManage.handleSortButtonsVisibility(true);
}
else {
WatchListManage.handleSortButtonsVisibility(false);
}
}
this.pinUnpinManager = new FinanceAppJS.PinUnpinManager("#bottomAppbar", this.getPageState(), FinanceAppJS.Constants.IDs.WatchList, FinanceAppJS.Constants.IDs.WATCHLIST_SYMBOL, null, null, null, null, FinanceAppJS.Constants.Instrumentation.PinStart_mystock_Click);
var sortItems = document.querySelectorAll(".sort-item");
if (sortItems) {
for (var i = 0; i < sortItems.length; i++) {
sortItems[i].id = sortItems[i].textContent.toString().replace(/\s/g, "");
sortItems[i].setAttribute("aria-describedby", sortItems[i].textContent);
}
}
},
_setIconForMode: function _setIconForMode(modeFromRoaming, mb) {
if (modeFromRoaming === "tile") {
WinJS.Utilities.removeClass(mb, "tilemode");
WinJS.Utilities.addClass(mb, "listmode");
mb.winControl.icon = '\uE263';
utils.setWinLabelText(mb, "ListView");
} else {
WinJS.Utilities.removeClass(mb, "listmode");
WinJS.Utilities.addClass(mb, "tilemode");
mb.winControl.icon = '\uE264';
utils.setWinLabelText(mb, "GridView");
}
},
_createModeEdgyButton: function _createModeEdgyButton() {
var mb = this._modeChangeButton = document.querySelector("#viewBtn");
var modeFromRoaming = this.roaming.readWatchlistModeFromRoaming();
this._setIconForMode(modeFromRoaming, mb);
if (this._modeChangeButton) {
this._modeChangeButton.addEventListener("click", this._onModeClicked.bind(this));
}
},
_onModeClicked: function _onModeClicked(mode) {
// array, identifier/label
var newMode = null;
var modeFromRoaming = this.roaming.readWatchlistModeFromRoaming();
if (modeFromRoaming === "tile") {
newMode = "list";
} else {
newMode = "tile";
}
this._setIconForMode(newMode, this._modeChangeButton);
var wlControl = this.getClusterControl("myStocksCluster");
this._handleAdsClusterVisibility(newMode);
wlControl.currentMode = newMode;
var watchlistcnt = this.roaming.getWatchlistCount();
var page = FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId);
var location = newMode === "list" ? FinanceAppJS.Telemetry.Constants.BtmEdgyBtn.VUBYLIST : FinanceAppJS.Telemetry.Constants.BtmEdgyBtn.VUBYTILE;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(page,
FinanceAppJS.Telemetry.Constants.Cluster.BOTTOMEDGY,
location,
newMode);
if (newMode === "list") {
WatchListManage.handleSortButtonsVisibility(false);
} else if (newMode === "tile") {
if (watchlistcnt !== 0) {
WatchListManage.handleSortButtonsVisibility(true);
}
else {
WatchListManage.handleSortButtonsVisibility(false);
}
}
var topEdgy = document.getElementById("platformNavigationBar");
if (topEdgy && topEdgy.winControl) {
topEdgy.winControl.hide();
}
this._setWaterMarkPosition(newMode);
},
_setWaterMarkPosition: function _setWaterMarkPosition(mode) {
var waterMark = document.querySelector(".platformWatermark");
if (!waterMark) {
return;
}
if (mode === "list") {
waterMark.style.bottom = "0px";
} else if (mode === "tile") {
waterMark.style.bottom = "20px";
}
},
_handleAdsClusterVisibility: function _handleAdsClusterVisibility(mode) {
/* dont add Ads Cluster in list mode */
var c1 = document.getElementById("FinanceAppJS.WatchListPano.MyStocksClusterDual_myStocksCluster");
var marginSelector = document.dir === "ltr" ? "marginRight" : "marginLeft";
var clusterToInsert = [];
var clustersDef = {};
var clusterKey = "AdsCluster";
if (!c1) {
debugger;
return;
}
if (mode === "list") {
c1.style[marginSelector] = "0px";
// Find if there is Ads cluster in the pano and then remove it.
for (var j = 0; j < this._clusters.length ; j++) {
if (this._clusters.getItem(j).data.clusterKey === clusterKey) {
this._clusters.splice(j, 1);
}
}
} else if (mode === "tile") {
c1.style[marginSelector] = "80px";
PlatformJS.Ads.addOrderedAdsClusterConfig(this._clusters);
}
},
getClustersPromise: function getClustersPromise() {
var promise = FinanceAppJS.FinanceBasePage.prototype.getClustersPromise.call(this);
var that = this;
return promise.then(function (clusterList) {
var mode = that.roaming.readWatchlistModeFromRoaming();
if (mode === "list") {
for (var j = 0; j < that._clusters.length ; j++) {
if (that._clusters.getItem(j).data.clusterKey === "AdsCluster") {
that._clusters.splice(j, 1);
}
}
}
return clusterList;
});
},
/* Overriding base class ads insert function to make it a no-op */
/* Ads cluster is added to the pano only when the listview is in tile mode */
_addAdsClusters: function _addAdsClusters() {
return;
},
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Watchlist View";
},
onPageLoadComplete: function onPageLoadComplete() {
FinanceAppJS.FinanceBasePage.prototype.onPageLoadComplete.call(this);
var items = this.modes;
if (!items) {
return ;
}
for (var i = 0; i < items.length; i++) {
if (items[i].selected === true) {
var page = FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId);
var location = items[i].value === "list" ? FinanceAppJS.Telemetry.Constants.BtmEdgyBtn.VUBYLIST : FinanceAppJS.Telemetry.Constants.BtmEdgyBtn.VUBYTILE;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(page,
FinanceAppJS.Telemetry.Constants.Cluster.BOTTOMEDGY,
location,
items[i].value);
return;
}
}
},
_onSortChanged: function _onSortChanged(sort) {
var page = FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId);
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(page,
FinanceAppJS.Telemetry.Constants.Cluster.BOTTOMEDGY,
FinanceAppJS.Telemetry.Constants.BtmEdgyBtn.SORT,
"Sort by " + sort.label);
// array, identifier/label
var newSortIndex = sort.selectedIndex;
var items = this.sorts;
for (var i = 0; i < items.length; i++) {
items[i].selected = false;
}
items[newSortIndex].selected = true;
this.sorts = items;
this.edgySortControl.setItems(this.sorts);
/* set new mode for watchlist cluster and initiate fetchdata */
var wlControl = this.getClusterControl("myStocksCluster");
wlControl.currentSort = sort.value;
WatchListManage.addStocksToWatchlist(this.listElmWin, this.roaming);
},
_createSortEdgyButton: function _createSortEdgyButton() {
if (!this.edgySortControl) {
var buttonText = utils.getResourceString("SORT_BUTTON_STRING");
var ctorOptions = {};
ctorOptions.buttonText = buttonText;
ctorOptions.icon = "sort";
ctorOptions.flyoutHeader = "";
ctorOptions.selectionChanged = this._onSortChanged.bind(this);
this.edgySortControl = new CommonJS.SortFlyout(null, ctorOptions);
var appbar = this.edgySortButton = document.querySelector(".edgySortButton");
if (appbar) {
appbar.appendChild(this.edgySortControl.element);
}
this.sorts = [
{ value: "instrumentFullName", label: utils.getResourceString("NameField"), selected: false },
{ value: "instrumentDisplaySymbol", label: utils.getResourceString("IndexSymbol"), selected: false },
{ value: "instrumentSortLp", label: utils.getResourceString("LastPrice"), selected: false },
{ value: "instrumentSortCh", label: utils.getResourceString("IndexCh"), selected: false },
{ value: "instrumentSortChp", label: utils.getResourceString("IndexChPct"), selected: false },
];
this.edgySortControl.setItems(this.sorts);
}
},
sorts: null,
edgySortControl: null,
edgySortButton: null,
modes: null,
edgyModeControl: null,
getSharedContractData: function getSharedContractData() {
FinanceAppJS.Utils.Logger.LogPerformance("Watchlist.js", "getSharedContractData", FinanceAppJS.Utils.Logger.PerformanceMarks.Start);
var shareContractData = null;
var listElmWin = this.listElmWin;
var dataProvider = this.getDataProvider("WatchlistDataProvider");
var lastUpdateTime = utils.formatLastUpdatedTime(this.lastUpdatedTime);
var listViewDataSource = listElmWin.itemDataSource;
var wlData = {
header: null,
timeAttribution: utils.getResourceString('ShareContractTimeAttribution').format(lastUpdateTime),
dataAttribution: utils.getResourceString('ShareContractDataAttribution'),
source: FinanceAppJS.Constants.IDs.NonIndices,
entities: []
};
var selectedItems = listElmWin.selection.getIndices();
var isSelected = false;
var noOfTiles = 0;
var subject = null;
var promises = [];
if (selectedItems.length) {
isSelected = true;
noOfTiles = selectedItems.length;
}
else {
noOfTiles = (listElmWin._cachedCount - 1);
}
if (noOfTiles) {
// Create a list binding and use it to obtain the items.
var binding = listViewDataSource.createListBinding();
// Item manipulation requires a key, so convert the indexes to keys.
// Form an array of all the item keys and promises.
for (var i = 0; i < noOfTiles; i++) {
var tileIndex = (isSelected) ? selectedItems[i] : i;
// Get the items based on the index (async).
promises[i] = binding.fromIndex(tileIndex).then(function (item) {
var entity = WatchListManage.prepareShareContractData(item);
wlData.entities.push(entity);
});
}
subject = (noOfTiles === 1) ? wlData.entities[0].cmp : utils.getResourceString("MyStocksLabel");
}
var uriBuilder = new Platform.Utilities.AppExUriBuilder();
uriBuilder.controllerId = "watchlist";
var uri = uriBuilder.toString();
wlData.deepLink = uri;
// 
return new WinJS.Promise(function (complete, error) {
if (promises && promises.length) {
// The fromIndex method is async, so use a join to wait for them all to be complete.
WinJS.Promise.join(promises).then(function () {
if (wlData.entities.length) {
utils.getShareContractHtmlFormat(wlData).then(function (htmlOutput) {
complete({
title: utils.getShareContractSubject(subject),
htmlContent: htmlOutput,
textContent: utils.getShareContractTextFormat(wlData),
uri: uri
});
});
}
else {
error({ msg: utils.getResourceString("ShareContractNoWatchListItemsToShare") });
}
FinanceAppJS.Utils.Logger.LogPerformance("Watchlist.js", "getSharedContractData", FinanceAppJS.Utils.Logger.PerformanceMarks.End);
});
}
else {
error({ msg: utils.getResourceString("ShareContractNoWatchListItemsToShare") });
}
});
},
dispose: function dispose() {
if (this.edgyModeControl && this.edgyModeControl.dispose) {
this.edgyModeControl.dispose();
}
if (this.edgySortControl && this.edgySortControl.dispose) {
this.edgySortControl.dispose();
}
FinanceAppJS.FinanceBasePage.prototype.dispose.call(this);
}
})
});
})();
