﻿(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
News: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
/// <summary>
/// Constructor for a simple IPage class that controls the multisizelistview
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
FinanceAppJS.FinanceBasePage.call(this, state);
this._hideQuotesDelayText = true;
var ItemClickCallbacks = {
bussNewsCluster: function bussNewsCluster(event) {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.NonUsNews_Item_Click, 1);
var item = event.item;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
FinanceAppJS.Telemetry.Constants.Cluster.NEWS,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
"article: " + item.contentid);
utils.launchNewsUri(item, Platform.Instrumentation.InstrumentationEditorialSourceId.cluster);
}
};
var that = this;
var bussNewsDataProviders = {};
if (Platform.Utilities.Globalization.isFeatureEnabled("NewsFromCMSEditorial")) {
bussNewsDataProviders.EditorialNewsDataProvider = {};
}
if (utils.isMarketSupportedForBingNews()) {
bussNewsDataProviders.BingNewsDataProvider = { queryType: "category" };
}
var map = PlatformJS.Services.appConfig.getDictionary("MoreSourcesMap");
var sourcesPageName = map.getString("News");
var sources = {};
sources.SourcesDataProvider = { featuredCategory: sourcesPageName };
var clusterDefinitions = {
bussNewsCluster: {
clusterTitle: utils.getResourceString("BussNews"),
clusterControl: Object.keys(bussNewsDataProviders).length === 1 ? "FinanceAppJS.NewsControls.EntityControl" : "FinanceAppJS.NewsControls.NewsMergedCluster",
dataProviders: bussNewsDataProviders,
validateFunc: function validateFunc() {
return utils.isNonEmptyObject(bussNewsDataProviders);
},
clusterOptions: {
mode: CommonJS.News.ClusterMode.static,
onitemclick: ItemClickCallbacks.bussNewsCluster,
instrumentationEntryPoint: FinanceAppJS.Instrumentation.EntryPoint.newsPano,
onerror: function onerror(event) {
var errType = FinanceAppJS.Globals.internetAvailable ? CommonJS.Error.STANDARD_ERROR : CommonJS.Error.NO_INTERNET;
var winControl = event.srcElement.winControl;
CommonJS.Error.showError(errType, function () {
winControl.render();
});
},
adsConfig: { adClusterId: "" },
onrendercomplete: function onrendercomplete(event) {
var anyInProgress = false;
if (!event.srcElement.winControl.dataSet || !(event.srcElement.winControl.dataSet.newsItems.length > 0)) {
for (var provider in bussNewsDataProviders) {
anyInProgress = anyInProgress || !(that.getDataProvider(provider).completedOnce);
}
if (!anyInProgress) {
event.srcElement.winControl.ipage.removeCluster("bussNewsCluster");
}
}
}
},
},
MoreSources_NewsCluster: {
clusterTitle: utils.getResourceString("MORE_NEWS_FROM"),
clusterControl: "FinanceAppJS.EntityPano.MoreSourcesCluster",
dataProviders: sources,
validateFunc: function validateFunc() {
return utils.isNonEmptyString(Platform.Configuration.ConfigurationManager.getMarketStringForEditorial());
},
clusterOptions: {
className: "platformListLayout",
clickInstrumentationID: FinanceAppJS.Constants.Instrumentation.News_MoreSource_Click
}
}
};
this.setClusterDefinitions(clusterDefinitions);
this.pageTitle = utils.getResourceString("chNews");
this._showMarketDataAttribution = false; // We will not show Market Data attribution on News pano
}, {
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/News";
},
})
});
})();
