﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS", {
NewsRSSReader: WinJS.Class.define(
/// <summary>
/// Constructor for a simple IPage class that controls the multisizelistview
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
function (state) {
var that = this;
FinanceAppJS.Utils.Logger.LogPerformance("NewsRSSReader.js", "page_load", FinanceAppJS.Utils.Logger.PerformanceMarks.Start);
this._state = state;
var source = this._state.entity;
if (source) {
this._title = source.displayname;
}
that.loadPageData();
// Attach action to Help button
utils.tryAttachHelpButtonAction();
},
{
_state: null,
_title: null,
_newsProviders: null,
_newsProviderAdapter: null,
_showingSingleFeed: false,
getPageState: function getPageState() { return this._state; },
getPageData: function getPageData() {
var that = this;
return WinJS.Promise.wrap({
title: that._title,
//semanticZoomRenderer: that.semanticZoomRenderer,
//headerOptions: that.commonHeaderOptions
});
},
itemInvoked: function itemInvoked(e, listInfo) {
var that = this;
var item = e.item;
var data = {
Source: item.source,
Article: item.articleUrl
};
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
FinanceAppJS.Telemetry.Constants.Cluster.SOURCES,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
data);
utils.launchNewsUri(item, Platform.Instrumentation.InstrumentationEditorialSourceId.cluster);
},
/// <summary>
/// This function is invoked when dpi changes ("Make everything on your screen bigger" setting)
/// </summary>
/// <param name="event">
/// Dpi change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
onDpiChange: function onDpiChange(event) {
var newsRSSReaderPanoramaControl = PlatformJS.Utilities.getControl("newsRSSReaderPanorama");
if (newsRSSReaderPanoramaControl) {
newsRSSReaderPanoramaControl.onDpiChange(event);
}
},
loadPageData: function loadPageData() {
this._newsProviders = [];
var source = this._state.entity;
if (source.feedNamesArray.length === source.feedUrlsArray.length) {
var startIndex = 0;
var endIndex = source.feedNamesArray.length;
if (this._state.defaultFeedName) {
// Show only the specified feed
startIndex = source.feedNamesArray.indexOf(this._state.defaultFeedName);
endIndex = startIndex + 1;
// Hide the follow and pin buttons
var button = document.getElementById("followSource");
if (button) {
WinJS.Utilities.addClass(button, "hidden");
}
button = document.getElementById("pinSource");
if (button) {
WinJS.Utilities.addClass(button, "hidden");
}
}
if (startIndex >= 0) {
for (var i = startIndex; i < endIndex; i++) {
var url = source.feedUrlsArray[i].trim();
var name = source.feedNamesArray[i].trim();
url = decodeURIComponent(url);
// var disableFavIcon = !PlatformJS.Services.appConfig.getDictionary("BDIConfig").getBool("EnableFavIcons");
var disableFavIcon = true;
this._newsProviders.push(new CommonJS.NewsRSS.NewsProvider({ feed: url, sourceName: source.displayname, title: name, showProgress: true, disableFavIcon: disableFavIcon, bypassCache: false }));
}
}
// If only showing one feed
if (this._newsProviders.length === 1) {
this._showingSingleFeed = true;
// TODO: Disable semantic zoom if there's only one cluster
} else {
this._maxColumnCount = 2; // leave undefined in first case so that there's no limit
}
}
var panorama = PlatformJS.Utilities.getControl("newsRSSReaderPanorama");
if (panorama) {
var clusters = this.createClusters();
panorama.clusterDataSource = clusters.dataSource;
}
},
createClusters: function createClusters() {
var that = this;
var clusters = new WinJS.Binding.List();
for (var i = 0; i < that._newsProviders.length; i++) {
(function (i) {
var provider = that._newsProviders[i];
clusters.push({
clusterKey: "newsCluster" + i,
clusterTitle: provider.title,
onHeaderSelection: that._showingSingleFeed ? null : function () {
// only allow header tap navigation if we're showing more than one feed
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
FinanceAppJS.Telemetry.Constants.Cluster.SOURCES,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERHEADER,
that._state.entity.displayname);
PlatformJS.Navigation.navigateToChannel("NewsRSSReader", { entity: that._state.entity, defaultFeedName: provider.title });
},
clusterContent: {
contentControl: "CommonJS.News.EntityCluster",
contentOptions: {
mode: CommonJS.News.ClusterMode.dynamic,
onitemclick: function onitemclick(e) {
that.itemInvoked(e);
},
provider: provider,
maxColumnCount: that._maxColumnCount,
theme: "financeAppTheme",
configKey: "EntityClusterDefaultFinanceSportsConfig",
configObject: CommonJS.News.EntityClusterConfig.DefaultFinanceSports,
telemetry: {
getCurrentImpression: function getCurrentImpression() {
return PlatformJS.Navigation.mainNavigator.getCurrentImpression();
}
},
onrendercomplete: function onrendercomplete() {
FinanceAppJS.Utils.Logger.LogPerformance("NewsRSSReader.js", "page_load", FinanceAppJS.Utils.Logger.PerformanceMarks.End);
}
}
}
});
})(i);
}
return clusters;
},
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/News RSS Reader";
},
})
});
})();
