﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS", {
NoSearchResults: WinJS.Class.define(
/// <summary>
/// Constructor for your IPage class
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
function (state) {
FinanceAppJS.Utils.Logger.LogPerformance("NoSearchResults.js", "page_load", FinanceAppJS.Utils.Logger.PerformanceMarks.Start);
this.query = state.query;
this.moreinfo = state.moreinfo || utils.getResourceString("NoSearchResultsMessage2");
this.msgElm = document.querySelector(".noResultsMessage2");
// Attach action to Help button
utils.tryAttachHelpButtonAction();
},
{
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/No Search Results";
},
// IPAGE interface
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away and when the app is suspending.
/// Return any data that you need to resurrect your UX when the page is recreated
/// Keep this state object as small as possible
/// </summary>
/// <returns>
/// This function must return a JSON object that can be serializable. Do not pass a Managed object
/// </returns>
getPageState: function getPageState() {
//saving state is not working because of circular ref prob
return null;
},
/// <summary>
/// This function is invoked by the UX Framework when the page is being created and when
/// it is necessary to bind data to the UX.
/// </summary>
/// <returns>
/// Returns a promise that contains data to bind the UX to
/// </returns>
getPageData: function getPageData() {
var that = this;
return WinJS.Promise.wrap({
title: that.query,
subTitle: utils.getResourceString("NoSearchResultsPageSubTitle")
});
},
/// <summary>
/// This function is invoked by the UX Framework when the data binding is complete
/// </summary>
/// <returns>
/// Nothing
/// </returns>
onBindingComplete: function onBindingComplete() {
this.msgElm.innerHTML = this.moreinfo;
},
/// <summary>
/// Set this property to true if you want the back button to appear in the navbar
/// This is used for immersive pages
/// </summary>
isImmersive: false,
/// <summary>
/// This function is invoked by the UX Framework when the layout has changed
/// </summary>
/// <param name="layoutState">
/// The current layout state
/// </param>
/// <returns>
/// Nothing
/// </returns>
onLayoutChange: function onLayoutChange(layoutState) { },
/// <summary>
/// This function is invoked by the device has been roated
/// </summary>
/// <param name="event">
/// orientation change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
onOrientationChange: function onOrientationChange(event) { },
/// <summary>
/// This function is invoked when the page is being navigated away
/// </summary>
/// <returns>
/// Nothing
/// </returns>
onNavigateAway: function onNavigateAway() { },
}
)
});
})();
