﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
FundPicksDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.DataProviderBase, function (options) {
FinanceAppJS.DataProvider.DataProviderBase.call(this, options);
}, {
queryServiceId: "fundpicksdata",
getQueryServiceParams: function getQueryServiceParams() {
var urlParams = PlatformJS.Collections.createStringDictionary();
urlParams.insert("localizeFor", FinanceAppJS.Globalization.getMarket());
return urlParams; 
},
dataBuilder: function dataBuilder(response) {
var data = response.map(function (category) {
return {
category: category.Cat,
items: category.Fl.map(function (item) { return { title: item.Nm, sid: item.SId, cat: category.Cat }; })
};
});
var order = ["Performance", "Highest Rated", "Pre-Screened"];
return data.sort(function (l, r) { return ((order.indexOf(l.category) > order.indexOf(r.category)) ? 1 : 0) * 2 - 1; });
}
}, {
})
});
})();
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS", {
FundPicks: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
FinanceAppJS.FinanceBasePage.call(this, state);
var clusterDefinition = {
fundpicks: {
dataProviders: "FundPicksDataProvider",
clusterControl: "FinanceAppJS.Controls.ItemsCluster",
clusterOptions: {
itemTemplate: {
templateId: "PicksTileTemplate",
className: "PicksTileTemplate",
},
onitemclick: function onitemclick(event) {
var item = event.detail.item.data;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.FUNDPICKS,
item.cat,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
item.title);
return navigationHelper.navigateToFundBrowsePage({ sid: item.sid, category: item.cat, title: item.title });
}
},
cloneFunc: function cloneFunc(data) {
var clusterDef = {};
for (var i = 0, item ; i < data.length && (item = data[i]) ; i++) {
clusterDef[item.category] = { clusterTitle: utils.getResourceString(item.category) };
clusterDef[item.category].clusterData = item.items;
}
return clusterDef;
}
}
};
this.setClusterDefinitions(clusterDefinition);
this.pageTitle = utils.getResourceString("ChFund Picks");
}, {
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Fund Picks";
},
})
});
})();
