﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
AverageRatesDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.DataProviderBase, function (options) {
FinanceAppJS.DataProvider.DataProviderBase.call(this, options);
}, {
queryServiceId: "RatesNationalAverages",
getQueryServiceParams: function getQueryServiceParams() {
var urlParams = PlatformJS.Collections.createStringDictionary();
urlParams.insert("localizeFor", FinanceAppJS.Globalization.getMarket());
return urlParams; 
},
dataBuilder: function dataBuilder(response) {
var imagemap = {
mortgage: "/pages/Rates/images/LogoMortgage.png",
homequity: "/pages/Rates/images/LogoHomeEquity.png",
auto: "/pages/Rates/images/LogoAuto.png",
deposit: "/pages/Rates/images/LogoDeposit.png",
creditcard: "/pages/Rates/images/LogoCreditCard.png"
};
var sortMap = {}, sortOrder = JSON.parse(PlatformJS.Services.appConfig.getString("AverageRatesSortOrder"));
sortOrder.forEach(function (item, index) { sortMap[item] = index; });
// Reorder the response based on predefined sort order in App Configuration
function sort(l, r) {
l = l.ProductId;
r = r.ProductId;
if (!sortMap.hasOwnProperty(l) || !sortMap.hasOwnProperty(r)) {
return 0;
}
return ((sortMap[l] > sortMap[r]) ? 1 : 0) * 2 - 1;
}
return response.sort(sort).map(function (avgrate) {
var prevValue = parseFloat(avgrate.PrevRate);
var currentValue = parseFloat(avgrate.Rate);
var ratesStatus = null;
if (prevValue === currentValue) {
ratesStatus = "mediumGlyph financeGlyphEq";
} else if (prevValue > currentValue) {
ratesStatus = "largeGlyph financeGlyphDn";
} else {
ratesStatus = "largeGlyph financeGlyphUp";
}
return {
key: avgrate.ProductId,
groupKey: avgrate.Category,
category: utils.getResourceString("RatesCategory_" + avgrate.Category),
productId: avgrate.ProductId,
product: avgrate.ProductName,
rate: avgrate.Rate,
prate: avgrate.PrevRate,
ratesStatus: ratesStatus,
imagesrc: imagemap[avgrate.Category],
imagealt: avgrate.ProductName,
}; 
});
}
}, {
})
});
})();
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.AverageRates", {
PageController: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
/// <summary>
/// Average Rates Page Controller
/// </summary>
FinanceAppJS.FinanceBasePage.call(this, state);
var headerSelectionCallback = function (clusterKey) {
var category = clusterKey.replace(/average/, "");
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.RATES,
FinanceAppJS.Telemetry.FlightRecorder.GetRatesContextFromId(category),
FinanceAppJS.Telemetry.Constants.Location.CLUSTERHEADER,
"");
navigationHelper.navigateToRatesPage({ category: category }, "Rates_ClusterHeader_" + category + "_Click");
};
var itemInvokedCallback = function (event) {
var item = event.detail.item.data;
var filters = PlatformJS.Services.appConfig.getDictionary("RatesProductFilters");
var state = filters && filters.hasOwnProperty(item.productId) ? JSON.parse(filters[item.productId].value) : {};
state.purpose = "MortgagePurchase";
state.type = item.productId;
state.category = item.groupKey;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.RATES,
FinanceAppJS.Telemetry.FlightRecorder.GetRatesContextFromId(state.category),
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
item.product);
navigationHelper.navigateToRatesPage(state, "Rates_Cluster_" + state.category + "_Click");
};
var clusterDefinition = {
average: {
dataProviders: "AverageRatesDataProvider",
clusterControl: "FinanceAppJS.Controls.ItemsCluster",
onHeaderSelection: headerSelectionCallback,
postDataValidateFunc: function postDataValidateFunc(data) { return true; },
clusterOptions: {
itemTemplate: { templateId: "AverageRateTemplate" },
onitemclick: itemInvokedCallback
},
cloneFunc: function cloneFunc(data) {
var clusterDef = {};
for (var i = 0, item ; i < data.length && (item = data[i]) ; i++) {
clusterDef[item.groupKey] = clusterDef[item.groupKey] || { clusterTitle: utils.getResourceString("RatesCategory_" + item.groupKey), clusterData: [] };
clusterDef[item.groupKey].clusterData.push(item);
}
return clusterDef;
}
}
};
this.setClusterDefinitions(clusterDefinition);
this.pageTitle = utils.getResourceString("MTRates");
this._showMarketDataAttribution = false; // We will not show Market Data attribution on Rates pano
}, {
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Rates";
},
})
});
})();
