﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.Controls", {
SnappedCluster: WinJS.Class.derive(FinanceAppJS.Controls.ModuleClusterControl, function (domElement, options) {
this.pageData = this.pageData || {};
var indexList = this.pageData.indexList = this.pageData.indexList || new WinJS.Binding.List();
var watchList = this.pageData.watchList = this.pageData.watchList || new WinJS.Binding.List();
var data = {
indexList: indexList.dataSource,
watchList: watchList.dataSource,
};
var that = this;
this._renderPromise = new WinJS.Promise(function (complete, error, progress) {
PlatformJS.Utilities.getControl("snappedModule").render(data, domElement).then(function (element) {
that._renderPromise = null;
that._element = element;
return element;
}).then(function (element) {
WatchListDataProvider.watchListTemplates(false).then(function (templates) {
var watchElem = element.querySelector(".snappedWatchList");
var indexElem = element.querySelector(".snappedIndicesList");
if (watchElem && watchElem.winControl) {
watchElem.winControl.itemTemplate = templates['stockItemTemplate'];
}
complete(element);
});
});
});
this.pageTitle = utils.getResourceString("SnappedAppTitle");
this._emptyWatchListMessageElem = document.querySelector(".noStocksTile");
this._renderDataQueue = [];
this._updateImpl_binding = this._updateImpl.bind(this);
FinanceAppJS.Controls.ModuleClusterControl.call(this, domElement, options);
WinJS.UI.setOptions(this, options);
}, {
pageData: null,
_element: null,
_renderPromise: null,
_emptyWatchListMessageElem: null,
_renderDataQueue: null,
update: function update(data, providerName) {
this._renderPromise = this._renderPromise || WinJS.Promise.as({});
this._renderDataQueue.push([data, providerName]);
return this._renderPromise.then(this._updateImpl_binding);
},
_updateImpl: function _updateImpl(data, providerName) {
var qData = this._renderDataQueue.pop();
var data = qData[0];
var providerName = qData[1];
var indexList = this.pageData.indexList;
var watchList = this.pageData.watchList;
var index = 0;
if (utils.isNonEmptyArray(data.Wl)) {
this._emptyWatchListMessageElem.style.display = 'none';
data.Wl.forEach(function (item) {
watchList.setAt(index++, { tileData: item.tileData });
});
if (watchList.length > data.Wl.length) {
watchList.splice(data.Wl.length, data.Wl.length - watchList.length);
}
} else {
this._emptyWatchListMessageElem.style.display = '';
watchList.splice(0, watchList.length);
}
data.Rtd.map(function (item, index) {
indexList.setAt(index, { tileData: item });
});
this._renderPromise = null;
return WinJS.Promise.as({});
}
})
});
})();
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS", {
SnappedView: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
FinanceAppJS.FinanceBasePage.call(this);
var that = this;
this.roaming = new FinanceAppJS.Roaming;
var equityDataProviderOptions = FinanceAppJS.DataProvider.EquityDataProvider.getDefaultProviderOptions(this.roaming);
if (PlatformJS.Services.configuration.getBool("ShowBatsDisclaimer")) {
this.showDisclaimer = true;
};
equityDataProviderOptions.isSnapped = false;
var clusterDefinitions = {
clusterTitle: utils.getResourceString("chToday"),
hideTitle: true,
dataProviders: {
EquityDataProvider: equityDataProviderOptions
},
clusterControl: "FinanceAppJS.Controls.SnappedCluster",
};
that.setSingleCluster(clusterDefinitions);
}, {
isSnapped: true,
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Snapped View";
},
})
});
})();
