﻿(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
StockDetailsImmersive: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
FinanceAppJS.FinanceBasePage.call(this, state);
var pageState = state;
var entityObj = {};
if (pageState && pageState.entity) {
entityObj = pageState.entity;
}
// Backward compatible for secondary tile to work; Remove this block after NEXT release
else if (pageState && pageState.items && pageState.items.length > 0) {
entityObj = pageState.items[0];
}
var symbols = [];
this.showDisclaimer = false;
this.entityObj = entityObj;
symbols.push(utils.getGlobalInstrumentSymbol(entityObj));
this.symbolsCsv = symbols.join(',');
this.isEOD = utils.isEODInstrument(symbols[0]);
this.tkr = entityObj.Sym;
this.displaySymbol = utils.getAutoSuggestDisplaySymbol(entityObj);
this.pageTitle = utils.toTitleCase(entityObj.Cmp);
this.exchangeCode = entityObj.E2;
this.isOTCStock = utils.isOTCInstrument(this.exchangeCode);
this.isUSExchange = FinanceAppJS.Globalization.isUSExchange(this.exchangeCode);
var exchangeConfig = FinanceAppJS.Globalization.getExchangeConfig(this.exchangeCode);
this.quotesDelay = exchangeConfig ? exchangeConfig.delay : null;
this.exchangeName = (this.exchangeCode && utils.getResourceString("Ex_" + this.exchangeCode)) || "";
this.isOTCStock && entityObj.ExSn && (this.exchangeName = entityObj.ExSn);
this.entityTitle = this.exchangeName ? FinanceAppJS.Utils.Formatters.stringFormatter("{0} ({1})", [this.displaySymbol, this.exchangeName]) : this.displaySymbol;
this._data = {};
this.roaming = new FinanceAppJS.Roaming;
var market = null;
var ItemClickCallbacks = {
newsCluster: function newsCluster(event) {
var data = event.item.articleid || event.item.title;
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.STOCKDETAILS,
FinanceAppJS.Telemetry.Constants.Cluster.NEWS,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
data);
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.QuoteDetails_NewsCluster_Click, 1);
var item = event.item;
utils.launchNewsUri(item, Platform.Instrumentation.InstrumentationEditorialSourceId.cluster);
}
};
//Get exhanges maket and user language to get news from bing.
if (exchangeConfig) {
if (exchangeConfig.countryCode) {
this.showDisclaimer = utils.showBATSDisclaimerForCountry(exchangeConfig.countryCode);
var actualTickMkt = "";
if (Windows.Globalization.GeographicRegion(exchangeConfig.countryCode)) {
actualTickMkt = Windows.Globalization.GeographicRegion(exchangeConfig.countryCode).codeTwoLetter;
}
var actualTickLang = FinanceAppJS.Globalization.getLanguage().split("-");
if (actualTickLang && actualTickMkt) {
market = actualTickLang[0] + "-" + actualTickMkt;
}
}
else {
market = FinanceAppJS.Globalization.getMarket();
}
}
var that = this;
var newsDataProviders = {};
newsDataProviders.BingStockNewsDataProvider = { market: market, queryType: "search", enableFRE: false };
var useNewsCluster = FinanceAppJS.Utils.ShowNewsCluster() && market && utils.isMarketSupportedForBingNews(market);
if (useNewsCluster) {
// Read NewsQueries from Config. This will happen only once.
var newsQueries = FinanceAppJS.ConfigManager.getConfigData("StockNewsQueries");
if (newsQueries && newsQueries[this.tkr]) {
newsDataProviders.BingStockNewsDataProvider.query = newsQueries[this.tkr];
}
else {
newsDataProviders.BingStockNewsDataProvider.query = "\"" + this.pageTitle + "\" " + this.displaySymbol;
}
}
var clusterDefinitions = {
overviewCluster: {
clusterTitle: this.entityTitle,
clusterControl: "FinanceAppJS.StockDetailsPage.StockOverviewCluster",
dataProviders: {
EntityOverviewDataProvider: { symbolsCsv: this.symbolsCsv, isUSExchange: this.isUSExchange, cmpName: this.pageTitle, refreshInterval: this.isEOD ? 0 : FinanceAppJS.Constants.RefreshIntervals.HomePageEquityData},
StockChartDataProvider: { instrumentType: "stock", stockSymbol: symbols[0], isEOD: this.isEOD, duration: this.isEOD ? "1m" : (this.isOTCStock ? "1y" : "1d"), refreshInterval: this.isEOD ? 0 : FinanceAppJS.Constants.RefreshIntervals.HomePageEquityData },
},
primaryProviders: "EntityOverviewDataProvider",
clusterOptions: {
isEOD: this.isEOD,
isOTC: this.isOTCStock,
isUSExchange: this.isUSExchange,
instrumentType: "stock",
moduleInfo: {
fragmentPath: "/pages/StockDetails/html/StockDetailsTemplates.html",
templateId: "tmplEntityMain",
},
}
},
newsCluster: {
clusterTitle: utils.getResourceString("chNews"),
clusterControl: "FinanceAppJS.NewsControls.EntityControl",
dataProviders: newsDataProviders,
validateFunc: function validateFunc() { return useNewsCluster; },
postDataValidateFunc: function postDataValidateFunc(data) {
return utils.isNonEmptyArray(utils.getDeepObject(data, ['newsItems']));
},
clusterOptions: {
mode: CommonJS.News.ClusterMode.static,
onitemclick: ItemClickCallbacks.newsCluster,
onerror: function onerror(event) {
var ipage = event.srcElement.winControl.ipage;
ipage.handleClusterDataError("newsCluster");
},
maxColumnCount: 3,
}
},
keyStatsCluster: {
clusterTitle: utils.getResourceString("KeyStats"),
clusterControl: "FinanceAppJS.Controls.ModuleClusterControl",
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.keyStats;
},
dataProviders: { EntityDetailDataProvider: { symbolsCsv: this.symbolsCsv, isUSExchange: this.isUSExchange, cmpName: this.pageTitle, isEOD: this.isEOD, isOTC: this.isOTCStock } },
clusterOptions: {
moduleInfo: {
fragmentPath: this.isUSExchange ? "/pages/StockDetails/html/StockDetailsTemplates.html" : "/pages/StockDetails/html/StockDetailsTemplates-non-us.html",
templateId: this.isUSExchange ? "tmplKeyStats" : "tmplKeyStatsNonUS",
},
className: this.isUSExchange ? "phKeyStats" : "phKeyStatsNonUs",
onrendercomplete: function onrendercomplete() {
var scrollableTable = that.isUSExchange ? document.querySelector(".stockEntityPage .statsReportContainer") : document.querySelector(".stockEntityPage .statsReportNonUs .listedAndStats");
if (scrollableTable) {
scrollableTable.addEventListener("mousewheel", CommonJS.Immersive.PanoramaPanel.verticalScrollHandler, false);
}
}
}
},
companyProfileCluster: {
clusterTitle: utils.getResourceString("CmpProfile"),
clusterControl: "FinanceAppJS.Controls.ModuleClusterControl",
validateFunc: function validateFunc() { return that.isUSExchange; },
postDataValidateFunc: function postDataValidateFunc(data) {
return data && ((data.cmpProfile && data.cmpProfile.isDataAvailable) || (data.proRating && data.proRating.isDataAvailable));
},
dataProviders: { EntityDetailDataProvider: { symbolsCsv: this.symbolsCsv, isUSExchange: this.isUSExchange, cmpName: this.pageTitle, isEOD: this.isEOD, isOTC: this.isOTCStock } },
clusterOptions: {
moduleInfo: {
fragmentPath: "/pages/StockDetails/html/StockDetailsTemplates.html",
templateId: "tmplCmpProfile",
},
className: "phCmpProfile"
}
},
revenueAndProfitCluster: {
clusterTitle: utils.getResourceString("SEFinancialStatus"),
clusterControl: "FinanceAppJS.Controls.ModuleClusterControl",
postDataValidateFunc: function postDataValidateFunc(data) {
return data && (data.revProfits.isDataAvailable || data.cashReserves.isDataAvailable);
},
dataProviders: { EntityDetailDataProvider: { symbolsCsv: this.symbolsCsv, isUSExchange: this.isUSExchange, cmpName: this.pageTitle, isEOD: this.isEOD, isOTC: this.isOTCStock } },
clusterOptions: {
moduleInfo: {
fragmentPath: "/pages/StockDetails/html/StockDetailsTemplates.html",
templateId: "tmplProfit",
},
}
},
fundOwnershipTrendsCluster: {
clusterTitle: utils.getResourceString("FundOwnershipTrends"),
clusterControl: "FinanceAppJS.Controls.TableCluster",
postDataValidateFunc: function postDataValidateFunc(data) {
return data && data.trends.length > 1;
},
dataProviders: { EntityDetailDataProvider: { symbolsCsv: this.symbolsCsv, isUSExchange: this.isUSExchange, cmpName: this.pageTitle, isEOD: this.isEOD, isOTC: this.isOTCStock } },
clusterOptions: {
dataKey:["trends"],
summary:utils.getResourceString("FundOwnershipTrends"),
footerText:utils.getResourceString("SEAs compared to funds last portfolio date"),
className: "phTrends",
columnTemplates: [null, "tmplTfRating", "tmplTfTrend", null].map(PlatformJS.Utilities.getControl),
onrendercomplete: function onrendercomplete() {
// Attach cluster with Arrow key navigation - scroll event.
FinanceAppJS.Utils.Navigator.enableArrowKeyAccessibilty();
},
stickyHeader:true,
}
}
};
this.setClusterDefinitions(clusterDefinitions);
}, {
isEOD: false,
isOTCStock: false,
pinUnpinManager: null,
/// <summary>
/// This function is invoked by the UX Framework when the data binding is complete
/// </summary>
/// <returns>
/// Nothing
/// </returns>
onBindingComplete: function onBindingComplete() {
FinanceAppJS.FinanceBasePage.prototype.onBindingComplete.call(this);
// Setup actions for bottom edgy
var btmEdgy = document.querySelector("#stockDetailsActionEdgy");
this.btnManage = btmEdgy.querySelector("#btnStkManage");
var isRoamingEntryExists = this.roaming.isWatchListEntryExists(this.symbolsCsv, FinanceAppJS.Constants.IDs.Stock);
WatchListManage.toggleEdgyLabels(isRoamingEntryExists, this.btnManage);
var options = {
symbol: this.symbolsCsv,
type: FinanceAppJS.Constants.IDs.Stock,
isEntryExists: isRoamingEntryExists,
elm: this.btnManage,
actionBar: btmEdgy,
name: this.pageTitle,
roamingObj: this.roaming
};
this.edgyBtnClickHandler = WatchListManage.addOrRemoveFromEdgy.bind(null, options);
this.btnManage.addEventListener("click", this.edgyBtnClickHandler);
this.pinUnpinManager = new FinanceAppJS.PinUnpinManager(btmEdgy, this.getPageState(), FinanceAppJS.Constants.IDs.Stock, this.symbolsCsv, this.pageTitle, this.displaySymbol, null, null, FinanceAppJS.Constants.Instrumentation.PinStart_Quote_Click);
},
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away
/// </summary>
/// <param name="reason">
/// The reason why the page is being navigated away: "backNavigation" or "newNavigation"
/// </param>
/// <returns>
/// Nothing
/// </returns>
onNavigateAway: function onNavigateAway(reason) {
FinanceAppJS.FinanceBasePage.prototype.onNavigateAway.call(this);
var chartControlDiv = document.querySelector(".entityChart");
if (chartControlDiv) {
var chartControl = chartControlDiv.winControl;
if (chartControl) {
chartControl.dispose();
}
}
if (this.pinUnpinManager) {
this.pinUnpinManager.clean();
}
if (this.btnManage && this.edgyBtnClickHandler) {
this.btnManage.removeEventListener("click", this.edgyBtnClickHandler);
this.btnManage = null;
}
},
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Stock details page";
},
onVisibilityChanged: function onVisibilityChanged(e) {
if (document.msVisibilityState === "visible" && this.pinUnpinManager) {
this.pinUnpinManager.updateBottomSwipyPinButtons(this.symbolsCsv, FinanceAppJS.Constants.IDs.Stock);
}
},
getSharedContractData: function getSharedContractData() {
var dataProvider = this.getDataProvider("EntityOverviewDataProvider");
return utils.getSharedContractDataForStocks(dataProvider, this.entityObj, this.exchangeName, this._lastUpdatedTime, "stock");
},
getCurrentContent: function getCurrentContent() {
var content = {
Symbol: this.symbolsCsv,
Page: FinanceAppJS.Telemetry.Constants.Page.STOCKDETAILS,
};
return content;
},
onPageLoadComplete: function onPageLoadComplete() {
FinanceAppJS.Telemetry.FlightRecorder.LogSearchEventFromResultPage();
FinanceAppJS.FinanceBasePage.prototype.onPageLoadComplete.call(this);
var content = this.getCurrentContent();
FinanceAppJS.Telemetry.FlightRecorder.LogContentView(content);
},
onWindowResize: function onWindowResize(event) {
FinanceAppJS.FinanceBasePage.prototype.onWindowResize.call(this, event);
this.updateCompanyProfileText();
},
onOrientationChange: function onOrientationChange(event) {
FinanceAppJS.FinanceBasePage.prototype.onOrientationChange.call(this, event);
this.updateCompanyProfileText();
},
updateCompanyProfileText: function updateCompanyProfileText() {
var companyProfileDescElem = document.getElementById("companyProfileDesc");
if (companyProfileDescElem) {
companyProfileDescElem.innerHTML = utils.getCompanyProfileDescForCurrentRes(companyProfileDescElem.fullDes);
}
},
},
{
areStateEqual: function areStateEqual(firstState, secondState) {
var firstItem = null, secondItem = null;
if (firstState && secondState) {
if (firstState.entity && secondState.entity) {
firstItem = firstState.entity;
secondItem = secondState.entity;
}
else if (firstState.items && firstState.items.length > 0 && secondState.items && secondState.items.length > 0) {
firstItem = firstState.items[0];
secondItem = secondState.items[0];
}
if (firstItem && secondItem) {
return utils.getGlobalInstrumentSymbol(firstItem) === utils.getGlobalInstrumentSymbol(secondItem);
}
}
return false;
}
})
});
})();
(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.StockDetailsPage",
{
/// <summary>
/// Cluster with Chart as view for stock quotes
/// </summary>
StockOverviewCluster: WinJS.Class.derive(FinanceAppJS.Controls.BaseOverviewCluster, function (domElement, options) {
// set options
FinanceAppJS.Controls.BaseOverviewCluster.call(this, domElement, options);
this._rangeSelectors = options.isEOD ? ['1m', '1y', '5y'] : (options.isUSExchange ? ['1d', '5d', '1m', '1y', '5y', 'max'] : ['1d', '5d', '1m', '1y', '5y']);
this.currentRangeIndex = options.isOTC ? this._rangeSelectors.indexOf('1y') : 0; //Default is year for OTC
WinJS.UI.setOptions(this, options);
},
{
update: function update(data, providerName) {
switch (providerName) {
case 'EntityOverviewDataProvider':
var that = this;
if (data && data.Eqsm) {
this.displayName = data.Eqsm;
}
else {
this.displayName = "-";
}
if (data) {
this.equityUpdateTime = data.lastUpdateTime;
}
this.realtimeQuotesLastUpdatedTimeString = utils.getResourceString("ChartRTLastTraded").format(data.dateTime);
return FinanceAppJS.Controls.ModuleClusterControl.prototype.update.call(this, data).then(function () {
var quoteSearchButton = document.querySelectorAll(".quoteSearchglyphParent");
if (quoteSearchButton.length > 0) {
for (var index = 0; index < quoteSearchButton.length; index++) {
quoteSearchButton[index].addEventListener("MSLostPointerCapture", PlatformJS.Utilities.pointerEventListenersMap["MSLostPointerCapture"], false);
quoteSearchButton[index].addEventListener("MSPointerCancel", PlatformJS.Utilities.pointerEventListenersMap["MSPointerCancel"], false);
quoteSearchButton[index].addEventListener("MSPointerUp", PlatformJS.Utilities.pointerEventListenersMap["MSPointerUp"], false);
quoteSearchButton[index].addEventListener("MSPointerDown", PlatformJS.Utilities.pointerEventListenersMap["MSPointerDown"], false);
quoteSearchButton[index].addEventListener("MSPointerOut", PlatformJS.Utilities.pointerEventListenersMap["MSPointerOut"], false);
}
}
return that.performPendingUpdate();
});
case 'StockChartDataProvider':
return this.updateChart(data);
}
},
}, {
})
});
})();