﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS", {
Tools: WinJS.Class.define(function (state) {
/// <summary>
/// Constructor for your IPage class
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
var tools = FinanceAppJS.Tools.getToolsList("pages/Tools/html/Tools.html", "toolsItemTemplate");
this._clusters = new WinJS.Binding.List();
this._clusters.push({
clusterKey: "toolsItems",
clusterTitle: "",
clusterContent: {
contentControl: "CommonJS.Immersive.ItemsContainer",
contentOptions: {
itemDataSource: tools.dataSource,
className: "platformListLayout",
onitemclick: FinanceAppJS.Tools.itemInvokedHandler,
}
}
});
// Attach action to Help button
utils.tryAttachHelpButtonAction();
}, {
_clusters: null,
// IPAGE interface
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away and when the app is suspending.
/// Return any data that you need to resurrect your UX when the page is recreated
/// Keep this state object as small as possible
/// </summary>
/// <returns>
/// This function must return a JSON object that can be serializable. Do not pass a Managed object
/// </returns>
getPageState: function getPageState() { },
/// <summary>
/// This function is invoked by the UX Framework when the page is being created and when
/// it is necessary to bind data to the UX.
/// </summary>
/// <returns>
/// Returns a promise that contains data to bind the UX to
/// </returns>
getPageData: function getPageData() {
var that = this;
return WinJS.Promise.wrap({
title: utils.getResourceString('chTools'),
clusters: that._clusters.dataSource,
});
},
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/Tools";
},
/// <summary>
/// This function is invoked by the UX Framework when the data binding is complete
/// </summary>
/// <returns>
/// Nothing
/// </returns>
onBindingComplete: function onBindingComplete() {
},
/// <summary>
/// Set this property to true if you want the back button to appear in the navbar
/// This is used for immersive pages
/// </summary>
isImmersive: false,
/// <summary>
/// This function is invoked by the UX Framework when the layout has changed
/// </summary>
/// <param name="layoutState">
/// The current layout state
/// </param>
/// <returns>
/// Nothing
/// </returns>
onLayoutChange: function onLayoutChange(layoutState) { },
/// <summary>
/// This function is invoked by the device has been roated
/// </summary>
/// <param name="event">
/// orientation change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
onOrientationChange: function onOrientationChange(event) { }
}, {
_toolsCalculatorCategoryList: PlatformJS.Services.configuration.getList("ToolsCalculatorCategoryList"),
getToolsList: function getToolsList(fragmentPath,templateId) {
/* Populate Calc List*/ 
var ToolsCalculatorCategoryList = FinanceAppJS.Tools._toolsCalculatorCategoryList;
var tools = new WinJS.Binding.List();                
for (var i = 0; i < ToolsCalculatorCategoryList.size; i++) {
var calcCat = JSON.parse(ToolsCalculatorCategoryList[i].value);                        
if (calcCat.clusterTitleKey && Platform.Utilities.Globalization.isFeatureEnabled(calcCat.id)) {
var title = utils.getResourceString(calcCat.clusterTitleKey + "_TileName");
// TODO check the elipses
if(fragmentPath === "/pages/MarketToday/html/MarketTodayTemplates.html"){
title = title.toLowerCase();
}
tools.push({
title: title,
desc: "<p>" + utils.getResourceString(calcCat.clusterTitleKey + "_Description") + "</p>",
icon: calcCat.IconCode,
calcId: calcCat.clusterTitleKey,
moduleInfo: {
fragmentPath: fragmentPath,
templateId: templateId
}
}
);
}
}
return tools;
},
navigators: {
MortgageCalculator: navigationHelper.navigateToMortgageCalculator,
LoanPaymentsCalculator: navigationHelper.navigateToAutoLoanCalculator,
CurrencyConverter: navigationHelper.navigateToCurrencyCalculator,
SavingsCalculator: navigationHelper.navigateToSavingsCalculator,
RetirementsCalculator: navigationHelper.navigateToRetirementCalculator,
FinancialCalculator: navigationHelper.navigateToFinancialCalculator
},
itemInvokedHandler: function itemInvokedHandler(event) {
if (event.detail.item.calcId) {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
FinanceAppJS.Telemetry.Constants.Cluster.TOOLITEMS,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
event.detail.item.calcId);
FinanceAppJS.Tools.navigators[event.detail.item.calcId]();
}
},
}
)
});
})();
