﻿(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
WorldMarketDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.DataProviderBase, function (options) {
FinanceAppJS.DataProvider.DataProviderBase.call(this, options);
}, {
queryServiceId:"WorldMarket",
refreshInterval: FinanceAppJS.Constants.RefreshIntervals.WorldMarket,
dataBuilder: function dataBuilder(data) {
var allMarkets = data.wm.map(function (category) {
return {
title: utils.getResourceString(category.rgn),
items: [["WMIndices", "IndexLevel", "IndexCh", "ChPercent"].map(utils.getResourceString)].concat(category.itms.map(function (item) {
item.Rgn = category.rgn;
var cntryname = item.cntry;
if (item.cntry === "BRA") {
cntryname = "Brazil";
} // This is a temporary change until we get the Brazil String. Once we get the brazil string, it has to be reverted.
return [{ name: item.nm, country: item.cntry, countryname: cntryname }, item.lvl, item.ch, item.chp, item];
}))
};
});
//mapping logic for top markets
var marketMap = {};
data.wm.forEach(function (category) {
category.itms.forEach(function (market) {
marketMap[market.idx] = market;
});
});
var topMarketList = [];
var heroImageMarketList = PlatformJS.Services.configuration.getList("WorldMarketList");
for (var i = 0; i < heroImageMarketList.size; i++) {
topMarketList.push(JSON.parse(heroImageMarketList[i].value));
}
var comparingProp = (document.dir === "ltr") ? "ltrIndex" : "rtlIndex";
topMarketList.sort(function (indexItem1, indexItem2) {
if (indexItem1[comparingProp] > indexItem2[comparingProp]) {
return 1;
} else if (indexItem1[comparingProp] < indexItem2[comparingProp]) {
return -1;
} else {
return 0;
}
});
var topMarkets = topMarketList.map(function (indexDetails) { return marketMap[indexDetails.indexId]; });
return { topMarkets: topMarkets, allMarkets: allMarkets };
}
}, {
})
});
})();
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
WorldMarket: WinJS.Class.derive(FinanceAppJS.FinanceBasePage, function (state) {
FinanceAppJS.FinanceBasePage.call(this, state);
var ItemClickCallbacks = {
WorldMarketIndexClicked: function WorldMarketIndexClicked(event) {
var instrumentID = FinanceAppJS.Constants.Instrumentation.Index_WorldMarketMap_Click;
var state = utils.getIndexDetails(event.item, "WorldMarketData");
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.WORLDMARKET,
FinanceAppJS.Telemetry.Constants.Cluster.TOPINDICES,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
event.item.nm);
navigationHelper.navigateToIndexDetailsPage(state, instrumentID);
}
};
var clusterDefinitions = {};
clusterDefinitions.HeroImage = {
clusterTitle: utils.getResourceString("TopIndices"),
hideTitle: true,
clusterControl: "FinanceAppJS.Controls.ItemsCluster",
dataProviders: "WorldMarketDataProvider",
clusterOptions: {
className: "worldMapLayout",
dataKey: ["topMarkets"],
footerTemplate: PlatformJS.Utilities.getControl("marketOpen"),
useDataObjectForBinding: true,
onitemclick: ItemClickCallbacks.WorldMarketIndexClicked,
itemTemplate: {
renderer: this.mapItemRenderer,
isInteractive: true
}
}
};
clusterDefinitions.gettingStartedCluster = utils.getTempClusterConfig();
clusterDefinitions.nextStepsCluster = utils.getNextStepsClusterConfig();
clusterDefinitions.Markets = {
clusterTitle: "",
clusterControl: "FinanceAppJS.Controls.TableCluster",
dataProviders: "WorldMarketDataProvider",
cloneFunc: function cloneFunc(data) {
var market, clusterDef = {};
for (var i = 0; i < data.allMarkets.length && (market = data.allMarkets[i]) ; i++) {
clusterDef[market.title] = {
clusterTitle: market.title,
clusterData: market.items,
clusterOptions: {
summary: market.title, columnTemplates: ["tmpl_indexname", "tmpl_lvl", "tmpl_change", "tmpl_changep"].map(PlatformJS.Utilities.getControl),
stickyHeader: true,
}
};
}
return clusterDef;
},
clusterOptions: {
columnTemplates: ["tmpl_indexname", "tmpl_lvl", "tmpl_change", "tmpl_changep"].map(PlatformJS.Utilities.getControl),
stickyHeader: true,
summary: utils.getResourceString("WorldMarket"),
rowClickCallback: function rowClickCallback(data) {
var instrumentID = FinanceAppJS.Constants.Instrumentation.Index_WorldMarketTable_Click;
var state = utils.getIndexDetails(data[4], "WorldMarketData");
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(FinanceAppJS.Telemetry.Constants.Page.WORLDMARKET,
data[4].Rgn,
FinanceAppJS.Telemetry.Constants.Location.CLUSTERITEM,
data[4].nm);
navigationHelper.navigateToIndexDetailsPage(state, instrumentID);
}
}
};
this.setClusterDefinitions(clusterDefinitions);
this.showCMSPreviewButton();
this.pageTitle = utils.getResourceString("WorldMarket");
}, {
showCMSPreviewButton: function showCMSPreviewButton() {
var previewButton;
// Dependent on the Platform team to disable this flag (PlatformJS.isDebug=false) for app store submission
if (!PlatformJS.isDebug || !(previewButton = PlatformJS.Utilities.getControl("previewButton"))) {
return;
}
var cmsPreviewButton = document.getElementById("cmsPreviewButton");
if (cmsPreviewButton) {
WinJS.Utilities.removeClass(cmsPreviewButton, "hide");
}
previewButton.label = utils.getResourceString(FinanceAppJS.Settings.cmsPreviewEnabled ? "PreviewOff" : "PreviewOn");
previewButton.onclick = function () {
FinanceAppJS.Settings.cmsPreviewEnabled = !FinanceAppJS.Settings.cmsPreviewEnabled;
previewButton.label = utils.getResourceString(FinanceAppJS.Settings.cmsPreviewEnabled ? "PreviewOff" : "PreviewOn");
};
},
mapItemRenderer: function mapItemRenderer(item) {
var container = document.createElement("div");
var idValue = item.data.idx.toString();
container.id = idValue;
container.setAttribute("aria-describedby", idValue);
var circle = document.createElement("div");
var dottedLine = document.createElement("div");
var dottedHLine = document.createElement("div");
var data = item.data;
circle.className = "circle";
dottedLine.className = "dottedLine";
dottedHLine.className = "dottedHLine";
CommonJS.loadModule({ fragmentPath: "/pages/WorldMarket/html/WorldMarket.html", templateId: "wmIndexTile" }, data, null, null, item).then(function (tile) {
//Commenting animation. May enable if reqd
// PlatformJS.Utilities.enablePointerUpDownAnimations(tile);
//Each item has a different layout. Grouping items based on layout                    
var topAlignedMarkets = ["127.10.0000", "126.10.!DJI", "151.10.UKX", "136.10.000001"];
var bottomAlignedMarkets = ["50.10.ME", "211.10.PX1", "139.10.1", "134.10.HSI"];
var rightAlignedMarkets = ["213.10.DAX", "132.10.100000018"];
if (topAlignedMarkets.indexOf(item.data.idx) > -1) {
container.appendChild(circle);
container.appendChild(tile);
container.appendChild(dottedLine);
}
else if (rightAlignedMarkets.indexOf(item.data.idx) > -1) {
container.className = "ltrGrid";
WinJS.Utilities.addClass(circle, "col1");
container.appendChild(circle);
WinJS.Utilities.addClass(dottedHLine, "col2");
container.appendChild(dottedHLine);
WinJS.Utilities.addClass(tile, "col3");
container.appendChild(tile);
}                    
else if (bottomAlignedMarkets.indexOf(item.data.idx) > -1) {
container.appendChild(circle);
container.appendChild(dottedLine);
container.appendChild(tile);
}
// Hack to disable tabIndex on the container for accessibility
msSetImmediate(function () {
container.setAttribute("tabIndex", "-1");
});
});
return container;
},
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
return "/World Market";
},
getSharedContractData: function getSharedContractData() {
var shareContractData = null;
var uriBuilder = new Platform.Utilities.AppExUriBuilder();
uriBuilder.controllerId = "worldmarkets";
var uri = uriBuilder.toString();
var textToDisplay = utils.getResourceString("ShareContractWorldMarketMessage");
var headline = utils.getResourceString("chWorldMarket");
var worldMarketData = {
source: FinanceAppJS.Constants.IDs.WorldMarket,
headline: headline,
text: textToDisplay,
deepLink: uri
};
return new WinJS.Promise(function (complete, error) {
utils.getShareContractHtmlFormat(worldMarketData).then(function (htmlOutput) {
complete({
title: utils.getShareContractSubject(utils.getResourceString("chWorldMarket")),
htmlContent: htmlOutput,
textContent: textToDisplay,
uri: uri
});
});
});
},
})
});
})();