﻿(function () {
"use strict";
WinJS.Namespace.define("NewsJS.Personalization",
{
DataManager: WinJS.Class.define(function (options) {
this._cnpLiveData = options.liveData;
this._cnpItems = options.items,
this._dataKey = options.dataKey,
this._itemsKey = options.itemsKey;
this._init();
},
{
_cnpLiveData: null,
_cnpItems: null,
_init: function _init() {
this._cnpItems = this.getMyRoamingData(this._itemsKey);
this._cnpLiveData = this.getMyRoamingData(this._dataKey);
},
// Operations on live data: _cnpLiveData
_removeMyItemsData: function _removeMyItemsData(newItems) {
var that = this;
newItems.forEach(function (item) {
if (item.data.topicEntity) {
var topic = item.data.topicEntity.title;
NewsJS.Utilities.unfollowTopic(topic);
that._removeSingleItemData(topic);
}
});
},
_getMyItemsData: function _getMyItemsData() {
return this._cnpLiveData;
},
_setMyItemsData: function _setMyItemsData(data) {
var that = this;
this._cnpLiveData = data;
},
_removeSingleItemData: function _removeSingleItemData(key) {
if ( !this._cnpLiveData || !this._cnpLiveData[key]) {
return;
}
delete this._cnpLiveData[key];
this.setMyRoamingData(this._dataKey, this._cnpLiveData);
},
_setMySingleItemData: function _setMySingleItemData(key, value) {
if (!this._cnpLiveData) {
this._cnpLiveData = {};
}
this._cnpLiveData[key] = value;
if (value) {
this.setMyRoamingData(this._dataKey, this._cnpLiveData);
}
},
_getMyItems: function _getMyItems() {
return this._cnpItems;
},
_setMyItems: function _setMyItems(items) {
this._cnpItems = items;
},
foundItem: function foundItem(item) {
var items = this._cnpItems;
var found = this._isDup(items, item);
return found;
},
handleAddItem: function handleAddItem(item) {
var that = this;
var itemAdded = that._addMyItem(item);
if (itemAdded) {
this.setMyRoamingData(this._itemsKey, this._cnpItems);
}
return itemAdded;
},
// Action handler: Add/Remove
handleRemoveItems: function handleRemoveItems(removedItems) {
var that = this;
if (removedItems) {
// update basic data
that._removeMyItems(removedItems); // todo: copy here
that.setMyRoamingData(that._itemsKey, that._cnpItems);
// update live data
that._removeMyItemsData(removedItems);
that.setMyRoamingData(that._dataKey, that._cnpLiveData);
}
},
// Action handler: Add/Remove
handleRemoveItem: function handleRemoveItem(index) {
var that = this;
if (index > 0) {
var item = that._cnpItems[index];
// update basic data
that._removeMyItems([{ data: item }]); // todo: copy here
that.setMyRoamingData(that._itemsKey, that._cnpItems);
// update live data
that._removeMyItemsData([{ data: item }]);
that.setMyRoamingData(that._dataKey, that._cnpLiveData);
}
},
// news items coming from binding, need to use .data
_removeMyItems: function _removeMyItems( newItems) {
var that = this;
var items = this._cnpItems;
var toChange = [];
newItems.forEach(function (item) {
var found = that._isDup(items, item.data);
if (found) {
toChange.push(found);
items.splice(items.indexOf(found), 1);
}
});
return toChange;
},
_addMyItem: function _addMyItem(newItem) {
var that = this;
var items = this._cnpItems;
var found = that._isDup(items, newItem);
if (!found) {
items.push(newItem);
return newItem;
}
return null;
},
_addMyItems: function _addMyItems(newItems) {
var that = this;
var items = this._cnpItems;
var toChange = [];
newItems.forEach(function (item) {
var found = that._isDup(items, item);
if (!found) {
toChange.push(item);
items.push(item);
}
});
return toChange;
},
_isDup: function _isDup(items, theOne) {
for (var i = 0 ; i < items.length; i++) {
var item = items[i];
if (item && (item.displaynameHeadline && item.displaynameHeadline === theOne.displaynameHeadline)
|| (item.id && item.id === theOne.id)) {
return item;
}
}
},
//TODO: using WinJS.Application.current.roaming for roaming instead of localstorage
hasRoamingData: function hasRoamingData() {
return localStorage.getItem(this._itemsKey);
},
//TODO: using WinJS.Application.current.roaming for roaming instead of localstorage
setMyRoamingData: function setMyRoamingData(key, value) {
localStorage.setItem(key, JSON.stringify(value));
},
//TODO: using WinJS.Application.current.roaming for roaming instead of localstorage
getMyRoamingData: function getMyRoamingData(key) {
try {
var data = localStorage.getItem(key);
if (data) {
return JSON.parse(data);
}
}
catch (e) {
return null;
}
return null;
},
})
});
})();
