﻿(function () {
"use strict";
WinJS.Namespace.define("NewsJS.Personalization",
{
MyTrendsControl: WinJS.Class.derive(NewsApp.Controls.ControlBase, function (element, options, orchestrator) {
NewsApp.Controls.ControlBase.call(this, element, options, orchestrator);
WinJS.Utilities.addClass(this.element, "myTrendsItemsContainer");
},
{
_dataSource: null,
_listBinding: null,
_addIndex: 0,
_maxHeightChanged: false,
_currentHeight: 0,
_maxItemToShow:0,
createProviderInstance: function createProviderInstance() {
return new NewsJS.Personalization.MyTrendsDataProvider()
},
clearControl: function clearControl() {
if (this.control) {
if (this.control.dispose) {
this.control.dispose();
this.control = null;
}
if (this.element) {
this.element.innerHTML = "";
}
}
},
_calcContainerHeight: function _calcContainerHeight() {
// 178(CUX change to 160) is the magic number that includes header and footer
// Entity cluter is using the same thing.
// if header/footer changed, this number needs to be updated.
// 32 is the height for credit label
var height = window.outerHeight - 178;
var rowHeight = NewsJS.Personalization.Utilities.tileSizeSmall + 10;
var rows = Math.floor((height + 10) / rowHeight);
var maxItemToShow = rows * 2;
this._maxItemToShow = maxItemToShow - (this._hasBig ? 3 : 0) - (this._hasMedium ? 1 : 0);
height = rows * (rowHeight) - 10;
this._maxHeightChanged = this._currentHeight !== height;
if (this._maxHeightChanged) {
this._currentHeight = height;
}
},
_hasBig: false,
_hasMedium: false,
_regularItems: 0,
renderFirstTime: function renderFirstTime(response) {
var that = this;
var items = response;
if (items) {
var itemsToShow = [];
var credits = [];
var item = null;
if (items[NewsJS.Personalization.Utilities.tileSize.Large].length > 0) {
item = items[NewsJS.Personalization.Utilities.tileSize.Large][0];
itemsToShow.push(item);
var attr = item.data.attribution;
if (attr) {
credits.push(attr);
}
this._hasBig  = true;
}
if (items[NewsJS.Personalization.Utilities.tileSize.Wide].length > 0) {
item = items[NewsJS.Personalization.Utilities.tileSize.Wide][0];
itemsToShow.push(item);
var attr = item.data.attribution;
if (attr) {
credits.push(attr);
}
this._hasMedium = true;
}
var regularItems = this._regularItems = items[NewsJS.Personalization.Utilities.tileSize.Small];
regularItems.forEach(function (item) {
var attr = item.data.attribution;
if (attr) {
credits.push(attr);
}
});
itemsToShow = this._allItemsToShow = itemsToShow.concat(regularItems);
if (itemsToShow && itemsToShow.length > 0) {
var div = this.clipContainer = document.createElement("div");
this._calcContainerHeight();
itemsToShow = this._allItemsToShow.slice(0, this._maxItemToShow);
that._listBinding = new WinJS.Binding.List(itemsToShow);
that._dataSource = that._listBinding.dataSource;
var binding = {
className: "platformListLayout myTrendsList",
contentOptions: {
itemDataSource: that._dataSource,
onitemclick: that.onItemInvoke.bind(that),
isInteractive: true,
},
}
div.style.maxHeight = this._currentHeight + "px";
WinJS.Utilities.addClass(div, "myTrendsList");
this.element.appendChild(div);
if (credits.length > 0) {
// image attribution
var imageAttributionElt = this._imageAttributionElt = document.createElement("div");
imageAttributionElt.className = "platformHeroImageAttribution myTrendsCredit";
this._createImageCreditsFlyout(this._imageAttributionElt, credits.join("; "));
this.element.appendChild(this._imageAttributionElt);
this.element.addEventListener("keydown", function (event) {
var keyCode = event.keyCode;
switch (keyCode) {
case WinJS.Utilities.Key.tab:
that._handleTabKey();
}
});
}
var control = this.control = new CommonJS.Immersive.ItemsContainer(div, binding.contentOptions);
return control.render();
}
}
return WinJS.Promise.wrap(null);
},
_handleTabKey: function _handleTabKey() {
if (this.flyoutControl) {
this.flyoutControl.hide();
}
},
_createImageCreditsFlyout: function _createImageCreditsFlyout(anchorElt, label) {
var that = this;
// create button
var buttonElt = document.createElement("button");
WinJS.Utilities.addClass(buttonElt, "imageCreditsButton");
buttonElt.innerText = PlatformJS.Services.resourceLoader.getString("ImageCredits");
buttonElt.onclick = function () {
that.flyoutControl.show();
}
// create flyout
var label = label;
var placement = "top";
var alignment = (window.getComputedStyle(document.body).direction === "rtl") ? "left" : "right";
var labelElt = this._labelElt = document.createElement("div");
WinJS.Utilities.addClass(labelElt, "platformAttributionLabel");
PlatformJS.Utilities.setInnerHtml(labelElt, label);
var flyoutElt = CommonJS.FlyoutManager.getFlyoutElement();
WinJS.Utilities.addClass(flyoutElt, "platformAttributionFlyout myTrendsCreditFlyout");
var flyoutControl = this.flyoutControl = new WinJS.UI.Flyout(flyoutElt, {
alignment: alignment,
anchor: anchorElt
});
flyoutElt.appendChild(labelElt);
anchorElt.appendChild(buttonElt);
anchorElt.appendChild(flyoutElt);
},
renderNextTime: function renderNextTime(response) {
return this.renderFirstTime(response);
},
onWindowResize: function onWindowResize(e) {
this._handleHeightChanged();
},
onOrientationChange: function onOrientationChange(e) {
this._handleHeightChanged();
},
onConnectionChanged: function onConnectionChanged(evt) {
if (evt.connection) {
this.render();
}
},
onResumed: function onResumed(evt) {
this.render();
},
onRefreshed: function onRefreshed(evt) {
//TODO: force refresh
this.render({ bypassCache: true });
},
_handleHeightChanged: function _handleHeightChanged(e) {
this._calcContainerHeight();
if (this.clipContainer && this._maxHeightChanged && this._allItemsToShow) {
var itemsToShow = this._allItemsToShow.slice(0, this._maxItemToShow);
this._listBinding = new WinJS.Binding.List(itemsToShow);
this._dataSource = this._listBinding.dataSource;
this.control.itemDataSource = this._dataSource;
this.clipContainer.style.maxHeight = this._currentHeight + "px";
this.clipContainer.setAttribute("maxItemToShow", this._maxItemToShow);
this.control.render();
}
},
onItemInvoke: function onItemInvoke(e) {
var that = this;
var item = e.detail.item;
if (item && item.data) {
NewsJS.Telemetry.BingDaily.recordPopularNowPress(item);
var articleInfo = null;
if (item.data.articleInfo.crawled) {
articleInfo = item.data.articleInfo;
}
Platform.Telemetry.FlightRecorder.setImpressionNavMethod(NewsJS.Telemetry.String.ImpressionNavMethod.popularNow);
WinJS.Navigation.navigate({ fragment: "/html/search.html", page: "NewsJS.Search" },
{ topicEntry: null, queryText: item.data.query, searchOrigin: NewsJS.Telemetry.Search.Origin.popularNow, articleInfo: articleInfo });
}
},
},
{
}),
});
})();
