﻿(function () {
"use strict";
WinJS.Namespace.define("NewsJS.Personalization",
{
MyTrendsDataProvider: WinJS.Class.define(function (options) {
this._init();
}, {
_cnpDataManager: null,
_init: function _init() {
this._cnpDataManager = NewsJS.Customization.getTopicsDataManager();
},
request: function request(args) {
var that = this;
args = args ||{};
var market = Platform.Globalization.Marketization.getCurrentMarket();
var bypassCache = args.bypassCache || false;
return this._cnpDataManager.getAllAsync(market, "trending", null, bypassCache).then(function (topics) {
return that._transformToMyItems(topics);
});
},
_transformToMyItems: function _transformToMyItems(topics) {
var that = this;
var items = {
Large: [],
Wide: [],
Small:[]
};
if (topics) {
for (var id in topics) {
var item = that.createNewItem(topics[id], id);
if (item) {
items[item.tileSize].push(item);
}
}
}
return items;
},
_uniformItem: function _uniformItem(originalData, templateId, tileType) {
var item = originalData ? JSON.parse(JSON.stringify(originalData)) : {};
item.itemKey = "key",
item.className = "myTrendsItem";
item.moduleInfo = {
fragmentPath: "/html/templates.html",
templateId: templateId,
};
item.tileType = "";
return item;
},
// create item from sources
createNewItem: function createNewItem(topic, id) {
var that = this;
var data = topic.data;
var hasImage = data.image && data.image.url && data.image.url.length > 0;
var templateId = NewsJS.Personalization.Utilities.todayMyItemsTrendsTemplate;
if (!hasImage) {
templateId = NewsJS.Personalization.Utilities.todayMyItemsTrendsTemplateTextOnly;
}
var item = that._uniformItem(topic, templateId, NewsJS.Personalization.Utilities.tileType.Customize);
item.title = data.displayname;
var tmp = document.createElement("div");
tmp.innerHTML = toStaticHTML(data.articleInfo.abstract);
var val = tmp.innerText;
item.sourceDesc = val;
item.thumbnail = data.image || { url: "" };
item.key = data.id;
item.id = id;
this.setModuleTileSize(item);
return item;
},
setModuleTileSize: function setModuleTileSize(item) {
var LargeSize = NewsJS.Personalization.Utilities.tileSizeLarge;
var SmallSize = NewsJS.Personalization.Utilities.tileSizeSmall;
var imageInfo = item.data.image || {};
var type = NewsJS.Personalization.Utilities.tileSize.Small;
var width = SmallSize + "px";
var height = SmallSize + "px";
var className = "small";
if (imageInfo.width >= LargeSize && imageInfo.height >= LargeSize ) {
width = height = LargeSize + "px";
type = NewsJS.Personalization.Utilities.tileSize.Large;
className = "big";
}
else if (imageInfo.width >= LargeSize && imageInfo.height >= SmallSize) {
width = LargeSize + "px";
height = SmallSize + "px";
className = "medium";
type = NewsJS.Personalization.Utilities.tileSize.Wide;
}
item.tileSize = type;
item.moduleInfo.className = className;
item.moduleInfo.width = width;
item.moduleInfo.height = height;
},
}),
});
})();
