﻿// This file basically has the entry level ipages for the partner and cloud panos.
// Each and every class here derives from their respective ipages
// If we want to override any method of these for finance app alone, we can override them here
// E.g. Our snap mode is different from the default snap of WSJ and Cloud
// This gives more control on partner/cloud panos
// We can add more stuff here based on requirement
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
//Entry ipage for WSJ Pano
WSJPano: WinJS.Class.derive(WSJJS.CategoryPano,
function (state) {
if (!FinanceAppJS.WSJ.wsjCssLoaded) {
utils.importStyleSheet("/css/default.css");
utils.importStyleSheet("/css/partners.css");
FinanceAppJS.WSJ.wsjCssLoaded = true;
}
WSJJS.CategoryPano.call(this, state);
this._articleReaderPage = "FinanceAppJS.WSJArticleReaderPage";
this._slideShowPage = "FinanceAppJS.WSJSlideShowPage";
}, {
_onHeaderSelection: function _onHeaderSelection(clusterKey, index, pano, event) {
/// <summary>Header selection handler</summary>
/// <param name="clusterKey">Key of cluster clicked</param>
/// <param name="index">Index of cluster </param>
/// <param name="pano">Pano clicked</param>
/// <param name="event">Event of click</param>
//channel Id should be set based on entry point.
var state = this._state;
var newState = {
feedType: state.feedType,
feedIdentifierValue: clusterKey,
theme: this._partner
};
var pageInfo = {
fragment: "/wsjshared/wsjCategoryPano.html",
page: "FinanceAppJS.WSJPano",
channelId: state.hoist ? state.feedIdentifierValue + "_" + clusterKey : this._partner + "_" + state.feedIdentifierValue,
};
WinJS.Navigation.navigate(pageInfo, newState);
},
onLayoutChange: function onLayoutChange(event) {
//This will prevent the default WSJ snap action. We have a snapped channel in finance where we'll always navigate on snap
},
onNavigateAway: function onNavigateAway(event) {
WSJJS.CategoryPano.prototype.onNavigateAway.call(this, event);
FinanceAppJS.WSJPano.closeSession();
},
getPageImpressionContext: function getPageImpressionContext() {
// DO NOT LOCALIZE THESE STRING HERE
switch (this._state.feedIdentifierValue) {
case "WSJ LIVE":
return "/WSJ Live";
case "FRONT SECTION":
default:
return "/WSJ";
}
return "/WSJ";
},
}, {
closeSession: function closeSession() {
var newChannel = PlatformJS.Navigation.mainNavigator.channelIDInView;
if (newChannel) {
if (!(newChannel.indexOf("WSJ") === 0)) {
NewsJS.Partners.Theme.onNavigated();
}
}
}
}),
//Deriving from WSJ process Listener and changing the entry ipage to FinanceAppJS.WSJPano in the overridden method of createChannel.
WSJProcessListener: WinJS.Class.derive(WSJJS.ProcessListener,
function (state) {
WSJJS.ProcessListener.call(this, state);
this._pageMapping["FinanceAppJS.WSJPano"] = "/wsjshared/wsjCategoryPano.html";
}, {
createChannel: function createChannel(section, visible) {
var channelObject = WSJJS.ProcessListener.prototype.createChannel.call(this, section, visible);
channelObject.pageInfo.page = "FinanceAppJS.WSJPano";
return channelObject;
},
}),
WSJArticleReaderPage: WinJS.Class.derive(WSJJS.ArticleReader.Page,
function (state) {
WSJJS.ArticleReader.Page.call(this, state);
}, {
onNavigateAway: function onNavigateAway(event) {
WSJJS.ArticleReader.Page.prototype.onNavigateAway.call(this, event);
FinanceAppJS.WSJPano.closeSession();
},
}),
WSJSlideShowPage: WinJS.Class.derive(WSJJS.SlideShow.Page,
function (state) {
WSJJS.SlideShow.Page.call(this, state);
this._pageMapping["FinanceAppJS.WSJPano"] = "/wsjshared/wsjCategoryPano.html";
}, {
onNavigateAway: function onNavigateAway(event) {
WSJJS.SlideShow.Page.prototype.onNavigateAway.call(this, event);
FinanceAppJS.WSJPano.closeSession();
},
}),
});
})();
(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS", {
//Entry ipage for Cloud Pano
CloudPano: WinJS.Class.derive(CommonJS.CloudPanorama,
function (state) {
CommonJS.CloudPanorama.call(this, state);
}, {
onLayoutChange: function onLayoutChange(event) {
//This will prevent the default Cloudpano snap action. We have a snapped channel in finance where we'll always navigate on snap
},
})
});
})();