﻿(function () {
'use strict';
WinJS.Namespace.define("CommonJS",
{
/// <summary>
/// Bond Chart control.
/// Renders bond chart
/// </summary>
BondChartControl: WinJS.Class.define(
/// <summary>
/// Constructor: Creates an instance of the Header Control object.
/// </summary>
/// <returns>
/// An instance of the Header control object.
/// </returns>
function (element, options) {
element = element || document.createElement("div");
element.winControl = this;
this._init(element);
WinJS.UI.setOptions(this, options);
},
// Instance members
{
_domElement: null,
_chartContainerId: null,
_dataSource: null,
_data: null,
_chart: null,
_chartHelper: null,
data: {
get: function get() {
return this._data;
},
set: function set(value) {
this._data = value;
if (!this._chart) {
this._chart = this._chartHelper.LoadChart(this._chartContainerId, this._data);
}
}
},
_init: function _init(element) {
this._domElement = element;
this._chartContainerId = this._domElement.getAttribute("id");
if (!this._chartContainerId) {
var uniqueId = 'C' + Math.ceil((100000 * Math.random())).toString() + '_chart';
this._domElement.setAttribute("id", uniqueId);
this._chartContainerId = uniqueId;
}
this._chartHelper = new BondChartHelper();
if (this._data) {
this._chart = this._chartHelper.LoadChart(this._chartContainerId, this._data);
}
},
})
});
})();
(function () {
'use strict';
WinJS.Namespace.define("CommonJS",
{
/// <summary>
/// Pie Chart control.
/// Renders Pie chart
/// </summary>
PieChartControl: WinJS.Class.define(
/// <summary>
/// Constructor: Creates an instance of the Header Control object.
/// </summary>
/// <returns>
/// An instance of the Header control object.
/// </returns>
function (element, options) {
element = element || document.createElement("div");
element.winControl = this;
this._init(element);
WinJS.UI.setOptions(this, options);
},
// Instance members
{
_domElement: null,
_chartContainerId: null,
_data: null,
_chart: null,
_chartHelper: null,
_isLandScape: true,
data5: {
get: function get() {
return this._data;
},
set: function set(value) {
var that = this;
this._data = value;
if (!this._chart) {
that._chart = that._chartHelper.LoadChart(that._domElement, that._data, that._isLandScape);
}
}
},
isLandScape: {
get: function get() {
return this._isLandScape;
},
set: function set(value) {
this._isLandScape = value;
}
},
_init: function _init(element) {
this._domElement = element;
this._chartContainerId = this._domElement.getAttribute("id");
if (!this._chartContainerId) {
var uniqueId = 'C' + Math.ceil((100000 * Math.random())).toString() + '_chart';
this._domElement.setAttribute("id", uniqueId);
this._chartContainerId = uniqueId;
}
if (!this._chartHelper) {
this._chartHelper = new PieChartHelper();
}
if (this._data) {
this._chart = this._chartHelper.LoadChart(this._domElement, this._data, this._isLandScape);
}
},
redraw: function redraw() {
var that = this;
msSetImmediate(function () { that._chart = that._chartHelper.LoadChart(that._chartContainerId, that._stock, that._domElement.clientWidth, that._domElement.clientHeight, that._isIndexChart, that._chartType, that._hoverEnabled, that._chartButtons); });
},
})
});
})();
(function () {
'use strict';
(function () {
WinJS.Namespace.define("CommonJS",
{
/// <summary>
/// Button that shows a menu when clicked on
/// </summary>
CompareButton: WinJS.Class.define(
function (element, options) {
/// <summary>
/// constructor
/// </summary>
/// <param name="element">
/// The DOM element
/// </param>
/// <param name="options">
/// Options structure
/// </param>
var that = this;
this.element = element || document.createElement("div");
CommonJS.setAutomationId(element);
this.element.setAttribute("aria-haspopup", true);
this.element.style.zIndex = 2000;
//this.element.addEventListener("mousedown", function () {
this.element.addEventListener("MSPointerUp", function () {
if (that._states) {
if (!that._flyoutShown && that._flyout.hidden) {
that._flyoutShown = true;
that._flyout.show(that.element, "top");
}
}
});
this._flyout = new WinJS.UI.Flyout(null, {});
this._flyout.addEventListener("afterhide", function () {
that._flyoutShown = false;
if (that._onFlyoutHide) {
that._onFlyoutHide();
}
});
CommonJS.setAutomationId(this._flyout.element, this.element, "flyout");
// Need to define the flyout outside of the edgeui. To make sure we do, just add it to the platformPageArea
WinJS.Utilities.addClass(this._flyout.element, "platformMenu win-menu");
this._flyout.element.setAttribute("role", "menu");
document.getElementById("platformPageArea").appendChild(this._flyout.element);
// hack to hide the fly out on scroll
var parentScrollContainer = document.getElementById("stockEntityMainList");
if (parentScrollContainer) {
if (parentScrollContainer
&& parentScrollContainer.winControl
&& parentScrollContainer.winControl._viewport) {
parentScrollContainer.winControl._viewport.addEventListener("scroll", function () {
if (that._flyoutShown) {
that._flyout.hide();
}
});
}
}
this.element.winControl = this;
this._onFlyoutHide = null;
this._onResetClicked = null;
this._flyoutShown = false;
this._currentState = null;
this._states = null;
this.selectionMode = CommonJS.MenuButton.Multi;
WinJS.UI.setOptions(this, options);
},
{
_flyoutShown: false,
_currentState: [],
_flyout: null,
_states: null,
/// <field>
/// The DOM element container
/// </field>
element: null,
/// <field>
/// Function to invoke when flyout goes away
/// </field>
onFlyoutHide: {
set: function set(value) {
this._onFlyoutHide = value;
},
get: function get() {
return this._onFlyoutHide;
}
},
/// <field>
/// Function to invoke when flyout goes away
/// </field>
onResetClicked: {
set: function set(value) {
this._onResetClicked = value;
},
get: function get() {
return this._onResetClicked;
}
},
/// <field>
/// Function to invoke when there is a state change
/// </field>
onStateChange: null,
/// <field>
/// Selection mode: "Multi" or "Single"
/// </field>
selectionMode: null,
/// <field>
/// The available states for the button. A state should be:
/// {
///    id: string,
///    title: string
/// }
/// </field>
states: {
get: function get() {
return this._states;
},
set: function set(value) {
var i = 0,
state = null,
that = this;
this._states = {};
WinJS.Utilities.empty(that._flyout.element);
value.push({ id: "reset", title: utils.getResourceString("SEReset Graph") });
for (i = 0; i < value.length; i++) {
state = value[i];
if (state.id === null || state.id === undefined) {
PlatformJS.Utilities.onError("ID must be included in a button state");
}
if (state.title === null || state.title === undefined) {
PlatformJS.Utilities.onError("Title must be included in a button state");
}
this._states[state.id] = state;
(function (state) {
var i = 0,
s = null,
otherState = null;
// Create the menu item
state.button = document.createElement("button");
CommonJS.setAutomationId(state.button, this.element, state.id);
WinJS.Utilities.addClass(state.button, "compareMenuItem");
state.button.setAttribute("role", "menuitem");
state.label = document.createElement("div");
state.label.textContent = state.title;
WinJS.Utilities.addClass(state.label, "compareMenuLabel");
state.label.style.width = 'auto';
state.button.appendChild(state.label);
state.check = document.createElement("div");
WinJS.Utilities.addClass(state.check, "compareMenuCheck");
state.button.appendChild(state.check);
state.button.onclick = function (event) {
if (state.id === "reset") {
if (that._currentState) {
for (var i = 0; i < that._currentState.length; i++) {
otherState = that._states[that._currentState[i]];
WinJS.Utilities.toggleClass(otherState.check, "compareMenuLabelCheck");
otherState.isChecked = false;
}
that._currentState = [];
}
if (that._onResetClicked) {
that._onResetClicked();
}
that._flyout.hide();
}
else {
if (!that._currentState) {
that._currentState = [];
}
if (that._currentState.length < 2 || state.isChecked === true) {
// Toggle the current button
state.isChecked = !state.isChecked;
WinJS.Utilities.toggleClass(state.check, "compareMenuLabelCheck");
//that._currentState = [];
if (state.isChecked === true) {
that._currentState.push(state.id);
}
else {
that._currentState = [];
// Build up the state array
for (s in that._states) {
otherState = that._states[s];
if (otherState.isChecked) {
that._currentState.push(otherState.id);
}
}
}
}
else {
if (that._currentState.length === 2) {
// Toggle the current button
state.isChecked = !state.isChecked;
WinJS.Utilities.toggleClass(state.check, "compareMenuLabelCheck");
var otherState = that._currentState.pop();
otherState = that._states[otherState];
otherState.isChecked = false;
WinJS.Utilities.toggleClass(otherState.check, "compareMenuLabelCheck");
that._currentState.push(state.id);
}
}
if (that.onStateChange) {
that.onStateChange(that._currentState);
}
}
};
that._flyout.element.appendChild(state.button);
})(state);
}
// update the check states if we haven't already
if (this._currentState) {
this.currentState = this._currentState;
}
}
},
/// <field>
/// The array of currently selected state id's
/// </field>
currentState: {
set: function set(value) {
var state = null,
i = 0,
s = null;
this._currentState = value;
if (this.selectionMode !== CommonJS.MenuButton.Menu && this._states) {
for (s in this._states) {
state = this._states[s];
state.isChecked = false;
WinJS.Utilities.removeClass(state.check, "compareMenuLabelCheck");
}
for (i = 0; i < this._currentState.length; i++) {
state = this._states[this._currentState[i]];
if (state) {
state.isChecked = true;
WinJS.Utilities.addClass(state.check, "compareMenuLabelCheck");
} else {
PlatformJS.Utilities.onError("Invalid button state id");
}
}
}
},
get: function get() {
return this._currentState;
}
},
/// <field>
/// The title of the button
/// </field>
title: {
set: function set(value) {
if (value) {
this.element.innerText = value;
} else {
PlatformJS.Utilities.onError("Button title must be non-null");
}
}
},
},
{
/// <field>
/// Multi select
/// </field>
Multi: "Multi",
/// <field>
/// Single select
/// </field>
Single: "Single",
/// <field>
/// Menu select
/// </field>
Menu: "Menu"
})
});
})();
//Class for BarChart Options
WinJS.Namespace.define("CommonJS",
{
BarChartOptions: WinJS.Class.define(
function () {
//initializing default options
this._isSplitBar = false;
this._colors = ["#0077b3", "#00283c", "yellowgreen", "blue", "red", "yellow"];
this._isRtl = null;
this._paddingLeft = 43;
this._paddingY = 50;
this._paddingRight = 0;
this._enableSave = false;
this._enablePrint = false;
this._enableHover = false;
this._horizontalLineColor = "#81919E";
this._backgroundColor = "#ffffff";
this._animationTimer;
this._animationScale = 0.0;
this._playAnimation = false;
this._forceDraw = true;
this._is3d = false;
this._legendContainerHeight = 30;
this._yAxisLabelCount = 5;
this._yAxisLabelProvided = true;
this._legendParent = null;
this._populateColorsArray = true;
},
{
populateColorsArray: {
get: function get() {
return this._populateColorsArray;
},
set: function set(value) {
this._populateColorsArray = value;
}
},
yAxisLabelCount: {
get: function get() {
return this._yAxisLabelCount;
},
set: function set(value) {
this._yAxisLabelCount = value;
}
},
legendParent: {
get: function get() {
return this._legendParent;
},
set: function set(value) {
this._legendParent = value;                    
}
},
yAxisLabelProvided: {
get: function get() {
return this._yAxisLabelProvided;
},
set: function set(value) {
this._yAxisLabelProvided = value;
}
},
isSplitBar: {
get: function get() {
return this._isSplitBar;
},
set: function set(value) {
this._isSplitBar = value;
}
},
colors: {
get: function get() {
return this._colors;
},
set: function set(value) {
this._colors = value;
}
},
horizontalLineColor: {
get: function get() {
return this._horizontalLineColor;
},
set: function set(value) {
this._horizontalLineColor = value;
}
},
paddingLeft: {
get: function get() {
return this._paddingLeft;
},
set: function set(value) {
this._paddingLeft = value;
}
},
paddingRight: {
get: function get() {
return this._paddingRight;
},
set: function set(value) {
this._paddingRight = value;
}
},
paddingY: {
get: function get() {
return this._paddingY;
},
set: function set(value) {
this._paddingY = value;
}
},
legendContainerHeight: {
get: function get() {
return this._legendContainerHeight;
},
set: function set(value) {
this._legendContainerHeight = value;
}
},
enableSave: {
get: function get() {
return this._enableSave;
},
set: function set(value) {
this._enableSave = value;
}
},
enablePrint: {
get: function get() {
return this._enablePrint;
},
set: function set(value) {
this._enablePrint = value;
}
},
enableHover: {
get: function get() {
return this._enableHover;
},
set: function set(value) {
this._enableHover = value;
}
},
backgroundColor: {
get: function get() {
return this._backgroundColor;
},
set: function set(value) {
this._backgroundColor = value;
}
},
animationTimer: {
get: function get() {
return this._animationTimer;
},
set: function set(value) {
this._animationTimer = value;
}
},
animationScale: {
get: function get() {
return this._animationScale;
},
set: function set(value) {
this._animationScale = value;
}
},
playAnimation: {
get: function get() {
return this._playAnimation;
},
set: function set(value) {
this._playAnimation = value;
}
},
forceDraw: {
get: function get() {
return this._forceDraw;
},
set: function set(value) {
this._forceDraw = value;
}
},
is3d: {
get: function get() {
return this._is3d;
},
set: function set(value) {
this._is3d = value;
}
}
},
{})
});
WinJS.Namespace.define("CommonJS",
{
/// <summary>
/// Bar Chart control.
/// Renders bar chart
/// </summary>
BarChartControl: WinJS.Class.define(
/// <summary>
/// Constructor: Creates an instance of the Header Control object.
/// </summary>
/// <returns>
/// An instance of the Header control object.
/// </returns>
function (element, options) {
element = element || document.createElement("div");
element.winControl = this;
this._init(element,options);        
},
// Instance members
{
_domElement: null,
_chartContainerId: null,            
_data: null,
_chart: null,
_chartHelper: null,
data: {
get: function get() {
return this._data;
},
set: function set(value) {
this._data = value;
if (!this._chart) {
this._chart = this._chartHelper.LoadChart(this._domElement, this._data, this._barChartOptions);
}
}
},
redraw: function redraw() {
this._chart = null;
this._chart = this._chartHelper.LoadChart(this._domElement, this._data, this._barChartOptions);
},
_init: function _init(element, options) {
this._domElement = element;
this._barChartOptions = new CommonJS.BarChartOptions();
WinJS.UI.setOptions(this._barChartOptions, options);
this._chartContainerId = this._domElement.getAttribute("id");
if (!this._chartContainerId) {
var uniqueId = 'C' + Math.ceil((100000 * Math.random())).toString() + '_chart';
this._domElement.setAttribute("id", uniqueId);
this._chartContainerId = uniqueId;
}
this._chartHelper = new BarChartHelper();
if (this._data) {
this._chart = this._chartHelper.LoadChart(this._domElement, this._data, this._barChartOptions);
}
},
})
});
})();