﻿(function () {
"use strict";
//Combined Data Provider for MyStocks, Movers, Index realtime data
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
chartDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.DataProviderBase, function (options) {
this.instrumentType = options.instrumentType;
FinanceAppJS.DataProvider.DataProviderBase.call(this, options);
this.stockSymbol = options && options.stockSymbol;
if (this.instrumentType === 'stock' || this.instrumentType === 'etf') {
this.isEOD = options && options.isEOD;
}
this.refreshInterval = options.refreshInterval;
this.duration = options && options.duration;
this.enableFRE = FinanceAppJS.Globals.FRE;
}, {
isEOD: false,
stockSymbol: null,
instrumentType: null,
duration: null,
getQueryServiceParams: function getQueryServiceParams() {
var urlParams = PlatformJS.Collections.createStringDictionary();
urlParams.insert("entities", encodeURIComponent(this.stockSymbol));
urlParams.insert("duration", this.duration);
urlParams.insert("isEOD", this.isEOD);
return urlParams;
},
updateOptions: function updateOptions(options) {
// cancel any previous call to fetch data.
// cancelfetch is required here but it has a bug that getData doesn't work once call to cancelFetch is made. 
this.cancelFetch();
// update option fields
if (options.stockSymbol) {
this.stockSymbol = options.stockSymbol;
this.isEOD = options.isEOD;
}
if (options.duration) {
this.duration = options.duration;
}
this.refreshInterval = options.refreshInterval;
// start data fetch operation as chart series has changed by user.
this._getDataBase({ forceRefresh: true });
},
_getDataBase: function _getDataBase(options) {
FinanceAppJS.DataProvider.DataProviderBase.prototype.getData.call(this, options);
},
dataBuilder: function dataBuilder(data, response) {
if (data && response) { //null check
if (FinanceAppJS.Globals.FRE === true || !Array.isArray(data)) {
// select proper FRE data node
data = data[FinanceAppJS.Globalization.getIndexCodeForSymbol(this.stockSymbol) + "_" + this.duration + "_chartData"];
}
if (data) {
var fstTs, ts;
var fundYcp = 10000.00;
for (var j = 0; j < data.length; j++) {
if (data[j]) {
var currentData = data[j];
currentData.series = [];
currentData.chartType = currentData.Ct.toLowerCase();
currentData.lastUpdateTime = response.lastUpdateTime;
if (this.instrumentType === "fund") {
currentData.Ycp = fundYcp;
currentData.Series = currentData.Srs;
currentData.seriesId = currentData.Scid + currentData.chartType;
}
else {
currentData.seriesId = currentData.Fi + currentData.chartType;
}
for (var i = 0; i < currentData.Series.length; i++) {
if (i === 0) {
fstTs = ts = currentData.Series[i].T;
} else {
ts = currentData.Series[i].T + fstTs;
}
//The timestamp is the number of minutes passed from 1st Jan 2000.
//Convert it current time.
ts = (ts * 60 * 1000) + 946684800000;
currentData.series.push([ts, currentData.Series[i].P]);
}
currentData.Series = null;
}
}
}
}
return data;
},
})
});
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
StockChartDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.chartDataProvider, function (options) {
FinanceAppJS.DataProvider.chartDataProvider.call(this, options);
}, {
queryServiceId: "stockchartdata"
})
});
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
FundChartDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.chartDataProvider, function (options) {
FinanceAppJS.DataProvider.chartDataProvider.call(this, options);
}, {
queryServiceId: "fundchartdata"
})
});
WinJS.Namespace.define("FinanceAppJS.DataProvider", {
ETFChartDataProvider: WinJS.Class.derive(FinanceAppJS.DataProvider.chartDataProvider, function (options) {
FinanceAppJS.DataProvider.chartDataProvider.call(this, options);
}, {
queryServiceId: "etfchartdata"
})
});
})();
