﻿(function () {
'use strict';
WinJS.Namespace.define("FinanceAppJS.UI",
{
appexChartOptions: WinJS.Class.define(function () {
// initialize chart options to default values.
this._paddingLeft = 75;
this._paddingTop = 20;
this._paddingRight = 2;
this._paddingBottom = 30;
this._enableExpand = false;
this._enableSave = false;
this._enablePrint = false;
this._backgroundColor = null;
this._borderColor = null;
this._gridLineWidth = 0.5;
this._gridLineColor = 'rgba(179, 194, 216, 0.7)';
this._gridLineCount = 4;
this._labelTextColor = null;
this._labelFont = '12px "Segoe UI"';
this._labelTextPaddingTop = 20;
this._labelTextPadding = 6;
this._hightLightTextPaddingTop = 12;
this._hightLightTextFont = '12px "Segoe UI"';
this._hightLightTextFontBold = 'Bold 12px "Segoe UI"';
this._hightLightTextColor = null;
this._hightLightLineColor = null;
this._seriesColors = null;
this._enableHover = 'mouseAndTouch';
this._disableHoverOnBlur = false;
this._xPaddingPercent = 0;
this._yPaddingPercent = 15;
this._isRtl = null;
this._xLabelsProvided = false;
this._graphType = 'area';
this._isMultiSeries = false;
this._chartColors = null;
this._decimalPrecision = 2;
this._labelSpacing = 15;
this._displayCaption = false;
this._instrumentationId = null;
}, {
resetColors: function resetColors() {
this.chartColors = null;
this.backgroundColor = null;
this.borderColor = null;
this.seriesColors = null;
this.labelTextColor = null;
this.hightLightLineColor = null;
this.hightLightTextColor = null;
},
isRtl: {
get: function get() {
if (this._isRtl === null) {
this._isRtl = (window.getComputedStyle(document.body).direction === "rtl");
}
return this._isRtl;
}
},
displayCaption: {
get: function get() {
return this._chartCaption;
},
set: function set(value) {
this._chartCaption = value;
}
},
instrumentationId: {
get: function get() {
return this._instrumentationId;
},
set: function set(value) {
this._instrumentationId = value;
}
},
graphType: {
get: function get() {
return this._graphType;
},
set: function set(value) {
this._graphType = value;
}
},
isMultiSeries: {
get: function get() {
return this._isMultiSeries;
},
set: function set(value) {
this._isMultiSeries = value;
}
},
paddingLeft: {
get: function get() {
return this._paddingLeft;
},
set: function set(value) {
this._paddingLeft = value;
}
},
paddingTop: {
get: function get() {
// TODO : - move to chart control
if (screen.height >= 900) {
if (this._paddingTop < 25) {
return 25;
}
} else {
if (this._paddingTop > 25) {
return 20;
}
}
return this._paddingTop;
},
set: function set(value) {
this._paddingTop = value;
}
},
paddingRight: {
get: function get() {
return this._paddingRight;
},
set: function set(value) {
this._paddingRight = value;
}
},
paddingBottom: {
get: function get() {
return this._paddingBottom;
},
set: function set(value) {
this._paddingBottom = value;
}
},
xLabelsProvided: {
get: function get() {
return this._xLabelsProvided;
},
set: function set(value) {
this._xLabelsProvided = value;
}
},
enableExpand: {
get: function get() {
return this._enableExpand;
},
set: function set(value) {
this._enableExpand = value;
}
},
enableSave: {
get: function get() {
return this._enableSave;
},
set: function set(value) {
this._enableSave = value;
}
},
enablePrint: {
get: function get() {
return this._enablePrint;
},
set: function set(value) {
this._enablePrint = value;
}
},
chartColors: {
get: function get() {
if (!this._chartColors) {
this._chartColors = utils.JsLessVariables(false);
}
return this._chartColors;
},
set: function set(value) {
this._chartColors = value;
}
},
borderColor: {
get: function get() {
if (!this._borderColor) {
var defaultBorderColor = "transparent";
this._borderColor = utils.getColorForCurrentContrast(defaultBorderColor);
}
return this._borderColor;
},
set: function set(value) {
this._borderColor = value;
}
},
backgroundColor: {
get: function get() {
if (!this._backgroundColor) {
this._backgroundColor = window.getComputedStyle(document.body).backgroundColor;
}
return this._backgroundColor;
},
set: function set(value) {
this._backgroundColor = value;
}
},
gridLineWidth: {
get: function get() {
return this._gridLineWidth;
},
set: function set(value) {
this._gridLineWidth = value;
}
},
gridLineColor: {
get: function get() {
return this._gridLineColor;
},
set: function set(value) {
this._gridLineColor = value;
}
},
gridLineCount: {
get: function get() {
return this._gridLineCount;
},
set: function set(value) {
this._gridLineCount = value;
}
},
labelTextColor: {
get: function get() {
if (!this._labelTextColor) {
var defaultLabelTextColor = '#4d6384';
this._labelTextColor = utils.getColorForCurrentContrast(defaultLabelTextColor);
}
return this._labelTextColor;
},
set: function set(value) {
this._labelTextColor = value;
}
},
labelFont: {
get: function get() {
return this._labelFont;
},
set: function set(value) {
this._labelFont = value;
}
},
labelTextPadding: {
get: function get() {
return this._labelTextPadding;
},
set: function set(value) {
this._labelTextPadding = value;
}
},
labelTextPaddingTop: {
get: function get() {
// TODO : - move to chart control
if(screen.height >= 900){
this._labelTextPaddingTop = 25;
} else {
this._labelTextPaddingTop = 20;
}
return this._labelTextPaddingTop;
},
set: function set(value) {
this._labelTextPaddingTop = value;
}
},
hightLightTextPaddingTop: {
get: function get() {
return this._hightLightTextPaddingTop;
},
set: function set(value) {
this._hightLightTextPaddingTop = value;
}
},
hightLightTextFont: {
get: function get() {
return this._hightLightTextFont;
},
set: function set(value) {
this._hightLightTextFont = value;
}
},
hightLightTextFontBold: {
get: function get() {
return this._hightLightTextFontBold;
},
set: function set(value) {
this._hightLightTextFontBold = value;
}
},
hightLightTextColor: {
get: function get() {
if (!this._hightLightTextColor) {
var defaultHightLightTextColor = '#2B4C66';
this._hightLightTextColor = utils.getColorForCurrentContrast(defaultHightLightTextColor);
}
return this._hightLightTextColor;
},
set: function set(value) {
this._hightLightTextColor = value;
}
},
hightLightLineColor: {
get: function get() {
if (!this._hightLightLineColor) {
var defaultHightLightLineColor = '#2B4C66';
this._hightLightLineColor = utils.getColorForCurrentContrast(defaultHightLightLineColor);
}
return this._hightLightLineColor;
},
set: function set(value) {
this._hightLightLineColor = value;
}
},
seriesColors: {
get: function get() {
if (!this._seriesColors) {
this._seriesColors = [];
var defaultSeriesColors = ['#2CABEF', '#F43EB0', '#F3C056', '#7D1616', '#DF01ED', '#DD3838', '#00D4CC', '#D40000', '#1C78B9', '#A6C73C', '#5E504A', '#ED0091', '#FF9B6F'];
for (var i = 0; i < defaultSeriesColors.length; i++) {
this._seriesColors.push(utils.getColorForCurrentContrast(defaultSeriesColors[i]));
}
}
return this._seriesColors;
},
set: function set(value) {
this._seriesColors = value;
}
},
enableHover: {
get: function get() {
return this._enableHover;
},
set: function set(value) {
this._enableHover = value;
}
},
disableHoverOnBlur: {
get: function get() {
return this._disableHoverOnBlur;
},
set: function set(value) {
this._disableHoverOnBlur = value;
}
},
xPaddingPercent: {
get: function get() {
return this._xPaddingPercent;
},
set: function set(value) {
this._xPaddingPercent = value;
}
},
yPaddingPercent: {
get: function get() {
return this._yPaddingPercent;
},
set: function set(value) {
this._yPaddingPercent = value;
}
},
decimalPrecision: {
get: function get() {
return this._decimalPrecision;
},
set: function set(value) {
this._decimalPrecision = value;
}
},
labelSpacing: {
get: function get() {
return this._labelSpacing;
},
set: function set(value) {
this._labelSpacing = value;
}
},
}, {}
),
appexChartDimensions: WinJS.Class.define(
function (controlWidth, controlHeight, chartPaddingLeft, chartPaddingTop, chartPaddingRight, chartPaddingBottom) {
this._chartPaddingLeft = chartPaddingLeft;
this._chartPaddingTop = chartPaddingTop;
this._chartPaddingRight = chartPaddingRight;
this._chartPaddingBottom = chartPaddingBottom;
this.controlWidth = controlWidth;
this.controlHeight = controlHeight;
},
{
_controlWidth: null,
_controlHeight: null,
_chartWidth: null,
_chartHeight: null,
_chartPaddingLeft: null,
_chartPaddingTop: null,
_chartPaddingRight: null,
_chartPaddingBottom: null,
controlWidth: {
get: function get() {
return this._controlWidth;
},
set: function set(value) {
this._controlWidth = value;
this._chartWidth = this._controlWidth - (this._chartPaddingLeft + this._chartPaddingRight);
}
},
controlHeight: {
get: function get() {
return this._controlHeight;
},
set: function set(value) {
this._controlHeight = value;
this._chartHeight = this._controlHeight - (this._chartPaddingTop + this._chartPaddingBottom);
}
},
chartPaddingLeft: {
get: function get() {
return this._chartPaddingLeft;
},
set: function set(value) {
this._chartPaddingLeft = value;
}
},
chartPaddingTop: {
get: function get() {
return this._chartPaddingTop;
},
set: function set(value) {
this._chartPaddingTop = value;
}
},
chartWidth: {
get: function get() {
return this._chartWidth;
},
},
chartHeight: {
get: function get() {
return this._chartHeight;
},
},
}
),
appexChartControlDimensions: WinJS.Class.define(
function (controlWidth, controlHeight) {
this._controlWidth = controlWidth;
this._controlHeight = controlHeight;
},
{
_controlWidth: null,
_controlHeight: null,
controlWidth: {
get: function get() {
return this._controlWidth;
},
set: function set(value) {
this._controlWidth = value;
}
},
controlHeight: {
get: function get() {
return this._controlHeight;
},
set: function set(value) {
this._controlHeight = value;
}
},
}
),
dataSeries: WinJS.Class.define(
//Constructor
function (chartOptions, seriesObject, data, chartDimensions, seriesColorIndex, chartLimits) {
this._chartOptions = chartOptions;
this.seriesId = seriesObject.seriesId;
this.seriesDisplayName = seriesObject.displayName ? seriesObject.displayName : "-";
this._chartDimensions = chartDimensions;
this._data = data;
this.chartType = this._data.chartType;
this.xVals = [];
this.yVals = [];
this.xCoord = [];
this.yCoord = [];
this.thresholdY = data.Ycp;
this.colorIndex = seriesColorIndex;
this._chartLimits = chartLimits;
if (this._chartLimits) {
this.minX = this._chartLimits.minX;
this.minY = this._chartLimits.minY;
this.maxX = this._chartLimits.maxX;
this.maxY = this._chartLimits.maxY;
}
else {
this.minY = null;
this.minX = null;
this.maxX = null;
this.maxY = null;
}
this.chartWidth = null;
this.chartHeight = null;
this.scaleX = null;
this.scaleY = null;
this.xMarginPercent = this._chartOptions.xPaddingPercent;
this.yMarginPercent = this._chartOptions.yPaddingPercent;
this.gapSize = 300000;
this.gapList = [];
this._lookupArray = [];
this._init();
},
//instance members
{
_init: function _init() {
this._setGapSize();
this._setRange(this._data.St, this._data.Et);
this._insertOpenPriceTick();
this.xVals = this._data.series.map(function (i) { return i[0]; });
this.yVals = this._data.series.map(function (i) { return i[1]; });
if (this._chartOptions.xLabelsProvided) {
this.xLabels = this._data.series.map(function (i) { return i[2]; });
}
this._calculateDrawingPoints();
},
_insertOpenPriceTick: function _insertOpenPriceTick() {
// insert fist data point corresponding to open price for 1d chart.
if (this.chartType === "1d") {
this._data.series.splice(0, 0, [this.startTime, this.thresholdY]);
}
},
update: function update(data) {
this._data = data;
this._setGapSize();
this._setRange(this._data.St, this._data.Et);
this.thresholdY = data.Ycp;
this._insertOpenPriceTick();
this.xVals = this._data.series.map(function (i) { return i[0]; });
this.yVals = this._data.series.map(function (i) { return i[1]; });
this._calculateDrawingPoints();
},
_setGapSize: function _setGapSize() {
switch (this._data.chartType) {
case "1d":
this.gapSize = 12 * 60 * 60 * 1000; //12 hours
break;
case "5d":
this.gapSize = 12 * 60 * 60 * 1000; //5 mins
break;
case "1m":
this.gapSize = 5 * 24 * 60 * 60 * 1000; // 5 days
break;
case "1y":
this.gapSize = 30 * 24 * 60 * 60 * 1000; // 30 days
break;
case "5y":
this.gapSize = 365 * 24 * 60 * 60 * 1000; // 1 year
break;
case "max":
this.gapSize = 2 * 365 * 24 * 60 * 60 * 1000; // 2 years
break;
case "bonds":
this.gapSize = 3; // tuned to suit the chart.
break;
default:
this.gapSize = 3 * 30 * 24 * 60 * 60 * 1000; // 30 days
break;
}
},
thresholdPoint: {
get: function get() {
return this._chartDimensions.chartHeight + this._chartDimensions.chartPaddingTop - ((this._data.Ycp - this.minY) / this.scaleY);
}
},
_setRange: function _setRange(marketOpen, marketClose) {
if (marketOpen && marketClose && this._data.chartType === "1d") {
var splits = marketOpen.split('T');
var marketOpenDate = splits[0];
var marketOpenTimes = splits[1].split(':');
var marketOpenHour = parseInt(marketOpenTimes[0]);
var marketOpenMins = parseInt(marketOpenTimes[1]);
splits = marketOpenDate.split('-');
this.startTime = new Date();
this.startTime.setUTCFullYear(parseInt(splits[0]), parseInt(splits[1]) - 1, parseInt(splits[2]));
this.startTime.setUTCHours(marketOpenHour, marketOpenMins, 0, 0);
this.startTime = this.startTime.getTime();
splits = marketClose.split('T');
var marketCloseDate = splits[0];
var marketCloseTimes = splits[1].split(':');
var marketCloseHour = parseInt(marketCloseTimes[0]);
var marketCloseMins = parseInt(marketCloseTimes[1]);
splits = marketCloseDate.split('-');
this.endTime = new Date();
this.endTime.setUTCFullYear(parseInt(splits[0]), parseInt(splits[1]) - 1, parseInt(splits[2]));
this.endTime.setUTCHours(marketCloseHour, marketCloseMins, 0, 0);
this.endTime = this.endTime.getTime();
}
// validate if start time and end time are set for 1d chart otherwise throw error
// this will be cought in calling module (appexChart class) which will show error message
if (this._data.chartType === "1d" && !(this.startTime && this.endTime)) {
throw "StartTime and EndTime are mendatory for 1d chart";
}
},
getHighLightPoint: function getHighLightPoint(mouseX) {
return this._lookupArray[~~mouseX];
},
_prepareGapList: function _prepareGapList() {
this.gapList = [];
var gapCounter = 0, diff;
for (var i = 0; i < this._data.series.length - 1; i++) {
// adjustment for the 1 data point which is drawn, otherwise all diffs would make scale zero eventually (in case when every data point costitutes a diff)
diff = (this._data.series[i + 1][0] - this._data.series[i][0] - 1);
if (diff > this.gapSize) {
this.gapList[gapCounter++] = [i, diff];
}
}
},
_getGapFactorForIndex: function _getGapFactorForIndex(index) {
var gapFactor = 0;
for (var i = 0; i < this.gapList.length; i++) {
if (this.gapList[i][0] < index) {
gapFactor += this.gapList[i][1];
}
else {
break;
}
}
return gapFactor;
},
_getGapFactorForValue: function _getGapFactorForValue(value) {
var index = 0;
var len = this._data.series.length;
for (var i = 0; i < len; i++) {
if (this._data.series[i][0] >= value) {
index = i;
break;
}
}
return this._getGapFactorForIndex(index);
},
_getGapsSum: function _getGapsSum() {
var gapSum = 0;
for (var i = 0; i < this.gapList.length; i++) {
gapSum += this.gapList[i][1];
}
return gapSum;
},
_isGapIndex: function _isGapIndex(index) {
var isGapIndex = false;
var gapIndices = this.gapList.map(function (i) { return i[0]; });
if (this._binarySearch(gapIndices, index) >= 0) {
isGapIndex = true;
}
else {
isGapIndex = false;
}
return isGapIndex;
},
_calculateDrawingPoints: function _calculateDrawingPoints() {
if (this._data && this._data.series && this._data.series.length > 0) {
this.xCoord = [];
this.yCoord = [];
this._prepareGapList();
this._calculateScales();
var x, y, gapFactor = 0;
for (var i = 0; i < this._data.series.length; i++) {
gapFactor = this._getGapFactorForIndex(i);
x = this.getXcoordForIndex(i);
y = this.getYcoordForIndex(i);
this.xCoord[i] = x;
this.yCoord[i] = y;
}
this._createLookupArray();
}
else {
//null or empty data
}
},
getXcoordForValue: function getXcoordForValue(xVal) {
var x = null;
var gapFactor = this._getGapFactorForValue(xVal);
x = (xVal - this.minX - gapFactor) / this.scaleX;
x = x + this._chartDimensions.chartPaddingLeft;
return x;
},
getXcoordForIndex: function getXcoordForIndex(index) {
var x = null;
var gapFactor = this._getGapFactorForIndex(index);
x = (this._data.series[index][0] - this.minX - gapFactor) / this.scaleX;
x = x + this._chartDimensions.chartPaddingLeft;
return x;
},
getYcoordForIndex: function getYcoordForIndex(index) {
var y = null;
var gapFactor = this._getGapFactorForIndex(index);
if (this._data.series[index][1] >= 0) {
y = (this._data.series[index][1] - this.minY) / this.scaleY;
y = this._chartDimensions.chartHeight - y;
y = y + this._chartDimensions.chartPaddingTop;
}
else {
throw "Negative value not expected on y-axis";
}
return y;
},
_calculateScales: function _calculateScales() {
this.minX = this._data.series[0][0];
this.maxX = this._data.series[this._data.series.length - 1][0];
var diff = this.maxX - this.minX;
if (this.startTime && this.endTime) {
this.minX = this.startTime;
this.maxX = this.endTime;
}
else {
this.minX = this.minX - diff * (this.xMarginPercent / 100);
this.maxX = this.maxX + diff * (this.xMarginPercent / 100);
}
this.scaleX = (this.maxX - this.minX - this._getGapsSum()) / this._chartDimensions.chartWidth;
// validate x-axis scale 
if (this.scaleX <= 0) {
// throw error
// this will be cought in calling module (appexChart class) which will show error message
throw "Negative or zero scaleX";
}
if (!this._chartLimits) {
this.minY = Math.min.apply(null, this.yVals);
this.maxY = Math.max.apply(null, this.yVals);
}
else {
this.minY = this._chartLimits.minY;
this.maxY = this._chartLimits.maxY;
}
var yMax, yMin;
yMin = Math.min(this.minY, this.thresholdY);
yMax = Math.max(this.maxY, this.thresholdY);
diff = yMax - yMin;
if (diff === 0) {
// diff should be of order of min value for example for min value 0.002 we should not set diff to 1.0
diff = Math.pow(10, Math.floor(Math.log(yMin) / Math.LN10)) * 2;
this.minY = yMin - diff;
this.maxY = yMax + diff;
}
else {
this.minY = yMin - diff * (this.yMarginPercent / 100);
this.maxY = yMax + diff * (this.yMarginPercent / 100);
}
// do not allow negative range on y-axis;
this.minY = this.minY > 0 ? this.minY : 0;
this._setPrecision(diff);
this.scaleY = (this.maxY - this.minY) / this._chartDimensions.chartHeight;
// validate y-axis scale
if (this.scaleY <= 0) {
// throw error
// this will be cought in calling module (appexChart class) which will show error message
throw "Negative or zero scaleY";
}
},
_setPrecision: function _setPrecision(num) {
var precision = Math.floor(Math.log(num) / Math.LN10);
if (precision >= 0) { // then number is greater than 1
// then number is greater than 1
// set default precision
this._chartOptions.decimalPrecision = 2;
}
else {
this._chartOptions.decimalPrecision = Math.abs(precision) + 1;
}
},
_createLookupArray: function _createLookupArray() {
this._lookupArray = [];
var point, mid, j = 0;
for (j = 0; j < this._chartDimensions.chartPaddingLeft; j++) {
this._lookupArray[j] = null;
}
for (var i = 0; i < this.xCoord.length - 1; i++) {
mid = Math.floor((this.xCoord[i] + this.xCoord[i + 1]) / 2);
point = { x: this.xCoord[i], y: this.yCoord[i], xVal: this.xVals[i], yVal: this.yVals[i], colorIndex: this.colorIndex, displayName: this.seriesDisplayName };
for (; j <= mid; j++) {
this._lookupArray[j] = point;
}
}
point = { x: this.xCoord[i], y: this.yCoord[i], xVal: this.xVals[i], yVal: this.yVals[i], colorIndex: this.colorIndex, displayName: this.seriesDisplayName };
var extremeRight = this._chartDimensions.chartPaddingLeft + this._chartDimensions.controlWidth;
for (; j <= extremeRight; j++) {
this._lookupArray[j] = point;
}
},
}
),
appexSeriesPlotter: WinJS.Class.define(
null,
null,
{
plotLineGraph: function plotLineGraph(series, drawingContext, chartOptions) {
var x, y;
drawingContext.beginPath();
for (var i = 0; i < series.xCoord.length; i++) {
x = series.xCoord[i];
y = series.yCoord[i];
if (i === 0) {
drawingContext.moveTo(x, y);
}
else {
drawingContext.lineTo(x, y);
}
}
drawingContext.strokeStyle = chartOptions.seriesColors[series.colorIndex];
drawingContext.lineJoin = "round";
drawingContext.stroke();
},
_findIntersectX: function _findIntersectX(y0, x1, y1, x2, y2) {
var m = (y2 - y1) / (x2 - x1);
return (y0 - y1 + (x1 * m)) / m;
},
drawStockAreaGraph: function drawStockAreaGraph(series, drawingContext, chartOptions) {
var loseColor = chartOptions.chartColors.loseColor;
var gainColor = chartOptions.chartColors.gainColor;
var x, y, x2, y2;
for (var i = 0; i < series.xCoord.length - 1; i++) {
var c, upColor, downColor;
x = series.xCoord[i];
y = series.yCoord[i];
x2 = series.xCoord[i + 1];
y2 = series.yCoord[i + 1];
// drawing a little bigger trapezoid then actual dimensions
// This is done to get rid of the tiny fringe it shows around trapezoid as we have removed line strocks
x -= 0.5;
x2 += 0.5;
if (y > series.thresholdPoint) {
y += 1;
}
else if (y <= series.thresholdPoint) {
y -= 1;
}
if (y2 > series.thresholdPoint) {
y2 += 1;
}
else if (y2 <= series.thresholdPoint) {
y2 -= 1;
}
if (y < series.thresholdPoint) {
upColor = gainColor;
downColor = loseColor;
} else if (y > series.thresholdPoint) {
upColor = loseColor;
downColor = gainColor;
}
else if (y === series.thresholdPoint) {
if (y2 >= series.thresholdPoint) {
upColor = gainColor;
downColor = loseColor;
} else if (y2 < series.thresholdPoint) {
upColor = loseColor;
downColor = gainColor;
}
}
if ((y >= series.thresholdPoint && y2 >= series.thresholdPoint) || (y <= series.thresholdPoint && y2 <= series.thresholdPoint)) {
drawingContext.beginPath();
drawingContext.moveTo(x, y);
drawingContext.lineTo(x2, y2);
drawingContext.lineTo(x2, series.thresholdPoint);
drawingContext.lineTo(x, series.thresholdPoint);
drawingContext.lineTo(x, y);
drawingContext.fillStyle = upColor;
drawingContext.fill();
drawingContext.beginPath();
}
else {
var ix = FinanceAppJS.UI.appexSeriesPlotter._findIntersectX(series.thresholdPoint, x, y, x2, y2);
drawingContext.beginPath();
drawingContext.moveTo(x, series.thresholdPoint);
drawingContext.lineTo(ix, series.thresholdPoint);
drawingContext.lineTo(x, y);
drawingContext.lineTo(x, series.thresholdPoint);
drawingContext.fillStyle = upColor;
drawingContext.fill();
drawingContext.beginPath();
drawingContext.moveTo(x2, series.thresholdPoint);
drawingContext.lineTo(ix, series.thresholdPoint);
drawingContext.lineTo(x2, y2);
drawingContext.lineTo(x2, series.thresholdPoint);
drawingContext.fillStyle = downColor;
drawingContext.fill();
drawingContext.beginPath();
}
drawingContext.fillStyle = c;
drawingContext.fill();
}
},
}
),
appexChartBuilder: WinJS.Class.define(
function (chartOptions, innerContainer, controlDimensions) {
this._chartOptions = chartOptions;
this._innerContainer = innerContainer;
this._controlDimensions = controlDimensions;
this._errorControl = null;
this._busyControl = null;
this.expandButton = null;
this.saveButton = null;
this.printButton = null;
this.chartBackgroundDiv = null;
this.accessibilityTextNodeContainer = null;
this.accessibilityTextNode = null;
this.displayCaptionDiv = null;
this._init();
},
{
_canvasElement: null,
_drawingContext: null,
_innerContainer: null,
drawingContext: {
get: function get() { return this._drawingContext; },
},
_init: function _init() {
this._createCanvas();
this._createOverlayCavas();
if (this._chartOptions.displayCaption) {
this._createCaptionDiv();
}
this._createButtons();
this._createNotificationControls();
this._createAccessibilityNode();
},
_createCaptionDiv: function _createCaptionDiv() {
this.displayCaptionDiv = document.createElement("div");
WinJS.Utilities.addClass(this.displayCaptionDiv, 'fundChartHeaderText');
WinJS.Utilities.addClass(this.displayCaptionDiv, 'legendFont');
this._innerContainer.appendChild(this.displayCaptionDiv);
},
fillCaption: function fillCaption(caption) {
if (this.displayCaptionDiv) {
this.displayCaptionDiv.innerText = caption;
}
},
_createAccessibilityNode: function _createAccessibilityNode() {
this.accessibilityTextNodeContainer = utils.createElement(this._innerContainer, "div", { className: "accessibilityTextNodeContainer", id: "accessibilityTextNodeContainer", tabIndex: "0" });
this.accessibilityTextNode = utils.createElement(this.accessibilityTextNodeContainer, "span", { className: "hide", id: "accessibilityTextNode", role: "value" });
},
_createNotificationControls: function _createNotificationControls() {
this._errorControl = document.createElement("div");
this._errorControl.textContent = utils.getResourceString("chartDataUnavailableMessage");
WinJS.Utilities.addClass(this._errorControl, 'chartError');
WinJS.Utilities.addClass(this._errorControl, 'hide');
this._innerContainer.appendChild(this._errorControl);
this._busyControl = document.createElement("div");
WinJS.Utilities.addClass(this._busyControl, "chartSpinnerContainer");
WinJS.Utilities.addClass(this._busyControl, 'hide');
var chartSpinner = document.createElement("progress");
WinJS.Utilities.addClass(chartSpinner, 'chartSpinner');
WinJS.Utilities.addClass(chartSpinner, 'win-ring');
this._busyControl.appendChild(chartSpinner);
this._innerContainer.appendChild(this._busyControl);
},
_createButtons: function _createButtons() {
this.expandButton = document.createElement("div");
WinJS.Utilities.addClass(this.expandButton, 'expandBtn');
if (!this._chartOptions.enableExpand) {
this.expandButton.style.display = 'none';
}
this._innerContainer.appendChild(this.expandButton);
this.saveButton = document.createElement("div");
WinJS.Utilities.addClass(this.saveButton, 'saveBtn');
if (!this._chartOptions.enableSave) {
this.saveButton.style.display = 'none';
}
this._innerContainer.appendChild(this.saveButton);
this.printButton = document.createElement("div");
WinJS.Utilities.addClass(this.printButton, 'printBtn');
if (!this._chartOptions.enablePrint) {
this.printButton.style.display = 'none';
}
this._innerContainer.appendChild(this.printButton);
this.chartBackgroundDiv = document.createElement("div");
this.chartBackgroundDiv.id = "chartBackgroundDiv";
WinJS.Utilities.addClass(this.chartBackgroundDiv, 'chartBackground');
},
resize: function resize(event) {
this._canvasElement.setAttribute("width", this._controlDimensions.controlWidth);
this._canvasElement.setAttribute("height", this._controlDimensions.controlHeight);
this.overlayCanvasElement.setAttribute("width", this._controlDimensions.controlWidth);
this.overlayCanvasElement.setAttribute("height", this._controlDimensions.controlHeight);
this._drawingContext.font = this._chartOptions.labelFont;
this.overlaydrawingContext.font = this._chartOptions.hightLightTextFont;
this._drawingContext.beginPath();
this._drawingContext.rect(0, 0, event.srcElement.clientWidth, event.srcElement.clientHeight);
this._drawingContext.fillStyle = this._chartOptions.backgroundColor;
this._drawingContext.fill();
},
_createCanvas: function _createCanvas() {
this._canvasElement = document.createElement("canvas");
var canvasId = 'C' + Math.ceil((100000 * Math.random())).toString() + '_stockChartCanvas';
this._canvasElement.setAttribute("id", canvasId);
this._canvasElement.setAttribute("width", this._controlDimensions.controlWidth);
this._canvasElement.setAttribute("height", this._controlDimensions.controlHeight);
WinJS.Utilities.addClass(this._canvasElement, "chartCanvas");
this._innerContainer.appendChild(this._canvasElement);
this._drawingContext = this._canvasElement.getContext("2d");
this._drawingContext.font = this._chartOptions.labelFont;
this._drawingContext.beginPath();
this._drawingContext.rect(0, 0, this._controlDimensions.controlWidth, this._controlDimensions.controlHeight);
this._drawingContext.fillStyle = this._chartOptions.backgroundColor;
this._drawingContext.fill();
},
_createOverlayCavas: function _createOverlayCavas() {
this.overlayCanvasElement = document.createElement("canvas");
var canvasId = 'C' + Math.ceil((100000 * Math.random())).toString() + '_overlayCanvas';
this.overlayCanvasElement.setAttribute("id", canvasId);
this.overlayCanvasElement.setAttribute("width", this._controlDimensions.controlWidth);
this.overlayCanvasElement.setAttribute("height", this._controlDimensions.controlHeight);
WinJS.Utilities.addClass(this.overlayCanvasElement, "chartCanvas");
this.overlaydrawingContext = this.overlayCanvasElement.getContext("2d");
this.overlaydrawingContext.font = this._chartOptions.hightLightTextFont;
this._innerContainer.appendChild(this.overlayCanvasElement);
},
}
),
appexChartPlotter: WinJS.Class.define(
function (chartOptions, innerContainer, drawingContext, overlaydrawingContext, controlDimensions, chartDimensions, seriesManager) {
this._chartOptions = chartOptions;
this._innerContainer = innerContainer;
this._controlDimensions = controlDimensions;
this._chartDimensions = chartDimensions;
this._drawingContext = drawingContext;
this._overlaydrawingContext = overlaydrawingContext;
this._seriesManager = seriesManager;
this._gridPlotter = new FinanceAppJS.UI.appexGridPlotter(chartOptions, chartDimensions, drawingContext, seriesManager);
this._init();
},
{
_init: function _init() {
},
plot: function plot() {
this._overlaydrawingContext.clearRect(0, 0, this._controlDimensions.controlWidth, this._controlDimensions.controlHeight);
var activeSeriesList = this._seriesManager.getActiveSeriesList();
this.drawGrid(activeSeriesList);
this.drawSeries(activeSeriesList);
},
drawGrid: function drawGrid(activeSeriesList) {
this._gridPlotter.plotGrid(activeSeriesList);
},
processSeriesData: function processSeriesData(activeSeriesList) {
for (var i = 0; i < activeSeriesList.length; i++) {
activeSeriesList[i]._calculateDrawingPoints();
}
},
drawSeries: function drawSeries(activeSeriesList) {
for (var i = 0; i < activeSeriesList.length; i++) {
switch (this._chartOptions.graphType) {
case 'area':
FinanceAppJS.UI.appexSeriesPlotter.drawStockAreaGraph(activeSeriesList[i], this._drawingContext, this._chartOptions);
break;
case 'line':
FinanceAppJS.UI.appexSeriesPlotter.plotLineGraph(activeSeriesList[i], this._drawingContext, this._chartOptions);
break;
}
}
},
replot: function replot() {
this._overlaydrawingContext.clearRect(0, 0, this._controlDimensions.controlWidth, this._controlDimensions.controlHeight);
var activeSeriesList = this._seriesManager.getActiveSeriesList();
this.processSeriesData(activeSeriesList);
this.drawGrid(activeSeriesList);
this.drawSeries(activeSeriesList);
},
erase: function erase() {
// clear the overlay canvas
this._overlaydrawingContext.clearRect(0, 0, this._controlDimensions.controlWidth, this._controlDimensions.controlHeight);
// redraw the backgound in order to erase the current drawing
this._gridPlotter._drawBackground();
},
}
),
appexGridPlotter: WinJS.Class.define(
function (chartOptions, chartDimensions, drawingContext, seriesManager) {
this._chartOptions = chartOptions;
this._chartDimensions = chartDimensions;
this._drawingContext = drawingContext;
this._seriesManager = seriesManager;
},
{
plotGrid: function plotGrid(activeSeriesList) {
this._drawBackground();
this._drawLines(activeSeriesList);
this._drawLabels(activeSeriesList);
},
_drawBackground: function _drawBackground() {
this._drawingContext.beginPath();
this._drawingContext.clearRect(0, 0, this._chartDimensions.controlWidth, this._chartDimensions.controlHeight);
this._drawingContext.rect(this._chartDimensions.chartPaddingLeft, this._chartDimensions.chartPaddingTop, this._chartDimensions.chartWidth, this._chartDimensions.chartHeight);
this._drawingContext.strokeStyle = this._chartOptions.borderColor;
this._drawingContext.stroke();
this._drawingContext.fillStyle = this._chartOptions.backgroundColor;
this._drawingContext.fill();
},
_drawLines: function _drawLines(activeSeriesList) {
var lineCount = this._chartOptions.gridLineCount;
if (activeSeriesList.length > 0) {
var activeSeries = activeSeriesList[0];
var yDelta = activeSeries.maxY - activeSeries.minY;
var stepSize = yDelta / (lineCount + 1);
this._drawingContext.beginPath();
for (var i = 0; i < lineCount + 2; i++) {
var yVal = activeSeries.minY + (stepSize * i);
yVal = FinanceAppJS.Utils.Formatters.numberFormatter(yVal, this._chartOptions.decimalPrecision);
var ycord = (stepSize * i) / activeSeries.scaleY;
ycord = this._chartDimensions.chartHeight - ycord;
ycord = ycord + this._chartDimensions.chartPaddingTop;
if (i !== 0 && i !== lineCount + 1) {
this._drawingContext.moveTo(this._chartDimensions.chartPaddingLeft, ycord);
this._drawingContext.lineTo(this._chartDimensions.chartWidth + this._chartDimensions.chartPaddingLeft, ycord);
}
this._drawingContext.fillStyle = this._chartOptions.labelTextColor;
var textWd = this._drawingContext.measureText(yVal);
var xcoordText;
if (this._chartOptions.isRtl) {
xcoordText = this._chartDimensions.chartWidth + this._chartDimensions.chartPaddingLeft + this._chartOptions.labelTextPadding;
}
else {
xcoordText = this._chartDimensions.chartPaddingLeft - textWd.width - this._chartOptions.labelTextPadding;
}
if (i === 0) {
this._drawingContext.fillText(yVal, xcoordText, ycord);
}
else if (i !== lineCount + 1) {
this._drawingContext.fillText(yVal, xcoordText, ycord + this._chartOptions.labelTextPadding);
}
else {
this._drawingContext.fillText(yVal, xcoordText, ycord + this._chartOptions.labelTextPadding * 2);
}
}
this._drawingContext.lineWidth = this._chartOptions.gridLineWidth;
this._drawingContext.strokeStyle = this._chartOptions.gridLineColor;
this._drawingContext.stroke();
}
else {
}
},
_inferActualChartDuration: function _inferActualChartDuration(series) {
var duration = series.chartType; // set claimed chart type as default
var diff = series._data.series[series._data.series.length - 1][0] - series._data.series[0][0];
if (diff < 24 * 60 * 60 * 1000) {
duration = "1d";
}
else if (diff < 15 * 24 * 60 * 60 * 1000) {
duration = "5d";
}
else if (diff < 2 * 30 * 24 * 60 * 60 * 1000) {
duration = "1m";
}
else if (diff < 5 * 30 * 24 * 60 * 60 * 1000) {
duration = "3m";
}
else if (diff < 2 * 365 * 24 * 60 * 60 * 1000) {
duration = "1y";
}
else if (diff < 4 * 365 * 24 * 60 * 60 * 1000) {
duration = "3y";
}
else if (diff < 7 * 365 * 24 * 60 * 60 * 1000) {
duration = "5y";
}
else {
duration = "max";
}
return duration;
},
_drawLabels: function _drawLabels(activeSeriesList) {
if (activeSeriesList.length > 0) {
if (activeSeriesList[0].chartType === "bonds") {
this._drawLabelsProvided(activeSeriesList);
}
else {
// the chart type may be taged as year chart but it might bring data for just few months if stock is new.
// therefore predict the chart duration based on min and max and draw x-labels accordingly
var actualChartDuration = this._inferActualChartDuration(activeSeriesList[0]);
switch (actualChartDuration) {
case "1d":
// interval 1 hour
this._drawLinearScaleLabels(activeSeriesList[0], (60 * 60 * 1000), "hour minute");
break;
case "5d":
this._drawNonLinearScaleLabels(activeSeriesList[0], "month.abbreviated day");
break;
case "1m":
// interval 3 days
this._drawLinearScaleLabels(activeSeriesList[0], (3 * 24 * 60 * 60 * 1000), "month.abbreviated day");
break;
case "3m":
// interval 10 days
this._drawLinearScaleLabels(activeSeriesList[0], (10 * 24 * 60 * 60 * 1000), "month.abbreviated day");
break;
case "1y":
// interval 2 months
this._drawLinearScaleLabels(activeSeriesList[0], (65 * 24 * 60 * 60 * 1000), "month.abbreviated year");
break;
case "3y":
// interval 5 months
this._drawLinearScaleLabels(activeSeriesList[0], (150 * 24 * 60 * 60 * 1000), "month.abbreviated year");
break;
case "5y":
// interval 1 year
this._drawLinearScaleLabels(activeSeriesList[0], (365 * 24 * 60 * 60 * 1000), "month.abbreviated year");
break;
default:
// interval 5 years
this._drawLinearScaleLabels(activeSeriesList[0], (5 * 365 * 24 * 60 * 60 * 1000), "month.abbreviated year");
break;
}
}
}
},
_drawLabelsProvided: function _drawLabelsProvided(activeSeriesList) {
var current = activeSeriesList[0].minX;
var lblwidth, xcordText, xcordDot;
var label;
var ycordDot = this._chartDimensions.chartHeight + this._chartDimensions.chartPaddingTop;
var ycordText = ycordDot + this._chartOptions.labelTextPaddingTop;
var xscale = (activeSeriesList[0].maxX - activeSeriesList[0].minX) / this._chartDimensions.chartWidth;
for (var i = 0; i < activeSeriesList[0].xCoord.length; i++) {
label = activeSeriesList[0].xLabels[i];
current = this._seriesManager._seriesCollection[0].xVals[i];
xcordDot = this._chartDimensions.chartPaddingLeft + ((current - activeSeriesList[0].minX) / xscale);
lblwidth = this._drawingContext.measureText(label);
xcordText = xcordDot - (lblwidth.width / 2);
if (xcordText <= (this._chartDimensions.chartPaddingLeft + this._chartDimensions.chartWidth)) {
this._drawingContext.beginPath();
this._drawingContext.fillText(label, xcordText, ycordText);
}
}
},
_drawNonLinearScaleLabels: function _drawNonLinearScaleLabels(series, format) {
var date, label, xcordText, xcordDot, textWd;
var ycordDot = this._chartDimensions.chartHeight + this._chartDimensions.chartPaddingTop;
var ycordText = ycordDot + this._chartOptions.labelTextPaddingTop;
var previousLabelEnd = 0;
for (var i = 0; i < series.gapList.length; i++) {
var gapIndex = series.gapList[i][0] + 1;
date = utils.normalizeDate(series._data.series[gapIndex][0]);
var formatter = new Windows.Globalization.DateTimeFormatting.DateTimeFormatter(format);
label = formatter.format(date);
textWd = this._drawingContext.measureText(label);
xcordDot = series.getXcoordForIndex(gapIndex);
xcordText = xcordDot - (textWd.width / 2);
// Avoid overflow on left of chart
if (xcordText < this._chartDimensions.chartPaddingLeft) {
xcordText = this._chartDimensions.chartPaddingLeft;
}
// Avoid truncation
if ((xcordText + textWd.width) <= (this._chartDimensions.chartPaddingLeft + this._chartDimensions.chartWidth)
&& xcordText > (previousLabelEnd + this._chartOptions.labelSpacing)) {
this._drawingContext.beginPath();
this._drawingContext.fillText(label, xcordText, ycordText);
previousLabelEnd = xcordDot + (textWd.width / 2);
}
}
},
_drawLinearScaleLabels: function _drawLinearScaleLabels(series, interval, format) {
var current = series.minX;
var date, label, xcordText, xcordDot, textWd;
var ycordDot = this._chartDimensions.chartHeight + this._chartDimensions.chartPaddingTop;
var ycordText = ycordDot + this._chartOptions.labelTextPaddingTop;
var previousLabelEnd = 0;
do {
current += interval;
if (format === "month.abbreviated year") {
// convert it to first day of month
var d = new Date(current);
d = new Date(d.getTime() - (d.getDate() - 1) * 24 * 60 * 60 * 1000);
current = d.getTime();
}
if (current >= series.minX && current <= series.maxX) {
date = utils.normalizeDate(current);
var formatter = new Windows.Globalization.DateTimeFormatting.DateTimeFormatter(format);
label = formatter.format(date);
textWd = this._drawingContext.measureText(label);
xcordDot = series.getXcoordForValue(current);
xcordText = xcordDot - (textWd.width / 2);
if (xcordText < this._chartDimensions.chartPaddingLeft) {
xcordText = this._chartDimensions.chartPaddingLeft;
}
// Avoid truncation
if ((xcordText + textWd.width) <= (this._chartDimensions.chartPaddingLeft + this._chartDimensions.chartWidth)
&& xcordText > (previousLabelEnd + this._chartOptions.labelSpacing)) {
this._drawingContext.beginPath();
this._drawingContext.fillText(label, xcordText, ycordText);
previousLabelEnd = xcordDot + (textWd.width / 2);
}
}
} while (current < series.maxX);
},
}
),
appexChartHighlighter_Canvas: WinJS.Class.define(
function (chartOptions, chartBuilder, controlDimensions, chartDimensions, seriesManager) {
this._chartOptions = chartOptions;
this._chartBuilder = chartBuilder;
this._controlDimensions = controlDimensions;
this._chartDimensions = chartDimensions;
this._seriesManager = seriesManager;
this._overlaydrawingContext = chartBuilder.overlaydrawingContext;
this._realtimeQuotesLastUpdatedTimeString = null;
},
{
isActive: false,
realtimeQuotesLastUpdatedTimeString: {
get: function get() {
return this._realtimeQuotesLastUpdatedTimeString;
},
set: function set(value) {
this._realtimeQuotesLastUpdatedTimeString = value;
if (!this.isActive && this._chartOptions.disableHoverOnBlur) {
setImmediate(this.removeStroke());
}
},
},
highlight: function highlight(mouseX, mouseY) {
var updateAccessibilityNode = false;
if (!mouseX) {
updateAccessibilityNode = true;
mouseX = this._chartDimensions.chartPaddingLeft + this._chartDimensions.chartWidth;
mouseY = 0;
}
var activeSeriesList = this._seriesManager.getActiveSeriesList();
var xCordText = 0, xCordColorDot = 0, xCordValue = 0, colorDivSize = 8;
for (var i = 0; i < activeSeriesList.length; i++) {
var highLightPoint = activeSeriesList[i].getHighLightPoint(mouseX);
if (highLightPoint) {
this._overlaydrawingContext.clearRect(0, 0, this._controlDimensions.controlWidth, this._controlDimensions.controlHeight);
this._overlaydrawingContext.fillStyle = this._chartOptions.hightLightTextColor;
if (!highLightPoint.formatedVals) {
if (activeSeriesList[i].chartType === "1d" || activeSeriesList[i].chartType === "5d") {
highLightPoint.formatedTime = this._formatDateWithTimeStamp(highLightPoint.xVal);
}
else {
highLightPoint.formatedTime = this._formatDate(highLightPoint.xVal);
}
highLightPoint.formatedVals = highLightPoint.displayName + " : " + this._formatValue(highLightPoint.yVal);
}
if (updateAccessibilityNode) {
this._updateAccessibilityNode(highLightPoint);
}
var textWdTime = this._overlaydrawingContext.measureText(highLightPoint.formatedTime);
if (this._chartOptions.isRtl) {
this._overlaydrawingContext.font = this._chartOptions.hightLightTextFontBold;
var textWdVals = this._overlaydrawingContext.measureText(highLightPoint.formatedVals);
this._overlaydrawingContext.font = this._chartOptions.hightLightTextFont;
var textWd = textWdTime.width + textWdVals.width + colorDivSize + this._chartOptions.labelTextPadding * 2;
xCordText = this._chartDimensions.chartPaddingLeft + this._chartDimensions.chartWidth - textWd;
this._overlaydrawingContext.beginPath();
this._overlaydrawingContext.arc(xCordText, this._chartOptions.hightLightTextPaddingTop - 5, 3, 0, 2 * Math.PI, false);
this._overlaydrawingContext.fillStyle = this._chartOptions.seriesColors[highLightPoint.colorIndex];
this._overlaydrawingContext.fill();
xCordText = xCordText + colorDivSize;
this._overlaydrawingContext.font = this._chartOptions.hightLightTextFontBold;
this._overlaydrawingContext.fillText(highLightPoint.formatedVals, xCordText, this._chartOptions.hightLightTextPaddingTop);
this._overlaydrawingContext.font = this._chartOptions.hightLightTextFont;
xCordText = xCordText + textWdVals.width + this._chartOptions.labelTextPadding * 2;
this._overlaydrawingContext.fillStyle = this._chartOptions.hightLightTextColor;
this._overlaydrawingContext.fillText(highLightPoint.formatedTime, xCordText, this._chartOptions.hightLightTextPaddingTop);
}
else {
xCordText = this._chartDimensions.chartPaddingLeft;
this._overlaydrawingContext.beginPath();
this._overlaydrawingContext.fillText(highLightPoint.formatedTime, xCordText, this._chartOptions.hightLightTextPaddingTop);
xCordText = xCordText + textWdTime.width + this._chartOptions.labelTextPadding * 2;
this._overlaydrawingContext.arc(xCordText, this._chartOptions.hightLightTextPaddingTop - 5, 3, 0, 2 * Math.PI, false);
this._overlaydrawingContext.fillStyle = this._chartOptions.seriesColors[highLightPoint.colorIndex];
this._overlaydrawingContext.fill();
xCordText = xCordText + colorDivSize;
this._overlaydrawingContext.font = this._chartOptions.hightLightTextFontBold;
this._overlaydrawingContext.fillText(highLightPoint.formatedVals, xCordText, this._chartOptions.hightLightTextPaddingTop);
this._overlaydrawingContext.font = this._chartOptions.hightLightTextFont;
}
this._overlaydrawingContext.beginPath();
this._overlaydrawingContext.moveTo(highLightPoint.x, this._chartDimensions.chartPaddingTop);
this._overlaydrawingContext.lineTo(highLightPoint.x, this._chartDimensions.chartHeight + this._chartDimensions.chartPaddingTop);
this._overlaydrawingContext.lineWidth = 1;
this._overlaydrawingContext.strokeStyle = this._chartOptions.hightLightLineColor;
this._overlaydrawingContext.stroke();
this._overlaydrawingContext.beginPath();
this._overlaydrawingContext.arc(highLightPoint.x, highLightPoint.y, 3, 0, 2 * Math.PI, false);
this._overlaydrawingContext.fillStyle = this._chartOptions.seriesColors[highLightPoint.colorIndex];
this._overlaydrawingContext.fill();
}
}
},
removeStroke: function removeStroke() {
if (this._realtimeQuotesLastUpdatedTimeString) {                      
this._overlaydrawingContext.clearRect(0, 0, this._controlDimensions.controlWidth, this._controlDimensions.controlHeight);
}
this.updateLastRTQuotesUpdatedTime();
},
updateLastRTQuotesUpdatedTime: function updateLastRTQuotesUpdatedTime(time) {
if (!time) {
time = this._realtimeQuotesLastUpdatedTimeString || "-";
}
var xCordText = 0;
this._overlaydrawingContext.font = this._chartOptions.labelFont;
this._overlaydrawingContext.fillStyle = this._chartOptions.labelTextColor;
if (this._chartOptions.isRtl) {
var timeWd = this._overlaydrawingContext.measureText(time);
xCordText = this._chartDimensions.chartPaddingLeft + this._chartDimensions.chartWidth - timeWd.width - this._chartOptions.labelTextPadding;
} else {
xCordText = this._chartDimensions.chartPaddingLeft;
}
this._overlaydrawingContext.fillText(time, xCordText, this._chartOptions.hightLightTextPaddingTop);
},
_updateAccessibilityNode: function _updateAccessibilityNode(highLightPoint) {
this._chartBuilder.accessibilityTextNode.textContent = highLightPoint.formatedTime + " " + highLightPoint.formatedVals;
},
_formatDate: function _formatDate(outputTimestamp) {
var date = utils.normalizeDate(outputTimestamp);
var timeStamp = FinanceAppJS.Utils.Formatters.shortDateFormatDateObj(date);
return timeStamp;
},
_formatDateWithTimeStamp: function _formatDateWithTimeStamp(outputTimestamp) {
var date = utils.normalizeDate(outputTimestamp);
var timeStamp = FinanceAppJS.Utils.Formatters.shortDateFormatDateObj(date) + ' ' + FinanceAppJS.Utils.Formatters.shortTimeFormatDateObj(date);
return timeStamp;
},
_formatValue: function _formatValue(val) {
return FinanceAppJS.Utils.Formatters.numberFormatter(val, this._chartOptions.decimalPrecision);
},
}
),
appexChartEventManager: WinJS.Class.define(
function (chartOptions, innerContainer, highlighter, chartDimensions, chartControlDimensions, chartBuilder, chartPlotter) {
this._chartOptions = chartOptions;
this._innerContainer = innerContainer;
this._highlighter = highlighter;
this._chartDimensions = chartDimensions;
this._chartControlDimensions = chartControlDimensions;
this._chartPlotter = chartPlotter;
this._chartBuilder = chartBuilder;
this._resizeHandlerBinding = null;
this._originalChartContainerClass = null;
this._mousemoveHandlerBinding = null;
this._pointermoveHandlerBinding = null;
this._resizeHandlerBinding = null;
this._expandHandlerBinding = null;
this._saveHandlerBinding = null;
this._printHandlerBinding = null;
this._mouseEnterHandlerBinding = null;
this._onBlurHandlerBinding = null,
this._onArrowKeyDownBinding = null,
this.highContrastChanged = msMatchMedia("(-ms-high-contrast)");
this.highContrastChangedBlackOnWhite = msMatchMedia("(-ms-high-contrast:black-on-white)");
this.highContrastChangedWhiteOnBlack = msMatchMedia("(-ms-high-contrast:white-on-black)");
this.bindEvents();
if (innerContainer.parentElement.parentElement && innerContainer.clientHeight && innerContainer.clientWidth) {
this.controlIsReady = true;
}
},
{
_mouseMoveEventCount: 0,
_handleMouseMove: function _handleMouseMove(event) {
try {
this._mouseMoveEventCount++;
if ((this._mouseMoveEventCount % 100) === 1) {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
FinanceAppJS.Telemetry.Constants.Cluster.CHART,
FinanceAppJS.Telemetry.Constants.Location.CHARTCANVAS,
"", "mousemove");
}
var mouseX = event.offsetX;
var mouseY = event.offsetY;
this._highlighter.highlight(mouseX, mouseY);
event.cancelBubble = true;
event.preventDefault();
event.stopImmediatePropagation();
}
catch (err) {
FinanceAppJS.Telemetry.FlightRecorder.LogErrorEvent(err.message, err.stack);
}
},
_handlePointerMove: function _handlePointerMove(event) {
event.cancelBubble = true;
event.preventDefault();
event.stopImmediatePropagation();
},
_handleMouseEnter: function _handleMouseEnter(event){
this._highlighter.isActive = true;
},
_handleExpand: function _handleExpand(event) {
try {
var chart = document.getElementById("chartContainer");
var chartHolder = document.getElementById("chartHolder");
if (WinJS.Utilities.hasClass(this._chartBuilder.expandButton, 'expandBtn')) {
WinJS.Utilities.removeClass(this._chartBuilder.expandButton, 'expandBtn');
WinJS.Utilities.addClass(this._chartBuilder.expandButton, 'collapseBtn');
this._originalChartContainerClass = chart.className;
WinJS.Utilities.removeClass(chart, this._originalChartContainerClass);
WinJS.Utilities.addClass(chart, 'fullscreenchartContainer');
document.body.appendChild(this._chartBuilder.chartBackgroundDiv);
document.body.appendChild(chart);
}
else {
WinJS.Utilities.removeClass(this._chartBuilder.expandButton, 'collapseBtn');
WinJS.Utilities.addClass(this._chartBuilder.expandButton, 'expandBtn');
chartHolder = document.getElementById("chartHolder");
WinJS.Utilities.removeClass(chart, 'fullscreenchartContainer');
WinJS.Utilities.addClass(chart, this._originalChartContainerClass);
document.body.removeChild(this._chartBuilder.chartBackgroundDiv);
chartHolder.appendChild(chart);
}
}
catch (err) {
FinanceAppJS.Telemetry.FlightRecorder.LogErrorEvent(err.message, err.stack);
}
},
_handleSave: function _handleSave(event) {
try {
var that = this;
var picker = new Windows.Storage.Pickers.FileSavePicker();
var Imaging = Windows.Graphics.Imaging;
// specify file formats that support encoding
picker.fileTypeChoices.insert("PNG file", [".png"]);
picker.fileTypeChoices.insert("BMP file", [".bmp"]);
picker.fileTypeChoices.insert("JPEG file", [".jpg"]);
picker.defaultFileExtension = ".png";
picker.suggestedFileName = "FinanceChart";
// Keep data in-scope across multiple asynchronous methods
var encoderId;
var filename;
picker.pickSaveFileAsync().then(function (file) {
if (file) {
filename = file.fileName;
switch (file.fileType) {
case ".jpg":
encoderId = Imaging.BitmapEncoder.jpegEncoderId;
break;
case ".bmp":
encoderId = Imaging.BitmapEncoder.bmpEncoderId;
break;
case ".png":
default:
encoderId = Imaging.BitmapEncoder.pngEncoderId;
break;
}
return file.openAsync(Windows.Storage.FileAccessMode.readWrite);
}
}).then(function (stream) {
if (stream) {
return Imaging.BitmapEncoder.createAsync(encoderId, stream);
}
}).then(function (encoder) {
if (encoder) {
var width = that._chartBuilder._canvasElement.width;
var height = that._chartBuilder._canvasElement.height;
var outputPixelData = that._chartBuilder._drawingContext.getImageData(0, 0, width, height);
var pixelArray = [];
// Copy the CanvasPixelData data into a real JavaScript array
for (var i = 0; i < outputPixelData.data.length; i++) {
pixelArray[i] = outputPixelData.data[i];
}
encoder.setPixelData(
Imaging.BitmapPixelFormat.rgba8,
Imaging.BitmapAlphaMode.straight,
width,
height,
96, // Horizontal DPI
96, // Vertical DPI
pixelArray
);
return encoder.flushAsync();
}
}).then(function () {
//display success message
}).then(null, function (error) {
// display error message
});
}
catch (err) {
FinanceAppJS.Telemetry.FlightRecorder.LogErrorEvent(err.message, err.stack);
}
},
_handlePrint: function _handlePrint(event) {
},
controlIsReady: false,
controlReadyCallback: null,
_handleResize: function _handleResize(event) {
try {
if (this._chartControlDimensions.controlWidth !== event.srcElement.clientWidth ||
this._chartControlDimensions.controlHeight !== event.srcElement.clientHeight) {
this._chartControlDimensions.controlWidth = event.srcElement.clientWidth;
this._chartControlDimensions.controlHeight = event.srcElement.clientHeight;
this._chartDimensions.controlWidth = this._chartControlDimensions.controlWidth;
this._chartDimensions.controlHeight = this._chartControlDimensions.controlHeight;
this.controlIsReady = true;
this._chartBuilder.resize(event);
this._chartPlotter.replot();
if (this._chartOptions.disableHoverOnBlur) {
this._highlighter.updateLastRTQuotesUpdatedTime();
}
if (this.controlReadyCallback) {
var callback = this.controlReadyCallback;
callback();
this.controlReadyCallback = null;
}
}
}
catch (err) {
FinanceAppJS.Telemetry.FlightRecorder.LogErrorEvent(err.message, err.stack);
}
},
_handleContrastChanged: function _handleContrastChanged(event) {
this._chartOptions.resetColors();
this._chartPlotter.replot();
if (this._chartOptions.disableHoverOnBlur) {
this._highlighter.updateLastRTQuotesUpdatedTime();
} else {
if (this._chartOptions.enableHover !== "none") {
this._highlighter.highlight();
}
}
},
_mouseOutHandler: function _mouseOutHandler(event) {
if (!event.pointerType || !(event.pointerType === event.MSPOINTER_TYPE_PEN || event.pointerType === event.MSPOINTER_TYPE_TOUCH)) {
this._highlighter.removeStroke();
this._highlighter.isActive = false;
}
},
_blurHandler: function _blurHandler(event) {
if (this._highlighter.isActive) {
this._highlighter.isActive = false;
this._highlighter.removeStroke();
}
},
_enableArrowKeyAccessibilty: function _enableArrowKeyAccessibilty(event){
if(event.keyCode){
if (event.keyCode === WinJS.Utilities.Key.rightArrow) {
CommonJS.NavigableView.dispatchBoundaryEvent(event.srcElement.parentElement, CommonJS.NavigableView.Direction.RIGHT);
event.stopImmediatePropagation();
event.preventDefault();
}
if (event.keyCode === WinJS.Utilities.Key.leftArrow) {
CommonJS.NavigableView.dispatchBoundaryEvent(event.srcElement.parentElement, CommonJS.NavigableView.Direction.LEFT);
event.stopImmediatePropagation();
event.preventDefault();
}
}
},
bindEvents: function bindEvents() {
this._resizeHandlerBinding = this._handleResize.bind(this);
this._innerContainer.attachEvent("onresize", this._resizeHandlerBinding);
if (this._chartOptions.disableHoverOnBlur) {
this._mouseEnterHandlerBinding = this._handleMouseEnter.bind(this);
this._innerContainer.addEventListener("mouseenter", this._mouseEnterHandlerBinding);
this._onBlurHandlerBinding = this._blurHandler.bind(this);
this._innerContainer.addEventListener("blur", this._onBlurHandlerBinding);
}
this._mouseOutHandlerBinding = this._mouseOutHandler.bind(this);
if (this._chartOptions.enableHover !== 'none') {
if (window.navigator.msPointerEnabled) {
this._pointermoveHandlerBinding = this._handleMouseMove.bind(this);
this._innerContainer.addEventListener("MSPointerMove", this._pointermoveHandlerBinding);
if (this._chartOptions.disableHoverOnBlur) {
this._innerContainer.addEventListener("MSPointerOut", this._mouseOutHandlerBinding);
}
}
else {
this._mousemoveHandlerBinding = this._handleMouseMove.bind(this);
this._innerContainer.addEventListener("mousemove", this._mousemoveHandlerBinding);
if (this._chartOptions.disableHoverOnBlur) {
this._innerContainer.addEventListener("mouseout", this._mouseOutHandlerBinding);
}
}
}
else {
this._pointermoveHandlerBinding = this._handlePointerMove.bind(this);
this._innerContainer.addEventListener("mousemove", this._mousemoveHandlerBinding);
this._innerContainer.addEventListener("MSPointerMove", this._pointermoveHandlerBinding);
if (this._chartOptions.disableHoverOnBlur) {
this._innerContainer.addEventListener("mouseout", this._mouseOutHandlerBinding);
}
}
this.highContrastChangedBinding = this._handleContrastChanged.bind(this);
// This will raise events whenever user switched from normal mode to high contrast mode
this.highContrastChanged.addListener(this.highContrastChangedBinding);
// This will raise events whenever user switched from normal mode or high contrast white-on-black mode to black-on-white mode
this.highContrastChangedBlackOnWhite.addListener(this.highContrastChangedBinding);
// This will raise events whenever user switched from normal mode or high contrast black-on-white mode to white-on-black mode
this.highContrastChangedWhiteOnBlack.addListener(this.highContrastChangedBinding);
if (this._chartOptions.enableExpand === true) {
this._expandHandlerBinding = this._handleExpand.bind(this);
this._chartBuilder.expandButton.addEventListener("click", this._expandHandlerBinding);
}
if (this._chartOptions.enableSave === true) {
this._saveHandlerBinding = this._handleSave.bind(this);
this._chartBuilder.saveButton.addEventListener("click", this._saveHandlerBinding);
}
if (this._chartOptions.enablePrint === true) {
this._printHandlerBinding = this._handlePrint.bind(this);
this._chartBuilder.printButton.addEventListener("click", this._printHandlerBinding);
}
// This will raise an event if left and right arrow is pressed on focused items in chart container.
if (this._chartBuilder) {
this._onArrowKeyDownBinding = this._enableArrowKeyAccessibilty.bind(this);
this._chartBuilder.accessibilityTextNodeContainer.addEventListener("keydown", this._onArrowKeyDownBinding);
}
},
releaseEvents: function releaseEvents() {
this._innerContainer.detachEvent("onresize", this._resizeHandlerBinding);
if (this._chartOptions.enableExpand === true) {
this._chartBuilder.expandButton.removeEventListener("click", this._expandHandlerBinding);
}
this._innerContainer.removeEventListener("mousemove", this._mousemoveHandlerBinding);
this._innerContainer.removeEventListener("MSPointerMove", this._pointermoveHandlerBinding);
if (this._chartOptions.disableHoverOnBlur) {
this._innerContainer.removeEventListener("mouseout", this._mouseOutHandlerBinding);
this._innerContainer.removeEventListener("mouseenter", this._mouseEnterHandlerBinding);
this._innerContainer.removeEventListener("blur", this._onBlurHandlerBinding);   
}
this.highContrastChanged.removeListener(this.highContrastChangedBinding);
this.highContrastChangedBlackOnWhite.removeListener(this.highContrastChangedBinding);
this.highContrastChangedWhiteOnBlack.removeListener(this.highContrastChangedBinding);
if (this._chartOptions.enableSave === true) {
this._chartBuilder.saveButton.removeEventListener("click", this._saveHandlerBinding);
}
if (this._chartOptions.enablePrint === true) {
this._chartBuilder.printButton.removeEventListener("click", this._printHandlerBinding);
}
if (this._chartBuilder) {
this._chartBuilder.accessibilityTextNodeContainer.removeEventListener("keydown", this._onArrowKeyDownBinding);
}
},
}
),
SeriesManager: WinJS.Class.define(
function (chartOptions, chartDimensions) {
this._chartOptions = chartOptions;
this._chartDimensions = chartDimensions;
this._seriesCollection = [];
this._activeSeriesIds = [];
this._seriesObjects = [];
if (this._chartOptions.isMultiSeries) {
this._chartLimits = { minX: null, minY: null, maxX: null, maxY: null };
}
else {
this._chartLimits = null;
}
},
{
updateData: function updateData(value) {
var plotRequired = false;
var xVals = [], yVals = [];
if (this._chartOptions.isMultiSeries) {
var currentChartLimit = { minX: null, minY: null, maxX: null, maxY: null };
for (var i = 0; i < value.length; i++) {
var x_array = value[i].series.map(function (j) { return j[0]; });
var y_array = value[i].series.map(function (j) { return j[1]; });
currentChartLimit.maxX = Math.max(currentChartLimit.maxX, Math.max.apply(null, x_array));
currentChartLimit.minX = Math.min(currentChartLimit.minX, Math.min.apply(null, x_array));
currentChartLimit.maxY = Math.max(currentChartLimit.maxY, Math.max.apply(null, y_array));
currentChartLimit.minY = Math.min(currentChartLimit.minY, Math.min.apply(null, y_array));
}
this._chartLimits.minX = currentChartLimit.minX;
this._chartLimits.maxX = currentChartLimit.maxX;
this._chartLimits.minY = currentChartLimit.minY;
this._chartLimits.maxY = currentChartLimit.maxY;
}
for (var i = 0; i < value.length; i++) {
// plot only if it is one of active serieses
if (this.contains(this._activeSeriesIds, value[i].seriesId)) {
plotRequired = true;
}
var series = this.getSeries(value[i].seriesId);
if (series) {
series.update(value[i]);
}
else {
var seriesObject = this.getSeriesObject(value[i].seriesId);
this._seriesCollection[this._seriesCollection.length] = new FinanceAppJS.UI.dataSeries(this._chartOptions, seriesObject, value[i], this._chartDimensions, i, this._chartLimits);
}
}
return plotRequired;
},
getSeriesObject: function getSeriesObject(seriesId) {
var returnObject = null;
for (var i = 0; i < this._seriesObjects.length; i++) {
if (this._seriesObjects[i].seriesId === seriesId) {
returnObject = this._seriesObjects[i];
break;
}
}
return returnObject;
},
getSeries: function getSeries(id) {
var series = null;
for (var i = 0; i < this._seriesCollection.length; i++) {
if (this._seriesCollection[i].seriesId === id) {
series = this._seriesCollection[i];
}
}
return series;
},
setActiveSeries: function setActiveSeries(activeSeriesObject, replaceCurrent) {
var plotRequired = false;
if (!this.contains(this._activeSeriesIds, activeSeriesObject.seriesId)) {
plotRequired = true;
if (replaceCurrent) {
//flush the array
this._activeSeriesIds = [];
this._activeSeriesIds[0] = activeSeriesObject.seriesId;
}
else {
this._activeSeriesIds.push(activeSeriesObject.seriesId);
}
this._seriesObjects.push(activeSeriesObject);
}
return plotRequired;
},
getActiveSeriesList: function getActiveSeriesList() {
var activeSeriesList = [];
var activeSeries = null;
for (var i = 0; i < this._activeSeriesIds.length; i++) {
activeSeries = this.getSeries(this._activeSeriesIds[i]);
if (activeSeries) {
activeSeriesList.push(activeSeries);
}
}
return activeSeriesList;
},
contains: function contains(array, obj) {
for (var i = 0; i < array.length; i++) {
if (array[i] === obj) {
return true;
}
}
return false;
},
}
),
appexChartNotificationManager: WinJS.Class.define(
function (chartBuilder, chartPlotter) {
this._chartBuilder = chartBuilder;
this._chartPlotter = chartPlotter;
},
{
showErrorMessage: function showErrorMessage() {
// erase the chart before showing the error
// so that error will not be shown on top of previously drawn chart
this._chartPlotter.erase();
this.hideBusyIndicator();
WinJS.Utilities.removeClass(this._chartBuilder._errorControl, 'hide');
WinJS.Utilities.addClass(this._chartBuilder._errorControl, 'chartErrorControlShow');
WinJS.Utilities.addClass(this._chartBuilder.accessibilityTextNodeContainer, 'hide');
},
hideErrorMessage: function hideErrorMessage() {
WinJS.Utilities.removeClass(this._chartBuilder._errorControl, 'chartErrorControlShow');
WinJS.Utilities.addClass(this._chartBuilder._errorControl, 'hide');
WinJS.Utilities.removeClass(this._chartBuilder.accessibilityTextNodeContainer, 'hide');
},
showBusyIndicator: function showBusyIndicator() {
this.hideErrorMessage();
WinJS.Utilities.removeClass(this._chartBuilder._busyControl, 'hide');
WinJS.Utilities.addClass(this._chartBuilder._busyControl, 'chartErrorControlShow');
},
hideBusyIndicator: function hideBusyIndicator() {
WinJS.Utilities.removeClass(this._chartBuilder._busyControl, 'chartErrorControlShow');
WinJS.Utilities.addClass(this._chartBuilder._busyControl, 'hide');
}
}
),
appexStockChart: WinJS.Class.define(
function (element, options) {
/// <summary>
/// Constructor: Creates an instance of the Chart Control object.
/// </summary>
/// <returns>
/// An instance of the Chart control object.
/// </returns>
element = element || document.createElement("div");
element.winControl = this;
this._chartOptions = null;
this._isRequestPending = false;
this._init(element, options);
this.instrumentationID = options.instrumentationId;
},
// Instance members
{
innerContainer: null,
_chartDimensions: null,
_chartControlDimensions: null,
_activeSeriesId: null,
_chartCaption: null,
_init: function _init(containerDiv, options) {
this._chartOptions = new FinanceAppJS.UI.appexChartOptions();
WinJS.UI.setOptions(this._chartOptions, options);
if (this._chartOptions.isRtl) {
var leftPadding = this._chartOptions.paddingLeft;
this._chartOptions.paddingLeft = this._chartOptions.paddingRight;
this._chartOptions.paddingRight = leftPadding;
}
this._chartControlDimensions = new FinanceAppJS.UI.appexChartControlDimensions(containerDiv.clientWidth, containerDiv.clientHeight);
this._chartDimensions = new FinanceAppJS.UI.appexChartDimensions(this._chartControlDimensions.controlWidth, this._chartControlDimensions.controlHeight, this._chartOptions.paddingLeft, this._chartOptions.paddingTop, this._chartOptions.paddingRight, this._chartOptions.paddingBottom);
this.innerContainer = document.createElement("div");
var innerContainerId = 'C' + Math.ceil((100000 * Math.random())).toString() + '_innerContainer';
this.innerContainer.setAttribute("id", innerContainerId);
WinJS.Utilities.addClass(this.innerContainer, 'innerChartContainer');
if (this._chartOptions.enableHover === 'mouseAndTouch') {
WinJS.Utilities.addClass(this.innerContainer, 'enableHover');
}
containerDiv.appendChild(this.innerContainer);
this._seriesManager = new FinanceAppJS.UI.SeriesManager(this._chartOptions, this._chartDimensions);
this._chartBuilder = new FinanceAppJS.UI.appexChartBuilder(this._chartOptions, this.innerContainer, this._chartControlDimensions);
this._chartPlotter = new FinanceAppJS.UI.appexChartPlotter(this._chartOptions, this.innerContainer, this._chartBuilder.drawingContext, this._chartBuilder.overlaydrawingContext, this._chartControlDimensions, this._chartDimensions, this._seriesManager);
this._chartHighlighter = new FinanceAppJS.UI.appexChartHighlighter_Canvas(this._chartOptions, this._chartBuilder, this._chartControlDimensions, this._chartDimensions, this._seriesManager);
this._eventManager = new FinanceAppJS.UI.appexChartEventManager(this._chartOptions, this.innerContainer, this._chartHighlighter, this._chartControlDimensions, this._chartDimensions, this._chartBuilder, this._chartPlotter);
this._notificationManager = new FinanceAppJS.UI.appexChartNotificationManager(this._chartBuilder, this._chartPlotter);
},
data: {
get: function get() {
return this._data;
},
set: function set(value) {
try {
if (!this._eventManager.controlIsReady) {
var that = this;
this._eventManager.controlReadyCallback = function () {
that.data = value;
};
return;
}
this._notificationManager.hideErrorMessage();
if (value && value.length > 0) {
var plotRequired = this._seriesManager.updateData(value);
if (plotRequired) {
this.plotAndHightlight();
}
}
else {
if (this._isRequestPending) {
// The error callback came for a previous request, which is overridden by next request already.
// ignore this error
this._notificationManager.showErrorMessage();
this._chartHighlighter.updateLastRTQuotesUpdatedTime();
}
}
this._isRequestPending = false;
}
catch (err) {
FinanceAppJS.Telemetry.FlightRecorder.LogErrorEvent(err.message, err.stack);
this._notificationManager.showErrorMessage();
}
this._notificationManager.hideBusyIndicator();
}
},
realtimeQuotesLastUpdatedTimeString: {
set: function set(value) {
this._chartHighlighter.realtimeQuotesLastUpdatedTimeString = value;
}
},
activeSeries: {
set: function set(seriesObject) {
this._isRequestPending = true;
var plotRequired;
if (this._chartOptions.isMultiSeries) {
for (var i = 0; i < seriesObject.length; i++) {
plotRequired = this._seriesManager.setActiveSeries(seriesObject[i], false);
}
}
else {
plotRequired = this._seriesManager.setActiveSeries(seriesObject, true);
}
if (plotRequired) {
this._notificationManager.showBusyIndicator();
this.plotAndHightlight();
}
}
},
chartCaption: {
set: function set(caption) {
this._chartCaption = caption;
if (this._chartBuilder) {
this._chartBuilder.fillCaption(caption);
}
},
get: function get() {
return this._chartCaption;
}
},
dispose: function dispose() {
this._eventManager.releaseEvents();
},
plotAndHightlight: function plotAndHightlight() {
try {
this._chartPlotter.plot();
if (this._chartOptions.enableHover !== 'none') {
if (!this._chartOptions.disableHoverOnBlur) {
var that = this;
// delay highlight (bug fix: 319773)
setImmediate(function () { that._chartHighlighter.highlight(); });
} else {
if (this._chartHighlighter.realtimeQuotesLastUpdatedTimeString) {
this._chartHighlighter.updateLastRTQuotesUpdatedTime();
}
}                          
}
}
catch (err) {
FinanceAppJS.Telemetry.FlightRecorder.LogErrorEvent(err.message, err.stack);
this._notificationManager.showErrorMessage();
}
},
}),
});
})();