﻿(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS.Telemetry", {
FlightRecorder: WinJS.Class.define(function () {
// constructor
},
{
// object members and functions
},
{
LogAppEvent: function LogAppEvent(page, utility, data) {
var element = utility;
var context = page;
var operation = "click";
var dataPoint = {
page: page,
utility: utility,
data: JSON.stringify(data)
};
Platform.Telemetry.FlightRecorder.logAppActionWithJsonAttributes(Platform.Telemetry.LogLevel.normal,
context, element, operation, 0, JSON.stringify(dataPoint));
},
_userEventK: [],
LogUserEvent: function LogUserEvent(page, cluster, location, data, useroprn) {
var element = location;
var context = "";
if (!page) {
if (cluster) {
context = cluster;
}
}
if (!cluster) {
if (page) {
context = page;
}
}
if (page && cluster) {
context = cluster;
}
var operation = "click";
if (useroprn) {
operation = "scroll";
}
var dataPoint = {
page: page,
cluster: cluster,
location: location,
operation: operation,
data: JSON.stringify(data)
};
if (!this._userEventK[context]) {
this._userEventK[context] = 1;
}
Platform.Telemetry.FlightRecorder.logUserActionWithJsonAttributes(
Platform.Telemetry.LogLevel.normal,
context,
element,
operation,
Platform.Telemetry.UserActionMethod.unknown,
//this._userEventK[context]++,
0,
JSON.stringify(dataPoint));
},
LogContentView: function LogContentView(content) {
var impression = PlatformJS.Navigation.mainNavigator.getCurrentImpression();
if (!impression || !content) {
return;
}
var k = impression.addContent(
"", // sourceName
"", // partnerCode
content.Page, // contentId
content.Symbol, //type
new Date(), //date
"", //uri
"", //slug
false, //isSummary
Platform.Telemetry.ContentWorth.Normal, //worth
false, //isAdd
"" //addCampaign
);
impression.logContent(Platform.Telemetry.LogLevel.normal);
impression.logContentViewWithJsonAttributes(
Platform.Telemetry.LogLevel.normal,              // level
k,                              // k
"Dynamic",                      // viewMechanism
false,                          // logOnlyIfNotViewed
null,                           // progress
JSON.stringify(content)         // jsonAttributes
);
},
_isWatchlistContentFromTodayLogged: false,
LogWatchlistContentFromToday: function LogWatchlistContentFromToday(content) {
if (this._isWatchlistContentFromTodayLogged === false) {
this._isWatchlistContentFromTodayLogged = true;
Platform.Telemetry.FlightRecorder.logPreferencesAsJson(
Platform.Telemetry.LogLevel.normal,
JSON.stringify(content));
}
},
NavigateFromTo: function NavigateFromTo() {
var navHist = WinJS.Navigation.history;
if (navHist.backStack.length > 0) {
var currPageId = this.GetPageId(navHist.current.location.channelId);
var lastPageId = this.GetPageId(navHist.backStack[navHist.backStack.length - 1].location.channelId);
var dataPoint = {
from: lastPageId,
to: currPageId,
direction: "forward",
};
Platform.Telemetry.FlightRecorder.logUserActionWithJsonAttributes(Platform.Telemetry.LogLevel.normal, "Navigation", "", "navigation",
Platform.Telemetry.UserActionMethod.unknown, 0, JSON.stringify(dataPoint));
}
},
SetNavigationMethod: function SetNavigationMethod(navMethod) {
Platform.Telemetry.FlightRecorder.setImpressionNavMethod(navMethod);
},
LogDataRequest: function LogDataRequest(QrySendRecv, providerName, lastQryObj) {
var eventId = "";
var lastQueryTime = null;
var evtDetail = {};
var lastRequestId = null;
if (QrySendRecv === "request") {
lastQryObj = {};
lastQueryTime = CollectionProvider.Formatters.formatNumber(performance.now(), 3).replace(",", "");
lastRequestId = providerName + "_" + Date.now();
eventId = "AppQueryRequest";
lastQryObj = {
RequestId: lastRequestId,
CurrTimeInms: lastQueryTime,
ResponseTime: 0,
DataProvider: providerName,
UserTag: "QRYREQ"
};
Platform.Telemetry.FlightRecorder.logCustom(Platform.Telemetry.LogLevel.normal, eventId, JSON.stringify(lastQryObj));
return lastQryObj;
} else if (QrySendRecv === "service") {
eventId = "AppQueryService";
if (!lastQryObj) {
Platform.Telemetry.FlightRecorder.logCustom(Platform.Telemetry.LogLevel.normal, eventId, "");
return;
}
var LastQryTim = lastQryObj.CurrTimeInms;
lastQryObj.CurrTimeInms = CollectionProvider.Formatters.formatNumber(performance.now(), 3).replace(",", "");
lastQryObj.ResponseTime = lastQryObj.CurrTimeInms - LastQryTim;
lastQryObj.UserTag = "QRYSRV",
Platform.Telemetry.FlightRecorder.logCustom(Platform.Telemetry.LogLevel.normal, eventId, JSON.stringify(lastQryObj));
return;
}
},
_queryResultsOfSearchCharm: null,
SetSearchCharmQueryDisplay: function SetSearchCharmQueryDisplay(qryResults) {
this._queryResultsOfSearchCharm = qryResults;
},
LogSearchEventFromResultPage: function LogSearchEventFromResultPage() {
// requested by BING - APP has no requirement for this
if (!this._queryResultsOfSearchCharm || !this._queryResultsOfSearchCharm.lastPage) {
// if lastPage is null then we have missed at least one logging from the 
// results page REASON - before the pageload completed (or impression id set)
// user has changed the search charm query and M* has given the results too
return;
}
// this is only and only for pages resulting in completion of Search Charm query
var respage = this.GetPageId(WinJS.Navigation.location.channelId);
this._queryResultsOfSearchCharm.resultPage = respage;
var qryResSel = this._queryResultsOfSearchCharm.dataList;
qryResSel.lastPage = this._queryResultsOfSearchCharm.lastPage;
qryResSel.queryStr = this._queryResultsOfSearchCharm.queryString;
qryResSel.resultPage = respage;
qryResSel.origin = this._queryResultsOfSearchCharm.origin;
Platform.Telemetry.FlightRecorder.logSearch(
Platform.Telemetry.LogLevel.normal, 
this._queryResultsOfSearchCharm.queryString, 
"", 
Platform.Telemetry.SearchMethod.charm,
false, FinanceAppJS.Constants.SearchCharm.NoOfSuggestions, true, false, true, 
"APXF01", 
JSON.stringify(qryResSel));
this._queryResultsOfSearchCharm = null;
},
LogSearchApp: function LogSearchApp(origin, queryStr, data) {
var queryMthd = Platform.Telemetry.SearchMethod.unknown;
var count = FinanceAppJS.Constants.QuickSearch.NoOfSuggestions;
var formCode = "";
if (origin) {
if (origin.indexOf("QuickSearch") > -1) {
queryMthd = Platform.Telemetry.SearchMethod.form;
count = FinanceAppJS.Constants.QuickSearch.NoOfSuggestions;
formCode = "APXF03";
} else if (origin.indexOf("SearchCharm") > -1) {
queryMthd = Platform.Telemetry.SearchMethod.charm;
count = FinanceAppJS.Constants.SearchCharm.NoOfSuggestions;
formCode = "APXF01";
} else if (origin.indexOf(FinanceAppJS.Telemetry.Constants.Location.PINNEDTILE) > -1) {
queryMthd = Platform.Telemetry.SearchMethod.view;
count = 1;
formCode = "APXF02";
}
}
var qryResSel = data;
if (origin.indexOf("Complete") > -1) {
if (origin.indexOf("SearchCharm") > -1 && this._queryResultsOfSearchCharm) {
var datalist = {};
for (var i = 1; i < this._queryResultsOfSearchCharm.length; i++) {
if (this._queryResultsOfSearchCharm[i]) {
datalist[i] = this._queryResultsOfSearchCharm[i];
if (this._queryResultsOfSearchCharm[i] === data[0]) {
datalist.selectionIndex = i;
}
}
}
if (datalist.selectionIndex) {
qryResSel = datalist;
}
this._queryResultsOfSearchCharm = {};
this._queryResultsOfSearchCharm.dataList = datalist;
this._queryResultsOfSearchCharm.lastPage = this.GetPageId(WinJS.Navigation.location.channelId);
this._queryResultsOfSearchCharm.queryString = queryStr;
this._queryResultsOfSearchCharm.origin = origin;
}
}
if (qryResSel) {
qryResSel = JSON.stringify(qryResSel);
} else {
qryResSel = "";
}
Platform.Telemetry.FlightRecorder.logSearch(Platform.Telemetry.LogLevel.normal, queryStr, "", queryMthd,
false, count, true, false, true, formCode, qryResSel);
},
LogErrorEvent: function LogErrorEvent(message, stackTrace) {
Platform.Telemetry.FlightRecorder.logCrash(
Platform.Telemetry.LogLevel.diagnostic,
Platform.Telemetry.RuntimeEnvironment.javascript,
message,
stackTrace);
},
GetPageId: function GetPageId(pageChannelId) {
switch (pageChannelId) {
case "MarketToday":
case "Home":
return FinanceAppJS.Telemetry.Constants.Page.MARKETTODAY;
case "Market":
return FinanceAppJS.Telemetry.Constants.Page.MARKET;
case "IndexDetails":
return FinanceAppJS.Telemetry.Constants.Page.INDEXDETAILS;
case "MyStocks": 
return FinanceAppJS.Telemetry.Constants.Page.WATCHLIST;
case "EntityNewsPano":
return FinanceAppJS.Telemetry.Constants.Page.ENTITYNEWSPANO;
case "EntityMoneyPano":
return FinanceAppJS.Telemetry.Constants.Page.ENTITYMONEYPANO;
case "Currencies":
return FinanceAppJS.Telemetry.Constants.Page.CURRENCIES;
case "StockEntity":
return FinanceAppJS.Telemetry.Constants.Page.STOCKDETAILS;
case "Tools":
return FinanceAppJS.Telemetry.Constants.Page.TOOLS;
case "CurrencyConverter":
return FinanceAppJS.Telemetry.Constants.Page.CURRENCYCONVERTER;
case "FundBrowse":
return FinanceAppJS.Telemetry.Constants.Page.FUNDBROWSE;
case "FundPicks":
return FinanceAppJS.Telemetry.Constants.Page.FUNDPICKS;
case "FundDetails":
return FinanceAppJS.Telemetry.Constants.Page.FUNDDETAILS;
case "ETF":
return FinanceAppJS.Telemetry.Constants.Page.ETF;
default:
return pageChannelId;
}
},
heropageloadtime: 0,
SetHeroPageLoadtime: function SetHeroPageLoadtime() {
this.heropageloadtime = Date.now();
},
HeroScroll: function HeroScroll(event) {
if (!this.heropageloadtime) {
var viewport = document.getElementById("FinanceAppJS.HomePage.HeroImageCluster_newsCluster");
if (viewport) {
viewport.removeEventListener("mousewheel", FinanceAppJS.Telemetry.FlightRecorder.HeroScroll);
}
return;
}
var timnow = Date.now();
var timdiff = timnow - this.heropageloadtime;
var eventId = "AppHeroDwellTime";
var TimeObj = {
TimeSpent: timdiff,
UserTag: "HeroDwellTime"
};
Platform.Telemetry.FlightRecorder.logCustom(Platform.Telemetry.LogLevel.normal, eventId, JSON.stringify(TimeObj));
this.heropageloadtime = 0;
},
GetRatesContextFromId: function GetRatesContextFromId(category, isImpression) {
switch (category) {
case "homequity":
return "Home Equity";
case "mortgage":
return "Mortgage";
case "auto":
if (isImpression === true) {
return "Auto Loan";
}
return "Auto Loan Rates";
case "deposit":
return "Savings";
case "creditcard":
return "Credit Card";
default:
return category;
}
},
})
});
})();