﻿(function (global) {
'use strict'
var FinanceAppJS = global.FinanceAppJS = {};
FinanceAppJS.initializeConfigOperation = global.FinanceAppJS.initializeConfigOperation = {
_completed: false,
complete: function complete() {
FinanceAppJS.initializeConfigOperation._completed = true;
}
};
FinanceAppJS.ConfigManager = {
_configData: {},
_queryService: null,
_queryServiceParams: null,
_container: null,
_lastUpdated: null,
_checkUpdateTimer: null,
_getFile: function _getFile(key) {
var dataFile = "ms-appx:///" + key + ".json";
var xhr = new XMLHttpRequest;
xhr.open("GET", dataFile, false);
xhr.send();
var data = JSON.parse(xhr.responseText);
return data;
},
_updateFullConfigData: function _updateFullConfigData(response) {
var that = FinanceAppJS.ConfigManager;
if (!response || response.isCachedResponse) { return; }
try {
var data = JSON.parse(response.dataString);
if (!data || !data.length) { return; }
var date = response.lastUpdateTime;
for (var i = 0, item ; i < data.length && (item = data[i]) ; i++) {
that._updateConfig(item.Key, JSON.parse(item.Value), date);
}
that._container = that._container || Windows.Storage.ApplicationData.current.localSettings.containers.lookup("FinanceConfig");
that._container.values["config_timestamp"] = JSON.stringify(date);
that._lastUpdated = date;
//Config JSON update has happened
//We need to reload/clear/refresh stuff which depend on the json files
// 1. Reload Globalization Data from the updated JSON
FinanceAppJS.Globalization.reload();
if (utils) {
//2. Update LiveTile after reloading Globalization Data as live tile has dependency on Globalization
utils.updateLiveTile();
//3. Clear currency config so that from the next time onwards it reads from the updated JSON
utils.clearCurrencyConfig();
}
if (that._checkUpdateTimer) {
clearInterval(that._checkUpdateTimer);
that._checkUpdateTimer = setInterval(that.checkConfigUpdate.bind(that), 1000 * 60 * 60 * 12);
}
}
catch (ex) {
}
},
checkConfigUpdate: function checkConfigUpdate(bypassCache) {
var that = FinanceAppJS.ConfigManager;
that._checkUpdateTimer = that._checkUpdateTimer || setInterval(that.checkConfigUpdate.bind(that), 1000 * 60 * 60 * 12);
if (!that._lastUpdated) {
that._container = that._container || Windows.Storage.ApplicationData.current.localSettings.containers.lookup("FinanceConfig");
if (that._container.values.hasKey("config_timestamp")) {
that._lastUpdated = new Date(JSON.parse(that._container.values["config_timestamp"]));
} else {
that._lastUpdated = new Date(1970, 1, 1);
}
}
that._queryService = that._queryService || new Platform.QueryService("FinanceConfig");
if (!that._queryServiceOptions) {
that._queryServiceOptions = new Platform.DataServices.QueryServiceOptions();
}
that._queryServiceOptions.bypassCache = bypassCache ? true : false;
that._queryService.downloadDataAsync(null, null, null, that._queryServiceOptions).then(that._updateFullConfigData.bind(that));
},
_updateConfig: function _updateConfig(key, data) {
var that = FinanceAppJS.ConfigManager;
var compositeData = new Windows.Storage.ApplicationDataCompositeValue();
for (var i in data) {
compositeData[i] = JSON.stringify(data[i]);
}
that._container.values[key] = compositeData;
},
_versionCheckDone: false,
getConfigData: function getConfigData(key) {
var that = FinanceAppJS.ConfigManager;
var data = that._configData[key], container;
if (data) { return data; }
var localSettings = Windows.Storage.ApplicationData.current.localSettings;
if (!localSettings.containers.hasKey("FinanceConfig")) {
container = localSettings.createContainer("FinanceConfig", Windows.Storage.ApplicationDataCreateDisposition.always);
} else {
container = localSettings.containers.lookup("FinanceConfig");
if (!that._versionCheckDone) {
var cfgversion = container.values["FinanceConfigVersion"];
var appversion = Platform.Process.instance.getAppVersionString();
if (cfgversion !== appversion) {
localSettings.deleteContainer("FinanceConfig");
that._versionCheckDone = true;
return that.getConfigData(key);
}
}
}
that._container = container;
if (container.values.hasKey(key)) {
var composite = container.values[key];
key = composite.first();
data = {};
key = composite.first();
do {
data[key.current.key] = JSON.parse(key.current.value);
} while (key.moveNext());
that._configData[key] = data;
return data;
} else {
data = that._getFile(key);
/* Local Settings seems to automatically make it an object from array
* Temporary fix to minimize code change
*/
if (data && data.length) {
var transformData = {};
data.forEach(function (item, index) { transformData[index.toString()] = item; });
data = transformData;
}
that._updateConfig(key, data);
container.values["FinanceConfigVersion"] = Platform.Process.instance.getAppVersionString();
return data;
}
},
getCollatedConfigData: function getCollatedConfigData() {
/// In case, we don't support the current language and region, the market is ROW, 
/// which does not have a region associated with it. Fall back to geographic region
var returnData = null;
var region = Platform.Globalization.Marketization.getCurrentMarketInfo().geographicRegion || Windows.Globalization.GeographicRegion();
var data = FinanceAppJS.ConfigManager.getConfigData("GlobalizationData");
var exchangeDef = FinanceAppJS.ConfigManager.getConfigData("ExchangesInfo");
var indicesDef = FinanceAppJS.ConfigManager.getConfigData("IndicesInfo");
var freSecondaryMarkets = FinanceAppJS.ConfigManager.getConfigData("FRESecondaryMarketInfo");
var countryCodes = FinanceAppJS.ConfigManager.getConfigData("CountryCodes");
if (!data || !exchangeDef || !indicesDef || !freSecondaryMarkets || !countryCodes) {
return null;
}
for (var ex in exchangeDef) {
exchangeDef[ex].id = ex;
}
var countryCodeToNameMap = {};
for ( var i in countryCodes ) {
var country = countryCodes[i];
countryCodeToNameMap[country.code] = country.country;
}
var indexSymbolToInfoMap = [];
for (var indx in indicesDef) {
var index = indicesDef[indx]
index.displayName = "Indx_" + indx;
index.code = indx;
index.countryname = countryCodeToNameMap[index.country];
indexSymbolToInfoMap[index.symbol] = index;
}
var regionClass = data.minBar;
var regionCode = region.codeThreeLetter;
var market = Platform.Globalization.Marketization.getCurrentMarket().toLowerCase();
for (var r in data.regionClassification) {
if (data.regionClassification[r].indexOf(regionCode) !== -1) {
regionClass = r;
break;
}
}
for (var r in data.regionClassification) {
if (data.regionClassification[r].indexOf(market) !== -1) {
regionClass = r;
break;
}
}
returnData = data[regionClass];
if (data.hasOwnProperty(regionCode)) {
for (var key in data[regionCode]) {
returnData[key] = data[regionCode][key];
}
}
if (data.hasOwnProperty(market)) {
for (var key in data[market]) {
returnData[key] = data[market][key];
}
}
returnData.usExchangeList = [];
returnData.localExchangesList = [];
for (var exchange in exchangeDef) {
if (exchangeDef[exchange].countryCode === regionCode) {
returnData.localExchangesList.push(exchange);
}
if (exchangeDef[exchange].countryCode === 'USA') {
returnData.usExchangeList.push(exchange);
}
}
//returnData.region = region;
//returnData.currencies = region.currenciesInUse;
returnData.market = Platform.Globalization.Marketization.getCurrentMarket();
returnData.defaultCurrency = region.currenciesInUse[0];
returnData.exchangeDef = exchangeDef;
returnData.indicesDef = indicesDef;
returnData.exchangeDefList = returnData.exchangeList.map(function (value) { return exchangeDef[value]; });
returnData.moversExchangeList = returnData.exchangeList.map(function (value) { return exchangeDef[value]; });
returnData.homePageIndices = returnData.homePageIndices.map(function (item) { return indicesDef[item]; });
returnData.defaultExchangeDef = exchangeDef[returnData.defaultExchange];
returnData.regionClassification = regionClass;
returnData.freSecondaryMarketsConfig = freSecondaryMarkets;
returnData.countryCodes = countryCodes;
returnData.indexSymbolToInfoMap = indexSymbolToInfoMap;
returnData.countryCodeToNameMap = countryCodeToNameMap;
return returnData;
}
};
})(this);
(function () {
'use strict';
if (typeof document !== 'undefined') {
var configWorker = new Worker("/workers/FinanceConfig.js");
configWorker.onmessage = function (event) {
if (!event.data) {
FinanceAppJS.initializeConfigOperation.complete();
return;
}
if (FinanceAppJS.Globalization._data) {
} else {
FinanceAppJS.Globalization._setData(event.data);
}
FinanceAppJS.initializeConfigOperation.complete();
}
} else {
try {
postMessage(FinanceAppJS.ConfigManager.getCollatedConfigData());
}
catch (ex) {
postMessage(null);
}
}
})();