﻿WinJS.Namespace.define('CommonJS', { Version: 'latest' });
/* File: ArticleReaderUtils.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function appexPlatformArticleReaderUtilitiesInit() {
"use strict";
WinJS.Namespace.define("PlatformJS.Utilities", {
_addTileAdToArticleInfo: function _addTileAdToArticleInfo(articleInfo, applicationId, adUnitId) {
if (articleInfo && articleInfo.adGroups) {
articleInfo.adGroups.push({
type: "inline",
adMetadatas: [
JSON.stringify({
controlType: "PlatformJS.Ads.AdsWrapperControl",
controlOptions: {
adUnitId: adUnitId,
otherAdOptions: {
applicationId: applicationId,
adUnitId: adUnitId,
keywords: "",
},
className: "adTypeTile",
},
height: 250,
width: 300,
})
]
});
} else {
if (articleInfo) {
console.log("_addTileAdToArticleInfo: undefined ad groups for article:" + articleInfo.articleId);
} else {
console.log("_addTileAdToArticleInfo: undefined articleInfo");
}
}
},
_addThinAdToArticleInfo: function _addThinAdToArticleInfo(articleInfo, applicationId, adUnitId) {
if (articleInfo && articleInfo.adGroups) {
articleInfo.adGroups.push({
type: "end",
adMetadatas: [
JSON.stringify({
controlType: "PlatformJS.Ads.AdsWrapperControl",
controlOptions: {
adUnitId: adUnitId,
otherAdOptions: {
applicationId: applicationId,
adUnitId: adUnitId,
keywords: "",
},
className: "adTypeThin",
},
height: 600,
width: 300,
})
]
});
} else {
if (articleInfo) {
console.log("_addThinAdToArticleInfo: undefined ad groups for article:" + articleInfo.articleId);
} else {
console.log("_addThinAdToArticleInfo: undefined articleInfo");
}
}
},
_addFullPageAdToArticleInfo: function _addFullPageAdToArticleInfo(articleInfo, applicationId, adUnitId) {
if (articleInfo && articleInfo.adGroups) {
articleInfo.adGroups.push({
type: "interstitial",
adMetadatas: [
JSON.stringify({
controlType: "PlatformJS.Ads.RotatingAdsWrapperControl",
controlOptions: {
adOptions: {
landscapeOptions: {
adUnitId: adUnitId,
otherAdOptions: {
applicationId: applicationId,
adUnitId: adUnitId,
keywords: "",
},
className: "adTypeFullPageLandscape",
},
portraitOptions: {
adUnitId: adUnitId,
otherAdOptions: {
applicationId: applicationId,
adUnitId: adUnitId,
keywords: "",
},
className: "adTypeFullPagePortrait",
},
},
},
})
]
});
} else {
if (articleInfo) {
console.log("_addFullPageAdToArticleInfo: undefined ad groups for article:" + articleInfo.articleId);
} else {
console.log("_addFullPageAdToArticleInfo: undefined articleInfo");
}
}
},
annotateArticleInfosWithAdInfo: function annotateArticleInfosWithAdInfo(articleInfos, adConfigs, applicationId) {
// NOTE: articleInfos does NOT GROW in this call
if (!articleInfos || !articleInfos.length || PlatformJS.Ads.Config.instance.disableArticleReaderAds === true ||
!PlatformJS.Utilities.hasInternetConnection()) {
return;
}
applicationId = applicationId || "";
var cmsAdConfig = PlatformJS.Ads.getCMSConfig();
if (cmsAdConfig) {
var articleReaderAdConfig = cmsAdConfig.articleReaderAds;
if (articleReaderAdConfig && Array.isArray(articleReaderAdConfig) && articleReaderAdConfig.length) {
for (var iArticlePage = 0, iAdPage = 0; iArticlePage < articleInfos.length; iArticlePage++, iAdPage++) {
var articleInfo = articleInfos[iArticlePage];
articleInfo.adGroups = [];
var adConfig = {};
// Reset the config index if we reached the end of the cycle
if (iAdPage >= articleReaderAdConfig.length) {
iAdPage = 0;
}
adConfig = articleReaderAdConfig[iAdPage];
switch (adConfig.type) {
case "tile":
this._addTileAdToArticleInfo(articleInfo, applicationId, adConfig.adUnitId);
break;
case "thin":
this._addThinAdToArticleInfo(articleInfo, applicationId, adConfig.adUnitId);
break;
case "fullpage":
this._addFullPageAdToArticleInfo(articleInfo, applicationId, adConfig.adUnitId);
break;
default:
// ignore this ad type
break;
}
}
}
} else if (adConfigs) {
this._oldAnnotateArticleInfosWithAdInfo(articleInfos, adConfigs, applicationId);
}
},
// TODO: removed once all article 
_oldAnnotateArticleInfosWithAdInfo: function _annotateArticleInfosWithAdInfo(articleInfos, adConfigs, applicationId) {
var fHaveConfig = adConfigs && adConfigs.length;
for (var iArticlePage = 0, iAdPage = 0; iArticlePage < articleInfos.length; iArticlePage++, iAdPage++) {
var articleInfo = articleInfos[iArticlePage];
articleInfo.adGroups = [];
var adConfig = {};
if (fHaveConfig) {
// Reset the config index if we reached the end of the cycle
if (iAdPage >= adConfigs.length) {
iAdPage = 0;
}
adConfig = adConfigs[iAdPage];
}
for (var i = 0; i < (adConfig.ads ? adConfig.ads.length : 0) ; i++) {
switch (adConfig.ads[i].type) {
case "tile":
this._addTileAdToArticleInfo(articleInfo, applicationId, adConfig.ads[i].adUnitId);
break;
case "thin":
this._addThinAdToArticleInfo(articleInfo, applicationId, adConfig.ads[i].adUnitId);
break;
case "fullPage":
this._addFullPageAdToArticleInfo(articleInfo, applicationId, adConfig.ads[i].adUnitId);
break;
default:
// ignore this ad type
break;
}
}
}
}
});
})();
(function appexPrivateArticleReaderUtilitiesInit() {
"use strict";
var T = Platform.Telemetry;
WinJS.Namespace.define("CommonJS.ArticleReader", {
ArticleReaderUtils: {
impressionNavMethod: {
endOfArticleBlock: "End of Article Block",
articleReader: "Article Reader",
},
actionContext: {
appBar: T.ActionContext.appBar,
body: "Article Reader",
},
convertColumnIndexToGridColumn: function convertColumnIndexToGridColumn(columnIndex, columnCount) {
/// <summary>
/// Converts a column index to a -ms-grid column.
/// </summary>
/// <param name="columnIndex">0-based column index</param>
/// <param name="columnCount">Number of columns in a page. e.g. 3</param>
return (((columnCount * 2) + 1) * (Math.floor(columnIndex / columnCount)) + ((columnIndex % columnCount) * 2 + 2));
},
convertColumnCountToWidth: function convertColumnCountToWidth(count, gridOptions) {
/// <summary>
/// Given a column count, return the width in pixels, including the gutters in between.
/// </summary>
/// <param name="count">Number of columns</param>
/// <param name="gridOptions">Grid options</param>
var columnMargin = gridOptions.columnMargin;
var columnWidth = gridOptions.columnWidth;
return (count * (columnMargin + columnWidth)) - columnMargin;
},
createSlideshowImageDefinition: function createSlideshowImageDefinition(blockImage, title) {
/// <summary>
/// From the given article reader image, creates a data structure for a single slide that can be passed to the slideshow control.
/// </summary>
var resource = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(blockImage, "original");
var caption = blockImage.caption;
var attribution = blockImage.attribution;
var image = {
url: resource.url,
width: resource.width,
height: resource.height,
};
var thumbnail = {
url: resource.url,
width: resource.width,
height: resource.height,
};
var slide = {
image: image,
thumbnail: thumbnail,
title: title,
desc: caption,
attribution: attribution,
};
return slide;
},
launchSlideshow: function launchSlideshow(slideshowData, startIndex, cacheId) {
/// <summary>
/// Launches a slideshow for the given slideshow data starting at the given index
/// </summary>
var location = {
fragment: "/common/Slideshow/html/GenericSlideshowPage.html",
page: "CommonJS.GenericSlideshowPage",
};
var state = {
data: slideshowData,
startIndex: startIndex,
instrumentationEntryPoint: "",
cacheId: cacheId,
impressionContext: "/Article Reader/Slideshow"
};
this.logUserAction(this.actionContext.body, "Image");
T.FlightRecorder.setImpressionNavMethod(this.impressionNavMethod.articleReader);
WinJS.Navigation.navigate(location, state);
},
getImageResource: function getImageResource(image, imageName) {
/// <summary>
/// Gets the image identified by imageName from the image dictionary.
/// By default gets "original".
/// </summary>
/// <param name="image">Image dictionary.</param>
/// <param name="imageName" optional="true">Optional, key into the dictionary to read.</param>
var imageResource = null;
var imageResources = image.images;
imageName = imageName || "original";
for (var i = 0, len = imageResources.length; i < len; i++) {
var current = imageResources[i];
if (current.name === imageName) {
imageResource = current;
break;
}
}
return imageResource;
},
getImageCardSource: function getImageCardSource(image, cacheId) {
/// <summary>
/// Returns a value that can be set as the imageSource attribute of an ImageCard based on the given image dictionary and cacheId.
/// </summary>
/// <param name="image">Image dictionary.</param>
/// <param name="cacheId">Cache ID. Can be null.</param>
var original = this.getImageResource(image, "original");
var lowRes = this.getImageResource(image, "lowRes");
var imageSource;
if (lowRes) {
imageSource = {
highResolutionUrl: original.url,
lowResolutionUrl: lowRes.url,
cacheId: cacheId,
};
}
else {
imageSource = {
url: original.url,
cacheId: cacheId,
};
}
return imageSource;
},
getBestExclusion: function getBestExclusion(startColumn, gridOptions, exclusions, maxWidth, maxHeight, minWidth) {
/// <summary>
/// Gets the best exclusion for an inline element. The final size does not exceed maxWidth x maxHeight, and is not smaller than minWidth.
/// </summary>
/// <param name="startColumn">0-based index of the column at which to start looking for best exclusion. Add 0.5 to start at end of column. e.g. 4.5 means end of column 4.</param>
/// <param name="gridOptions">Grid options.</param>
/// <param name="exclusions">All other exclusions on the surface.</param>
/// <param name="maxWidth">Max width of block.</param>
/// <param name="maxHeight">Max height of block.</param>
/// <param name="minWidth">Min width of block. Min height is inferred from the max aspect ratio.</param>
var columnCount = gridOptions.columnCount;
var aspectRatio = maxWidth / maxHeight;
// get start column, ideal alignmnet, and end column
var realStartColumn = Math.floor(startColumn);
var initialRowAlign = (realStartColumn === startColumn ? "start" : "end");
var endColumn = ((Math.floor(realStartColumn / columnCount) + 1) * columnCount) - 1;
var columnHeight = gridOptions.columnHeight;
var columnWidth = gridOptions.columnWidth;
var columnMargin = gridOptions.columnMargin;
// get the biggest size we can render based on original size and size of columns
var maxColumns = Math.floor((maxWidth + columnMargin) / (columnWidth + columnMargin)) + 1;
do {
maxColumns--;
var heightForMaxColumns = ((maxColumns * (columnWidth + columnMargin)) - columnMargin) / aspectRatio;
} while (heightForMaxColumns > columnHeight);
// get the smallest number of columns that must be allocated to this block
var minColumns = Math.ceil((minWidth + columnMargin) / (columnWidth + columnMargin));
// if min columns is higher than max, then adjust max
maxColumns = Math.max(maxColumns, minColumns);
var done = false;
var exclusion;
var currentStartColumn = realStartColumn;
while (!done) {
var columns = maxColumns + 1;
while (!exclusion) {
columns--;
columns = Math.min(columns, endColumn - currentStartColumn + 1);
if (columns < minColumns) {
break;
}
var heightForColumns = ((columns * (columnWidth + columnMargin)) - columnMargin) / aspectRatio;
exclusion = this._getExclusion(currentStartColumn, columns, heightForColumns, initialRowAlign, exclusions, gridOptions);
}
if (exclusion) {
done = true;
}
else {
if (initialRowAlign === "start") {
initialRowAlign = "end";
}
else if (initialRowAlign === "end") {
currentStartColumn++;
initialRowAlign = "start";
if (endColumn - currentStartColumn < maxColumns - 1) { // stop trying if less than max columns are left on this page, so we'll try again with max columns on the next page
done = true;
}
}
}
}
return exclusion;
},
isContentElementEmpty: function isContentElementEmpty(contentElement) {
/// <summary>
/// Given a content element, returns whether it is empty.
/// </summary>
var ranges = contentElement.msGetRegionContent();
var isEmpty = !(ranges && ranges.length && ranges[0].toString()) && (contentElement.msRegionOverflow === "empty" || contentElement.msRegionOverflow === "undefined");
return isEmpty;
},
isContentElementOverflowing: function isContentElementOverflowing(contentElement) {
/// <summary>
/// Given a content element, returns whether it is overflowing.
/// </summary>
var isOverflowing = (contentElement.msRegionOverflow === "overflow");
return isOverflowing;
},
isExclusionOnColumn: function isExclusionOnColumn(exclusion, columnIndex) {
/// <summary>
/// Given an exclusion and a 0-based column index, determines if any part of the exclusion falls on that column.
/// </summary>
var column = exclusion.column;
var columnSpan = exclusion.columnSpan;
var is = this._isColumnInRange(column, columnSpan, columnIndex);
return is;
},
isElementOnColumn: function isElementOnColumn(element, columnIndex, columnCount) {
/// <summary>
/// Given a block element and a 0-based column index, determines if any part of the block elemnent falls on that column.
/// </summary>
var style = getComputedStyle(element);
var gridColumn = parseInt(style.msGridColumn);
var gridColumnSpan = parseInt(style.msGridColumnSpan);
var column = this._convertGridColumnToColumnIndex(gridColumn, columnCount);
var columnSpan = (gridColumnSpan + 1) / 2;
var is = this._isColumnInRange(column, columnSpan, columnIndex);
return is;
},
getAllExclusions: function getAllExclusions(context) {
/// <summary>
/// Returns an array of all exclusions currently in layout data. This includes all block exclusions, and all title exclusions.
/// </summary>
var renderData = context.renderData;
var renderableBlocks = renderData.renderableBlocks;
var endRenderableBlocks = renderData.endRenderableBlocks;
var exclusions1 = this.getAllExclusionsFromRenderableBlocks(renderableBlocks);
var exclusions2 = this.getAllExclusionsFromRenderableBlocks(endRenderableBlocks);
var exclusions = [].concat(exclusions1, exclusions2);
return exclusions;
},
getAllNonTitleExclusions: function getAllNonTitleExclusions(context) {
/// <summary>
/// Returns an array of all non title exclusions currently in layout data.
/// </summary>
var renderData = context.renderData;
var renderableBlocks = renderData.renderableBlocks;
var endRenderableBlocks = renderData.endRenderableBlocks;
var exclusions1 = this.getAllExclusionsFromRenderableBlocks(renderableBlocks, true);
var exclusions2 = this.getAllExclusionsFromRenderableBlocks(endRenderableBlocks, true);
var exclusions = [].concat(exclusions1, exclusions2);
return exclusions;
},
getAllExclusionsFromRenderableBlocks: function getAllExclusionsFromRenderableBlocks(renderableBlocks, excludeTitle) {
// excludeTitle: when true we exclude title blocks in the list of exclusions that we return
var exclusions = [];
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
var element = renderableBlock.element;
if (element) {
var visibility = element.getAttribute("data-block-visibility");
var isHidden = (visibility === "hidden");
if (!isHidden) {
var exclusion = renderableBlock.exclusion;
if (exclusion) {
if (!excludeTitle || (excludeTitle && renderableBlock.position !== -1)) {
exclusions.push(exclusion);
}
}
}
}
}
return exclusions;
},
setFixedElementHeight: function setFixedElementHeight(elt) {
/// <summary>
/// Measures the height of the given element and sets it back on the element in fixed number of pixels.
/// This is to get around a CSS exclusions + -ms-grid bug, where end-aligned elements in a grid that are
/// also exclusions are not aligned properly.
/// </summary>
var offsetHeight = 0;
if (elt) {
//HACK: If we want to use the element's current height we set this flag to true
var hasHeight = elt.getAttribute("data-block-hasheight") === "true";
if (!hasHeight) {
elt.style.height = "";
}
offsetHeight = elt.offsetHeight;
elt.style.height = offsetHeight + "px";
}
return offsetHeight;
},
createContentElement: function createContentElement(flowId) {
/// <summary>
/// Creates a content element and returns it. Does not add the element to the DOM.
/// </summary>
/// <param name="flowId">Name of the flow to set -ms-flow-from to.</param>
var element = document.createElement("div");
WinJS.Utilities.addClass(element, "contentBlock");
element.style.msFlowFrom = flowId;
return element;
},
showModalProgress: function showModalProgress() {
/// <summary>
/// Shows a modal progress screen, not an overlay like platform's.
/// </summary>
var loadingScreen = document.getElementById("articleLoadingScreen");
if (loadingScreen) {
WinJS.Utilities.removeClass(loadingScreen, "platformHide");
}
CommonJS.Progress.showProgress(CommonJS.Progress.centerProgressType);
},
hideModalProgress: function hideModalProgress() {
/// <summary>
/// Hides the modal progress screen.
/// </summary>
var loadingScreen = document.getElementById("articleLoadingScreen");
if (loadingScreen) {
WinJS.Utilities.addClass(loadingScreen, "platformHide");
}
CommonJS.Progress.hideProgress(CommonJS.Progress.centerProgressType);
},
hasSourceLogo: function hasSourceLogo(titleBlock) {
/// <summary>
/// Returns true if the given title block has a source logo.
/// </summary>
return titleBlock && titleBlock.publisher && titleBlock.publisher.favicon;
},
combineCaptionAndAttribution: function combineCaptionAndAttribution(caption, attribution) {
/// <summary>
/// Combines caption and attribution into a space delimited string.
/// </summary>
var result = caption ? (attribution ? (caption + " " + attribution) : caption) : (attribution ? attribution : "");
return result;
},
instantiateChildAds: function instantiateChildAds(element) {
/// <summary>
/// For the given element, finds all the child AdContainer controls and instantiates them.
/// </summary>
var adContainerElts = element.querySelectorAll(".adContainer");
for (var i = 0, len = adContainerElts.length; i < len; i++) {
var adContainerElt = adContainerElts[i];
var adContainer = adContainerElt.winControl;
if (adContainer) {
adContainer.instantiateAd();
}
}
},
// This needs to be moved to ArticleReaderUtils
adTypeMatchesClass: function adTypeMatchesClass(theType, theClass) {
if (theClass === "adTypeThin" && theType === "thin") {
return true;
} else if (theClass === "adTypeTile" && theType === "tile") {
return true;
} else if (theClass === "adTypeFullPageLandscape" && theType === "fullPage") {
return true;
} else if (theClass === "adTypeFullPagePortrait" && theType === "fullPage") {
return true;
} else {
return (theClass && theType && theClass === theType);
}
},
convertAdInformationToAdOverrides: function convertAdInformationToAdOverrides(adInformation) {
/// <summary>
/// Parses the following JSON object, ignoring the two period values
/// 
/// "adInformation":{
///      "adPeriod":5,
///      "videoPeriod":10
///      "ads":[{"adUnits":[{"height":10,"id":"12342","type":"tile","width":10}, ...],
///              "partnerId":"ArticleSource"
///             },
///             ...
///      ],
///  }
/// </summary>
// adInformation could either be a JSON object or the stringified version of that JSON object. Normalize.
if (adInformation && typeof adInformation === "string") {
adInformation = JSON.parse(adInformation);
}
var adOverrides = [];
if (adInformation) {
var partnerAds = adInformation.ads;
if (partnerAds) {
for (var j = 0, lenj = partnerAds.length; j < lenj; j++) {
var adGroupNode = partnerAds[j];
var ads = {};
ads.ads = [];
ads.partnerId = adGroupNode.partnerId || "";
var adUnits = adGroupNode.adUnits;
if (adUnits) {
for (var i = 0, leni = adUnits.length; i < leni; i++) {
var adUnit = adUnits[i];
var type = adUnit.type;
var id = adUnit.id;
if (!type || !id) {
continue; // invalid
}
var height = adUnit.height ? parseInt(adUnit.height) || 0 : 0;
var width = adUnit.width ? parseInt(adUnit.width) || 0 : 0;
var ad = {
type: type,
id: id,
height: height,
width: width,
};
ads.ads.push(ad);
}
}
adOverrides.push(ads);
}
}
}
return adOverrides;
},
isNumber: function isNumber(n) {
/// <summary>
/// Returns true if n is a number
/// </summary>
return !isNaN(parseFloat(n)) && isFinite(n);
},
convertPageIndexToPageNumber: function convertPageIndexToPageNumber(pageIndex) {
/// <summary>
/// Converts the given page index to a presentable string. If index is -1, returns empty string.
/// </summary>
return (pageIndex === -1 ? "" : (pageIndex + 1) + "");
},
convertPageNumberDataToString: function convertPageNumberDataToString(pageIndex, pageCount) {
/// <summary>
/// Converts the given page number data (index and count) to a presentable string.
/// </summary>
return PlatformJS.Services.resourceLoader.getString("/Common/PageOf").format(pageIndex + 1, pageCount);
},
updateLayout: function updateLayout(renderableBlock, context) {
/// <summary>
/// For the given renderableBlock, reads the actual layout values from its dom element and writes them into
/// the layout property. Also updates the exclusion to match the layout.
/// </summary>
var element = renderableBlock.element;
if (element) {
var style = getComputedStyle(element);
var layout = {
row: parseInt(style.msGridRow),
rowSpan: parseInt(style.msGridRowSpan),
rowAlign: style.msGridRowAlign,
column: parseInt(style.msGridColumn),
columnSpan: parseInt(style.msGridColumnSpan),
columnAlign: style.msGridColumnAlign,
height: element.offsetHeight,
width: element.offsetWidth,
zIndex: parseInt(style.zIndex),
top: parseInt(style.marginTop) || 0,
bottom: parseInt(style.marginBottom) || 0,
left: parseInt(style.marginLeft) || 0,
right: parseInt(style.marginRight) || 0,
visibility: element.getAttribute("data-block-visibility") || "shown",
};
renderableBlock.layout = layout;
this._convertLayoutToExclusion(renderableBlock, context);
}
},
assignLayout: function assignLayout(renderableBlock, context) {
var element = renderableBlock.element;
var layout = renderableBlock.layout;
if (element && layout) {
var style = element.style;
style.msGridRow = layout.row;
style.msGridRowSpan = layout.rowSpan;
this.setRowAlign(element, layout.rowAlign);
style.msGridColumn = layout.column;
style.msGridColumnSpan = layout.columnSpan;
style.msGridColumnAlign = layout.columnAlign;
style.height = layout.height + "px";
style.width = layout.width + "px";
style.zIndex = layout.zIndex;
style.marginTop = layout.top + "px";
style.marginBottom = layout.bottom + "px";
style.marginLeft = layout.left + "px";
style.marginRight = layout.right + "px";
element.setAttribute("data-block-visibility", layout.visibility);
this._convertLayoutToExclusion(renderableBlock, context);
}
},
compressHints: function compressHints(hints) {
var blockLayouts = hints.blockLayouts;
var compressedLayouts = [];
for (var i = 0, len = blockLayouts.length; i < len; i++) {
var layout = blockLayouts[i];
var compressedLayout = [
layout.row,
layout.rowSpan,
this._convertGridAlignToInt(layout.rowAlign),
layout.column,
layout.columnSpan,
this._convertGridAlignToInt(layout.columnAlign),
layout.height,
layout.width,
layout.zIndex,
layout.top,
layout.bottom,
layout.left,
layout.right,
this._convertVisibilityToInt(layout.visibility),
];
compressedLayouts.push(compressedLayout);
}
var compressedHints = [
hints.pageCount,
compressedLayouts,
];
return compressedHints;
},
expandHints: function expandHints(compressedHints) {
var pageCount = compressedHints[0];
var compressedLayouts = compressedHints[1];
var blockLayouts = [];
for (var i = 0, len = compressedLayouts.length; i < len; i++) {
var compressedLayout = compressedLayouts[i];
var layout = {
row: compressedLayout[0],
rowSpan: compressedLayout[1],
rowAlign: this._convertIntToGridAlign(compressedLayout[2]),
column: compressedLayout[3],
columnSpan: compressedLayout[4],
columnAlign: this._convertIntToGridAlign(compressedLayout[5]),
height: compressedLayout[6],
width: compressedLayout[7],
zIndex: compressedLayout[8],
top: compressedLayout[9],
bottom: compressedLayout[10],
left: compressedLayout[11],
right: compressedLayout[12],
visibility: this._convertIntToVisibility(compressedLayout[13]),
};
blockLayouts.push(layout);
}
var hints = {
pageCount: pageCount,
blockLayouts: blockLayouts,
};
return hints;
},
assignExclusion: function assignExclusion(renderableBlock, context) {
var element = renderableBlock.element;
var exclusion = renderableBlock.exclusion;
if (element && exclusion) {
var gridOptions = context.gridOptions;
var columnCount = gridOptions.columnCount;
var columnWidth = gridOptions.columnWidth;
var columnSpan = exclusion.columnSpan;
var gridRowAlign = exclusion.rowAlign;
var gridColumn = CommonJS.ArticleReader.ArticleReaderUtils.convertColumnIndexToGridColumn(exclusion.column, columnCount);
var gridColumnSpan = columnSpan * 2 - 1;
var style = element.style;
style.msGridRow = 2;
style.msGridRowSpan = 2;
this.setRowAlign(element, gridRowAlign);
style.msGridColumn = gridColumn;
style.msGridColumnSpan = gridColumnSpan;
style.marginTop = "";
style.marginBottom = "";
style.height = "";
style.width = "";
}
},
resetLayout: function resetLayout(renderableBlock, context) {
/// <summary>
/// Resets the layout property of the given renderable block, and also resets its exclusion.
/// </summary>
renderableBlock.layout = null;
renderableBlock.exclusion = null;
var element = renderableBlock.element;
element.style.width = "";
element.style.height = "";
},
setStyles: function setStyles(elt, styles) {
var style = elt.style;
for (var k in styles) {
style[k] = styles[k];
}
},
stack: function stack(elements, column, columnSpan, context, isUsingEntireColumn, isUsingGridColumns, marginTop) {
// isUsingEntireColumn: boolean that specifies whether we're starting from the top of the column (row 1) or where content should start (row 2)
// isUsingGridColumns: boolean that specifies whether we're using the input column/columnSpan as their raw ms-grid equivalents
// marginTop: int that specifies the top value to start the stacking at
var gridOptions = context.gridOptions;
var columnCount = gridOptions.columnCount;
var row = isUsingEntireColumn ? 1 : 2;
var rowSpan = isUsingEntireColumn ? 4 : 2;
var gridColumnSpan = isUsingGridColumns ? columnSpan : this.convertColumnSpanToGridColumnSpan(columnSpan);
var gridColumn = isUsingGridColumns ? column : this.convertColumnIndexToGridColumn(column, columnCount);
var top = marginTop;
for (var i = 0, len = elements.length; i < len; i++) {
var element = elements[i];
var style = element.style;
style.msGridRow = row;
style.msGridRowSpan = rowSpan;
this.setRowAlign(element, "start");
style.msGridColumn = gridColumn;
style.msGridColumnSpan = gridColumnSpan;
style.zIndex = 2;
style.marginTop = top + "px";
element.setAttribute("data-block-visibility", "shown");
CommonJS.ArticleReader.ArticleReaderUtils.setFixedElementHeight(element);
top = top + element.offsetHeight;
}
return top;
},
place: function place(element, column, columnSpan, rowAlign, context) {
var gridOptions = context.gridOptions;
var columnCount = gridOptions.columnCount;
var gridColumnSpan = this.convertColumnSpanToGridColumnSpan(columnSpan);
var gridColumn = this.convertColumnIndexToGridColumn(column, columnCount);
this.placeInGrid(element, gridColumn, gridColumnSpan, "", 2, 2, rowAlign);
},
placeInGrid: function placeInGrid(element, gridColumn, gridColumnSpan, gridColumnAlign, gridRow, gridRowSpan, gridRowAlign) {
var style = element.style;
style.msGridRow = gridRow;
style.msGridRowSpan = gridRowSpan;
this.setRowAlign(element, gridRowAlign);
style.msGridColumn = gridColumn;
style.msGridColumnSpan = gridColumnSpan;
style.msGridColumnAlign = gridColumnAlign;
style.zIndex = 2;
element.setAttribute("data-block-visibility", "shown");
CommonJS.ArticleReader.ArticleReaderUtils.setFixedElementHeight(element);
},
setRowAlign: function setRowAlign(element, rowAlign) {
element.style.msGridRowAlign = rowAlign;
element.setAttribute("data-location", rowAlign);
},
convertColumnSpanToGridColumnSpan: function convertColumnSpanToGridColumnSpan(columnSpan) {
var gridColumnSpan = columnSpan * 2 - 1;
return gridColumnSpan;
},
isTitleBlock: function isTitleBlock(renderableBlock) {
var isTitle = renderableBlock.position === -1;
return isTitle;
},
createLayoutProperties: function createLayoutProperties(width, height, textAttributes, inlineAdCount) {
var resolutionKey = width + "_" + height;
var textAttributesKey = textAttributes ? this._createTextAttributesKey(textAttributes) : null;
var layoutProperties = {};
if (resolutionKey) {
layoutProperties.r = resolutionKey;
}
if (textAttributesKey) {
layoutProperties.t = textAttributesKey;
}
layoutProperties.i = inlineAdCount + "";
return layoutProperties;
},
getLayoutByProperties: function getLayoutByProperties(layouts, layoutProperties) {
/// <summary>
/// Returns the layout that best matches the given properties. Null if no layout matches.
/// </summary>
function contains(p1, p2) {
/// <summary>
/// Returns true if p1 contains all values of p2
/// </summary>
var contains = false;
if (p1 && p2) {
contains = true;
for (var k in p2) {
if (p1[k] !== p2[k]) {
contains = false;
break;
}
}
}
else if (!p2) {
contains = true;
}
return contains;
};
var layout = null;
if (layouts && layouts.length) {
for (var i = 0, len = layouts.length; i < len; i++) {
var l = layouts[i];
var p = l.properties;
if (contains(p, layoutProperties)) {
layout = l;
break;
}
}
}
return layout;
},
doTextAttributesMatch: function doTextAttributesMatch(layoutProperties, textAttributes) {
var key = this._createTextAttributesKey(textAttributes);
var match = (layoutProperties.t === key);
return match;
},
doExclusionsOverlap: function doExclusionsOverlap(ex1, ex2, gridOptions) {
var columnHeight = gridOptions.columnHeight;
var overlap =
(ex1.height && ex2.height && (ex1.rowAlign === ex2.rowAlign) && (ex1.column < ex2.column + ex2.columnSpan) && (ex2.column < ex1.column + ex1.columnSpan)) ||
(ex1.height && ex2.height && (ex1.rowAlign !== ex2.rowAlign) && (ex1.column < ex2.column + ex2.columnSpan) && (ex2.column < ex1.column + ex1.columnSpan) && (ex1.height + ex2.height > columnHeight));
return overlap;
},
convertDateToString: function convertDateToString(date) {
/// <summary>
/// Given an article date which could be either a string or a Model.DateDescriptor object, returns a user-friendly date string such as "Sunday, March 3, 2013"
/// </summary>
var str = "";
if (date) {
if (typeof (date) === "string") {
str = date;
}
else if (date.utctime) {
str = AppEx.Common.ArticleReader.DateFormatter.formatDate(date.utctime);
}
}
return str;
},
getEffectiveDate: function getEffectiveDate(title) {
/// <summary>
/// Given the title node of an article, returns the effective date, which is title.lastUpdatedDate if it exists, and title.date if not.
/// </summary>
var date = title.date;
var lastUpdatedDate = title.lastUpdatedDate;
var effectiveDate = lastUpdatedDate || date || null;
return effectiveDate;
},
logUserAction: function logUserAction(actionContext, element) {
T.FlightRecorder.logUserAction(
T.LogLevel.normal,
actionContext,
element,
T.UserActionOperation.click,
T.UserActionMethod.unknown,
0);
},
getColumnLimits: function getColumnLimits(context, index, excludedRenderableBlocks) {
/// <summary>
/// Returns the number of occupied pixels at the top and bottom of the indexth column, without taking the list of excludedRenderableBlocks into account.
/// </summary>
var gridOptions = context.gridOptions;
var columnCount = gridOptions.columnCount;
var renderData = context.renderData;
var renderableBlocks = renderData.renderableBlocks;
var top = 0;
var bottom = 0;
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
var blockElement = renderableBlock.element;
var isHidden = (blockElement.getAttribute("data-block-visibility") === "hidden");
var isExcluded = (excludedRenderableBlocks.indexOf(renderableBlock) > -1);
var isOnColumn = CommonJS.ArticleReader.ArticleReaderUtils.isElementOnColumn(blockElement, index, columnCount);
if (!isExcluded && !isHidden && isOnColumn) {
var blockHeight = WinJS.Utilities.getTotalHeight(blockElement);
var blockAlign = blockElement.currentStyle.msGridRowAlign;
if (blockAlign === "start") {
top = Math.max(top, blockHeight);
}
else if (blockAlign === "end") {
bottom = Math.max(bottom, blockHeight);
}
}
}
var limits = {
top: top,
bottom: bottom,
};
return limits;
},
convertEntryPointEnum: function convertEntryPointEnum(code) {
var entryPoint;
switch (code) {
case 0: entryPoint = "Today Pano"; break;
case 1: entryPoint = "Partner Pano"; break;
case 2: entryPoint = "Category"; break;
case undefined:
case null: entryPoint = "Unspecified"; break;
default: entryPoint = code; break;
}
return entryPoint;
},
convertSourceEnum: function convertSourceEnum(code) {
var source;
switch (code) {
case 0: source = "Hero"; break;
case 1: source = "Cluster"; break;
case 2: source = "Protocol"; break;
case 3: source = "Scroll-Swipe-Keyboard"; break;
case 4: source = "Previous-Next"; break;
case undefined:
case null: source = "Unspecified"; break;
default: source = code; break;
}
return source;
},
_convertVisibilityToInt: function _convertVisibilityToInt(visibility) {
var int = -1;
switch (visibility) {
case "hidden": int = 0; break;
case "shown": int = 1; break;
}
return int;
},
_convertIntToVisibility: function _convertIntToVisibility(int) {
var visibility = "";
switch (int) {
case 0: visibility = "hidden"; break;
case 1: visibility = "shown"; break;
}
return visibility;
},
_convertGridAlignToInt: function _convertGridAlignToInt(gridAlign) {
var int = -1;
switch (gridAlign) {
case "start": int = 0; break;
case "end": int = 1; break;
case "center": int = 2; break;
case "stretch": int = 3; break;
}
return int;
},
_convertIntToGridAlign: function _convertIntToGridAlign(int) {
var gridAlign = "";
switch (int) {
case 0: gridAlign = "start"; break;
case 1: gridAlign = "end"; break;
case 2: gridAlign = "center"; break;
case 3: gridAlign = "stretch"; break;
}
return gridAlign;
},
_getExclusion: function _getExclusion(startColumn, columns, heightForColumns, rowAlign, exclusions, gridOptions) {
var exclusion = {
column: startColumn,
columnSpan: columns,
rowAlign: rowAlign,
height: heightForColumns,
};
var overlap = false;
for (var i = 0, len = exclusions.length; i < len; i++) {
var testExclusion = exclusions[i];
overlap = overlap || this.doExclusionsOverlap(testExclusion, exclusion, gridOptions);
if (overlap) {
break;
}
}
return overlap ? null : exclusion;
},
_createTextAttributesKey: function _createTextAttributesKey(textAttributes) {
var key = textAttributes.style + "_" + textAttributes.size;
return key;
},
_convertGridColumnToColumnIndex: function _convertGridColumnToColumnIndex(gridColumn, columnCount) {
return (gridColumn - 2 - (Math.floor(gridColumn / (columnCount * 2 + 1)))) / 2;
},
_isColumnInRange: function _isColumnInRange(rangeStart, rangeSpan, columnIndex) {
return (columnIndex >= rangeStart && columnIndex < rangeStart + rangeSpan);
},
_convertGridColumnSpanToColumnSpan: function _convertGridColumnSpanToColumnSpan(gridColumnSpan) {
var columnSpan = (gridColumnSpan + 1) / 2;
return columnSpan;
},
_convertLayoutToExclusion: function _convertLayoutToExclusion(renderableBlock, context) {
/// <summary>
/// For renderableBlock, takes its layout property and updates its exclusion based on the layout.
/// </summary>
var gridOptions = context.gridOptions;
var layout = renderableBlock.layout;
var exclusion = this._getExclusionFromLayout(layout, gridOptions);
renderableBlock.exclusion = exclusion;
},
_getExclusionFromLayout: function _getExclusionFromLayout(layout, gridOptions) {
// TODO: Must fix this to account for layout values that are not on the "media block" grid, such as anchor bar
var exclusion = null;
if (layout) {
var columnCount = gridOptions.columnCount;
var exclusionColumn = this._convertGridColumnToColumnIndex(parseInt(layout.column) || 1, columnCount);
var exclusionColumnSpan = this._convertGridColumnSpanToColumnSpan(parseInt(layout.columnSpan) || 1);
exclusion = {
column: exclusionColumn,
columnSpan: exclusionColumnSpan,
rowAlign: layout.rowAlign,
height: layout.height + layout.top + layout.bottom,
};
}
return exclusion;
},
},
});
})();
/* File: TitleBlocks.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
WinJS.Namespace.define("CommonJS.ArticleReader", {
TextRenderer: {
render: function render(renderableBlock, context) {
/// <summary>
/// Renders a block of text
/// </summary>
var block = renderableBlock.block;
var attributes = block.attributes;
var text = attributes.text;
var textClassName = attributes.textClassName;
var textStyles = attributes.textStyles;
var textBlockElt = document.createElement("div");
WinJS.Utilities.addClass(textBlockElt, "textBlock exclusion");
var textElt = document.createElement("div");
WinJS.Utilities.addClass(textElt, "text");
textBlockElt.appendChild(textElt);
// set text
textElt.innerText = text;
// set text class name
if (textClassName) {
WinJS.Utilities.addClass(textElt, textClassName);
}
// set other styles
CommonJS.ArticleReader.ArticleReaderUtils.setStyles(textElt, textStyles);
return textBlockElt;
},
},
NullRenderer: {
/// <summary>
/// Renders nothing, for forward compat
/// </summary>
render: function render(renderableBlock, context) {
var elt = document.createElement("div");
elt.style.display = "none";
return elt;
}
},
RectRenderer: {
/// <summary>
/// Renders a rectangle
/// </summary>
render: function render(renderableBlock, context) {
var block = renderableBlock.block;
var attributes = block.attributes;
var blockClassName = attributes.blockClassName;
var rectClassName = attributes.rectClassName;
var rectStyles = attributes.rectStyles;
var rectBlockElt = document.createElement("div");
WinJS.Utilities.addClass(rectBlockElt, "rectBlock exclusion");
rectBlockElt.setAttribute("data-block-hasheight", "true");
var rectElt = document.createElement("div");
WinJS.Utilities.addClass(rectElt, "rect");
rectBlockElt.appendChild(rectElt);
// set block class name
if (blockClassName) {
WinJS.Utilities.addClass(rectBlockElt, blockClassName);
}
// set rect class name
if (rectClassName) {
WinJS.Utilities.addClass(rectElt, rectClassName);
}
// set other styles
CommonJS.ArticleReader.ArticleReaderUtils.setStyles(rectElt, rectStyles);
return rectBlockElt;
},
},
ImageRenderer: {
render: function render(renderableBlock, context) {
/// <summary>
/// Renders an image
/// </summary>
var auxiliaryData = context.auxiliaryData;
var block = renderableBlock.block;
var attributes = block.attributes;
var altText = attributes.altText;
var attribution = attributes.attribution;
var isSlideshowTarget = attributes.isSlideshowTarget;
var cacheId = attributes.cacheId;
var placeholder = attributes.placeholder;
var highResUrl = attributes.highResUrl;
var lowResUrl = attributes.lowResUrl;
var imageContainerClassName = attributes.imageContainerClassName;
var imageStyles = attributes.imageStyles;
var imageBlockElt = document.createElement("div");
WinJS.Utilities.addClass(imageBlockElt, "imageBlock exclusion");
imageBlockElt.setAttribute("data-block-hasheight", "true");
var imageContainerElt = document.createElement("div");
WinJS.Utilities.addClass(imageContainerElt, "imageContainer");
if (imageContainerClassName) {
WinJS.Utilities.addClass(imageContainerElt, imageContainerClassName);
}
imageBlockElt.appendChild(imageContainerElt);
var imageElt = document.createElement("div");
WinJS.Utilities.addClass(imageElt, "image");
// create image card
var imageSource;
if (lowResUrl) {
imageSource = {
lowResolutionUrl: lowResUrl,
highResolutionUrl: highResUrl,
cacheId: cacheId,
};
}
else {
imageSource = {
url: highResUrl,
cacheId: cacheId,
};
}
var options = {
alternateText: altText,
imageSource: imageSource,
classification: placeholder,
};
var imageCard = new CommonJS.ImageCard(imageElt, options);
// set other styles
CommonJS.ArticleReader.ArticleReaderUtils.setStyles(imageElt, imageStyles);
// create (i) attribution 
if (attribution) {
var attributionElt = document.createElement("div");
WinJS.Utilities.addClass(attributionElt, "attribution");
imageContainerElt.appendChild(attributionElt);
new CommonJS.ImageAttribution(attributionElt, {
flyout: {
label: attribution,
placement: "top",
alignment: (window.getComputedStyle(document.body).direction === "rtl") ? "left" : "right"
}
});
// stop the event propagation on attribution clicks
attributionElt.addEventListener("click", function (event) {
event.stopPropagation();
});
}
// create target navigation anchor
if (isSlideshowTarget) {
var slideshowData = auxiliaryData.slideshowData;
var anchorElt = document.createElement("a");
WinJS.Utilities.addClass(anchorElt, "anchor");
var target = CommonJS.ArticleReader.ArticleReaderUtils.launchSlideshow.bind(CommonJS.ArticleReader.ArticleReaderUtils, slideshowData, 0, cacheId);
anchorElt.onclick = target;
anchorElt.href = "#";
imageContainerElt.appendChild(anchorElt);
anchorElt.appendChild(imageElt);
}
else {
imageContainerElt.appendChild(imageElt);
}
return imageBlockElt;
},
},
});
})();
/* File: TitleStyle1Renderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Renders title style 1
WinJS.Namespace.define("CommonJS.ArticleReader", {
TitleStyle1Renderer: {
render: function render(renderableTitle, context) {
var auxiliaryData = context.auxiliaryData;
var cacheId = auxiliaryData.cacheId;
var gridOptions = context.gridOptions;
var columnWidth = gridOptions.columnWidth;
// create blocks
var authorBlock = {
type: "Text",
attributes: {
text: renderableTitle.author,
textClassName: "authorText",
}
};
var dateBlock = {
type: "Text",
attributes: {
text: renderableTitle.date,
textClassName: "dateText",
}
};
var kickerBlock = {
type: "Text",
attributes: {
text: renderableTitle.kicker,
textClassName: "kickerText",
}
};
var headlineBlock = {
type: "Text",
attributes: {
text: renderableTitle.headline,
textClassName: "headlineText",
}
};
var anchorBarBlock = {
type: "Rect",
attributes: {
rectClassName: "anchorBar",
blockClassName: "anchorBarBlock",
}
};
var columnBlockerBlock = {
type: "Rect",
attributes: {
rectClassName: "columnBlockerBlock",
}
};
// source logo image
var sourceLogoBlock = null;
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var publisher = renderableTitle.publisher;
var name = publisher.name;
var favicon = publisher.favicon;
var url = favicon.url;
sourceLogoBlock = {
type: "Image",
attributes: {
altText: name,
placeholder: "hidden",
cacheId: cacheId,
highResUrl: url,
lowResUrl: null,
imageContainerClassName: "sourceLogo",
}
};
}
// add to blocks array
var blocks = {};
blocks["author"] = authorBlock;
blocks["date"] = dateBlock;
blocks["kicker"] = kickerBlock;
blocks["headline"] = headlineBlock;
blocks["anchorBar"] = anchorBarBlock;
if (sourceLogoBlock) {
blocks["sourceLogo"] = sourceLogoBlock;
}
blocks["columnBlocker"] = columnBlockerBlock;
return blocks;
},
layout: function layout(titleRenderableBlocks, context) {
var gridOptions = context.gridOptions;
var columnCount = gridOptions.columnCount;
var columnWidth = gridOptions.columnWidth;
var renderData = context.renderData;
var renderableTitle = renderData.renderableTitle;
var author = titleRenderableBlocks["author"].element;
var date = titleRenderableBlocks["date"].element;
var kicker = titleRenderableBlocks["kicker"].element;
var headline = titleRenderableBlocks["headline"].element;
var columnBlocker = titleRenderableBlocks["columnBlocker"].element;
// stack some of the elements
var column = 0;
var columnSpan = Math.min(2, columnCount);
var elements = [author, date, kicker, headline];
CommonJS.ArticleReader.ArticleReaderUtils.stack(elements, column, columnSpan, context, false, false, 0);
// place the anchor bar
var anchorBar = titleRenderableBlocks["anchorBar"].element;
var gridColumnSpan = CommonJS.ArticleReader.ArticleReaderUtils.convertColumnSpanToGridColumnSpan(columnSpan);
CommonJS.ArticleReader.ArticleReaderUtils.placeInGrid(anchorBar, 2, gridColumnSpan, "", 1, 1, "start");
// place the source logo
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var sourceLogo = titleRenderableBlocks["sourceLogo"].element;
var publisher = renderableTitle.publisher;
var favicon = publisher.favicon;
var width = favicon.width;
var height = favicon.height;
var effectiveHeight = Math.min(height, 30);
var effectiveWidth = Math.min(effectiveHeight * width / height, columnWidth);
CommonJS.ArticleReader.ArticleReaderUtils.place(sourceLogo, 0, 1, "end", context);
sourceLogo.style.height = effectiveHeight + "px";
sourceLogo.style.width = effectiveWidth + "px";
// handle column blocker
// the column blocker will be put where the source image is but span the entire width of the column span in order to block text from flowing there
columnBlocker.setAttribute("data-block-visibility", "shown");
columnBlocker.style.height = effectiveHeight + 20 + "px";
CommonJS.ArticleReader.ArticleReaderUtils.place(columnBlocker, 0, 1, "end", context);
}
else {
// handle column blocker
columnBlocker.setAttribute("data-block-visibility", "hidden");
}
},
}
});
})();
/* File: TitleStyle2Renderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Renders title style 2 - landscape image
WinJS.Namespace.define("CommonJS.ArticleReader", {
TitleStyle2Renderer: {
render: function render(renderableTitle, context) {
var auxiliaryData = context.auxiliaryData;
var cacheId = auxiliaryData.cacheId;
var gridOptions = context.gridOptions;
var columnWidth = gridOptions.columnWidth;
// create blocks
var authorBlock = {
type: "Text",
attributes: {
text: renderableTitle.author,
textClassName: "authorText",
}
};
var dateBlock = {
type: "Text",
attributes: {
text: renderableTitle.date,
textClassName: "dateText",
}
};
var kickerBlock = {
type: "Text",
attributes: {
text: renderableTitle.kicker,
textClassName: "kickerText",
}
};
var headlineBlock = {
type: "Text",
attributes: {
text: renderableTitle.headline,
textClassName: "headlineText2",
}
};
var anchorBarBlock = {
type: "Rect",
attributes: {
rectClassName: "anchorBar",
blockClassName: "anchorBarBlock",
}
};
var columnBlockerBlock = {
type: "Rect",
attributes: {
rectClassName: "columnBlockerBlock",
}
};
// source logo image
var sourceLogoBlock = null;
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var publisher = renderableTitle.publisher;
var name = publisher.name;
var favicon = publisher.favicon;
var url = favicon.url;
sourceLogoBlock = {
type: "Image",
attributes: {
altText: name,
placeholder: "hidden",
cacheId: cacheId,
highResUrl: url,
lowResUrl: null,
imageContainerClassName: "sourceLogo",
}
};
}
//titleImage block
var image = renderableTitle.titleImage.image;
var attribution = image.attribution || "";
var caption = image.caption || "";
var altText = image.altText || "";
var captionAndAttribution = CommonJS.ArticleReader.ArticleReaderUtils.combineCaptionAndAttribution(caption, attribution);
var originalImage = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(image);
var lowResImage = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(image, "lowRes");
var titleImageBlock = {
type: "Image",
attributes: {
altText: altText,
placeholder: "hidden",
cacheId: cacheId,
highResUrl: originalImage ? originalImage.url : null,
lowResUrl: lowResImage ? lowResImage.url : null,
imageContainerClassName: "titleImage",
attribution: captionAndAttribution,
isSlideshowTarget: true,
}
};
// add to blocks array
var blocks = {};
blocks["author"] = authorBlock;
blocks["date"] = dateBlock;
blocks["kicker"] = kickerBlock;
blocks["headline"] = headlineBlock;
blocks["anchorBar"] = anchorBarBlock;
if (sourceLogoBlock) {
blocks["sourceLogo"] = sourceLogoBlock;
}
blocks["titleImage"] = titleImageBlock;
blocks["columnBlocker"] = columnBlockerBlock;
return blocks;
},
layout: function layout(titleRenderableBlocks, context) {
var gridOptions = context.gridOptions;
if (this._isPortraitLayout(gridOptions)) {
this._calculateLayoutPortrait(titleRenderableBlocks, context);
}
else if (this._isBigLandscapeLayout(gridOptions)) {
this._calculateLayoutBigLandscape(titleRenderableBlocks, context);
}
else {
this._calculateLayoutLandscape(titleRenderableBlocks, context);
}
},
_calculateLayoutLandscape: function _calculateLayoutLandscape(titleRenderableBlocks, context) {
var gridOptions = context.gridOptions;
var columnWidth = gridOptions.columnWidth;
var columnHeight = gridOptions.columnHeight;
var columnMargin = gridOptions.columnMargin;
var columnCount = gridOptions.columnCount;
var renderData = context.renderData;
var renderableTitle = renderData.renderableTitle;
var author = titleRenderableBlocks["author"].element;
var date = titleRenderableBlocks["date"].element;
var kicker = titleRenderableBlocks["kicker"].element;
var headline = titleRenderableBlocks["headline"].element;
var titleImage = titleRenderableBlocks["titleImage"].element;
var columnBlocker = titleRenderableBlocks["columnBlocker"].element;
var anchorBar = titleRenderableBlocks["anchorBar"].element;
// handle image
var imageWidth = columnMargin + (2 * columnWidth);
var imageHeightAndFit = this._getImageHeightAndFit(context, imageWidth);
var imageHeight = imageHeightAndFit.height;
var titleImageStyle = titleImage.style;
titleImageStyle.width = imageWidth + "px";
titleImageStyle.height = imageHeight + "px";
// handle headline
headline.style.width = (columnMargin + (columnWidth * 1.66)) + "px";
// stack some of the elements
var column = 0;
var columnSpan = Math.min(2, columnCount);
var elements = [titleImage, kicker, headline];
CommonJS.ArticleReader.ArticleReaderUtils.stack(elements, column, columnSpan, context, true, false, 0);
// set z-index 
kicker.style.zIndex = 4;
headline.style.zIndex = 3;
titleImage.style.zIndex = 3;
// place the anchor bar
CommonJS.ArticleReader.ArticleReaderUtils.placeInGrid(anchorBar, 2, 3, "start", 4, 1, "end");
anchorBar.style.width = (columnMargin + (columnWidth * 1.5)) + "px";
// place source logo
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var sourceLogo = titleRenderableBlocks["sourceLogo"].element;
var publisher = renderableTitle.publisher;
var favicon = publisher.favicon;
var width = favicon.width;
var height = favicon.height;
var effectiveHeight = Math.min(height, 30);
var effectiveWidth = Math.min(effectiveHeight * width / height, columnWidth);
CommonJS.ArticleReader.ArticleReaderUtils.place(sourceLogo, 0, 1, "end", context);
sourceLogo.style.height = effectiveHeight + "px";
sourceLogo.style.width = effectiveWidth + "px";                  
}
// stack the author and date in other column
CommonJS.ArticleReader.ArticleReaderUtils.stack([author, date], 2, 1, context, false, false, 0);
// place column blocker
// the column blocker will block the area below the headline so that no text flows there
var columnBlockerStyle = columnBlocker.style;
columnBlockerStyle.height = columnHeight + "px";
columnBlocker.setAttribute("data-block-visibility", "shown");
CommonJS.ArticleReader.ArticleReaderUtils.place(columnBlocker, 0, 2, "start", context);
columnBlockerStyle.zIndex = 1;
},
_calculateLayoutBigLandscape: function _calculateLayoutBigLandscape(titleRenderableBlocks, context) {
var gridOptions = context.gridOptions;
var columnWidth = gridOptions.columnWidth;
var columnHeight = gridOptions.columnHeight;
var columnMargin = gridOptions.columnMargin;
var columnCount = gridOptions.columnCount;
var renderData = context.renderData;
var renderableTitle = renderData.renderableTitle;
var author = titleRenderableBlocks["author"].element;
var date = titleRenderableBlocks["date"].element;
var kicker = titleRenderableBlocks["kicker"].element;
var headline = titleRenderableBlocks["headline"].element;
var titleImage = titleRenderableBlocks["titleImage"].element;
var columnBlocker = titleRenderableBlocks["columnBlocker"].element;
var anchorBar = titleRenderableBlocks["anchorBar"].element;
// handle image
var imageWidth = columnMargin + (2 * columnWidth);
var imageHeightAndFit = this._getImageHeightAndFit(context, imageWidth);
var imageHeight = imageHeightAndFit.height;
var titleImageStyle = titleImage.style;
titleImageStyle.width = imageWidth + "px";
titleImageStyle.height = imageHeight + "px";
// stack some of the elements
var column = 0;
var columnSpan = Math.min(2, columnCount);
var elements = [titleImage, kicker, headline];
var top = CommonJS.ArticleReader.ArticleReaderUtils.stack(elements, column, columnSpan, context, true, false, 0);
// place author and date into only the first column
var elements2 = [author, date];
CommonJS.ArticleReader.ArticleReaderUtils.stack(elements2, column, 1, context, true, false, top);
// set z-index 
headline.style.zIndex = 3;
titleImage.style.zIndex = 3;
// place the anchor bar
CommonJS.ArticleReader.ArticleReaderUtils.placeInGrid(anchorBar, 2, 3, "start", 4, 1, "end");
anchorBar.style.width = (columnMargin + (columnWidth * 1.5)) + "px";
// place source logo
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var sourceLogo = titleRenderableBlocks["sourceLogo"].element;
var publisher = renderableTitle.publisher;
var favicon = publisher.favicon;
var width = favicon.width;
var height = favicon.height;
var effectiveHeight = Math.min(height, 30);
var effectiveWidth = Math.min(effectiveHeight * width / height, columnWidth);
sourceLogo.style.height = effectiveHeight + "px";
sourceLogo.style.width = effectiveWidth + "px";
CommonJS.ArticleReader.ArticleReaderUtils.place(sourceLogo, 0, 1, "end", context);
// handle column blocker
// the column blocker will be put where the source image is but span the entire width of the column span in order to block text from flowing there
columnBlocker.setAttribute("data-block-visibility", "shown");
columnBlocker.style.height = effectiveHeight + 20 + "px";
CommonJS.ArticleReader.ArticleReaderUtils.place(columnBlocker, 0, 1, "end", context);
}
else {
// handle column blocker
columnBlocker.setAttribute("data-block-visibility", "hidden");
}
},
_calculateLayoutPortrait: function _calculateLayoutPortrait(titleRenderableBlocks, context) {
var gridOptions = context.gridOptions;
var columnWidth = gridOptions.columnWidth;
var columnHeight = gridOptions.columnHeight;
var columnMargin = gridOptions.columnMargin;
var columnCount = gridOptions.columnCount;
var leftMargin = gridOptions.leftMargin;
var rightMargin = gridOptions.rightMargin;
var renderData = context.renderData;
var renderableTitle = renderData.renderableTitle;
var author = titleRenderableBlocks["author"].element;
var date = titleRenderableBlocks["date"].element;
var kicker = titleRenderableBlocks["kicker"].element;
var headline = titleRenderableBlocks["headline"].element;
var titleImage = titleRenderableBlocks["titleImage"].element;
// handle image
var imageWidth = leftMargin + (columnCount * columnWidth) + ((columnCount - 1) * columnMargin) + rightMargin;
var imageHeightAndFit = this._getImageHeightAndFit(context, imageWidth);
var imageHeight = imageHeightAndFit.height;
var titleImageStyle = titleImage.style;
titleImageStyle.width = imageWidth + "px";
titleImageStyle.height = imageHeight + "px";
// stack some of the elements
var column = 0;
var columnSpan = Math.min(columnCount * 2 + 1, columnCount);
var elements = [titleImage, kicker, headline, author, date];
CommonJS.ArticleReader.ArticleReaderUtils.stack(elements, column, columnSpan, context, true, false, 0);
titleImage.style.msGridColumn = 1;
titleImage.style.msGridColumnSpan = columnCount * 2 + 1;
// set z-index 
headline.style.zIndex = 3;
titleImage.style.zIndex = 3;
// place the anchor bar
var anchorBar = titleRenderableBlocks["anchorBar"].element;
CommonJS.ArticleReader.ArticleReaderUtils.placeInGrid(anchorBar, 2, 1, "start", 4, 1, "end");
anchorBar.style.width = (columnMargin + columnWidth) + "px";
// place source logo
var columnBlocker = titleRenderableBlocks["columnBlocker"].element;
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var sourceLogo = titleRenderableBlocks["sourceLogo"].element;
var publisher = renderableTitle.publisher;
var favicon = publisher.favicon;
var width = favicon.width;
var height = favicon.height;
var effectiveHeight = Math.min(height, 30);
var effectiveWidth = Math.min(effectiveHeight * width / height, columnWidth);
sourceLogo.style.height = effectiveHeight + "px";
sourceLogo.style.width = effectiveWidth + "px";
CommonJS.ArticleReader.ArticleReaderUtils.place(sourceLogo, 0, 1, "end", context);
// handle column blocker
// the column blocker will be put where the source image is but span the entire width of the column span in order to block text from flowing there
columnBlocker.setAttribute("data-block-visibility", "shown");
columnBlocker.style.height = effectiveHeight + 20 + "px";
CommonJS.ArticleReader.ArticleReaderUtils.place(columnBlocker, 0, 1, "end", context);
}
else {
// handle column blocker
columnBlocker.setAttribute("data-block-visibility", "hidden");
}
},
_isPortraitLayout: function _isPortraitLayout(gridOptions) {
var isPortraitLayout = gridOptions.pageWidth < gridOptions.pageHeight;
return isPortraitLayout;
},
_isBigLandscapeLayout: function _isBigLandscapeLayout(gridOptions) {
var isBigLandscapeLayout = !this._isPortraitLayout(gridOptions) && gridOptions.pageHeight >= 900;
return isBigLandscapeLayout;
},
_getImageHeightAndFit: function _getImageHeightAndFit(context, imageWidth) {
var renderData = context.renderData;
var titleBlock = renderData.renderableTitle;
var image = titleBlock.titleImage.image;
var imageResource = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(image);
var originalWidth = parseInt(imageResource.width);
var originalHeight = parseInt(imageResource.height);
var imageHeight = imageWidth * originalHeight / originalWidth;
var aspectRatio = imageWidth / imageHeight;
var imageFit = "both";
if (aspectRatio < 1.62) {
imageFit = "width";
imageHeight = imageWidth / 1.62;
}
else if (aspectRatio > 1.62) {
imageFit = "height";
imageHeight = imageWidth / 1.62;
}
return {
height: imageHeight,
fit: imageFit,
};
},
}
});
})();
/* File: TitleStyle9Renderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Renders title style 9 - portrait image
WinJS.Namespace.define("CommonJS.ArticleReader", {
TitleStyle9Renderer: {
render: function render(renderableTitle, context) {
var auxiliaryData = context.auxiliaryData;
var cacheId = auxiliaryData.cacheId;
var gridOptions = context.gridOptions;
var columnWidth = gridOptions.columnWidth;
// create blocks
var authorBlock = {
type: "Text",
attributes: {
text: renderableTitle.author,
textClassName: "authorText",
}
};
var dateBlock = {
type: "Text",
attributes: {
text: renderableTitle.date,
textClassName: "dateText",
}
};
var kickerBlock = {
type: "Text",
attributes: {
text: renderableTitle.kicker,
textClassName: "kickerText",
}
};
var headlineBlock = {
type: "Text",
attributes: {
text: renderableTitle.headline,
textClassName: "headlineText",
}
};
var anchorBarBlock = {
type: "Rect",
attributes: {
rectClassName: "anchorBar",
blockClassName: "anchorBarBlock",
}
};
var columnBlockerBlock = {
type: "Rect",
attributes: {
rectClassName: "columnBlockerBlock",
}
};
var columnBlockerBlock2 = {
type: "Rect",
attributes: {
rectClassName: "columnBlockerBlock",
}
};
// source logo image
var sourceLogoBlock = null;
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var publisher = renderableTitle.publisher;
var name = publisher.name;
var favicon = publisher.favicon;
var url = favicon.url;
sourceLogoBlock = {
type: "Image",
attributes: {
altText: name,
placeholder: "hidden",
cacheId: cacheId,
highResUrl: url,
lowResUrl: null,
imageContainerClassName: "sourceLogo",
}
};
}
//titleImage block
var image = renderableTitle.titleImage.image;
var attribution = image.attribution || "";
var caption = image.caption || "";
var altText = image.altText || "";
var captionAndAttribution = CommonJS.ArticleReader.ArticleReaderUtils.combineCaptionAndAttribution(caption, attribution);
var originalImage = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(image);
var lowResImage = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(image, "lowRes");
var titleImageBlock = {
type: "Image",
attributes: {
altText: altText,
placeholder: "hidden",
cacheId: cacheId,
highResUrl: originalImage ? originalImage.url : null,
lowResUrl: lowResImage ? lowResImage.url : null,
imageContainerClassName: "titleImage",
attribution: captionAndAttribution,
isSlideshowTarget: true,
}
};
// add to blocks array
var blocks = {};
blocks["author"] = authorBlock;
blocks["date"] = dateBlock;
blocks["kicker"] = kickerBlock;
blocks["headline"] = headlineBlock;
blocks["anchorBar"] = anchorBarBlock;
if (sourceLogoBlock) {
blocks["sourceLogo"] = sourceLogoBlock;
}
blocks["titleImage"] = titleImageBlock;
blocks["columnBlocker"] = columnBlockerBlock;
blocks["columnBlocker2"] = columnBlockerBlock2;
return blocks;
},
layout: function layout(titleRenderableBlocks, context) {
var gridOptions = context.gridOptions;
if (this._isPortraitLayout(gridOptions)) {
this._calculateLayoutPortrait(titleRenderableBlocks, context);
}
else {
this._calculateLayoutLandscape(titleRenderableBlocks, context);
}
},
_isPortraitLayout: function _isPortraitLayout(gridOptions) {
var isPortraitLayout = gridOptions.pageWidth < gridOptions.pageHeight;
return isPortraitLayout;
},
_calculateLayoutPortrait: function _calculateLayoutPortrait(titleRenderableBlocks, context) {
var gridOptions = context.gridOptions;
var columnWidth = gridOptions.columnWidth;
var columnHeight = gridOptions.columnHeight;
var columnMargin = gridOptions.columnMargin;
var columnCount = gridOptions.columnCount;
var leftMargin = gridOptions.leftMargin;
var topMargin = gridOptions.topMargin;
var bottomMargin = gridOptions.bottomMargin;
var renderData = context.renderData;
var renderableTitle = renderData.renderableTitle;
var author = titleRenderableBlocks["author"].element;
var date = titleRenderableBlocks["date"].element;
var kicker = titleRenderableBlocks["kicker"].element;
var headline = titleRenderableBlocks["headline"].element;
var titleImage = titleRenderableBlocks["titleImage"].element;
var columnBlocker = titleRenderableBlocks["columnBlocker"].element;
var columnBlocker2 = titleRenderableBlocks["columnBlocker2"].element;
var anchorBar = titleRenderableBlocks["anchorBar"].element;
// stack some of the elements
var column = 0;
var columnSpan = Math.min(3, columnCount); // cap at 3
var elements = [author, date, kicker, headline];
CommonJS.ArticleReader.ArticleReaderUtils.stack(elements, column, columnSpan, context, false, false, 0);
// place anchor bar
CommonJS.ArticleReader.ArticleReaderUtils.placeInGrid(anchorBar, 2, columnSpan * 2 - 1, "", 1, 1, "start");
// handle image
var imageWidth = leftMargin + (columnWidth < 550 ? columnWidth : columnWidth * 0.5);
var imageHeightAndFit = this._getImageHeightAndFit(context, imageWidth, (2 / 3));
var imageHeight = imageHeightAndFit.height;
var titleImageStyle = titleImage.style;
titleImageStyle.width = imageWidth + "px";
titleImageStyle.height = imageHeight + "px";
var imageTopMargin = headline.offsetHeight + author.offsetHeight + kicker.offsetHeight + date.offsetHeight;
// set the height of the column blocker to what the margin on top of the picture should be in order to take up space
columnBlocker2.style.height = imageTopMargin + "px";
columnBlocker2.setAttribute("data-block-visibility", "shown");
// stack column blocker and picture
// the column blocker will go before the picture to take up space and act like a psuedo-top-margin
CommonJS.ArticleReader.ArticleReaderUtils.stack([columnBlocker2, titleImage], 1, 2, context, false, true, 0);
// set z-index to be behind the picture, and also adjust the width and height of the blocker to take into account of the margins that should surround the picture
columnBlocker2.style.zIndex = 1;
columnBlocker2.style.height = imageTopMargin + titleImage.offsetHeight + 20 + "px";
columnBlocker2.style.width = titleImage.offsetWidth + 20 + "px";
// place source logo
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var sourceLogo = titleRenderableBlocks["sourceLogo"].element;
var publisher = renderableTitle.publisher;
var favicon = publisher.favicon;
var width = favicon.width;
var height = favicon.height;
var effectiveHeight = Math.min(height, 30);
var effectiveWidth = Math.min(effectiveHeight * width / height, columnWidth);
CommonJS.ArticleReader.ArticleReaderUtils.place(sourceLogo, 0, 1, "end", context);
sourceLogo.style.height = effectiveHeight + "px";
sourceLogo.style.width = effectiveWidth + "px";
// place column blocker
// the column blocker will be put where the source image is but span the entire width of the column span in order to block text from flowing there
CommonJS.ArticleReader.ArticleReaderUtils.place(columnBlocker, 0, 1, "end", context);
columnBlocker.style.height = effectiveHeight + 20 + "px";
columnBlocker.setAttribute("data-block-visibility", "shown");
}
else {
// place column blocker
columnBlocker.setAttribute("data-block-visibility", "hidden");
}
},
_calculateLayoutLandscape: function _calculateLayoutLandscape(titleRenderableBlocks, context) {
var gridOptions = context.gridOptions;
var columnWidth = gridOptions.columnWidth;
var columnHeight = gridOptions.columnHeight;
var columnMargin = gridOptions.columnMargin;
var columnCount = gridOptions.columnCount;
var leftMargin = gridOptions.leftMargin;
var topMargin = gridOptions.topMargin;
var bottomMargin = gridOptions.bottomMargin;
var renderData = context.renderData;
var renderableTitle = renderData.renderableTitle;
var author = titleRenderableBlocks["author"].element;
var date = titleRenderableBlocks["date"].element;
var kicker = titleRenderableBlocks["kicker"].element;
var headline = titleRenderableBlocks["headline"].element;
var titleImage = titleRenderableBlocks["titleImage"].element;
var anchorBar = titleRenderableBlocks["anchorBar"].element;
var columnBlocker = titleRenderableBlocks["columnBlocker"].element;
var columnBlocker2 = titleRenderableBlocks["columnBlocker2"].element;
// handle image
var imageWidth = leftMargin + columnWidth;
var targetAspectRatio = Math.max((2 / 3) / 1.1, (imageWidth / (columnHeight + topMargin + bottomMargin))); // allow for 10% crop
var imageHeightAndFit = this._getImageHeightAndFit(context, imageWidth, targetAspectRatio);
var imageHeight = imageHeightAndFit.height;
var titleImageStyle = titleImage.style;
titleImageStyle.width = imageWidth + "px";
titleImageStyle.height = imageHeight + "px";
titleImageStyle.marginTop = "";
// handle column blocker that'll take up space below the picture in order to insure that no text flows below it
columnBlocker2.style.height = columnHeight + "px";
columnBlocker2.setAttribute("data-block-visibility", "shown");
// stack picture and column blocker
CommonJS.ArticleReader.ArticleReaderUtils.stack([titleImage, columnBlocker2], 1, 2, context, true, true, 0);
// stack some of the elements
var column = 1;
var columnSpan = Math.min(3, columnCount - 1); // cap at 3
var elements = [anchorBar, author, date, kicker, headline];
CommonJS.ArticleReader.ArticleReaderUtils.stack(elements, column, columnSpan, context, true, false, 0);
// set z-index 
headline.style.zIndex = 3;
titleImage.style.zIndex = 3;
// place source logo
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var sourceLogo = titleRenderableBlocks["sourceLogo"].element;
var publisher = renderableTitle.publisher;
var favicon = publisher.favicon;
var width = favicon.width;
var height = favicon.height;
var effectiveHeight = Math.min(height, 30);
var effectiveWidth = Math.min(effectiveHeight * width / height, columnWidth);
CommonJS.ArticleReader.ArticleReaderUtils.place(sourceLogo, 1, 1, "end", context);
sourceLogo.style.height = effectiveHeight + "px";
sourceLogo.style.width = effectiveWidth + "px";
// place column blocker
// the column blocker will be put where the source image is but span the entire width of the column span in order to block text from flowing there
CommonJS.ArticleReader.ArticleReaderUtils.place(columnBlocker, 1, 1, "end", context);
columnBlocker.style.height = effectiveHeight + 20 + "px";
columnBlocker.setAttribute("data-block-visibility", "shown");
}
else {
// place column blocker
columnBlocker.setAttribute("data-block-visibility", "hidden");
}
},
_getImageHeightAndFit: function _getImageHeightAndFit(context, imageWidth, targetAspectRatio) {
var renderData = context.renderData;
var titleBlock = renderData.renderableTitle;
var image = titleBlock.titleImage.image;
var imageResource = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(image);
var originalWidth = parseInt(imageResource.width);
var originalHeight = parseInt(imageResource.height);
var imageHeight = imageWidth * originalHeight / originalWidth;
var aspectRatio = imageWidth / imageHeight;
var imageFit = "both";
if (aspectRatio < targetAspectRatio) {
imageFit = "width";
imageHeight = imageWidth / targetAspectRatio;
}
else if (aspectRatio > targetAspectRatio) {
imageFit = "height";
imageHeight = imageWidth / targetAspectRatio;
}
return {
height: imageHeight,
fit: imageFit,
};
},
}
});
})();
/* File: TitleStyle100Renderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Renders title style 100
WinJS.Namespace.define("CommonJS.ArticleReader", {
TitleStyle100Renderer: {
render: function render(renderableTitle, context) {
var auxiliaryData = context.auxiliaryData;
var cacheId = auxiliaryData.cacheId;
var gridOptions = context.gridOptions;
var columnWidth = gridOptions.columnWidth;
// create blocks
var authorBlock = {
type: "Text",
attributes: {
text: renderableTitle.author,
textClassName: "authorText",
}
};
var dateBlock = {
type: "Text",
attributes: {
text: renderableTitle.date,
textClassName: "dateText",
}
};
var kickerBlock = {
type: "Text",
attributes: {
text: renderableTitle.kicker,
textClassName: "kickerText",
}
};
var headlineBlock = {
type: "Text",
attributes: {
text: renderableTitle.headline,
textClassName: "headlineText",
}
};
var anchorBarBlock = {
type: "Rect",
attributes: {
rectClassName: "anchorBar",
blockClassName: "anchorBarBlock",
}
};
var columnBlockerBlock = {
type: "Rect",
attributes: {
rectClassName: "columnBlockerBlock",
}
};
// source logo image
var sourceLogoBlock = null;
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var publisher = renderableTitle.publisher;
var name = publisher.name;
var favicon = publisher.favicon;
var url = favicon.url;
sourceLogoBlock = {
type: "Image",
attributes: {
altText: name,
placeholder: "hidden",
cacheId: cacheId,
highResUrl: url,
lowResUrl: null,
imageContainerClassName: "sourceLogo",
}
};
}
// add to blocks array
var blocks = {};
blocks["author"] = authorBlock;
blocks["date"] = dateBlock;
blocks["kicker"] = kickerBlock;
blocks["headline"] = headlineBlock;
blocks["anchorBar"] = anchorBarBlock;
if (sourceLogoBlock) {
blocks["sourceLogo"] = sourceLogoBlock;
}
blocks["columnBlocker"] = columnBlockerBlock;
return blocks;
},
layout: function layout(titleRenderableBlocks, context) {
var gridOptions = context.gridOptions;
var columnCount = gridOptions.columnCount;
var renderData = context.renderData;
var renderableTitle = renderData.renderableTitle;
var columnWidth = gridOptions.columnWidth;
var author = titleRenderableBlocks["author"].element;
var date = titleRenderableBlocks["date"].element;
var kicker = titleRenderableBlocks["kicker"].element;
var headline = titleRenderableBlocks["headline"].element;
var anchorBar = titleRenderableBlocks["anchorBar"].element;
var columnBlocker = titleRenderableBlocks["columnBlocker"].element;
// stack some of the elements
var column = 0;
var columnSpan = Math.min(2, columnCount);
var elements = [kicker, headline, author, date];
CommonJS.ArticleReader.ArticleReaderUtils.stack(elements, column, columnSpan, context, false, false, 0);
// place the anchor bar
var gridColumnSpan = CommonJS.ArticleReader.ArticleReaderUtils.convertColumnSpanToGridColumnSpan(columnSpan);
CommonJS.ArticleReader.ArticleReaderUtils.placeInGrid(anchorBar, 2, gridColumnSpan, "", 1, 1, "start");
var hasSourceLogo = CommonJS.ArticleReader.ArticleReaderUtils.hasSourceLogo(renderableTitle);
if (hasSourceLogo) {
var sourceLogo = titleRenderableBlocks["sourceLogo"].element;
var publisher = renderableTitle.publisher;
var favicon = publisher.favicon;
var width = favicon.width;
var height = favicon.height;
var effectiveHeight = Math.min(height, 30);
var effectiveWidth = Math.min(effectiveHeight * width / height, columnWidth);
CommonJS.ArticleReader.ArticleReaderUtils.place(sourceLogo, 0, 1, "end", context);
sourceLogo.style.height = effectiveHeight + "px";
sourceLogo.style.width = effectiveWidth + "px";
// handle column blocker
// the column blocker will be put where the source image is but span the entire width of the column span in order to block text from flowing there
columnBlocker.setAttribute("data-block-visibility", "shown");
columnBlocker.style.height = effectiveHeight + 20 + "px";
CommonJS.ArticleReader.ArticleReaderUtils.place(columnBlocker, 0, 1, "end", context);
}
else {
// handle column blocker
columnBlocker.setAttribute("data-block-visibility", "hidden");
}
},
}
});
})();
/* File: InlineRendererHelper.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
var maxCaptionFraction = 0.33; // wrt the column height
WinJS.Namespace.define("CommonJS.ArticleReader", {
InlineRendererHelper: {
render: function render(imageAttributes, context, icon, target) {
var gridOptions = context.gridOptions;
var columnHeight = gridOptions.columnHeight;
var auxiliaryData = context.auxiliaryData;
var cacheId = auxiliaryData.cacheId || "";
var attribution = imageAttributes.attribution || "";
var caption = imageAttributes.caption || "";
var altText = imageAttributes.altText || "";
var imageBlockElt = document.createElement("div");
WinJS.Utilities.addClass(imageBlockElt, "inlineImageBlock exclusion");
// image + description container
var inlineContainerElt = document.createElement("div");
WinJS.Utilities.addClass(inlineContainerElt, "inlineContainer");
imageBlockElt.appendChild(inlineContainerElt);
// image container (image + icon)
var imageContainerElt = document.createElement("div");
WinJS.Utilities.addClass(imageContainerElt, "imageContainer");
// anchor
if (target) {
var anchorElt = document.createElement("a");
WinJS.Utilities.addClass(anchorElt, "anchor");
if (typeof target === "string") {
// uri target
anchorElt.href = target;
}
else if (typeof target === "function") {
// function target
anchorElt.onclick = target;
anchorElt.href = "#";
}
anchorElt.appendChild(imageContainerElt);
inlineContainerElt.appendChild(anchorElt);
}
else {
inlineContainerElt.appendChild(imageContainerElt);
}
// image
var imageElt = document.createElement("div");
WinJS.Utilities.addClass(imageElt, "image fitHeight anchorMiddle");
imageContainerElt.appendChild(imageElt);
// icon
if (icon) {
var iconElt = document.createElement("div");
iconElt.className = "icon win-command";
WinJS.Utilities.addClass(iconElt, icon);
var iconRing = document.createElement("div");
iconRing.className = "iconRing win-commandring win-commandicon";
var iconImage = document.createElement("div");
iconImage.className = "iconImage win-commandimage";
iconRing.appendChild(iconImage);
iconElt.appendChild(iconRing);
imageContainerElt.appendChild(iconElt);
}
// description
var descriptionElt = document.createElement("div");
WinJS.Utilities.addClass(descriptionElt, "description");
inlineContainerElt.appendChild(descriptionElt);
// attribution
if (attribution) {
var attributionElt = document.createElement("span");
WinJS.Utilities.addClass(attributionElt, "attribution");
attributionElt.innerText = attribution;
descriptionElt.appendChild(attributionElt);
}
// caption
if (caption) {
var captionElt = document.createElement("span");
WinJS.Utilities.addClass(captionElt, "caption");
captionElt.innerText = caption;
descriptionElt.appendChild(captionElt);
}
var imageSource = CommonJS.ArticleReader.ArticleReaderUtils.getImageCardSource(imageAttributes, cacheId);
var imageCard = new CommonJS.ImageCard(imageElt, {
alternateText: " ",
classification: "medium",
imageSource: imageSource,
});
return imageBlockElt;
},
calculateLayout: function calculateLayout(renderableBlock, startColumn, gridOptions, exclusions) {
var block = renderableBlock.block;
var attributes = block.attributes;
var imageAttributes = attributes.image;
var columnHeight = gridOptions.columnHeight;
// get original image size from data
var imageResource = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(imageAttributes);
var resourceWidth = parseInt(imageResource.width);
var resourceHeight = parseInt(imageResource.height);
// max height based on column height
var maxHeight = Math.min((1 - maxCaptionFraction) * columnHeight, resourceHeight);
var maxWidth = maxHeight * resourceWidth / resourceHeight;
var minWidth = 1;
var estimatedMaxHeight = maxHeight + (maxCaptionFraction * columnHeight) + 20; // buffer 20, and add max caption height
var exclusion = CommonJS.ArticleReader.ArticleReaderUtils.getBestExclusion(startColumn, gridOptions, exclusions, maxWidth, estimatedMaxHeight, minWidth);
return exclusion;
},
applyLayout: function applyLayout(renderableBlock, aggregation, context) {
var gridOptions = context.gridOptions;
var exclusion = renderableBlock.exclusion;
if (exclusion) {
var useHalfColumn = !aggregation;
var element = renderableBlock.element;
var style = element.style;
var block = renderableBlock.block;
var attributes = block.attributes;
var imageAttributes = attributes.image;
var columnHeight = gridOptions.columnHeight;
var columnWidth = gridOptions.columnWidth;
var columnSpan = exclusion.columnSpan;
var column = exclusion.column;
// get original image size from data
var imageResource = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(imageAttributes);
var resourceWidth = parseInt(imageResource.width);
var resourceHeight = parseInt(imageResource.height);
var columnLimits = CommonJS.ArticleReader.ArticleReaderUtils.getColumnLimits(context, column, [renderableBlock]);
var availableColumnHeight = Math.max(0, columnHeight - columnLimits.top - columnLimits.bottom); // defensively making sure this
// max height based on column height
var maxHeight = Math.min((1 - maxCaptionFraction) * availableColumnHeight, resourceHeight);
var maxWidth = maxHeight * resourceWidth / resourceHeight;
var containerWidth = CommonJS.ArticleReader.ArticleReaderUtils.convertColumnCountToWidth(columnSpan, gridOptions);
if (columnSpan === 1 && columnWidth > 550 && useHalfColumn) {
containerWidth = columnWidth * 0.50;
style.msGridColumnAlign = "start";
}
else {
style.msGridColumnAlign = "";
}
var imageWidth = Math.min(containerWidth, maxWidth);
var imageHeight = imageWidth * maxHeight / maxWidth;
var imageContainerElt = element.querySelector(".imageContainer");
var imageContainerStyle = imageContainerElt.style;
imageContainerStyle.width = imageWidth + "px";
imageContainerStyle.height = imageHeight + "px";
var imageElt = element.querySelector(".image");
var imageStyle = imageElt.style;
imageStyle.width = imageWidth + "px";
imageStyle.height = imageHeight + "px";
var inlineContainerElt = element.querySelector(".inlineContainer");
inlineContainerElt.style.width = containerWidth + "px";
// adjust description height
var descriptionElt = element.querySelector(".description");
descriptionElt.style.maxHeight = (maxCaptionFraction * availableColumnHeight) + "px";
}
},
},
});
})();
/* File: InlineImageRenderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Renders an inline image block
WinJS.Namespace.define("CommonJS.ArticleReader", {
InlineImageRenderer: {
render: function render(renderableBlock, context) {
var block = renderableBlock.block;
var attributes = block.attributes;
var imageIndex = renderableBlock.imageIndex;
var imageAttributes = attributes.image;
// create the target for on-the-fly slideshow
var auxiliaryData = context.auxiliaryData;
var cacheId = auxiliaryData.cacheId;
var slideshowData = auxiliaryData.slideshowData;
var target = CommonJS.ArticleReader.ArticleReaderUtils.launchSlideshow.bind(CommonJS.ArticleReader.ArticleReaderUtils, slideshowData, imageIndex, cacheId);
var element = CommonJS.ArticleReader.InlineRendererHelper.render(imageAttributes, context, null, target);
return element;
},
calculateLayout: function calculateLayout(renderableBlock, startColumn, gridOptions, exclusions) {
var exclusion = CommonJS.ArticleReader.InlineRendererHelper.calculateLayout(renderableBlock, startColumn, gridOptions, exclusions);
return exclusion;
},
applyLayout: function applyLayout(renderableBlock, aggregation, context) {
CommonJS.ArticleReader.InlineRendererHelper.applyLayout(renderableBlock, aggregation, context);
},
}
});
})();
/* File: InlineSlideshowRenderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
var U = CommonJS.ArticleReader.ArticleReaderUtils;
// Renders an inline slideshow
WinJS.Namespace.define("CommonJS.ArticleReader", {
InlineSlideshowRenderer: {
render: function render(renderableBlock, context) {
var block = renderableBlock.block;
var attributes = block.attributes;
var imageAttributes = attributes.image;
var icon = "slideshow";
var target = function (event) {
U.logUserAction(U.actionContext.body, "Slideshow");
var options = new Windows.System.LauncherOptions();
Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(attributes.uri), options);
};
var element = CommonJS.ArticleReader.InlineRendererHelper.render(imageAttributes, context, icon, target);
return element;
},
calculateLayout: function calculateLayout(renderableBlock, startColumn, gridOptions, exclusions) {
var exclusion = CommonJS.ArticleReader.InlineRendererHelper.calculateLayout(renderableBlock, startColumn, gridOptions, exclusions, this);
return exclusion;
},
applyLayout: function applyLayout(renderableBlock, aggregation, context) {
CommonJS.ArticleReader.InlineRendererHelper.applyLayout(renderableBlock, aggregation, context);
},
}
});
})();
/* File: InlineVideoRenderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Renders an inline video
WinJS.Namespace.define("CommonJS.ArticleReader", {
InlineVideoRenderer: {
render: function render(renderableBlock, context) {
var block = renderableBlock.block;
var attributes = block.attributes;
var gridOptions = context.gridOptions;
var video = attributes.video;
var attribution = video.attribution;
var videoSource = video.videoSource;
var videoBlockElt = document.createElement("div");
WinJS.Utilities.addClass(videoBlockElt, "inlineVideoBlock exclusion");
// video + attribution container
var videoContainerElt = document.createElement("div");
WinJS.Utilities.addClass(videoContainerElt, "mediaPlaybackContainer");
videoBlockElt.appendChild(videoContainerElt);
// video
var videoElt = document.createElement("div");
WinJS.Utilities.addClass(videoElt, "video");
videoContainerElt.appendChild(videoElt);
var imageCardDiv = document.createElement("div");
WinJS.Utilities.addClass(imageCardDiv, "rrMediaPlaybackImageCard");
if (video.posterUrl) {
var image = document.createElement("img");
image.src = video.posterUrl;
image.style.width = "100%";
image.style.height = "100%";
imageCardDiv.appendChild(image);
}
var playIcon = document.createElement("div");
WinJS.Utilities.addClass(playIcon, "win-commandicon win-commandring mediaPlaybackPlayIcon");
imageCardDiv.appendChild(playIcon);
var adUnitId = null;
var enableVideoAds = null; //true and false are both VALID value
if (context.auxiliaryData && context.auxiliaryData.videoOptions) {
adUnitId = context.auxiliaryData.videoOptions.adUnitId;
enableVideoAds = context.auxiliaryData.videoOptions.enableVideoAds;
}
var wrapper = new CommonJS.VideoWrapper(videoElt, {
subElement: imageCardDiv, videoOptions: {
//NOTE: match the fields' name in EntityCluster item
title: video.attribution,
videoSource: video.videoSource,
fullscreen: "true",
adUnitId: adUnitId,
enableVideoAds: enableVideoAds
}
});
// attribution
var attributionElt = document.createElement("div");
WinJS.Utilities.addClass(attributionElt, "rrMediaPlaybackAttribution");
attributionElt.innerText = attribution;
videoContainerElt.appendChild(attributionElt);
// register for disposal
var auxiliaryData = context.auxiliaryData;
var disposalManager = auxiliaryData.disposalManager;
disposalManager.addDisposedDelegate(function () {
// This occurs when the article reader page is navigated away from back to another panorama. In this case you might want to remove your event listeners, stop your timeouts, etc.
});
disposalManager.addArticleFocusLostDelegate(function () {
// This occurs when the article is still in the dom but no longer in view because of next/prev, or when we go to snap. In this case you might want to pause the video.
});
return videoBlockElt;
},
calculateLayout: function calculateLayout(renderableBlock, startColumn, gridOptions, exclusions) {
var that = this;
var block = renderableBlock.block;
var attributes = block.attributes;
var video = attributes.video;
var maxWidth = parseInt(video.width);
var maxHeight = parseInt(video.height);
var minWidth = 1;
var estimatedMaxHeight = maxHeight + 250; // estimate 250 pixels for caption
var exclusion = CommonJS.ArticleReader.ArticleReaderUtils.getBestExclusion(startColumn, gridOptions, exclusions, maxWidth, estimatedMaxHeight, minWidth);
return exclusion;
},
applyLayout: function applyLayout(renderableBlock, aggregation, context) {
var gridOptions = context.gridOptions;
var exclusion = renderableBlock.exclusion;
if (exclusion) {
var element = renderableBlock.element;
var block = renderableBlock.block;
var attributes = block.attributes;
var video = attributes.video;
var maxWidth = parseInt(video.width);
var maxHeight = parseInt(video.height);
var columnSpan = exclusion.columnSpan;
var videoWidth = Math.min(CommonJS.ArticleReader.ArticleReaderUtils.convertColumnCountToWidth(columnSpan, gridOptions), maxWidth);
var videoHeight = videoWidth * maxHeight / maxWidth;
var videoElt = element.querySelector(".video");
var videoStyle = videoElt.style;
videoStyle.width = videoWidth + "px";
videoStyle.height = videoHeight + "px";
}
},
}
});
})();
/* File: ReferralRenderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Renders the trailing Referral block
WinJS.Namespace.define("CommonJS.ArticleReader", {
ReferralRenderer: {
render: function render(renderableBlock, context) {
var block = renderableBlock.block;
var attributes = block.attributes;
var gridOptions = context.gridOptions;
var columnMargin = gridOptions.columnMargin;
var auxiliaryData = context.auxiliaryData;
var cacheId = auxiliaryData.cacheId || "";
var referral = attributes.referral;
var url = referral.url;
var title = referral.title;
var description = referral.description;
var thumbnail = referral.thumbnail;
var logo = referral.logo;
var urlAction = referral.urlAction;
var referralBlockElt = document.createElement("div");
WinJS.Utilities.addClass(referralBlockElt, "referralBlock");
var referralContainerElt = document.createElement("div");
WinJS.Utilities.addClass(referralContainerElt, "referralContainer");
referralContainerElt.style.paddingLeft = columnMargin + "px";
referralContainerElt.style.paddingRight = columnMargin + "px";
referralBlockElt.appendChild(referralContainerElt);
var image = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(thumbnail);
var imageHeight = image.height;
var imageElt = document.createElement("div");
var imageSource = CommonJS.ArticleReader.ArticleReaderUtils.getImageCardSource(thumbnail, cacheId);
WinJS.Utilities.addClass(imageElt, "referralImage fitHeight anchorMiddle");
imageElt.style.height = imageHeight + "px";
var imageCard = new CommonJS.ImageCard(imageElt, {
imageSource: imageSource,
});
referralContainerElt.appendChild(imageElt);
// title
var titleElt = document.createElement("div");
WinJS.Utilities.addClass(titleElt, "referralTitle");
titleElt.innerText = title;
referralContainerElt.appendChild(titleElt);
// description
var descriptionElt = document.createElement("div");
WinJS.Utilities.addClass(descriptionElt, "referralDescription");
descriptionElt.innerText = description;
referralContainerElt.appendChild(descriptionElt);
var visitElt = document.createElement("button");
WinJS.Utilities.addClass(visitElt, "referralButton");
visitElt.innerText = urlAction;
(function createUriClickHandler(theReferral) {
visitElt.addEventListener("click", function (event) {
var uri = new Windows.Foundation.Uri(theReferral.url);
// Launch the URI.
Windows.System.Launcher.launchUriAsync(uri);
});
})(referral);
referralContainerElt.appendChild(visitElt);
var imageLogo = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(logo);
var logoElt = document.createElement("div");
WinJS.Utilities.addClass(logoElt, "referralLogo");
var captionLogoElt = document.createElement("div");
WinJS.Utilities.addClass(captionLogoElt, "referralLogoCaption");
captionLogoElt.innerText = referral.logo.caption;
logoElt.appendChild(captionLogoElt);
var imageLogoElt = document.createElement("div");
imageLogoElt.style.height = imageLogo.height + "px";
imageLogoElt.style.width = imageLogo.width + "px";
var imageLogoSource = CommonJS.ArticleReader.ArticleReaderUtils.getImageCardSource(logo, cacheId);
var imageLogoCard = new CommonJS.ImageCard(imageLogoElt, {
imageSource: imageLogoSource,
});
logoElt.appendChild(imageLogoElt);
referralContainerElt.appendChild(logoElt);
return referralBlockElt;
},
layout: function layout(renderableBlock, surfaceManager, context) {
var gridOptions = context.gridOptions;
var columnCount = gridOptions.columnCount;
var element = renderableBlock.element;
var page = surfaceManager.getLastPageWithEmptyLastColumn(context, true);
var pageIndex = page.pageIndex;
var column = (pageIndex + 1) * columnCount - 1;
// TODO: Use tony's new helper function to place this element)
var style = element.style;
style.msGridRow = 1;
style.msGridRowSpan = 4;
style.msGridColumn = CommonJS.ArticleReader.ArticleReaderUtils.convertColumnIndexToGridColumn(column, columnCount);
style.msGridColumnSpan = 2;
return true;
},
}
});
})();
/* File: ExternalRenderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Renders an external block
WinJS.Namespace.define("CommonJS.ArticleReader", {
ExternalRenderer: {
render: function render(renderableBlock, context) {
var block = renderableBlock.block;
var attributes = block.attributes;
var auxiliaryData = context.auxiliaryData;
var cacheId = auxiliaryData.cacheId || "";
var renderOptions = {
cacheId: cacheId,
};
var controlType = attributes.controlType;
var controlOptionsSerialized = attributes.controlOptionsSerialized;
var controlOptions = JSON.parse(controlOptionsSerialized);
var options = {
controlOptions: controlOptions,
renderOptions: renderOptions,
};
var control = PlatformJS.Utilities.createObject(controlType, null, options);
var blockElt = document.createElement("div");
WinJS.Utilities.addClass(blockElt, "externalBlock exclusion");
var containerElt = document.createElement("div");
WinJS.Utilities.addClass(containerElt, "externalContainer");
blockElt.appendChild(containerElt);
if (control) {
// get element from control
var controlElt = control.element;
containerElt.appendChild(controlElt);
}
return blockElt;
},
calculateLayout: function calculateLayout(renderableBlock, startColumn, gridOptions, exclusions) {
var that = this;
var block = renderableBlock.block;
var attributes = block.attributes;
// get max block size from data
var maxWidth = attributes.maxWidth;
var maxHeight = attributes.maxHeight;
var minWidth = attributes.minWidth || 1;
// calculate exclusion
var placement = attributes.placement; // TODO: currently the only placement option is "inline", so we'll ignore this field and always use getBestExclusion which is for "inline"
var estimatedMaxHeight = maxHeight * 1.2; // allow for 20% height increase
var exclusion = CommonJS.ArticleReader.ArticleReaderUtils.getBestExclusion(startColumn, gridOptions, exclusions, maxWidth, estimatedMaxHeight, minWidth);
return exclusion;
},
applyLayout: function applyLayout(renderableBlock, aggregation, context) {
var gridOptions = context.gridOptions;
var exclusion = renderableBlock.exclusion;
if (exclusion) {
var element = renderableBlock.element;
var block = renderableBlock.block;
var attributes = block.attributes;
var maxWidth = attributes.maxWidth;
var maxHeight = attributes.maxHeight;
var containerElt = element.querySelector(".sized") || element.querySelector(".externalContainer");
var columnSpan = exclusion.columnSpan;
var blockWidth = Math.min(CommonJS.ArticleReader.ArticleReaderUtils.convertColumnCountToWidth(columnSpan, gridOptions), maxWidth);
var blockHeight = blockWidth * maxHeight / maxWidth;
containerElt.style.width = blockWidth + "px";
containerElt.style.height = blockHeight + "px";
}
},
}
});
})();
/* File: ActionsRenderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
var U = CommonJS.ArticleReader.ArticleReaderUtils;
// Renders the end of article Actions block
WinJS.Namespace.define("CommonJS.ArticleReader", {
ActionsRenderer: {
render: function render(renderableBlock, context) {
var block = renderableBlock.block;
var attributes = block.attributes;
var articleActions = attributes.articleActions;
var actionsHandlerType = attributes.actionsHandlerType;
var actionsHandler = PlatformJS.Utilities.createObject(actionsHandlerType);
var auxiliaryData = context.auxiliaryData;
var cacheId = auxiliaryData.cacheId || "";
var articleMetadata = auxiliaryData.articleMetadata;
var articleHeader = auxiliaryData.articleHeader;
var actionsBlockElt = document.createElement("div");
WinJS.Utilities.addClass(actionsBlockElt, "actionsBlock exclusion");
var actionsContainerElt = document.createElement("div");
WinJS.Utilities.addClass(actionsContainerElt, "actionsContainer");
actionsBlockElt.appendChild(actionsContainerElt);
var actionsElt = document.createElement("ol");
WinJS.Utilities.addClass(actionsElt, "actions");
actionsContainerElt.appendChild(actionsElt);
for (var actionKey in articleActions) {
var articleAction = articleActions[actionKey];
var text = articleAction.text;
var textSize = articleAction.textSize;
var icon = articleAction.icon;
var actionOptions = articleAction.actionOptions;
var actionElt = document.createElement("li");
WinJS.Utilities.addClass(actionElt, "action");
actionsElt.appendChild(actionElt);
var buttonElt = document.createElement("button");
WinJS.Utilities.addClass(buttonElt, "button");
actionElt.appendChild(buttonElt);
PlatformJS.Utilities.enablePointerUpDownAnimations(buttonElt);
if (actionsHandler) {
(function (actionKey, actionOptions) {
buttonElt.addEventListener("click", function (event) {
U.logUserAction(U.actionContext.body, "EOAB");
var newEvent = {
originalEvent: event,
data: {
actionKey: actionKey,
actionOptions: actionOptions,
articleMetadata: articleMetadata,
articleHeader: articleHeader,
impressionNavMethod: U.impressionNavMethod.endOfArticleBlock
}
};
actionsHandler.onActionInvoked(newEvent);
});
})(actionKey, actionOptions);
}
// icon
if (icon) {
var iconContainerElt = document.createElement("div");
WinJS.Utilities.addClass(iconContainerElt, "iconContainer");
buttonElt.appendChild(iconContainerElt);
var iconElt = document.createElement("div");
WinJS.Utilities.addClass(iconElt, "icon");
iconContainerElt.appendChild(iconElt);
var iconType = icon.type;
switch (iconType) {
case "glyph":
var className = icon.className;
WinJS.Utilities.addClass(iconContainerElt, "glyph");
WinJS.Utilities.addClass(iconElt, className);
break;
case "image":
var url = icon.url;
WinJS.Utilities.addClass(iconContainerElt, "image fitBoth");
var imageCard = new CommonJS.ImageCard(iconElt, {
imageSource: {
url: url,
cacheId: cacheId,
}
});
break;
}
}
// text
var textElt = document.createElement("div");
textElt.innerText = text;
WinJS.Utilities.addClass(textElt, "text");
switch (textSize) {
case "large":
WinJS.Utilities.addClass(textElt, "large");
break;
case "small":
default:
WinJS.Utilities.addClass(textElt, "small");
break;
}
buttonElt.appendChild(textElt);
}
return actionsBlockElt;
},
layout: function layout(renderableBlock, surfaceManager, context) {
var gridOptions = context.gridOptions;
var element = renderableBlock.element;
var style = element.style;
// get the first empty column
var firstEmptyColumn = surfaceManager.getFirstEmptyColumn(context, false);
// try the previous column first
var tryColumn = Math.max(0, firstEmptyColumn - 1);
U.place(element, tryColumn, 1, "end", context);
var columnLimits = U.getColumnLimits(context, tryColumn, [renderableBlock]);
style.marginBottom = columnLimits.bottom + "px";
U.updateLayout(renderableBlock, context);
var tryNext = false;
// first see if the actions block overlaps any existing exclusions. if it did, we need to go to next column.
var exclusions = U.getAllNonTitleExclusions(context);
var actionsExclusion = renderableBlock.exclusion;
for (var i = 0, len = exclusions.length; i < len; i++) {
var exclusion = exclusions[i];
if (actionsExclusion !== exclusion) {
if (U.doExclusionsOverlap(exclusion, actionsExclusion, gridOptions)) {
tryNext = true;
break;
}
}
}
if (!tryNext) {
// then see if content spilled over. if it did, we need to go to next column.
var overflow = surfaceManager.isColumnOverflowing(tryColumn, context);
if (overflow) {
tryNext = true;
}
}
// if needed, move actions block to top of next column
if (tryNext) {
// reset the margin bottom that was applied in the first try
style.marginBottom = "";
tryColumn = surfaceManager.getNextColumnIndexAndMaybeCreatePage(tryColumn, context);
columnLimits = U.getColumnLimits(context, tryColumn, [renderableBlock]);
U.place(element, tryColumn, 1, "start", context);
style.marginTop = columnLimits.top + "px";
U.updateLayout(renderableBlock, context);
}
return true;
},
}
});
})();
/* File: EndAdRenderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Renders the trailing End Ad block
WinJS.Namespace.define("CommonJS.ArticleReader", {
EndAdRenderer: {
render: function render(renderableBlock, context) {
var block = renderableBlock.block;
var attributes = block.attributes;
var controlOptions = attributes.controlOptions;
var controlType = attributes.controlType;
var endAdBlockElt = document.createElement("div");
WinJS.Utilities.addClass(endAdBlockElt, "endAdBlock");
var adContainer = new CommonJS.ArticleReader.AdContainer(null, {
controlOptions: controlOptions,
controlType: controlType,
});
var adContainerElt = adContainer.element;
endAdBlockElt.appendChild(adContainerElt);
// register for disposal
var auxiliaryData = context.auxiliaryData;
var disposalManager = auxiliaryData.disposalManager;
disposalManager.addDisposedDelegate(function () {
adContainer.dispose();
});
return endAdBlockElt;
},
layout: function layout(renderableBlock, surfaceManager, context) {
var gridOptions = context.gridOptions;
var columnCount = gridOptions.columnCount;
var element = renderableBlock.element;
var page = surfaceManager.getLastPageWithEmptyLastColumn(context, false);
var isVisible = false;
if (page) {
var pageIndex = page.pageIndex;
var column = (pageIndex + 1) * columnCount - 1;
// TODO: Use tony's new helper function to place this element)
var style = element.style;
style.msGridRow = 1;
style.msGridRowSpan = 4;
style.msGridColumn = CommonJS.ArticleReader.ArticleReaderUtils.convertColumnIndexToGridColumn(column, columnCount);
style.msGridColumnSpan = 2;
CommonJS.ArticleReader.ArticleReaderUtils.instantiateChildAds(element);
isVisible = true;
}
return isVisible;
},
}
});
})();
/* File: InlineAdRenderer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Renders an inline ad block
WinJS.Namespace.define("CommonJS.ArticleReader", {
InlineAdRenderer: {
render: function render(renderableBlock, context) {
var block = renderableBlock.block;
var attributes = block.attributes;
var controlOptions = attributes.controlOptions;
var controlType = attributes.controlType;
var inlineAdBlockElt = document.createElement("div");
WinJS.Utilities.addClass(inlineAdBlockElt, "inlineAdBlock exclusion");
var adContainer = new CommonJS.ArticleReader.AdContainer(null, {
controlOptions: controlOptions,
controlType: controlType,
});
var adContainerElt = adContainer.element;
inlineAdBlockElt.appendChild(adContainerElt);
// register for disposal
var auxiliaryData = context.auxiliaryData;
var disposalManager = auxiliaryData.disposalManager;
disposalManager.addDisposedDelegate(function () {
adContainer.dispose();
});
return inlineAdBlockElt;
},
calculateLayout: function calculateLayout(renderableBlock, startColumn, gridOptions, exclusions) {
var block = renderableBlock.block;
var attributes = block.attributes;
// get ad size
var adWidth = attributes.width;
var adHeight = attributes.height;
var exclusion = CommonJS.ArticleReader.ArticleReaderUtils.getBestExclusion(startColumn, gridOptions, exclusions, adWidth, adHeight, adWidth);
return exclusion;
},
applyLayout: function applyLayout(renderableBlock, aggregation, context) {
var gridOptions = context.gridOptions;
var exclusion = renderableBlock.exclusion;
if (exclusion) {
var useHalfColumn = !aggregation;
var element = renderableBlock.element;
var style = element.style;
var block = renderableBlock.block;
var attributes = block.attributes;
var adWidth = attributes.width;
var adHeight = attributes.height;
var columnCount = gridOptions.columnCount;
var columnWidth = gridOptions.columnWidth;
var columnSpan = exclusion.columnSpan;
var adContainer = element.querySelector(".adContainer");
if (columnSpan === 1 && columnWidth > 550 && adWidth <= 300 && useHalfColumn) {
adContainer.style.width = adWidth + "px";
style.msGridColumnAlign = "start";
}
else {
adContainer.style.width = "";
style.msGridColumnAlign = "";
}
CommonJS.ArticleReader.ArticleReaderUtils.instantiateChildAds(element);
var adElt = element.querySelector(".ad");
if (adElt) {
var adStyle = adElt.style;
adStyle.width = adWidth + "px";
adStyle.height = adHeight + "px";
}
}
},
}
});
})();
/* File: ArticleReader.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
var U = CommonJS.ArticleReader.ArticleReaderUtils;
var T = Platform.Telemetry;
// ArticleReader is the main control and is responsible for rendering article content in a magazine-style UI.
WinJS.Namespace.define("CommonJS.ArticleReader", {
ArticleReader: WinJS.Class.define(
function (elt, options) {
/// <summary>
/// Creates an instance of the ArticleReader control.
/// </summary>
/// <param name="options">
/// - paginatedViewManager: handler for mouse/keyboard scroll behavior
/// - market: Market of the article reader page
/// </param>
// create the dom elements
elt = this._elt = elt || document.createElement("div");
elt.winControl = this;
WinJS.Utilities.addClass(elt, "reader");
var surface = this._surface = document.createElement("div");
WinJS.Utilities.addClass(surface, "surface");
elt.appendChild(surface);
var contentFrame = document.createElement("iframe");
WinJS.Utilities.addClass(contentFrame, "contentFrame");
elt.appendChild(contentFrame);
// create surface manager
var surfaceManager = this._surfaceManager = new CommonJS.ArticleReader.SurfaceManager({
surface: surface,
});
// create content frame manager
var paginatedViewManager = options.paginatedViewManager;
var contentFrameManager = this._contentFrameManager = new CommonJS.ArticleReader.ContentFrameManager({
contentFrame: contentFrame,
paginatedViewManager: paginatedViewManager,
market: options.market,
});
// create the disposal manager
var disposalManager = this._disposalManager = new CommonJS.ArticleReader.DisposalManager();
this._header = null;
this._context = null;
this._isRendered = false;
this._isLayoutValid = true;
},
{
_elt: null,
_surfaceManager: null,
_contentFrameManager: null,
_disposalManager: null,
_header: null,
_instrumentationData: null,
_context: null,
_surface: null,
_isRendered: null,
_isLayoutValid: null,
element: {
get: function get() {
return this._elt;
}
},
isRendered: {
get: function get() {
return this._isRendered;
}
},
dispose: function dispose() {
var surfaceManager = this._surfaceManager;
if (surfaceManager) {
var context = this._context;
if (context) {
var data = context.data;
if (data) {
var renderData = data.renderData;
if (renderData) {
surfaceManager.removeBlocks(renderData.renderableBlocks);
surfaceManager.removeBlocks(renderData.endRenderableBlocks);
}
}
}
surfaceManager.dispose();
}
//HACK: This is a workaround that the IE team proposed to us in order to get around a bug in their code
//      that causes an MSHTML crash when we pan through the AR (Appex Bug #400653). We should be able to
//      remove this hack after they fix it on their end in future IE releases. The issue surfaces when we
//      try to remove articles from the DOM. Internally, within IE, there are certain edge cases where it
//      ends up removing the CSS regions before the iFrame is removed. Here, we are forcing IE to recompute
//      its layout by querying for the offsetHeight of the body, which may hurt perf but will advert the crash. (tozha)
//[BEGIN]
document.body.offsetHeight;
//[END]
var contentFrameManager = this._contentFrameManager;
if (contentFrameManager) {
contentFrameManager.dispose();
}
var disposalManager = this._disposalManager;
if (disposalManager) {
disposalManager.runAllDisposedDelegates();
disposalManager.dispose();
}
var elt = this._elt;
elt.innerHTML = "";
this._header = null;
this._instrumentationData = null;
this._surface = null;
this._elt = null;
this._context = null;
},
getHeader: function getHeader() {
/// <summary>
/// Returns the article header object used for sharing.
/// </summary>
return this._header;
},
getInstrumentationData: function getInstrumentationData() {
/// <summary>
/// Returns the data object used for instrumentation.
/// </summary>
return this._instrumentationData;
},
render: function render(data, renderOptions) {
/// <summary>
/// Renders the given data in the control.
/// </summary>
/// <param name="data">The article data. Must conform to the article JSON format.</param>
/// <param name="renderOptions">
/// Options to use for rendering. The following are respected:
/// - gridOptions: Grid measurements, as calculated by GridCalculator
/// - cacheId: Cache ID to use for images.
/// - initialTextAttributes: Initial text attributes
/// - validActions: Dictionary of actions and their definitions. These are rendered at the end of the article.
/// - actionsHandlerType: Type that handles EOA actions. onActionsInvoked() must be defined on it.
/// - contentCssPaths: Array of CSS files to apply to the content document. articleMetadata.contentCssPaths takes precedence if it exists.
/// - actionKeys: Array of actions applicable to this article. articleMetadata.actionKeys takes precedence if it exists.
/// - renderAll: Whether to render all blocks or not. articleMetadata.renderAll takes precedence if it exists.
/// - adGroups: Definitions for ads within the article.
/// - viewportManager: Object that can be used for scrolling the viewport or querying it.
/// - adPartnerName: Used for disambiguating partner vs. bing daily ads.
/// - hideInlineAds: Special boolean that is used by the server renderer to render the inline ads as invisible. Should not be set by the client.
/// - ignoreDataAds: Special boolean that is used by the server renderer. When set, the metadata.adInformation and title.ads fields are ignored. Should not be set by the client.
/// - ignoreDataActions: Special boolean that is used by the server renderer. When set, metadata.actions is ignored. Should not be set by the client.
/// </param>
var that = this;
var promise = WinJS.Promise.wrap(null);
var articleMetadata = data.metadata;
var articleTitle = data.title;
var gridOptions = renderOptions.gridOptions;
var cacheId = renderOptions.cacheId;
var adPartnerName = renderOptions.adPartnerName;
var initialTextAttributes = renderOptions.initialTextAttributes;
var validActions = renderOptions.validActions;
var actionsHandlerType = renderOptions.actionsHandlerType;
var ignoreDataAds = renderOptions.ignoreDataAds;
var ignoreDataActions = renderOptions.ignoreDataActions;
var contentCssPaths = (articleMetadata ? this._maybeConvertToJsonArray(articleMetadata.contentCssPaths) : null) || renderOptions.contentCssPaths || [];
var actionKeys = (articleMetadata ? this._maybeConvertToJsonArray(articleMetadata.actionKeys) : null) || renderOptions.actionKeys || [];
var renderAll = articleMetadata ? (typeof (articleMetadata.renderAll) === "boolean" ? articleMetadata.renderAll : (renderOptions.renderAll || false)) : (renderOptions.renderAll || false);
var adGroups = ignoreDataAds ? (renderOptions.adGroups || []) : ((articleTitle.ads === null || articleTitle.ads > 0) ? ((articleMetadata ? this._maybeConvertToJsonArray(articleMetadata.adGroups) : null) || renderOptions.adGroups || []) : []);
var viewportManager = renderOptions.viewportManager;
var disposalManager = this._disposalManager;
var adInformation = ignoreDataAds ? null : (articleMetadata ? articleMetadata.adInformation : null);
var adOverrides = adInformation ? CommonJS.ArticleReader.ArticleReaderUtils.convertAdInformationToAdOverrides(adInformation) : null;
adGroups = this._overrideAds(adGroups, adOverrides, adPartnerName);
var videoOptions = this._extractVideoOverride(adOverrides, adPartnerName);
var hideInlineAds = renderOptions.hideInlineAds;
var header = this._header = {
snippet: null,
headline: null,
publisherName: null,
author: null,
date: null,
sharingUrl: null,
};
var instrumentationData = this._instrumentationData = {
content: {
sourceName: null,
partnerCode: null,
contentId: null,
type: null,
date: null,
uri: null,
slug: null,
isSummary: null,
worth: null,
isAd: null,
adCampaign: null,
},
trailingMediaBlockCount: null,
renderType: null
};
// initialize the context object. the context object is passed through all the render steps.
var context = this._context = {
data: data,
gridOptions: gridOptions,
renderData: {
content: null,
renderableTitle: null,
renderableBlocks: null,
titleRenderableBlocks: null,
endRenderableBlocks: null,
},
layoutData: {
pageCount: null,
},
calibrationData: {
contentDensity: null,
contentColumnCount: null,
},
auxiliaryData: {
articleHeader: header,
instrumentationData: instrumentationData,
renderAll: renderAll,
cacheId: cacheId,
textAttributes: initialTextAttributes,
articleMetadata: articleMetadata,
flowId: null,
contentCssPaths: contentCssPaths,
viewportManager: viewportManager,
disposalManager: disposalManager,
videoOptions: videoOptions,
slideshowData: {},
adGroups: adGroups,
hideInlineAds: hideInlineAds,
articleActions: null,
actionsHandlerType: actionsHandlerType,
},
};
var renderData = this._getRenderData(data);
var layout = this._getApplicableLayout(data, context);
var hasLayoutHints = layout ? true : false;
// get renderable data, article header, etc.
if (renderData) {
this._populateRenderDataFromRenderData(renderData, context);
if (!hasLayoutHints) {
this._resetTitle(context, false);
}
this._resetInlineAds(context);
}
else {
this._populateRenderData(data, context);
}
// do more processing on the render data
this._preprocessRenderData(context);
// EOA actions
this._processActions(validActions, actionKeys, actionsHandlerType, data, ignoreDataActions, context);
// end blocks (eoa, tower ads, referral)
this._createEndBlocks(context);
// populate iframe with content
this._populateContent(context);
// initializeSurface
this._initializeSurface(context);
// render
if (hasLayoutHints) {
promise = this._renderImplFromLayout(layout, renderOptions, context);
}
else {
promise = this._renderImpl(data, renderOptions, context);
}
promise = promise.then(function () {
that._updateInstrumentationData(true, layout, renderData);
});
return promise;
},
relayout: function relayout(relayoutOptions) {
/// <summary>
/// Relays out the article using the existing context that was produced in the render() call. It updates parts of the
/// context based on the given relayoutOptions.
/// </summary>
/// <param name="relayoutOptions">
/// - gridOptions: the new grid measurements.
/// </param>
var that = this;
var currentContext = this._context;
currentContext.gridOptions = relayoutOptions.gridOptions;
var promise = WinJS.Promise.wrap(null);
if (currentContext) {
var data = currentContext.data;
var layout = this._getApplicableLayout(data, currentContext);
var hasLayoutHints = layout ? true : false;
if (hasLayoutHints) {
promise = this._relayoutImplFromLayout(layout, currentContext);
}
else {
this._resetTitle(currentContext, true);
promise = this._relayoutImpl(currentContext);
}
promise = promise.then(function () {
var renderData = that._getRenderData(data);
that._updateInstrumentationData(false, layout, renderData);
});
}
return promise;
},
getRenderData: function getRenderData() {
var outputRenderData = null;
var isLayoutValid = this._isLayoutValid;
if (isLayoutValid) {
var currentContext = this._context;
if (currentContext) {
var renderData = currentContext.renderData;
var renderableBlocks = renderData.renderableBlocks;
var endRenderableBlocks = renderData.endRenderableBlocks;
var outputRenderableBlocks = [];
for (var i = 0, leni = renderableBlocks.length; i < leni; i++) {
var renderableBlock = renderableBlocks[i];
var outputRenderableBlock = {
block: renderableBlock.block,
position: renderableBlock.position,
};
outputRenderableBlocks.push(outputRenderableBlock);
}
var outputEndRenderableBlocks = [];
for (var j = 0, lenj = endRenderableBlocks.length; j < lenj; j++) {
var endRenderableBlock = endRenderableBlocks[j];
var outputEndRenderableBlock = {
block: endRenderableBlock.block,
position: endRenderableBlock.position,
};
outputEndRenderableBlocks.push(outputEndRenderableBlock);
}
outputRenderData = {
renderableBlocks: outputRenderableBlocks,
endRenderableBlocks: outputEndRenderableBlocks,
renderableTitle: renderData.renderableTitle,
content: renderData.content,
};
}
}
return outputRenderData;
},
getLayout: function getLayout() {
var layout = null;
var isLayoutValid = this._isLayoutValid;
if (isLayoutValid) {
var layoutProperties = this._getLayoutProperties();
var layoutHints = this._getLayoutHints();
if (layoutHints) {
layout = {
properties: layoutProperties,
hints: layoutHints,
};
}
}
return layout;
},
setTextAttributes: function setTextAttributes(textAttributes) {
/// <summary>
/// Sets the text size and style of the article reader.
/// </summary>
/// <param name="textAttributes">
/// - style: primary or secondary
/// - size: small, medium, or large
/// </param>
var contentFrameManager = this._contentFrameManager;
contentFrameManager.setTextAttributes(textAttributes);
var promise = WinJS.Promise.wrap(null);
var surfaceManager = this._surfaceManager;
var currentContext = this._context;
if (currentContext) {
promise = surfaceManager.adjust(currentContext, false)
.then(function () {
var auxiliaryData = currentContext.auxiliaryData;
auxiliaryData.textAttributes = textAttributes;
});
}
return promise;
},
getPageCount: function getPageCount() {
var surfaceManager = this._surfaceManager;
var pageCount = surfaceManager.getPageCount();
return pageCount;
},
articleFocusLost: function articleFocusLost() {
var disposalManager = this._disposalManager;
if (disposalManager) {
disposalManager.runAllArticleFocusLostDelegates();
}
},
/*
Logic Implemented in this function, where:
- adPartnerName == 1 when adPartnerName is present and non-empty
- PartnerAd == 1 when an override with a matching PartnerId & size is present
- NonPartnerAd == 1 when an override with a matching size & empty PartnerId is present
adPartnerName PartnerAd NonPartnerAd Ad displayed
1             1         *            Partner Ad
1	          0         *	         NO AD
0	          *     	1       	 NonPartnerAd
0       	  1     	0	         NO AD
0	          0     	0	         Use what's in adGroup
*/
_findAdOverride: function _findAdOverride(adClass, adOverrides, adPartnerName) {
var foundAPartnerAdSameSize = false;
var foundAdUnitIdOverride = "";
var action;
var i, j;
adOverrides = adOverrides || [];
for (i = 0; i < adOverrides.length && !foundAdUnitIdOverride; i++) {
var adOverride = adOverrides[i];
if ((adPartnerName && adOverride.partnerId === adPartnerName) ||
(!adPartnerName && !adOverride.partnerId)) {
for (j = 0; j < adOverride.ads.length && !foundAdUnitIdOverride; j++) {
if (CommonJS.ArticleReader.ArticleReaderUtils.adTypeMatchesClass(adOverride.ads[j].type, adClass)) {
foundAdUnitIdOverride = adOverride.ads[j].id;
}
}
} else if (!adPartnerName && adOverride.partnerId) {
/* this case is needed to implement this part of the logic:
adPartnerName PartnerAd NonPartnerAd Ad displayed
0       	  1     	0	         NO AD
0	          0     	0	         Use what's in adGroup
*/
for (j = 0; j < adOverride.ads.length && !foundAdUnitIdOverride; j++) {
if (CommonJS.ArticleReader.ArticleReaderUtils.adTypeMatchesClass(adOverride.ads[j].type, adClass)) {
foundAPartnerAdSameSize = true;
break;
}
}
}
}
if (foundAdUnitIdOverride) {
action = "override";
} else if ((adPartnerName) ||
(!adPartnerName && foundAPartnerAdSameSize)) {
action = "noAd";
} else {
action = "useDefault";
}
return { action: action, adUnitIdOverride: foundAdUnitIdOverride };
},
_extractVideoOverride: function _extractVideoOverride(adOverrides, adPartnerName) {
var matchResults = this._findAdOverride("video", adOverrides, adPartnerName);
var videoOptions = {};
if (matchResults.action === "override") {
videoOptions.adUnitId = matchResults.adUnitIdOverride;
videoOptions.enableVideoAds = true;
} else if (matchResults.action === "noAd") {
videoOptions.enableVideoAds = false;
} //else useDefault
return videoOptions;
},
_overrideAd: function _overrideAd(adMetadata, adOverrides, adPartnerName) {
var adMetadataObj = null;
// See bug 372332 for scenario when adMetadata is empty
if (adMetadata) {
try {
adMetadataObj = JSON.parse(adMetadata);
} catch (ex) {
}
}
if (adMetadataObj &&
adMetadataObj.controlOptions &&
adMetadataObj.controlOptions.className &&
typeof adMetadataObj.controlOptions.className === "string") {
var matchResults = this._findAdOverride(adMetadataObj.controlOptions.className, adOverrides, adPartnerName);
if (matchResults.action === "override") {
adMetadataObj.controlOptions.otherAdOptions.adUnitId = adMetadataObj.controlOptions.adUnitId = matchResults.adUnitIdOverride;
adMetadata = JSON.stringify(adMetadataObj);
} else if (matchResults.action === "noAd") {
adMetadata = "";
}
}
return adMetadata;
},
_overrideAds: function _overrideAds(adGroups, adOverrides, adPartnerName) {
if (!adOverrides || !adOverrides.length) {
if (adPartnerName) {
// no ads
adGroups = [];
}
return adGroups;
}
for (var i = 0; i < adGroups.length; i++) {
var adGroup = adGroups[i];
for (var j = 0; j < adGroup.adMetadatas.length; j++) {
adGroup.adMetadatas[j] = this._overrideAd(adGroup.adMetadatas[j], adOverrides, adPartnerName);
if (!adGroup.adMetadatas[j]) {
adGroups[i] = {};
}
}
}
return adGroups;
},
_getLayoutHints: function _getLayoutHints() {
var currentContext = this._context;
var hints = null;
if (currentContext) {
var renderData = currentContext.renderData;
var layoutData = currentContext.layoutData;
var pageCount = layoutData.pageCount;
var blockLayouts = [];
var renderableBlocks = renderData.renderableBlocks;
var valid = true;
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
var layout = renderableBlock.layout;
if (layout) {
blockLayouts.push(layout);
}
else {
valid = false;
break;
}
}
if (valid) {
hints = {
pageCount: pageCount,
blockLayouts: blockLayouts,
};
}
}
var compressedHints = null;
if (hints) {
compressedHints = CommonJS.ArticleReader.ArticleReaderUtils.compressHints(hints);
}
return compressedHints;
},
_getLayoutProperties: function _getLayoutProperties() {
var layoutProperties = null;
var currentContext = this._context;
if (currentContext) {
layoutProperties = this._createLayoutProperties(currentContext, false);
}
return layoutProperties;
},
_getInlineAdCount: function _getInlineAdCount(context) {
var auxiliaryData = context.auxiliaryData;
var adGroups = auxiliaryData.adGroups;
var hideInlineAds = auxiliaryData.hideInlineAds;
var count = 0;
if (adGroups && !hideInlineAds) {
for (var i = 0, len = adGroups.length; i < len; i++) {
var adGroup = adGroups[i];
var type = adGroup.type;
if (type === "inline") {
var adMetadatas = adGroup.adMetadatas;
if (adMetadatas) {
count += adMetadatas.length;
}
}
}
}
return count;
},
_getApplicableLayout: function _getApplicableLayout(data, context) {
var layout = null;
var layouts = data.layouts;
if (layouts && layouts.length) {
// try to get the layout for current attributes of the page
var layoutProperties = this._createLayoutProperties(context, false);
layout = U.getLayoutByProperties(layouts, layoutProperties);
if (!layout) {
// if no layout available, relax the text attributes constraint and try again
layoutProperties = this._createLayoutProperties(context, true);
layout = U.getLayoutByProperties(layouts, layoutProperties);
}
}
return layout;
},
_createLayoutProperties: function _createLayoutProperties(context, relaxed) {
var auxiliaryData = context.auxiliaryData;
var gridOptions = context.gridOptions;
var pageWidth = gridOptions.pageWidth;
var pageHeight = gridOptions.pageHeight;
var textAttributes = relaxed ? null : auxiliaryData.textAttributes;
var inlineAdCount = this._getInlineAdCount(context);
var layoutProperties = U.createLayoutProperties(pageWidth, pageHeight, textAttributes, inlineAdCount);
return layoutProperties;
},
_populateRenderData: function _populateRenderData(data, context) {
var gridOptions = context.gridOptions;
// this function determines the values of the following and sets them on renderData at the end
var renderableBlocks;
var endRenderableBlocks;
var renderableTitle;
var content;
var blocks = data.blocks;
var contentArray = [];
var contentLength = 0;
renderableBlocks = [];
endRenderableBlocks = [];
function isSupported(identifier) {
var SurfaceManager = CommonJS.ArticleReader.SurfaceManager;
return SurfaceManager.blockRenderers[identifier] || SurfaceManager.endUiRenderers[identifier];
}
// go through all the blocks in the data
for (var i = 0, len = blocks.length; i < len; i++) {
var block = blocks[i];
var type = block.type;
if (type === "SectionBreak") {
var sectionName = block.attributes.name;
// add to content array
var html = this._getSectionHeaderHtml(sectionName);
contentArray.push(html);
contentLength += html.length;
}
else if (type === "Content") {
var c = block.attributes.content;
contentArray.push(c);
contentLength += c.length;
}
else if (type === "Referral") {
var endRenderableBlock = this._createRenderableBlock(block, -20);
endRenderableBlocks.push(endRenderableBlock);
}
else if (isSupported(type)) {
var renderableBlock = this._createRenderableBlock(block, contentLength);
renderableBlocks.push(renderableBlock);
} else {
// un-supported block types
}
}
// get content by concating all elements in the content array
content = contentArray.join("");
// renderable title
var title = data.title;
renderableTitle = this._getRenderableTitle(title, renderableBlocks, gridOptions);
// process title
var titleRenderableBlocks = this._processTitle(renderableTitle, renderableBlocks, context);
// process ads
this._processInlineAds(renderableBlocks, contentLength, context);
// sort renderable blocks based on their position in the data
this._sort(renderableBlocks);
var renderData = context.renderData;
renderData.renderableBlocks = renderableBlocks;
renderData.endRenderableBlocks = endRenderableBlocks;
renderData.renderableTitle = renderableTitle;
renderData.titleRenderableBlocks = titleRenderableBlocks;
renderData.content = content;
},
_populateRenderDataFromRenderData: function _populateRenderDataFromRenderData(dataRenderData, context) {
// this function determines the values of the following and sets them on renderData at the end
var renderableBlocks;
var endRenderableBlocks;
var renderableTitle;
var content;
renderableBlocks = dataRenderData.renderableBlocks;
endRenderableBlocks = dataRenderData.endRenderableBlocks;
renderableTitle = dataRenderData.renderableTitle;
content = dataRenderData.content;
var renderData = context.renderData;
renderData.renderableBlocks = renderableBlocks;
renderData.endRenderableBlocks = endRenderableBlocks;
renderData.renderableTitle = renderableTitle;
renderData.content = content;
},
_resetTitle: function _resetTitle(context, createElements) {
// removes the title blocks and recalculates them. do not call this if there are layout hints present.
var renderData = context.renderData;
var renderableBlocks = renderData.renderableBlocks;
var renderableTitle = renderData.renderableTitle;
// first remove all title renderable blocks
this._removeTitleBlocks(renderableBlocks);
// handle unknown title styles
var style = renderableTitle.style;
var renderer = CommonJS.ArticleReader.SurfaceManager.titleRenderers[style];
if (!renderer) {
this._demoteTitleImageToInlineImage(renderableTitle.titleImage, renderableBlocks);
renderableTitle.titleImage = null;
renderableTitle.style = 1;
}
// get new title blocks
var titleRenderableBlocks = this._processTitle(renderableTitle, renderableBlocks, context);
// resort all renderable blocks
this._sort(renderableBlocks);
renderData.titleRenderableBlocks = titleRenderableBlocks;
if (createElements) {
var surfaceManager = this._surfaceManager;
surfaceManager.createTitleElements(context);
}
},
_getRenderData: function _getRenderData(data) {
var renderData = data.renderData;
return renderData;
},
_removeTitleBlocks: function _removeTitleBlocks(renderableBlocks) {
var surfaceManager = this._surfaceManager;
for (var i = renderableBlocks.length - 1; i >= 0; i--) {
var renderableBlock = renderableBlocks[i];
var isTitle = U.isTitleBlock(renderableBlock);
if (isTitle) {
surfaceManager.removeBlock(renderableBlock);
renderableBlocks.splice(i, 1);
}
}
},
_getSnippet: function _getSnippet(content) {
var maxSnippetLength = CommonJS.ArticleReader.ArticleReader._maxSnippetLength;
var div = document.createElement("div");
WinJS.Utilities.setInnerHTML(div, toStaticHTML(content));
var text = div.innerText.trim();
var snippet = text.substr(0, maxSnippetLength) + "...";
return snippet;
},
_preprocessRenderData: function _preprocessRenderData(context) {
// concat all content
// determine block character positions
// article header for sharing
var auxiliaryData = context.auxiliaryData;
var renderData = context.renderData;
var content = renderData.content;
var renderableTitle = renderData.renderableTitle;
var data = context.data;
var metadata = data.metadata;
// article header
var articleHeader = auxiliaryData.articleHeader;
var snippet = this._getSnippet(content);
articleHeader.snippet = snippet;
articleHeader.sharingUrl = metadata.sharingUrl;
articleHeader.headline = renderableTitle.headline || "";
articleHeader.publisherName = renderableTitle.publisher ? renderableTitle.publisher.name : "";
articleHeader.author = renderableTitle.author || "";
articleHeader.date = renderableTitle.date || "";
// generate unique flow id
var flowId = "content" + AppEx.Common.ArticleReader.GuidProvider.getGuid();
auxiliaryData.flowId = flowId;
// create data for on-the-fly slideshows
var slideshowData = auxiliaryData.slideshowData;
this._populateSlideshowData(renderData, slideshowData);
// update instrumentation data
var title = data.title;
var instrumentationData = auxiliaryData.instrumentationData;
var contentData = instrumentationData.content;
contentData.sourceName = renderableTitle.publisher ? renderableTitle.publisher.name : "";
contentData.partnerCode = metadata.instrumentationId || "";
contentData.type = T.ContentType.article;
contentData.date = this._getDateForInstrumentation(title);
contentData.uri = metadata.sharingUrl || "";
contentData.slug = renderableTitle.headline || "";
contentData.isSummary = false;
contentData.worth = (title.free === false) ? T.ContentWorth.subscription : T.ContentWorth.free;
contentData.isAd = false;
contentData.adCampaign = null;
// recalculate date because we can't do this server-side (BUG #529880)
this._recalculateDate(context);
},
_recalculateDate: function _recalculateDate(context) {
var data = context.data;
var title = data.title;
var renderData = context.renderData;
var renderableTitle = renderData.renderableTitle;
var date = this._getDateString(title);
renderableTitle.date = date;
var renderableBlocks = renderData.renderableBlocks;
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
var isTitle = U.isTitleBlock(renderableBlock);
if (isTitle) {
var block = renderableBlock.block;
var type = block.type;
if (type === "Text") {
var attributes = block.attributes;
var textClassName = attributes.textClassName;
if (textClassName && textClassName.indexOf("dateText") > -1) {
attributes.text = date;
}
}
}
}
},
_populateSlideshowData: function _populateSlideshowData(renderData, slideshowData) {
var slides = [];
var imageIndex = -1;
// title
var renderableTitle = renderData.renderableTitle;
var headline = renderableTitle.headline;
var titleImage = renderableTitle.titleImage;
if (titleImage) {
var image = titleImage.image;
var slide = CommonJS.ArticleReader.ArticleReaderUtils.createSlideshowImageDefinition(image, headline);
slides.push(slide);
imageIndex++;
}
// blocks
var renderableBlocks = renderData.renderableBlocks;
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
var block = renderableBlock.block;
var type = block.type;
if (type === "InlineImage" || type === "FocusImage") {
var attributes = block.attributes;
var blockImage = attributes.image;
var blockSlide = CommonJS.ArticleReader.ArticleReaderUtils.createSlideshowImageDefinition(blockImage, headline);
slides.push(blockSlide);
imageIndex++;
renderableBlock.imageIndex = imageIndex;
}
else {
continue;
}
}
// create slideshow data
slideshowData.slides = slides;
},
_sort: function _sort(renderableBlocks) {
renderableBlocks.sort(function (a, b) {
return a.position - b.position;
});
},
_resetInlineAds: function _resetInlineAds(context) {
var renderData = context.renderData;
var content = renderData.content;
var contentLength = content.length;
var renderableBlocks = renderData.renderableBlocks;
this._processInlineAds(renderableBlocks, contentLength, context);
this._sort(renderableBlocks);
},
_processInlineAds: function _processInlineAds(renderableBlocks, contentLength, context) {
var auxiliaryData = context.auxiliaryData;
var adGroups = auxiliaryData.adGroups;
var inlineAdMetadatas = [];
if (adGroups) {
for (var i = 0, leni = adGroups.length; i < leni; i++) {
var adGroup = adGroups[i];
var type = adGroup.type;
if (type === "inline") {
var adMetadatas = adGroup.adMetadatas;
for (var j = 0, lenj = adMetadatas.length; j < lenj; j++) {
var adMetadata = adMetadatas[j];
inlineAdMetadatas.push(adMetadata);
}
}
}
var b = 0;
for (var k = 0, lenk = inlineAdMetadatas.length; k < lenk; k++) {
var inlineAdMetadata = inlineAdMetadatas[k];
var parsedInlineAdMetadata = JSON.parse(inlineAdMetadata);
var inlineAdControlType = parsedInlineAdMetadata.controlType;
var inlineAdControlOptions = parsedInlineAdMetadata.controlOptions;
var width = parseInt(parsedInlineAdMetadata.width);
var height = parseInt(parsedInlineAdMetadata.height);
var attributes = {
controlOptions: inlineAdControlOptions,
controlType: inlineAdControlType,
width: width,
height: height,
};
// Find the first InlineAd renderable block and replace its attributes. If not found, create a new renderable block.
var found = false;
while (b < renderableBlocks.length) {
var testRenderableBlock = renderableBlocks[b];
if (testRenderableBlock) {
var testBlock = testRenderableBlock.block;
if (testBlock.type === "InlineAd") {
testBlock.attributes = attributes;
found = true;
break;
}
}
b++;
}
if (!found) {
var position = Math.floor(contentLength * (k + 1) / (lenk + 1)); // sprinkle evenly 
var inlineAdBlock = {
type: "InlineAd",
attributes: attributes,
};
var renderableBlock = this._createRenderableBlock(inlineAdBlock, position);
renderableBlocks.push(renderableBlock);
}
}
}
},
_processActions: function _processActions(validActions, actionKeys, actionsHandlerType, data, ignoreDataActions, context) {
var auxiliaryData = context.auxiliaryData;
if (actionKeys && actionKeys.length) {
this._processActionsFromMetadata(validActions, actionKeys, actionsHandlerType, context);
}
else if (!ignoreDataActions) {
this._processActionsFromData(data, context);
}
},
_processActionsFromData: function _processActionsFromData(data, context) {
var articleActions = {};
var metadata = data.metadata;
var actions = metadata.actions;
var auxiliaryData = context.auxiliaryData;
if (actions && actions.length) {
for (var i = 0, len = actions.length; i < len; i++) {
var action = actions[i];
if (action.type === "LaunchUri" && !action.attributes.uri) {
continue;
}
var labelSize = action.labelSize;
var articleAction = {
text: action.label,
textSize: labelSize ? labelSize.toLowerCase() : "small",
actionOptions: {
actionType: action.type,
actionAttributes: action.attributes,
},
};
var icon = action.icon;
if (icon) {
articleAction.icon = {
type: "image",
url: icon.url,
};
}
var actionKey = "action_" + i;
articleActions[actionKey] = articleAction;
}
auxiliaryData.articleActions = articleActions;
auxiliaryData.actionsHandlerType = "CommonJS.ArticleReader.ActionsHandler";
}
},
_processActionsFromMetadata: function _processActionsFromMetadata(validActions, actionKeys, actionsHandlerType, context) {
var articleActions = {};
var auxiliaryData = context.auxiliaryData;
if (actionKeys && actionKeys.length) {
for (var j = 0, lenj = Math.min(3, actionKeys.length) ; j < lenj; j++) {
var actionKey = actionKeys[j];
var validAction = validActions[actionKey];
if (validAction) {
articleActions[actionKey] = validAction;
}
}
}
auxiliaryData.articleActions = articleActions;
auxiliaryData.actionsHandlerType = actionsHandlerType;
},
_populateContent: function _populateContent(context) {
// set all content into iframe
var contentFrameManager = this._contentFrameManager;
var auxiliaryData = context.auxiliaryData;
var flowId = auxiliaryData.flowId;
var renderData = context.renderData;
var content = renderData.content;
var initialTextAttributes = auxiliaryData.textAttributes;
var contentCssPaths = auxiliaryData.contentCssPaths;
var articleHeader = auxiliaryData.articleHeader;
var articleMetadata = auxiliaryData.articleMetadata;
var actionsHandlerType = auxiliaryData.actionsHandlerType;
contentFrameManager.setup(initialTextAttributes, flowId, contentCssPaths, actionsHandlerType, articleHeader, articleMetadata);
contentFrameManager.addContent(content);
},
_initializeSurface: function _initializeSurface(context) {
// initialize the surface
var surfaceManager = this._surfaceManager;
surfaceManager.initializeSurface(context);
},
_calibrateLayout: function _calibrateLayout(context) {
// add a single content block to surface
// attach surface
// put data in content block
// get number of characters in content block
// attach the surface and get content density from it, then detach the surface
var surfaceManager = this._surfaceManager;
var contentDensity = surfaceManager.getContentDensity(context);
// calculate number of columns that we will need to fit all the content
var renderData = context.renderData;
var content = renderData.content;
var contentLength = content.length;
var gridOptions = context.gridOptions;
var columnWidth = gridOptions.columnWidth;
var columnHeight = gridOptions.columnHeight;
var columnCount = gridOptions.columnCount;
var contentColumnCount = contentDensity === 0 ? 0 : Math.ceil((contentLength / contentDensity) / (columnWidth * columnHeight));
// update calibration data with all the findings
var calibrationData = context.calibrationData;
calibrationData.contentDensity = contentDensity;
calibrationData.contentColumnCount = contentColumnCount;
},
_calculateLayout: function _calculateLayout(context) {
// for each block, determine where on the surface it goes (row, column, rowspan, colspan) [need height and row-align instead of rowspan if not granular grid]
// return layout data
var surfaceManager = this._surfaceManager;
var promise = surfaceManager.calculateLayout(context);
return promise;
},
_populateSurface: function _populateSurface(context) {
// create content blocks
// create blocks and associated controls
var surfaceManager = this._surfaceManager;
var promise = surfaceManager.createElements(context);
return promise;
},
_associateLayoutWithElements: function _associateLayoutWithElements(context, useLayoutHints) {
// for each layout info, update dom element
var surfaceManager = this._surfaceManager;
var promise = surfaceManager.associateLayoutWithElements(context, useLayoutHints);
return promise;
},
_adjustSurface: function _adjustSurface(context, useLayoutHints) {
// add more pages or remove pages to match exact content length
// layout (or render?) trailing blocks such as end ad, referral block, etc.
// adjust surface
var surfaceManager = this._surfaceManager;
var promise = surfaceManager.adjust(context, useLayoutHints);
return promise;
},
_getSectionHeaderHtml: function _getSectionHeaderHtml(sectionName) {
var elt = document.createElement("h2");
elt.innerText = sectionName;
var html = elt.outerHTML;
return html;
},
_getRenderableTitle: function _getRenderableTitle(title, renderableBlocks, gridOptions) {
// Given the title block that came from the data, do required data transformation on it to get it in 
// a form that can be rendered. This includes the backward compat code for getting author/publisher
// right, and converting styles 2 and 3 to style 1 with an inline image.
var renderableTitle = {
headline: null,
style: null,
author: null,
date: null,
titleImage: null,
publisher: null,
kicker: null,
};
// kicker
var kicker = title.kicker;
renderableTitle.kicker = kicker || "";
// headline
var headline = title.headline;
renderableTitle.headline = headline || "";
// author
var publisherName = this._getPublisherName(title);
var authorOrByline = title.author ? title.author : title.byline;
var author = authorOrByline !== publisherName ? authorOrByline : "";
renderableTitle.author = author || "";
// publisher
renderableTitle.publisher = title.publisher || null;
// date
renderableTitle.date = this._getDateString(title);
// title style
this._determineTitleStyle(title, renderableTitle, renderableBlocks, gridOptions);
return renderableTitle;
},
_getDateString: function _getDateString(title) {
var publisherName = this._getPublisherName(title);
var effectiveDate = U.getEffectiveDate(title);
var dateString = U.convertDateToString(effectiveDate);
var separator = (publisherName.length > 0 && dateString.length > 0) ? " - " : "";
dateString = (publisherName + separator + dateString) || "";
return dateString;
},
_getPublisherName: function _getPublisherName(title) {
var publisherName = "";
if (title.publisher && title.publisher.name) {
publisherName = title.publisher.name;
}
return publisherName;
},
_getDateForInstrumentation: function _getDateForInstrumentation(title) {
var date = null;
var effectiveDate = U.getEffectiveDate(title);
if (!effectiveDate || typeof (effectiveDate) === "string") {
// when the date is a string, use min date
date = new Date(0);
}
else {
date = new Date(effectiveDate.utctime / 10000 + Date.UTC(1601, 0, 1, 0, 0, 0));
}
return date;
},
_determineTitleStyle: function _determineTitleStyle(title, renderableTitle, renderableBlocks, gridOptions) {
var titleStyle = title.style;
var titleImage = title.titleImage;
var titleRenderers = CommonJS.ArticleReader.SurfaceManager.titleRenderers;
// Bug #384490
var isServerPaddedImage = this._fixServerPaddedImage(titleImage, renderableBlocks, renderableTitle);
if (!isServerPaddedImage) {
var renderableStyle;
var renderableTitleImage;
if (titleStyle) {
// title style is not null
renderableStyle = titleStyle;
// map equivalent styles
switch (renderableStyle) {
case 3:
// 3 maps to 2
renderableStyle = 2;
break;
case 4:
// 4 maps to 1
renderableStyle = 1;
break;
}
var titleRenderer = titleRenderers[renderableStyle];
if (titleRenderer) {
// title style is recognized
var pageHeight = gridOptions.pageHeight;
var pageWidth = gridOptions.pageWidth;
var screenSize = pageHeight * pageWidth;
var minSize = 1024 * 768;
if (screenSize < minSize) {
// if screen is small, demote title image
renderableStyle = 1;
this._demoteTitleImageToInlineImage(titleImage, renderableBlocks);
this._isLayoutValid = false;
}
else {
switch (renderableStyle) {
case 1:
// demote the title image (if any)
this._demoteTitleImageToInlineImage(titleImage, renderableBlocks);
break;
case 2:
var validateResult2 = this._validateTitleImage(titleImage, renderableBlocks, 1.3, 1.89, 950, renderableStyle, renderableTitleImage);
renderableStyle = validateResult2.renderableStyle;
renderableTitleImage = validateResult2.renderableTitleImage;
break;
case 9:
var validateResult9 = this._validateTitleImage(titleImage, renderableBlocks, 0.5, 0.89, 580, renderableStyle, renderableTitleImage);
renderableStyle = validateResult9.renderableStyle;
renderableTitleImage = validateResult9.renderableTitleImage;
break;
case 100:
// demote the title image (if any)
this._demoteTitleImageToInlineImage(titleImage, renderableBlocks);
break;
}
}
}
else {
// title style is not recognized
renderableStyle = 1;
this._demoteTitleImageToInlineImage(titleImage, renderableBlocks);
}
}
else {
// title style is null
renderableStyle = 1;
this._demoteTitleImageToInlineImage(titleImage, renderableBlocks);
}
renderableTitle.style = renderableStyle;
renderableTitle.titleImage = renderableTitleImage;
}
},
_fixServerPaddedImage: function _fixServerPaddedImage(titleImage, renderableBlocks, renderableTitle) {
// Bug #384490
var isServerPaddedImage = false;
if (titleImage) {
var image = titleImage.image;
if (image) {
var inlineResource = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(image, "inline");
if (inlineResource) {
// approximate the position of the inline image to the halfway between the start of the article and the first block, 
// because we are assuming that the server took the first inline image and padded it
var minPosition = Number.MAX_VALUE;
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
var position = renderableBlock.position;
minPosition = Math.min(minPosition, position);
}
var inlinePosition = (minPosition === Number.MAX_VALUE) ? 0 : Math.max(0, minPosition / 2);
// replace padded image with non-padded image
var originalResource = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(image, "original");
var lowResResource = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(image, "lowRes");
var inlineLowResResource = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(image, "inlineLowRes");
var images = [];
if (inlineLowResResource) {
images.push({
name: "lowRes",
url: inlineLowResResource.url,
width: inlineLowResResource.width,
height: inlineLowResResource.height,
});
}
images.push({
name: "original",
url: inlineResource.url,
width: inlineResource.width,
height: inlineResource.height,
});
// create inline image and add it to the list of blocks
var block = {
type: "InlineImage",
attributes: {
image: {
attribution: image.attribution,
caption: image.caption,
altText: image.altText,
images: images,
},
},
};
var inlineRenderableBlock = this._createRenderableBlock(block, inlinePosition);
renderableBlocks.push(inlineRenderableBlock);
// remove title image
isServerPaddedImage = true;
renderableTitle.style = 1;
renderableTitle.titleImage = null;
}
}
}
return isServerPaddedImage;
},
_validateTitleImage: function _validateTitleImage(titleImage, renderableBlocks, minAspectRatio, maxAspectRatio, minWidth, renderableStyle, renderableTitleImage) {
if (titleImage) {
var imageResource = CommonJS.ArticleReader.ArticleReaderUtils.getImageResource(titleImage.image);
// title image exists
var width = imageResource.width;
var height = imageResource.height;
var aspectRatio = width / height;
if (aspectRatio < minAspectRatio || aspectRatio > maxAspectRatio || width < minWidth) {
// title image is not valid, demote it and go to 1
this._demoteTitleImageToInlineImage(titleImage, renderableBlocks);
renderableStyle = 1;
}
else {
// title image is valid, use it
renderableTitleImage = titleImage;
}
}
else {
// if no title image, go to 1
renderableStyle = 1;
}
return {
renderableStyle: renderableStyle,
renderableTitleImage: renderableTitleImage,
};
},
_demoteTitleImageToInlineImage: function _demoteTitleImageToInlineImage(titleImage, renderableBlocks) {
if (titleImage) {
var block = {
type: "InlineImage",
attributes: titleImage,
};
var renderableBlock = this._createRenderableBlock(block, 0);
renderableBlocks.push(renderableBlock);
}
},
_maybeConvertToJsonArray: function _maybeConvertToJsonArray(array) {
var jsonArray;
if (array && array.length) {
jsonArray = [];
for (var i = 0, len = array.length; i < len; i++) {
var item = array[i];
jsonArray.push(item);
}
}
return jsonArray || null;
},
_processTitle: function _processTitle(renderableTitle, renderableBlocks, context) {
var surfaceManager = this._surfaceManager;
var style = renderableTitle.style;
var titleRenderer = CommonJS.ArticleReader.SurfaceManager.titleRenderers[style];
// convert the title into an array of renderable blocks
var titleBlocks = titleRenderer.render(renderableTitle, context);
var titleRenderableBlocks = {};
// add title blocks to renderable blocks
for (var k in titleBlocks) {
var titleBlock = titleBlocks[k];
var renderableBlock = this._createRenderableBlock(titleBlock, -1);
renderableBlocks.push(renderableBlock);
titleRenderableBlocks[k] = renderableBlock;
}
return titleRenderableBlocks;
},
_createRenderableBlock: function _createRenderableBlock(block, position) {
var renderableBlock = {
block: block,
position: position,
layout: null,
element: null,
exclusion: null,
};
return renderableBlock;
},
_renderImpl: function _renderImpl(data, renderOptions, context) {
var that = this;
var promise = WinJS.Promise.wrap(null);
promise = promise
.then(function () {
// calibrate
return that._calibrateLayout(context);
})
.then(function () {
// populate surface and blocks
return that._populateSurface(context);
})
.then(function () {
// calculate layout
return that._calculateLayout(context);
})
.then(function () {
// associate layout with surface
return that._associateLayoutWithElements(context, false);
})
.then(function () {
// fix page estimates and trailing blocks
return that._adjustSurface(context, false);
})
.then(function () {
that._isRendered = true;
});
return promise;
},
_renderImplFromLayout: function _renderImplFromLayout(layout, renderOptions, context) {
var that = this;
var promise = WinJS.Promise.wrap(null);
promise = promise
.then(function () {
// populate surface and blocks
return that._populateSurface(context);
})
.then(function () {
// set layouts from data
that._setLayout(layout, context);
// associate layout with surface
that._associateLayoutWithElements(context, true);
})
.then(function () {
// if text attributes in the layout don't match the context, adjust them
return that._maybeAdjustTextAttributes(layout, context);
})
.then(function () {
// fix surface size etc.
return that._adjustSurface(context, true);
})
.then(function () {
that._isRendered = true;
});
return promise;
},
_relayoutImpl: function _relayoutImpl(context) {
var that = this;
var promise = WinJS.Promise.wrap(null);
promise = promise
.then(function () {
// initialize surface
that._initializeSurface(context);
// calibrate
that._calibrateLayout(context);
// calculate layout
that._calculateLayout(context);
// associate layout with surface
return that._associateLayoutWithElements(context, false);
})
.then(function () {
return that._adjustSurface(context, false);
});
return promise;
},
_relayoutImplFromLayout: function _relayoutImplFromLayout(layout, context) {
var that = this;
var promise = WinJS.Promise.wrap(null);
promise = promise
.then(function () {
// initialize surface
that._initializeSurface(context);
// set layouts from layout data
that._setLayout(layout, context);
// associate layout with surface
return that._associateLayoutWithElements(context, true);
})
.then(function () {
// if text attributes in the layout don't match the context, adjust them
return that._maybeAdjustTextAttributes(layout, context);
})
.then(function () {
// fix page estimates and trailing blocks
return that._adjustSurface(context, true);
});
return promise;
},
_maybeAdjustTextAttributes: function _maybeAdjustTextAttributes(layout, context) {
var auxiliaryData = context.auxiliaryData;
var textAttributes = auxiliaryData.textAttributes;
var layoutProperties = layout.properties;
var isMatch = U.doTextAttributesMatch(layoutProperties, textAttributes);
var promise = WinJS.Promise.wrap(null);
if (!isMatch) {
promise = this.setTextAttributes(textAttributes);
}
return promise;
},
_setLayout: function _setLayout(layout, context) {
var renderData = context.renderData;
var layoutData = context.layoutData;
var renderableBlocks = renderData.renderableBlocks;
var compressedHints = layout.hints;
var hints = CommonJS.ArticleReader.ArticleReaderUtils.expandHints(compressedHints);
var blockLayouts = hints.blockLayouts;
var pageCount = hints.pageCount;
if (blockLayouts.length !== renderableBlocks.length) {
throw "layout is not valid";
}
// set layout on each block
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
var blockLayout = blockLayouts[i];
renderableBlock.layout = blockLayout;
}
// set page count
layoutData.pageCount = pageCount;
},
_createEndBlocks: function _createEndBlocks(context) {
var renderData = context.renderData;
var endRenderableBlocks = renderData.endRenderableBlocks;
if (!this._containsBlockOfType(endRenderableBlocks, "EndAd")) {
this._createEndAd(context);
}
if (!this._containsBlockOfType(endRenderableBlocks, "Actions")) {
this._createActions(context);
}
this._sort(endRenderableBlocks);
},
_containsBlockOfType: function _containsBlockOfType(renderableBlocks, type) {
var contains = false;
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
var block = renderableBlock.block;
if (block.type === type) {
contains = true;
break;
}
}
return contains;
},
_createEndAd: function _createEndAd(context) {
var renderData = context.renderData;
var endRenderableBlocks = renderData.endRenderableBlocks;
var auxiliaryData = context.auxiliaryData;
var adGroups = auxiliaryData.adGroups;
// extract out the end ad metadata
var endAdMetadata = null;
for (var i = 0, len = adGroups.length; i < len; i++) {
var adGroup = adGroups[i];
var type = adGroup.type;
if (type === "end") {
var adMetadatas = adGroup.adMetadatas;
if (adMetadatas && adMetadatas.length) {
endAdMetadata = adMetadatas[0];
break;
}
}
}
if (endAdMetadata) {
var parsedEndAdMetadata = JSON.parse(endAdMetadata);
var endAdControlType = parsedEndAdMetadata.controlType;
var endAdControlOptions = parsedEndAdMetadata.controlOptions;
var endAdBlock = {
type: "EndAd",
attributes: {
controlOptions: endAdControlOptions,
controlType: endAdControlType,
},
};
var renderableBlock = this._createRenderableBlock(endAdBlock, -10);
endRenderableBlocks.push(renderableBlock);
}
},
_createActions: function _createActions(context) {
var renderData = context.renderData;
var endRenderableBlocks = renderData.endRenderableBlocks;
var auxiliaryData = context.auxiliaryData;
var articleActions = auxiliaryData.articleActions;
var hasActions = false;
if (articleActions) {
for (var key in articleActions) {
hasActions = true;
break;
}
}
if (hasActions) {
var actionsHandlerType = auxiliaryData.actionsHandlerType;
var actionsBlock = {
type: "Actions",
attributes: {
articleActions: articleActions,
actionsHandlerType: actionsHandlerType,
},
};
var renderableBlock = this._createRenderableBlock(actionsBlock, -30);
endRenderableBlocks.push(renderableBlock);
}
},
_updateInstrumentationData: function _updateInstrumentationData(isRender, layout, renderData) {
var renderInfo = this._getRenderInfo(isRender, layout, renderData);
var instrumentationData = this._instrumentationData;
if(instrumentationData){
instrumentationData.renderType = renderInfo;
instrumentationData.pageCount = this.getPageCount();
}
if (PlatformJS.isDebug) {
this._updateDebugIndicator(renderInfo);
}
},
_updateDebugIndicator: function _updateDebugIndicator(text) {
if (this._elt) {
var indicator = this._elt.querySelector(".debugIndicator");
if (!indicator) {
indicator = document.createElement("div");
indicator.className = "debugIndicator";
indicator.setAttribute("style", "height:20px;width:300px;-ms-grid-row:1;-ms-grid-column:1;-ms-grid-row-align:start;-ms-grid-column-align:start;z-index:100;font-weight:bold;font-family:segoe ui;");
indicator.style.color = "white";
indicator.style.backgroundColor = "rgba(255, 0, 0, 0.5)";
var surface = this._elt.querySelector(".surface");
if (surface) {
surface.appendChild(indicator);
}
}
indicator.innerText = text;
}
},
_getRenderInfo: function _getRenderInfo(isRender, layout, renderData) {
var renderInfo = isRender ? "Layout" : "Relayout";
if (layout) {
renderInfo += "-Hints";
renderInfo += layout.isClientGenerated ? "-Client" : "-Server";
}
else {
if (renderData) {
renderInfo += "-UnusableHints";
renderInfo += renderData.isClientGenerated ? "-Client" : "-Server";
}
else {
renderInfo += "-NoHints";
}
}
return renderInfo;
},
},
{
/// <summary>Maxiumum length of snippet used for sharing.</summary>
_maxSnippetLength: 100,
})
});
})();
/* File: ArticleReaderOrchestrator.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Manages a scrollable panorama of article readers
WinJS.Namespace.define("CommonJS.ArticleReader", {
ArticleReaderOrchestrator: WinJS.Class.mix(WinJS.Class.define(
function (elt, options) {
/// <summary>
/// Creates an instance of ArticleReaderOrchestrator.
/// </summary>
/// <param name="options">
/// - market: Market of the article reader page
/// </param>
// zoomable
var zoomable = this._zoomable = elt || document.createElement("div");
zoomable.className = "zoomable";
// viewport
var viewport = this._viewport = document.createElement("div");
WinJS.Utilities.addClass(viewport, "orchestrator");
zoomable.appendChild(viewport);
// panel
var panel = this._panel = document.createElement("div");
WinJS.Utilities.addClass(panel, "panel viewport"); // For Bug #402198, need to add "viewport" as a classname for backward compat with the CSS that CMS generates for partner panos
viewport.appendChild(panel);
// viewport events
var scrollListener = this._scrollListener = this._onScroll.bind(this);
viewport.addEventListener("scroll", scrollListener);
// paginated view manager for keyboard/mouse scroll
var paginatedViewManager = this._paginatedViewManager = new CommonJS.ArticleReader.ArticleReaderPaginatedViewManager({
orchestrator: this,
});
paginatedViewManager.attachEventListeners(elt);
this._articles = {};
this._redrawPromise = WinJS.Promise.wrap(null);
this._currentArticleId = null;
this._pageWidth = 0;
this._pageHeight = 0;
this._scrollTimer = null;
this._monitorScroll = true;
this._market = options.market;
Object.defineProperties(this, WinJS.Utilities.createEventProperties("swipetounrealizedarticle"));
Object.defineProperties(this, WinJS.Utilities.createEventProperties("nearunrealizedarticle"));
Object.defineProperties(this, WinJS.Utilities.createEventProperties("scrolltoarticle"));
},
{
_viewport: null,
_panel: null,
_articles: null,
_redrawPromise: null,
_currentArticleId: null,
_pageWidth: null,
_pageHeight: null,
_scrollListener: null,
_scrollTimer: null,
_monitorScroll: null,
_paginatedViewManager: null,
_staticPositionTimer: null,
_scrollAnimationTimeout: null,
_zoomable: null,
_market: null,
viewport: {
get: function get() {
return this._viewport;
},
},
zoomable: {
get: function get() {
return this._zoomable;
},
},
currentArticleId: {
get: function get() {
return this._currentArticleId;
},
},
nextArticleId: {
get: function get() {
var nextArticleId = null;
var articles = this._articles;
var currentArticleId = this._currentArticleId;
var currentArticle = articles[currentArticleId];
if (currentArticle) {
var nextArticle = currentArticle.next;
if (nextArticle) {
nextArticleId = nextArticle.articleId;
}
}
return nextArticleId;
},
},
previousArticleId: {
get: function get() {
var previousArticleId = null;
var articles = this._articles;
var currentArticleId = this._currentArticleId;
var currentArticle = articles[currentArticleId];
if (currentArticle) {
var previousArticle = currentArticle.previous;
if (previousArticle) {
previousArticleId = previousArticle.articleId;
}
}
return previousArticleId;
},
},
currentPageIndex: {
get: function get() {
return this._getCurrentPageIndex(this.currentArticleId);
},
},
focusViewport: function focusViewport() {
this._viewport.focus();
},
dispose: function dispose() {
var panel = this._panel;
var viewport = this._viewport;
var zoomable = this._zoomable;
var scrollListener = this._scrollListener;
viewport.removeEventListener("scroll", scrollListener);
var paginatedViewManager = this._paginatedViewManager;
paginatedViewManager.dispose();
var articles = this._articles;
for (var articleId in articles) {
var article = articles[articleId];
if (!article) {
continue;
}
var articleReader = article.articleReader;
var placeholder = article.placeholder;
if (articleReader) {
articleReader.dispose();
}
if (placeholder) {
placeholder.dispose();
}
}
var scrollTimer = this._scrollTimer;
clearTimeout(scrollTimer);
},
setTextAttributes: function setTextAttributes(textAttributes) {
var that = this;
var promise = WinJS.Promise.wrap(null);
var currentArticleId = this._currentArticleId;
var articles = this._articles;
var article = articles[currentArticleId];
if (article) {
var articleReader = article.articleReader;
if (articleReader) {
var pageIndex = this._getCurrentPageIndex(currentArticleId);
promise = articleReader.setTextAttributes(textAttributes)
.then(function () {
that._removeAllButCurrent();
that._adjustViewport(false);
that._scrollToPageIndex(currentArticleId, pageIndex);
});
}
}
return promise;
},
getHeader: function getHeader() {
var currentArticleId = this._currentArticleId;
var articles = this._articles;
var header;
var article = articles[currentArticleId];
if (article) {
var articleReader = article.articleReader;
if (articleReader) {
header = articleReader.getHeader();
}
}
return header;
},
isArticleRendered: function isArticleRendered(articleId) {
/// <summary>
/// Returns true if the given articleId is currently rendered in the panorama.
/// </summary>
var isRendered = false;
var articles = this._articles;
var article = articles[articleId];
if (article) {
var articleReader = article.articleReader;
isRendered = articleReader ? true : false;
}
return isRendered;
},
getPageWidth: function getPageWidth() {
/// <summary>
/// Returns the current page width used to render the articles.
/// </summary>
return this._pageWidth;
},
getPageHeight: function getPageHeight() {
/// <summary>
/// Returns the current page height used to render the articles.
/// </summary>
return this._pageHeight;
},
render: function render(articleId, data, renderOptions, navigateOptions, preRender) {
var that = this;
var redrawPromise = that._redrawPromise = that._redrawPromise.then(function () {
return that._renderImpl(articleId, data, renderOptions, navigateOptions, preRender);
});
return redrawPromise;
},
relayout: function relayout(relayoutOptions) {
var that = this;
var redrawPromise = that._redrawPromise = that._redrawPromise.then(function () {
return that._relayoutImpl(relayoutOptions);
});
return redrawPromise;
},
scrollToArticle: function scrollToArticle(articleId) {
var exists = !!this._articles[articleId];
if (exists) {
this._currentArticleId = articleId;
this._adjustWindow();
}
},
showArticleError: function showArticleError(articleId, errorCode, errorCallback) {
var articles = this._articles;
var article = articles[articleId];
this._monitorScroll = true;
if (article) {
CommonJS.Error.showError(errorCode, errorCallback, null, null, article.placeholder.element);
}
else {
CommonJS.Error.showError(errorCode, errorCallback, null, null, null);
}
},
articleFocusLost: function articleFocusLost(oldArticleId) {
var articles = this._articles;
var oldArticle = articles[oldArticleId];
if (oldArticle) {
var oldArticleReader = oldArticle.articleReader;
if (oldArticleReader) {
oldArticleReader.articleFocusLost();
}
}
},
hasNextPage: function hasNextPage() {
/// <summary>
/// Returns true if there is a next page.
/// </summary>
var articleId = this._currentArticleId;
var articles = this._articles;
var article = articles[articleId];
if (!article) {
return false;
}
var hasNext = false;
var next = article.next;
if (next) {
hasNext = true;
}
else {
var articleReader = article.articleReader;
var pageCount = getPageCount(article);
var pageIndex = this._getCurrentPageIndex(articleId);
hasNext = (pageIndex < pageCount - 1);
}
return hasNext;
},
hasPreviousPage: function hasPreviousPage() {
/// <summary>
/// Returns true if there is a previous page.
/// </summary>
var articleId = this._currentArticleId;
var articles = this._articles;
var article = articles[articleId];
if (!article) {
return false;
}
var hasPrevious = false;
var previous = article.previous;
if (previous) {
hasPrevious = true;
}
else {
var pageIndex = this._getCurrentPageIndex(articleId);
hasPrevious = (pageIndex > 0);
}
return hasPrevious;
},
scrollOnePage: function scrollOnePage(direction) {
/// <summary>
/// Scrolls the viewport by one page. direction = 1 means scroll next, direction = 2 means scroll previous.
/// </summary>
var pageWidth = this._pageWidth;
var panel = this._panel;
var viewport = this._viewport;
var scrollLeft = viewport.scrollLeft;
var modifier = 0;
if (direction === 1) {
modifier = 1;
}
else if (direction === 2) {
modifier = -1;
}
var marketDirection = window.getComputedStyle(viewport).direction;
var directionModifier = marketDirection === "ltr" ? -1 : 1;
if ((direction === 1 && this.hasNextPage()) || (direction === 2 && this.hasPreviousPage())) {
var newScrollLeft = (Math.round(scrollLeft / pageWidth) + modifier) * pageWidth;
panel.style.msTransitionProperty = "transform";
panel.style.msTransitionDuration = "0.25s";
panel.style.msTransform = "translate(" + ((modifier * pageWidth) * directionModifier) + "px, 0px)";
clearTimeout(this._scrollAnimationTimeout);
this._scrollAnimationTimeout = setTimeout(function () {
panel.style.msTransitionProperty = "";
panel.style.msTransitionDuration = "";
panel.style.msTransform = "";
viewport.scrollLeft = newScrollLeft;
}, 260);
}
},
scrollToStartOfCurrentArticle: function scrollToStartOfCurrentArticle() {
/// <summary>
/// Scrolls to the first page of the current article.
/// </summary>
var articleId = this._currentArticleId;
this._scrollToPageIndex(articleId, 0);
},
scrollToEndOfCurrentArticle: function scrollToEndOfCurrentArticle() {
/// <summary>
/// Scrolls to the last page of the current article.
/// </summary>
var articleId = this._currentArticleId;
this._scrollToPageIndex(articleId, Number.MAX_VALUE);
},
getInstrumentationData: function getInstrumentationData(articleId) {
var instrumentationData = null;
var articles = this._articles;
var article = articles[articleId];
if (article) {
var articleReader = article.articleReader;
if (articleReader) {
instrumentationData = articleReader.getInstrumentationData();
}
}
return instrumentationData;
},
getLayout: function getLayout(articleId) {
var layout = null;
var articles = this._articles;
var article = articles[articleId];
if (article) {
var articleReader = article.articleReader;
if (articleReader) {
layout = articleReader.getLayout();
}
}
return layout;
},
getRenderData: function getRenderData(articleId) {
var renderData = null;
var articles = this._articles;
var article = articles[articleId];
if (article) {
var articleReader = article.articleReader;
if (articleReader) {
renderData = articleReader.getRenderData();
}
}
return renderData;
},
_renderImpl: function _renderImpl(articleId, data, renderOptions, navigateOptions, preRender) {
var that = this;
var articles = this._articles;
var promise = WinJS.Promise.wrap(null);
// update page width
var gridOptions = renderOptions.gridOptions;
var pageWidth = gridOptions.pageWidth;
var pageHeight = gridOptions.pageHeight;
this._setPageDimensions(pageWidth, pageHeight);
var panel = this._panel;
var articleReader;
var renderPromise;
var renderResult;
var containerElement;
var article = articles[articleId];
if (article) {
// article exists
articleReader = article.articleReader;
// if(article), article has already been rendered
// scroll to it later
if (!articleReader) {
// article hasn't been rendered
// render article and append it to the dom
containerElement = article.containerElement;
renderResult = this._renderArticleOrAd(articleId, data, renderOptions, preRender, containerElement);
if (renderResult) {
// Get direction
var direction = 1;
if (article.next !== null &&
article.previous === null) {
direction = 2;
}
// setup next and prev articles
this._createNextAndPrevious(data, article);
renderPromise = renderResult.renderPromise
.then(function () {
that._removePlaceholder(article);
article.pendingLoad = false;
}, function error() {
// If this was an ad page that failed to render
if (that && that._isAdPage(data)) {
// Remove article from view
that._removeArticleFromView(article, direction);
}
// Clear pending load flag
article.pendingLoad = false;
})
.then(function () {
var adjustScrollPosition = article.pageCount;
article.pageCount = null;
article.containerElement.style.width = "";
// when navigateOptions is -1, it means the bottom edgy next/prev buttons were used to navigate, 
// in which case we want to scroll to the first page of the target article
return (navigateOptions === -1) ? 0 : adjustScrollPosition;
});
articleReader = renderResult.articleReader;
article.articleReader = articleReader;
promise = renderPromise;
}
}
}
else {
// article does not exist
// TODO: clear existing articles if any
// render article
containerElement = this._createContainerElement();
panel.appendChild(containerElement);
renderResult = this._renderArticleOrAd(articleId, data, renderOptions, preRender, containerElement);
if (renderResult) {
renderPromise = renderResult.renderPromise;
articleReader = renderResult.articleReader;
promise = renderPromise;
// create article
var placeholder = this._createPlaceholder();
var newArticle = {
articleId: articleId,
articleReader: articleReader,
placeholder: placeholder,
containerElement: containerElement,
next: null,
previous: null,
order: 0,
};
articles[articleId] = newArticle;
// set up next and prev
this._createNextAndPrevious(data, newArticle);
}
}
// set current article
if (!preRender) {
var oldArticleId = this._currentArticleId;
this.articleFocusLost(oldArticleId);
this._currentArticleId = articleId;
this._monitorScroll = false;
}
promise = promise.then(
function (adjustScrollPosition) {
var adjustWindow = !(preRender || adjustScrollPosition);
that._adjustViewport(adjustWindow);
that._monitorScroll = true;
that._adjustArticleContainer(articleId, true);
if (!preRender) {
that._processNavigateOptions(articleId, navigateOptions);
that._maybeDispatchNear();
}
});
return promise;
},
_relayoutImpl: function _relayoutImpl(relayoutOptions) {
var that = this;
var currentArticleId = this._currentArticleId;
var articles = this._articles;
var promise = WinJS.Promise.wrap(null);
// update page width
var gridOptions = relayoutOptions.gridOptions;
var pageWidth = gridOptions.pageWidth;
var pageHeight = gridOptions.pageHeight;
var oldPageWidth = this._pageWidth;
this._setPageDimensions(pageWidth, pageHeight);
var currentArticle = articles[currentArticleId];
if (currentArticle) {
var articleReader = currentArticle.articleReader;
var pageIndex = 0;
if (articleReader) {
pageIndex = Math.max(this._getCurrentPageIndex(currentArticleId, oldPageWidth), 0);
promise = articleReader.relayout(relayoutOptions);
}
promise = promise.then(function () {
that._removeAllButCurrent();
that._adjustViewport(false); // no need to adjust window because we are scrolling right after
that._scrollToPageIndex(currentArticleId, pageIndex, pageWidth);
that._maybeDispatchNear();
});
}
return promise;
},
_createViewportManager: function _createViewportManager(articleId) {
var that = this;
return {
paginatedViewManager: that._paginatedViewManager,
scrollToPageIndex: function scrollToPageIndex(pageIndex, pageWidth) {
return that._scrollToPageIndex(articleId, pageIndex, pageWidth);
},
getCurrentPageIndex: function getCurrentPageIndex(pageWidth) {
return that._getCurrentPageIndex(articleId, pageWidth);
},
};
},
_scrollToPageIndex: function _scrollToPageIndex(articleId, pageIndex, pageWidth) {
/// <summary>
/// Scrolls the viewport to the given 0-based page index. If pageIndex is beyond the end of the article, scrolls to the last page.
/// </summary>
pageWidth = pageWidth || this._pageWidth;
var currentArticleId = this._currentArticleId;
if (currentArticleId === articleId) {
var viewport = this._viewport;
var articles = this._articles;
var article = articles[articleId];
var newPageIndex = pageIndex;
if (article) {
var articleReader = article.articleReader;
if (articleReader) {
var pageCount = getPageCount(article);
var maxIndex = pageCount - 1;
newPageIndex = Math.min(pageIndex, maxIndex);
}
}
var previousPageCount = this._getPreviousPageCount(article);
viewport.scrollLeft = (previousPageCount + newPageIndex) * pageWidth;
}
},
_getCurrentPageIndex: function _getCurrentPageIndex(articleId, pageWidth) {
/// <summary>
/// Returns the index of the current page the scroll position is on. Rounds to the nearest page.
/// </summary>
pageWidth = pageWidth || this._pageWidth;
var viewport = this._viewport;
var currentArticleId = this._currentArticleId;
var pageIndex = -1;
if (currentArticleId === articleId) {
var articles = this._articles;
var article = articles[articleId];
var previousPageCount = this._getPreviousPageCount(article);
pageIndex = Math.round(viewport.scrollLeft / pageWidth - previousPageCount);
}
return pageIndex;
},
_processNavigateOptions: function _processNavigateOptions(articleId, navigateOptions) {
if (navigateOptions) {
var startPage = navigateOptions.startPage;
var isStartPageValid = CommonJS.ArticleReader.ArticleReaderUtils.isNumber(startPage);
if (isStartPageValid) {
// start page is provided, honor it
this._scrollToPageIndex(articleId, startPage);
}
}
},
_removePlaceholder: function _removePlaceholder(article) {
var placeholder = article.placeholder;
var containerElement = article.containerElement;
containerElement.removeChild(placeholder.element);
},
_removeAllButCurrent: function _removeAllButCurrent() {
var articles = this._articles;
var currentArticleId = this._currentArticleId;
var panel = this._panel;
var currentArticle = articles[currentArticleId];
if (currentArticle) {
var next = currentArticle.next;
var previous = currentArticle.previous;
for (var articleId in articles) {
var article = articles[articleId];
if (next && article === next) {
// unchain next from the rest, dispose its article reader, and show its placeholder
next.next = null;
var nextContainerElement = next.containerElement;
var nextPlaceholder = next.placeholder;
nextContainerElement.appendChild(nextPlaceholder.element);
var nextArticleReader = next.articleReader;
if (nextArticleReader) {
nextContainerElement.removeChild(nextArticleReader.element);
nextArticleReader.dispose();
next.articleReader = null;
}
this._adjustArticleContainer(nextContainerElement, false);
}
else if (previous && article === previous) {
// unchain previous from the rest, dispose its article reader, and show its placeholder
previous.previous = null;
var previousContainerElement = previous.containerElement;
var previousPlaceholder = previous.placeholder;
previousContainerElement.appendChild(previousPlaceholder.element);
var previousArticleReader = previous.articleReader;
if (previousArticleReader) {
previousContainerElement.removeChild(previousArticleReader.element);
previousArticleReader.dispose();
previous.articleReader = null;
}
this._adjustArticleContainer(previousContainerElement, false);
}
else if (article !== currentArticle) {
// remove everything else from the dom
var articleReader = article.articleReader;
var placeholder = article.placeholder;
if (articleReader) {
articleReader.dispose();
}
if (placeholder) {
placeholder.dispose();
}
var containerElement = article.containerElement;
//HACK: #399248.  Because a failing interstitial ad removes it's element
//                from the panel but doesn't update the linked list accordingly,
//                walking the list to remove elements from the surface
//                throws a parenting exception.  For now, introducing
//                an IF block mitigates the issue but a broader change
//                that would update the list has to be considered
if (containerElement.parentElement === panel) {
panel.removeChild(containerElement);
}
delete articles[articleId];
}
}
}
},
_cleanupPreviousArticles: function _cleanupPreviousArticles(scrollPosition) {
function introducePlaceholder(article) {
var containerElement = article.containerElement,
placeholder = article.placeholder,
articleReader = article.articleReader;
if (articleReader) {
var pageCount = article.pageCount = getPageCount(article);
containerElement.style.width = (pageCount * 100) + "vw";
containerElement.removeChild(article.articleReader.element);
containerElement.appendChild(placeholder.element);
article.articleReader.dispose();
article.articleReader = null;
this._adjustArticleContainer(containerElement, false);
}
}
var currentArticleId = this._currentArticleId,
articles = this._articles,
instance = articles[currentArticleId];
// null case, there is no current or previous article
if (!instance || !instance.previous) {
return;
}
// we keep one back-log entry
instance = instance.previous;
if (!instance.previous) {
return;
}
// start introducing placeholders
instance = instance.previous;
while (instance) {
if (instance.articleReader) {
introducePlaceholder.apply(this, [instance]);
}
instance = instance.previous;
}
},
_adjustViewport: function _adjustViewport(adjustWindow) {
this._adjustArticlesInGrid();
if (adjustWindow) {
this._adjustWindow();
}
},
_adjustArticleContainer: function _adjustArticleContainer(articleId, hasContent) {
var articles = this._articles;
var article = articles[articleId];
if (article) {
var containerElement = article.containerElement;
if (hasContent) {
WinJS.Utilities.addClass(containerElement, "hasContent");
WinJS.Utilities.removeClass(containerElement, "noContent");
}
else {
WinJS.Utilities.addClass(containerElement, "noContent");
WinJS.Utilities.removeClass(containerElement, "hasContent");
}
}
},
_adjustArticlesInGrid: function _adjustArticlesInGrid() {
// figure out the grid columns for each article/placeholder
var articles = this._articles;
var minOrder = this._getMinOrder(articles);
for (var key in articles) {
var article = articles[key];
var order = article.order;
var gridColumn = (order - minOrder + 1).toString();
var containerElement = article.containerElement;
if (!article.errorSkip) {
this._maybeSetStyle(containerElement, "msGridColumn", gridColumn);
}
}
},
_maybeSetStyle: function _maybeSetStyle(element, name, value) {
if (!element.currentStyle || element.currentStyle[name] !== value) {
element.style[name] = value;
}
},
_adjustWindow: function _adjustWindow() {
// adjust the visible window into the viewport to match the current article
var currentArticleId = this._currentArticleId;
var viewport = this._viewport;
var pageWidth = this._pageWidth;
var bounds = this._getArticleBounds(currentArticleId);
var start = bounds.start;
var startPixels = start * pageWidth;
viewport.scrollLeft = startPixels;
},
_getMinOrder: function _getMinOrder(articles) {
var minOrder = Number.MAX_VALUE;
for (var key in articles) {
var article = articles[key];
var order = article.order;
minOrder = Math.min(minOrder, order);
}
return minOrder;
},
_createNextAndPrevious: function _createNextAndPrevious(data, article) {
var articles = this._articles;
var nextArticle = data.nextArticle;
var previousArticle = data.previousArticle;
var order = article.order;
var panel = this._panel;
if (nextArticle) {
var nextArticleId = nextArticle.articleId;
if (!articles[nextArticleId]) {
var nextOrder = order + 1;
var nextPlaceholder = this._createPlaceholder();
var nextContainerElement = this._createContainerElement();
nextContainerElement.appendChild(nextPlaceholder.element);
panel.appendChild(nextContainerElement);
var next = {
articleId: nextArticleId,
articleReader: null,
placeholder: nextPlaceholder,
containerElement: nextContainerElement,
next: null,
previous: article,
order: nextOrder,
};
articles[nextArticleId] = next;
article.next = next;
}
}
if (previousArticle) {
var previousArticleId = previousArticle.articleId;
if (!articles[previousArticleId]) {
var previousOrder = order - 1;
var previousPlaceholder = this._createPlaceholder();
var previousContainerElement = this._createContainerElement();
previousContainerElement.appendChild(previousPlaceholder.element);
panel.appendChild(previousContainerElement);
var previous = {
articleId: previousArticleId,
articleReader: null,
placeholder: previousPlaceholder,
containerElement: previousContainerElement,
next: article,
previous: null,
order: previousOrder,
};
articles[previousArticleId] = previous;
article.previous = previous;
}
}
},
_removeArticleFromView: function _removeArticleFromView(article, direction) {
// Validate article and panel
var panel = this._panel;
if (!article || !panel) {
return;
}
// Validate article Id
var articleId = article.articleId;
if (!articleId) {
// Nothing to do
return;
}
// Article must have at least a previous or next pointer
if (!article.next && !article.previous) {
// Can't remove only article
return;
}
// Get current article Id
var currentArticleId = this._currentArticleId;
// If we're on the article
var scrollToArticleId = null;
if (currentArticleId === articleId) {
// Try going to next article since current
// article is getting removed
var nextArticle = article.next;
var prevArticle = article.previous;
if (direction === 2) {
scrollToArticleId = prevArticle.articleId;
if (!scrollToArticleId) {
scrollToArticleId = nextArticle.articleId;
}
} else {
scrollToArticleId = nextArticle.articleId;
if (!scrollToArticleId) {
scrollToArticleId = prevArticle.articleId;
}
}
}
// Relink and remove article from view
if (article.previous && article.previous.next) {
article.previous.next = article.next;
}
if (article.next && article.next.previous) {
article.next.previous = article.previous;
}
article.previous = null;
article.next = null;
// Re-adjust articles in grid
article.errorSkip = true;
this._adjustArticlesInGrid();
// Get article reader and placeholder
var articleReader = article.articleReader;
var placeholder = article.placeholder;
// Dispose of article reader
if (articleReader) {
articleReader.dispose();
article.articleReader = null;
}
// Dispose of placeholder
if (placeholder) {
placeholder.dispose();
}
// Remove container element from the dom
var containerElement = article.containerElement;
if (containerElement) {
panel.removeChild(containerElement);
}
// If we need to scroll to article
if (scrollToArticleId !== null) {
// Update current article Id
var oldArticleId = currentArticleId;
currentArticleId = this._currentArticleId = scrollToArticleId;
this._scrolled(currentArticleId, oldArticleId);
}
// Check for near unrealized article
this._maybeDispatchNear();
},
_renderArticleOrAd: function _renderArticleOrAd(articleId, data, renderOptions, preRender, containerElement) {
var result;
var adMetadata = data.metadata ? data.metadata.adMetadata : null;
if (adMetadata) {
result = this._renderInterstitialAd(articleId, data, renderOptions, containerElement);
if (preRender) {
// Set article pending load flag
// since interstitial ads load asynchronously
var articles = this._articles;
if (articles) {
var article = articles[articleId];
if (article) {
article.pendingLoad = true;
}
}
}
}
else {
result = this._renderArticle(articleId, data, renderOptions, containerElement);
}
return result;
},
_renderInterstitialAd: function _renderInterstitialAd(articleId, data, renderOptions, containerElement) {
var interstitialAd = new CommonJS.ArticleReader.InterstitialAd();
var element = interstitialAd.element;
containerElement.appendChild(element);
renderOptions.paginatedViewManager = this._paginatedViewManager;
var renderPromise = interstitialAd.render(data, renderOptions);
var result = {
articleReader: interstitialAd,
renderPromise: renderPromise,
};
return result;
},
_renderArticle: function _renderArticle(articleId, data, renderOptions, containerElement) {
var paginatedViewManager = this._paginatedViewManager;
var articleReader = new CommonJS.ArticleReader.ArticleReader(null, {
paginatedViewManager: paginatedViewManager,
market: this._market,
});
var element = articleReader.element;
containerElement.appendChild(element);
renderOptions.viewportManager = this._createViewportManager(articleId);
var renderPromise = articleReader.render(data, renderOptions);
var result = {
articleReader: articleReader,
renderPromise: renderPromise,
};
return result;
},
_createPlaceholder: function _createPlaceholder() {
var placeholder = new CommonJS.ArticleReader.ArticlePlaceholder();
return placeholder;
},
_createContainerElement: function _createContainerElement() {
var containerElt = document.createElement("div");
WinJS.Utilities.addClass(containerElt, "articleContainer noContent");
return containerElt;
},
_getArticleBounds: function _getArticleBounds(articleId) {
var articles = this._articles;
var article = articles[articleId];
var pageCount = 0;
if (article) {
var articleReader = article.articleReader;
pageCount = getPageCount(article);
}
var previousPageCount = this._getPreviousPageCount(article);
var start = previousPageCount;
var end = previousPageCount + pageCount;
var bounds = {
start: start,
end: end,
};
return bounds;
},
_getPreviousPageCount: function _getPreviousPageCount(article) {
var previousPageCount = 0;
if (article) {
var previous = article.previous;
while (previous) {
previousPageCount += getPageCount(previous);
previous = previous.previous;
}
}
return previousPageCount;
},
_getCurrentArticleIdFromViewport: function _getCurrentArticleIdFromViewport() {
var viewport = this._viewport;
var scrollLeft = viewport.scrollLeft;
var currentArticleId = this._currentArticleId;
var articles = this._articles;
var currentArticle = articles[currentArticleId];
var pageWidth = this._pageWidth;
if ((scrollLeft % pageWidth) !== 0) {
return currentArticleId;
}
var articleId;
var article = currentArticle;
if (article) {
// walk backward to find the first article
while (article.previous) {
article = article.previous;
}
var start = 0;
while (article) {
var articleReader = article.articleReader;
var pageCount = getPageCount(article);
var end = ((start / pageWidth) + pageCount) * pageWidth;
if (start <= scrollLeft && scrollLeft < end) {
articleId = article.articleId;
break;
}
start = end;
article = article.next;
}
}
return articleId;
},
_isAdPage: function _isAdPage(data) {
var isAd = (data && data.metadata && data.metadata.adMetadata);
return isAd;
},
_maybeDispatchNear: function _maybeDispatchNear() {
var that = this;
var articles = this._articles;
var currentArticleId = this._currentArticleId;
var currentArticle = articles[currentArticleId];
if (currentArticle) {
var next = currentArticle.next;
if (next && !next.articleReader) {
var nextArticleId = next.articleId;
that.dispatchEvent("nearunrealizedarticle", nextArticleId);
}
}
},
_maybeDispatchScrollEvents: function _maybeDispatchScrollEvents() {
// If swiped to a different article, fire scrolltoarticle event, only if the article is already realized.
// If the article is not realized, we will not fire the scroll event. The swipetounrealizedarticle will be fired instead.
var that = this;
var articles = this._articles;
var currentArticleId = this._currentArticleId;
var article = articles[currentArticleId];
if (article) {
var articleReader = article.articleReader;
if (!articleReader) {
that.dispatchEvent("swipetounrealizedarticle", currentArticleId);
} else {
that.dispatchEvent("scrolltoarticle", currentArticleId);
if (article.pendingLoad) {
// User swiped to an article that's still loading
CommonJS.ArticleReader.ArticleReaderUtils.showModalProgress();
this._monitorScroll = false;
}
}
}
},
_onScroll: function _onScroll(event) {
var scrollTimer = this._scrollTimer;
var viewport = this._viewport;
var scrollLeft = viewport.scrollLeft;
if (scrollTimer) {
clearTimeout(scrollTimer);
}
this._scrollTimer = setTimeout(this._scrollTimerExpired.bind(this), 25, scrollLeft);
},
_scrollTimerExpired: function _scrollTimerExpired(oldScrollLeft) {
var that = this;
var monitorScroll = this._monitorScroll;
if (monitorScroll) {
var viewport = this._viewport;
var newScrollLeft = viewport.scrollLeft;
this._scrollTimer = null;
if (oldScrollLeft === newScrollLeft) {
// if same scroll position as when the timeout had started, maybe load the unrealized article
var oldArticleId = this._currentArticleId;
var currentArticleId = this._currentArticleId = this._getCurrentArticleIdFromViewport();
if (oldArticleId !== currentArticleId) {
this._scrolled(currentArticleId, oldArticleId);
}
// check for near unrealized article
this._maybeDispatchNear();
}
// clean-up
clearTimeout(this._staticPositionTimer);
this._staticPositionTimer = setTimeout(staticPositionTimerExpired.bind(this), 100, newScrollLeft);
}
},
_scrolled: function _scrolled(currentArticleId, oldArticleId) {
// dispatch scroll events
this._maybeDispatchScrollEvents();
// notify that the old article is longer in focus
this.articleFocusLost(oldArticleId);
},
_setPageDimensions: function _setPageDimensions(pageWidth, pageHeight) {
this._setPageWidth(pageWidth);
this._setPageHeight(pageHeight);
},
_setPageWidth: function _setPageWidth(pageWidth) {
this._pageWidth = pageWidth;
var viewport = this._viewport;
viewport.style.width = pageWidth + "px";
var zoomable = this._zoomable;
zoomable.style.width = pageWidth + "px";
},
_setPageHeight: function _setPageHeight(pageHeight) {
this._pageHeight = pageHeight;
},
}), WinJS.Utilities.eventMixin),
});
function getPageCount(article) {
if (article.articleReader) {
return article.articleReader.getPageCount();
} else if (article.pageCount) {
return article.pageCount;
} else {
return 1;
}
}
function staticPositionTimerExpired(scrollPosition) {
var monitorScroll = this._monitorScroll;
if (monitorScroll) {
var viewport = this._viewport;
var newScrollLeft = viewport.scrollLeft;
if (scrollPosition === newScrollLeft) {
// user is reading / not scrolling, perform clean-up
this._cleanupPreviousArticles(scrollPosition);
}
}
}
})();
/* File: ArticleReaderPaginatedViewManager.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
var U = CommonJS.ArticleReader.ArticleReaderUtils;
// ArticleReaderPaginatedViewManager is derived from PaginatedViewManager.
// It owns the mousewheel, pgup, pgdown, leftarrow, rightarrow events in article reader
// and implements the interface exposed from baseclass for article reader.
WinJS.Namespace.define("CommonJS.ArticleReader", {
ArticleReaderPaginatedViewManager: WinJS.Class.derive(CommonJS.PaginatedViewManager, function (options) {
this._orchestrator = options.orchestrator;
CommonJS.PaginatedViewManager.call(this, options);
// events
this._attach(this._orchestrator, "scrolltoarticle", this._onScroll);
this._attach(this._elt, "scroll", this._onScroll);
},
{
_orchestrator: null,
attachEventListeners: function attachEventListeners(elt) {
this._attach(elt, "wheel", this._wheelListener);
this._attach(elt, "keydown", this._keyDownListener);
this._attach(elt, "MSPointerHover", this._pointerHoverListener);
this._attach(elt, "MSPointerMove", this._pointerMoveListener);
this._attach(elt, "MSPointerDown", this._pointerDownListener);
this._attach(elt, "MSManipulationStateChanged", this._manipulationListener);
},
exclude: function exclude(elt) {
var stopPropagation = this._stopPropagation.bind(this);
this._attach(elt, "wheel", stopPropagation);
this._attach(elt, "keydown", stopPropagation);
this._attach(elt, "MSPointerHover", stopPropagation);
this._attach(elt, "MSPointerMove", stopPropagation);
this._attach(elt, "MSPointerDown", stopPropagation);
this._attach(elt, "MSManipulationStateChanged", stopPropagation);
},
_getContainerElement: function _getContainerElement() {
return this._orchestrator.viewport;
},
_hasNext: function _hasNext() {
return this._orchestrator.hasNextPage();
},
_hasPrevious: function _hasPrevious() {
return this._orchestrator.hasPreviousPage();
},
_onNextPageClick: function _onNextPageClick(event) {
this._orchestrator.scrollOnePage(1);
U.logUserAction(U.actionContext.body, "Next Button");
},
_onPreviousPageClick: function _onPreviousPageClick(event) {
this._orchestrator.scrollOnePage(2);
U.logUserAction(U.actionContext.body, "Previous Button");
},
_wheelListener: function _wheelListener(event) {
var deltaY = event.deltaY;
var orchestrator = this._orchestrator;
if (deltaY > 0) {
orchestrator.scrollOnePage(1);
}
else if (deltaY < 0) {
orchestrator.scrollOnePage(2);
}
event.preventDefault();
},
_keyDownListener: function _keyDownListener(event) {
var orchestrator = this._orchestrator;
var viewport = orchestrator.viewport;
var zoomable = orchestrator.zoomable;
var marketDirection = window.getComputedStyle(zoomable).direction;
var keyCode = event.keyCode;
var direction = null;
this._touch = false;
switch (keyCode) {
case WinJS.Utilities.Key.pageUp:
orchestrator.scrollOnePage(2);
event.preventDefault();
break;
case WinJS.Utilities.Key.leftArrow:
direction = marketDirection === "ltr" ? 2 : 1;
orchestrator.scrollOnePage(direction);
event.preventDefault();
break;
case WinJS.Utilities.Key.pageDown:
orchestrator.scrollOnePage(1);
event.preventDefault();
break;
case WinJS.Utilities.Key.rightArrow:
direction = marketDirection === "ltr" ? 1 : 2;
orchestrator.scrollOnePage(direction);
event.preventDefault();
break;
case WinJS.Utilities.Key.upArrow:
orchestrator.scrollOnePage(2);
event.preventDefault();
break;
case WinJS.Utilities.Key.downArrow:
orchestrator.scrollOnePage(1);
event.preventDefault();
break;
case WinJS.Utilities.Key.home:
orchestrator.scrollToStartOfCurrentArticle();
event.preventDefault();
break;
case WinJS.Utilities.Key.end:
orchestrator.scrollToEndOfCurrentArticle();
event.preventDefault();
break;
}
},
_onScroll: function _onScroll(event) {
var orchestrator = this._orchestrator;
this._maybeUpdateButtons();
var touch = this._touch;
if (!touch) {
this._fixScroll();
}
var viewport = orchestrator.viewport;
var scrollLeft = viewport.scrollLeft;
this._lastScroll = scrollLeft;
},
_fixScroll: function _fixScroll() {
var orchestrator = this._orchestrator;
var viewport = orchestrator.viewport;
var pageWidth = orchestrator.getPageWidth();
var lastScroll = this._lastScroll || 0;
var scrollLeft = viewport.scrollLeft;
if (scrollLeft % pageWidth !== 0) {
var func = (lastScroll - scrollLeft > 0 ? Math.floor : Math.ceil);
viewport.scrollLeft = func(scrollLeft / pageWidth) * pageWidth;
}
},
}),
});
})();
/* File: ArticlePlaceholder.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// 
WinJS.Namespace.define("CommonJS.ArticleReader", {
ArticlePlaceholder: WinJS.Class.define(
function (elt, options) {
/// <summary>
/// Creates an instance of the ArticlePlaceholder control.
/// </summary>
// create the dom elements
elt = this._elt = elt || document.createElement("div");
elt.winControl = this;
WinJS.Utilities.addClass(elt, "placeholder");
},
{
_elt: null,
element: {
get: function get() {
return this._elt;
}
},
dispose: function dispose() {
},
},
{
})
});
})();
/* File: ArticleReaderPage.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
var ApplicationView = Windows.UI.ViewManagement.ApplicationView;
var ApplicationViewState = Windows.UI.ViewManagement.ApplicationViewState;
var Instrumentation = Platform.Instrumentation;
var T = Platform.Telemetry;
var U = CommonJS.ArticleReader.ArticleReaderUtils;
var defaultImpressionContext = "/Article Reader";
var partnerPanoImpressionContext = "/Partner Pano/Article Reader";
WinJS.Namespace.define("CommonJS",
{
/// <summary>
/// The article reader page.
///
/// The state object has the following properties:
///
/// - initialArticleId: string id of the article to request and render initially
/// - startPage: 0-based index of the page within the article to scroll to.
/// - enableSharing: boolean for whether or not sharing is enabled. if enabled, subclass must implement _handleShareRequestImpl()
/// - enableSnap: boolean for whether snapped view is enabled or not
/// - snappedHeaderTitle: string title of the snapped view
/// - snappedHeaderFontColor: string title color of the snapped view
/// - providerType: fully qualified namespace of the IArticleProvider implementation
/// - providerConfiguration: string->string dictionary passed to the provider initializer
/// - theme: theme for styling the article reader's chrome elemnets
/// - contentCssPaths: array of paths to css files that get applied to article content. may be overridden by provider in article metadata.
/// - actionKeys: list of actions that apply to all articles. may be overridden by provider in article metadata.
/// - renderAll: whether to render all blocks or not. may be overridden by provider in article metadata.
/// - adGroups: Definitions for ads within the article. may be overridden by provider in article metadata.
/// - validActions: dictionary of actions and their definitions. These are rendered at the end of the article.
/// - actionsHandlerType: fully qualified namespace of the object that will handle actions. The function onActionInvoked must be defined on this object.
/// - market: used for instrumentation
/// - source: used for instrumentation
/// - page: used for instrumentation
/// - entryPoint: used for instrumentation
/// - adPartnerName: partner name used for determining which set of ads to display
/// </summary>
ArticleReaderPage: WinJS.Class.define(
function articleReaderPage_ctor(state) {
// get data from the state object
this._state = state;
this._isFirstView = true;
// set up page's market
var root = document.getElementById("articleReaderPage");
var market = state.market;
if (root && market) {
root.lang = PlatformJS.Utilities.convertMarketToLanguageCode(market);
}
// set up global config
this._textStyleEnabled = PlatformJS.Services.configuration.getDictionary("ArticleReaderConfig").getBool("TextStyleButtonEnabled", true);
// read settings from storage
this._readSettings();
// convert provider configuration to a managed dictionary
var providerConfiguration = this._providerConfiguration = PlatformJS.Collections.createStringDictionary();
for (var key in state.providerConfiguration) {
providerConfiguration.insert(key, state.providerConfiguration[key]);
}
// create the provider
var providerType = state.providerType;
var provider = this._provider = PlatformJS.Utilities.createObject(providerType);
// setup bottom edgy
this._setupTextAttributes();
this._setupBottomEdgy();
// actionsHandler
var actionsHandlerType = state.actionsHandlerType;
// create article manager
var contentCssPaths = state.contentCssPaths;
var actionKeys = state.actionKeys;
var renderAll = state.renderAll;
var adGroups = state.adGroups;
var initialTextAttributes = this._getCurrentTextAttributes().effective;
var articleManager = this._articleManager = new CommonJS.ArticleReader.ArticleManager({
provider: provider,
bottomEdgy: this._bottomEdgy,
renderOptionsSeed: {
contentCssPaths: contentCssPaths,
actionKeys: actionKeys,
renderAll: renderAll,
adGroups: adGroups,
adPartnerName: state.adPartnerName,
},
initialTextAttributes: initialTextAttributes,
validActions: state.validActions,
actionsHandlerType: actionsHandlerType,
market: state.market,
});
// listen to article changes for instrumentation
var defaultArticleChangedListener = this._defaultArticleChangedListener = this._defaultArticleChanged.bind(this);
articleManager.addEventListener("articlechanged", defaultArticleChangedListener);
var defaultArticleErrorListener = this._defaultArticleErrorListener = this._defaultArticleError.bind(this);
articleManager.addEventListener("articleerror", defaultArticleErrorListener);
this._currentViewState = null;
this._changeView(ApplicationView.value);
this._promise = null;
var theme = state.theme || "defaultArticleReaderTheme";
this._applyTheme(theme);
},
{
_providerConfiguration: null,
_provider: null,
_currentViewState: null,
_state: null,
_promise: null,
_articleManager: null,
_bottomEdgy: null,
_edgyDismissedHandler: null,
_textSizeOptions: null,
_textSizeFlyout: null,
_textStyleOptions: null,
_textStyleButton: null,
_settings: null,
_defaultArticleChangedListener: null,
_defaultArticleErrorListener: null,
_textStyleEnabled: null,
_isFirstView: null,
onNavigateAway: function onNavigateAway() {
},
onSuspending: function onSuspending(event) {
},
dispose: function dispose() {
var promise = this._promise;
if (promise) {
promise.cancel();
}
var articleManager = this._articleManager;
if (articleManager) {
articleManager.removeEventListener("articlechanged", this._defaultArticleChangedListener);
articleManager.removeEventListener("articleerror", this._defaultArticleErrorListener);
articleManager.dispose();
}
var textSizeFlyout = this._textSizeFlyout;
if (textSizeFlyout) {
textSizeFlyout.dispose();
}
var textStyleButton = this._textStyleButton;
if (textStyleButton) {
textStyleButton.dispose();
}
this._bottomEdgy.appBar.removeEventListener("afterhide", this._edgyDismissedHandler);
},
getPageImpressionContext: function getPageImpressionContext() {
return this._state.entryPoint === Platform.Instrumentation.InstrumentationArticleEntryPoint.partnerPano ? partnerPanoImpressionContext : defaultImpressionContext;
},
_defaultArticleChanged: function _defaultArticleChanged(event) {
// update article id in the state object
var state = this._state;
var clientArticleId = event.detail.clientArticleId;
state.initialArticleId = clientArticleId;
// handle instrumentation tasks
var instrumentationData = event.detail.instrumentationData;
if (instrumentationData) {
this._recordArticleView(instrumentationData);
}
},
_defaultArticleError: function _defaultArticleError(event) {
var error = event.detail;
var message = error ? error.message : "";
var stack = error ? error.stack : "";
T.FlightRecorder.logCodeError(T.LogLevel.normal, T.RuntimeEnvironment.javascript, message, stack);
},
_getSettingsContainer: function _getSettingsContainer() {
var roamingSettings = Windows.Storage.ApplicationData.current.roamingSettings;
var container = roamingSettings.createContainer("articleReaderSettings", Windows.Storage.ApplicationDataCreateDisposition.always);
return container;
},
_writeSettings: function _writeSettings() {
var container = this._getSettingsContainer();
// write text size and text style to roaming settings container
var settings = this._settings;
container.values["textSize"] = settings.textSize;
container.values["textStyle"] = settings.textStyle;
},
_readSettings: function _readSettings() {
var container = this._getSettingsContainer();
var config = PlatformJS.Services.configuration.getDictionary("ArticleReaderConfig");
// text size default
var xlargeEnabled = config.getBool("XLargeTextSizeEnabled");
var sizeDefaultConfig = config.getString("DefaultTextSize").toLowerCase();
var sizeDefault = (sizeDefaultConfig === "small" || sizeDefaultConfig === "medium" || sizeDefaultConfig === "large" || (xlargeEnabled && sizeDefaultConfig === "xlarge")) ? sizeDefaultConfig : "medium";
// text style default
var styleDefaultConfig = config.getString("DefaultTextStyle").toLowerCase();
var styleDefault = (styleDefaultConfig === "primary" || styleDefaultConfig === "secondary") ? styleDefaultConfig : "primary";
// try to read settings out of the roaming container, otherwise use defaults
// if xlarge is not enabled and container says "xlarge", used default
var containerTextSize = container.values["textSize"];
if (!xlargeEnabled && containerTextSize === "xlarge") {
containerTextSize = null;
}
var containerTextStyle = container.values["textStyle"];
var settings = {
textSize: containerTextSize || sizeDefault,
textStyle: containerTextStyle || styleDefault,
};
this._settings = settings;
},
_applyTheme: function _applyTheme(theme) {
var root = document.querySelector(".articleReaderPage");
if (root && theme) {
WinJS.Utilities.addClass(root, theme);
}
},
_getActiveArticleReader: function _getActiveArticleReader() {
var state = this._state;
return (this._currentViewState === ApplicationViewState.snapped && state.enableSnap) ? this._snappedArticleReader : this._articleReader;
},
/// <summary>
/// initializes the page, also used when retrying after connectivity issues
/// </summary>
_initialize: function _initialize() {
var that = this;
var state = this._state;
var provider = this._provider;
var initialArticleId = state.initialArticleId;
var startPage = state.startPage;
var articleManager = this._articleManager;
if (provider) {
// Check if we need to suppress interstitial for partner
if (state && state.adPartnerName) {
var noInterstitialAdPartnerNames = PlatformJS.Services.configuration.getDictionary("NoInterstitialAdPartnerNames");
if (noInterstitialAdPartnerNames && noInterstitialAdPartnerNames.hasKey &&
noInterstitialAdPartnerNames.hasKey(state.adPartnerName)) {
// Supress interstitial ads
this._providerConfiguration.suppressInterstitial = true;
}
}
// initialize the provider
this._promise = provider.initializeAsync(this._providerConfiguration)
.then(function () {
var cacheId = provider.getCacheId();
articleManager.cacheId = cacheId;
articleManager.focusViewport();
var navigateOptions = {
startPage: startPage,
};
return articleManager.gotoArticle(initialArticleId, navigateOptions);
})
.then(function () {
if (PlatformJS.mainProcessManager.afterFirstView) {
PlatformJS.mainProcessManager.afterFirstView();
}
},
function (err) {
that.dispose();
});
} else {
// Provider does not exist.
PlatformJS.Navigation.mainNavigator.returnHomeAndClearHistoryIfNecessary();
}
},
_setupTextAttributes: function _setupTextAttributes() {
var textSizeOptions = this._textSizeOptions = [
{
label: PlatformJS.Services.resourceLoader.getString("/Common/ArticleTextSizeSmall"),
selected: false,
value: "small",
},
{
label: PlatformJS.Services.resourceLoader.getString("/Common/ArticleTextSizeMedium"),
selected: false,
value: "medium",
},
{
label: PlatformJS.Services.resourceLoader.getString("/Common/ArticleTextSizeLarge"),
selected: false,
value: "large",
},
];
var xlargeEnabled = PlatformJS.Services.configuration.getDictionary("ArticleReaderConfig").getBool("XLargeTextSizeEnabled");
if (xlargeEnabled) {
textSizeOptions.push({
label: PlatformJS.Services.resourceLoader.getString("/Common/ArticleTextSizeXLarge"),
selected: false,
value: "xlarge",
});
}
var textStyleOptions = this._textStyleOptions = [
{
label: PlatformJS.Services.resourceLoader.getString("/Common/TextStylePrimary"),
icon: "\uE239",
selected: false,
value: "primary",
},
{
label: PlatformJS.Services.resourceLoader.getString("/Common/TextStyleSecondary"),
icon: "\uE221",
selected: false,
value: "secondary",
},
];
// read initial values from settings or use defaults
var settings = this._settings;
var textSize = settings.textSize;
var textStyle = settings.textStyle;
var selectedTextSize = 0;
for (var i = 0, leni = textSizeOptions.length; i < leni; i++) {
var textSizeOption = textSizeOptions[i];
if (textSizeOption.value === textSize) {
selectedTextSize = i;
break;
}
}
var selectedTextStyle = 0;
for (var j = 0, lenj = textStyleOptions.length; j < lenj; j++) {
var textStyleOption = textStyleOptions[j];
if (textStyleOption.value === textStyle) {
selectedTextStyle = j;
break;
}
}
textSizeOptions[selectedTextSize].selected = true;
textStyleOptions[selectedTextStyle].selected = true;
},
_setupBottomEdgy: function _setupBottomEdgy() {
var that = this;
// next button
var nextElt = document.createElement("button");
var nextButton = new WinJS.UI.AppBarCommand(nextElt, {
icon: "\u007D",
extraClass: "appexSymbol",
label: PlatformJS.Services.resourceLoader.getString("/Common/NextArticle")
});
nextButton.onclick = function (event) {
that._logBottomEdgyAction("Next Button");
that._dismissTopEdgy();
that._articleManager.nextArticle().then(
function () {
},
function (err) {
that.dispose();
});
};
// previous button
var previousElt = document.createElement("button");
var previousButton = new WinJS.UI.AppBarCommand(previousElt, {
icon: "\u007B",
extraClass: "appexSymbol",
label: PlatformJS.Services.resourceLoader.getString("/Common/PreviousArticle")
});
previousButton.onclick = function (event) {
that._logBottomEdgyAction("Previous Button");
that._dismissTopEdgy();
that._articleManager.previousArticle().then(
function () {
},
function (err) {
that.dispose();
});
};
// text size
var textSizeOptions = this._textSizeOptions;
var textSizeFlyoutOptions = {
buttonText: PlatformJS.Services.resourceLoader.getString("/Common/ArticleTextSizeMenuLabel"),
icon: "\uE219",
extraClass: "appexSymbol",
selectionChanged: function selectionChanged(item) {
that._updateTextSize(item.index);
},
};
var textSizeFlyout = this._textSizeFlyout = new CommonJS.SortFlyout(null, textSizeFlyoutOptions);
var textSizeButton = textSizeFlyout.appbarbtn;
textSizeButton.onclick = function () {
that._logBottomEdgyAction("Text Size Button");
};
textSizeFlyout.setItems(textSizeOptions);
// text style
var textStyleOptions = this._textStyleOptions;
var textStyleEnabled = this._textStyleEnabled;
var extraClass = textStyleEnabled ? "appexSymbol" : "appexSymbol platformHide";
var textStyleButtonOptions = {
extraClass: extraClass,
label: PlatformJS.Services.resourceLoader.getString("/Common/ArticleTextStyleMenuLabel"),
items: textStyleOptions,
onselectionchanged: function onselectionchanged(event) {
that._logBottomEdgyAction("Text Style Button");
that._dismissTopEdgy();
var index = event.detail;
that._updateTextStyle(index);
},
};
var textStyleButton = this._textStyleButton = new CommonJS.SelectorButton(null, textStyleButtonOptions);
// bottom edgy
var commands = [textStyleButton, textSizeButton, previousButton, nextButton];
// add help button if we have a helpUrl
var helpUrl = PlatformJS.Services.appConfig.getString("HelpURL");
if (helpUrl) {
var helpCommand = CommonJS.Settings.getHelpButton().winControl;
commands.push(helpCommand);
helpCommand.addEventListener("click", function onHelpButtonClick() {
that._logBottomEdgyAction("Help Button");
});
}
var elt = document.getElementById("bottomEdgy");
var appBar = new WinJS.UI.AppBar(elt, {
placement: "bottom",
commands: commands,
});
var edgyDismissedHandler = this._edgyDismissedHandler = this._onEdgyDismissed.bind(this);
appBar.addEventListener("afterhide", edgyDismissedHandler);
that._bottomEdgy = {
appBar: appBar,
nextButton: nextButton,
previousButton: previousButton
};
},
_onEdgyDismissed: function _onEdgyDismissed() {
this._articleManager.focusViewport();
},
_toggleBottomEdgy: function _toggleBottomEdgy(enabled) {
var bottomEdgy = this._bottomEdgy;
if (bottomEdgy) {
var appBar = bottomEdgy.appBar;
appBar.disabled = !enabled;
}
},
_updateTextSize: function _updateTextSize(index) {
var textSizeOptions = this._textSizeOptions;
var textSizeFlyout = this._textSizeFlyout;
for (var i = 0, len = textSizeOptions.length; i < len; i++) {
var textSizeOption = textSizeOptions[i];
textSizeOption.selected = (i === index);
}
textSizeFlyout.setItems(textSizeOptions);
this._updateTextAttributes();
},
_updateTextStyle: function _updateTextStyle(index) {
var textStyleOptions = this._textStyleOptions;
var textStyleButton = this._textStyleButton;
for (var i = 0, len = textStyleOptions.length; i < len; i++) {
var textStyleOption = textStyleOptions[i];
textStyleOption.selected = (i === index);
}
this._updateTextAttributes();
},
_updateTextAttributes: function _updateTextAttributes() {
var textAttributes = this._getCurrentTextAttributes();
var effectiveTextAttributes = textAttributes.effective;
var storedTextAttributes = textAttributes.stored;
var articleManager = this._articleManager;
articleManager.setTextAttributes(effectiveTextAttributes);
// write to settings
var settings = this._settings;
settings.textSize = storedTextAttributes.size;
settings.textStyle = storedTextAttributes.style;
this._writeSettings();
this._recordPreferences();
},
_getCurrentTextAttributes: function _getCurrentTextAttributes() {
var textSizeOptions = this._textSizeOptions;
var textSize, selected;
for (var i = 0, len = textSizeOptions.length; i < len; i++) {
var textSizeOption = textSizeOptions[i];
selected = textSizeOption.selected;
if (selected) {
textSize = textSizeOption.value;
break;
}
}
var textStyleOptions = this._textStyleOptions;
var textStyle;
for (var j = 0, lenj = textStyleOptions.length; j < lenj; j++) {
var textStyleOption = textStyleOptions[j];
selected = textStyleOption.selected;
if (selected) {
textStyle = textStyleOption.value;
break;
}
}
var stored = {
size: textSize,
style: textStyle,
};
var textStyleEnabled = this._textStyleEnabled;
var effective = {
size: textSize,
style: textStyleEnabled ? textStyle : "primary",
};
var textAttributes = {
effective: effective,
stored: stored,
};
return textAttributes;
},
_logBottomEdgyAction: function _logBottomEdgyAction(element) {
U.logUserAction(U.actionContext.appBar, element);
},
_recordPreferences: function _recordPreferences() {
var settings = this._settings;
var preferences = {};
preferences["ArticleReader/TextSize"] = settings.textSize;
preferences["ArticleReader/TextStyle"] = settings.textStyle;
var jsonString = JSON.stringify(preferences);
T.FlightRecorder.logPreferencesAsJson(
T.LogLevel.normal,
jsonString
);
},
_updateStateForInstrumentation: function _updateStateForInstrumentation(viewMechanism) {
if (viewMechanism) {
switch (viewMechanism) {
case T.ContentViewMechanism.scroll:
this._state.source = Platform.Instrumentation.InstrumentationEditorialSourceId.scrollSwipe;
T.FlightRecorder.setImpressionNavMethod(T.ImpressionNavMethod.scrollSwipe);
break;
case T.ContentViewMechanism.link:
this._state.source = Platform.Instrumentation.InstrumentationEditorialSourceId.nextPrev;
T.FlightRecorder.setImpressionNavMethod(T.ImpressionNavMethod.nextPrev);
break;
}
}
},
_recordArticleView: function _recordArticleView(instrumentationData) {
// Get the current impression on top of the stack for the first article view, and for subsequent ones replace it with a new one
var navigator = PlatformJS.Navigation.mainNavigator;
var isFirstView = this._isFirstView;
var viewMechanism = instrumentationData.viewMechanism;
this._updateStateForInstrumentation(viewMechanism);
var impression = isFirstView ? navigator.getCurrentImpression() : navigator.replaceCurrentImpression(this.getPageImpressionContext());
this._isFirstView = false;
if (impression) {
// add content
var content = instrumentationData.content;
var k = impression.addContent(
content.sourceName,     // sourceName
content.partnerCode,    // partnerCode
content.contentId,      // contentId
content.type,           // type
content.date,           // date
content.uri,            // uri
content.slug,           // slug
content.isSummary,      // isSummary
content.worth,          // worth
content.isAd,           // isAd
content.adCampaign      // adCampaign
);
// log content
impression.logContent(T.LogLevel.normal);
// get additional json attributes for view
var state = this._state;
// Save the current 'k' index for this article. This can be used by instrumentation that needs to refer
// to the content, such as sharing.
if (state.telemetry) {
state.telemetry.k = k;
}
else {
state.telemetry = {
k: k
};
}
var textAttributes = this._getCurrentTextAttributes();
var viewJson = {
TrailingMediaBlockCount: instrumentationData.trailingMediaBlockCount,
Market: state.market,
Source: U.convertSourceEnum(state.source),
Page: state.page,
EntryPoint: U.convertEntryPointEnum(state.entryPoint),
TextSize: textAttributes.effective.size,
TextStyle: textAttributes.effective.style,
RenderType: instrumentationData.renderType
};
var viewJsonString = JSON.stringify(viewJson);
// log view
var progress = new T.ContentViewProgress();
progress.pageCount = instrumentationData.pageCount;
impression.logContentViewWithJsonAttributes(
T.LogLevel.normal,              // level
k,                              // k
viewMechanism,                  // viewMechanism
true,                           // logOnlyIfNotViewed
progress,                       // progress
viewJsonString                  // jsonAttributes
);
}
},
_dismissTopEdgy: function _dismissTopEdgy() {
var elts = WinJS.Utilities.query("#platformNavigationBar");
if (elts && elts.length === 1) {
var elt = elts[0];
if (elt) {
var topEdgy = elt.winControl;
if (topEdgy && topEdgy.hide) {
topEdgy.hide();
}
}
}
},
_handleShareRequestImpl: function _handleShareRequestImpl(request, shareData) {
/// <summary>
/// Handles the Share Charm data request. If sharing is enabled for this instance, ArticleReaderPage must be subclassed and this function must be implemented in the subclass.
/// </summary>
/// <param name="request">The share request object.</param>
/// <param name="shareData">
/// Object that contains metadata that can be used to construct a uri, html fragment, or text from, for sharing.
/// {
///     pageState: {}           // ArticleReaderPage IPage can be reconstructed exactly with this object passed to its constructor. Put this or a subset of it in the URI, but be sure to reconstruct it exactly on the receiving end.
///     articleHeader: {        // Use the data in this object to construct your html and text data.
///         headline,
///         author,
///         date,
///         publisherName,
///         snippet,
///     },
///     articleId: "..."
/// }
/// </param>
throw "To enable sharing in the Article Reader, _handleShareRequestImpl() must be implemented by the subclass of CommonJS.ArticleReaderPage.";
},
handleShareRequest: function handleShareRequest(request) {
/// <summary>
/// Handles the Share Charm data request.
/// </summary>
/// <param name="request">The share request object.</param>
var pageState = this.getPageState();
var enableSharing = pageState.enableSharing;
if (enableSharing) {
// page state
var articleManager = this._articleManager;
// article header information
var articleHeader = articleManager.getHeader();
// article id
var articleId = articleManager.currentArticleId;
if (articleHeader) {
var shareData = {
pageState: pageState,
articleHeader: articleHeader,
articleId: articleId,
};
this._handleShareRequestImpl(request, shareData);
}
}
},
// IPAGE interface
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away and when the app is suspending.
/// Return any data that you need to resurrect your UX when the page is recreated
/// Keep this state object as small as possible
/// </summary>
/// <returns>
/// This function must return a JSON object that can be serializable. Do not pass a Managed object
/// </returns>
getPageState: function getPageState() {
var state = this._state;
var articleManager = this._articleManager;
if (articleManager) {
// update start page
var currentPageIndex = articleManager.currentPageIndex;
state.startPage = currentPageIndex;
}
return state;
},
/// <summary>
/// This function is invoked by the UX Framework when the page is being created and when
/// it is necessary to bind data to the UX.
/// </summary>
/// <returns>
/// Returns a promise that contains data to bind the UX to
/// </returns>
getPageData: function getPageData() {
return WinJS.Promise.wrap({});
},
/// <summary>
/// This function is invoked by the UX Framework when the data binding is complete
/// </summary>
/// <returns>
/// Nothing
/// </returns>
onBindingComplete: function onBindingComplete() {
this._initialize();
},
/// <summary>
/// Set this property to true if you want the back button to appear in the navbar
/// This is used for immersive pages
/// </summary>
isImmersive: true,
/// <summary>
/// This function is invoked by the UX Framework when the layout has changed
/// </summary>
/// <param name="viewState">
/// The current view state
/// </param>
/// <returns>
/// Nothing
/// </returns>
onLayoutChange: function onLayoutChange(viewState) {
this._changeView(viewState);
},
_changeView: function _changeView(viewState) {
var state = this._state;
var currentViewState = this._currentViewState;
var enableSnap = state.enableSnap;
var articleManager = this._articleManager;
switch (viewState) {
case ApplicationViewState.snapped:
if (enableSnap && (currentViewState === null || currentViewState === ApplicationViewState.filled || currentViewState === ApplicationViewState.fullScreenLandscape || currentViewState === ApplicationViewState.fullScreenPortrait)) {
// switch to snap mode
var immersiveHeaderSnapped = PlatformJS.Utilities.getControl("immersiveHeader");
if (immersiveHeaderSnapped) {
// Reset the header before changing the color
immersiveHeaderSnapped.fontColor = state.snappedHeaderFontColor;
immersiveHeaderSnapped.headerTitleText = state.snappedHeaderTitle;
}
this._toggleBottomEdgy(false);
}
articleManager.redraw(currentViewState, viewState);
break;
case ApplicationViewState.fullScreenLandscape:
case ApplicationViewState.fullScreenPortrait:
case ApplicationViewState.filled:
if (enableSnap && (currentViewState === null || currentViewState === ApplicationViewState.snapped)) {
var immersiveHeader = PlatformJS.Utilities.getControl("immersiveHeader");
if (immersiveHeader) {
// Reset the header before changing the color
immersiveHeader.fontColor = "headerFontDark";
immersiveHeader.headerTitleText = "";
}
this._toggleBottomEdgy(true);
}
articleManager.redraw(currentViewState, viewState);
break;
}
this._currentViewState = viewState;
},
/// <summary>
/// This function is invoked by the device has been roated
/// </summary>
/// <param name="event">
/// orientation change event
/// </param>
/// <returns>
/// Nothing
/// </returns>
onOrientationChange: function onOrientationChange(event) {
var viewState = ApplicationView.value;
this._changeView(viewState);
},
onWindowResize: function onWindowResize(event) {
var viewState = ApplicationView.value;
this._changeView(viewState);
},
},
{
})
});
})();
/* File: ArticleStore.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
WinJS.Namespace.define("CommonJS.ArticleReader", {
ArticleStore: WinJS.Class.define(
function () {
this._dataMap = {};
},
{
_dataMap: null,
setData: function setData(articleId, data) {
var dataMap = this._dataMap;
var newData = {
title: data.title,
blocks: data.blocks,
metadata: data.metadata,
nextArticle: data.nextArticle,
previousArticle: data.previousArticle,
renderData: null,
layouts: null,
};
dataMap[articleId] = newData;
// render data (can be string or json)
var renderData = data.renderData || null;
if (renderData) {
this.setRenderData(articleId, renderData);
}
// layouts (can be string or json)
var layouts = data.layouts || null;
if (layouts) {
this.setLayouts(articleId, layouts);
}
},
getData: function getData(articleId) {
var dataMap = this._dataMap;
var data = dataMap[articleId];
return data;
},
setRenderData: function setRenderData(articleId, renderData) {
if (typeof renderData === "string") {
renderData = JSON.parse(renderData);
}
var dataMap = this._dataMap;
var data = dataMap[articleId];
data.renderData = renderData;
// Release blocks, not needed when renderData is present.
// Note: We would release title here as well, but unfortunately due to a problem with the data contract where some metadata fields are on title, we can't.
data.blocks = null; 
},
setLayouts: function setLayouts(articleId, layouts) {
if (typeof layouts === "string") {
layouts = JSON.parse(layouts);
}
for (var i = 0, len = layouts.length; i < len; i++) {
var layout = layouts[i];
this.addLayout(articleId, layout);
}
},
addLayout: function addLayout(articleId, newLayout) {
var dataMap = this._dataMap;
var data = dataMap[articleId];
var layouts = data.layouts;
// if this is the first layout for this article, create a new layouts list
if (!layouts) {
layouts = [];
data.layouts = layouts;
}
var newProperties = newLayout.properties;
var index = this._getLayoutIndexByExactProperties(layouts, newProperties);
if (index === -1) {
// new set of properties, add to list
layouts.push(newLayout);
}
else {
// replace old layout
layouts[index] = newLayout;
}
},
_getLayoutIndexByExactProperties: function _getLayoutIndexByExactProperties(layouts, properties) {
var index = -1;
for (var i = 0, len = layouts.length; i < len; i++) {
var layout = layouts[i];
var p = layout.properties;
var equal = this._arePropertiesEqual(p, properties);
if (equal) {
index = i;
break;
}
}
return index;
},
_arePropertiesEqual: function _arePropertiesEqual(p1, p2) {
var equal = false;
if (p1 && p2) {
equal = true;
for (var k1 in p1) {
if (p1[k1] !== p2[k1]) {
equal = false;
break;
}
}
for (var k2 in p2) {
if (p2[k2] !== p1[k2]) {
equal = false;
break;
}
}
}
else if (!p1 && !p2) {
equal = true;
}
else {
equal = false;
}
return equal;
},
})
});
})();
/* File: ArticleManager.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
var ApplicationView = Windows.UI.ViewManagement.ApplicationView;
var ApplicationViewState = Windows.UI.ViewManagement.ApplicationViewState;
var T = Platform.Telemetry;
// ArticleManager is responsible for managing the full and snapped article readers, and managing the next/prev stack.
WinJS.Namespace.define("CommonJS.ArticleReader", {
ArticleManager: WinJS.Class.mix(WinJS.Class.define(
function (options) {
/// <summary>
/// Creates an instance of ArticleManager.
/// </summary>
/// <param name="object">
/// - provider: Data provider to use to fetch data. Must conform to IArticleProvider.
/// - bottomEdgy: The bottom edgy, for managing the state of the next/prev buttons.
/// - renderOptionsSeed: Seeds the renderOptions object passed to the render method of the article reader.
/// - initialTextAttributes: Initial text attributes
/// - validActions: Dictionary of actions and their definitions. These are rendered at the end of the article.
/// - actionsHandlerType: Type that handles EOA actions. onActionsInvoked() must be defined on it.
/// - market: Market of the article page
/// </param>
this._provider = options.provider;
this._bottomEdgy = options.bottomEdgy;
this._articleStore = new CommonJS.ArticleReader.ArticleStore();
this._disposed = false;
this._dataReady = false;
this._redrawPromise = WinJS.Promise.wrap(null);
this._cacheId = null;
this._renderOptionsSeed = options.renderOptionsSeed;
this._initialTextAttributes = options.initialTextAttributes;
this._validActions = options.validActions;
this._actionsHandlerType = options.actionsHandlerType;
this._pageWidth = null;
this._pageHeight = null;
this._oldArticleId = null;
this._articleViewedEventDelay = PlatformJS.Services.configuration.getDictionary("ArticleReaderConfig").getInt32("ArticleViewedEventDelay");
this._lastArticleViewedEventTimerId = null;
// create the article reader and snapped article reader controls
this._snappedArticleReader = new CommonJS.ArticleReader.SnappedArticleReader(document.getElementById("snappedArticleReader"));
var articleOrchestrator = this._articleOrchestrator = new CommonJS.ArticleReader.ArticleReaderOrchestrator(
document.getElementById("articleOrchestrator"),
{
market: options.market,
}
);
var swipeToUnrealizedArticleListener = this._swipeToUnrealizedArticleListener = this._swipeToUnrealizedArticle.bind(this);
articleOrchestrator.addEventListener("swipetounrealizedarticle", swipeToUnrealizedArticleListener);
var nearUnrealizedArticleListener = this._nearUnrealizedArticleListener = this._nearUnrealizedArticle.bind(this);
articleOrchestrator.addEventListener("nearunrealizedarticle", nearUnrealizedArticleListener);
var scrollToArticleListener = this._scrollToArticleListener = this._scrollToArticle.bind(this);
articleOrchestrator.addEventListener("scrolltoarticle", scrollToArticleListener);
Object.defineProperties(this, WinJS.Utilities.createEventProperties("articlechanged"));
Object.defineProperties(this, WinJS.Utilities.createEventProperties("articleviewed"));
Object.defineProperties(this, WinJS.Utilities.createEventProperties("articleerror"));
},
{
_provider: null,
_articleStore: null,
_bottomEdgy: null,
_disposed: null,
_dataReady: null,
_redrawPromise: null,
_cacheId: null,
_articleOrchestrator: null,
_snappedArticleReader: null,
_renderOptionsSeed: null,
_initialTextAttributes: null,
_validActions: null,
_actionsHandlerType: null,
_swipeToUnrealizedArticleListener: null,
_nearUnrealizedArticleListener: null,
_scrollToArticleListener: null,
_pageWidth: null,
_pageHeight: null,
_isErrorVisible: null,
_oldArticleId: null,
_articleViewedEventDelay: null,
_lastArticleViewedEventTimerId: null,
cacheId: {
set: function set(value) {
this._cacheId = value;
}
},
currentArticleId: {
get: function get() {
/// <summary>
/// Returns the current server article ID showing.
/// </summary>
var currentClientArticleId = this.getCurrentClientArticleId();
var serverArticleId = this._getServerArticleId(currentClientArticleId);
return serverArticleId;
}
},
previousArticleId: {
get: function get() {
/// <summary>
/// Returns the previous server article ID showing.
/// </summary>
var previousClientArticleId = this._getPreviousArticleId();
var serverArticleId = this._getServerArticleId(previousClientArticleId);
return serverArticleId;
}
},
currentPageIndex: {
get: function get() {
/// <summary>
/// Returns the 0-based current page index of the article that is in view.
/// </summary>
var pageIndex = 0;
var view = ApplicationView.value;
if (view !== ApplicationViewState.snapped) {
var articleOrchestrator = this._articleOrchestrator;
if (articleOrchestrator) {
pageIndex = articleOrchestrator.currentPageIndex;
}
}
return pageIndex;
},
},
getCurrentArticleMetadata: function getCurrentArticleMetadata() {
/// <summary>
/// Returns metadata about the current article. Metadata has the following fields:
/// - articleId (server id)
/// - free
/// - instrumentationId
/// </summary>
var articleStore = this._articleStore;
var articleId = this.getCurrentClientArticleId();
var currentArticleData = articleStore.getData(articleId);
var result = null;
var serverArticleId;
var free;
var instrumentationId;
var isAd = false;
if (currentArticleData) {
// set article id
serverArticleId = this._getServerArticleId(articleId);
// free
var title = currentArticleData.title;
if (title) {
free = title.free;
if (free === null || free === undefined) {
free = true;
}
}
// instrumentationId and isAd
var metadata = currentArticleData.metadata;
if (metadata) {
instrumentationId = metadata.instrumentationId;
isAd = !!currentArticleData.metadata.adMetadata;        // !! is to convert it to boolean
}
}
result = {
articleId: serverArticleId,
free: free,
instrumentationId: instrumentationId,
isAd: isAd,
};
return result;
},
getCurrentClientArticleId: function getCurrentClientArticleId() {
/// <summary>
/// Returns the current article ID that is used by the client. It does not necessarily equal to the server ID.
/// In most cases you do not need this ID, so don't use it, use currentArticleId instead.
/// </summary>
var articleId;
var view = ApplicationView.value;
articleId = this._getCurrentClientArticleIdForView(view);
return articleId;
},
focusViewport: function focusViewport() {
this._articleOrchestrator.focusViewport();
},
gotoArticle: function gotoArticle(articleId, navigateOptions, viewMechanism) {
/// <summary>
/// Load the given article, render it, and scroll to start page provided in navigateOptions.
/// </summary>
var that = this;
var promise = this._fetchAndRender(
articleId,
navigateOptions,
0,
false,
this.gotoArticle.bind(this, articleId, navigateOptions, viewMechanism));
promise.then(function () {
that._updateArticlePointers(viewMechanism);
});
return promise;
},
nextArticle: function nextArticle() {
/// <summary>
/// Go to the next article.
/// </summary>
var that = this;
var promise = this._nextArticle(
1,
this._currentArticle.bind(this));
promise.then(function () {
that._updateArticlePointers(T.ContentViewMechanism.link);
});
return promise;
},
previousArticle: function previousArticle() {
/// <summary>
/// Go to the previous article.
/// </summary>
var that = this;
var promise = this._nextArticle(
2,
this._currentArticle.bind(this));
promise.then(function () {
that._updateArticlePointers(T.ContentViewMechanism.link);
});
return promise;
},
dispose: function dispose() {
if (this._lastArticleViewedEventTimerId) {
clearTimeout(this._lastArticleViewedEventTimerId);
}
var snappedArticleReader = this._snappedArticleReader;
if (snappedArticleReader) {
snappedArticleReader.dispose();
}
var articleOrchestrator = this._articleOrchestrator;
if (articleOrchestrator) {
articleOrchestrator.removeEventListener("swipetounrealizedarticle", this._swipeToUnrealizedArticleListener);
articleOrchestrator.removeEventListener("nearunrealizedarticle", this._nearUnrealizedArticleListener);
articleOrchestrator.removeEventListener("scrolltoarticle", this._scrollToArticleListener);
articleOrchestrator.dispose();
}
this._disposed = true;
},
redraw: function redraw(oldViewState, newViewState) {
/// <summary>
/// Rerenders the article reader using the current data. Must be called on rotation, etc.
/// </summary>
var that = this;
if (this._dataReady) {
this._redrawPromise = this._redrawPromise.then(function () {
return that._relayout(oldViewState, newViewState);
}).then(function () { }, function (err) {
// swallow errors on relayout if disposed already
if (!that._disposed) {
throw err;
}
});
}
},
getHeader: function getHeader() {
/// <summary>
/// Returns the article header object used for sharing.
/// </summary>
var header;
if (!this._isErrorVisible) {
var articleOrchestrator = this._articleOrchestrator;
if (articleOrchestrator) {
header = articleOrchestrator.getHeader();
}
}
return header;
},
setTextAttributes: function setTextAttributes(textAttributes) {
/// <summary>
/// Sets the text size and style of the article reader.
/// </summary>
/// <param name="textAttributes">
/// - style: primary or secondary
/// - size: small, medium, or large
/// </param>
var that = this;
var articleOrchestrator = this._articleOrchestrator;
if (articleOrchestrator) {
articleOrchestrator.setTextAttributes(textAttributes)
.then(function () {
that._addAdditionalData();
});
}
this._initialTextAttributes = textAttributes;
},
_getServerArticleId: function _getServerArticleId(articleId) {
var serverArticleId = articleId;
var provider = this._provider;
if (provider.getServerArticleId) {
serverArticleId = provider.getServerArticleId(articleId);
}
return serverArticleId;
},
_isSnappedView: function _isSnappedView(viewState) {
return viewState === ApplicationViewState.snapped;
},
_relayout: function _relayout(oldViewState, newViewState) {
var gc = CommonJS.ArticleReader.GridCalculator;
var redrawPromise;
var pageWidth;
var pageHeight;
var dimensions;
var gridOptions;
var relayoutOptions;
var articleOrchestrator = this._articleOrchestrator;
var isOldSnapped = this._isSnappedView(oldViewState);
var isNewSnapped = this._isSnappedView(newViewState);
if (isOldSnapped !== isNewSnapped) {
// coming out of snapped => rerender
// going into snapped => rerender
var currentArticleId = this._getCurrentClientArticleIdForView(oldViewState);
var articleStore = this._articleStore;
var currentData = articleStore.getData(currentArticleId);
this._updatePageDimensions();
redrawPromise = this._renderData(currentArticleId, currentData, null, false);
if (isNewSnapped) {
// if going into snap mode, fire article focus lost, so for example videos can be paused
articleOrchestrator.articleFocusLost(currentArticleId);
}
}
else if (!isOldSnapped && !isNewSnapped) {
// orientation change => relayout
switch (newViewState) {
case ApplicationViewState.filled:
case ApplicationViewState.fullScreenLandscape:
this._updatePageDimensions();
dimensions = this._getPageDimensions();
pageWidth = dimensions.pageWidth;
pageHeight = dimensions.pageHeight;
gridOptions = gc.calculateGridOptions(gc.landscapeGridConstants, pageWidth, pageHeight);
relayoutOptions = {
gridOptions: gridOptions
};
redrawPromise = this._relayoutRenderedArticle(relayoutOptions);
break;
case ApplicationViewState.fullScreenPortrait:
this._updatePageDimensions();
dimensions = this._getPageDimensions();
pageWidth = dimensions.pageWidth;
pageHeight = dimensions.pageHeight;
gridOptions = gc.calculateGridOptions(gc.portraitGridConstants, pageWidth, pageHeight);
relayoutOptions = {
gridOptions: gridOptions
};
redrawPromise = this._relayoutRenderedArticle(relayoutOptions);
break;
}
}
return redrawPromise;
},
_isRenderable: function _isRenderable(data) {
var is = data.renderData || false;
return is;
},
_renderData: function _renderData(articleId, data, navigateOptions, preRender) {
/// Possible formats for data:
/// 1. {
///        metadata: {},
///        title: {}, 
///        blocks: []
///    }
///
/// 2. {
///        metadata: {},
///        title: {},
///        renderData: {}, // may be stringified
///        layouts: [] // may be stringified
///    }
var that = this;
var gc = CommonJS.ArticleReader.GridCalculator;
var view = ApplicationView.value;
var cacheId = this._cacheId;
var initialTextAttributes = this._initialTextAttributes;
var validActions = this._validActions;
var actionsHandlerType = this._actionsHandlerType;
var redrawPromise;
var dimensions;
var pageWidth;
var pageHeight;
var gridOptions;
var renderOptions;
var renderOptionsSeed = this._renderOptionsSeed;
var articleOrchestrator = this._articleOrchestrator;
var articleStore = this._articleStore;
switch (view) {
case ApplicationViewState.filled:
case ApplicationViewState.fullScreenLandscape:
dimensions = this._getPageDimensions();
pageWidth = dimensions.pageWidth;
pageHeight = dimensions.pageHeight;
gridOptions = gc.calculateGridOptions(gc.landscapeGridConstants, pageWidth, pageHeight);
var isArticleRendered = articleOrchestrator.isArticleRendered(articleId);
var lastPageWidth = articleOrchestrator.getPageWidth();
if (isArticleRendered && lastPageWidth !== pageWidth) {
// if article is already rendered in a different grid, relayout
var relayoutOptions = {
gridOptions: gridOptions
};
redrawPromise = this._relayoutRenderedArticle(relayoutOptions);
}
else {
// otherwise, render the article (this would only scroll to the article, if it's already rendered)
renderOptions = {
gridOptions: gridOptions,
cacheId: cacheId,
initialTextAttributes: initialTextAttributes,
validActions: validActions,
actionsHandlerType: actionsHandlerType,
contentCssPaths: renderOptionsSeed.contentCssPaths,
actionKeys: renderOptionsSeed.actionKeys,
renderAll: renderOptionsSeed.renderAll,
adGroups: renderOptionsSeed.adGroups,
adPartnerName: renderOptionsSeed.adPartnerName,
hideInlineAds: false, // MUST always pass false for this
ignoreDataAds: false, // MUST always pass false for this
ignoreDataActions: false, // MUST always pass false for this
};
redrawPromise = articleOrchestrator.render(articleId, data, renderOptions, navigateOptions, preRender)
.then(function () {
that._addAdditionalData();
});
}
break;
case ApplicationViewState.fullScreenPortrait:
dimensions = this._getPageDimensions();
pageWidth = dimensions.pageWidth;
pageHeight = dimensions.pageHeight;
gridOptions = gc.calculateGridOptions(gc.portraitGridConstants, pageWidth, pageHeight);
renderOptions = {
gridOptions: gridOptions,
cacheId: cacheId,
initialTextAttributes: initialTextAttributes,
validActions: validActions,
actionsHandlerType: actionsHandlerType,
contentCssPaths: renderOptionsSeed.contentCssPaths,
actionKeys: renderOptionsSeed.actionKeys,
renderAll: renderOptionsSeed.renderAll,
adGroups: renderOptionsSeed.adGroups,
adPartnerName: renderOptionsSeed.adPartnerName,
hideInlineAds: false, // MUST always pass false for this
ignoreDataAds: false, // MUST always pass false for this
ignoreDataActions: false, // MUST always pass false for this
};
redrawPromise = articleOrchestrator.render(articleId, data, renderOptions, navigateOptions, preRender)
.then(function () {
that._addAdditionalData();
});
break;
case ApplicationViewState.snapped:
renderOptions = {};
redrawPromise = this._snappedArticleReader.render(articleId, data, renderOptions);
break;
}
return redrawPromise || WinJS.Promise.wrap(null);
},
_updatePageDimensions: function _updatePageDimensions() {
// TODO (is there a faster way to get screen height and width? maybe a WinRT call?)
this._pageWidth = document.body.offsetWidth;
this._pageHeight = document.body.offsetHeight;
},
_getPageDimensions: function _getPageDimensions() {
if (this._pageWidth === null || this._pageHeight === null) {
this._updatePageDimensions();
}
var dimensions = {
pageWidth: this._pageWidth,
pageHeight: this._pageHeight,
};
return dimensions;
},
_relayoutRenderedArticle: function _relayoutRenderedArticle(relayoutOptions) {
var that = this;
CommonJS.ArticleReader.ArticleReaderUtils.showModalProgress();
return WinJS.Promise.timeout()
.then(function () {
var articleOrchestrator = that._articleOrchestrator;
var redrawPromise = articleOrchestrator.relayout(relayoutOptions);
return redrawPromise;
})
.then(function () {
that._addAdditionalData();
CommonJS.ArticleReader.ArticleReaderUtils.hideModalProgress();
});
},
_fetchAndRender: function _fetchAndRender(articleId, navigateOptions, direction, preRender, errorCallback) {
var that = this;
if (CommonJS.Error.errorExists()) {
this._removeError();
}
var provider = this._provider;
if (!preRender) {
CommonJS.ArticleReader.ArticleReaderUtils.showModalProgress();
}
var articleStore = this._articleStore;
this._dataReady = false;
var renderedCacheData = false;
msWriteProfilerMark("CommonControls:ArticleReader:render:s");
var dataPromise;
var data = articleStore.getData(articleId);
if (data) {
this._dataReady = true;
dataPromise = WinJS.Promise.wrap(data);
}
else {
dataPromise = provider.getArticleAsync(articleId);
}
return dataPromise
.then(
function (data) {
that._dataReady = true;
if (!renderedCacheData) {
articleStore.setData(articleId, data);
data = articleStore.getData(articleId);
that._redrawPromise = that._renderData(articleId, data, navigateOptions, preRender);
}
return that._redrawPromise;
}
,
null
,
function (cachedData) {
that._dataReady = true;
articleStore.setData(articleId, cachedData);
cachedData = articleStore.getData(articleId);
renderedCacheData = true;
that._redrawPromise = that._renderData(articleId, cachedData, navigateOptions, preRender);
})
.then(
function () {
CommonJS.ArticleReader.ArticleReaderUtils.hideModalProgress();
msWriteProfilerMark("CommonControls:ArticleReader:render:e");
},
function (err) {
var bottomEdgy = that._bottomEdgy;
if (!that._disposed) {
CommonJS.ArticleReader.ArticleReaderUtils.hideModalProgress();
if (!preRender) {
if (direction === 1) {
bottomEdgy.nextButton.disabled = true;
bottomEdgy.previousButton.disabled = false;
} else if (direction === 2) {
bottomEdgy.nextButton.disabled = false;
bottomEdgy.previousButton.disabled = true;
}
if (!err || err.name !== "Canceled") {
var code = PlatformJS.Utilities.getPlatformErrorCode(err);
// range 100-199 is query service / connectivity exceptions, 102 only per service exception code
var errorCode = PlatformJS.Utilities.checkOfflineErrorCode(code);
that.dispatchEvent("articleerror", err);
that._showError(articleId, errorCode, errorCallback);
that._articleOrchestrator.scrollToArticle(articleId);
}
}
}
}
);
},
_currentArticle: function _currentArticle() {
var that = this;
var promise = this._nextArticle(
0,
this._currentArticle.bind(this));
promise.then(function () {
that._updateArticlePointers();
});
return promise;
},
_nextArticle: function _nextArticle(direction, errorCallback) {
var that = this;
var promise = WinJS.Promise.wrap(null);
var nextArticleId = this._getNextArticleId();
var previousArticleId = this._getPreviousArticleId();
var currentArticleId = this.getCurrentClientArticleId();
if (direction === 1 && nextArticleId) {
promise = that._fetchAndRender(nextArticleId, -1, direction, false, errorCallback);
}
else if (direction === 2 && previousArticleId) {
promise = that._fetchAndRender(previousArticleId, -1, direction, false, errorCallback);
}
else if (direction === 0 && currentArticleId) {
promise = that._fetchAndRender(currentArticleId, -1, direction, false, errorCallback);
}
return promise;
},
_updateArticlePointers: function _updateArticlePointers(viewMechanism) {
var currentArticleId = this.getCurrentClientArticleId();
var articleStore = this._articleStore;
var data = articleStore.getData(currentArticleId);
if (data) {
var next = this._getNextArticleId();
var previous = this._getPreviousArticleId();
// update bottom edgy
var bottomEdgy = this._bottomEdgy;
var nextDisabled = !next;
var previousDisabled = !previous;
bottomEdgy.nextButton.disabled = nextDisabled;
bottomEdgy.previousButton.disabled = previousDisabled;
//if a solitary article, hide nav buttons
if (!next && !previous && bottomEdgy.appBar.hidden) {
bottomEdgy.previousButton.hidden = true;
bottomEdgy.nextButton.hidden = true;
}
}
if (this._oldArticleId !== currentArticleId) {
this._oldArticleId = currentArticleId;
var detail = this._getEventDetail(currentArticleId, viewMechanism);
this.dispatchEvent("articlechanged", detail);
this._articleBecameViewable(currentArticleId, viewMechanism);
}
},
_swipeToUnrealizedArticle: function _swipeToUnrealizedArticle(event) {
var articleId = event.detail;
this.gotoArticle(articleId, null, T.ContentViewMechanism.scroll);
},
_nearUnrealizedArticle: function _nearUnrealizedArticle(event) {
var that = this;
var articleId = event.detail;
return this._fetchAndRender(
articleId,
null,
0,
true,
that.gotoArticle.bind(that, articleId, null))
.then(
function () {
},
function (err) {
// swallow error on prerender
});
},
_scrollToArticle: function _scrollToArticle(event) {
this._updateArticlePointers(T.ContentViewMechanism.scroll);
},
_articleBecameViewable: function _articleBecameViewable(articleId, viewMechanism) {
var currentArticleId = this.getCurrentClientArticleId();
var that = this;
if (currentArticleId === articleId) {
var detail = this._getEventDetail(articleId, viewMechanism);
var delay = this._articleViewedEventDelay;
if (!delay) {
this.dispatchEvent("articleviewed", detail);
}
else {
if (this._lastArticleViewedEventTimerId) {
clearTimeout(this._lastArticleViewedEventTimerId);
}
this._lastArticleViewedEventTimerId = setTimeout(
function () {
that.dispatchEvent("articleviewed", detail);
},
delay
);
}
}
},
_getEventDetail: function _getEventDetail(articleId, viewMechanism) {
// returns the event detail object that is used by both "articlechanged" and "articleviewed" events.
var orchestrator = this._articleOrchestrator;
var instrumentationData = orchestrator.getInstrumentationData(articleId);
var serverArticleId = this._getServerArticleId(articleId) || "undefined";
// append more fields to it.
if (instrumentationData) {
instrumentationData.content.contentId = serverArticleId;
instrumentationData.viewMechanism = viewMechanism;
}
var detail = {
articleId: serverArticleId,
clientArticleId: articleId,
instrumentationData: instrumentationData,
};
return detail;
},
_removeError: function _removeError() {
CommonJS.Error.removeError();
this._isErrorVisible = false;
},
_showError: function _showError(articleId, errorCode, errorCallback) {
this._articleOrchestrator.showArticleError(articleId, errorCode, errorCallback);
this._isErrorVisible = true;
},
_getNextArticleId: function _getNextArticleId() {
var articleId = null;
var view = ApplicationView.value;
switch (view) {
case ApplicationViewState.filled:
case ApplicationViewState.fullScreenLandscape:
case ApplicationViewState.fullScreenPortrait:
var articleOrchestrator = this._articleOrchestrator;
if (articleOrchestrator) {
articleId = articleOrchestrator.nextArticleId;
}
break;
}
return articleId;
},
_getPreviousArticleId: function _getPreviousArticleId() {
var articleId = null;
var view = ApplicationView.value;
switch (view) {
case ApplicationViewState.filled:
case ApplicationViewState.fullScreenLandscape:
case ApplicationViewState.fullScreenPortrait:
var articleOrchestrator = this._articleOrchestrator;
if (articleOrchestrator) {
articleId = articleOrchestrator.previousArticleId;
}
break;
}
return articleId;
},
_addAdditionalData: function _addAdditionalData() {
/// <summary>
/// This function queries the article reader control that's currently rendered for its layouts hints
/// and stores the layout hints in the article store.
/// </summary>
var view = ApplicationView.value;
var isSnapped = this._isSnappedView(view);
if (!isSnapped) {
var articleOrchestrator = this._articleOrchestrator;
var articleId = this.getCurrentClientArticleId();
var articleStore = this._articleStore;
// get renderable data from orchestrator
var renderData = articleOrchestrator.getRenderData(articleId);
if (renderData) {
renderData.isClientGenerated = true;
}
// get layout based on the environment
var layout = articleOrchestrator.getLayout(articleId);
if (layout) {
layout.isClientGenerated = true;
}
// save it in the store
if (renderData && layout) {
articleStore.setRenderData(articleId, renderData);
articleStore.addLayout(articleId, layout);
}
}
},
_getCurrentClientArticleIdForView: function _getCurrentClientArticleIdForView(view) {
var articleId;
switch (view) {
case ApplicationViewState.filled:
case ApplicationViewState.fullScreenLandscape:
case ApplicationViewState.fullScreenPortrait:
var articleOrchestrator = this._articleOrchestrator;
if (articleOrchestrator) {
articleId = articleOrchestrator.currentArticleId;
}
break;
case ApplicationViewState.snapped:
var snappedArticleReader = this._snappedArticleReader;
if (snappedArticleReader) {
articleId = snappedArticleReader.currentArticleId;
}
break;
}
return articleId;
},
}), WinJS.Utilities.eventMixin),
});
})();
/* File: ContentFrameManager.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// ContentFrameManager manages the iframe for regions.
WinJS.Namespace.define("CommonJS.ArticleReader", {
ContentFrameManager: WinJS.Class.define(
function (options) {
/// <summary>
/// Creates an instance.
/// </summary>
/// <param name="options">
/// - contentFrame: The iframe object.
/// - paginatedViewManager: handler for mouse/keyboard scroll behavior
/// - market: market of the article reader page
/// </param>
this._contentFrame = options.contentFrame;
this._clickListener = null;
this._pointerUpListener = null;
this._paginatedViewManager = options.paginatedViewManager;
this._actionsHandlerType = null;
this._articleMetadata = null;
this._articleHeader = null;
this._market = options.market;
},
{
_contentFrame: null,
_clickListener: null,
_pointerUpListener: null,
_paginatedViewManager: null,
_actionsHandlerType: null, // setup()
_articleMetadata: null, // setup()
_articleHeader: null, // setup()
_market: null,
dispose: function dispose() {
var contentDocument = this._getContentDocument();
if (contentDocument) {
var clickListener = this._clickListener;
contentDocument.removeEventListener("click", clickListener);
var pointerUpListener = this._pointerUpListener;
contentDocument.removeEventListener("MSPointerUp", pointerUpListener, false);
}
},
setup: function setup(initialTextAttributes, flowId, contentCssPaths, actionsHandlerType, articleHeader, articleMetadata) {
/// <summary>
/// Initializes the iframe.
/// </summary>
/// <param name="initialTextAttributes">
/// Initial text attributes of the content.
/// - style: primary or secondary
/// - size: small, medium, or large
/// </param>
/// <param name="flowId">Name of the flow to set -ms-flow-into to.</param>
/// <param name="contentCssPaths">Array of css files to apply to the content document.</param>
/// <param name="actionsHandlerType">Event handler for the clicks happening on this content frame.</param>
/// <param name="articleHeader">Needed for actionsHandler's event.</param>
/// <param name="articleMetadata">Needed for actionsHandler's event.</param>
var contentDocument = this._getContentDocument();
if (contentDocument) {
var contentFrame = this._contentFrame;
contentFrame.style.msFlowInto = flowId;
contentDocument.open();
contentDocument.close();
// add css files
var defaultCssPath = CommonJS.ArticleReader.ContentFrameManager._defaultCssPath;
var cssFiles = [].concat([defaultCssPath], contentCssPaths);
this._addCssFilesToDocument(contentDocument, cssFiles);
// set up html tag for bidi
var market = this._market;
if (!market) {
// if market is not passed in, inherit the outer document's lang
market = document.getElementsByTagName("HTML")[0].lang;
}
if(market) {
contentDocument.getElementsByTagName("HTML")[0].lang = PlatformJS.Utilities.convertMarketToLanguageCode(market);
}
// attach event handlers to iframe document
var clickListener = this._clickListener = this._onContentClick.bind(this);
contentDocument.addEventListener("click", clickListener);
var pointerUpListener = this._pointerUpListener = this._onContentMSPointerUp.bind(this);
contentDocument.addEventListener("MSPointerUp", pointerUpListener, false);
var paginatedViewManager = this._paginatedViewManager;
paginatedViewManager.attachEventListeners(contentDocument);
// set initial text attributes
this.setTextAttributes(initialTextAttributes);
this._actionsHandlerType = actionsHandlerType;
this._articleHeader = articleHeader;
this._articleMetadata = articleMetadata;
}
},
addContent: function addContent(content) {
/// <summary>
/// Appends the given string into the iframe body.
/// </summary>
/// <param name="content">HTML string to insert into the iframe.</param>
var contentDocument = this._getContentDocument();
if (contentDocument) {
var contentFrame = this._contentFrame;
var root = contentDocument.body;
if (content && root) {
if (!root.childNodes.length) {
// first add
// bug 306501: There is a rendering bug in IE with U+3000 and regions. Insert an invisible span before U+3000 in the content as a work-around.
// U+3000 = ideographic space (decimal code 12288)
var fixedContent = content.replace(/[\u3000]/g, "<span class='hiddenContentSpan'></span>" + String.fromCharCode(12288));
WinJS.Utilities.setInnerHTML(root, toStaticHTML(fixedContent));
}
else {
// subsequent adds
var temp = document.createElement("div");
WinJS.Utilities.setInnerHTML(temp, toStaticHTML(content));
var frag = contentDocument.createDocumentFragment();
var nodes = temp.childNodes;
while (nodes && nodes.length) {
frag.appendChild(nodes[0]);
}
root.appendChild(frag);
}
}
}
},
setTextAttributes: function setTextAttributes(textAttributes) {
/// <summary>
/// Sets the text size and style of the article reader.
/// </summary>
/// <param name="textAttributes">
/// - style: primary or secondary
/// - size: small, medium, or large
/// </param>
var contentDocument = this._getContentDocument();
if (contentDocument) {
var root = contentDocument.body;
if (root) {
var size = textAttributes.size;
var style = textAttributes.style;
root.setAttribute("data-text-size", size);
root.setAttribute("data-text-style", style);
}
}
},
_getContentDocument: function _getContentDocument() {
var contentDocument = null;
var contentFrame = this._contentFrame;
try {
contentDocument = contentFrame.contentWindow.document;
}
catch (ex) {
// swallow exception. sometimes on navigate away, the iframe can be in a state where there is no content document.
}
return contentDocument;
},
_addCssFilesToDocument: function _addCssFilesToDocument(doc, cssFiles) {
for (var i = 0, len = cssFiles.length; i < len; i++) {
var link = doc.createElement("link");
link.setAttribute("href", cssFiles[i]);
link.setAttribute("rel", "stylesheet");
doc.getElementsByTagName("HEAD")[0].appendChild(link);
}
},
_onContentClick: function _onContentClick(evt) {
/// <summary>
/// Makes sure link clicks are opened in browser not the app.
/// </summary>
var elt = evt.srcElement;
while (elt) {
if (elt.tagName === "A" || elt.tagName === "BUTTON") {
var actionKey = elt.getAttribute("data-action-key");
if (actionKey) { // action can be either button or hyperlink
var actionsHandlerType = this._actionsHandlerType;
if (actionsHandlerType) {
var actionsHandler = PlatformJS.Utilities.createObject(actionsHandlerType);
if (actionsHandler && actionsHandler.onActionInvoked) {
var actionOptions = elt.getAttribute("data-action-options");
var newEvent = {
originalEvent: evt,
data: {
actionKey: actionKey,
actionOptions: actionOptions,
articleMetadata: this._articleMetadata,
articleHeader: this._articleHeader
}
};
actionsHandler.onActionInvoked(newEvent);
}
}
evt.preventDefault();
evt.stopPropagation();
} else if (elt.tagName === "A") {
elt.setAttribute("target", "_blank");
}
break;
}
elt = elt.parentElement;
}
},
_onContentMSPointerUp: function _onContentMSPointerUp(event) {
switch (event.button) {
// Mouse back button
case 3:
if (WinJS.Navigation.canGoBack) {
WinJS.Navigation.back();
}
break;
// Mouse forward button
case 4:
if (WinJS.Navigation.canGoForward) {
WinJS.Navigation.forward();
}
break;
}
},
},
{
_defaultCssPath: "/common/ArticleReader/css/Content.css"
}),
});
})();
/* File: Footer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Footer at the bottom of each page. Contains the the page number.
WinJS.Namespace.define("CommonJS.ArticleReader", {
Footer: WinJS.Class.define(
function (elt, options) {
/// <summary>
/// Creates a Footer instance.
/// </summary>
/// <param name="options">
/// - gridOptions: grid options
/// - pageNumberString: text for the page number control
/// </param>
elt = this.elt = elt ? elt : document.createElement("div");
elt.winControl = this;
WinJS.Utilities.addClass(elt, "footer");
// create page number container
var pageNumberContainerElt = document.createElement("div");
WinJS.Utilities.addClass(pageNumberContainerElt, "pageNumberContainer");
elt.appendChild(pageNumberContainerElt);
// create page number control
var pageNumberString = options.pageNumberString;
var pageNumberElt = document.createElement("div");
var pageNumber = this._pageNumber = new CommonJS.ArticleReader.PageNumber(pageNumberElt, {
pageNumberString: pageNumberString,
});
pageNumberContainerElt.appendChild(pageNumberElt);
},
{
_pageNumber: null,
pageNumberString: {
set: function set(value) {
var pageNumber = this._pageNumber;
pageNumber.pageNumberString = value;
},
},
}),
});
})();
/* File: GridCalculator.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Responsible for calculating the grid measuremnets.
WinJS.Namespace.define("CommonJS.ArticleReader", {
GridCalculator: WinJS.Class.define(
function () {
},
{
},
{
calculateGridOptions: function calculateGridOptions(gridConstants, pageWidth, pageHeight) {
var columnCount = 3; // typical case
var columnWidth;
var done = false;
var defaultRightMargin = gridConstants.defaultRightMargin;
var maxColumnWidth = gridConstants.maxColumnWidth;
var minColumnWidth = gridConstants.minColumnWidth;
while (!done && columnCount >= 2) {
// Try with one more column, and with one less column, and see if the column widths are within range. Minimum of 2 columns.
var currentColumnWidth = CommonJS.ArticleReader.GridCalculator._getColumnWidth(pageWidth, defaultRightMargin, columnCount, gridConstants);
var oneMoreColumnWidth = CommonJS.ArticleReader.GridCalculator._getColumnWidth(pageWidth, defaultRightMargin, columnCount + 1, gridConstants);
var oneLessColumnWidth = CommonJS.ArticleReader.GridCalculator._getColumnWidth(pageWidth, defaultRightMargin, columnCount - 1, gridConstants);
if (currentColumnWidth > maxColumnWidth) {
// if column width is too big
if (oneMoreColumnWidth < minColumnWidth) {
// and column width is too small with one more column, use the max column width
columnWidth = maxColumnWidth;
done = true;
} else if (oneMoreColumnWidth > maxColumnWidth) {
// and column width is still too big with one more column, try again with one more column
columnCount++;
} else {
// otherwise, one more column is the right column count
columnCount++;
columnWidth = oneMoreColumnWidth;
done = true;
}
} else if (currentColumnWidth < minColumnWidth) {
// if column width is too small
if (oneLessColumnWidth > maxColumnWidth) {
// and column width is too big with one less column, use the max column width with one fewer column
columnCount--;
columnWidth = maxColumnWidth;
done = true;
} else if (oneLessColumnWidth < minColumnWidth) {
// and column width is too small with one less column, try again with one fewer column
columnCount--;
} else {
// otherwise, one fewer column is the right column count
columnCount--;
columnWidth = oneLessColumnWidth;
done = true;
}
} else {
// if column width is within range, use it
columnWidth = currentColumnWidth;
done = true;
}
}
// set the right margin to pick up any slack
var rightMargin = CommonJS.ArticleReader.GridCalculator._getRightMargin(pageWidth, columnWidth, columnCount, gridConstants);
// calculate the column height
var columnHeight = pageHeight - gridConstants.topMargin - gridConstants.bottomMargin;
return {
pageWidth: pageWidth,
pageHeight: pageHeight,
columnCount: columnCount,
columnWidth: columnWidth,
columnHeight: columnHeight,
rightMargin: rightMargin,
leftMargin: gridConstants.leftMargin,
columnMargin: gridConstants.columnMargin,
topMargin: gridConstants.topMargin,
bottomMargin: gridConstants.bottomMargin
};
},
_getColumnWidth: function _getColumnWidth(pageWidth, rightMargin, columnCount, gridConstants) {
return Math.floor((pageWidth - gridConstants.leftMargin - rightMargin - (columnCount - 1) * gridConstants.columnMargin) / columnCount);
},
_getRightMargin: function _getRightMargin(pageWidth, columnWidth, columnCount, gridConstants) {
return pageWidth - gridConstants.leftMargin - columnCount * (columnWidth + gridConstants.columnMargin) + gridConstants.columnMargin;
},
landscapeGridConstants: {
leftMargin: 120,
columnMargin: 30,
defaultRightMargin: 25,
topMargin: 30,
bottomMargin: 50,
minColumnWidth: 300,
maxColumnWidth: 460
},
portraitGridConstants: {
leftMargin: 100,
columnMargin: 30,
defaultRightMargin: 100,
topMargin: 30,
bottomMargin: 80,
minColumnWidth: 375,
maxColumnWidth: 770
}
}),
});
})();
/* File: PageManager.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// PageManager manages a single page. It is a view into the array of content elements, footer elements, etc.
WinJS.Namespace.define("CommonJS.ArticleReader", {
PageManager: WinJS.Class.define(
function (options) {
/// <summary>
/// Creates an insance of PageManager.
/// </summary>
/// <param name="options">
/// - surfaceManager: the SurfaceManager instance
/// - contentElements: Array of all content elements
/// - footerBlockElements: Array of all footer elements
/// - pageIndex: index of current page
/// </param>
this._surfaceManager = options.surfaceManager;
this._contentElements = options.contentElements;
this._footerBlockElements = options.footerBlockElements;
this._pageIndex = options.pageIndex;
this._footer = null;
},
{
_surfaceManager: null,
_contentElements: null,
_footerElements: null,
_pageIndex: null,
_footer: null,
pageIndex: {
get: function get() {
/// <summary>
/// Returns the 0-based index of this page.
/// </summary>
return this._pageIndex;
}
},
pageNumberString: {
set: function set(value) {
var footer = this._footer;
if (footer) {
footer.pageNumberString = value;
}
},
},
isEmpty: function isEmpty(context) {
/// <summary>
/// Returns true if this page does not have any content or blocks.
/// </summary>
var gridOptions = context.gridOptions;
var isBlockEmpty = true;
var isContentEmpty = true;
// find out if there are no blocks on the page
var exclusions = CommonJS.ArticleReader.ArticleReaderUtils.getAllExclusions(context);
for (var i = 0, len = exclusions.length; i < len; i++) {
var exclusion = exclusions[i];
if (exclusion) {
var isExclusionOnPage = this._isExclusionOnPage(exclusion, gridOptions);
if (isExclusionOnPage) {
isBlockEmpty = false;
break;
}
}
}
if (isBlockEmpty) {
// find out if there is no content on page
var startIndex = this._getStartIndex(gridOptions);
var firstContentElement = this._getContentElement(startIndex, context);
isContentEmpty = CommonJS.ArticleReader.ArticleReaderUtils.isContentElementEmpty(firstContentElement);
}
return isBlockEmpty && isContentEmpty;
},
isOverflowing: function isOverflowing(context) {
/// <summary>
/// Returns true if the page is overflowing with content, or there are exclusions on higher pages.
/// </summary>
var gridOptions = context.gridOptions;
var isBlockOverflowing = false;
var isContentOverflowing = false;
// find out if blocks are overflowing
var exclusions = CommonJS.ArticleReader.ArticleReaderUtils.getAllExclusions(context);
for (var i = 0, len = exclusions.length; i < len; i++) {
var exclusion = exclusions[i];
var isExclusionOnHigherPage = this._isExclusionOnHigherPage(exclusion, gridOptions);
if (isExclusionOnHigherPage) {
isBlockOverflowing = true;
break;
}
}
if (!isBlockOverflowing) {
// find out if content is overflowing
var endIndex = this._getEndIndex(gridOptions);
var lastContentElement = this._getContentElement(endIndex, context);
var ranges = lastContentElement.msGetRegionContent();
isContentOverflowing = CommonJS.ArticleReader.ArticleReaderUtils.isContentElementOverflowing(lastContentElement);
}
return isBlockOverflowing || isContentOverflowing;
},
isLastColumnEmpty: function isLastColumnEmpty(context) {
/// <summary>
/// Returns true if the last column of this page is empty.
/// </summary>
var gridOptions = context.gridOptions;
var endIndex = this._getEndIndex(gridOptions);
return this._isColumnEmpty(endIndex, context);
},
createElements: function createElements(context) {
/// <summary>
/// Create content and footer elements required for this page. Reuse from existing elements in array if appropriate.
/// </summary>
var contentElements = this._contentElements;
var gridOptions = context.gridOptions;
var endIndex = this._getEndIndex(gridOptions);
// create content elements
while (endIndex > contentElements.length - 1) {
this._getContentElement(contentElements.length, context);
}
// create footer
this._getFooterBlockElement(context);
},
associateLayoutWithElements: function associateLayoutWithElements(context) {
/// <summary>
/// Layout content and footer elements that belong to this page.
/// </summary>
var contentElements = this._contentElements;
var gridOptions = context.gridOptions;
var startIndex = this._getStartIndex(gridOptions);
var endIndex = this._getEndIndex(gridOptions);
var pageIndex = this.pageIndex;
var columnCount = gridOptions.columnCount;
// layout content elements
for (var i = startIndex; i <= endIndex; i++) {
var contentElement = this._getContentElement(i, context);
var contentStyle = contentElement.style;
var contentColumn = CommonJS.ArticleReader.ArticleReaderUtils.convertColumnIndexToGridColumn(i, columnCount);
contentStyle.msGridRow = 2;
contentStyle.msGridColumn = contentColumn;
contentStyle.msGridRowSpan = 2;
contentStyle.msGridColumnSpan = 1;
contentElement.setAttribute("data-block-visibility", "shown");
}
// layout footer
var footerBlockElement = this._getFooterBlockElement(context);
var footerStyle = footerBlockElement.style;
var footerColumn = (((columnCount * 2) + 1) * pageIndex) + 2;
var footerColumnSpan = columnCount * 2 - 1;
footerStyle.msGridRow = 4;
footerStyle.msGridColumn = footerColumn;
footerStyle.msGridRowSpan = 1;
footerStyle.msGridColumnSpan = footerColumnSpan;
footerBlockElement.setAttribute("data-block-visibility", "shown");
},
destroy: function destroy(context) {
/// <summary>
/// Destroy this page by hiding its content and footer elements.
/// </summary>
var contentElements = this._contentElements;
var gridOptions = context.gridOptions;
var startIndex = this._getStartIndex(gridOptions);
var endIndex = this._getEndIndex(gridOptions);
// hide content elements
for (var i = startIndex; i <= endIndex; i++) {
var contentElement = this._getContentElement(i, context);
contentElement.setAttribute("data-block-visibility", "hidden");
}
// hide footer element
var footerBlockElement = this._getFooterBlockElement(context);
footerBlockElement.setAttribute("data-block-visibility", "hidden");
},
getFirstEmptyColumn: function getFirstEmptyColumn(context) {
/// <summary>
/// Returns the 0-based index of the first empty column on this page
/// </summary>
var gridOptions = context.gridOptions;
var startIndex = this._getStartIndex(gridOptions);
var endIndex = this._getEndIndex(gridOptions);
var emptyColumn = -1;
for (var i = startIndex; i <= endIndex; i++) {
var isColumnEmpty = this._isColumnEmpty(i, context, true);
if (isColumnEmpty) {
emptyColumn = i;
break;
}
}
return emptyColumn;
},
_getStartIndex: function _getStartIndex(gridOptions) {
/// <summary>
/// Returns the 0-based index of the first column on this page.
/// </summary>
var columnCount = gridOptions.columnCount;
var pageIndex = this.pageIndex;
var startIndex = pageIndex * columnCount;
return startIndex;
},
_getEndIndex: function _getEndIndex(gridOptions) {
/// <summary>
/// Returns the 0-based index of the last column on this page.
/// </summary>
var columnCount = gridOptions.columnCount;
var pageIndex = this.pageIndex;
var endIndex = (pageIndex + 1) * columnCount - 1;
return endIndex;
},
_isExclusionOnPage: function _isExclusionOnPage(exclusion, gridOptions) {
var columnCount = gridOptions.columnCount;
var column = exclusion.column;
var pageIndex = this.pageIndex;
var pageIndexForColumn = Math.floor(column / columnCount);
var isExclusionOnPage = (pageIndexForColumn === pageIndex);
return isExclusionOnPage;
},
_isExclusionOnHigherPage: function _isExclusionOnHigherPage(exclusion, gridOptions) {
var columnCount = gridOptions.columnCount;
var column = exclusion.column;
var pageIndex = this.pageIndex;
var pageIndexForColumn = Math.floor(column / columnCount);
var isExclusionOnHigherPage = (pageIndexForColumn > pageIndex);
return isExclusionOnHigherPage;
},
_getContentElement: function _getContentElement(index, context) {
var contentElements = this._contentElements;
var surfaceManager = this._surfaceManager;
var auxiliaryData = context.auxiliaryData;
var flowId = auxiliaryData.flowId;
while (index > contentElements.length - 1) {
var element = CommonJS.ArticleReader.ArticleReaderUtils.createContentElement(flowId);
surfaceManager.appendElement(element);
contentElements.push(element);
}
var contentElement = contentElements[index];
return contentElement;
},
_getFooterBlockElement: function _getFooterBlockElement(context) {
var footerBlockElements = this._footerBlockElements;
var pageIndex = this.pageIndex;
var surfaceManager = this._surfaceManager;
var gridOptions = context.gridOptions;
while (pageIndex > footerBlockElements.length - 1) {
var element = document.createElement("div");
WinJS.Utilities.addClass(element, "footerBlock");
surfaceManager.appendElement(element);
footerBlockElements.push(element);
}
var footerBlockElt = footerBlockElements[pageIndex];
footerBlockElt.innerHTML = "";
var footer = this._footer = new CommonJS.ArticleReader.Footer(null, {
gridOptions: gridOptions,
pageNumberString: "",
});
var footerElt = footer.elt;
footerBlockElt.appendChild(footerElt);
return footerBlockElt;
},
_isColumnEmpty: function _isColumnEmpty(index, context, excludeTitle) {
var isBlockEmpty = true;
var isContentEmpty = true;
var exclusions = excludeTitle ? CommonJS.ArticleReader.ArticleReaderUtils.getAllNonTitleExclusions(context) : CommonJS.ArticleReader.ArticleReaderUtils.getAllExclusions(context);
for (var i = 0, len = exclusions.length; i < len; i++) {
var exclusion = exclusions[i];
var isExclusionOnColumn = CommonJS.ArticleReader.ArticleReaderUtils.isExclusionOnColumn(exclusion, index);
if (isExclusionOnColumn) {
isBlockEmpty = false;
break;
}
}
if (isBlockEmpty) {
var column = this._getContentElement(index, context);
isContentEmpty = CommonJS.ArticleReader.ArticleReaderUtils.isContentElementEmpty(column);
}
var isColumnEmpty = isContentEmpty && isBlockEmpty;
return isColumnEmpty;
},
},
{
})
});
})();
/* File: PageNumber.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Control for the page number on each page.
WinJS.Namespace.define("CommonJS.ArticleReader", {
PageNumber: WinJS.Class.define(
function (elt, options) {
/// <summary>
/// Creates an instance.
/// </summary>
/// <param name="options">
/// pageNumberString: the presentable string to show in this control.
/// </param>
elt = this._elt = elt ? elt : document.createElement("div");
elt.winControl = this;
elt.setAttribute("aria-hidden", true);
WinJS.Utilities.addClass(elt, "pageNumber");
this.pageNumberString = options.pageNumberString;
},
{
_elt: null,
pageNumberString: {
set: function set(value) {
var elt = this._elt;
elt.innerText = value;
},
},
},
{
}),
});
})();
/* File: SnappedArticleReader.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
var U = CommonJS.ArticleReader.ArticleReaderUtils;
// Displays article data in vertical layout for snapped mode.
WinJS.Namespace.define("CommonJS.ArticleReader", {
SnappedArticleReader: WinJS.Class.define(
function (elt) {
/// <summary>
/// Constructs a SnappedArticle Reader.
/// </summary>
elt = this.elt = elt ? elt : document.createElement("div");
elt.winControl = this;
WinJS.Utilities.addClass(elt, "snappedArticleReader");
this._currentArticleId = null;
},
{
_rendered: null,
_currentArticleId: null,
dispose: function dispose() {
this.elt.innerHTML = "";
},
currentArticleId: {
get: function get() {
return this._currentArticleId;
}
},
render: function render(articleId, data, renderOptions) {
var elt = this.elt;
elt.innerHTML = "";
this._currentArticleId = articleId;
var titleBlockElt = document.createElement("div");
titleBlockElt.className = "titleBlock";
var titleContainerElt = document.createElement("div");
titleContainerElt.className = "titleContainer";
titleBlockElt.appendChild(titleContainerElt);
var isInterstitialAd = data.metadata && data.metadata.adMetadata;
if (isInterstitialAd) {
// for interstitial ad, just add a button that says Unsnap
var unsnapButton = document.createElement("button");
unsnapButton.textContent = CommonJS.resourceLoader.getString("/Platform/Unsnap");
unsnapButton.attachEvent("onclick", function snappedArticleReader_onClick() {
Windows.UI.ViewManagement.ApplicationView.tryUnsnap();
});
elt.appendChild(unsnapButton);
}
else {
// headline
var headlineElt = document.createElement("h1");
headlineElt.className = "headline";
headlineElt.innerText = data.title.headline;
titleContainerElt.appendChild(headlineElt);
// author
var authorElt = document.createElement("div");
authorElt.className = "author";
authorElt.innerText = data.title.author ? data.title.author : data.title.byline;
titleContainerElt.appendChild(authorElt);
// date
var dateElt = document.createElement("div");
dateElt.className = "date";
var effectiveDate = U.getEffectiveDate(data.title);
var dateString = U.convertDateToString(effectiveDate);
dateElt.innerText = dateString;
titleContainerElt.appendChild(dateElt);
elt.appendChild(titleBlockElt);
var button = document.createElement("button");
button.textContent = CommonJS.resourceLoader.getString("/Common/ArticleReaderUnsnap");
button.attachEvent("onclick", function snappedArticleReader_onClick() {
Windows.UI.ViewManagement.ApplicationView.tryUnsnap();
});
elt.appendChild(button);
}
return WinJS.Promise.wrap({});
}
})
});
})();
/* File: SurfaceManager.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
var U = CommonJS.ArticleReader.ArticleReaderUtils;
// Represents the surface of the article reader. Surface is where all the blocks are rendered.
WinJS.Namespace.define("CommonJS.ArticleReader", {
SurfaceManager: WinJS.Class.define(
function (options) {
/// <summary>
/// Creates an instance of SurfaceManager.
/// </summary>
/// <param name="options">
/// - surface: The surface dom element.
/// </param>
this._surface = options.surface;
this._contentElements = [];
this._pageManagers = [];
this._footerBlockElements = [];
},
{
_surface: null,
_contentElements: null,
_pageManagers: null,
_footerBlockElements: null,
dispose: function dispose() {
// TODO: dispose controls here
},
initializeSurface: function initializeSurface(context) {
/// <summary>
/// initializes the surface
/// </summary>
var surface = this._surface;
var gridOptions = context.gridOptions;
var columnMargin = gridOptions.columnMargin;
var columnWidth = gridOptions.columnWidth;
var leftMargin = gridOptions.leftMargin;
var rightMargin = gridOptions.rightMargin;
var columnCount = gridOptions.columnCount;
var columnHeight = gridOptions.columnHeight;
var topMargin = gridOptions.topMargin;
var bottomMargin = gridOptions.bottomMargin;
var pageWidth = gridOptions.pageWidth;
// row style
var rowHeight = columnHeight / 2;
var rowsStyle = [];
rowsStyle.push(topMargin + "px");
rowsStyle.push(rowHeight + "px");
rowsStyle.push(rowHeight + "px");
rowsStyle.push(bottomMargin + "px");
surface.style.msGridRows = rowsStyle.join(" ");
// column style
var columnsStyle = [];
columnsStyle.push(leftMargin + "px");
for (var j = 0, jlen = columnCount; j < jlen; j++) {
columnsStyle.push(columnWidth + "px");
columnsStyle.push(columnMargin + "px");
}
columnsStyle.pop();
columnsStyle.push(rightMargin + "px");
surface.style.msGridColumns = ["(", columnsStyle.join(" "), ")[1000]"].join(" ");
// title style
var renderData = context.renderData;
var renderableTitle = renderData.renderableTitle;
var titleStyle = renderableTitle.style;
surface.setAttribute("data-title-style", titleStyle);
},
getContentDensity: function getContentDensity(context) {
/// <summary>
/// Returns the number of characters per pixel times pixel.
/// </summary>
var contentDensity;
var calibrationData = context.calibrationData;
if (calibrationData) {
var existingDensity = calibrationData.contentDensity;
if (existingDensity || existingDensity === 0) {
contentDensity = existingDensity;
}
else {
contentDensity = this._determineContentDensity(context);
}
}
else {
contentDensity = this._determineContentDensity(context);
}
contentDensity = Math.max(0.001, contentDensity); // putting a lower cap on density per bug #339350
return contentDensity;
},
calculateLayout: function calculateLayout(context) {
/// <summary>
/// Determines the positioning of all blocks, and populates the layoutData object in context.
/// </summary>
var gridOptions = context.gridOptions;
var columnHeight = gridOptions.columnHeight;
var columnWidth = gridOptions.columnWidth;
var columnCount = gridOptions.columnCount;
var calibrationData = context.calibrationData;
var contentColumnCount = calibrationData.contentColumnCount;
var contentDensity = calibrationData.contentDensity;
var renderData = context.renderData;
var layoutData = context.layoutData;
var auxiliaryData = context.auxiliaryData;
var hideInlineAds = auxiliaryData.hideInlineAds;
// reset layout
this._resetLayout(context);
// title layout
this._layoutTitle(context);
// blocks layout
var renderableBlocks = renderData.renderableBlocks;
var exclusions = CommonJS.ArticleReader.ArticleReaderUtils.getAllExclusionsFromRenderableBlocks(renderableBlocks);
var maxBlockColumn = 0;
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
// don't calculate layout for title blocks
var isTitle = CommonJS.ArticleReader.ArticleReaderUtils.isTitleBlock(renderableBlock);
if (!isTitle) {
var renderer = this._getRenderer(renderableBlock);
if (renderer) {
var position = renderableBlock.position;
var tries = 5; // try for 5 pages and then give up
var currentExclusionColumnCount = this._getExclusionsColumnCount(exclusions, columnHeight);
var startColumn = contentDensity === 0 ? 0 : Math.floor((currentExclusionColumnCount + (position / (contentDensity * columnWidth * columnHeight))) * 2) / 2;
var exclusion = null;
while (!exclusion && tries) {
tries--;
exclusion = renderer.calculateLayout(renderableBlock, startColumn, gridOptions, exclusions);
if (!exclusion) {
// try the next page
startColumn = Math.floor(startColumn) + columnCount - (Math.floor(startColumn) % columnCount);
}
}
if (exclusion) {
// Special treatment for inline ads when the hideInlineAds flag is set.
// This code only runs for server side rendering where we want inline ads to be present
// in the list of renderableBlocks, but for the no-ad configuration be hidden.
var type = this._getType(renderableBlock);
if (hideInlineAds && type === "InlineAd") {
exclusion.height = 0;
}
// End special treatment
renderableBlock.exclusion = exclusion;
exclusions.push(exclusion);
maxBlockColumn = Math.max(maxBlockColumn, exclusion.column + exclusion.columnSpan - 1);
}
}
}
}
// page count (calibrated + exclusions)
var exclusionColumnCount = this._getExclusionsColumnCount(exclusions, columnHeight);
var totalColumnCount = contentColumnCount + exclusionColumnCount;
var pageCount = Math.ceil(Math.max(totalColumnCount, maxBlockColumn + 1) / columnCount);
layoutData.pageCount = pageCount;
// TODO: Consider inserting timeouts
return WinJS.Promise.wrap(null);
},
createElements: function createElements(context) {
/// <summary>
/// Create all the dom elements for all blocks.
/// </summary>
var that = this;
var innerPromise;
var promise = new WinJS.Promise(
function (c, e, p) {
innerPromise = WinJS.Promise.wrap(null);
innerPromise = innerPromise
.then(function () {
that.createTitleElements(context);
return WinJS.Promise.wrap(null);
})
.then(function () {
return WinJS.Promise.timeout();
})
.then(function () {
that._createBlockElements(context);
return WinJS.Promise.wrap(null);
})
.then(function () {
c();
}, function (err) {
e(err);
});
},
function () {
if (innerPromise) {
innerPromise.cancel();
}
});
return promise;
},
associateLayoutWithElements: function associateLayoutWithElements(context, useLayoutHints) {
/// <summary>
/// Associate layout positining data with dom elements are created.
/// </summary>
var gridOptions = context.gridOptions;
this._createPages(context);
// initially hide all content and footer blocks (in case any left overs from previous rotation)
this._hideAllPageElements();
// hide all blocks
this._hideAllBlocks(context);
// page elements
var pageManagers = this._pageManagers;
for (var i = 0, leni = pageManagers.length; i < leni; i++) {
var pageManager = pageManagers[i];
pageManager.associateLayoutWithElements(context);
}
var renderData = context.renderData;
var renderableBlocks = renderData.renderableBlocks;
// layout other blocks
for (var j = 0, lenj = renderableBlocks.length; j < lenj; j++) {
var renderableBlock = renderableBlocks[j];
var isTitle = CommonJS.ArticleReader.ArticleReaderUtils.isTitleBlock(renderableBlock);
if (!isTitle || useLayoutHints) {
var element = renderableBlock.element;
if (useLayoutHints) {
// place the element and create the exclusion based on layout
CommonJS.ArticleReader.ArticleReaderUtils.assignLayout(renderableBlock, context);
}
else {
// get the exclusion
var exclusion = renderableBlock.exclusion;
if (exclusion) {
CommonJS.ArticleReader.ArticleReaderUtils.assignExclusion(renderableBlock, context);
}
}
// run renderer's specific layout tasks
if (!isTitle) {
var renderer = this._getRenderer(renderableBlock);
var isAggregated = this._isAggregated(renderableBlock);
renderer.applyLayout(renderableBlock, isAggregated, context);
}
// show or hide the block based on whether it has an exclusion associated
exclusion = renderableBlock.exclusion;
if (exclusion && exclusion.height > 0) {
element.setAttribute("data-block-visibility", "shown");
var rowAlign = exclusion.rowAlign;
element.setAttribute("data-location", rowAlign);
}
else {
element.setAttribute("data-block-visibility", "hidden");
}
if (!useLayoutHints) {
// HACK for an IE bug
CommonJS.ArticleReader.ArticleReaderUtils.setFixedElementHeight(element);
// END HACK
}
// update layout
CommonJS.ArticleReader.ArticleReaderUtils.updateLayout(renderableBlock, context);
}
}
// TODO
return WinJS.Promise.wrap(null);
},
adjust: function adjust(context, useLayoutHints) {
/// <summary>
/// After layout association, does any final adjustments necessary.
/// </summary>
var that = this;
var promise = WinJS.Promise.wrap(null);
promise = promise
.then(function () {
if (!useLayoutHints) {
// aggregate inline blocks that are off by themselves
that._aggregateOrphans(context);
}
// hide end blocks
that._hideEndRenderableBlocks(context);
// fix up number of pages
that._adjustPages(context);
return WinJS.Promise.timeout();
})
.then(function () {
// render end blocks (tower ad, eoa, referral)
that._renderAndLayoutEndUi(context);
// fix up number of pages
that._adjustPages(context);
return WinJS.Promise.timeout();
})
.then(function () {
// update surface size
that._updateSurfaceSize(context);
// update page data
that._updatePageNumberData(context);
// update layout hints for page count, etc. this should be the last thing to run
that._updateLayoutHints(context);
return WinJS.Promise.wrap(null);
});
return promise;
},
appendElement: function appendElement(element) {
/// <summary>
/// Appends the given dom element to the surface.
/// </summary>
var surface = this._surface;
if (element) {
surface.appendChild(element);
}
},
appendBlock: function appendBlock(renderableBlock, element) {
/// <summary>
/// Appends the given element to the surface and update its renderableBlock.
/// </summary>
var surface = this._surface;
var oldElement = renderableBlock.oldElement;
if (oldElement) {
surface.removeChild(oldElement);
}
if(element) {
surface.appendChild(element);
}
renderableBlock.element = element;
},
removeBlock: function removeBlock(renderableBlock) {
/// <summary>
/// Removes the given renderable block's dom element from the surface.
/// </summary>
var surface = this._surface;
var element = renderableBlock.element;
if (element) {
surface.removeChild(element);
}
renderableBlock.element = null;
},
removeBlocks: function removeBlocks(renderableBlocks) {
/// <summary>
/// A loop around removeBlock()
/// </summary>
var surface = this._surface;
if (renderableBlocks) {
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
this.removeBlock(renderableBlock);
}
}
},
getLastPageWithEmptyLastColumn: function getLastPageWithEmptyLastColumn(context, createNewPage) {
/// <summary>
/// Returns the PageManager associated with the last page with an empty column.
/// Creates a new page if necessary. Used for trailing blocks such as Referral block.
/// </summary>
/// <param name="createNewPage">If false, don't attempt to create a new page, and return null.</param>
var pageManagers = this._pageManagers;
var lastPage = pageManagers[pageManagers.length - 1];
var isLastColumnEmpty = lastPage.isLastColumnEmpty(context);
var page;
if (isLastColumnEmpty) {
page = lastPage;
}
else if (createNewPage) {
page = this._addPage(context);
page.associateLayoutWithElements(context);
}
return page;
},
getLastColumnWithContent: function getLastColumnWithContent(context) {
/// <summary>
/// Returns the 0-based column index of the last column on the surface with any content in it.
/// </summary>
var contentElements = this._contentElements;
var index = 0;
for (var i = contentElements.length - 1; i >= 0; i--) {
var contentElement = contentElements[i];
if (!CommonJS.ArticleReader.ArticleReaderUtils.isContentElementEmpty(contentElement)) {
index = i;
break;
}
}
return index;
},
isColumnOverflowing: function isColumnOverflowing(columnIndex, context) {
/// <summary>
/// Given a 0-based column index, determines whether that column is overflowing.
/// </summary>
var contentElements = this._contentElements;
var contentElement = contentElements[columnIndex];
var isOverflowing = false;
if (contentElement) {
isOverflowing = CommonJS.ArticleReader.ArticleReaderUtils.isContentElementOverflowing(contentElement);
}
return isOverflowing;
},
getNextColumnIndexAndMaybeCreatePage: function getNextColumnIndexAndMaybeCreatePage(columnIndex, context) {
/// <summary>
/// Given a starting 0-based column index, returns the index of the next column, and creates an additional page in the process if necessary.
/// </summary>
var pageManagers = this._pageManagers;
var gridOptions = context.gridOptions;
var columnCount = gridOptions.columnCount;
var nextColumnIndex = columnIndex + 1;
while (pageManagers.length * columnCount <= nextColumnIndex) {
var page = this._addPage(context);
page.associateLayoutWithElements(context);
}
return nextColumnIndex;
},
getPageCount: function getPageCount() {
var pageManagers = this._pageManagers;
var pageCount = pageManagers.length;
return pageCount;
},
getFirstEmptyColumn: function getFirstEmptyColumn(context, createPage) {
/// <summary>
/// Returns the 0-based index of the first empty column after the end of the article.
/// If createPage is true, creates a page if last page is full.
/// </summary>
var pageManagers = this._pageManagers;
var lastPage = pageManagers[pageManagers.length - 1];
var emptyColumn = lastPage ? lastPage.getFirstEmptyColumn(context) : -1;
if (emptyColumn === -1) {
// if last page doesn't have any empty columns, create a new page and return the first column of the new page
if (createPage) {
var page = this._addPage(context);
page.associateLayoutWithElements(context);
}
var gridOptions = context.gridOptions;
var columnCount = gridOptions.columnCount;
emptyColumn = (lastPage.pageIndex + 1) * columnCount;
}
return emptyColumn;
},
createTitleElements: function createTitleElements(context) {
var renderData = context.renderData;
var titleRenderableBlocks = renderData.titleRenderableBlocks;
// render title blocks
for (var k in titleRenderableBlocks) {
var titleRenderableBlock = titleRenderableBlocks[k];
var renderer = this._getRenderer(titleRenderableBlock);
if (renderer) {
var element = renderer.render(titleRenderableBlock, context);
this.appendBlock(titleRenderableBlock, element);
}
}
},
_isAggregated: function _isAggregated(renderableBlock) {
var isAggregated = false;
var layout = renderableBlock.layout;
if (layout) {
var zIndex = layout.zIndex;
isAggregated = (zIndex === 3);
}
return isAggregated;
},
_renderAndLayoutEndUi: function _renderAndLayoutEndUi(context) {
var renderData = context.renderData;
var endRenderableBlocks = renderData.endRenderableBlocks;
var renderers = CommonJS.ArticleReader.SurfaceManager.endUiRenderers;
for (var i = 0, len = endRenderableBlocks.length; i < len; i++) {
var endRenderableBlock = endRenderableBlocks[i];
var block = endRenderableBlock.block;
var type = block.type;
var renderer = renderers[type];
if (renderer) {
var element = endRenderableBlock.element;
// render element if not already rendered
if (!element) {
element = renderer.render(endRenderableBlock, context);
this.appendBlock(endRenderableBlock, element);
}
// layout
element.setAttribute("data-block-visibility", "hidden"); // hide the block first so an accurate position for it can be calculate in layout()
var isVisible = renderer.layout(endRenderableBlock, this, context);
element.setAttribute("data-block-visibility", isVisible ? "shown" : "hidden");
CommonJS.ArticleReader.ArticleReaderUtils.updateLayout(endRenderableBlock, context);
}
}
var promise = WinJS.Promise.wrap(null);
return promise;
},
_determineContentDensity: function _determineContentDensity(context) {
var surface = this._surface;
var contentElements = this._contentElements;
var auxiliaryData = context.auxiliaryData;
var flowId = auxiliaryData.flowId;
var contentElement = CommonJS.ArticleReader.ArticleReaderUtils.createContentElement(flowId);
contentElements.push(contentElement);
surface.appendChild(contentElement);
var style = contentElement.style;
style.msGridRow = 2;
style.msGridColumn = 2;
style.msGridRowSpan = 2;
style.msGridColumnSpan = 1;
var charCount = 0;
var ranges = contentElement.msGetRegionContent();
if (ranges) {
for (var i = 0, len = ranges.length; i < len; i++) {
var range = ranges[i];
charCount = charCount + range.toString().length;
}
}
var charactersPerColumn = charCount;
var gridOptions = context.gridOptions;
var columnHeight = gridOptions.columnHeight;
var columnWidth = gridOptions.columnWidth;
var density = charactersPerColumn / (columnHeight * columnWidth);
return density; // characters per px*px
},
_getExclusionsColumnCount: function _getExclusionsColumnCount(exclusions, columnHeight) {
var startMap = {};
var endMap = {};
var maxColumn = -1;
for (var i = 0, len = exclusions.length; i < len; i++) {
var exclusion = exclusions[i];
var rowAlign = exclusion.rowAlign;
var column = exclusion.column;
var columnSpan = exclusion.columnSpan;
var height = exclusion.height;
maxColumn = Math.max(maxColumn, column + columnSpan - 1);
var map = (rowAlign === "end" ? endMap : startMap);
for (var j = column; j < column + columnSpan; j++) {
var currentColumn = j;
var currentHeight = map[currentColumn] || 0;
map[currentColumn] = Math.max(currentHeight, height);
}
}
var columns = 0;
for (var k = 0; k <= maxColumn; k++) {
var startHeight = startMap[k] || 0;
var endHeight = endMap[k] || 0;
var sumHeight = Math.min(startHeight + endHeight, columnHeight);
columns += sumHeight / columnHeight;
}
return columns;
},
_adjustPages: function _adjustPages(context) {
var pageManagers = this._pageManagers;
var lastPage;
// remove some
while (true) {
lastPage = pageManagers[pageManagers.length - 1];
var isEmpty = lastPage && lastPage.isEmpty(context);
if (isEmpty) {
this._removeLastPage(context);
}
else {
break;
}
}
// add some
while (true) {
lastPage = pageManagers[pageManagers.length - 1];
var isOverflowing = lastPage && lastPage.isOverflowing(context);
if (isOverflowing) {
// add one more page
var pageManager = this._addPage(context);
pageManager.associateLayoutWithElements(context);
}
else {
break;
}
}
},
_updatePageNumberData: function _updatePageNumberData(context) {
var pageManagers = this._pageManagers;
var pageCount = pageManagers.length;
for (var i = 0; i < pageCount; i++) {
var pageManager = pageManagers[i];
pageManager.pageNumberString = CommonJS.ArticleReader.ArticleReaderUtils.convertPageNumberDataToString(i, pageCount);
}
},
_addPage: function _addPage(context) {
var contentElements = this._contentElements;
var footerBlockElements = this._footerBlockElements;
var gridOptions = context.gridOptions;
var surface = this._surface;
var pageManagers = this._pageManagers;
var auxiliaryData = context.auxiliaryData;
// page data
var pageIndex = pageManagers.length;
var pageManager = new CommonJS.ArticleReader.PageManager({
pageIndex: pageIndex,
pageNumberString: "",
contentElements: contentElements,
footerBlockElements: footerBlockElements,
gridOptions: gridOptions,
surfaceManager: this,
});
pageManagers.push(pageManager);
return pageManager;
},
_removeLastPage: function _removeLastPage(context) {
var pageManagers = this._pageManagers;
var pageManager = pageManagers.pop();
pageManager.destroy(context);
},
_updateSurfaceSize: function _updateSurfaceSize(context) {
var surface = this._surface;
var gridOptions = context.gridOptions;
var pageWidth = gridOptions.pageWidth;
var pageManagers = this._pageManagers;
var pageCount = pageManagers.length;
// update surface width
surface.style.width = pageWidth * pageCount + "px";
},
_createBlockElements: function _createBlockElements(context) {
var renderData = context.renderData;
var renderableBlocks = renderData.renderableBlocks;
var surface = this._surface;
var gridOptions = context.gridOptions;
for (var i = 0, ilen = renderableBlocks.length; i < ilen; i++) {
var renderableBlock = renderableBlocks[i];
var element = renderableBlock.element;
if (!element) {
var renderer = this._getRenderer(renderableBlock);
if (renderer) {
var block = renderableBlock.block;
var attributes = block.attributes;
element = renderer.render(renderableBlock, context);
// process element
this.appendBlock(renderableBlock, element);
}
}
}
},
_hideAllPageElements: function _hideAllPageElements() {
var contentElements = this._contentElements;
for (var i = 0, leni = contentElements.length; i < leni; i++) {
var contentElement = contentElements[i];
contentElement.setAttribute("data-block-visibility", "hidden");
}
var footerBlockElements = this._footerBlockElements;
for (var j = 0, lenj = footerBlockElements.length; j < lenj; j++) {
var footerBlockElement = footerBlockElements[j];
footerBlockElement.setAttribute("data-block-visibility", "hidden");
}
},
_hideAllBlocks: function _hideAllBlocks(context) {
var renderData = context.renderData;
var renderableBlocks = renderData.renderableBlocks;
var endRenderableBlocks = renderData.endRenderableBlocks;
this._hideRenderableBlocks(renderableBlocks);
this._hideRenderableBlocks(endRenderableBlocks);
},
_hideRenderableBlocks: function _hideRenderableBlocks(renderableBlocks) {
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
var isTitle = CommonJS.ArticleReader.ArticleReaderUtils.isTitleBlock(renderableBlock);
if (!isTitle) {
var element = renderableBlock.element;
if (element) {
element.setAttribute("data-block-visibility", "hidden");
}
}
}
},
_hideEndRenderableBlocks: function _hideEndRenderableBlocks(context) {
var renderData = context.renderData;
var endRenderableBlocks = renderData.endRenderableBlocks;
this._hideRenderableBlocks(endRenderableBlocks);
},
_aggregateOrphans: function _aggregateOrphans(context) {
var surface = this._surface;
// aggregate blocks that are not allowed to be orphaned and are on empty final columns
var contentElements = this._contentElements;
var gridOptions = context.gridOptions;
var columnHeight = gridOptions.columnHeight;
var columnCount = gridOptions.columnCount;
// first pass to get all the orphans, fix up number of pages first for accuracy of the getLastColumnWithContent call.
this._adjustPages(context);
var lastColumnWithContent = this.getLastColumnWithContent(context);
var orphansData = this._getOrphansData(context, lastColumnWithContent);
var orphanRenderableBlocks = orphansData.orphanRenderableBlocks;
context.auxiliaryData.instrumentationData.trailingMediaBlockCount = orphansData.trailingMediaBlockCount;
// second pass to aggregate the orphans
var aggregationColumn = lastColumnWithContent;
var lastColumnWithExclusion = this._getLastColumnWithExclusion(context);
var emptyColumn = Math.max(lastColumnWithContent, lastColumnWithExclusion) + 1;
var limits = U.getColumnLimits(context, aggregationColumn, orphanRenderableBlocks);
var marginTop = limits.top;
var marginBottom = limits.bottom;
var first = true;
// hide all orphans first
this._hideRenderableBlocks(orphanRenderableBlocks);
for (var i = 0, len = orphanRenderableBlocks.length; i < len; i++) {
var orphanRenderableBlock = orphanRenderableBlocks[i];
var element = orphanRenderableBlock.element;
// show just this orphan
element.setAttribute("data-block-visibility", "shown");
// reset aggregation state from previous layout
this._applyAggregation(orphanRenderableBlock, true);
// prepare for aggregation (resize, etc.) and measure height
var height = this._prepareForAggregation(orphanRenderableBlock, columnHeight, emptyColumn, context);
// special handling for the first orphan
if (first) {
first = false;
// try the bottom of the last column first
height = this._aggregate(orphanRenderableBlock, aggregationColumn, marginBottom, context, "end");
// did the last column overflow? 
var isOverflowing = this.isColumnOverflowing(aggregationColumn, context);
if (isOverflowing) {
// the next aggregation point is the top of the next column
aggregationColumn++;
limits = U.getColumnLimits(context, aggregationColumn, orphanRenderableBlocks);
marginTop = limits.top;
// if it did, aggregate to the top of next column instead
height = this._aggregate(orphanRenderableBlock, aggregationColumn, marginTop, context, "start");
// move aggregation snap point down
marginTop += height;
}
else {
// the next aggregation point is the top of the next column
aggregationColumn++;
limits = U.getColumnLimits(context, aggregationColumn, orphanRenderableBlocks);
marginTop = limits.top;
}
CommonJS.ArticleReader.ArticleReaderUtils.updateLayout(orphanRenderableBlock, context);
// handled the first block, go on to the next one
continue;
}
// go to next aggregation column if necessary
if (marginTop + height > columnHeight - limits.bottom) {
aggregationColumn++;
limits = U.getColumnLimits(context, aggregationColumn, orphanRenderableBlocks);
marginTop = limits.top;
}
height = this._aggregate(orphanRenderableBlock, aggregationColumn, marginTop, context, "start");
CommonJS.ArticleReader.ArticleReaderUtils.updateLayout(orphanRenderableBlock, context);
// move aggregation snap point down
marginTop += height;
}
},
_getOrphansData: function _getOrphansData(context, lastColumnWithContent) {
var orphanRenderableBlocks = [];
var actions;
var renderData = context.renderData;
var renderableBlocks = renderData.renderableBlocks;
var trailingMediaBlockCount = 0;
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
var element = renderableBlock.element;
var isTitle = CommonJS.ArticleReader.ArticleReaderUtils.isTitleBlock(renderableBlock);
var shouldHandleOrphan = !isTitle && this._shouldHandleOrphan(renderableBlock, lastColumnWithContent);
if (shouldHandleOrphan) {
orphanRenderableBlocks.push(renderableBlock);
trailingMediaBlockCount++;
}
}
var orphansData = {
orphanRenderableBlocks: orphanRenderableBlocks,
trailingMediaBlockCount: trailingMediaBlockCount
};
return orphansData;
},
_aggregate: function _aggregate(renderableBlock, column, margin, context, rowAlign) {
var exclusion = renderableBlock.exclusion;
var element = renderableBlock.element;
var gridOptions = context.gridOptions;
var columnHeight = gridOptions.columnHeight;
var columnCount = gridOptions.columnCount;
// update exclusion
var columnSpan = 1;
exclusion.column = column;
exclusion.columnSpan = columnSpan;
exclusion.rowAlign = rowAlign;
exclusion.height = columnHeight;
// update element in grid
var gridColumn = CommonJS.ArticleReader.ArticleReaderUtils.convertColumnIndexToGridColumn(column, columnCount);
var gridColumnSpan = columnSpan * 2 - 1;
var style = element.style;
style.msGridColumn = gridColumn;
style.msGridColumnSpan = gridColumnSpan;
CommonJS.ArticleReader.ArticleReaderUtils.setRowAlign(element, rowAlign);
// aggregate
this._applyAggregation(renderableBlock, false, margin, rowAlign);
var renderer = this._getRenderer(renderableBlock);
renderer.applyLayout(renderableBlock, true, context);
var height = U.setFixedElementHeight(element);
return height;
},
_prepareForAggregation: function _prepareForAggregation(renderableBlock, columnHeight, emptyColumn, context) {
var gridOptions = context.gridOptions;
var newExclusion = {
column: emptyColumn,
columnSpan: 1,
rowAlign: "start",
height: columnHeight,
};
renderableBlock.exclusion = newExclusion;
CommonJS.ArticleReader.ArticleReaderUtils.assignExclusion(renderableBlock, context);
var renderer = this._getRenderer(renderableBlock);
renderer.applyLayout(renderableBlock, true, context);
var element = renderableBlock.element;
var height = U.setFixedElementHeight(element);
return height;
},
_applyAggregation: function _applyAggregation(renderableBlock, reset, margin, rowAlign) {
var element = renderableBlock.element;
var style = element.style;
// Reset top and bottom margins regardless of the reset flag. This is because for the first aggregated block, we may
// call this function twice, once for the bottom of column N, and once for the top of column N+1
style.marginTop = "";
style.marginBottom = "";
if (reset) {
style.zIndex = 2; // use zIndex 2 to indicate non-aggregated blocks
style.height = "";
style.width = "";
}
else {
style.zIndex = 3; // use zIndex 3 to indicate aggregated blocks
// see if we're applying top or bottom margin
var isMarginBottom = rowAlign === "end" ? true : false;
if (isMarginBottom) {
style.marginBottom = margin + "px";
}
else {
style.marginTop = margin + "px";
}
}
},
_shouldHandleOrphan: function _shouldHandleOrphan(renderableBlock, lastColumnWithContent) {
var shouldHandleOrphan = false;
var contentElements = this._contentElements;
var isAggregatable = this._isAggregatable(renderableBlock);
if (isAggregatable) {
var exclusion = renderableBlock.exclusion;
if (exclusion) {
var column = exclusion.column;
var columnSpan = exclusion.columnSpan;
for (var j = column, jlen = column + columnSpan; j < jlen; j++) {
var contentElement = contentElements[j];
if (!contentElement) {
shouldHandleOrphan = true;
break;
} else {
// handle orphan when it is visible and any part of it is beyond the last content column, or it is at the bottom of the last content column
var onLastColumn =  (j === lastColumnWithContent && exclusion.rowAlign === "end" && columnSpan === 1);
var beyondLastColumn = (j > lastColumnWithContent);
var visibility = contentElement.getAttribute("data-block-visibility");
var shown = (visibility === "shown");
if (shown && (onLastColumn || beyondLastColumn)) {
shouldHandleOrphan = true;
break;
}
}
}
}
}
return shouldHandleOrphan;
},
_getLastColumnWithExclusion: function _getLastColumnWithExclusion(context) {
var exclusions = CommonJS.ArticleReader.ArticleReaderUtils.getAllExclusions(context);
var index = 0;
for (var i = 0, len = exclusions.length; i < len; i++) {
var exclusion = exclusions[i];
index = Math.max(index, exclusion.column + exclusion.columnSpan - 1);
}
return index;
},
_isAggregatable: function _isAggregatable(renderableBlock) {
var block = renderableBlock.block;
var type = block.type;
var isTitle = CommonJS.ArticleReader.ArticleReaderUtils.isTitleBlock(renderableBlock);
var isAggregatable = !isTitle && (CommonJS.ArticleReader.SurfaceManager.aggregatableTypes.indexOf(type) > -1);
return isAggregatable;
},
_layoutTitle: function _layoutTitle(context) {
var renderData = context.renderData;
var renderableTitle = renderData.renderableTitle;
var titleRenderableBlocks = renderData.titleRenderableBlocks;
var style = renderableTitle.style;
var titleRenderer = CommonJS.ArticleReader.SurfaceManager.titleRenderers[style];
// calculate title block layouts
titleRenderer.layout(titleRenderableBlocks, context);
// update layout
for (var k in titleRenderableBlocks) {
var titleRenderableBlock = titleRenderableBlocks[k];
CommonJS.ArticleReader.ArticleReaderUtils.updateLayout(titleRenderableBlock, context);
}
},
_updateLayoutHints: function _updateLayoutHints(context) {
var layoutData = context.layoutData;
var pageManagers = this._pageManagers;
var pageCount = pageManagers.length;
layoutData.pageCount = pageCount;
},
_createPages: function _createPages(context) {
var layoutData = context.layoutData;
var pageCount = layoutData.pageCount;
// create page managers
var pageManagers = this._pageManagers;
while (pageManagers.length < pageCount) {
this._addPage(context);
}
while (pageManagers.length > pageCount) {
this._removeLastPage(context);
}
},
_getRenderer: function _getRenderer(renderableBlock) {
var block = renderableBlock.block;
var type = block.type;
var renderers = CommonJS.ArticleReader.SurfaceManager.blockRenderers;
var renderer = renderers[type] || renderers["Null"];
return renderer;
},
_getType: function _getType(renderableBlock) {
var block = renderableBlock.block;
var type = block.type;
return type;
},
_resetLayout: function _resetLayout(context) {
var renderData = context.renderData;
var renderableBlocks = renderData.renderableBlocks;
for (var i = 0, len = renderableBlocks.length; i < len; i++) {
var renderableBlock = renderableBlocks[i];
CommonJS.ArticleReader.ArticleReaderUtils.resetLayout(renderableBlock, context);
var element = renderableBlock.element;
element.setAttribute("data-block-visibility", "hidden");
}
},
},
{
blockRenderers: {
InlineImage: CommonJS.ArticleReader.InlineImageRenderer,
InlineSlideshow: CommonJS.ArticleReader.InlineSlideshowRenderer,
FocusImage: CommonJS.ArticleReader.InlineImageRenderer,
InlineVideo: CommonJS.ArticleReader.InlineVideoRenderer,
External: CommonJS.ArticleReader.ExternalRenderer,
InlineAd: CommonJS.ArticleReader.InlineAdRenderer,
// title blocks
Text: CommonJS.ArticleReader.TextRenderer,
Image: CommonJS.ArticleReader.ImageRenderer,
Rect: CommonJS.ArticleReader.RectRenderer,
Null: CommonJS.ArticleReader.NullRenderer,
},
endUiRenderers: {
EndAd: CommonJS.ArticleReader.EndAdRenderer,
Actions: CommonJS.ArticleReader.ActionsRenderer,
Referral: CommonJS.ArticleReader.ReferralRenderer,
},
titleRenderers: {
1: CommonJS.ArticleReader.TitleStyle1Renderer,
2: CommonJS.ArticleReader.TitleStyle2Renderer,
9: CommonJS.ArticleReader.TitleStyle9Renderer,
100: CommonJS.ArticleReader.TitleStyle100Renderer,
},
aggregatableTypes: [
"InlineImage",
"InlineSlideshow",
"FocusImage",
"InlineVideo",
"External",
"InlineAd",
],
}),
});
})();
/* File: AdContainer.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// 
WinJS.Namespace.define("CommonJS.ArticleReader", {
AdContainer: WinJS.Class.define(
function (elt, options) {
/// <summary>
/// Creates a AdContainer instance.
/// </summary>
/// <param name="options">
/// - controlOptions: options object sent to the control
/// - controlType: "PlatformJS.Ads.RotatingAdsWrapperControl" or "PlatformJS.Ads.AdsWrapperControl"
/// </param>
elt = this._elt = elt ? elt : document.createElement("div");
elt.winControl = this;
WinJS.Utilities.addClass(elt, "adContainer");
// read from options
var controlOptions = this._controlOptions = options.controlOptions;
var controlType = this._controlType = options.controlType;
this._isAdInstantiated = false;
},
{
_elt: null,
_adControl: null,
_controlOptions: null,
_controlType: null,
_isAdInstantiated: null,
element: {
get: function get() {
return this._elt;
}
},
instantiateAd: function instantiateAd() {
var isAdInstantiated = this._isAdInstantiated;
if (!isAdInstantiated) {
this._isAdInstantiated = true;
var elt = this._elt;
var controlOptions = this._controlOptions;
var controlType = this._controlType;
// create ad element
var adElt = document.createElement("div");
WinJS.Utilities.addClass(adElt, "ad");
elt.appendChild(adElt);
// create ad control
var adControlElt = document.createElement("div");
var adControl = this._adControl = PlatformJS.Utilities.createObject(controlType, adControlElt, controlOptions);
if (adControl) {
adElt.appendChild(adControlElt);
}
} else {
this._refreshAd();
}
},
dispose: function dispose() {
var adControl = this._adControl;
if (adControl && adControl.dispose) {
adControl.dispose();
}
},
relayout: function relayout(relayoutOptions) {
var adControl = this._adControl;
if (adControl && adControl.onOrientationChange) {
adControl.onOrientationChange(Windows.UI.ViewManagement.ApplicationView.value);
}
},
_refreshAd: function _refreshAd() {
var adControl = this._adControl;
if (adControl) {
adControl.refresh();
}
},
}),
});
})();
/* File: InterstitialAd.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
var T = Platform.Telemetry;
// 
WinJS.Namespace.define("CommonJS.ArticleReader", {
InterstitialAd: WinJS.Class.define(
function (elt, options) {
/// <summary>
/// Creates an instance of the InterstitialAd control.
/// </summary>
// create the dom elements
elt = this._elt = elt || document.createElement("div");
elt.winControl = this;
WinJS.Utilities.addClass(elt, "interstitialAd");
this._adContainer = null;
this._isRendered = false;
this._instrumentationData = {
content: {
sourceName: null,
partnerCode: null,
contentId: null,
type: T.ContentType.article,
date: new Date(0),
uri: null,
slug: null,
isSummary: false,
worth: null,
isAd: true,
adCampaign: null,
}
};
},
{
_elt: null,
_adContainer: null,
_isRendered: null,
_instrumentationData: null,
element: {
get: function get() {
return this._elt;
}
},
isRendered: {
get: function get() {
return this._isRendered;
}
},
dispose: function dispose() {
var adContainer = this._adContainer;
if (adContainer) {
adContainer.dispose();
}
},
getHeader: function getHeader() {
return null;
},
getInstrumentationData: function getInstrumentationData() {
return this._instrumentationData;
},
getRenderData: function getRenderData() {
return {};
},
getLayout: function getLayout() {
return {};
},
/*
Logic Implemented, where:
- adPartnerName == 1 when adPartnerName is present and non-empty
- PartnerAd == 1 when an override with a matching PartnerId & size is present
- NonPartnerAd == 1 when an override with a matching size & empty PartnerId is present
NOTE: Logic ideally would match the one in ArticleReader.js - _overrideAds, but the
we couldn't implement NO AD action at this level in the code.
adPartnerName PartnerAd NonPartnerAd Ad displayed
1             1         *            Partner Ad
1	          0         *	         Use what's in adMetadata
0	          *     	1       	 NonPartnerAd
0	          *     	0	         Use what's in adMetadata
*/
_overrideAd: function _overrideAd(parsedAdMetadata, data, adPartnerName) {
var adOverrides = null;
var adInformation = null;
if (data.previousArticle) {
adInformation = data.previousArticle.adInformation;
adOverrides = adInformation ? CommonJS.ArticleReader.ArticleReaderUtils.convertAdInformationToAdOverrides(adInformation) : null;
}
if (!adOverrides && data.nextArticle) {
adInformation = data.nextArticle.adInformation;
adOverrides = adInformation ? CommonJS.ArticleReader.ArticleReaderUtils.convertAdInformationToAdOverrides(adInformation) : null;
}
if (!adOverrides || !adOverrides.length) {
return;
}
var options = parsedAdMetadata.controlOptions.adOptions;
var lOptions = options.landscapeOptions;
var pOptions = options.portraitOptions;
for (var i = 0; i < adOverrides.length; i++) {
var adOverride = adOverrides[i];
if ((adPartnerName && adOverride.partnerId === adPartnerName) ||
(!adPartnerName && !adOverride.partnerId)) {
for (var j = 0; j < adOverride.ads.length; j++) {
if (CommonJS.ArticleReader.ArticleReaderUtils.adTypeMatchesClass(adOverride.ads[j].type, lOptions.className)) {
lOptions.otherAdOptions.adUnitId = lOptions.adUnitId = adOverride.ads[j].id;
}
if (CommonJS.ArticleReader.ArticleReaderUtils.adTypeMatchesClass(adOverride.ads[j].type, pOptions.className)) {
pOptions.otherAdOptions.adUnitId = pOptions.adUnitId = adOverride.ads[j].id;
}
}
}
}
},
render: function render(data, renderOptions) {
var elt = this._elt;
var metadata = data.metadata;
var adMetadata = metadata.adMetadata;
var parsedAdMetadata = JSON.parse(adMetadata);
var controlType = parsedAdMetadata.controlType;
var controlOptions = parsedAdMetadata.controlOptions;
this._overrideAd(parsedAdMetadata, data, renderOptions.adPartnerName);
// Create render promise
var that = this;
var renderPromise = new WinJS.Promise(
function (complete, error) {
// Pass completion and error methods
// to ad control
if (controlOptions.adOptions) {
var adOptions = controlOptions.adOptions;
if (adOptions.landscapeOptions) {
adOptions.landscapeOptions.completionHandler = complete;
adOptions.landscapeOptions.errorHandler = error;
}
if (adOptions.portraitOptions) {
adOptions.portraitOptions.completionHandler = complete;
adOptions.portraitOptions.errorHandler = error;
}
}
// Create ad container
var adContainer = that._adContainer = new CommonJS.ArticleReader.AdContainer(null, {
controlOptions: controlOptions,
controlType: controlType,
});
var adContainerElt = adContainer.element;
elt.appendChild(adContainerElt);
// Instantiate ad
adContainer.instantiateAd();
})
.then(function () {
that._isRendered = true;
});
// Return render promise
return renderPromise;
},
relayout: function relayout(relayoutOptions) {
var adContainer = this._adContainer;
if (adContainer) {
adContainer.relayout(relayoutOptions);
}
return WinJS.Promise.wrap(null);
},
setTextAttributes: function setTextAttributes(textAttributes) {
// do nothing
return WinJS.Promise.wrap();
},
getPageCount: function getPageCount() {
return 1;
},
articleFocusLost: function articleFocusLost() {
// do nothing
},
},
{
})
});
})();
/* File: DisposalManager.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Manages the disposal of article blocks
WinJS.Namespace.define("CommonJS.ArticleReader", {
DisposalManager: WinJS.Class.mix(WinJS.Class.define(
function (options) {
/// <summary>
/// Creates an instance of DisposalManager.
/// </summary>
this._disposedDelegates = [];
this._articleFocusLostDelegates = [];
Object.defineProperties(this, WinJS.Utilities.createEventProperties("disposed"));
Object.defineProperties(this, WinJS.Utilities.createEventProperties("articlefocuslost"));
},
{
_disposedDelegates: null,
_articleFocusLostDelegates: null,
dispose: function dispose() {
var disposedDelegates = this._disposedDelegates;
for (var i = 0, leni = disposedDelegates.length; i < leni; i++) {
var disposedDelegate = disposedDelegates[i];
this.removeEventListener("disposed", disposedDelegate);
}
var articleFocusLostDelegates = this._articleFocusLostDelegates;
for (var j = 0, lenj = articleFocusLostDelegates.length; j < lenj; j++) {
var articleFocusLostDelegate = articleFocusLostDelegates[j];
this.removeEventListener("articlefocuslost", articleFocusLostDelegate);
}
},
addDisposedDelegate: function addDisposedDelegate(delegate) {
var disposedDelegates = this._disposedDelegates;
disposedDelegates.push(delegate);
this.addEventListener("disposed", delegate);
},
addArticleFocusLostDelegate: function addArticleFocusLostDelegate(delegate) {
var articleFocusLostDelegates = this._articleFocusLostDelegates;
articleFocusLostDelegates.push(delegate);
this.addEventListener("articlefocuslost", delegate);
},
runAllDisposedDelegates: function runAllDisposedDelegates() {
this.dispatchEvent("disposed");
},
runAllArticleFocusLostDelegates: function runAllArticleFocusLostDelegates() {
this.dispatchEvent("articlefocuslost");
},
},
{
}), WinJS.Utilities.eventMixin),
});
})();
/* File: ActionsHandler.js */
/********************************************************
* *
* © Microsoft. All rights reserved. *
* *
*********************************************************/
(function () {
"use strict";
// Actions handler for data-driven actions (e.g. actions from CMS)
WinJS.Namespace.define("CommonJS.ArticleReader", {
ActionsHandler: WinJS.Class.define(
function () {
},
{
onActionInvoked: function onActionInvoked(event) {
var data = event.data;
var actionOptions = data.actionOptions;
var actionType = actionOptions.actionType;
switch (actionType) {
case "LaunchUri":
var actionAttributes = actionOptions.actionAttributes;
var uri = actionAttributes.uri;
try {
Platform.Telemetry.FlightRecorder.setImpressionNavMethod(data.impressionNavMethod);
var options = new Windows.System.LauncherOptions();
Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(uri), options);
}
catch (ex) {
// do nothing if launch fails
}
break;
}
},
})
});
})();
